diff -pruN 0.14.1+dfsg-1/build-aux/config.guess 0.15+dfsg-1/build-aux/config.guess
--- 0.14.1+dfsg-1/build-aux/config.guess	2020-07-08 06:50:03.000000000 +0000
+++ 0.15+dfsg-1/build-aux/config.guess	2020-09-23 14:48:57.000000000 +0000
@@ -2,7 +2,7 @@
 # Attempt to guess a canonical system name.
 #   Copyright 1992-2018 Free Software Foundation, Inc.
 
-timestamp='2018-08-29'
+timestamp='2018-03-08'
 
 # This file is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License as published by
@@ -84,6 +84,8 @@ if test $# != 0; then
   exit 1
 fi
 
+trap 'exit 1' 1 2 15
+
 # CC_FOR_BUILD -- compiler used by this script. Note that the use of a
 # compiler to aid in system detection is discouraged as it requires
 # temporary files to be created and, as you can see below, it is a
@@ -94,39 +96,34 @@ fi
 
 # Portable tmp directory creation inspired by the Autoconf team.
 
-tmp=
-# shellcheck disable=SC2172
-trap 'test -z "$tmp" || rm -fr "$tmp"' 1 2 13 15
-trap 'exitcode=$?; test -z "$tmp" || rm -fr "$tmp"; exit $exitcode' 0
-
-set_cc_for_build() {
-    : "${TMPDIR=/tmp}"
-    # shellcheck disable=SC2039
-    { tmp=`(umask 077 && mktemp -d "$TMPDIR/cgXXXXXX") 2>/dev/null` && test -n "$tmp" && test -d "$tmp" ; } ||
-	{ test -n "$RANDOM" && tmp=$TMPDIR/cg$$-$RANDOM && (umask 077 && mkdir "$tmp" 2>/dev/null) ; } ||
-	{ tmp=$TMPDIR/cg-$$ && (umask 077 && mkdir "$tmp" 2>/dev/null) && echo "Warning: creating insecure temp directory" >&2 ; } ||
-	{ echo "$me: cannot create a temporary directory in $TMPDIR" >&2 ; exit 1 ; }
-    dummy=$tmp/dummy
-    case ${CC_FOR_BUILD-},${HOST_CC-},${CC-} in
-	,,)    echo "int x;" > "$dummy.c"
-	       for driver in cc gcc c89 c99 ; do
-		   if ($driver -c -o "$dummy.o" "$dummy.c") >/dev/null 2>&1 ; then
-		       CC_FOR_BUILD="$driver"
-		       break
-		   fi
-	       done
-	       if test x"$CC_FOR_BUILD" = x ; then
-		   CC_FOR_BUILD=no_compiler_found
-	       fi
-	       ;;
-	,,*)   CC_FOR_BUILD=$CC ;;
-	,*,*)  CC_FOR_BUILD=$HOST_CC ;;
-    esac
-}
+set_cc_for_build='
+trap "exitcode=\$?; (rm -f \$tmpfiles 2>/dev/null; rmdir \$tmp 2>/dev/null) && exit \$exitcode" 0 ;
+trap "rm -f \$tmpfiles 2>/dev/null; rmdir \$tmp 2>/dev/null; exit 1" 1 2 13 15 ;
+: ${TMPDIR=/tmp} ;
+ { tmp=`(umask 077 && mktemp -d "$TMPDIR/cgXXXXXX") 2>/dev/null` && test -n "$tmp" && test -d "$tmp" ; } ||
+ { test -n "$RANDOM" && tmp=$TMPDIR/cg$$-$RANDOM && (umask 077 && mkdir $tmp) ; } ||
+ { tmp=$TMPDIR/cg-$$ && (umask 077 && mkdir $tmp) && echo "Warning: creating insecure temp directory" >&2 ; } ||
+ { echo "$me: cannot create a temporary directory in $TMPDIR" >&2 ; exit 1 ; } ;
+dummy=$tmp/dummy ;
+tmpfiles="$dummy.c $dummy.o $dummy.rel $dummy" ;
+case $CC_FOR_BUILD,$HOST_CC,$CC in
+ ,,)    echo "int x;" > "$dummy.c" ;
+	for c in cc gcc c89 c99 ; do
+	  if ($c -c -o "$dummy.o" "$dummy.c") >/dev/null 2>&1 ; then
+	     CC_FOR_BUILD="$c"; break ;
+	  fi ;
+	done ;
+	if test x"$CC_FOR_BUILD" = x ; then
+	  CC_FOR_BUILD=no_compiler_found ;
+	fi
+	;;
+ ,,*)   CC_FOR_BUILD=$CC ;;
+ ,*,*)  CC_FOR_BUILD=$HOST_CC ;;
+esac ; set_cc_for_build= ;'
 
 # This is needed to find uname on a Pyramid OSx when run in the BSD universe.
 # (ghazi@noc.rutgers.edu 1994-08-24)
-if test -f /.attbin/uname ; then
+if (test -f /.attbin/uname) >/dev/null 2>&1 ; then
 	PATH=$PATH:/.attbin ; export PATH
 fi
 
@@ -141,7 +138,7 @@ Linux|GNU|GNU/*)
 	# We could probably try harder.
 	LIBC=gnu
 
-	set_cc_for_build
+	eval "$set_cc_for_build"
 	cat <<-EOF > "$dummy.c"
 	#include <features.h>
 	#if defined(__UCLIBC__)
@@ -202,7 +199,7 @@ case "$UNAME_MACHINE:$UNAME_SYSTEM:$UNAM
 		os=netbsdelf
 		;;
 	    arm*|i386|m68k|ns32k|sh3*|sparc|vax)
-		set_cc_for_build
+		eval "$set_cc_for_build"
 		if echo __ELF__ | $CC_FOR_BUILD -E - 2>/dev/null \
 			| grep -q __ELF__
 		then
@@ -240,7 +237,7 @@ case "$UNAME_MACHINE:$UNAME_SYSTEM:$UNAM
 	# Since CPU_TYPE-MANUFACTURER-KERNEL-OPERATING_SYSTEM:
 	# contains redundant information, the shorter form:
 	# CPU_TYPE-MANUFACTURER-OPERATING_SYSTEM is used.
-	echo "$machine-${os}${release}${abi-}"
+	echo "$machine-${os}${release}${abi}"
 	exit ;;
     *:Bitrig:*:*)
 	UNAME_MACHINE_ARCH=`arch | sed 's/Bitrig.//'`
@@ -392,15 +389,20 @@ case "$UNAME_MACHINE:$UNAME_SYSTEM:$UNAM
 	echo i386-pc-auroraux"$UNAME_RELEASE"
 	exit ;;
     i86pc:SunOS:5.*:* | i86xen:SunOS:5.*:*)
-	UNAME_REL="`echo "$UNAME_RELEASE" | sed -e 's/[^.]*//'`"
-	case `isainfo -b` in
-	    32)
-		echo i386-pc-solaris2"$UNAME_REL"
-		;;
-	    64)
-		echo x86_64-pc-solaris2"$UNAME_REL"
-		;;
-	esac
+	eval "$set_cc_for_build"
+	SUN_ARCH=i386
+	# If there is a compiler, see if it is configured for 64-bit objects.
+	# Note that the Sun cc does not turn __LP64__ into 1 like gcc does.
+	# This test works for both compilers.
+	if [ "$CC_FOR_BUILD" != no_compiler_found ]; then
+	    if (echo '#ifdef __amd64'; echo IS_64BIT_ARCH; echo '#endif') | \
+		(CCOPTS="" $CC_FOR_BUILD -E - 2>/dev/null) | \
+		grep IS_64BIT_ARCH >/dev/null
+	    then
+		SUN_ARCH=x86_64
+	    fi
+	fi
+	echo "$SUN_ARCH"-pc-solaris2"`echo "$UNAME_RELEASE"|sed -e 's/[^.]*//'`"
 	exit ;;
     sun4*:SunOS:6*:*)
 	# According to config.sub, this is the proper way to canonicalize
@@ -480,7 +482,7 @@ case "$UNAME_MACHINE:$UNAME_SYSTEM:$UNAM
 	echo clipper-intergraph-clix"$UNAME_RELEASE"
 	exit ;;
     mips:*:*:UMIPS | mips:*:*:RISCos)
-	set_cc_for_build
+	eval "$set_cc_for_build"
 	sed 's/^	//' << EOF > "$dummy.c"
 #ifdef __cplusplus
 #include <stdio.h>  /* for printf() prototype */
@@ -577,7 +579,7 @@ EOF
 	exit ;;
     *:AIX:2:3)
 	if grep bos325 /usr/include/stdio.h >/dev/null 2>&1; then
-		set_cc_for_build
+		eval "$set_cc_for_build"
 		sed 's/^		//' << EOF > "$dummy.c"
 		#include <sys/systemcfg.h>
 
@@ -658,7 +660,7 @@ EOF
 		    esac
 		fi
 		if [ "$HP_ARCH" = "" ]; then
-		    set_cc_for_build
+		    eval "$set_cc_for_build"
 		    sed 's/^		//' << EOF > "$dummy.c"
 
 		#define _HPUX_SOURCE
@@ -698,7 +700,7 @@ EOF
 	esac
 	if [ "$HP_ARCH" = hppa2.0w ]
 	then
-	    set_cc_for_build
+	    eval "$set_cc_for_build"
 
 	    # hppa2.0w-hp-hpux* has a 64-bit kernel and a compiler generating
 	    # 32-bit code.  hppa64-hp-hpux* has the same kernel and a compiler
@@ -724,7 +726,7 @@ EOF
 	echo ia64-hp-hpux"$HPUX_REV"
 	exit ;;
     3050*:HI-UX:*:*)
-	set_cc_for_build
+	eval "$set_cc_for_build"
 	sed 's/^	//' << EOF > "$dummy.c"
 	#include <unistd.h>
 	int
@@ -838,17 +840,6 @@ EOF
     *:BSD/OS:*:*)
 	echo "$UNAME_MACHINE"-unknown-bsdi"$UNAME_RELEASE"
 	exit ;;
-    arm:FreeBSD:*:*)
-	UNAME_PROCESSOR=`uname -p`
-	set_cc_for_build
-	if echo __ARM_PCS_VFP | $CC_FOR_BUILD -E - 2>/dev/null \
-	    | grep -q __ARM_PCS_VFP
-	then
-	    echo "${UNAME_PROCESSOR}"-unknown-freebsd"`echo ${UNAME_RELEASE}|sed -e 's/[-(].*//'`"-gnueabi
-	else
-	    echo "${UNAME_PROCESSOR}"-unknown-freebsd"`echo ${UNAME_RELEASE}|sed -e 's/[-(].*//'`"-gnueabihf
-	fi
-	exit ;;
     *:FreeBSD:*:*)
 	UNAME_PROCESSOR=`/usr/bin/uname -p`
 	case "$UNAME_PROCESSOR" in
@@ -903,8 +894,8 @@ EOF
 	# other systems with GNU libc and userland
 	echo "$UNAME_MACHINE-unknown-`echo "$UNAME_SYSTEM" | sed 's,^[^/]*/,,' | tr "[:upper:]" "[:lower:]"``echo "$UNAME_RELEASE"|sed -e 's/[-(].*//'`-$LIBC"
 	exit ;;
-    *:Minix:*:*)
-	echo "$UNAME_MACHINE"-unknown-minix
+    i*86:Minix:*:*)
+	echo "$UNAME_MACHINE"-pc-minix
 	exit ;;
     aarch64:Linux:*:*)
 	echo "$UNAME_MACHINE"-unknown-linux-"$LIBC"
@@ -931,7 +922,7 @@ EOF
 	echo "$UNAME_MACHINE"-unknown-linux-"$LIBC"
 	exit ;;
     arm*:Linux:*:*)
-	set_cc_for_build
+	eval "$set_cc_for_build"
 	if echo __ARM_EABI__ | $CC_FOR_BUILD -E - 2>/dev/null \
 	    | grep -q __ARM_EABI__
 	then
@@ -980,7 +971,7 @@ EOF
 	echo "$UNAME_MACHINE"-unknown-linux-"$LIBC"
 	exit ;;
     mips:Linux:*:* | mips64:Linux:*:*)
-	set_cc_for_build
+	eval "$set_cc_for_build"
 	sed 's/^	//' << EOF > "$dummy.c"
 	#undef CPU
 	#undef ${UNAME_MACHINE}
@@ -1294,7 +1285,7 @@ EOF
 	exit ;;
     *:Darwin:*:*)
 	UNAME_PROCESSOR=`uname -p` || UNAME_PROCESSOR=unknown
-	set_cc_for_build
+	eval "$set_cc_for_build"
 	if test "$UNAME_PROCESSOR" = unknown ; then
 	    UNAME_PROCESSOR=powerpc
 	fi
@@ -1367,7 +1358,6 @@ EOF
 	# "uname -m" is not consistent, so use $cputype instead. 386
 	# is converted to i386 for consistency with other x86
 	# operating systems.
-	# shellcheck disable=SC2154
 	if test "$cputype" = 386; then
 	    UNAME_MACHINE=i386
 	else
diff -pruN 0.14.1+dfsg-1/build-aux/config.sub 0.15+dfsg-1/build-aux/config.sub
--- 0.14.1+dfsg-1/build-aux/config.sub	2020-07-08 06:50:03.000000000 +0000
+++ 0.15+dfsg-1/build-aux/config.sub	2020-09-23 14:48:57.000000000 +0000
@@ -2,7 +2,7 @@
 # Configuration validation subroutine script.
 #   Copyright 1992-2018 Free Software Foundation, Inc.
 
-timestamp='2018-08-29'
+timestamp='2018-05-05'
 
 # This file is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License as published by
@@ -110,20 +110,16 @@ case $# in
     exit 1;;
 esac
 
-# Split fields of configuration type
+# Spilt fields of configuration type
 IFS="-" read -r field1 field2 field3 field4 <<EOF
 $1
 EOF
 
 # Separate into logical components for further validation
 case $1 in
-	*-*-*-*-*)
-		echo Invalid configuration \`"$1"\': more than four components >&2
-		exit 1
-		;;
 	*-*-*-*)
 		basic_machine=$field1-$field2
-		os=$field3-$field4
+		os=-$field3-$field4
 		;;
 	*-*-*)
 		# Ambiguous whether COMPANY is present, or skipped and KERNEL-OS is two
@@ -136,1133 +132,1227 @@ case $1 in
 			| netbsd*-eabi* | kopensolaris*-gnu* | cloudabi*-eabi* \
 			| storm-chaos* | os2-emx* | rtmk-nova*)
 				basic_machine=$field1
-				os=$maybe_os
+				os=-$maybe_os
 				;;
 			android-linux)
 				basic_machine=$field1-unknown
-				os=linux-android
+				os=-linux-android
 				;;
 			*)
 				basic_machine=$field1-$field2
-				os=$field3
+				os=-$field3
 				;;
 		esac
 		;;
 	*-*)
-		# A lone config we happen to match not fitting any patern
-		case $field1-$field2 in
-			decstation-3100)
-				basic_machine=mips-dec
-				os=
-				;;
-			*-*)
-				# Second component is usually, but not always the OS
-				case $field2 in
-					# Prevent following clause from handling this valid os
-					sun*os*)
-						basic_machine=$field1
-						os=$field2
-						;;
-					# Manufacturers
-					dec* | mips* | sequent* | encore* | pc533* | sgi* | sony* \
-					| att* | 7300* | 3300* | delta* | motorola* | sun[234]* \
-					| unicom* | ibm* | next | hp | isi* | apollo | altos* \
-					| convergent* | ncr* | news | 32* | 3600* | 3100* \
-					| hitachi* | c[123]* | convex* | sun | crds | omron* | dg \
-					| ultra | tti* | harris | dolphin | highlevel | gould \
-					| cbm | ns | masscomp | apple | axis | knuth | cray \
-					| microblaze* | sim | cisco \
-					| oki | wec | wrs | winbond)
-						basic_machine=$field1-$field2
-						os=
-						;;
-					*)
-						basic_machine=$field1
-						os=$field2
-						;;
-				esac
-			;;
-		esac
+		basic_machine=$field1
+		os=-$field2
 		;;
 	*)
-		# Convert single-component short-hands not valid as part of
-		# multi-component configurations.
-		case $field1 in
-			386bsd)
-				basic_machine=i386-pc
-				os=bsd
-				;;
-			a29khif)
-				basic_machine=a29k-amd
-				os=udi
-				;;
-			adobe68k)
-				basic_machine=m68010-adobe
-				os=scout
-				;;
-			alliant)
-				basic_machine=fx80-alliant
-				os=
-				;;
-			altos | altos3068)
-				basic_machine=m68k-altos
-				os=
-				;;
-			am29k)
-				basic_machine=a29k-none
-				os=bsd
-				;;
-			amdahl)
-				basic_machine=580-amdahl
-				os=sysv
-				;;
-			amiga)
-				basic_machine=m68k-unknown
-				os=
-				;;
-			amigaos | amigados)
-				basic_machine=m68k-unknown
-				os=amigaos
-				;;
-			amigaunix | amix)
-				basic_machine=m68k-unknown
-				os=sysv4
-				;;
-			apollo68)
-				basic_machine=m68k-apollo
-				os=sysv
-				;;
-			apollo68bsd)
-				basic_machine=m68k-apollo
-				os=bsd
-				;;
-			aros)
-				basic_machine=i386-pc
-				os=aros
-				;;
-			aux)
-				basic_machine=m68k-apple
-				os=aux
-				;;
-			balance)
-				basic_machine=ns32k-sequent
-				os=dynix
-				;;
-			blackfin)
-				basic_machine=bfin-unknown
-				os=linux
-				;;
-			cegcc)
-				basic_machine=arm-unknown
-				os=cegcc
-				;;
-			convex-c1)
-				basic_machine=c1-convex
-				os=bsd
-				;;
-			convex-c2)
-				basic_machine=c2-convex
-				os=bsd
-				;;
-			convex-c32)
-				basic_machine=c32-convex
-				os=bsd
-				;;
-			convex-c34)
-				basic_machine=c34-convex
-				os=bsd
-				;;
-			convex-c38)
-				basic_machine=c38-convex
-				os=bsd
-				;;
-			cray)
-				basic_machine=j90-cray
-				os=unicos
-				;;
-			crds | unos)
-				basic_machine=m68k-crds
-				os=
-				;;
-			da30)
-				basic_machine=m68k-da30
-				os=
-				;;
-			decstation | pmax | pmin | dec3100 | decstatn)
-				basic_machine=mips-dec
-				os=
-				;;
-			delta88)
-				basic_machine=m88k-motorola
-				os=sysv3
-				;;
-			dicos)
-				basic_machine=i686-pc
-				os=dicos
-				;;
-			djgpp)
-				basic_machine=i586-pc
-				os=msdosdjgpp
-				;;
-			ebmon29k)
-				basic_machine=a29k-amd
-				os=ebmon
-				;;
-			es1800 | OSE68k | ose68k | ose | OSE)
-				basic_machine=m68k-ericsson
-				os=ose
-				;;
-			gmicro)
-				basic_machine=tron-gmicro
-				os=sysv
-				;;
-			go32)
-				basic_machine=i386-pc
-				os=go32
-				;;
-			h8300hms)
-				basic_machine=h8300-hitachi
-				os=hms
-				;;
-			h8300xray)
-				basic_machine=h8300-hitachi
-				os=xray
-				;;
-			h8500hms)
-				basic_machine=h8500-hitachi
-				os=hms
-				;;
-			harris)
-				basic_machine=m88k-harris
-				os=sysv3
-				;;
-			hp300)
-				basic_machine=m68k-hp
-				;;
-			hp300bsd)
-				basic_machine=m68k-hp
-				os=bsd
-				;;
-			hp300hpux)
-				basic_machine=m68k-hp
-				os=hpux
-				;;
-			hppaosf)
-				basic_machine=hppa1.1-hp
-				os=osf
-				;;
-			hppro)
-				basic_machine=hppa1.1-hp
-				os=proelf
-				;;
-			i386mach)
-				basic_machine=i386-mach
-				os=mach
-				;;
-			vsta)
-				basic_machine=i386-pc
-				os=vsta
-				;;
-			isi68 | isi)
-				basic_machine=m68k-isi
-				os=sysv
-				;;
-			m68knommu)
-				basic_machine=m68k-unknown
-				os=linux
-				;;
-			magnum | m3230)
-				basic_machine=mips-mips
-				os=sysv
-				;;
-			merlin)
-				basic_machine=ns32k-utek
-				os=sysv
-				;;
-			mingw64)
-				basic_machine=x86_64-pc
-				os=mingw64
-				;;
-			mingw32)
-				basic_machine=i686-pc
-				os=mingw32
-				;;
-			mingw32ce)
-				basic_machine=arm-unknown
-				os=mingw32ce
-				;;
-			monitor)
-				basic_machine=m68k-rom68k
-				os=coff
-				;;
-			morphos)
-				basic_machine=powerpc-unknown
-				os=morphos
-				;;
-			moxiebox)
-				basic_machine=moxie-unknown
-				os=moxiebox
-				;;
-			msdos)
-				basic_machine=i386-pc
-				os=msdos
-				;;
-			msys)
-				basic_machine=i686-pc
-				os=msys
-				;;
-			mvs)
-				basic_machine=i370-ibm
-				os=mvs
-				;;
-			nacl)
-				basic_machine=le32-unknown
-				os=nacl
-				;;
-			ncr3000)
-				basic_machine=i486-ncr
-				os=sysv4
-				;;
-			netbsd386)
-				basic_machine=i386-pc
-				os=netbsd
-				;;
-			netwinder)
-				basic_machine=armv4l-rebel
-				os=linux
-				;;
-			news | news700 | news800 | news900)
-				basic_machine=m68k-sony
-				os=newsos
-				;;
-			news1000)
-				basic_machine=m68030-sony
-				os=newsos
-				;;
-			necv70)
-				basic_machine=v70-nec
-				os=sysv
-				;;
-			nh3000)
-				basic_machine=m68k-harris
-				os=cxux
-				;;
-			nh[45]000)
-				basic_machine=m88k-harris
-				os=cxux
-				;;
-			nindy960)
-				basic_machine=i960-intel
-				os=nindy
-				;;
-			mon960)
-				basic_machine=i960-intel
-				os=mon960
-				;;
-			nonstopux)
-				basic_machine=mips-compaq
-				os=nonstopux
-				;;
-			os400)
-				basic_machine=powerpc-ibm
-				os=os400
-				;;
-			OSE68000 | ose68000)
-				basic_machine=m68000-ericsson
-				os=ose
-				;;
-			os68k)
-				basic_machine=m68k-none
-				os=os68k
-				;;
-			paragon)
-				basic_machine=i860-intel
-				os=osf
-				;;
-			parisc)
-				basic_machine=hppa-unknown
-				os=linux
-				;;
-			pw32)
-				basic_machine=i586-unknown
-				os=pw32
-				;;
-			rdos | rdos64)
-				basic_machine=x86_64-pc
-				os=rdos
-				;;
-			rdos32)
-				basic_machine=i386-pc
-				os=rdos
-				;;
-			rom68k)
-				basic_machine=m68k-rom68k
-				os=coff
-				;;
-			sa29200)
-				basic_machine=a29k-amd
-				os=udi
-				;;
-			sei)
-				basic_machine=mips-sei
-				os=seiux
-				;;
-			sequent)
-				basic_machine=i386-sequent
-				os=
-				;;
-			sps7)
-				basic_machine=m68k-bull
-				os=sysv2
-				;;
-			st2000)
-				basic_machine=m68k-tandem
-				os=
-				;;
-			stratus)
-				basic_machine=i860-stratus
-				os=sysv4
-				;;
-			sun2)
-				basic_machine=m68000-sun
-				os=
-				;;
-			sun2os3)
-				basic_machine=m68000-sun
-				os=sunos3
-				;;
-			sun2os4)
-				basic_machine=m68000-sun
-				os=sunos4
-				;;
-			sun3)
-				basic_machine=m68k-sun
-				os=
-				;;
-			sun3os3)
-				basic_machine=m68k-sun
-				os=sunos3
-				;;
-			sun3os4)
-				basic_machine=m68k-sun
-				os=sunos4
-				;;
-			sun4)
-				basic_machine=sparc-sun
-				os=
-				;;
-			sun4os3)
-				basic_machine=sparc-sun
-				os=sunos3
-				;;
-			sun4os4)
-				basic_machine=sparc-sun
-				os=sunos4
-				;;
-			sun4sol2)
-				basic_machine=sparc-sun
-				os=solaris2
-				;;
-			sun386 | sun386i | roadrunner)
-				basic_machine=i386-sun
-				os=
-				;;
-			sv1)
-				basic_machine=sv1-cray
-				os=unicos
-				;;
-			symmetry)
-				basic_machine=i386-sequent
-				os=dynix
-				;;
-			t3e)
-				basic_machine=alphaev5-cray
-				os=unicos
-				;;
-			t90)
-				basic_machine=t90-cray
-				os=unicos
-				;;
-			toad1)
-				basic_machine=pdp10-xkl
-				os=tops20
-				;;
-			tpf)
-				basic_machine=s390x-ibm
-				os=tpf
-				;;
-			udi29k)
-				basic_machine=a29k-amd
-				os=udi
-				;;
-			ultra3)
-				basic_machine=a29k-nyu
-				os=sym1
-				;;
-			v810 | necv810)
-				basic_machine=v810-nec
-				os=none
-				;;
-			vaxv)
-				basic_machine=vax-dec
-				os=sysv
-				;;
-			vms)
-				basic_machine=vax-dec
-				os=vms
-				;;
-			vxworks960)
-				basic_machine=i960-wrs
-				os=vxworks
-				;;
-			vxworks68)
-				basic_machine=m68k-wrs
-				os=vxworks
-				;;
-			vxworks29k)
-				basic_machine=a29k-wrs
-				os=vxworks
-				;;
-			xbox)
-				basic_machine=i686-pc
-				os=mingw32
-				;;
-			ymp)
-				basic_machine=ymp-cray
-				os=unicos
-				;;
-			*)
-				basic_machine=$1
-				os=
-				;;
-		esac
+		basic_machine=$1
+		os=
+		;;
+esac
+
+### Let's recognize common machines as not being operating systems so
+### that things like config.sub decstation-3100 work.  We also
+### recognize some manufacturers as not being operating systems, so we
+### can provide default operating systems below.
+case $os in
+	-sun*os*)
+		# Prevent following clause from handling this invalid input.
+		;;
+	-dec* | -mips* | -sequent* | -encore* | -pc532* | -sgi* | -sony* | \
+	-att* | -7300* | -3300* | -delta* | -motorola* | -sun[234]* | \
+	-unicom* | -ibm* | -next | -hp | -isi* | -apollo | -altos* | \
+	-convergent* | -ncr* | -news | -32* | -3600* | -3100* | -hitachi* |\
+	-c[123]* | -convex* | -sun | -crds | -omron* | -dg | -ultra | -tti* | \
+	-harris | -dolphin | -highlevel | -gould | -cbm | -ns | -masscomp | \
+	-apple | -axis | -knuth | -cray | -microblaze*)
+		os=
+		basic_machine=$1
+		;;
+	-bluegene*)
+		os=-cnk
+		;;
+	-sim | -cisco | -oki | -wec | -winbond)
+		os=
+		basic_machine=$1
+		;;
+	-scout)
+		;;
+	-wrs)
+		os=-vxworks
+		basic_machine=$1
+		;;
+	-chorusos*)
+		os=-chorusos
+		basic_machine=$1
+		;;
+	-chorusrdb)
+		os=-chorusrdb
+		basic_machine=$1
+		;;
+	-hiux*)
+		os=-hiuxwe2
+		;;
+	-sco6)
+		os=-sco5v6
+		basic_machine=`echo "$1" | sed -e 's/86-.*/86-pc/'`
+		;;
+	-sco5)
+		os=-sco3.2v5
+		basic_machine=`echo "$1" | sed -e 's/86-.*/86-pc/'`
+		;;
+	-sco4)
+		os=-sco3.2v4
+		basic_machine=`echo "$1" | sed -e 's/86-.*/86-pc/'`
+		;;
+	-sco3.2.[4-9]*)
+		os=`echo $os | sed -e 's/sco3.2./sco3.2v/'`
+		basic_machine=`echo "$1" | sed -e 's/86-.*/86-pc/'`
+		;;
+	-sco3.2v[4-9]*)
+		# Don't forget version if it is 3.2v4 or newer.
+		basic_machine=`echo "$1" | sed -e 's/86-.*/86-pc/'`
+		;;
+	-sco5v6*)
+		# Don't forget version if it is 3.2v4 or newer.
+		basic_machine=`echo "$1" | sed -e 's/86-.*/86-pc/'`
+		;;
+	-sco*)
+		os=-sco3.2v2
+		basic_machine=`echo "$1" | sed -e 's/86-.*/86-pc/'`
+		;;
+	-udk*)
+		basic_machine=`echo "$1" | sed -e 's/86-.*/86-pc/'`
+		;;
+	-isc)
+		os=-isc2.2
+		basic_machine=`echo "$1" | sed -e 's/86-.*/86-pc/'`
+		;;
+	-clix*)
+		basic_machine=clipper-intergraph
+		;;
+	-isc*)
+		basic_machine=`echo "$1" | sed -e 's/86-.*/86-pc/'`
+		;;
+	-lynx*178)
+		os=-lynxos178
+		;;
+	-lynx*5)
+		os=-lynxos5
+		;;
+	-lynx*)
+		os=-lynxos
+		;;
+	-ptx*)
+		basic_machine=`echo "$1" | sed -e 's/86-.*/86-sequent/'`
+		;;
+	-psos*)
+		os=-psos
+		;;
+	-mint | -mint[0-9]*)
+		basic_machine=m68k-atari
+		os=-mint
 		;;
 esac
 
-# Decode 1-component or ad-hoc basic machines
+# Decode aliases for certain CPU-COMPANY combinations.
 case $basic_machine in
-	# Here we handle the default manufacturer of certain CPU types.  It is in
-	# some cases the only manufacturer, in others, it is the most popular.
-	w89k)
-		cpu=hppa1.1
-		vendor=winbond
+	# Recognize the basic CPU types without company name.
+	# Some are omitted here because they have special meanings below.
+	1750a | 580 \
+	| a29k \
+	| aarch64 | aarch64_be \
+	| alpha | alphaev[4-8] | alphaev56 | alphaev6[78] | alphapca5[67] \
+	| alpha64 | alpha64ev[4-8] | alpha64ev56 | alpha64ev6[78] | alpha64pca5[67] \
+	| am33_2.0 \
+	| arc | arceb \
+	| arm | arm[bl]e | arme[lb] | armv[2-8] | armv[3-8][lb] | armv6m | armv[78][arm] \
+	| avr | avr32 \
+	| ba \
+	| be32 | be64 \
+	| bfin \
+	| c4x | c8051 | clipper | csky \
+	| d10v | d30v | dlx | dsp16xx \
+	| e2k | epiphany \
+	| fido | fr30 | frv | ft32 \
+	| h8300 | h8500 | hppa | hppa1.[01] | hppa2.0 | hppa2.0[nw] | hppa64 \
+	| hexagon \
+	| i370 | i860 | i960 | ia16 | ia64 \
+	| ip2k | iq2000 \
+	| k1om \
+	| le32 | le64 \
+	| lm32 \
+	| m32c | m32r | m32rle | m68000 | m68k | m88k \
+	| maxq | mb | microblaze | microblazeel | mcore | mep | metag \
+	| mips | mipsbe | mipseb | mipsel | mipsle \
+	| mips16 \
+	| mips64 | mips64el \
+	| mips64octeon | mips64octeonel \
+	| mips64orion | mips64orionel \
+	| mips64r5900 | mips64r5900el \
+	| mips64vr | mips64vrel \
+	| mips64vr4100 | mips64vr4100el \
+	| mips64vr4300 | mips64vr4300el \
+	| mips64vr5000 | mips64vr5000el \
+	| mips64vr5900 | mips64vr5900el \
+	| mipsisa32 | mipsisa32el \
+	| mipsisa32r2 | mipsisa32r2el \
+	| mipsisa32r6 | mipsisa32r6el \
+	| mipsisa64 | mipsisa64el \
+	| mipsisa64r2 | mipsisa64r2el \
+	| mipsisa64r6 | mipsisa64r6el \
+	| mipsisa64sb1 | mipsisa64sb1el \
+	| mipsisa64sr71k | mipsisa64sr71kel \
+	| mipsr5900 | mipsr5900el \
+	| mipstx39 | mipstx39el \
+	| mn10200 | mn10300 \
+	| moxie \
+	| mt \
+	| msp430 \
+	| nds32 | nds32le | nds32be \
+	| nfp \
+	| nios | nios2 | nios2eb | nios2el \
+	| ns16k | ns32k \
+	| open8 | or1k | or1knd | or32 \
+	| pdp10 | pj | pjl \
+	| powerpc | powerpc64 | powerpc64le | powerpcle \
+	| pru \
+	| pyramid \
+	| riscv32 | riscv64 \
+	| rl78 | rx \
+	| score \
+	| sh | sh[1234] | sh[24]a | sh[24]aeb | sh[23]e | sh[234]eb | sheb | shbe | shle | sh[1234]le | sh3ele \
+	| sh64 | sh64le \
+	| sparc | sparc64 | sparc64b | sparc64v | sparc86x | sparclet | sparclite \
+	| sparcv8 | sparcv9 | sparcv9b | sparcv9v \
+	| spu \
+	| tahoe | tic4x | tic54x | tic55x | tic6x | tic80 | tron \
+	| ubicom32 \
+	| v850 | v850e | v850e1 | v850e2 | v850es | v850e2v3 \
+	| visium \
+	| wasm32 \
+	| x86 | xc16x | xstormy16 | xtensa \
+	| z8k | z80)
+		basic_machine=$basic_machine-unknown
 		;;
-	op50n)
-		cpu=hppa1.1
-		vendor=oki
+	c54x)
+		basic_machine=tic54x-unknown
 		;;
-	op60c)
-		cpu=hppa1.1
-		vendor=oki
+	c55x)
+		basic_machine=tic55x-unknown
 		;;
-	ibm*)
-		cpu=i370
-		vendor=ibm
+	c6x)
+		basic_machine=tic6x-unknown
 		;;
-	orion105)
-		cpu=clipper
-		vendor=highlevel
+	leon|leon[3-9])
+		basic_machine=sparc-$basic_machine
 		;;
-	mac | mpw | mac-mpw)
-		cpu=m68k
-		vendor=apple
+	m6811 | m68hc11 | m6812 | m68hc12 | m68hcs12x | nvptx | picochip)
+		basic_machine=$basic_machine-unknown
+		os=-none
 		;;
-	pmac | pmac-mpw)
-		cpu=powerpc
-		vendor=apple
+	m88110 | m680[12346]0 | m683?2 | m68360 | m5200 | v70 | w65)
+		;;
+	m9s12z | m68hcs12z | hcs12z | s12z)
+		basic_machine=s12z-unknown
+		os=-none
+		;;
+	ms1)
+		basic_machine=mt-unknown
 		;;
 
+	strongarm | thumb | xscale)
+		basic_machine=arm-unknown
+		;;
+	xgate)
+		basic_machine=$basic_machine-unknown
+		os=-none
+		;;
+	xscaleeb)
+		basic_machine=armeb-unknown
+		;;
+
+	xscaleel)
+		basic_machine=armel-unknown
+		;;
+
+	# We use `pc' rather than `unknown'
+	# because (1) that's what they normally are, and
+	# (2) the word "unknown" tends to confuse beginning users.
+	i*86 | x86_64)
+	  basic_machine=$basic_machine-pc
+	  ;;
+	# Object if more than one company name word.
+	*-*-*)
+		echo Invalid configuration \`"$1"\': machine \`"$basic_machine"\' not recognized 1>&2
+		exit 1
+		;;
+	# Recognize the basic CPU types with company name.
+	580-* \
+	| a29k-* \
+	| aarch64-* | aarch64_be-* \
+	| alpha-* | alphaev[4-8]-* | alphaev56-* | alphaev6[78]-* \
+	| alpha64-* | alpha64ev[4-8]-* | alpha64ev56-* | alpha64ev6[78]-* \
+	| alphapca5[67]-* | alpha64pca5[67]-* | arc-* | arceb-* \
+	| arm-*  | armbe-* | armle-* | armeb-* | armv*-* \
+	| avr-* | avr32-* \
+	| ba-* \
+	| be32-* | be64-* \
+	| bfin-* | bs2000-* \
+	| c[123]* | c30-* | [cjt]90-* | c4x-* \
+	| c8051-* | clipper-* | craynv-* | csky-* | cydra-* \
+	| d10v-* | d30v-* | dlx-* \
+	| e2k-* | elxsi-* \
+	| f30[01]-* | f700-* | fido-* | fr30-* | frv-* | fx80-* \
+	| h8300-* | h8500-* \
+	| hppa-* | hppa1.[01]-* | hppa2.0-* | hppa2.0[nw]-* | hppa64-* \
+	| hexagon-* \
+	| i*86-* | i860-* | i960-* | ia16-* | ia64-* \
+	| ip2k-* | iq2000-* \
+	| k1om-* \
+	| le32-* | le64-* \
+	| lm32-* \
+	| m32c-* | m32r-* | m32rle-* \
+	| m68000-* | m680[012346]0-* | m68360-* | m683?2-* | m68k-* \
+	| m88110-* | m88k-* | maxq-* | mcore-* | metag-* \
+	| microblaze-* | microblazeel-* \
+	| mips-* | mipsbe-* | mipseb-* | mipsel-* | mipsle-* \
+	| mips16-* \
+	| mips64-* | mips64el-* \
+	| mips64octeon-* | mips64octeonel-* \
+	| mips64orion-* | mips64orionel-* \
+	| mips64r5900-* | mips64r5900el-* \
+	| mips64vr-* | mips64vrel-* \
+	| mips64vr4100-* | mips64vr4100el-* \
+	| mips64vr4300-* | mips64vr4300el-* \
+	| mips64vr5000-* | mips64vr5000el-* \
+	| mips64vr5900-* | mips64vr5900el-* \
+	| mipsisa32-* | mipsisa32el-* \
+	| mipsisa32r2-* | mipsisa32r2el-* \
+	| mipsisa32r6-* | mipsisa32r6el-* \
+	| mipsisa64-* | mipsisa64el-* \
+	| mipsisa64r2-* | mipsisa64r2el-* \
+	| mipsisa64r6-* | mipsisa64r6el-* \
+	| mipsisa64sb1-* | mipsisa64sb1el-* \
+	| mipsisa64sr71k-* | mipsisa64sr71kel-* \
+	| mipsr5900-* | mipsr5900el-* \
+	| mipstx39-* | mipstx39el-* \
+	| mmix-* \
+	| mt-* \
+	| msp430-* \
+	| nds32-* | nds32le-* | nds32be-* \
+	| nfp-* \
+	| nios-* | nios2-* | nios2eb-* | nios2el-* \
+	| none-* | np1-* | ns16k-* | ns32k-* \
+	| open8-* \
+	| or1k*-* \
+	| orion-* \
+	| pdp10-* | pdp11-* | pj-* | pjl-* | pn-* | power-* \
+	| powerpc-* | powerpc64-* | powerpc64le-* | powerpcle-* \
+	| pru-* \
+	| pyramid-* \
+	| riscv32-* | riscv64-* \
+	| rl78-* | romp-* | rs6000-* | rx-* \
+	| sh-* | sh[1234]-* | sh[24]a-* | sh[24]aeb-* | sh[23]e-* | sh[34]eb-* | sheb-* | shbe-* \
+	| shle-* | sh[1234]le-* | sh3ele-* | sh64-* | sh64le-* \
+	| sparc-* | sparc64-* | sparc64b-* | sparc64v-* | sparc86x-* | sparclet-* \
+	| sparclite-* \
+	| sparcv8-* | sparcv9-* | sparcv9b-* | sparcv9v-* | sv1-* | sx*-* \
+	| tahoe-* \
+	| tic30-* | tic4x-* | tic54x-* | tic55x-* | tic6x-* | tic80-* \
+	| tile*-* \
+	| tron-* \
+	| ubicom32-* \
+	| v850-* | v850e-* | v850e1-* | v850es-* | v850e2-* | v850e2v3-* \
+	| vax-* \
+	| visium-* \
+	| wasm32-* \
+	| we32k-* \
+	| x86-* | x86_64-* | xc16x-* | xps100-* \
+	| xstormy16-* | xtensa*-* \
+	| ymp-* \
+	| z8k-* | z80-*)
+		;;
+	# Recognize the basic CPU types without company name, with glob match.
+	xtensa*)
+		basic_machine=$basic_machine-unknown
+		;;
 	# Recognize the various machine names and aliases which stand
 	# for a CPU type and a company and sometimes even an OS.
+	386bsd)
+		basic_machine=i386-pc
+		os=-bsd
+		;;
 	3b1 | 7300 | 7300-att | att-7300 | pc7300 | safari | unixpc)
-		cpu=m68000
-		vendor=att
+		basic_machine=m68000-att
 		;;
 	3b*)
-		cpu=we32k
-		vendor=att
+		basic_machine=we32k-att
+		;;
+	a29khif)
+		basic_machine=a29k-amd
+		os=-udi
+		;;
+	abacus)
+		basic_machine=abacus-unknown
+		;;
+	adobe68k)
+		basic_machine=m68010-adobe
+		os=-scout
+		;;
+	alliant | fx80)
+		basic_machine=fx80-alliant
+		;;
+	altos | altos3068)
+		basic_machine=m68k-altos
+		;;
+	am29k)
+		basic_machine=a29k-none
+		os=-bsd
+		;;
+	amd64)
+		basic_machine=x86_64-pc
+		;;
+	amd64-*)
+		basic_machine=x86_64-`echo "$basic_machine" | sed 's/^[^-]*-//'`
+		;;
+	amdahl)
+		basic_machine=580-amdahl
+		os=-sysv
+		;;
+	amiga | amiga-*)
+		basic_machine=m68k-unknown
+		;;
+	amigaos | amigados)
+		basic_machine=m68k-unknown
+		os=-amigaos
+		;;
+	amigaunix | amix)
+		basic_machine=m68k-unknown
+		os=-sysv4
+		;;
+	apollo68)
+		basic_machine=m68k-apollo
+		os=-sysv
+		;;
+	apollo68bsd)
+		basic_machine=m68k-apollo
+		os=-bsd
+		;;
+	aros)
+		basic_machine=i386-pc
+		os=-aros
+		;;
+	asmjs)
+		basic_machine=asmjs-unknown
+		;;
+	aux)
+		basic_machine=m68k-apple
+		os=-aux
+		;;
+	balance)
+		basic_machine=ns32k-sequent
+		os=-dynix
+		;;
+	blackfin)
+		basic_machine=bfin-unknown
+		os=-linux
+		;;
+	blackfin-*)
+		basic_machine=bfin-`echo "$basic_machine" | sed 's/^[^-]*-//'`
+		os=-linux
 		;;
 	bluegene*)
-		cpu=powerpc
-		vendor=ibm
-		os=cnk
+		basic_machine=powerpc-ibm
+		os=-cnk
+		;;
+	c54x-*)
+		basic_machine=tic54x-`echo "$basic_machine" | sed 's/^[^-]*-//'`
+		;;
+	c55x-*)
+		basic_machine=tic55x-`echo "$basic_machine" | sed 's/^[^-]*-//'`
+		;;
+	c6x-*)
+		basic_machine=tic6x-`echo "$basic_machine" | sed 's/^[^-]*-//'`
+		;;
+	c90)
+		basic_machine=c90-cray
+		os=-unicos
+		;;
+	cegcc)
+		basic_machine=arm-unknown
+		os=-cegcc
+		;;
+	convex-c1)
+		basic_machine=c1-convex
+		os=-bsd
+		;;
+	convex-c2)
+		basic_machine=c2-convex
+		os=-bsd
+		;;
+	convex-c32)
+		basic_machine=c32-convex
+		os=-bsd
+		;;
+	convex-c34)
+		basic_machine=c34-convex
+		os=-bsd
+		;;
+	convex-c38)
+		basic_machine=c38-convex
+		os=-bsd
+		;;
+	cray | j90)
+		basic_machine=j90-cray
+		os=-unicos
+		;;
+	craynv)
+		basic_machine=craynv-cray
+		os=-unicosmp
+		;;
+	cr16 | cr16-*)
+		basic_machine=cr16-unknown
+		os=-elf
+		;;
+	crds | unos)
+		basic_machine=m68k-crds
+		;;
+	crisv32 | crisv32-* | etraxfs*)
+		basic_machine=crisv32-axis
+		;;
+	cris | cris-* | etrax*)
+		basic_machine=cris-axis
+		;;
+	crx)
+		basic_machine=crx-unknown
+		os=-elf
+		;;
+	da30 | da30-*)
+		basic_machine=m68k-da30
+		;;
+	decstation | decstation-3100 | pmax | pmax-* | pmin | dec3100 | decstatn)
+		basic_machine=mips-dec
 		;;
 	decsystem10* | dec10*)
-		cpu=pdp10
-		vendor=dec
-		os=tops10
+		basic_machine=pdp10-dec
+		os=-tops10
 		;;
 	decsystem20* | dec20*)
-		cpu=pdp10
-		vendor=dec
-		os=tops20
+		basic_machine=pdp10-dec
+		os=-tops20
 		;;
 	delta | 3300 | motorola-3300 | motorola-delta \
 	      | 3300-motorola | delta-motorola)
-		cpu=m68k
-		vendor=motorola
+		basic_machine=m68k-motorola
+		;;
+	delta88)
+		basic_machine=m88k-motorola
+		os=-sysv3
+		;;
+	dicos)
+		basic_machine=i686-pc
+		os=-dicos
+		;;
+	djgpp)
+		basic_machine=i586-pc
+		os=-msdosdjgpp
+		;;
+	dpx20 | dpx20-*)
+		basic_machine=rs6000-bull
+		os=-bosx
 		;;
 	dpx2*)
-		cpu=m68k
-		vendor=bull
-		os=sysv3
+		basic_machine=m68k-bull
+		os=-sysv3
 		;;
-	encore | umax | mmax)
-		cpu=ns32k
-		vendor=encore
+	e500v[12])
+		basic_machine=powerpc-unknown
+		os=$os"spe"
+		;;
+	e500v[12]-*)
+		basic_machine=powerpc-`echo "$basic_machine" | sed 's/^[^-]*-//'`
+		os=$os"spe"
+		;;
+	ebmon29k)
+		basic_machine=a29k-amd
+		os=-ebmon
 		;;
 	elxsi)
-		cpu=elxsi
-		vendor=elxsi
-		os=${os:-bsd}
+		basic_machine=elxsi-elxsi
+		os=-bsd
+		;;
+	encore | umax | mmax)
+		basic_machine=ns32k-encore
+		;;
+	es1800 | OSE68k | ose68k | ose | OSE)
+		basic_machine=m68k-ericsson
+		os=-ose
 		;;
 	fx2800)
-		cpu=i860
-		vendor=alliant
+		basic_machine=i860-alliant
 		;;
 	genix)
-		cpu=ns32k
-		vendor=ns
+		basic_machine=ns32k-ns
+		;;
+	gmicro)
+		basic_machine=tron-gmicro
+		os=-sysv
+		;;
+	go32)
+		basic_machine=i386-pc
+		os=-go32
 		;;
 	h3050r* | hiux*)
-		cpu=hppa1.1
-		vendor=hitachi
-		os=hiuxwe2
+		basic_machine=hppa1.1-hitachi
+		os=-hiuxwe2
+		;;
+	h8300hms)
+		basic_machine=h8300-hitachi
+		os=-hms
+		;;
+	h8300xray)
+		basic_machine=h8300-hitachi
+		os=-xray
+		;;
+	h8500hms)
+		basic_machine=h8500-hitachi
+		os=-hms
+		;;
+	harris)
+		basic_machine=m88k-harris
+		os=-sysv3
+		;;
+	hp300-*)
+		basic_machine=m68k-hp
+		;;
+	hp300bsd)
+		basic_machine=m68k-hp
+		os=-bsd
+		;;
+	hp300hpux)
+		basic_machine=m68k-hp
+		os=-hpux
 		;;
 	hp3k9[0-9][0-9] | hp9[0-9][0-9])
-		cpu=hppa1.0
-		vendor=hp
+		basic_machine=hppa1.0-hp
 		;;
 	hp9k2[0-9][0-9] | hp9k31[0-9])
-		cpu=m68000
-		vendor=hp
+		basic_machine=m68000-hp
 		;;
 	hp9k3[2-9][0-9])
-		cpu=m68k
-		vendor=hp
+		basic_machine=m68k-hp
 		;;
 	hp9k6[0-9][0-9] | hp6[0-9][0-9])
-		cpu=hppa1.0
-		vendor=hp
+		basic_machine=hppa1.0-hp
 		;;
 	hp9k7[0-79][0-9] | hp7[0-79][0-9])
-		cpu=hppa1.1
-		vendor=hp
+		basic_machine=hppa1.1-hp
 		;;
 	hp9k78[0-9] | hp78[0-9])
 		# FIXME: really hppa2.0-hp
-		cpu=hppa1.1
-		vendor=hp
+		basic_machine=hppa1.1-hp
 		;;
 	hp9k8[67]1 | hp8[67]1 | hp9k80[24] | hp80[24] | hp9k8[78]9 | hp8[78]9 | hp9k893 | hp893)
 		# FIXME: really hppa2.0-hp
-		cpu=hppa1.1
-		vendor=hp
+		basic_machine=hppa1.1-hp
 		;;
 	hp9k8[0-9][13679] | hp8[0-9][13679])
-		cpu=hppa1.1
-		vendor=hp
+		basic_machine=hppa1.1-hp
 		;;
 	hp9k8[0-9][0-9] | hp8[0-9][0-9])
-		cpu=hppa1.0
-		vendor=hp
+		basic_machine=hppa1.0-hp
+		;;
+	hppaosf)
+		basic_machine=hppa1.1-hp
+		os=-osf
+		;;
+	hppro)
+		basic_machine=hppa1.1-hp
+		os=-proelf
+		;;
+	i370-ibm* | ibm*)
+		basic_machine=i370-ibm
 		;;
 	i*86v32)
-		cpu=`echo "$1" | sed -e 's/86.*/86/'`
-		vendor=pc
-		os=sysv32
+		basic_machine=`echo "$1" | sed -e 's/86.*/86-pc/'`
+		os=-sysv32
 		;;
 	i*86v4*)
-		cpu=`echo "$1" | sed -e 's/86.*/86/'`
-		vendor=pc
-		os=sysv4
+		basic_machine=`echo "$1" | sed -e 's/86.*/86-pc/'`
+		os=-sysv4
 		;;
 	i*86v)
-		cpu=`echo "$1" | sed -e 's/86.*/86/'`
-		vendor=pc
-		os=sysv
+		basic_machine=`echo "$1" | sed -e 's/86.*/86-pc/'`
+		os=-sysv
 		;;
 	i*86sol2)
-		cpu=`echo "$1" | sed -e 's/86.*/86/'`
-		vendor=pc
-		os=solaris2
-		;;
-	j90 | j90-cray)
-		cpu=j90
-		vendor=cray
-		os=${os:-unicos}
+		basic_machine=`echo "$1" | sed -e 's/86.*/86-pc/'`
+		os=-solaris2
+		;;
+	i386mach)
+		basic_machine=i386-mach
+		os=-mach
+		;;
+	vsta)
+		basic_machine=i386-unknown
+		os=-vsta
 		;;
 	iris | iris4d)
-		cpu=mips
-		vendor=sgi
+		basic_machine=mips-sgi
 		case $os in
-		    irix*)
+		    -irix*)
 			;;
 		    *)
-			os=irix4
+			os=-irix4
 			;;
 		esac
 		;;
+	isi68 | isi)
+		basic_machine=m68k-isi
+		os=-sysv
+		;;
+	leon-*|leon[3-9]-*)
+		basic_machine=sparc-`echo "$basic_machine" | sed 's/-.*//'`
+		;;
+	m68knommu)
+		basic_machine=m68k-unknown
+		os=-linux
+		;;
+	m68knommu-*)
+		basic_machine=m68k-`echo "$basic_machine" | sed 's/^[^-]*-//'`
+		os=-linux
+		;;
+	magnum | m3230)
+		basic_machine=mips-mips
+		os=-sysv
+		;;
+	merlin)
+		basic_machine=ns32k-utek
+		os=-sysv
+		;;
+	microblaze*)
+		basic_machine=microblaze-xilinx
+		;;
+	mingw64)
+		basic_machine=x86_64-pc
+		os=-mingw64
+		;;
+	mingw32)
+		basic_machine=i686-pc
+		os=-mingw32
+		;;
+	mingw32ce)
+		basic_machine=arm-unknown
+		os=-mingw32ce
+		;;
 	miniframe)
-		cpu=m68000
-		vendor=convergent
+		basic_machine=m68000-convergent
 		;;
-	*mint | mint[0-9]* | *MiNT | *MiNT[0-9]*)
-		cpu=m68k
-		vendor=atari
-		os=mint
+	*mint | -mint[0-9]* | *MiNT | *MiNT[0-9]*)
+		basic_machine=m68k-atari
+		os=-mint
+		;;
+	mips3*-*)
+		basic_machine=`echo "$basic_machine" | sed -e 's/mips3/mips64/'`
+		;;
+	mips3*)
+		basic_machine=`echo "$basic_machine" | sed -e 's/mips3/mips64/'`-unknown
+		;;
+	monitor)
+		basic_machine=m68k-rom68k
+		os=-coff
+		;;
+	morphos)
+		basic_machine=powerpc-unknown
+		os=-morphos
+		;;
+	moxiebox)
+		basic_machine=moxie-unknown
+		os=-moxiebox
+		;;
+	msdos)
+		basic_machine=i386-pc
+		os=-msdos
+		;;
+	ms1-*)
+		basic_machine=`echo "$basic_machine" | sed -e 's/ms1-/mt-/'`
+		;;
+	msys)
+		basic_machine=i686-pc
+		os=-msys
+		;;
+	mvs)
+		basic_machine=i370-ibm
+		os=-mvs
+		;;
+	nacl)
+		basic_machine=le32-unknown
+		os=-nacl
+		;;
+	ncr3000)
+		basic_machine=i486-ncr
+		os=-sysv4
+		;;
+	netbsd386)
+		basic_machine=i386-unknown
+		os=-netbsd
+		;;
+	netwinder)
+		basic_machine=armv4l-rebel
+		os=-linux
+		;;
+	news | news700 | news800 | news900)
+		basic_machine=m68k-sony
+		os=-newsos
+		;;
+	news1000)
+		basic_machine=m68030-sony
+		os=-newsos
 		;;
 	news-3600 | risc-news)
-		cpu=mips
-		vendor=sony
-		os=newsos
+		basic_machine=mips-sony
+		os=-newsos
+		;;
+	necv70)
+		basic_machine=v70-nec
+		os=-sysv
 		;;
 	next | m*-next)
-		cpu=m68k
-		vendor=next
+		basic_machine=m68k-next
 		case $os in
-		    nextstep* )
+		    -nextstep* )
 			;;
-		    ns2*)
-		      os=nextstep2
+		    -ns2*)
+		      os=-nextstep2
 			;;
 		    *)
-		      os=nextstep3
+		      os=-nextstep3
 			;;
 		esac
 		;;
+	nh3000)
+		basic_machine=m68k-harris
+		os=-cxux
+		;;
+	nh[45]000)
+		basic_machine=m88k-harris
+		os=-cxux
+		;;
+	nindy960)
+		basic_machine=i960-intel
+		os=-nindy
+		;;
+	mon960)
+		basic_machine=i960-intel
+		os=-mon960
+		;;
+	nonstopux)
+		basic_machine=mips-compaq
+		os=-nonstopux
+		;;
 	np1)
-		cpu=np1
-		vendor=gould
+		basic_machine=np1-gould
+		;;
+	neo-tandem)
+		basic_machine=neo-tandem
+		;;
+	nse-tandem)
+		basic_machine=nse-tandem
+		;;
+	nsr-tandem)
+		basic_machine=nsr-tandem
+		;;
+	nsv-tandem)
+		basic_machine=nsv-tandem
+		;;
+	nsx-tandem)
+		basic_machine=nsx-tandem
 		;;
 	op50n-* | op60c-*)
-		cpu=hppa1.1
-		vendor=oki
-		os=proelf
+		basic_machine=hppa1.1-oki
+		os=-proelf
+		;;
+	openrisc | openrisc-*)
+		basic_machine=or32-unknown
+		;;
+	os400)
+		basic_machine=powerpc-ibm
+		os=-os400
+		;;
+	OSE68000 | ose68000)
+		basic_machine=m68000-ericsson
+		os=-ose
+		;;
+	os68k)
+		basic_machine=m68k-none
+		os=-os68k
 		;;
 	pa-hitachi)
-		cpu=hppa1.1
-		vendor=hitachi
-		os=hiuxwe2
+		basic_machine=hppa1.1-hitachi
+		os=-hiuxwe2
+		;;
+	paragon)
+		basic_machine=i860-intel
+		os=-osf
+		;;
+	parisc)
+		basic_machine=hppa-unknown
+		os=-linux
+		;;
+	parisc-*)
+		basic_machine=hppa-`echo "$basic_machine" | sed 's/^[^-]*-//'`
+		os=-linux
 		;;
 	pbd)
-		cpu=sparc
-		vendor=tti
+		basic_machine=sparc-tti
 		;;
 	pbb)
-		cpu=m68k
-		vendor=tti
+		basic_machine=m68k-tti
 		;;
-	pc532)
-		cpu=ns32k
-		vendor=pc532
+	pc532 | pc532-*)
+		basic_machine=ns32k-pc532
 		;;
-	pn)
-		cpu=pn
-		vendor=gould
+	pc98)
+		basic_machine=i386-pc
 		;;
-	power)
-		cpu=power
-		vendor=ibm
+	pc98-*)
+		basic_machine=i386-`echo "$basic_machine" | sed 's/^[^-]*-//'`
 		;;
-	ps2)
-		cpu=i386
-		vendor=ibm
+	pentium | p5 | k5 | k6 | nexgen | viac3)
+		basic_machine=i586-pc
 		;;
-	rm[46]00)
-		cpu=mips
-		vendor=siemens
+	pentiumpro | p6 | 6x86 | athlon | athlon_*)
+		basic_machine=i686-pc
 		;;
-	rtpc | rtpc-*)
-		cpu=romp
-		vendor=ibm
+	pentiumii | pentium2 | pentiumiii | pentium3)
+		basic_machine=i686-pc
 		;;
-	sde)
-		cpu=mipsisa32
-		vendor=sde
-		os=${os:-elf}
+	pentium4)
+		basic_machine=i786-pc
 		;;
-	simso-wrs)
-		cpu=sparclite
-		vendor=wrs
-		os=vxworks
+	pentium-* | p5-* | k5-* | k6-* | nexgen-* | viac3-*)
+		basic_machine=i586-`echo "$basic_machine" | sed 's/^[^-]*-//'`
 		;;
-	tower | tower-32)
-		cpu=m68k
-		vendor=ncr
+	pentiumpro-* | p6-* | 6x86-* | athlon-*)
+		basic_machine=i686-`echo "$basic_machine" | sed 's/^[^-]*-//'`
 		;;
-	vpp*|vx|vx-*)
-		cpu=f301
-		vendor=fujitsu
+	pentiumii-* | pentium2-* | pentiumiii-* | pentium3-*)
+		basic_machine=i686-`echo "$basic_machine" | sed 's/^[^-]*-//'`
 		;;
-	w65)
-		cpu=w65
-		vendor=wdc
+	pentium4-*)
+		basic_machine=i786-`echo "$basic_machine" | sed 's/^[^-]*-//'`
 		;;
-	w89k-*)
-		cpu=hppa1.1
-		vendor=winbond
-		os=proelf
+	pn)
+		basic_machine=pn-gould
 		;;
-	none)
-		cpu=none
-		vendor=none
+	power)	basic_machine=power-ibm
 		;;
-	leon|leon[3-9])
-		cpu=sparc
-		vendor=$basic_machine
+	ppc | ppcbe)	basic_machine=powerpc-unknown
 		;;
-	leon-*|leon[3-9]-*)
-		cpu=sparc
-		vendor=`echo "$basic_machine" | sed 's/-.*//'`
+	ppc-* | ppcbe-*)
+		basic_machine=powerpc-`echo "$basic_machine" | sed 's/^[^-]*-//'`
 		;;
-
-	*-*)
-		IFS="-" read -r cpu vendor <<EOF
-$basic_machine
-EOF
+	ppcle | powerpclittle)
+		basic_machine=powerpcle-unknown
 		;;
-	# We use `pc' rather than `unknown'
-	# because (1) that's what they normally are, and
-	# (2) the word "unknown" tends to confuse beginning users.
-	i*86 | x86_64)
-		cpu=$basic_machine
-		vendor=pc
+	ppcle-* | powerpclittle-*)
+		basic_machine=powerpcle-`echo "$basic_machine" | sed 's/^[^-]*-//'`
 		;;
-	# These rules are duplicated from below for sake of the special case above;
-	# i.e. things that normalized to x86 arches should also default to "pc"
-	pc98)
-		cpu=i386
-		vendor=pc
+	ppc64)	basic_machine=powerpc64-unknown
 		;;
-	x64 | amd64)
-		cpu=x86_64
-		vendor=pc
+	ppc64-*) basic_machine=powerpc64-`echo "$basic_machine" | sed 's/^[^-]*-//'`
 		;;
-	# Recognize the basic CPU types without company name.
-	*)
-		cpu=$basic_machine
-		vendor=unknown
+	ppc64le | powerpc64little)
+		basic_machine=powerpc64le-unknown
 		;;
-esac
-
-unset -v basic_machine
-
-# Decode basic machines in the full and proper CPU-Company form.
-case $cpu-$vendor in
-	# Here we handle the default manufacturer of certain CPU types in cannonical form. It is in
-	# some cases the only manufacturer, in others, it is the most popular.
-	craynv-unknown)
-		vendor=cray
-		os=${os:-unicosmp}
+	ppc64le-* | powerpc64little-*)
+		basic_machine=powerpc64le-`echo "$basic_machine" | sed 's/^[^-]*-//'`
 		;;
-	c90-unknown | c90-cray)
-		vendor=cray
-		os=${os:-unicos}
+	ps2)
+		basic_machine=i386-ibm
 		;;
-	fx80-unknown)
-		vendor=alliant
+	pw32)
+		basic_machine=i586-unknown
+		os=-pw32
+		;;
+	rdos | rdos64)
+		basic_machine=x86_64-pc
+		os=-rdos
+		;;
+	rdos32)
+		basic_machine=i386-pc
+		os=-rdos
+		;;
+	rom68k)
+		basic_machine=m68k-rom68k
+		os=-coff
 		;;
-	romp-unknown)
-		vendor=ibm
+	rm[46]00)
+		basic_machine=mips-siemens
 		;;
-	mmix-unknown)
-		vendor=knuth
+	rtpc | rtpc-*)
+		basic_machine=romp-ibm
 		;;
-	microblaze-unknown | microblazeel-unknown)
-		vendor=xilinx
+	s390 | s390-*)
+		basic_machine=s390-ibm
 		;;
-	rs6000-unknown)
-		vendor=ibm
+	s390x | s390x-*)
+		basic_machine=s390x-ibm
 		;;
-	vax-unknown)
-		vendor=dec
+	sa29200)
+		basic_machine=a29k-amd
+		os=-udi
 		;;
-	pdp11-unknown)
-		vendor=dec
+	sb1)
+		basic_machine=mipsisa64sb1-unknown
 		;;
-	we32k-unknown)
-		vendor=att
+	sb1el)
+		basic_machine=mipsisa64sb1el-unknown
 		;;
-	cydra-unknown)
-		vendor=cydrome
+	sde)
+		basic_machine=mipsisa32-sde
+		os=-elf
 		;;
-	i370-ibm*)
-		vendor=ibm
+	sei)
+		basic_machine=mips-sei
+		os=-seiux
 		;;
-	orion-unknown)
-		vendor=highlevel
+	sequent)
+		basic_machine=i386-sequent
 		;;
-	xps-unknown | xps100-unknown)
-		cpu=xps100
-		vendor=honeywell
+	sh5el)
+		basic_machine=sh5le-unknown
 		;;
-
-	# Here we normalize CPU types with a missing or matching vendor
-	dpx20-unknown | dpx20-bull)
-		cpu=rs6000
-		vendor=bull
-		os=${os:-bosx}
+	simso-wrs)
+		basic_machine=sparclite-wrs
+		os=-vxworks
 		;;
-
-	# Here we normalize CPU types irrespective of the vendor
-	amd64-*)
-		cpu=x86_64
+	sps7)
+		basic_machine=m68k-bull
+		os=-sysv2
+		;;
+	spur)
+		basic_machine=spur-unknown
+		;;
+	st2000)
+		basic_machine=m68k-tandem
+		;;
+	stratus)
+		basic_machine=i860-stratus
+		os=-sysv4
 		;;
-	blackfin-*)
-		cpu=bfin
-		os=linux
+	strongarm-* | thumb-*)
+		basic_machine=arm-`echo "$basic_machine" | sed 's/^[^-]*-//'`
 		;;
-	c54x-*)
-		cpu=tic54x
+	sun2)
+		basic_machine=m68000-sun
 		;;
-	c55x-*)
-		cpu=tic55x
+	sun2os3)
+		basic_machine=m68000-sun
+		os=-sunos3
 		;;
-	c6x-*)
-		cpu=tic6x
+	sun2os4)
+		basic_machine=m68000-sun
+		os=-sunos4
 		;;
-	e500v[12]-*)
-		cpu=powerpc
-		os=$os"spe"
+	sun3os3)
+		basic_machine=m68k-sun
+		os=-sunos3
 		;;
-	mips3*-*)
-		cpu=mips64
+	sun3os4)
+		basic_machine=m68k-sun
+		os=-sunos4
 		;;
-	ms1-*)
-		cpu=mt
+	sun4os3)
+		basic_machine=sparc-sun
+		os=-sunos3
 		;;
-	m68knommu-*)
-		cpu=m68k
-		os=linux
+	sun4os4)
+		basic_machine=sparc-sun
+		os=-sunos4
 		;;
-	m9s12z-* | m68hcs12z-* | hcs12z-* | s12z-*)
-		cpu=s12z
+	sun4sol2)
+		basic_machine=sparc-sun
+		os=-solaris2
 		;;
-	openrisc-*)
-		cpu=or32
+	sun3 | sun3-*)
+		basic_machine=m68k-sun
 		;;
-	parisc-*)
-		cpu=hppa
-		os=linux
+	sun4)
+		basic_machine=sparc-sun
 		;;
-	pentium-* | p5-* | k5-* | k6-* | nexgen-* | viac3-*)
-		cpu=i586
+	sun386 | sun386i | roadrunner)
+		basic_machine=i386-sun
 		;;
-	pentiumpro-* | p6-* | 6x86-* | athlon-* | athalon_*-*)
-		cpu=i686
+	sv1)
+		basic_machine=sv1-cray
+		os=-unicos
 		;;
-	pentiumii-* | pentium2-* | pentiumiii-* | pentium3-*)
-		cpu=i686
+	symmetry)
+		basic_machine=i386-sequent
+		os=-dynix
 		;;
-	pentium4-*)
-		cpu=i786
+	t3e)
+		basic_machine=alphaev5-cray
+		os=-unicos
 		;;
-	pc98-*)
-		cpu=i386
+	t90)
+		basic_machine=t90-cray
+		os=-unicos
 		;;
-	ppc-* | ppcbe-*)
-		cpu=powerpc
+	tile*)
+		basic_machine=$basic_machine-unknown
+		os=-linux-gnu
 		;;
-	ppcle-* | powerpclittle-*)
-		cpu=powerpcle
+	tx39)
+		basic_machine=mipstx39-unknown
 		;;
-	ppc64-*)
-		cpu=powerpc64
+	tx39el)
+		basic_machine=mipstx39el-unknown
 		;;
-	ppc64le-* | powerpc64little-*)
-		cpu=powerpc64le
+	toad1)
+		basic_machine=pdp10-xkl
+		os=-tops20
 		;;
-	sb1-*)
-		cpu=mipsisa64sb1
+	tower | tower-32)
+		basic_machine=m68k-ncr
 		;;
-	sb1el-*)
-		cpu=mipsisa64sb1el
+	tpf)
+		basic_machine=s390x-ibm
+		os=-tpf
+		;;
+	udi29k)
+		basic_machine=a29k-amd
+		os=-udi
+		;;
+	ultra3)
+		basic_machine=a29k-nyu
+		os=-sym1
+		;;
+	v810 | necv810)
+		basic_machine=v810-nec
+		os=-none
+		;;
+	vaxv)
+		basic_machine=vax-dec
+		os=-sysv
+		;;
+	vms)
+		basic_machine=vax-dec
+		os=-vms
 		;;
-	sh5e[lb]-*)
-		cpu=`echo "$cpu" | sed 's/^\(sh.\)e\(.\)$/\1\2e/'`
+	vpp*|vx|vx-*)
+		basic_machine=f301-fujitsu
 		;;
-	spur-*)
-		cpu=spur
+	vxworks960)
+		basic_machine=i960-wrs
+		os=-vxworks
+		;;
+	vxworks68)
+		basic_machine=m68k-wrs
+		os=-vxworks
+		;;
+	vxworks29k)
+		basic_machine=a29k-wrs
+		os=-vxworks
+		;;
+	w65*)
+		basic_machine=w65-wdc
+		os=-none
 		;;
-	strongarm-* | thumb-*)
-		cpu=arm
+	w89k-*)
+		basic_machine=hppa1.1-winbond
+		os=-proelf
 		;;
-	tx39-*)
-		cpu=mipstx39
+	x64)
+		basic_machine=x86_64-pc
 		;;
-	tx39el-*)
-		cpu=mipstx39el
+	xbox)
+		basic_machine=i686-pc
+		os=-mingw32
 		;;
-	x64-*)
-		cpu=x86_64
+	xps | xps100)
+		basic_machine=xps100-honeywell
 		;;
 	xscale-* | xscalee[bl]-*)
-		cpu=`echo "$cpu" | sed 's/^xscale/arm/'`
+		basic_machine=`echo "$basic_machine" | sed 's/^xscale/arm/'`
+		;;
+	ymp)
+		basic_machine=ymp-cray
+		os=-unicos
+		;;
+	none)
+		basic_machine=none-none
+		os=-none
 		;;
 
-	# Recognize the cannonical CPU Types that limit and/or modify the
-	# company names they are paired with.
-	cr16-*)
-		os=${os:-elf}
+# Here we handle the default manufacturer of certain CPU types.  It is in
+# some cases the only manufacturer, in others, it is the most popular.
+	w89k)
+		basic_machine=hppa1.1-winbond
 		;;
-	crisv32-* | etraxfs*-*)
-		cpu=crisv32
-		vendor=axis
+	op50n)
+		basic_machine=hppa1.1-oki
 		;;
-	cris-* | etrax*-*)
-		cpu=cris
-		vendor=axis
+	op60c)
+		basic_machine=hppa1.1-oki
 		;;
-	crx-*)
-		os=${os:-elf}
+	romp)
+		basic_machine=romp-ibm
 		;;
-	neo-tandem)
-		cpu=neo
-		vendor=tandem
+	mmix)
+		basic_machine=mmix-knuth
 		;;
-	nse-tandem)
-		cpu=nse
-		vendor=tandem
+	rs6000)
+		basic_machine=rs6000-ibm
 		;;
-	nsr-tandem)
-		cpu=nsr
-		vendor=tandem
+	vax)
+		basic_machine=vax-dec
 		;;
-	nsv-tandem)
-		cpu=nsv
-		vendor=tandem
+	pdp11)
+		basic_machine=pdp11-dec
 		;;
-	nsx-tandem)
-		cpu=nsx
-		vendor=tandem
+	we32k)
+		basic_machine=we32k-att
 		;;
-	s390-*)
-		cpu=s390
-		vendor=ibm
-		;;
-	s390x-*)
-		cpu=s390x
-		vendor=ibm
+	sh[1234] | sh[24]a | sh[24]aeb | sh[34]eb | sh[1234]le | sh[23]ele)
+		basic_machine=sh-unknown
 		;;
-	tile*-*)
-		os=${os:-linux-gnu}
+	cydra)
+		basic_machine=cydra-cydrome
+		;;
+	orion)
+		basic_machine=orion-highlevel
+		;;
+	orion105)
+		basic_machine=clipper-highlevel
+		;;
+	mac | mpw | mac-mpw)
+		basic_machine=m68k-apple
+		;;
+	pmac | pmac-mpw)
+		basic_machine=powerpc-apple
+		;;
+	*-unknown)
+		# Make sure to match an already-canonicalized machine name.
 		;;
-
 	*)
-		# Recognize the cannonical CPU types that are allowed with any
-		# company name.
-		case $cpu in
-			1750a | 580 \
-			| a29k \
-			| aarch64 | aarch64_be \
-			| abacus \
-			| alpha | alphaev[4-8] | alphaev56 | alphaev6[78] \
-			| alpha64 | alpha64ev[4-8] | alpha64ev56 | alpha64ev6[78] \
-			| alphapca5[67] | alpha64pca5[67] \
-			| am33_2.0 \
-			| arc | arceb \
-			| arm  | arm[lb]e | arme[lb] | armv* \
-			| avr | avr32 \
-			| asmjs \
-			| ba \
-			| be32 | be64 \
-			| bfin | bs2000 \
-			| c[123]* | c30 | [cjt]90 | c4x \
-			| c8051 | clipper | craynv | csky | cydra \
-			| d10v | d30v | dlx | dsp16xx \
-			| e2k | elxsi | epiphany \
-			| f30[01] | f700 | fido | fr30 | frv | ft32 | fx80 \
-			| h8300 | h8500 \
-			| hppa | hppa1.[01] | hppa2.0 | hppa2.0[nw] | hppa64 \
-			| hexagon \
-			| i370 | i*86 | i860 | i960 | ia16 | ia64 \
-			| ip2k | iq2000 \
-			| k1om \
-			| le32 | le64 \
-			| lm32 \
-			| m32c | m32r | m32rle \
-			| m5200 | m68000 | m680[012346]0 | m68360 | m683?2 | m68k | v70 | w65 \
-			| m6811 | m68hc11 | m6812 | m68hc12 | m68hcs12x | nvptx | picochip \
-			| m88110 | m88k | maxq | mb | mcore | mep | metag \
-			| microblaze | microblazeel \
-			| mips | mipsbe | mipseb | mipsel | mipsle \
-			| mips16 \
-			| mips64 | mips64el \
-			| mips64octeon | mips64octeonel \
-			| mips64orion | mips64orionel \
-			| mips64r5900 | mips64r5900el \
-			| mips64vr | mips64vrel \
-			| mips64vr4100 | mips64vr4100el \
-			| mips64vr4300 | mips64vr4300el \
-			| mips64vr5000 | mips64vr5000el \
-			| mips64vr5900 | mips64vr5900el \
-			| mipsisa32 | mipsisa32el \
-			| mipsisa32r2 | mipsisa32r2el \
-			| mipsisa32r6 | mipsisa32r6el \
-			| mipsisa64 | mipsisa64el \
-			| mipsisa64r2 | mipsisa64r2el \
-			| mipsisa64r6 | mipsisa64r6el \
-			| mipsisa64sb1 | mipsisa64sb1el \
-			| mipsisa64sr71k | mipsisa64sr71kel \
-			| mipsr5900 | mipsr5900el \
-			| mipstx39 | mipstx39el \
-			| mmix \
-			| mn10200 | mn10300 \
-			| moxie \
-			| mt \
-			| msp430 \
-			| nds32 | nds32le | nds32be \
-			| nfp \
-			| nios | nios2 | nios2eb | nios2el \
-			| none | np1 | ns16k | ns32k \
-			| open8 \
-			| or1k* \
-			| or32 \
-			| orion \
-			| pdp10 | pdp11 | pj | pjl | pn | power \
-			| powerpc | powerpc64 | powerpc64le | powerpcle | powerpcspe \
-			| pru \
-			| pyramid \
-			| riscv | riscv32 | riscv64 \
-			| rl78 | romp | rs6000 | rx \
-			| score \
-			| sh | sh[1234] | sh[24]a | sh[24]ae[lb] | sh[23]e | she[lb] | sh[lb]e \
-			| sh[1234]e[lb] |  sh[12345][lb]e | sh[23]ele | sh64 | sh64le \
-			| sparc | sparc64 | sparc64b | sparc64v | sparc86x | sparclet \
-			| sparclite \
-			| sparcv8 | sparcv9 | sparcv9b | sparcv9v | sv1 | sx* \
-			| spu \
-			| tahoe \
-			| tic30 | tic4x | tic54x | tic55x | tic6x | tic80 \
-			| tron \
-			| ubicom32 \
-			| v850 | v850e | v850e1 | v850es | v850e2 | v850e2v3 \
-			| vax \
-			| visium \
-			| wasm32 \
-			| we32k \
-			| x86 | x86_64 | xc16x | xgate | xps100 \
-			| xstormy16 | xtensa* \
-			| ymp \
-			| z8k | z80)
-				;;
-
-			*)
-				echo Invalid configuration \`"$1"\': machine \`"$cpu-$vendor"\' not recognized 1>&2
-				exit 1
-				;;
-		esac
+		echo Invalid configuration \`"$1"\': machine \`"$basic_machine"\' not recognized 1>&2
+		exit 1
 		;;
 esac
 
 # Here we canonicalize certain aliases for manufacturers.
-case $vendor in
-	digital*)
-		vendor=dec
+case $basic_machine in
+	*-digital*)
+		basic_machine=`echo "$basic_machine" | sed 's/digital.*/dec/'`
 		;;
-	commodore*)
-		vendor=cbm
+	*-commodore*)
+		basic_machine=`echo "$basic_machine" | sed 's/commodore.*/cbm/'`
 		;;
 	*)
 		;;
@@ -1275,240 +1365,200 @@ then
 case $os in
 	# First match some system type aliases that might get confused
 	# with valid system types.
-	# solaris* is a basic system type, with this one exception.
-	auroraux)
-		os=auroraux
+	# -solaris* is a basic system type, with this one exception.
+	-auroraux)
+		os=-auroraux
 		;;
-	bluegene*)
-		os=cnk
-		;;
-	solaris1 | solaris1.*)
+	-solaris1 | -solaris1.*)
 		os=`echo $os | sed -e 's|solaris1|sunos4|'`
 		;;
-	solaris)
-		os=solaris2
+	-solaris)
+		os=-solaris2
 		;;
-	unixware*)
-		os=sysv4.2uw
+	-unixware*)
+		os=-sysv4.2uw
 		;;
-	gnu/linux*)
+	-gnu/linux*)
 		os=`echo $os | sed -e 's|gnu/linux|linux-gnu|'`
 		;;
 	# es1800 is here to avoid being matched by es* (a different OS)
-	es1800*)
-		os=ose
-		;;
-	# Some version numbers need modification
-	chorusos*)
-		os=chorusos
-		;;
-	isc)
-		os=isc2.2
-		;;
-	sco6)
-		os=sco5v6
-		;;
-	sco5)
-		os=sco3.2v5
-		;;
-	sco4)
-		os=sco3.2v4
-		;;
-	sco3.2.[4-9]*)
-		os=`echo $os | sed -e 's/sco3.2./sco3.2v/'`
-		;;
-	sco3.2v[4-9]* | sco5v6*)
-		# Don't forget version if it is 3.2v4 or newer.
-		;;
-	scout)
-		# Don't match below
-		;;
-	sco*)
-		os=sco3.2v2
-		;;
-	psos*)
-		os=psos
+	-es1800*)
+		os=-ose
 		;;
 	# Now accept the basic system types.
 	# The portable systems comes first.
 	# Each alternative MUST end in a * to match a version number.
-	# sysv* is not here because it comes later, after sysvr4.
-	gnu* | bsd* | mach* | minix* | genix* | ultrix* | irix* \
-	     | *vms* | esix* | aix* | cnk* | sunos | sunos[34]*\
-	     | hpux* | unos* | osf* | luna* | dgux* | auroraux* | solaris* \
-	     | sym* | kopensolaris* | plan9* \
-	     | amigaos* | amigados* | msdos* | newsos* | unicos* | aof* \
-	     | aos* | aros* | cloudabi* | sortix* \
-	     | nindy* | vxsim* | vxworks* | ebmon* | hms* | mvs* \
-	     | clix* | riscos* | uniplus* | iris* | isc* | rtu* | xenix* \
-	     | knetbsd* | mirbsd* | netbsd* \
-	     | bitrig* | openbsd* | solidbsd* | libertybsd* \
-	     | ekkobsd* | kfreebsd* | freebsd* | riscix* | lynxos* \
-	     | bosx* | nextstep* | cxux* | aout* | elf* | oabi* \
-	     | ptx* | coff* | ecoff* | winnt* | domain* | vsta* \
-	     | udi* | eabi* | lites* | ieee* | go32* | aux* | hcos* \
-	     | chorusrdb* | cegcc* | glidix* \
-	     | cygwin* | msys* | pe* | moss* | proelf* | rtems* \
-	     | midipix* | mingw32* | mingw64* | linux-gnu* | linux-android* \
-	     | linux-newlib* | linux-musl* | linux-uclibc* \
-	     | uxpv* | beos* | mpeix* | udk* | moxiebox* \
-	     | interix* | uwin* | mks* | rhapsody* | darwin* \
-	     | openstep* | oskit* | conix* | pw32* | nonstopux* \
-	     | storm-chaos* | tops10* | tenex* | tops20* | its* \
-	     | os2* | vos* | palmos* | uclinux* | nucleus* \
-	     | morphos* | superux* | rtmk* | windiss* \
-	     | powermax* | dnix* | nx6 | nx7 | sei* | dragonfly* \
-	     | skyos* | haiku* | rdos* | toppers* | drops* | es* \
-	     | onefs* | tirtos* | phoenix* | fuchsia* | redox* | bme* \
-	     | midnightbsd*)
+	# -sysv* is not here because it comes later, after sysvr4.
+	-gnu* | -bsd* | -mach* | -minix* | -genix* | -ultrix* | -irix* \
+	      | -*vms* | -sco* | -esix* | -isc* | -aix* | -cnk* | -sunos | -sunos[34]*\
+	      | -hpux* | -unos* | -osf* | -luna* | -dgux* | -auroraux* | -solaris* \
+	      | -sym* | -kopensolaris* | -plan9* \
+	      | -amigaos* | -amigados* | -msdos* | -newsos* | -unicos* | -aof* \
+	      | -aos* | -aros* | -cloudabi* | -sortix* \
+	      | -nindy* | -vxsim* | -vxworks* | -ebmon* | -hms* | -mvs* \
+	      | -clix* | -riscos* | -uniplus* | -iris* | -rtu* | -xenix* \
+	      | -hiux* | -knetbsd* | -mirbsd* | -netbsd* \
+	      | -bitrig* | -openbsd* | -solidbsd* | -libertybsd* \
+	      | -ekkobsd* | -kfreebsd* | -freebsd* | -riscix* | -lynxos* \
+	      | -bosx* | -nextstep* | -cxux* | -aout* | -elf* | -oabi* \
+	      | -ptx* | -coff* | -ecoff* | -winnt* | -domain* | -vsta* \
+	      | -udi* | -eabi* | -lites* | -ieee* | -go32* | -aux* | -hcos* \
+	      | -chorusos* | -chorusrdb* | -cegcc* | -glidix* \
+	      | -cygwin* | -msys* | -pe* | -psos* | -moss* | -proelf* | -rtems* \
+	      | -midipix* | -mingw32* | -mingw64* | -linux-gnu* | -linux-android* \
+	      | -linux-newlib* | -linux-musl* | -linux-uclibc* \
+	      | -uxpv* | -beos* | -mpeix* | -udk* | -moxiebox* \
+	      | -interix* | -uwin* | -mks* | -rhapsody* | -darwin* \
+	      | -openstep* | -oskit* | -conix* | -pw32* | -nonstopux* \
+	      | -storm-chaos* | -tops10* | -tenex* | -tops20* | -its* \
+	      | -os2* | -vos* | -palmos* | -uclinux* | -nucleus* \
+	      | -morphos* | -superux* | -rtmk* | -windiss* \
+	      | -powermax* | -dnix* | -nx6 | -nx7 | -sei* | -dragonfly* \
+	      | -skyos* | -haiku* | -rdos* | -toppers* | -drops* | -es* \
+	      | -onefs* | -tirtos* | -phoenix* | -fuchsia* | -redox* | -bme* \
+	      | -midnightbsd*)
 	# Remember, each alternative MUST END IN *, to match a version number.
 		;;
-	qnx*)
-		case $cpu in
-		    x86 | i*86)
+	-qnx*)
+		case $basic_machine in
+		    x86-* | i*86-*)
 			;;
 		    *)
-			os=nto-$os
+			os=-nto$os
 			;;
 		esac
 		;;
-	hiux*)
-		os=hiuxwe2
+	-nto-qnx*)
 		;;
-	nto-qnx*)
-		;;
-	nto*)
+	-nto*)
 		os=`echo $os | sed -e 's|nto|nto-qnx|'`
 		;;
-	sim | xray | os68k* | v88r* \
-	    | windows* | osx | abug | netware* | os9* \
-	    | macos* | mpw* | magic* | mmixware* | mon960* | lnews*)
-		;;
-	linux-dietlibc)
-		os=linux-dietlibc
-		;;
-	linux*)
-		os=`echo $os | sed -e 's|linux|linux-gnu|'`
+	-sim | -xray | -os68k* | -v88r* \
+	      | -windows* | -osx | -abug | -netware* | -os9* \
+	      | -macos* | -mpw* | -magic* | -mmixware* | -mon960* | -lnews*)
 		;;
-	lynx*178)
-		os=lynxos178
-		;;
-	lynx*5)
-		os=lynxos5
-		;;
-	lynx*)
-		os=lynxos
-		;;
-	mac*)
+	-mac*)
 		os=`echo "$os" | sed -e 's|mac|macos|'`
 		;;
-	opened*)
-		os=openedition
+	-linux-dietlibc)
+		os=-linux-dietlibc
 		;;
-	os400*)
-		os=os400
+	-linux*)
+		os=`echo $os | sed -e 's|linux|linux-gnu|'`
 		;;
-	sunos5*)
+	-sunos5*)
 		os=`echo "$os" | sed -e 's|sunos5|solaris2|'`
 		;;
-	sunos6*)
+	-sunos6*)
 		os=`echo "$os" | sed -e 's|sunos6|solaris3|'`
 		;;
-	wince*)
-		os=wince
+	-opened*)
+		os=-openedition
 		;;
-	utek*)
-		os=bsd
+	-os400*)
+		os=-os400
 		;;
-	dynix*)
-		os=bsd
+	-wince*)
+		os=-wince
 		;;
-	acis*)
-		os=aos
+	-utek*)
+		os=-bsd
 		;;
-	atheos*)
-		os=atheos
+	-dynix*)
+		os=-bsd
 		;;
-	syllable*)
-		os=syllable
+	-acis*)
+		os=-aos
 		;;
-	386bsd)
-		os=bsd
+	-atheos*)
+		os=-atheos
+		;;
+	-syllable*)
+		os=-syllable
 		;;
-	ctix* | uts*)
-		os=sysv
+	-386bsd)
+		os=-bsd
 		;;
-	nova*)
-		os=rtmk-nova
+	-ctix* | -uts*)
+		os=-sysv
 		;;
-	ns2)
-		os=nextstep2
+	-nova*)
+		os=-rtmk-nova
 		;;
-	nsk*)
-		os=nsk
+	-ns2)
+		os=-nextstep2
+		;;
+	-nsk*)
+		os=-nsk
 		;;
 	# Preserve the version number of sinix5.
-	sinix5.*)
+	-sinix5.*)
 		os=`echo $os | sed -e 's|sinix|sysv|'`
 		;;
-	sinix*)
-		os=sysv4
+	-sinix*)
+		os=-sysv4
 		;;
-	tpf*)
-		os=tpf
+	-tpf*)
+		os=-tpf
 		;;
-	triton*)
-		os=sysv3
+	-triton*)
+		os=-sysv3
 		;;
-	oss*)
-		os=sysv3
+	-oss*)
+		os=-sysv3
 		;;
-	svr4*)
-		os=sysv4
+	-svr4*)
+		os=-sysv4
 		;;
-	svr3)
-		os=sysv3
+	-svr3)
+		os=-sysv3
 		;;
-	sysvr4)
-		os=sysv4
+	-sysvr4)
+		os=-sysv4
 		;;
-	# This must come after sysvr4.
-	sysv*)
+	# This must come after -sysvr4.
+	-sysv*)
 		;;
-	ose*)
-		os=ose
+	-ose*)
+		os=-ose
 		;;
-	*mint | mint[0-9]* | *MiNT | MiNT[0-9]*)
-		os=mint
+	-*mint | -mint[0-9]* | -*MiNT | -MiNT[0-9]*)
+		os=-mint
 		;;
-	zvmoe)
-		os=zvmoe
+	-zvmoe)
+		os=-zvmoe
 		;;
-	dicos*)
-		os=dicos
+	-dicos*)
+		os=-dicos
 		;;
-	pikeos*)
+	-pikeos*)
 		# Until real need of OS specific support for
 		# particular features comes up, bare metal
 		# configurations are quite functional.
-		case $cpu in
+		case $basic_machine in
 		    arm*)
-			os=eabi
+			os=-eabi
 			;;
 		    *)
-			os=elf
+			os=-elf
 			;;
 		esac
 		;;
-	nacl*)
+	-nacl*)
 		;;
-	ios)
+	-ios)
 		;;
-	none)
+	-none)
 		;;
-	*-eabi)
+	-*-eabi)
+		case $basic_machine in
+		    arm*)
+			;;
+		esac
 		;;
 	*)
+		# Get rid of the `-' at the beginning of $os.
+		os=`echo $os | sed 's/[^-]*-//'`
 		echo Invalid configuration \`"$1"\': system \`"$os"\' not recognized 1>&2
 		exit 1
 		;;
@@ -1525,261 +1575,254 @@ else
 # will signal an error saying that MANUFACTURER isn't an operating
 # system, and we'll never get to this point.
 
-case $cpu-$vendor in
+case $basic_machine in
 	score-*)
-		os=elf
+		os=-elf
 		;;
 	spu-*)
-		os=elf
+		os=-elf
 		;;
 	*-acorn)
-		os=riscix1.2
+		os=-riscix1.2
 		;;
 	arm*-rebel)
-		os=linux
+		os=-linux
 		;;
 	arm*-semi)
-		os=aout
+		os=-aout
 		;;
 	c4x-* | tic4x-*)
-		os=coff
+		os=-coff
 		;;
 	c8051-*)
-		os=elf
-		;;
-	clipper-intergraph)
-		os=clix
+		os=-elf
 		;;
 	hexagon-*)
-		os=elf
+		os=-elf
 		;;
 	tic54x-*)
-		os=coff
+		os=-coff
 		;;
 	tic55x-*)
-		os=coff
+		os=-coff
 		;;
 	tic6x-*)
-		os=coff
+		os=-coff
 		;;
 	# This must come before the *-dec entry.
 	pdp10-*)
-		os=tops20
+		os=-tops20
 		;;
 	pdp11-*)
-		os=none
+		os=-none
 		;;
 	*-dec | vax-*)
-		os=ultrix4.2
+		os=-ultrix4.2
 		;;
 	m68*-apollo)
-		os=domain
+		os=-domain
 		;;
 	i386-sun)
-		os=sunos4.0.2
+		os=-sunos4.0.2
 		;;
 	m68000-sun)
-		os=sunos3
+		os=-sunos3
 		;;
 	m68*-cisco)
-		os=aout
+		os=-aout
 		;;
 	mep-*)
-		os=elf
+		os=-elf
 		;;
 	mips*-cisco)
-		os=elf
+		os=-elf
 		;;
 	mips*-*)
-		os=elf
+		os=-elf
 		;;
 	or32-*)
-		os=coff
+		os=-coff
 		;;
 	*-tti)	# must be before sparc entry or we get the wrong os.
-		os=sysv3
+		os=-sysv3
 		;;
 	sparc-* | *-sun)
-		os=sunos4.1.1
+		os=-sunos4.1.1
 		;;
 	pru-*)
-		os=elf
+		os=-elf
 		;;
 	*-be)
-		os=beos
+		os=-beos
 		;;
 	*-ibm)
-		os=aix
+		os=-aix
 		;;
 	*-knuth)
-		os=mmixware
+		os=-mmixware
 		;;
 	*-wec)
-		os=proelf
+		os=-proelf
 		;;
 	*-winbond)
-		os=proelf
+		os=-proelf
 		;;
 	*-oki)
-		os=proelf
+		os=-proelf
 		;;
 	*-hp)
-		os=hpux
+		os=-hpux
 		;;
 	*-hitachi)
-		os=hiux
+		os=-hiux
 		;;
 	i860-* | *-att | *-ncr | *-altos | *-motorola | *-convergent)
-		os=sysv
+		os=-sysv
 		;;
 	*-cbm)
-		os=amigaos
+		os=-amigaos
 		;;
 	*-dg)
-		os=dgux
+		os=-dgux
 		;;
 	*-dolphin)
-		os=sysv3
+		os=-sysv3
 		;;
 	m68k-ccur)
-		os=rtu
+		os=-rtu
 		;;
 	m88k-omron*)
-		os=luna
+		os=-luna
 		;;
 	*-next)
-		os=nextstep
+		os=-nextstep
 		;;
 	*-sequent)
-		os=ptx
+		os=-ptx
 		;;
 	*-crds)
-		os=unos
+		os=-unos
 		;;
 	*-ns)
-		os=genix
+		os=-genix
 		;;
 	i370-*)
-		os=mvs
+		os=-mvs
 		;;
 	*-gould)
-		os=sysv
+		os=-sysv
 		;;
 	*-highlevel)
-		os=bsd
+		os=-bsd
 		;;
 	*-encore)
-		os=bsd
+		os=-bsd
 		;;
 	*-sgi)
-		os=irix
+		os=-irix
 		;;
 	*-siemens)
-		os=sysv4
+		os=-sysv4
 		;;
 	*-masscomp)
-		os=rtu
+		os=-rtu
 		;;
 	f30[01]-fujitsu | f700-fujitsu)
-		os=uxpv
+		os=-uxpv
 		;;
 	*-rom68k)
-		os=coff
+		os=-coff
 		;;
 	*-*bug)
-		os=coff
+		os=-coff
 		;;
 	*-apple)
-		os=macos
+		os=-macos
 		;;
 	*-atari*)
-		os=mint
-		;;
-	*-wrs)
-		os=vxworks
+		os=-mint
 		;;
 	*)
-		os=none
+		os=-none
 		;;
 esac
 fi
 
 # Here we handle the case where we know the os, and the CPU type, but not the
 # manufacturer.  We pick the logical manufacturer.
-case $vendor in
-	unknown)
+vendor=unknown
+case $basic_machine in
+	*-unknown)
 		case $os in
-			riscix*)
+			-riscix*)
 				vendor=acorn
 				;;
-			sunos*)
+			-sunos*)
 				vendor=sun
 				;;
-			cnk*|-aix*)
+			-cnk*|-aix*)
 				vendor=ibm
 				;;
-			beos*)
+			-beos*)
 				vendor=be
 				;;
-			hpux*)
+			-hpux*)
 				vendor=hp
 				;;
-			mpeix*)
+			-mpeix*)
 				vendor=hp
 				;;
-			hiux*)
+			-hiux*)
 				vendor=hitachi
 				;;
-			unos*)
+			-unos*)
 				vendor=crds
 				;;
-			dgux*)
+			-dgux*)
 				vendor=dg
 				;;
-			luna*)
+			-luna*)
 				vendor=omron
 				;;
-			genix*)
+			-genix*)
 				vendor=ns
 				;;
-			clix*)
-				vendor=intergraph
-				;;
-			mvs* | opened*)
+			-mvs* | -opened*)
 				vendor=ibm
 				;;
-			os400*)
+			-os400*)
 				vendor=ibm
 				;;
-			ptx*)
+			-ptx*)
 				vendor=sequent
 				;;
-			tpf*)
+			-tpf*)
 				vendor=ibm
 				;;
-			vxsim* | vxworks* | windiss*)
+			-vxsim* | -vxworks* | -windiss*)
 				vendor=wrs
 				;;
-			aux*)
+			-aux*)
 				vendor=apple
 				;;
-			hms*)
+			-hms*)
 				vendor=hitachi
 				;;
-			mpw* | macos*)
+			-mpw* | -macos*)
 				vendor=apple
 				;;
-			*mint | mint[0-9]* | *MiNT | MiNT[0-9]*)
+			-*mint | -mint[0-9]* | -*MiNT | -MiNT[0-9]*)
 				vendor=atari
 				;;
-			vos*)
+			-vos*)
 				vendor=stratus
 				;;
 		esac
+		basic_machine=`echo "$basic_machine" | sed "s/unknown/$vendor/"`
 		;;
 esac
 
-echo "$cpu-$vendor-$os"
+echo "$basic_machine$os"
 exit
 
 # Local variables:
diff -pruN 0.14.1+dfsg-1/build-aux/ltmain.sh 0.15+dfsg-1/build-aux/ltmain.sh
--- 0.14.1+dfsg-1/build-aux/ltmain.sh	2020-07-08 06:50:01.000000000 +0000
+++ 0.15+dfsg-1/build-aux/ltmain.sh	2020-09-23 14:48:53.000000000 +0000
@@ -2124,7 +2124,7 @@ fi
 # a configuration failure hint, and exit.
 func_fatal_configuration ()
 {
-    func_fatal_error ${1+"$@"} \
+    func__fatal_error ${1+"$@"} \
       "See the $PACKAGE documentation for more information." \
       "Fatal configuration error."
 }
diff -pruN 0.14.1+dfsg-1/config.h.in 0.15+dfsg-1/config.h.in
--- 0.14.1+dfsg-1/config.h.in	2020-07-08 06:50:03.000000000 +0000
+++ 0.15+dfsg-1/config.h.in	2020-09-23 14:48:56.000000000 +0000
@@ -12,6 +12,9 @@
 /* Define to 1 if you have the <dlfcn.h> header file. */
 #undef HAVE_DLFCN_H
 
+/* Define if DLOPEN is available */
+#undef HAVE_DLOPEN
+
 /* Define if eBPF is available */
 #undef HAVE_EBPF
 
@@ -42,6 +45,9 @@
 /* Define if seccomp is available */
 #undef HAVE_SECCOMP
 
+/* Define if SECCOMP_GET_NOTIF_SIZES is available */
+#undef HAVE_SECCOMP_GET_NOTIF_SIZES
+
 /* Define to 1 if you have the <seccomp.h> header file. */
 #undef HAVE_SECCOMP_H
 
diff -pruN 0.14.1+dfsg-1/configure 0.15+dfsg-1/configure
--- 0.14.1+dfsg-1/configure	2020-07-08 06:50:03.000000000 +0000
+++ 0.15+dfsg-1/configure	2020-09-23 14:48:56.000000000 +0000
@@ -1,6 +1,6 @@
 #! /bin/sh
 # Guess values for system-dependent variables and create Makefiles.
-# Generated by GNU Autoconf 2.69 for crun 0.14.1.
+# Generated by GNU Autoconf 2.69 for crun 0.15.
 #
 # Report bugs to <giuseppe@scrivano.org>.
 #
@@ -590,8 +590,8 @@ MAKEFLAGS=
 # Identity of this package.
 PACKAGE_NAME='crun'
 PACKAGE_TARNAME='crun'
-PACKAGE_VERSION='0.14.1'
-PACKAGE_STRING='crun 0.14.1'
+PACKAGE_VERSION='0.15'
+PACKAGE_STRING='crun 0.15'
 PACKAGE_BUGREPORT='giuseppe@scrivano.org'
 PACKAGE_URL=''
 
@@ -1364,7 +1364,7 @@ if test "$ac_init_help" = "long"; then
   # Omit some internal or obsolete options to make the list less imposing.
   # This message is too long to be a string in the A/UX 3.1 sh.
   cat <<_ACEOF
-\`configure' configures crun 0.14.1 to adapt to many kinds of systems.
+\`configure' configures crun 0.15 to adapt to many kinds of systems.
 
 Usage: $0 [OPTION]... [VAR=VALUE]...
 
@@ -1434,7 +1434,7 @@ fi
 
 if test -n "$ac_init_help"; then
   case $ac_init_help in
-     short | recursive ) echo "Configuration of crun 0.14.1:";;
+     short | recursive ) echo "Configuration of crun 0.15:";;
    esac
   cat <<\_ACEOF
 
@@ -1566,7 +1566,7 @@ fi
 test -n "$ac_init_help" && exit $ac_status
 if $ac_init_version; then
   cat <<\_ACEOF
-crun configure 0.14.1
+crun configure 0.15
 generated by GNU Autoconf 2.69
 
 Copyright (C) 2012 Free Software Foundation, Inc.
@@ -1935,7 +1935,7 @@ cat >config.log <<_ACEOF
 This file contains any messages produced by compilers while
 running configure, to aid debugging if configure makes a mistake.
 
-It was created by crun $as_me 0.14.1, which was
+It was created by crun $as_me 0.15, which was
 generated by GNU Autoconf 2.69.  Invocation command line was
 
   $ $0 $@
@@ -11879,7 +11879,7 @@ fi
 
 # Define the identity of the package.
  PACKAGE='crun'
- VERSION='0.14.1'
+ VERSION='0.15'
 
 
 cat >>confdefs.h <<_ACEOF
@@ -14227,6 +14227,25 @@ $as_echo "no" >&6; }
 fi
 rm -f core conftest.err conftest.$ac_objext conftest.$ac_ext
 
+cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+/* end confdefs.h.  */
+
+			#include <linux/seccomp.h>
+			int cmd = SECCOMP_GET_NOTIF_SIZES;
+
+_ACEOF
+if ac_fn_c_try_compile "$LINENO"; then :
+  { $as_echo "$as_me:${as_lineno-$LINENO}: result: yes" >&5
+$as_echo "yes" >&6; }
+
+$as_echo "#define HAVE_SECCOMP_GET_NOTIF_SIZES 1" >>confdefs.h
+
+else
+  { $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
+$as_echo "no" >&6; }
+fi
+rm -f core conftest.err conftest.$ac_objext conftest.$ac_ext
+
 
 $as_echo "#define LIBCRUN_PUBLIC __attribute__((visibility(\"default\"))) extern" >>confdefs.h
 
@@ -14334,6 +14353,64 @@ if test -z "$GPERF"; then
 $as_echo "$as_me: gperf not found - cannot rebuild signal parser code" >&6;}
 fi
 
+{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for library containing dlopen" >&5
+$as_echo_n "checking for library containing dlopen... " >&6; }
+if ${ac_cv_search_dlopen+:} false; then :
+  $as_echo_n "(cached) " >&6
+else
+  ac_func_search_save_LIBS=$LIBS
+cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+/* end confdefs.h.  */
+
+/* Override any GCC internal prototype to avoid an error.
+   Use char because int might match the return type of a GCC
+   builtin and then its argument prototype would still apply.  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char dlopen ();
+int
+main ()
+{
+return dlopen ();
+  ;
+  return 0;
+}
+_ACEOF
+for ac_lib in '' dl; do
+  if test -z "$ac_lib"; then
+    ac_res="none required"
+  else
+    ac_res=-l$ac_lib
+    LIBS="-l$ac_lib  $ac_func_search_save_LIBS"
+  fi
+  if ac_fn_c_try_link "$LINENO"; then :
+  ac_cv_search_dlopen=$ac_res
+fi
+rm -f core conftest.err conftest.$ac_objext \
+    conftest$ac_exeext
+  if ${ac_cv_search_dlopen+:} false; then :
+  break
+fi
+done
+if ${ac_cv_search_dlopen+:} false; then :
+
+else
+  ac_cv_search_dlopen=no
+fi
+rm conftest.$ac_ext
+LIBS=$ac_func_search_save_LIBS
+fi
+{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_search_dlopen" >&5
+$as_echo "$ac_cv_search_dlopen" >&6; }
+ac_res=$ac_cv_search_dlopen
+if test "$ac_res" != no; then :
+  test "$ac_res" = "none required" || LIBS="$ac_res $LIBS"
+
+$as_echo "#define HAVE_DLOPEN 1" >>confdefs.h
+]
+fi
+
 
 { $as_echo "$as_me:${as_lineno-$LINENO}: checking for library containing argp_parse" >&5
 $as_echo_n "checking for library containing argp_parse... " >&6; }
@@ -14964,7 +15041,7 @@ cat >>$CONFIG_STATUS <<\_ACEOF || ac_wri
 # report actual input values of CONFIG_FILES etc. instead of their
 # values after options handling.
 ac_log="
-This file was extended by crun $as_me 0.14.1, which was
+This file was extended by crun $as_me 0.15, which was
 generated by GNU Autoconf 2.69.  Invocation command line was
 
   CONFIG_FILES    = $CONFIG_FILES
@@ -15030,7 +15107,7 @@ _ACEOF
 cat >>$CONFIG_STATUS <<_ACEOF || ac_write_fail=1
 ac_cs_config="`$as_echo "$ac_configure_args" | sed 's/^ //; s/[\\""\`\$]/\\\\&/g'`"
 ac_cs_version="\\
-crun config.status 0.14.1
+crun config.status 0.15
 configured by $0, generated by GNU Autoconf 2.69,
   with options \\"\$ac_cs_config\\"
 
diff -pruN 0.14.1+dfsg-1/configure.ac 0.15+dfsg-1/configure.ac
--- 0.14.1+dfsg-1/configure.ac	2020-07-08 06:49:25.000000000 +0000
+++ 0.15+dfsg-1/configure.ac	2020-09-03 11:43:25.000000000 +0000
@@ -115,6 +115,16 @@ AC_COMPILE_IFELSE(
 		 AC_DEFINE([HAVE_FSCONFIG_CMD_CREATE], 1, [Define if FSCONFIG_CMD_CREATE is available])],
 		[AC_MSG_RESULT(no)])
 
+dnl seccomp notify API
+AC_COMPILE_IFELSE(
+	[AC_LANG_SOURCE([[
+			#include <linux/seccomp.h>
+			int cmd = SECCOMP_GET_NOTIF_SIZES;
+		]])],
+		[AC_MSG_RESULT(yes)
+		 AC_DEFINE([HAVE_SECCOMP_GET_NOTIF_SIZES], 1, [Define if SECCOMP_GET_NOTIF_SIZES is available])],
+		[AC_MSG_RESULT(no)])
+
 AC_DEFINE([LIBCRUN_PUBLIC], [__attribute__((visibility("default"))) extern], [LIBCRUN_PUBLIC])
 AC_SUBST([FOUND_LIBS])
 AC_SUBST([CRUN_LDFLAGS])
@@ -128,6 +138,7 @@ if test -z "$GPERF"; then
        AC_MSG_NOTICE(gperf not found - cannot rebuild signal parser code)
 fi
 
+AC_SEARCH_LIBS([dlopen], [dl], [AC_DEFINE([HAVE_DLOPEN], 1, [Define if DLOPEN is available])]], [])
 
 AC_SEARCH_LIBS([argp_parse], [argp], [], [AC_MSG_ERROR([*** argp functions not found - install libargp or argp_standalone])])
 
diff -pruN 0.14.1+dfsg-1/crun.1 0.15+dfsg-1/crun.1
--- 0.14.1+dfsg-1/crun.1	1970-01-01 00:00:00.000000000 +0000
+++ 0.15+dfsg-1/crun.1	2020-09-22 18:31:13.000000000 +0000
@@ -0,0 +1,558 @@
+.nh
+.TH crun 1 "User Commands"
+
+.SH NAME
+.PP
+crun \- a fast and lightweight OCI runtime
+
+
+.SH SYNOPSIS
+.PP
+crun [global options] command [command options] [arguments...]
+
+
+.SH DESCRIPTION
+.PP
+crun is a command line program for running Linux containers that
+follow the Open Container Initiative (OCI) format.
+
+
+.SH COMMANDS
+.PP
+\fBcreate\fP
+Create a container.  The runtime detaches from the container process
+once the container environment is created.  It is necessary to
+successively use \fB\fCstart\fR for starting the container.
+
+.PP
+\fBdelete\fP
+Remove definition for a container.
+
+.PP
+\fBexec\fP
+Exec a command in a running container.
+
+.PP
+\fBlist\fP
+List known containers.
+
+.PP
+\fBkill\fP
+Send the specified signal to the container init process.  If no signal
+is specified, SIGTERM is used.
+
+.PP
+\fBps\fP
+Show the processes running in a container.
+
+.PP
+\fBrun\fP
+Create and immediately start a container.
+
+.PP
+\fBspec\fP
+Generate a configuration file.
+
+.PP
+\fBstart\fP
+Start a container that was previously created.  A container cannot be
+started multiple times.
+
+.PP
+\fBstate\fP
+Output the state of a container.
+
+.PP
+\fBpause\fP
+Pause all the processes in the container.
+
+.PP
+\fBresume\fP
+Resume the processes in the container.
+
+.PP
+\fBupdate\fP
+Update container resource constraints.
+
+
+.SH STATE
+.PP
+By default, when running as root user, crun saves its state under the
+\fB/run/crun\fP directory.  As unprivileged user, instead the
+\fIXDG\_RUNTIME\_DIR\fP environment variable is honored, and the directory
+\fB$XDG\_RUNTIME\_DIR/crun\fP is used.  The global option \fB\-\-root\fP
+overrides this setting.
+
+
+.SH GLOBAL OPTIONS
+.PP
+\fB\-\-debug\fP
+Produce verbose output.
+
+.PP
+\fB\-\-log\fP=\fBLOG\-DESTINATION\fP
+Define the destination for the error and warning messages generated by
+crun.
+If the error happens late in the container init process, when crun
+already stopped watching it, then it will be printed to the container
+stderr.
+
+.PP
+It is specified in the form \fIBACKEND:SPECIFIER\fP\&.
+
+.PP
+These following backends are supported:
+
+.RS
+.IP \(bu 2
+file:PATH
+.IP \(bu 2
+journald:IDENTIFIER
+.IP \(bu 2
+syslog:IDENTIFIER
+
+.RE
+
+.PP
+If no backend is specified, then \fIfile:\fP is used by default.
+
+.PP
+\fB\-\-log\-format\fP=\fBFORMAT\fP
+Define the format of the log messages.  It can either be \fBtext\fP, or
+\fBjson\fP\&.  The default is \fBtext\fP\&.
+
+.PP
+\fB\-\-no\-pivot\fP
+Use \fB\fCchroot(2)\fR instead of \fB\fCpivot\_root(2)\fR when creating the container.
+This option is not safe, and should be avoided.
+
+.PP
+\fB\-\-root\fP=\fBDIR\fP
+Defines where to store the state for crun containers.
+
+.PP
+\fB\-\-systemd\-cgroup\fP
+Use systemd for configuring cgroups.  If not specified, the cgroup is
+created directly using the cgroupfs backend.
+
+.PP
+\fB\-\-cgroup\-manager=MANAGER\fP
+Specify what cgroup manager must be used.  Permitted values are \fBcgroupfs\fP,
+\fBsystemd\fP and \fBdisabled\fP\&.
+
+.PP
+\fB\-?\fP, \fB\-\-help\fP
+Print a help list.
+
+.PP
+\fB\-\-usage\fP
+Print a short usage message.
+
+.PP
+\fB\-V\fP, \fB\-\-version\fP
+Print program version
+
+.SH CREATE OPTIONS
+.PP
+crun [global options] create [options] CONTAINER
+
+.PP
+\fB\-\-bundle\fP=\fBBUNDLE\fP
+Path to the OCI bundle, by default it is the current directory.
+
+.PP
+\fB\-\-config\fP=\fBFILE\fP
+Override the configuration file to use.  The default value is \fBconfig.json\fP\&.
+
+.PP
+\fB\-\-console\-socket\fP=\fBSOCKET\fP
+Path to a UNIX socket that will receive the ptmx end of the tty for
+the container.
+
+.PP
+\fB\-\-no\-new\-keyring\fP
+Keep the same session key
+
+.PP
+\fB\-\-preserve\-fds\fP=\fBN\fP
+Additional number of FDs to pass into the container.
+
+.PP
+\fB\-\-pid\-file\fP=\fBPATH\fP
+Path to the file that will contain the container process PID.
+
+.SH RUN OPTIONS
+.PP
+crun [global options] run [options] CONTAINER
+
+.PP
+\fB\-\-bundle\fP=\fBBUNDLE\fP
+Path to the OCI bundle, by default it is the current directory.
+
+.PP
+\fB\-\-config\fP=\fBFILE\fP
+Override the configuration file to use.  The default value is \fBconfig.json\fP\&.
+
+.PP
+\fB\-\-console\-socket\fP=\fBSOCKET\fP
+Path to a UNIX socket that will receive the ptmx end of the tty for
+the container.
+
+.PP
+\fB\-\-no\-new\-keyring\fP
+Keep the same session key.
+
+.PP
+\fB\-\-preserve\-fds\fP=\fBN\fP
+Additional number of FDs to pass into the container.
+
+.PP
+\fB\-\-pid\-file\fP=\fBPATH\fP
+Path to the file that will contain the container process PID.
+
+.PP
+\fB\-\-detach\fP
+Detach the container process from the current session.
+
+.SH DELETE OPTIONS
+.PP
+crun [global options] delete [options] CONTAINER
+
+.PP
+\fB\-\-force\fP
+Delete the container even if it is still running.
+
+.PP
+\fB\-\-regex\fP=\fBREGEX\fP
+Delete all the containers that satisfy the specified regex.
+
+.SH EXEC OPTIONS
+.PP
+crun [global options] exec [options] CONTAINER CMD
+
+.PP
+\fB\-\-console\-socket\fP=\fBSOCKET\fP
+Path to a UNIX socket that will receive the ptmx end of the tty for
+the container.
+
+.PP
+\fB\-\-cwd\fP=\fBPATH\fP
+Set the working directory for the process to PATH.
+
+.PP
+\fB\-\-cap\fP=\fBCAP\fP
+Specify an additional capability to add to the process.
+
+.PP
+\fB\-\-detach\fP
+Detach the container process from the current session.
+
+.PP
+\fB\-\-env\fP=\fBENV\fP
+Specify an environment variable.
+
+.PP
+\fB\-\-preserve\-fds\fP=\fBN\fP
+Additional number of FDs to pass into the container.
+
+.PP
+\fB\-\-process\fP=\fBFILE\fP
+Path to a file containing the process JSON configuration.
+
+.PP
+\fB\-\-pid\-file\fP=\fBPATH\fP
+Path to the file that will contain the new process PID.
+
+.PP
+\fB\-t\fP \fB\-\-tty\fP
+Allocate a pseudo TTY.
+
+.PP
+\fB\-u USERSPEC\fP \fB\-\-user\fP=\fBUSERSPEC\fP
+Specify the user in the form UID[:GID].
+
+.SH LIST OPTIONS
+.PP
+crun [global options] list [options]
+
+.PP
+\fB\-q\fP \fB\-\-quiet\fP
+Show only the container ID.
+
+.SH KILL OPTIONS
+.PP
+crun [global options] kill [options] CONTAINER SIGNAL
+
+.PP
+\fB\-\-all\fP
+Kill all the processes in the container.
+
+.PP
+\fB\-\-regex\fP=\fBREGEX\fP
+Kill all the containers that satisfy the specified regex.
+
+.SH PS OPTIONS
+.PP
+crun [global options] ps [options]
+
+.PP
+\fB\-\-format=FORMAT\fP
+Specify the output format.  It must be either \fB\fCtable\fR or \fB\fCjson\fR\&.
+By default \fB\fCtable\fR is used.
+
+.SH SPEC OPTIONS
+.PP
+crun [global options] spec [options]
+
+.PP
+\fB\-\-rootless\fP
+Generate a config.json file that is usable by an unprivileged user.
+
+.SH UPDATE OPTIONS
+.PP
+crun [global options] update [options] CONTAINER
+
+.PP
+\fB\-\-blkio\-weight\fP=\fBVALUE\fP
+Specifies per cgroup weight.
+
+.PP
+\fB\-\-cpu\-period\fP=\fBVALUE\fP
+CPU CFS period to be used for hardcapping.
+
+.PP
+\-\-cpu\-quota\fB=\fPVALUE**
+CPU CFS hardcap limit.
+
+.PP
+\fB\-\-cpu\-rt\-period\fP=\fBVALUE\fP
+CPU realtime period to be used for hardcapping.
+
+.PP
+\fB\-\-cpu\-rt\-runtime\fP=\fBVALUE\fP
+CPU realtime hardcap limit.
+
+.PP
+\fB\-\-cpu\-share\fP=\fBVALUE\fP
+CPU shares.
+
+.PP
+\fB\-\-cpuset\-cpus\fP=\fBVALUE\fP
+CPU(s) to use.
+
+.PP
+\fB\-\-cpuset\-mems\fP=\fBVALUE\fP
+Memory node(s) to use.
+
+.PP
+\fB\-\-kernel\-memory\fP=\fBVALUE\fP
+Kernel memory limit.
+
+.PP
+\fB\-\-kernel\-memory\-tcp\fP=\fBVALUE\fP
+Kernel memory limit for TCP buffer.
+
+.PP
+\fB\-\-memory\fP=\fBVALUE\fP
+Memory limit.
+
+.PP
+\fB\-\-memory\-reservation\fP=\fBVALUE\fP
+Memory reservation or soft\_limit.
+
+.PP
+\fB\-\-memory\-swap\fP=\fBVALUE\fP
+Total memory usage.
+
+.PP
+\fB\-\-pids\-limit\fP=\fBVALUE\fP
+Maximum number of pids allowed in the container.
+
+.PP
+\fB\-r\fP, \fB\-\-resources\fP=\fBFILE\fP
+Path to the file containing the resources to update.
+
+
+.SH Extensions to OCI
+.SH \fB\fCrun.oci.seccomp.receiver=PATH\fR
+.PP
+If the annotation \fB\fCrun.oci.seccomp.receiver=PATH\fR is specified, the
+seccomp listener is sent to the UNIX socket listening on the specified
+path.  It can also set with the \fB\fCRUN\_OCI\_SECCOMP\_RECEIVER\fR environment variable.
+It is an experimental feature, and the annotation will be removed once
+it is supported in the OCI runtime specs.  It must be an absolute path.
+
+.SH \fB\fCrun.oci.seccomp.plugins=PATH\fR
+.PP
+If the annotation \fB\fCrun.oci.seccomp.plugins=PLUGIN1[:PLUGIN2]...\fR is specified, the
+seccomp listener fd is handled through the specified plugins.  The
+plugin must either be an absolute path or a filename.
+
+.SH \fB\fCrun.oci.seccomp\_fail\_unknown\_syscall=1\fR
+.PP
+If the annotation \fB\fCrun.oci.seccomp\_fail\_unknown\_syscall\fR is present, then crun
+will fail when an unknown syscall is encountered in the seccomp configuration.
+
+.SH \fB\fCrun.oci.keep\_original\_groups=1\fR
+.PP
+If the annotation \fB\fCrun.oci.keep\_original\_groups\fR is present, then crun
+will skip the \fB\fCsetgroups\fR syscall that is used to either set the
+additional groups specified in the OCI configuration, or to reset the
+list of additional groups if none is specified.
+
+.SH \fB\fCrun.oci.systemd.force\_cgroup\_v1=/PATH\fR
+.PP
+If the annotation \fB\fCrun.oci.systemd.force\_cgroup\_v1=/PATH\fR is present, then crun
+will override the specified mount point \fB\fC/PATH\fR with a cgroup v1 mount
+made of a single hierarchy \fB\fCnone,name=systemd\fR\&.
+It is useful to run on a cgroup v2 system containers using older
+versions of systemd that lack support for cgroup v2.
+
+.SH \fB\fCrun.oci.timens\_offset=ID SEC NSEC\fR
+.PP
+Specify the offset to be written to /proc/self/timens\_offsets when creating
+a time namespace.
+
+.SH \fB\fCrun.oci.systemd.subgroup=SUBGROUP\fR
+.PP
+Override the name for the systemd sub cgroup created under the systemd
+scope, so the final cgroup will be like:
+
+.PP
+.RS
+
+.nf
+/sys/fs/cgroup/$PATH/$SUBGROUP
+
+.fi
+.RE
+
+.PP
+When it is set to the empty string, a sub cgroup is not created.
+
+.PP
+If not specified, it defaults to \fB\fCcontainer\fR on cgroup v2, and to \fB\fC""\fR
+on cgroup v1.
+
+.PP
+e.g.
+
+.PP
+.RS
+
+.nf
+/sys/fs/cgroup//system.slice/foo\-352700.scope/container
+
+.fi
+.RE
+
+.SH \fB\fCrun.oci.hooks.stdout=FILE\fR
+.PP
+If the annotation \fB\fCrun.oci.hooks.stdout\fR is present, then crun
+will open the specified file and use it as the stdout for the hook
+processes.  The file is opened in append mode and it is created if it
+doesn't already exist.
+
+.SH \fB\fCrun.oci.hooks.stderr=FILE\fR
+.PP
+If the annotation \fB\fCrun.oci.hooks.stderr\fR is present, then crun
+will open the specified file and use it as the stderr for the hook
+processes.  The file is opened in append mode and it is created if it
+doesn't already exist.
+
+.SH tmpcopyup mount options
+.PP
+If the \fB\fCtmpcopyup\fR option is specified for a tmpfs, then the path that
+is shadowed by the tmpfs mount is recursively copied up to the tmpfs
+itself.
+
+.SH Automatically create user namespace
+.PP
+When running as user different than root, an user namespace is
+automatically created even if it is not specified in the config file.
+The current user is mapped to the ID 0 in the container, and any
+additional id specified in the files \fB\fC/etc/subuid\fR and \fB\fC/etc/subgid\fR
+is automatically added starting with ID 1.
+
+
+.SH CGROUP v2
+.PP
+crun has some basic support for cgroup v2.  Since the OCI spec is
+designed for cgroup v1, in some cases there is need to convert from
+the cgroup v1 configuration to cgroup v2.
+
+.PP
+These are the OCI resources currently supported with cgroup v2 and how
+they are converted when needed from the cgroup v1 configuration.
+
+.SH Memory controller
+.TS
+allbox;
+l l l l 
+l l l l .
+\fB\fCOCI (x)\fR	\fB\fCcgroup 2 value (y)\fR	\fB\fCconversion\fR	\fB\fCcomment\fR
+limit	memory.max	y = x	swap	memory.swap\_max	y = x	reservation	memory.low	y = x	.TE
+
+.SH PIDs controller
+.TS
+allbox;
+l l l l 
+l l l l .
+\fB\fCOCI (x)\fR	\fB\fCcgroup 2 value (y)\fR	\fB\fCconversion\fR	\fB\fCcomment\fR
+limit	pids.max	y = x	.TE
+
+.SH CPU controller
+.TS
+allbox;
+l l l l 
+l l l l .
+\fB\fCOCI (x)\fR	\fB\fCcgroup 2 value (y)\fR	\fB\fCconversion\fR	\fB\fCcomment\fR
+shares	cpu.weight	T{
+y = (1 + ((x \- 2) * 9999) / 262142)
+T}
+	T{
+convert from [2\-262144] to [1\-10000]
+T}
+period	cpu.max	y = x	T{
+period and quota are written together
+T}
+quota	cpu.max	y = x	T{
+period and quota are written together
+T}
+.TE
+
+.SH blkio controller
+.TS
+allbox;
+l l l l 
+l l l l .
+\fB\fCOCI (x)\fR	\fB\fCcgroup 2 value (y)\fR	\fB\fCconversion\fR	\fB\fCcomment\fR
+weight	io.bfq.weight	T{
+y = (1 + (x \- 10) * 9999 / 990)
+T}
+	T{
+convert linearly from [10\-1000] to [1\-10000]
+T}
+weight\_device	io.bfq.weight	T{
+y = (1 + (x \- 10) * 9999 / 990)
+T}
+	T{
+convert linearly from [10\-1000] to [1\-10000]
+T}
+rbps	io.max	y=x	wbps	io.max	y=x	riops	io.max	y=x	wiops	io.max	y=x	.TE
+
+.SH cpuset controller
+.TS
+allbox;
+l l l l 
+l l l l .
+\fB\fCOCI (x)\fR	\fB\fCcgroup 2 value (y)\fR	\fB\fCconversion\fR	\fB\fCcomment\fR
+cpus	cpuset.cpus	y = x	mems	cpuset.mems	y = x	.TE
+
+.SH hugetlb controller
+.TS
+allbox;
+l l l l 
+l l l l .
+\fB\fCOCI (x)\fR	\fB\fCcgroup 2 value (y)\fR	\fB\fCconversion\fR	\fB\fCcomment\fR
+\&.limit\_\&in\_\&bytes	hugetlb.\&.max	y = x	.TE
diff -pruN 0.14.1+dfsg-1/crun.1.md 0.15+dfsg-1/crun.1.md
--- 0.14.1+dfsg-1/crun.1.md	2020-07-03 20:17:07.000000000 +0000
+++ 0.15+dfsg-1/crun.1.md	2020-09-03 11:43:25.000000000 +0000
@@ -128,7 +128,7 @@ Path to the OCI bundle, by default it is
 Override the configuration file to use.  The default value is **config.json**.
 
 **--console-socket**=**SOCKET**
-Path to a UNIX socket that will receive the master end of the tty for
+Path to a UNIX socket that will receive the ptmx end of the tty for
 the container.
 
 **--no-new-keyring**
@@ -151,7 +151,7 @@ Path to the OCI bundle, by default it is
 Override the configuration file to use.  The default value is **config.json**.
 
 **--console-socket**=**SOCKET**
-Path to a UNIX socket that will receive the master end of the tty for
+Path to a UNIX socket that will receive the ptmx end of the tty for
 the container.
 
 **--no-new-keyring**
@@ -181,7 +181,7 @@ Delete all the containers that satisfy t
 crun [global options] exec [options] CONTAINER CMD
 
 **--console-socket**=**SOCKET**
-Path to a UNIX socket that will receive the master end of the tty for
+Path to a UNIX socket that will receive the ptmx end of the tty for
 the container.
 
 **--cwd**=**PATH**
@@ -294,6 +294,22 @@ Path to the file containing the resource
 
 # Extensions to OCI
 
+## `run.oci.seccomp.receiver=PATH`
+
+If the annotation `run.oci.seccomp.receiver=PATH` is specified, the
+seccomp listener is sent to the UNIX socket listening on the specified
+path.  It can also set with the `RUN_OCI_SECCOMP_RECEIVER` environment variable.
+It is an experimental feature, and the annotation will be removed once
+it is supported in the OCI runtime specs.  It must be an absolute path.
+
+## `run.oci.seccomp.plugins=PATH`
+
+If the annotation `run.oci.seccomp.plugins=PLUGIN1[:PLUGIN2]...` is specified, the
+seccomp listener fd is handled through the specified plugins.  The
+plugin must either be an absolute path or a file name that is looked
+up by `ldopen(3)`.  More information on how the lookup is performed
+are available on the `ld.so(8)` man page.
+
 ## `run.oci.seccomp_fail_unknown_syscall=1`
 
 If the annotation `run.oci.seccomp_fail_unknown_syscall` is present, then crun
diff -pruN 0.14.1+dfsg-1/debian/changelog 0.15+dfsg-1/debian/changelog
--- 0.14.1+dfsg-1/debian/changelog	2020-07-17 13:14:03.000000000 +0000
+++ 0.15+dfsg-1/debian/changelog	2020-09-23 20:44:34.000000000 +0000
@@ -1,3 +1,10 @@
+crun (0.15+dfsg-1) unstable; urgency=medium
+
+  * New upstream release.
+  * rules: don't install .la file.
+
+ -- Dmitry Smirnov <onlyjob@debian.org>  Thu, 24 Sep 2020 06:44:34 +1000
+
 crun (0.14.1+dfsg-1) unstable; urgency=medium
 
   * New upstream release.
diff -pruN 0.14.1+dfsg-1/debian/copyright 0.15+dfsg-1/debian/copyright
--- 0.14.1+dfsg-1/debian/copyright	2020-04-05 23:55:05.000000000 +0000
+++ 0.15+dfsg-1/debian/copyright	2020-09-23 20:44:34.000000000 +0000
@@ -101,7 +101,7 @@ License: MIT-X11
 
 Files: debian/*
 Copyright:
-    2019 Dmitry Smirnov <onlyjob@debian.org>
+    2019-2020 Dmitry Smirnov <onlyjob@debian.org>
 License: Expat or GPL-3+
 
 License: Expat
diff -pruN 0.14.1+dfsg-1/debian/rules 0.15+dfsg-1/debian/rules
--- 0.14.1+dfsg-1/debian/rules	2020-02-04 02:08:39.000000000 +0000
+++ 0.15+dfsg-1/debian/rules	2020-09-23 20:44:34.000000000 +0000
@@ -31,6 +31,7 @@ override_dh_auto_test:
 
 override_dh_auto_install:
 	dh_auto_install --destdir=debian/tmp
+	-$(RM) debian/tmp/usr/lib/*/*.la
 
 override_dh_gencontrol:
 	dh_gencontrol -- -Vmy:Built-Using="$(shell dpkg-query --show -f '$${source:Package} (=$${source:Version}),' golang-github-opencontainers-image-spec-dev golang-github-opencontainers-specs-dev)"
diff -pruN 0.14.1+dfsg-1/git-version.h 0.15+dfsg-1/git-version.h
--- 0.14.1+dfsg-1/git-version.h	2020-07-08 06:50:16.000000000 +0000
+++ 0.15+dfsg-1/git-version.h	2020-09-23 14:49:11.000000000 +0000
@@ -1,4 +1,4 @@
 /* autogenerated.  */
 #ifndef GIT_VERSION
-# define GIT_VERSION "598ea5e192ca12d4f6378217d3ab1415efeddefa"
+# define GIT_VERSION "56ca95e61639510c7dbd39ff512f80f626404969"
 #endif
diff -pruN 0.14.1+dfsg-1/libcrun.lds 0.15+dfsg-1/libcrun.lds
--- 0.14.1+dfsg-1/libcrun.lds	1970-01-01 00:00:00.000000000 +0000
+++ 0.15+dfsg-1/libcrun.lds	2020-07-01 13:02:51.000000000 +0000
@@ -0,0 +1,10 @@
+{
+  global:
+        /* Not all the libcrun_ functions are exported, only those marked LIBCRUN_PUBLIC.  */
+        libcrun_*;
+        /* libocispec functions */
+        runtime_spec_*;
+        free_runtime_spec_*;
+        make_runtime_spec_*;
+  local: *;
+};
diff -pruN 0.14.1+dfsg-1/libocispec/build-aux/config.guess 0.15+dfsg-1/libocispec/build-aux/config.guess
--- 0.14.1+dfsg-1/libocispec/build-aux/config.guess	2020-07-08 06:50:01.000000000 +0000
+++ 0.15+dfsg-1/libocispec/build-aux/config.guess	2020-09-23 14:48:53.000000000 +0000
@@ -2,7 +2,7 @@
 # Attempt to guess a canonical system name.
 #   Copyright 1992-2018 Free Software Foundation, Inc.
 
-timestamp='2018-08-29'
+timestamp='2018-03-08'
 
 # This file is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License as published by
@@ -84,6 +84,8 @@ if test $# != 0; then
   exit 1
 fi
 
+trap 'exit 1' 1 2 15
+
 # CC_FOR_BUILD -- compiler used by this script. Note that the use of a
 # compiler to aid in system detection is discouraged as it requires
 # temporary files to be created and, as you can see below, it is a
@@ -94,39 +96,34 @@ fi
 
 # Portable tmp directory creation inspired by the Autoconf team.
 
-tmp=
-# shellcheck disable=SC2172
-trap 'test -z "$tmp" || rm -fr "$tmp"' 1 2 13 15
-trap 'exitcode=$?; test -z "$tmp" || rm -fr "$tmp"; exit $exitcode' 0
-
-set_cc_for_build() {
-    : "${TMPDIR=/tmp}"
-    # shellcheck disable=SC2039
-    { tmp=`(umask 077 && mktemp -d "$TMPDIR/cgXXXXXX") 2>/dev/null` && test -n "$tmp" && test -d "$tmp" ; } ||
-	{ test -n "$RANDOM" && tmp=$TMPDIR/cg$$-$RANDOM && (umask 077 && mkdir "$tmp" 2>/dev/null) ; } ||
-	{ tmp=$TMPDIR/cg-$$ && (umask 077 && mkdir "$tmp" 2>/dev/null) && echo "Warning: creating insecure temp directory" >&2 ; } ||
-	{ echo "$me: cannot create a temporary directory in $TMPDIR" >&2 ; exit 1 ; }
-    dummy=$tmp/dummy
-    case ${CC_FOR_BUILD-},${HOST_CC-},${CC-} in
-	,,)    echo "int x;" > "$dummy.c"
-	       for driver in cc gcc c89 c99 ; do
-		   if ($driver -c -o "$dummy.o" "$dummy.c") >/dev/null 2>&1 ; then
-		       CC_FOR_BUILD="$driver"
-		       break
-		   fi
-	       done
-	       if test x"$CC_FOR_BUILD" = x ; then
-		   CC_FOR_BUILD=no_compiler_found
-	       fi
-	       ;;
-	,,*)   CC_FOR_BUILD=$CC ;;
-	,*,*)  CC_FOR_BUILD=$HOST_CC ;;
-    esac
-}
+set_cc_for_build='
+trap "exitcode=\$?; (rm -f \$tmpfiles 2>/dev/null; rmdir \$tmp 2>/dev/null) && exit \$exitcode" 0 ;
+trap "rm -f \$tmpfiles 2>/dev/null; rmdir \$tmp 2>/dev/null; exit 1" 1 2 13 15 ;
+: ${TMPDIR=/tmp} ;
+ { tmp=`(umask 077 && mktemp -d "$TMPDIR/cgXXXXXX") 2>/dev/null` && test -n "$tmp" && test -d "$tmp" ; } ||
+ { test -n "$RANDOM" && tmp=$TMPDIR/cg$$-$RANDOM && (umask 077 && mkdir $tmp) ; } ||
+ { tmp=$TMPDIR/cg-$$ && (umask 077 && mkdir $tmp) && echo "Warning: creating insecure temp directory" >&2 ; } ||
+ { echo "$me: cannot create a temporary directory in $TMPDIR" >&2 ; exit 1 ; } ;
+dummy=$tmp/dummy ;
+tmpfiles="$dummy.c $dummy.o $dummy.rel $dummy" ;
+case $CC_FOR_BUILD,$HOST_CC,$CC in
+ ,,)    echo "int x;" > "$dummy.c" ;
+	for c in cc gcc c89 c99 ; do
+	  if ($c -c -o "$dummy.o" "$dummy.c") >/dev/null 2>&1 ; then
+	     CC_FOR_BUILD="$c"; break ;
+	  fi ;
+	done ;
+	if test x"$CC_FOR_BUILD" = x ; then
+	  CC_FOR_BUILD=no_compiler_found ;
+	fi
+	;;
+ ,,*)   CC_FOR_BUILD=$CC ;;
+ ,*,*)  CC_FOR_BUILD=$HOST_CC ;;
+esac ; set_cc_for_build= ;'
 
 # This is needed to find uname on a Pyramid OSx when run in the BSD universe.
 # (ghazi@noc.rutgers.edu 1994-08-24)
-if test -f /.attbin/uname ; then
+if (test -f /.attbin/uname) >/dev/null 2>&1 ; then
 	PATH=$PATH:/.attbin ; export PATH
 fi
 
@@ -141,7 +138,7 @@ Linux|GNU|GNU/*)
 	# We could probably try harder.
 	LIBC=gnu
 
-	set_cc_for_build
+	eval "$set_cc_for_build"
 	cat <<-EOF > "$dummy.c"
 	#include <features.h>
 	#if defined(__UCLIBC__)
@@ -202,7 +199,7 @@ case "$UNAME_MACHINE:$UNAME_SYSTEM:$UNAM
 		os=netbsdelf
 		;;
 	    arm*|i386|m68k|ns32k|sh3*|sparc|vax)
-		set_cc_for_build
+		eval "$set_cc_for_build"
 		if echo __ELF__ | $CC_FOR_BUILD -E - 2>/dev/null \
 			| grep -q __ELF__
 		then
@@ -240,7 +237,7 @@ case "$UNAME_MACHINE:$UNAME_SYSTEM:$UNAM
 	# Since CPU_TYPE-MANUFACTURER-KERNEL-OPERATING_SYSTEM:
 	# contains redundant information, the shorter form:
 	# CPU_TYPE-MANUFACTURER-OPERATING_SYSTEM is used.
-	echo "$machine-${os}${release}${abi-}"
+	echo "$machine-${os}${release}${abi}"
 	exit ;;
     *:Bitrig:*:*)
 	UNAME_MACHINE_ARCH=`arch | sed 's/Bitrig.//'`
@@ -392,15 +389,20 @@ case "$UNAME_MACHINE:$UNAME_SYSTEM:$UNAM
 	echo i386-pc-auroraux"$UNAME_RELEASE"
 	exit ;;
     i86pc:SunOS:5.*:* | i86xen:SunOS:5.*:*)
-	UNAME_REL="`echo "$UNAME_RELEASE" | sed -e 's/[^.]*//'`"
-	case `isainfo -b` in
-	    32)
-		echo i386-pc-solaris2"$UNAME_REL"
-		;;
-	    64)
-		echo x86_64-pc-solaris2"$UNAME_REL"
-		;;
-	esac
+	eval "$set_cc_for_build"
+	SUN_ARCH=i386
+	# If there is a compiler, see if it is configured for 64-bit objects.
+	# Note that the Sun cc does not turn __LP64__ into 1 like gcc does.
+	# This test works for both compilers.
+	if [ "$CC_FOR_BUILD" != no_compiler_found ]; then
+	    if (echo '#ifdef __amd64'; echo IS_64BIT_ARCH; echo '#endif') | \
+		(CCOPTS="" $CC_FOR_BUILD -E - 2>/dev/null) | \
+		grep IS_64BIT_ARCH >/dev/null
+	    then
+		SUN_ARCH=x86_64
+	    fi
+	fi
+	echo "$SUN_ARCH"-pc-solaris2"`echo "$UNAME_RELEASE"|sed -e 's/[^.]*//'`"
 	exit ;;
     sun4*:SunOS:6*:*)
 	# According to config.sub, this is the proper way to canonicalize
@@ -480,7 +482,7 @@ case "$UNAME_MACHINE:$UNAME_SYSTEM:$UNAM
 	echo clipper-intergraph-clix"$UNAME_RELEASE"
 	exit ;;
     mips:*:*:UMIPS | mips:*:*:RISCos)
-	set_cc_for_build
+	eval "$set_cc_for_build"
 	sed 's/^	//' << EOF > "$dummy.c"
 #ifdef __cplusplus
 #include <stdio.h>  /* for printf() prototype */
@@ -577,7 +579,7 @@ EOF
 	exit ;;
     *:AIX:2:3)
 	if grep bos325 /usr/include/stdio.h >/dev/null 2>&1; then
-		set_cc_for_build
+		eval "$set_cc_for_build"
 		sed 's/^		//' << EOF > "$dummy.c"
 		#include <sys/systemcfg.h>
 
@@ -658,7 +660,7 @@ EOF
 		    esac
 		fi
 		if [ "$HP_ARCH" = "" ]; then
-		    set_cc_for_build
+		    eval "$set_cc_for_build"
 		    sed 's/^		//' << EOF > "$dummy.c"
 
 		#define _HPUX_SOURCE
@@ -698,7 +700,7 @@ EOF
 	esac
 	if [ "$HP_ARCH" = hppa2.0w ]
 	then
-	    set_cc_for_build
+	    eval "$set_cc_for_build"
 
 	    # hppa2.0w-hp-hpux* has a 64-bit kernel and a compiler generating
 	    # 32-bit code.  hppa64-hp-hpux* has the same kernel and a compiler
@@ -724,7 +726,7 @@ EOF
 	echo ia64-hp-hpux"$HPUX_REV"
 	exit ;;
     3050*:HI-UX:*:*)
-	set_cc_for_build
+	eval "$set_cc_for_build"
 	sed 's/^	//' << EOF > "$dummy.c"
 	#include <unistd.h>
 	int
@@ -838,17 +840,6 @@ EOF
     *:BSD/OS:*:*)
 	echo "$UNAME_MACHINE"-unknown-bsdi"$UNAME_RELEASE"
 	exit ;;
-    arm:FreeBSD:*:*)
-	UNAME_PROCESSOR=`uname -p`
-	set_cc_for_build
-	if echo __ARM_PCS_VFP | $CC_FOR_BUILD -E - 2>/dev/null \
-	    | grep -q __ARM_PCS_VFP
-	then
-	    echo "${UNAME_PROCESSOR}"-unknown-freebsd"`echo ${UNAME_RELEASE}|sed -e 's/[-(].*//'`"-gnueabi
-	else
-	    echo "${UNAME_PROCESSOR}"-unknown-freebsd"`echo ${UNAME_RELEASE}|sed -e 's/[-(].*//'`"-gnueabihf
-	fi
-	exit ;;
     *:FreeBSD:*:*)
 	UNAME_PROCESSOR=`/usr/bin/uname -p`
 	case "$UNAME_PROCESSOR" in
@@ -903,8 +894,8 @@ EOF
 	# other systems with GNU libc and userland
 	echo "$UNAME_MACHINE-unknown-`echo "$UNAME_SYSTEM" | sed 's,^[^/]*/,,' | tr "[:upper:]" "[:lower:]"``echo "$UNAME_RELEASE"|sed -e 's/[-(].*//'`-$LIBC"
 	exit ;;
-    *:Minix:*:*)
-	echo "$UNAME_MACHINE"-unknown-minix
+    i*86:Minix:*:*)
+	echo "$UNAME_MACHINE"-pc-minix
 	exit ;;
     aarch64:Linux:*:*)
 	echo "$UNAME_MACHINE"-unknown-linux-"$LIBC"
@@ -931,7 +922,7 @@ EOF
 	echo "$UNAME_MACHINE"-unknown-linux-"$LIBC"
 	exit ;;
     arm*:Linux:*:*)
-	set_cc_for_build
+	eval "$set_cc_for_build"
 	if echo __ARM_EABI__ | $CC_FOR_BUILD -E - 2>/dev/null \
 	    | grep -q __ARM_EABI__
 	then
@@ -980,7 +971,7 @@ EOF
 	echo "$UNAME_MACHINE"-unknown-linux-"$LIBC"
 	exit ;;
     mips:Linux:*:* | mips64:Linux:*:*)
-	set_cc_for_build
+	eval "$set_cc_for_build"
 	sed 's/^	//' << EOF > "$dummy.c"
 	#undef CPU
 	#undef ${UNAME_MACHINE}
@@ -1294,7 +1285,7 @@ EOF
 	exit ;;
     *:Darwin:*:*)
 	UNAME_PROCESSOR=`uname -p` || UNAME_PROCESSOR=unknown
-	set_cc_for_build
+	eval "$set_cc_for_build"
 	if test "$UNAME_PROCESSOR" = unknown ; then
 	    UNAME_PROCESSOR=powerpc
 	fi
@@ -1367,7 +1358,6 @@ EOF
 	# "uname -m" is not consistent, so use $cputype instead. 386
 	# is converted to i386 for consistency with other x86
 	# operating systems.
-	# shellcheck disable=SC2154
 	if test "$cputype" = 386; then
 	    UNAME_MACHINE=i386
 	else
diff -pruN 0.14.1+dfsg-1/libocispec/build-aux/config.sub 0.15+dfsg-1/libocispec/build-aux/config.sub
--- 0.14.1+dfsg-1/libocispec/build-aux/config.sub	2020-07-08 06:50:01.000000000 +0000
+++ 0.15+dfsg-1/libocispec/build-aux/config.sub	2020-09-23 14:48:53.000000000 +0000
@@ -2,7 +2,7 @@
 # Configuration validation subroutine script.
 #   Copyright 1992-2018 Free Software Foundation, Inc.
 
-timestamp='2018-08-29'
+timestamp='2018-05-05'
 
 # This file is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License as published by
@@ -110,20 +110,16 @@ case $# in
     exit 1;;
 esac
 
-# Split fields of configuration type
+# Spilt fields of configuration type
 IFS="-" read -r field1 field2 field3 field4 <<EOF
 $1
 EOF
 
 # Separate into logical components for further validation
 case $1 in
-	*-*-*-*-*)
-		echo Invalid configuration \`"$1"\': more than four components >&2
-		exit 1
-		;;
 	*-*-*-*)
 		basic_machine=$field1-$field2
-		os=$field3-$field4
+		os=-$field3-$field4
 		;;
 	*-*-*)
 		# Ambiguous whether COMPANY is present, or skipped and KERNEL-OS is two
@@ -136,1133 +132,1227 @@ case $1 in
 			| netbsd*-eabi* | kopensolaris*-gnu* | cloudabi*-eabi* \
 			| storm-chaos* | os2-emx* | rtmk-nova*)
 				basic_machine=$field1
-				os=$maybe_os
+				os=-$maybe_os
 				;;
 			android-linux)
 				basic_machine=$field1-unknown
-				os=linux-android
+				os=-linux-android
 				;;
 			*)
 				basic_machine=$field1-$field2
-				os=$field3
+				os=-$field3
 				;;
 		esac
 		;;
 	*-*)
-		# A lone config we happen to match not fitting any patern
-		case $field1-$field2 in
-			decstation-3100)
-				basic_machine=mips-dec
-				os=
-				;;
-			*-*)
-				# Second component is usually, but not always the OS
-				case $field2 in
-					# Prevent following clause from handling this valid os
-					sun*os*)
-						basic_machine=$field1
-						os=$field2
-						;;
-					# Manufacturers
-					dec* | mips* | sequent* | encore* | pc533* | sgi* | sony* \
-					| att* | 7300* | 3300* | delta* | motorola* | sun[234]* \
-					| unicom* | ibm* | next | hp | isi* | apollo | altos* \
-					| convergent* | ncr* | news | 32* | 3600* | 3100* \
-					| hitachi* | c[123]* | convex* | sun | crds | omron* | dg \
-					| ultra | tti* | harris | dolphin | highlevel | gould \
-					| cbm | ns | masscomp | apple | axis | knuth | cray \
-					| microblaze* | sim | cisco \
-					| oki | wec | wrs | winbond)
-						basic_machine=$field1-$field2
-						os=
-						;;
-					*)
-						basic_machine=$field1
-						os=$field2
-						;;
-				esac
-			;;
-		esac
+		basic_machine=$field1
+		os=-$field2
 		;;
 	*)
-		# Convert single-component short-hands not valid as part of
-		# multi-component configurations.
-		case $field1 in
-			386bsd)
-				basic_machine=i386-pc
-				os=bsd
-				;;
-			a29khif)
-				basic_machine=a29k-amd
-				os=udi
-				;;
-			adobe68k)
-				basic_machine=m68010-adobe
-				os=scout
-				;;
-			alliant)
-				basic_machine=fx80-alliant
-				os=
-				;;
-			altos | altos3068)
-				basic_machine=m68k-altos
-				os=
-				;;
-			am29k)
-				basic_machine=a29k-none
-				os=bsd
-				;;
-			amdahl)
-				basic_machine=580-amdahl
-				os=sysv
-				;;
-			amiga)
-				basic_machine=m68k-unknown
-				os=
-				;;
-			amigaos | amigados)
-				basic_machine=m68k-unknown
-				os=amigaos
-				;;
-			amigaunix | amix)
-				basic_machine=m68k-unknown
-				os=sysv4
-				;;
-			apollo68)
-				basic_machine=m68k-apollo
-				os=sysv
-				;;
-			apollo68bsd)
-				basic_machine=m68k-apollo
-				os=bsd
-				;;
-			aros)
-				basic_machine=i386-pc
-				os=aros
-				;;
-			aux)
-				basic_machine=m68k-apple
-				os=aux
-				;;
-			balance)
-				basic_machine=ns32k-sequent
-				os=dynix
-				;;
-			blackfin)
-				basic_machine=bfin-unknown
-				os=linux
-				;;
-			cegcc)
-				basic_machine=arm-unknown
-				os=cegcc
-				;;
-			convex-c1)
-				basic_machine=c1-convex
-				os=bsd
-				;;
-			convex-c2)
-				basic_machine=c2-convex
-				os=bsd
-				;;
-			convex-c32)
-				basic_machine=c32-convex
-				os=bsd
-				;;
-			convex-c34)
-				basic_machine=c34-convex
-				os=bsd
-				;;
-			convex-c38)
-				basic_machine=c38-convex
-				os=bsd
-				;;
-			cray)
-				basic_machine=j90-cray
-				os=unicos
-				;;
-			crds | unos)
-				basic_machine=m68k-crds
-				os=
-				;;
-			da30)
-				basic_machine=m68k-da30
-				os=
-				;;
-			decstation | pmax | pmin | dec3100 | decstatn)
-				basic_machine=mips-dec
-				os=
-				;;
-			delta88)
-				basic_machine=m88k-motorola
-				os=sysv3
-				;;
-			dicos)
-				basic_machine=i686-pc
-				os=dicos
-				;;
-			djgpp)
-				basic_machine=i586-pc
-				os=msdosdjgpp
-				;;
-			ebmon29k)
-				basic_machine=a29k-amd
-				os=ebmon
-				;;
-			es1800 | OSE68k | ose68k | ose | OSE)
-				basic_machine=m68k-ericsson
-				os=ose
-				;;
-			gmicro)
-				basic_machine=tron-gmicro
-				os=sysv
-				;;
-			go32)
-				basic_machine=i386-pc
-				os=go32
-				;;
-			h8300hms)
-				basic_machine=h8300-hitachi
-				os=hms
-				;;
-			h8300xray)
-				basic_machine=h8300-hitachi
-				os=xray
-				;;
-			h8500hms)
-				basic_machine=h8500-hitachi
-				os=hms
-				;;
-			harris)
-				basic_machine=m88k-harris
-				os=sysv3
-				;;
-			hp300)
-				basic_machine=m68k-hp
-				;;
-			hp300bsd)
-				basic_machine=m68k-hp
-				os=bsd
-				;;
-			hp300hpux)
-				basic_machine=m68k-hp
-				os=hpux
-				;;
-			hppaosf)
-				basic_machine=hppa1.1-hp
-				os=osf
-				;;
-			hppro)
-				basic_machine=hppa1.1-hp
-				os=proelf
-				;;
-			i386mach)
-				basic_machine=i386-mach
-				os=mach
-				;;
-			vsta)
-				basic_machine=i386-pc
-				os=vsta
-				;;
-			isi68 | isi)
-				basic_machine=m68k-isi
-				os=sysv
-				;;
-			m68knommu)
-				basic_machine=m68k-unknown
-				os=linux
-				;;
-			magnum | m3230)
-				basic_machine=mips-mips
-				os=sysv
-				;;
-			merlin)
-				basic_machine=ns32k-utek
-				os=sysv
-				;;
-			mingw64)
-				basic_machine=x86_64-pc
-				os=mingw64
-				;;
-			mingw32)
-				basic_machine=i686-pc
-				os=mingw32
-				;;
-			mingw32ce)
-				basic_machine=arm-unknown
-				os=mingw32ce
-				;;
-			monitor)
-				basic_machine=m68k-rom68k
-				os=coff
-				;;
-			morphos)
-				basic_machine=powerpc-unknown
-				os=morphos
-				;;
-			moxiebox)
-				basic_machine=moxie-unknown
-				os=moxiebox
-				;;
-			msdos)
-				basic_machine=i386-pc
-				os=msdos
-				;;
-			msys)
-				basic_machine=i686-pc
-				os=msys
-				;;
-			mvs)
-				basic_machine=i370-ibm
-				os=mvs
-				;;
-			nacl)
-				basic_machine=le32-unknown
-				os=nacl
-				;;
-			ncr3000)
-				basic_machine=i486-ncr
-				os=sysv4
-				;;
-			netbsd386)
-				basic_machine=i386-pc
-				os=netbsd
-				;;
-			netwinder)
-				basic_machine=armv4l-rebel
-				os=linux
-				;;
-			news | news700 | news800 | news900)
-				basic_machine=m68k-sony
-				os=newsos
-				;;
-			news1000)
-				basic_machine=m68030-sony
-				os=newsos
-				;;
-			necv70)
-				basic_machine=v70-nec
-				os=sysv
-				;;
-			nh3000)
-				basic_machine=m68k-harris
-				os=cxux
-				;;
-			nh[45]000)
-				basic_machine=m88k-harris
-				os=cxux
-				;;
-			nindy960)
-				basic_machine=i960-intel
-				os=nindy
-				;;
-			mon960)
-				basic_machine=i960-intel
-				os=mon960
-				;;
-			nonstopux)
-				basic_machine=mips-compaq
-				os=nonstopux
-				;;
-			os400)
-				basic_machine=powerpc-ibm
-				os=os400
-				;;
-			OSE68000 | ose68000)
-				basic_machine=m68000-ericsson
-				os=ose
-				;;
-			os68k)
-				basic_machine=m68k-none
-				os=os68k
-				;;
-			paragon)
-				basic_machine=i860-intel
-				os=osf
-				;;
-			parisc)
-				basic_machine=hppa-unknown
-				os=linux
-				;;
-			pw32)
-				basic_machine=i586-unknown
-				os=pw32
-				;;
-			rdos | rdos64)
-				basic_machine=x86_64-pc
-				os=rdos
-				;;
-			rdos32)
-				basic_machine=i386-pc
-				os=rdos
-				;;
-			rom68k)
-				basic_machine=m68k-rom68k
-				os=coff
-				;;
-			sa29200)
-				basic_machine=a29k-amd
-				os=udi
-				;;
-			sei)
-				basic_machine=mips-sei
-				os=seiux
-				;;
-			sequent)
-				basic_machine=i386-sequent
-				os=
-				;;
-			sps7)
-				basic_machine=m68k-bull
-				os=sysv2
-				;;
-			st2000)
-				basic_machine=m68k-tandem
-				os=
-				;;
-			stratus)
-				basic_machine=i860-stratus
-				os=sysv4
-				;;
-			sun2)
-				basic_machine=m68000-sun
-				os=
-				;;
-			sun2os3)
-				basic_machine=m68000-sun
-				os=sunos3
-				;;
-			sun2os4)
-				basic_machine=m68000-sun
-				os=sunos4
-				;;
-			sun3)
-				basic_machine=m68k-sun
-				os=
-				;;
-			sun3os3)
-				basic_machine=m68k-sun
-				os=sunos3
-				;;
-			sun3os4)
-				basic_machine=m68k-sun
-				os=sunos4
-				;;
-			sun4)
-				basic_machine=sparc-sun
-				os=
-				;;
-			sun4os3)
-				basic_machine=sparc-sun
-				os=sunos3
-				;;
-			sun4os4)
-				basic_machine=sparc-sun
-				os=sunos4
-				;;
-			sun4sol2)
-				basic_machine=sparc-sun
-				os=solaris2
-				;;
-			sun386 | sun386i | roadrunner)
-				basic_machine=i386-sun
-				os=
-				;;
-			sv1)
-				basic_machine=sv1-cray
-				os=unicos
-				;;
-			symmetry)
-				basic_machine=i386-sequent
-				os=dynix
-				;;
-			t3e)
-				basic_machine=alphaev5-cray
-				os=unicos
-				;;
-			t90)
-				basic_machine=t90-cray
-				os=unicos
-				;;
-			toad1)
-				basic_machine=pdp10-xkl
-				os=tops20
-				;;
-			tpf)
-				basic_machine=s390x-ibm
-				os=tpf
-				;;
-			udi29k)
-				basic_machine=a29k-amd
-				os=udi
-				;;
-			ultra3)
-				basic_machine=a29k-nyu
-				os=sym1
-				;;
-			v810 | necv810)
-				basic_machine=v810-nec
-				os=none
-				;;
-			vaxv)
-				basic_machine=vax-dec
-				os=sysv
-				;;
-			vms)
-				basic_machine=vax-dec
-				os=vms
-				;;
-			vxworks960)
-				basic_machine=i960-wrs
-				os=vxworks
-				;;
-			vxworks68)
-				basic_machine=m68k-wrs
-				os=vxworks
-				;;
-			vxworks29k)
-				basic_machine=a29k-wrs
-				os=vxworks
-				;;
-			xbox)
-				basic_machine=i686-pc
-				os=mingw32
-				;;
-			ymp)
-				basic_machine=ymp-cray
-				os=unicos
-				;;
-			*)
-				basic_machine=$1
-				os=
-				;;
-		esac
+		basic_machine=$1
+		os=
+		;;
+esac
+
+### Let's recognize common machines as not being operating systems so
+### that things like config.sub decstation-3100 work.  We also
+### recognize some manufacturers as not being operating systems, so we
+### can provide default operating systems below.
+case $os in
+	-sun*os*)
+		# Prevent following clause from handling this invalid input.
+		;;
+	-dec* | -mips* | -sequent* | -encore* | -pc532* | -sgi* | -sony* | \
+	-att* | -7300* | -3300* | -delta* | -motorola* | -sun[234]* | \
+	-unicom* | -ibm* | -next | -hp | -isi* | -apollo | -altos* | \
+	-convergent* | -ncr* | -news | -32* | -3600* | -3100* | -hitachi* |\
+	-c[123]* | -convex* | -sun | -crds | -omron* | -dg | -ultra | -tti* | \
+	-harris | -dolphin | -highlevel | -gould | -cbm | -ns | -masscomp | \
+	-apple | -axis | -knuth | -cray | -microblaze*)
+		os=
+		basic_machine=$1
+		;;
+	-bluegene*)
+		os=-cnk
+		;;
+	-sim | -cisco | -oki | -wec | -winbond)
+		os=
+		basic_machine=$1
+		;;
+	-scout)
+		;;
+	-wrs)
+		os=-vxworks
+		basic_machine=$1
+		;;
+	-chorusos*)
+		os=-chorusos
+		basic_machine=$1
+		;;
+	-chorusrdb)
+		os=-chorusrdb
+		basic_machine=$1
+		;;
+	-hiux*)
+		os=-hiuxwe2
+		;;
+	-sco6)
+		os=-sco5v6
+		basic_machine=`echo "$1" | sed -e 's/86-.*/86-pc/'`
+		;;
+	-sco5)
+		os=-sco3.2v5
+		basic_machine=`echo "$1" | sed -e 's/86-.*/86-pc/'`
+		;;
+	-sco4)
+		os=-sco3.2v4
+		basic_machine=`echo "$1" | sed -e 's/86-.*/86-pc/'`
+		;;
+	-sco3.2.[4-9]*)
+		os=`echo $os | sed -e 's/sco3.2./sco3.2v/'`
+		basic_machine=`echo "$1" | sed -e 's/86-.*/86-pc/'`
+		;;
+	-sco3.2v[4-9]*)
+		# Don't forget version if it is 3.2v4 or newer.
+		basic_machine=`echo "$1" | sed -e 's/86-.*/86-pc/'`
+		;;
+	-sco5v6*)
+		# Don't forget version if it is 3.2v4 or newer.
+		basic_machine=`echo "$1" | sed -e 's/86-.*/86-pc/'`
+		;;
+	-sco*)
+		os=-sco3.2v2
+		basic_machine=`echo "$1" | sed -e 's/86-.*/86-pc/'`
+		;;
+	-udk*)
+		basic_machine=`echo "$1" | sed -e 's/86-.*/86-pc/'`
+		;;
+	-isc)
+		os=-isc2.2
+		basic_machine=`echo "$1" | sed -e 's/86-.*/86-pc/'`
+		;;
+	-clix*)
+		basic_machine=clipper-intergraph
+		;;
+	-isc*)
+		basic_machine=`echo "$1" | sed -e 's/86-.*/86-pc/'`
+		;;
+	-lynx*178)
+		os=-lynxos178
+		;;
+	-lynx*5)
+		os=-lynxos5
+		;;
+	-lynx*)
+		os=-lynxos
+		;;
+	-ptx*)
+		basic_machine=`echo "$1" | sed -e 's/86-.*/86-sequent/'`
+		;;
+	-psos*)
+		os=-psos
+		;;
+	-mint | -mint[0-9]*)
+		basic_machine=m68k-atari
+		os=-mint
 		;;
 esac
 
-# Decode 1-component or ad-hoc basic machines
+# Decode aliases for certain CPU-COMPANY combinations.
 case $basic_machine in
-	# Here we handle the default manufacturer of certain CPU types.  It is in
-	# some cases the only manufacturer, in others, it is the most popular.
-	w89k)
-		cpu=hppa1.1
-		vendor=winbond
+	# Recognize the basic CPU types without company name.
+	# Some are omitted here because they have special meanings below.
+	1750a | 580 \
+	| a29k \
+	| aarch64 | aarch64_be \
+	| alpha | alphaev[4-8] | alphaev56 | alphaev6[78] | alphapca5[67] \
+	| alpha64 | alpha64ev[4-8] | alpha64ev56 | alpha64ev6[78] | alpha64pca5[67] \
+	| am33_2.0 \
+	| arc | arceb \
+	| arm | arm[bl]e | arme[lb] | armv[2-8] | armv[3-8][lb] | armv6m | armv[78][arm] \
+	| avr | avr32 \
+	| ba \
+	| be32 | be64 \
+	| bfin \
+	| c4x | c8051 | clipper | csky \
+	| d10v | d30v | dlx | dsp16xx \
+	| e2k | epiphany \
+	| fido | fr30 | frv | ft32 \
+	| h8300 | h8500 | hppa | hppa1.[01] | hppa2.0 | hppa2.0[nw] | hppa64 \
+	| hexagon \
+	| i370 | i860 | i960 | ia16 | ia64 \
+	| ip2k | iq2000 \
+	| k1om \
+	| le32 | le64 \
+	| lm32 \
+	| m32c | m32r | m32rle | m68000 | m68k | m88k \
+	| maxq | mb | microblaze | microblazeel | mcore | mep | metag \
+	| mips | mipsbe | mipseb | mipsel | mipsle \
+	| mips16 \
+	| mips64 | mips64el \
+	| mips64octeon | mips64octeonel \
+	| mips64orion | mips64orionel \
+	| mips64r5900 | mips64r5900el \
+	| mips64vr | mips64vrel \
+	| mips64vr4100 | mips64vr4100el \
+	| mips64vr4300 | mips64vr4300el \
+	| mips64vr5000 | mips64vr5000el \
+	| mips64vr5900 | mips64vr5900el \
+	| mipsisa32 | mipsisa32el \
+	| mipsisa32r2 | mipsisa32r2el \
+	| mipsisa32r6 | mipsisa32r6el \
+	| mipsisa64 | mipsisa64el \
+	| mipsisa64r2 | mipsisa64r2el \
+	| mipsisa64r6 | mipsisa64r6el \
+	| mipsisa64sb1 | mipsisa64sb1el \
+	| mipsisa64sr71k | mipsisa64sr71kel \
+	| mipsr5900 | mipsr5900el \
+	| mipstx39 | mipstx39el \
+	| mn10200 | mn10300 \
+	| moxie \
+	| mt \
+	| msp430 \
+	| nds32 | nds32le | nds32be \
+	| nfp \
+	| nios | nios2 | nios2eb | nios2el \
+	| ns16k | ns32k \
+	| open8 | or1k | or1knd | or32 \
+	| pdp10 | pj | pjl \
+	| powerpc | powerpc64 | powerpc64le | powerpcle \
+	| pru \
+	| pyramid \
+	| riscv32 | riscv64 \
+	| rl78 | rx \
+	| score \
+	| sh | sh[1234] | sh[24]a | sh[24]aeb | sh[23]e | sh[234]eb | sheb | shbe | shle | sh[1234]le | sh3ele \
+	| sh64 | sh64le \
+	| sparc | sparc64 | sparc64b | sparc64v | sparc86x | sparclet | sparclite \
+	| sparcv8 | sparcv9 | sparcv9b | sparcv9v \
+	| spu \
+	| tahoe | tic4x | tic54x | tic55x | tic6x | tic80 | tron \
+	| ubicom32 \
+	| v850 | v850e | v850e1 | v850e2 | v850es | v850e2v3 \
+	| visium \
+	| wasm32 \
+	| x86 | xc16x | xstormy16 | xtensa \
+	| z8k | z80)
+		basic_machine=$basic_machine-unknown
 		;;
-	op50n)
-		cpu=hppa1.1
-		vendor=oki
+	c54x)
+		basic_machine=tic54x-unknown
 		;;
-	op60c)
-		cpu=hppa1.1
-		vendor=oki
+	c55x)
+		basic_machine=tic55x-unknown
 		;;
-	ibm*)
-		cpu=i370
-		vendor=ibm
+	c6x)
+		basic_machine=tic6x-unknown
 		;;
-	orion105)
-		cpu=clipper
-		vendor=highlevel
+	leon|leon[3-9])
+		basic_machine=sparc-$basic_machine
 		;;
-	mac | mpw | mac-mpw)
-		cpu=m68k
-		vendor=apple
+	m6811 | m68hc11 | m6812 | m68hc12 | m68hcs12x | nvptx | picochip)
+		basic_machine=$basic_machine-unknown
+		os=-none
 		;;
-	pmac | pmac-mpw)
-		cpu=powerpc
-		vendor=apple
+	m88110 | m680[12346]0 | m683?2 | m68360 | m5200 | v70 | w65)
+		;;
+	m9s12z | m68hcs12z | hcs12z | s12z)
+		basic_machine=s12z-unknown
+		os=-none
+		;;
+	ms1)
+		basic_machine=mt-unknown
 		;;
 
+	strongarm | thumb | xscale)
+		basic_machine=arm-unknown
+		;;
+	xgate)
+		basic_machine=$basic_machine-unknown
+		os=-none
+		;;
+	xscaleeb)
+		basic_machine=armeb-unknown
+		;;
+
+	xscaleel)
+		basic_machine=armel-unknown
+		;;
+
+	# We use `pc' rather than `unknown'
+	# because (1) that's what they normally are, and
+	# (2) the word "unknown" tends to confuse beginning users.
+	i*86 | x86_64)
+	  basic_machine=$basic_machine-pc
+	  ;;
+	# Object if more than one company name word.
+	*-*-*)
+		echo Invalid configuration \`"$1"\': machine \`"$basic_machine"\' not recognized 1>&2
+		exit 1
+		;;
+	# Recognize the basic CPU types with company name.
+	580-* \
+	| a29k-* \
+	| aarch64-* | aarch64_be-* \
+	| alpha-* | alphaev[4-8]-* | alphaev56-* | alphaev6[78]-* \
+	| alpha64-* | alpha64ev[4-8]-* | alpha64ev56-* | alpha64ev6[78]-* \
+	| alphapca5[67]-* | alpha64pca5[67]-* | arc-* | arceb-* \
+	| arm-*  | armbe-* | armle-* | armeb-* | armv*-* \
+	| avr-* | avr32-* \
+	| ba-* \
+	| be32-* | be64-* \
+	| bfin-* | bs2000-* \
+	| c[123]* | c30-* | [cjt]90-* | c4x-* \
+	| c8051-* | clipper-* | craynv-* | csky-* | cydra-* \
+	| d10v-* | d30v-* | dlx-* \
+	| e2k-* | elxsi-* \
+	| f30[01]-* | f700-* | fido-* | fr30-* | frv-* | fx80-* \
+	| h8300-* | h8500-* \
+	| hppa-* | hppa1.[01]-* | hppa2.0-* | hppa2.0[nw]-* | hppa64-* \
+	| hexagon-* \
+	| i*86-* | i860-* | i960-* | ia16-* | ia64-* \
+	| ip2k-* | iq2000-* \
+	| k1om-* \
+	| le32-* | le64-* \
+	| lm32-* \
+	| m32c-* | m32r-* | m32rle-* \
+	| m68000-* | m680[012346]0-* | m68360-* | m683?2-* | m68k-* \
+	| m88110-* | m88k-* | maxq-* | mcore-* | metag-* \
+	| microblaze-* | microblazeel-* \
+	| mips-* | mipsbe-* | mipseb-* | mipsel-* | mipsle-* \
+	| mips16-* \
+	| mips64-* | mips64el-* \
+	| mips64octeon-* | mips64octeonel-* \
+	| mips64orion-* | mips64orionel-* \
+	| mips64r5900-* | mips64r5900el-* \
+	| mips64vr-* | mips64vrel-* \
+	| mips64vr4100-* | mips64vr4100el-* \
+	| mips64vr4300-* | mips64vr4300el-* \
+	| mips64vr5000-* | mips64vr5000el-* \
+	| mips64vr5900-* | mips64vr5900el-* \
+	| mipsisa32-* | mipsisa32el-* \
+	| mipsisa32r2-* | mipsisa32r2el-* \
+	| mipsisa32r6-* | mipsisa32r6el-* \
+	| mipsisa64-* | mipsisa64el-* \
+	| mipsisa64r2-* | mipsisa64r2el-* \
+	| mipsisa64r6-* | mipsisa64r6el-* \
+	| mipsisa64sb1-* | mipsisa64sb1el-* \
+	| mipsisa64sr71k-* | mipsisa64sr71kel-* \
+	| mipsr5900-* | mipsr5900el-* \
+	| mipstx39-* | mipstx39el-* \
+	| mmix-* \
+	| mt-* \
+	| msp430-* \
+	| nds32-* | nds32le-* | nds32be-* \
+	| nfp-* \
+	| nios-* | nios2-* | nios2eb-* | nios2el-* \
+	| none-* | np1-* | ns16k-* | ns32k-* \
+	| open8-* \
+	| or1k*-* \
+	| orion-* \
+	| pdp10-* | pdp11-* | pj-* | pjl-* | pn-* | power-* \
+	| powerpc-* | powerpc64-* | powerpc64le-* | powerpcle-* \
+	| pru-* \
+	| pyramid-* \
+	| riscv32-* | riscv64-* \
+	| rl78-* | romp-* | rs6000-* | rx-* \
+	| sh-* | sh[1234]-* | sh[24]a-* | sh[24]aeb-* | sh[23]e-* | sh[34]eb-* | sheb-* | shbe-* \
+	| shle-* | sh[1234]le-* | sh3ele-* | sh64-* | sh64le-* \
+	| sparc-* | sparc64-* | sparc64b-* | sparc64v-* | sparc86x-* | sparclet-* \
+	| sparclite-* \
+	| sparcv8-* | sparcv9-* | sparcv9b-* | sparcv9v-* | sv1-* | sx*-* \
+	| tahoe-* \
+	| tic30-* | tic4x-* | tic54x-* | tic55x-* | tic6x-* | tic80-* \
+	| tile*-* \
+	| tron-* \
+	| ubicom32-* \
+	| v850-* | v850e-* | v850e1-* | v850es-* | v850e2-* | v850e2v3-* \
+	| vax-* \
+	| visium-* \
+	| wasm32-* \
+	| we32k-* \
+	| x86-* | x86_64-* | xc16x-* | xps100-* \
+	| xstormy16-* | xtensa*-* \
+	| ymp-* \
+	| z8k-* | z80-*)
+		;;
+	# Recognize the basic CPU types without company name, with glob match.
+	xtensa*)
+		basic_machine=$basic_machine-unknown
+		;;
 	# Recognize the various machine names and aliases which stand
 	# for a CPU type and a company and sometimes even an OS.
+	386bsd)
+		basic_machine=i386-pc
+		os=-bsd
+		;;
 	3b1 | 7300 | 7300-att | att-7300 | pc7300 | safari | unixpc)
-		cpu=m68000
-		vendor=att
+		basic_machine=m68000-att
 		;;
 	3b*)
-		cpu=we32k
-		vendor=att
+		basic_machine=we32k-att
+		;;
+	a29khif)
+		basic_machine=a29k-amd
+		os=-udi
+		;;
+	abacus)
+		basic_machine=abacus-unknown
+		;;
+	adobe68k)
+		basic_machine=m68010-adobe
+		os=-scout
+		;;
+	alliant | fx80)
+		basic_machine=fx80-alliant
+		;;
+	altos | altos3068)
+		basic_machine=m68k-altos
+		;;
+	am29k)
+		basic_machine=a29k-none
+		os=-bsd
+		;;
+	amd64)
+		basic_machine=x86_64-pc
+		;;
+	amd64-*)
+		basic_machine=x86_64-`echo "$basic_machine" | sed 's/^[^-]*-//'`
+		;;
+	amdahl)
+		basic_machine=580-amdahl
+		os=-sysv
+		;;
+	amiga | amiga-*)
+		basic_machine=m68k-unknown
+		;;
+	amigaos | amigados)
+		basic_machine=m68k-unknown
+		os=-amigaos
+		;;
+	amigaunix | amix)
+		basic_machine=m68k-unknown
+		os=-sysv4
+		;;
+	apollo68)
+		basic_machine=m68k-apollo
+		os=-sysv
+		;;
+	apollo68bsd)
+		basic_machine=m68k-apollo
+		os=-bsd
+		;;
+	aros)
+		basic_machine=i386-pc
+		os=-aros
+		;;
+	asmjs)
+		basic_machine=asmjs-unknown
+		;;
+	aux)
+		basic_machine=m68k-apple
+		os=-aux
+		;;
+	balance)
+		basic_machine=ns32k-sequent
+		os=-dynix
+		;;
+	blackfin)
+		basic_machine=bfin-unknown
+		os=-linux
+		;;
+	blackfin-*)
+		basic_machine=bfin-`echo "$basic_machine" | sed 's/^[^-]*-//'`
+		os=-linux
 		;;
 	bluegene*)
-		cpu=powerpc
-		vendor=ibm
-		os=cnk
+		basic_machine=powerpc-ibm
+		os=-cnk
+		;;
+	c54x-*)
+		basic_machine=tic54x-`echo "$basic_machine" | sed 's/^[^-]*-//'`
+		;;
+	c55x-*)
+		basic_machine=tic55x-`echo "$basic_machine" | sed 's/^[^-]*-//'`
+		;;
+	c6x-*)
+		basic_machine=tic6x-`echo "$basic_machine" | sed 's/^[^-]*-//'`
+		;;
+	c90)
+		basic_machine=c90-cray
+		os=-unicos
+		;;
+	cegcc)
+		basic_machine=arm-unknown
+		os=-cegcc
+		;;
+	convex-c1)
+		basic_machine=c1-convex
+		os=-bsd
+		;;
+	convex-c2)
+		basic_machine=c2-convex
+		os=-bsd
+		;;
+	convex-c32)
+		basic_machine=c32-convex
+		os=-bsd
+		;;
+	convex-c34)
+		basic_machine=c34-convex
+		os=-bsd
+		;;
+	convex-c38)
+		basic_machine=c38-convex
+		os=-bsd
+		;;
+	cray | j90)
+		basic_machine=j90-cray
+		os=-unicos
+		;;
+	craynv)
+		basic_machine=craynv-cray
+		os=-unicosmp
+		;;
+	cr16 | cr16-*)
+		basic_machine=cr16-unknown
+		os=-elf
+		;;
+	crds | unos)
+		basic_machine=m68k-crds
+		;;
+	crisv32 | crisv32-* | etraxfs*)
+		basic_machine=crisv32-axis
+		;;
+	cris | cris-* | etrax*)
+		basic_machine=cris-axis
+		;;
+	crx)
+		basic_machine=crx-unknown
+		os=-elf
+		;;
+	da30 | da30-*)
+		basic_machine=m68k-da30
+		;;
+	decstation | decstation-3100 | pmax | pmax-* | pmin | dec3100 | decstatn)
+		basic_machine=mips-dec
 		;;
 	decsystem10* | dec10*)
-		cpu=pdp10
-		vendor=dec
-		os=tops10
+		basic_machine=pdp10-dec
+		os=-tops10
 		;;
 	decsystem20* | dec20*)
-		cpu=pdp10
-		vendor=dec
-		os=tops20
+		basic_machine=pdp10-dec
+		os=-tops20
 		;;
 	delta | 3300 | motorola-3300 | motorola-delta \
 	      | 3300-motorola | delta-motorola)
-		cpu=m68k
-		vendor=motorola
+		basic_machine=m68k-motorola
+		;;
+	delta88)
+		basic_machine=m88k-motorola
+		os=-sysv3
+		;;
+	dicos)
+		basic_machine=i686-pc
+		os=-dicos
+		;;
+	djgpp)
+		basic_machine=i586-pc
+		os=-msdosdjgpp
+		;;
+	dpx20 | dpx20-*)
+		basic_machine=rs6000-bull
+		os=-bosx
 		;;
 	dpx2*)
-		cpu=m68k
-		vendor=bull
-		os=sysv3
+		basic_machine=m68k-bull
+		os=-sysv3
 		;;
-	encore | umax | mmax)
-		cpu=ns32k
-		vendor=encore
+	e500v[12])
+		basic_machine=powerpc-unknown
+		os=$os"spe"
+		;;
+	e500v[12]-*)
+		basic_machine=powerpc-`echo "$basic_machine" | sed 's/^[^-]*-//'`
+		os=$os"spe"
+		;;
+	ebmon29k)
+		basic_machine=a29k-amd
+		os=-ebmon
 		;;
 	elxsi)
-		cpu=elxsi
-		vendor=elxsi
-		os=${os:-bsd}
+		basic_machine=elxsi-elxsi
+		os=-bsd
+		;;
+	encore | umax | mmax)
+		basic_machine=ns32k-encore
+		;;
+	es1800 | OSE68k | ose68k | ose | OSE)
+		basic_machine=m68k-ericsson
+		os=-ose
 		;;
 	fx2800)
-		cpu=i860
-		vendor=alliant
+		basic_machine=i860-alliant
 		;;
 	genix)
-		cpu=ns32k
-		vendor=ns
+		basic_machine=ns32k-ns
+		;;
+	gmicro)
+		basic_machine=tron-gmicro
+		os=-sysv
+		;;
+	go32)
+		basic_machine=i386-pc
+		os=-go32
 		;;
 	h3050r* | hiux*)
-		cpu=hppa1.1
-		vendor=hitachi
-		os=hiuxwe2
+		basic_machine=hppa1.1-hitachi
+		os=-hiuxwe2
+		;;
+	h8300hms)
+		basic_machine=h8300-hitachi
+		os=-hms
+		;;
+	h8300xray)
+		basic_machine=h8300-hitachi
+		os=-xray
+		;;
+	h8500hms)
+		basic_machine=h8500-hitachi
+		os=-hms
+		;;
+	harris)
+		basic_machine=m88k-harris
+		os=-sysv3
+		;;
+	hp300-*)
+		basic_machine=m68k-hp
+		;;
+	hp300bsd)
+		basic_machine=m68k-hp
+		os=-bsd
+		;;
+	hp300hpux)
+		basic_machine=m68k-hp
+		os=-hpux
 		;;
 	hp3k9[0-9][0-9] | hp9[0-9][0-9])
-		cpu=hppa1.0
-		vendor=hp
+		basic_machine=hppa1.0-hp
 		;;
 	hp9k2[0-9][0-9] | hp9k31[0-9])
-		cpu=m68000
-		vendor=hp
+		basic_machine=m68000-hp
 		;;
 	hp9k3[2-9][0-9])
-		cpu=m68k
-		vendor=hp
+		basic_machine=m68k-hp
 		;;
 	hp9k6[0-9][0-9] | hp6[0-9][0-9])
-		cpu=hppa1.0
-		vendor=hp
+		basic_machine=hppa1.0-hp
 		;;
 	hp9k7[0-79][0-9] | hp7[0-79][0-9])
-		cpu=hppa1.1
-		vendor=hp
+		basic_machine=hppa1.1-hp
 		;;
 	hp9k78[0-9] | hp78[0-9])
 		# FIXME: really hppa2.0-hp
-		cpu=hppa1.1
-		vendor=hp
+		basic_machine=hppa1.1-hp
 		;;
 	hp9k8[67]1 | hp8[67]1 | hp9k80[24] | hp80[24] | hp9k8[78]9 | hp8[78]9 | hp9k893 | hp893)
 		# FIXME: really hppa2.0-hp
-		cpu=hppa1.1
-		vendor=hp
+		basic_machine=hppa1.1-hp
 		;;
 	hp9k8[0-9][13679] | hp8[0-9][13679])
-		cpu=hppa1.1
-		vendor=hp
+		basic_machine=hppa1.1-hp
 		;;
 	hp9k8[0-9][0-9] | hp8[0-9][0-9])
-		cpu=hppa1.0
-		vendor=hp
+		basic_machine=hppa1.0-hp
+		;;
+	hppaosf)
+		basic_machine=hppa1.1-hp
+		os=-osf
+		;;
+	hppro)
+		basic_machine=hppa1.1-hp
+		os=-proelf
+		;;
+	i370-ibm* | ibm*)
+		basic_machine=i370-ibm
 		;;
 	i*86v32)
-		cpu=`echo "$1" | sed -e 's/86.*/86/'`
-		vendor=pc
-		os=sysv32
+		basic_machine=`echo "$1" | sed -e 's/86.*/86-pc/'`
+		os=-sysv32
 		;;
 	i*86v4*)
-		cpu=`echo "$1" | sed -e 's/86.*/86/'`
-		vendor=pc
-		os=sysv4
+		basic_machine=`echo "$1" | sed -e 's/86.*/86-pc/'`
+		os=-sysv4
 		;;
 	i*86v)
-		cpu=`echo "$1" | sed -e 's/86.*/86/'`
-		vendor=pc
-		os=sysv
+		basic_machine=`echo "$1" | sed -e 's/86.*/86-pc/'`
+		os=-sysv
 		;;
 	i*86sol2)
-		cpu=`echo "$1" | sed -e 's/86.*/86/'`
-		vendor=pc
-		os=solaris2
-		;;
-	j90 | j90-cray)
-		cpu=j90
-		vendor=cray
-		os=${os:-unicos}
+		basic_machine=`echo "$1" | sed -e 's/86.*/86-pc/'`
+		os=-solaris2
+		;;
+	i386mach)
+		basic_machine=i386-mach
+		os=-mach
+		;;
+	vsta)
+		basic_machine=i386-unknown
+		os=-vsta
 		;;
 	iris | iris4d)
-		cpu=mips
-		vendor=sgi
+		basic_machine=mips-sgi
 		case $os in
-		    irix*)
+		    -irix*)
 			;;
 		    *)
-			os=irix4
+			os=-irix4
 			;;
 		esac
 		;;
+	isi68 | isi)
+		basic_machine=m68k-isi
+		os=-sysv
+		;;
+	leon-*|leon[3-9]-*)
+		basic_machine=sparc-`echo "$basic_machine" | sed 's/-.*//'`
+		;;
+	m68knommu)
+		basic_machine=m68k-unknown
+		os=-linux
+		;;
+	m68knommu-*)
+		basic_machine=m68k-`echo "$basic_machine" | sed 's/^[^-]*-//'`
+		os=-linux
+		;;
+	magnum | m3230)
+		basic_machine=mips-mips
+		os=-sysv
+		;;
+	merlin)
+		basic_machine=ns32k-utek
+		os=-sysv
+		;;
+	microblaze*)
+		basic_machine=microblaze-xilinx
+		;;
+	mingw64)
+		basic_machine=x86_64-pc
+		os=-mingw64
+		;;
+	mingw32)
+		basic_machine=i686-pc
+		os=-mingw32
+		;;
+	mingw32ce)
+		basic_machine=arm-unknown
+		os=-mingw32ce
+		;;
 	miniframe)
-		cpu=m68000
-		vendor=convergent
+		basic_machine=m68000-convergent
 		;;
-	*mint | mint[0-9]* | *MiNT | *MiNT[0-9]*)
-		cpu=m68k
-		vendor=atari
-		os=mint
+	*mint | -mint[0-9]* | *MiNT | *MiNT[0-9]*)
+		basic_machine=m68k-atari
+		os=-mint
+		;;
+	mips3*-*)
+		basic_machine=`echo "$basic_machine" | sed -e 's/mips3/mips64/'`
+		;;
+	mips3*)
+		basic_machine=`echo "$basic_machine" | sed -e 's/mips3/mips64/'`-unknown
+		;;
+	monitor)
+		basic_machine=m68k-rom68k
+		os=-coff
+		;;
+	morphos)
+		basic_machine=powerpc-unknown
+		os=-morphos
+		;;
+	moxiebox)
+		basic_machine=moxie-unknown
+		os=-moxiebox
+		;;
+	msdos)
+		basic_machine=i386-pc
+		os=-msdos
+		;;
+	ms1-*)
+		basic_machine=`echo "$basic_machine" | sed -e 's/ms1-/mt-/'`
+		;;
+	msys)
+		basic_machine=i686-pc
+		os=-msys
+		;;
+	mvs)
+		basic_machine=i370-ibm
+		os=-mvs
+		;;
+	nacl)
+		basic_machine=le32-unknown
+		os=-nacl
+		;;
+	ncr3000)
+		basic_machine=i486-ncr
+		os=-sysv4
+		;;
+	netbsd386)
+		basic_machine=i386-unknown
+		os=-netbsd
+		;;
+	netwinder)
+		basic_machine=armv4l-rebel
+		os=-linux
+		;;
+	news | news700 | news800 | news900)
+		basic_machine=m68k-sony
+		os=-newsos
+		;;
+	news1000)
+		basic_machine=m68030-sony
+		os=-newsos
 		;;
 	news-3600 | risc-news)
-		cpu=mips
-		vendor=sony
-		os=newsos
+		basic_machine=mips-sony
+		os=-newsos
+		;;
+	necv70)
+		basic_machine=v70-nec
+		os=-sysv
 		;;
 	next | m*-next)
-		cpu=m68k
-		vendor=next
+		basic_machine=m68k-next
 		case $os in
-		    nextstep* )
+		    -nextstep* )
 			;;
-		    ns2*)
-		      os=nextstep2
+		    -ns2*)
+		      os=-nextstep2
 			;;
 		    *)
-		      os=nextstep3
+		      os=-nextstep3
 			;;
 		esac
 		;;
+	nh3000)
+		basic_machine=m68k-harris
+		os=-cxux
+		;;
+	nh[45]000)
+		basic_machine=m88k-harris
+		os=-cxux
+		;;
+	nindy960)
+		basic_machine=i960-intel
+		os=-nindy
+		;;
+	mon960)
+		basic_machine=i960-intel
+		os=-mon960
+		;;
+	nonstopux)
+		basic_machine=mips-compaq
+		os=-nonstopux
+		;;
 	np1)
-		cpu=np1
-		vendor=gould
+		basic_machine=np1-gould
+		;;
+	neo-tandem)
+		basic_machine=neo-tandem
+		;;
+	nse-tandem)
+		basic_machine=nse-tandem
+		;;
+	nsr-tandem)
+		basic_machine=nsr-tandem
+		;;
+	nsv-tandem)
+		basic_machine=nsv-tandem
+		;;
+	nsx-tandem)
+		basic_machine=nsx-tandem
 		;;
 	op50n-* | op60c-*)
-		cpu=hppa1.1
-		vendor=oki
-		os=proelf
+		basic_machine=hppa1.1-oki
+		os=-proelf
+		;;
+	openrisc | openrisc-*)
+		basic_machine=or32-unknown
+		;;
+	os400)
+		basic_machine=powerpc-ibm
+		os=-os400
+		;;
+	OSE68000 | ose68000)
+		basic_machine=m68000-ericsson
+		os=-ose
+		;;
+	os68k)
+		basic_machine=m68k-none
+		os=-os68k
 		;;
 	pa-hitachi)
-		cpu=hppa1.1
-		vendor=hitachi
-		os=hiuxwe2
+		basic_machine=hppa1.1-hitachi
+		os=-hiuxwe2
+		;;
+	paragon)
+		basic_machine=i860-intel
+		os=-osf
+		;;
+	parisc)
+		basic_machine=hppa-unknown
+		os=-linux
+		;;
+	parisc-*)
+		basic_machine=hppa-`echo "$basic_machine" | sed 's/^[^-]*-//'`
+		os=-linux
 		;;
 	pbd)
-		cpu=sparc
-		vendor=tti
+		basic_machine=sparc-tti
 		;;
 	pbb)
-		cpu=m68k
-		vendor=tti
+		basic_machine=m68k-tti
 		;;
-	pc532)
-		cpu=ns32k
-		vendor=pc532
+	pc532 | pc532-*)
+		basic_machine=ns32k-pc532
 		;;
-	pn)
-		cpu=pn
-		vendor=gould
+	pc98)
+		basic_machine=i386-pc
 		;;
-	power)
-		cpu=power
-		vendor=ibm
+	pc98-*)
+		basic_machine=i386-`echo "$basic_machine" | sed 's/^[^-]*-//'`
 		;;
-	ps2)
-		cpu=i386
-		vendor=ibm
+	pentium | p5 | k5 | k6 | nexgen | viac3)
+		basic_machine=i586-pc
 		;;
-	rm[46]00)
-		cpu=mips
-		vendor=siemens
+	pentiumpro | p6 | 6x86 | athlon | athlon_*)
+		basic_machine=i686-pc
 		;;
-	rtpc | rtpc-*)
-		cpu=romp
-		vendor=ibm
+	pentiumii | pentium2 | pentiumiii | pentium3)
+		basic_machine=i686-pc
 		;;
-	sde)
-		cpu=mipsisa32
-		vendor=sde
-		os=${os:-elf}
+	pentium4)
+		basic_machine=i786-pc
 		;;
-	simso-wrs)
-		cpu=sparclite
-		vendor=wrs
-		os=vxworks
+	pentium-* | p5-* | k5-* | k6-* | nexgen-* | viac3-*)
+		basic_machine=i586-`echo "$basic_machine" | sed 's/^[^-]*-//'`
 		;;
-	tower | tower-32)
-		cpu=m68k
-		vendor=ncr
+	pentiumpro-* | p6-* | 6x86-* | athlon-*)
+		basic_machine=i686-`echo "$basic_machine" | sed 's/^[^-]*-//'`
 		;;
-	vpp*|vx|vx-*)
-		cpu=f301
-		vendor=fujitsu
+	pentiumii-* | pentium2-* | pentiumiii-* | pentium3-*)
+		basic_machine=i686-`echo "$basic_machine" | sed 's/^[^-]*-//'`
 		;;
-	w65)
-		cpu=w65
-		vendor=wdc
+	pentium4-*)
+		basic_machine=i786-`echo "$basic_machine" | sed 's/^[^-]*-//'`
 		;;
-	w89k-*)
-		cpu=hppa1.1
-		vendor=winbond
-		os=proelf
+	pn)
+		basic_machine=pn-gould
 		;;
-	none)
-		cpu=none
-		vendor=none
+	power)	basic_machine=power-ibm
 		;;
-	leon|leon[3-9])
-		cpu=sparc
-		vendor=$basic_machine
+	ppc | ppcbe)	basic_machine=powerpc-unknown
 		;;
-	leon-*|leon[3-9]-*)
-		cpu=sparc
-		vendor=`echo "$basic_machine" | sed 's/-.*//'`
+	ppc-* | ppcbe-*)
+		basic_machine=powerpc-`echo "$basic_machine" | sed 's/^[^-]*-//'`
 		;;
-
-	*-*)
-		IFS="-" read -r cpu vendor <<EOF
-$basic_machine
-EOF
+	ppcle | powerpclittle)
+		basic_machine=powerpcle-unknown
 		;;
-	# We use `pc' rather than `unknown'
-	# because (1) that's what they normally are, and
-	# (2) the word "unknown" tends to confuse beginning users.
-	i*86 | x86_64)
-		cpu=$basic_machine
-		vendor=pc
+	ppcle-* | powerpclittle-*)
+		basic_machine=powerpcle-`echo "$basic_machine" | sed 's/^[^-]*-//'`
 		;;
-	# These rules are duplicated from below for sake of the special case above;
-	# i.e. things that normalized to x86 arches should also default to "pc"
-	pc98)
-		cpu=i386
-		vendor=pc
+	ppc64)	basic_machine=powerpc64-unknown
 		;;
-	x64 | amd64)
-		cpu=x86_64
-		vendor=pc
+	ppc64-*) basic_machine=powerpc64-`echo "$basic_machine" | sed 's/^[^-]*-//'`
 		;;
-	# Recognize the basic CPU types without company name.
-	*)
-		cpu=$basic_machine
-		vendor=unknown
+	ppc64le | powerpc64little)
+		basic_machine=powerpc64le-unknown
 		;;
-esac
-
-unset -v basic_machine
-
-# Decode basic machines in the full and proper CPU-Company form.
-case $cpu-$vendor in
-	# Here we handle the default manufacturer of certain CPU types in cannonical form. It is in
-	# some cases the only manufacturer, in others, it is the most popular.
-	craynv-unknown)
-		vendor=cray
-		os=${os:-unicosmp}
+	ppc64le-* | powerpc64little-*)
+		basic_machine=powerpc64le-`echo "$basic_machine" | sed 's/^[^-]*-//'`
 		;;
-	c90-unknown | c90-cray)
-		vendor=cray
-		os=${os:-unicos}
+	ps2)
+		basic_machine=i386-ibm
 		;;
-	fx80-unknown)
-		vendor=alliant
+	pw32)
+		basic_machine=i586-unknown
+		os=-pw32
+		;;
+	rdos | rdos64)
+		basic_machine=x86_64-pc
+		os=-rdos
+		;;
+	rdos32)
+		basic_machine=i386-pc
+		os=-rdos
+		;;
+	rom68k)
+		basic_machine=m68k-rom68k
+		os=-coff
 		;;
-	romp-unknown)
-		vendor=ibm
+	rm[46]00)
+		basic_machine=mips-siemens
 		;;
-	mmix-unknown)
-		vendor=knuth
+	rtpc | rtpc-*)
+		basic_machine=romp-ibm
 		;;
-	microblaze-unknown | microblazeel-unknown)
-		vendor=xilinx
+	s390 | s390-*)
+		basic_machine=s390-ibm
 		;;
-	rs6000-unknown)
-		vendor=ibm
+	s390x | s390x-*)
+		basic_machine=s390x-ibm
 		;;
-	vax-unknown)
-		vendor=dec
+	sa29200)
+		basic_machine=a29k-amd
+		os=-udi
 		;;
-	pdp11-unknown)
-		vendor=dec
+	sb1)
+		basic_machine=mipsisa64sb1-unknown
 		;;
-	we32k-unknown)
-		vendor=att
+	sb1el)
+		basic_machine=mipsisa64sb1el-unknown
 		;;
-	cydra-unknown)
-		vendor=cydrome
+	sde)
+		basic_machine=mipsisa32-sde
+		os=-elf
 		;;
-	i370-ibm*)
-		vendor=ibm
+	sei)
+		basic_machine=mips-sei
+		os=-seiux
 		;;
-	orion-unknown)
-		vendor=highlevel
+	sequent)
+		basic_machine=i386-sequent
 		;;
-	xps-unknown | xps100-unknown)
-		cpu=xps100
-		vendor=honeywell
+	sh5el)
+		basic_machine=sh5le-unknown
 		;;
-
-	# Here we normalize CPU types with a missing or matching vendor
-	dpx20-unknown | dpx20-bull)
-		cpu=rs6000
-		vendor=bull
-		os=${os:-bosx}
+	simso-wrs)
+		basic_machine=sparclite-wrs
+		os=-vxworks
 		;;
-
-	# Here we normalize CPU types irrespective of the vendor
-	amd64-*)
-		cpu=x86_64
+	sps7)
+		basic_machine=m68k-bull
+		os=-sysv2
+		;;
+	spur)
+		basic_machine=spur-unknown
+		;;
+	st2000)
+		basic_machine=m68k-tandem
+		;;
+	stratus)
+		basic_machine=i860-stratus
+		os=-sysv4
 		;;
-	blackfin-*)
-		cpu=bfin
-		os=linux
+	strongarm-* | thumb-*)
+		basic_machine=arm-`echo "$basic_machine" | sed 's/^[^-]*-//'`
 		;;
-	c54x-*)
-		cpu=tic54x
+	sun2)
+		basic_machine=m68000-sun
 		;;
-	c55x-*)
-		cpu=tic55x
+	sun2os3)
+		basic_machine=m68000-sun
+		os=-sunos3
 		;;
-	c6x-*)
-		cpu=tic6x
+	sun2os4)
+		basic_machine=m68000-sun
+		os=-sunos4
 		;;
-	e500v[12]-*)
-		cpu=powerpc
-		os=$os"spe"
+	sun3os3)
+		basic_machine=m68k-sun
+		os=-sunos3
 		;;
-	mips3*-*)
-		cpu=mips64
+	sun3os4)
+		basic_machine=m68k-sun
+		os=-sunos4
 		;;
-	ms1-*)
-		cpu=mt
+	sun4os3)
+		basic_machine=sparc-sun
+		os=-sunos3
 		;;
-	m68knommu-*)
-		cpu=m68k
-		os=linux
+	sun4os4)
+		basic_machine=sparc-sun
+		os=-sunos4
 		;;
-	m9s12z-* | m68hcs12z-* | hcs12z-* | s12z-*)
-		cpu=s12z
+	sun4sol2)
+		basic_machine=sparc-sun
+		os=-solaris2
 		;;
-	openrisc-*)
-		cpu=or32
+	sun3 | sun3-*)
+		basic_machine=m68k-sun
 		;;
-	parisc-*)
-		cpu=hppa
-		os=linux
+	sun4)
+		basic_machine=sparc-sun
 		;;
-	pentium-* | p5-* | k5-* | k6-* | nexgen-* | viac3-*)
-		cpu=i586
+	sun386 | sun386i | roadrunner)
+		basic_machine=i386-sun
 		;;
-	pentiumpro-* | p6-* | 6x86-* | athlon-* | athalon_*-*)
-		cpu=i686
+	sv1)
+		basic_machine=sv1-cray
+		os=-unicos
 		;;
-	pentiumii-* | pentium2-* | pentiumiii-* | pentium3-*)
-		cpu=i686
+	symmetry)
+		basic_machine=i386-sequent
+		os=-dynix
 		;;
-	pentium4-*)
-		cpu=i786
+	t3e)
+		basic_machine=alphaev5-cray
+		os=-unicos
 		;;
-	pc98-*)
-		cpu=i386
+	t90)
+		basic_machine=t90-cray
+		os=-unicos
 		;;
-	ppc-* | ppcbe-*)
-		cpu=powerpc
+	tile*)
+		basic_machine=$basic_machine-unknown
+		os=-linux-gnu
 		;;
-	ppcle-* | powerpclittle-*)
-		cpu=powerpcle
+	tx39)
+		basic_machine=mipstx39-unknown
 		;;
-	ppc64-*)
-		cpu=powerpc64
+	tx39el)
+		basic_machine=mipstx39el-unknown
 		;;
-	ppc64le-* | powerpc64little-*)
-		cpu=powerpc64le
+	toad1)
+		basic_machine=pdp10-xkl
+		os=-tops20
 		;;
-	sb1-*)
-		cpu=mipsisa64sb1
+	tower | tower-32)
+		basic_machine=m68k-ncr
 		;;
-	sb1el-*)
-		cpu=mipsisa64sb1el
+	tpf)
+		basic_machine=s390x-ibm
+		os=-tpf
+		;;
+	udi29k)
+		basic_machine=a29k-amd
+		os=-udi
+		;;
+	ultra3)
+		basic_machine=a29k-nyu
+		os=-sym1
+		;;
+	v810 | necv810)
+		basic_machine=v810-nec
+		os=-none
+		;;
+	vaxv)
+		basic_machine=vax-dec
+		os=-sysv
+		;;
+	vms)
+		basic_machine=vax-dec
+		os=-vms
 		;;
-	sh5e[lb]-*)
-		cpu=`echo "$cpu" | sed 's/^\(sh.\)e\(.\)$/\1\2e/'`
+	vpp*|vx|vx-*)
+		basic_machine=f301-fujitsu
 		;;
-	spur-*)
-		cpu=spur
+	vxworks960)
+		basic_machine=i960-wrs
+		os=-vxworks
+		;;
+	vxworks68)
+		basic_machine=m68k-wrs
+		os=-vxworks
+		;;
+	vxworks29k)
+		basic_machine=a29k-wrs
+		os=-vxworks
+		;;
+	w65*)
+		basic_machine=w65-wdc
+		os=-none
 		;;
-	strongarm-* | thumb-*)
-		cpu=arm
+	w89k-*)
+		basic_machine=hppa1.1-winbond
+		os=-proelf
 		;;
-	tx39-*)
-		cpu=mipstx39
+	x64)
+		basic_machine=x86_64-pc
 		;;
-	tx39el-*)
-		cpu=mipstx39el
+	xbox)
+		basic_machine=i686-pc
+		os=-mingw32
 		;;
-	x64-*)
-		cpu=x86_64
+	xps | xps100)
+		basic_machine=xps100-honeywell
 		;;
 	xscale-* | xscalee[bl]-*)
-		cpu=`echo "$cpu" | sed 's/^xscale/arm/'`
+		basic_machine=`echo "$basic_machine" | sed 's/^xscale/arm/'`
+		;;
+	ymp)
+		basic_machine=ymp-cray
+		os=-unicos
+		;;
+	none)
+		basic_machine=none-none
+		os=-none
 		;;
 
-	# Recognize the cannonical CPU Types that limit and/or modify the
-	# company names they are paired with.
-	cr16-*)
-		os=${os:-elf}
+# Here we handle the default manufacturer of certain CPU types.  It is in
+# some cases the only manufacturer, in others, it is the most popular.
+	w89k)
+		basic_machine=hppa1.1-winbond
 		;;
-	crisv32-* | etraxfs*-*)
-		cpu=crisv32
-		vendor=axis
+	op50n)
+		basic_machine=hppa1.1-oki
 		;;
-	cris-* | etrax*-*)
-		cpu=cris
-		vendor=axis
+	op60c)
+		basic_machine=hppa1.1-oki
 		;;
-	crx-*)
-		os=${os:-elf}
+	romp)
+		basic_machine=romp-ibm
 		;;
-	neo-tandem)
-		cpu=neo
-		vendor=tandem
+	mmix)
+		basic_machine=mmix-knuth
 		;;
-	nse-tandem)
-		cpu=nse
-		vendor=tandem
+	rs6000)
+		basic_machine=rs6000-ibm
 		;;
-	nsr-tandem)
-		cpu=nsr
-		vendor=tandem
+	vax)
+		basic_machine=vax-dec
 		;;
-	nsv-tandem)
-		cpu=nsv
-		vendor=tandem
+	pdp11)
+		basic_machine=pdp11-dec
 		;;
-	nsx-tandem)
-		cpu=nsx
-		vendor=tandem
+	we32k)
+		basic_machine=we32k-att
 		;;
-	s390-*)
-		cpu=s390
-		vendor=ibm
-		;;
-	s390x-*)
-		cpu=s390x
-		vendor=ibm
+	sh[1234] | sh[24]a | sh[24]aeb | sh[34]eb | sh[1234]le | sh[23]ele)
+		basic_machine=sh-unknown
 		;;
-	tile*-*)
-		os=${os:-linux-gnu}
+	cydra)
+		basic_machine=cydra-cydrome
+		;;
+	orion)
+		basic_machine=orion-highlevel
+		;;
+	orion105)
+		basic_machine=clipper-highlevel
+		;;
+	mac | mpw | mac-mpw)
+		basic_machine=m68k-apple
+		;;
+	pmac | pmac-mpw)
+		basic_machine=powerpc-apple
+		;;
+	*-unknown)
+		# Make sure to match an already-canonicalized machine name.
 		;;
-
 	*)
-		# Recognize the cannonical CPU types that are allowed with any
-		# company name.
-		case $cpu in
-			1750a | 580 \
-			| a29k \
-			| aarch64 | aarch64_be \
-			| abacus \
-			| alpha | alphaev[4-8] | alphaev56 | alphaev6[78] \
-			| alpha64 | alpha64ev[4-8] | alpha64ev56 | alpha64ev6[78] \
-			| alphapca5[67] | alpha64pca5[67] \
-			| am33_2.0 \
-			| arc | arceb \
-			| arm  | arm[lb]e | arme[lb] | armv* \
-			| avr | avr32 \
-			| asmjs \
-			| ba \
-			| be32 | be64 \
-			| bfin | bs2000 \
-			| c[123]* | c30 | [cjt]90 | c4x \
-			| c8051 | clipper | craynv | csky | cydra \
-			| d10v | d30v | dlx | dsp16xx \
-			| e2k | elxsi | epiphany \
-			| f30[01] | f700 | fido | fr30 | frv | ft32 | fx80 \
-			| h8300 | h8500 \
-			| hppa | hppa1.[01] | hppa2.0 | hppa2.0[nw] | hppa64 \
-			| hexagon \
-			| i370 | i*86 | i860 | i960 | ia16 | ia64 \
-			| ip2k | iq2000 \
-			| k1om \
-			| le32 | le64 \
-			| lm32 \
-			| m32c | m32r | m32rle \
-			| m5200 | m68000 | m680[012346]0 | m68360 | m683?2 | m68k | v70 | w65 \
-			| m6811 | m68hc11 | m6812 | m68hc12 | m68hcs12x | nvptx | picochip \
-			| m88110 | m88k | maxq | mb | mcore | mep | metag \
-			| microblaze | microblazeel \
-			| mips | mipsbe | mipseb | mipsel | mipsle \
-			| mips16 \
-			| mips64 | mips64el \
-			| mips64octeon | mips64octeonel \
-			| mips64orion | mips64orionel \
-			| mips64r5900 | mips64r5900el \
-			| mips64vr | mips64vrel \
-			| mips64vr4100 | mips64vr4100el \
-			| mips64vr4300 | mips64vr4300el \
-			| mips64vr5000 | mips64vr5000el \
-			| mips64vr5900 | mips64vr5900el \
-			| mipsisa32 | mipsisa32el \
-			| mipsisa32r2 | mipsisa32r2el \
-			| mipsisa32r6 | mipsisa32r6el \
-			| mipsisa64 | mipsisa64el \
-			| mipsisa64r2 | mipsisa64r2el \
-			| mipsisa64r6 | mipsisa64r6el \
-			| mipsisa64sb1 | mipsisa64sb1el \
-			| mipsisa64sr71k | mipsisa64sr71kel \
-			| mipsr5900 | mipsr5900el \
-			| mipstx39 | mipstx39el \
-			| mmix \
-			| mn10200 | mn10300 \
-			| moxie \
-			| mt \
-			| msp430 \
-			| nds32 | nds32le | nds32be \
-			| nfp \
-			| nios | nios2 | nios2eb | nios2el \
-			| none | np1 | ns16k | ns32k \
-			| open8 \
-			| or1k* \
-			| or32 \
-			| orion \
-			| pdp10 | pdp11 | pj | pjl | pn | power \
-			| powerpc | powerpc64 | powerpc64le | powerpcle | powerpcspe \
-			| pru \
-			| pyramid \
-			| riscv | riscv32 | riscv64 \
-			| rl78 | romp | rs6000 | rx \
-			| score \
-			| sh | sh[1234] | sh[24]a | sh[24]ae[lb] | sh[23]e | she[lb] | sh[lb]e \
-			| sh[1234]e[lb] |  sh[12345][lb]e | sh[23]ele | sh64 | sh64le \
-			| sparc | sparc64 | sparc64b | sparc64v | sparc86x | sparclet \
-			| sparclite \
-			| sparcv8 | sparcv9 | sparcv9b | sparcv9v | sv1 | sx* \
-			| spu \
-			| tahoe \
-			| tic30 | tic4x | tic54x | tic55x | tic6x | tic80 \
-			| tron \
-			| ubicom32 \
-			| v850 | v850e | v850e1 | v850es | v850e2 | v850e2v3 \
-			| vax \
-			| visium \
-			| wasm32 \
-			| we32k \
-			| x86 | x86_64 | xc16x | xgate | xps100 \
-			| xstormy16 | xtensa* \
-			| ymp \
-			| z8k | z80)
-				;;
-
-			*)
-				echo Invalid configuration \`"$1"\': machine \`"$cpu-$vendor"\' not recognized 1>&2
-				exit 1
-				;;
-		esac
+		echo Invalid configuration \`"$1"\': machine \`"$basic_machine"\' not recognized 1>&2
+		exit 1
 		;;
 esac
 
 # Here we canonicalize certain aliases for manufacturers.
-case $vendor in
-	digital*)
-		vendor=dec
+case $basic_machine in
+	*-digital*)
+		basic_machine=`echo "$basic_machine" | sed 's/digital.*/dec/'`
 		;;
-	commodore*)
-		vendor=cbm
+	*-commodore*)
+		basic_machine=`echo "$basic_machine" | sed 's/commodore.*/cbm/'`
 		;;
 	*)
 		;;
@@ -1275,240 +1365,200 @@ then
 case $os in
 	# First match some system type aliases that might get confused
 	# with valid system types.
-	# solaris* is a basic system type, with this one exception.
-	auroraux)
-		os=auroraux
+	# -solaris* is a basic system type, with this one exception.
+	-auroraux)
+		os=-auroraux
 		;;
-	bluegene*)
-		os=cnk
-		;;
-	solaris1 | solaris1.*)
+	-solaris1 | -solaris1.*)
 		os=`echo $os | sed -e 's|solaris1|sunos4|'`
 		;;
-	solaris)
-		os=solaris2
+	-solaris)
+		os=-solaris2
 		;;
-	unixware*)
-		os=sysv4.2uw
+	-unixware*)
+		os=-sysv4.2uw
 		;;
-	gnu/linux*)
+	-gnu/linux*)
 		os=`echo $os | sed -e 's|gnu/linux|linux-gnu|'`
 		;;
 	# es1800 is here to avoid being matched by es* (a different OS)
-	es1800*)
-		os=ose
-		;;
-	# Some version numbers need modification
-	chorusos*)
-		os=chorusos
-		;;
-	isc)
-		os=isc2.2
-		;;
-	sco6)
-		os=sco5v6
-		;;
-	sco5)
-		os=sco3.2v5
-		;;
-	sco4)
-		os=sco3.2v4
-		;;
-	sco3.2.[4-9]*)
-		os=`echo $os | sed -e 's/sco3.2./sco3.2v/'`
-		;;
-	sco3.2v[4-9]* | sco5v6*)
-		# Don't forget version if it is 3.2v4 or newer.
-		;;
-	scout)
-		# Don't match below
-		;;
-	sco*)
-		os=sco3.2v2
-		;;
-	psos*)
-		os=psos
+	-es1800*)
+		os=-ose
 		;;
 	# Now accept the basic system types.
 	# The portable systems comes first.
 	# Each alternative MUST end in a * to match a version number.
-	# sysv* is not here because it comes later, after sysvr4.
-	gnu* | bsd* | mach* | minix* | genix* | ultrix* | irix* \
-	     | *vms* | esix* | aix* | cnk* | sunos | sunos[34]*\
-	     | hpux* | unos* | osf* | luna* | dgux* | auroraux* | solaris* \
-	     | sym* | kopensolaris* | plan9* \
-	     | amigaos* | amigados* | msdos* | newsos* | unicos* | aof* \
-	     | aos* | aros* | cloudabi* | sortix* \
-	     | nindy* | vxsim* | vxworks* | ebmon* | hms* | mvs* \
-	     | clix* | riscos* | uniplus* | iris* | isc* | rtu* | xenix* \
-	     | knetbsd* | mirbsd* | netbsd* \
-	     | bitrig* | openbsd* | solidbsd* | libertybsd* \
-	     | ekkobsd* | kfreebsd* | freebsd* | riscix* | lynxos* \
-	     | bosx* | nextstep* | cxux* | aout* | elf* | oabi* \
-	     | ptx* | coff* | ecoff* | winnt* | domain* | vsta* \
-	     | udi* | eabi* | lites* | ieee* | go32* | aux* | hcos* \
-	     | chorusrdb* | cegcc* | glidix* \
-	     | cygwin* | msys* | pe* | moss* | proelf* | rtems* \
-	     | midipix* | mingw32* | mingw64* | linux-gnu* | linux-android* \
-	     | linux-newlib* | linux-musl* | linux-uclibc* \
-	     | uxpv* | beos* | mpeix* | udk* | moxiebox* \
-	     | interix* | uwin* | mks* | rhapsody* | darwin* \
-	     | openstep* | oskit* | conix* | pw32* | nonstopux* \
-	     | storm-chaos* | tops10* | tenex* | tops20* | its* \
-	     | os2* | vos* | palmos* | uclinux* | nucleus* \
-	     | morphos* | superux* | rtmk* | windiss* \
-	     | powermax* | dnix* | nx6 | nx7 | sei* | dragonfly* \
-	     | skyos* | haiku* | rdos* | toppers* | drops* | es* \
-	     | onefs* | tirtos* | phoenix* | fuchsia* | redox* | bme* \
-	     | midnightbsd*)
+	# -sysv* is not here because it comes later, after sysvr4.
+	-gnu* | -bsd* | -mach* | -minix* | -genix* | -ultrix* | -irix* \
+	      | -*vms* | -sco* | -esix* | -isc* | -aix* | -cnk* | -sunos | -sunos[34]*\
+	      | -hpux* | -unos* | -osf* | -luna* | -dgux* | -auroraux* | -solaris* \
+	      | -sym* | -kopensolaris* | -plan9* \
+	      | -amigaos* | -amigados* | -msdos* | -newsos* | -unicos* | -aof* \
+	      | -aos* | -aros* | -cloudabi* | -sortix* \
+	      | -nindy* | -vxsim* | -vxworks* | -ebmon* | -hms* | -mvs* \
+	      | -clix* | -riscos* | -uniplus* | -iris* | -rtu* | -xenix* \
+	      | -hiux* | -knetbsd* | -mirbsd* | -netbsd* \
+	      | -bitrig* | -openbsd* | -solidbsd* | -libertybsd* \
+	      | -ekkobsd* | -kfreebsd* | -freebsd* | -riscix* | -lynxos* \
+	      | -bosx* | -nextstep* | -cxux* | -aout* | -elf* | -oabi* \
+	      | -ptx* | -coff* | -ecoff* | -winnt* | -domain* | -vsta* \
+	      | -udi* | -eabi* | -lites* | -ieee* | -go32* | -aux* | -hcos* \
+	      | -chorusos* | -chorusrdb* | -cegcc* | -glidix* \
+	      | -cygwin* | -msys* | -pe* | -psos* | -moss* | -proelf* | -rtems* \
+	      | -midipix* | -mingw32* | -mingw64* | -linux-gnu* | -linux-android* \
+	      | -linux-newlib* | -linux-musl* | -linux-uclibc* \
+	      | -uxpv* | -beos* | -mpeix* | -udk* | -moxiebox* \
+	      | -interix* | -uwin* | -mks* | -rhapsody* | -darwin* \
+	      | -openstep* | -oskit* | -conix* | -pw32* | -nonstopux* \
+	      | -storm-chaos* | -tops10* | -tenex* | -tops20* | -its* \
+	      | -os2* | -vos* | -palmos* | -uclinux* | -nucleus* \
+	      | -morphos* | -superux* | -rtmk* | -windiss* \
+	      | -powermax* | -dnix* | -nx6 | -nx7 | -sei* | -dragonfly* \
+	      | -skyos* | -haiku* | -rdos* | -toppers* | -drops* | -es* \
+	      | -onefs* | -tirtos* | -phoenix* | -fuchsia* | -redox* | -bme* \
+	      | -midnightbsd*)
 	# Remember, each alternative MUST END IN *, to match a version number.
 		;;
-	qnx*)
-		case $cpu in
-		    x86 | i*86)
+	-qnx*)
+		case $basic_machine in
+		    x86-* | i*86-*)
 			;;
 		    *)
-			os=nto-$os
+			os=-nto$os
 			;;
 		esac
 		;;
-	hiux*)
-		os=hiuxwe2
+	-nto-qnx*)
 		;;
-	nto-qnx*)
-		;;
-	nto*)
+	-nto*)
 		os=`echo $os | sed -e 's|nto|nto-qnx|'`
 		;;
-	sim | xray | os68k* | v88r* \
-	    | windows* | osx | abug | netware* | os9* \
-	    | macos* | mpw* | magic* | mmixware* | mon960* | lnews*)
-		;;
-	linux-dietlibc)
-		os=linux-dietlibc
-		;;
-	linux*)
-		os=`echo $os | sed -e 's|linux|linux-gnu|'`
+	-sim | -xray | -os68k* | -v88r* \
+	      | -windows* | -osx | -abug | -netware* | -os9* \
+	      | -macos* | -mpw* | -magic* | -mmixware* | -mon960* | -lnews*)
 		;;
-	lynx*178)
-		os=lynxos178
-		;;
-	lynx*5)
-		os=lynxos5
-		;;
-	lynx*)
-		os=lynxos
-		;;
-	mac*)
+	-mac*)
 		os=`echo "$os" | sed -e 's|mac|macos|'`
 		;;
-	opened*)
-		os=openedition
+	-linux-dietlibc)
+		os=-linux-dietlibc
 		;;
-	os400*)
-		os=os400
+	-linux*)
+		os=`echo $os | sed -e 's|linux|linux-gnu|'`
 		;;
-	sunos5*)
+	-sunos5*)
 		os=`echo "$os" | sed -e 's|sunos5|solaris2|'`
 		;;
-	sunos6*)
+	-sunos6*)
 		os=`echo "$os" | sed -e 's|sunos6|solaris3|'`
 		;;
-	wince*)
-		os=wince
+	-opened*)
+		os=-openedition
 		;;
-	utek*)
-		os=bsd
+	-os400*)
+		os=-os400
 		;;
-	dynix*)
-		os=bsd
+	-wince*)
+		os=-wince
 		;;
-	acis*)
-		os=aos
+	-utek*)
+		os=-bsd
 		;;
-	atheos*)
-		os=atheos
+	-dynix*)
+		os=-bsd
 		;;
-	syllable*)
-		os=syllable
+	-acis*)
+		os=-aos
 		;;
-	386bsd)
-		os=bsd
+	-atheos*)
+		os=-atheos
+		;;
+	-syllable*)
+		os=-syllable
 		;;
-	ctix* | uts*)
-		os=sysv
+	-386bsd)
+		os=-bsd
 		;;
-	nova*)
-		os=rtmk-nova
+	-ctix* | -uts*)
+		os=-sysv
 		;;
-	ns2)
-		os=nextstep2
+	-nova*)
+		os=-rtmk-nova
 		;;
-	nsk*)
-		os=nsk
+	-ns2)
+		os=-nextstep2
+		;;
+	-nsk*)
+		os=-nsk
 		;;
 	# Preserve the version number of sinix5.
-	sinix5.*)
+	-sinix5.*)
 		os=`echo $os | sed -e 's|sinix|sysv|'`
 		;;
-	sinix*)
-		os=sysv4
+	-sinix*)
+		os=-sysv4
 		;;
-	tpf*)
-		os=tpf
+	-tpf*)
+		os=-tpf
 		;;
-	triton*)
-		os=sysv3
+	-triton*)
+		os=-sysv3
 		;;
-	oss*)
-		os=sysv3
+	-oss*)
+		os=-sysv3
 		;;
-	svr4*)
-		os=sysv4
+	-svr4*)
+		os=-sysv4
 		;;
-	svr3)
-		os=sysv3
+	-svr3)
+		os=-sysv3
 		;;
-	sysvr4)
-		os=sysv4
+	-sysvr4)
+		os=-sysv4
 		;;
-	# This must come after sysvr4.
-	sysv*)
+	# This must come after -sysvr4.
+	-sysv*)
 		;;
-	ose*)
-		os=ose
+	-ose*)
+		os=-ose
 		;;
-	*mint | mint[0-9]* | *MiNT | MiNT[0-9]*)
-		os=mint
+	-*mint | -mint[0-9]* | -*MiNT | -MiNT[0-9]*)
+		os=-mint
 		;;
-	zvmoe)
-		os=zvmoe
+	-zvmoe)
+		os=-zvmoe
 		;;
-	dicos*)
-		os=dicos
+	-dicos*)
+		os=-dicos
 		;;
-	pikeos*)
+	-pikeos*)
 		# Until real need of OS specific support for
 		# particular features comes up, bare metal
 		# configurations are quite functional.
-		case $cpu in
+		case $basic_machine in
 		    arm*)
-			os=eabi
+			os=-eabi
 			;;
 		    *)
-			os=elf
+			os=-elf
 			;;
 		esac
 		;;
-	nacl*)
+	-nacl*)
 		;;
-	ios)
+	-ios)
 		;;
-	none)
+	-none)
 		;;
-	*-eabi)
+	-*-eabi)
+		case $basic_machine in
+		    arm*)
+			;;
+		esac
 		;;
 	*)
+		# Get rid of the `-' at the beginning of $os.
+		os=`echo $os | sed 's/[^-]*-//'`
 		echo Invalid configuration \`"$1"\': system \`"$os"\' not recognized 1>&2
 		exit 1
 		;;
@@ -1525,261 +1575,254 @@ else
 # will signal an error saying that MANUFACTURER isn't an operating
 # system, and we'll never get to this point.
 
-case $cpu-$vendor in
+case $basic_machine in
 	score-*)
-		os=elf
+		os=-elf
 		;;
 	spu-*)
-		os=elf
+		os=-elf
 		;;
 	*-acorn)
-		os=riscix1.2
+		os=-riscix1.2
 		;;
 	arm*-rebel)
-		os=linux
+		os=-linux
 		;;
 	arm*-semi)
-		os=aout
+		os=-aout
 		;;
 	c4x-* | tic4x-*)
-		os=coff
+		os=-coff
 		;;
 	c8051-*)
-		os=elf
-		;;
-	clipper-intergraph)
-		os=clix
+		os=-elf
 		;;
 	hexagon-*)
-		os=elf
+		os=-elf
 		;;
 	tic54x-*)
-		os=coff
+		os=-coff
 		;;
 	tic55x-*)
-		os=coff
+		os=-coff
 		;;
 	tic6x-*)
-		os=coff
+		os=-coff
 		;;
 	# This must come before the *-dec entry.
 	pdp10-*)
-		os=tops20
+		os=-tops20
 		;;
 	pdp11-*)
-		os=none
+		os=-none
 		;;
 	*-dec | vax-*)
-		os=ultrix4.2
+		os=-ultrix4.2
 		;;
 	m68*-apollo)
-		os=domain
+		os=-domain
 		;;
 	i386-sun)
-		os=sunos4.0.2
+		os=-sunos4.0.2
 		;;
 	m68000-sun)
-		os=sunos3
+		os=-sunos3
 		;;
 	m68*-cisco)
-		os=aout
+		os=-aout
 		;;
 	mep-*)
-		os=elf
+		os=-elf
 		;;
 	mips*-cisco)
-		os=elf
+		os=-elf
 		;;
 	mips*-*)
-		os=elf
+		os=-elf
 		;;
 	or32-*)
-		os=coff
+		os=-coff
 		;;
 	*-tti)	# must be before sparc entry or we get the wrong os.
-		os=sysv3
+		os=-sysv3
 		;;
 	sparc-* | *-sun)
-		os=sunos4.1.1
+		os=-sunos4.1.1
 		;;
 	pru-*)
-		os=elf
+		os=-elf
 		;;
 	*-be)
-		os=beos
+		os=-beos
 		;;
 	*-ibm)
-		os=aix
+		os=-aix
 		;;
 	*-knuth)
-		os=mmixware
+		os=-mmixware
 		;;
 	*-wec)
-		os=proelf
+		os=-proelf
 		;;
 	*-winbond)
-		os=proelf
+		os=-proelf
 		;;
 	*-oki)
-		os=proelf
+		os=-proelf
 		;;
 	*-hp)
-		os=hpux
+		os=-hpux
 		;;
 	*-hitachi)
-		os=hiux
+		os=-hiux
 		;;
 	i860-* | *-att | *-ncr | *-altos | *-motorola | *-convergent)
-		os=sysv
+		os=-sysv
 		;;
 	*-cbm)
-		os=amigaos
+		os=-amigaos
 		;;
 	*-dg)
-		os=dgux
+		os=-dgux
 		;;
 	*-dolphin)
-		os=sysv3
+		os=-sysv3
 		;;
 	m68k-ccur)
-		os=rtu
+		os=-rtu
 		;;
 	m88k-omron*)
-		os=luna
+		os=-luna
 		;;
 	*-next)
-		os=nextstep
+		os=-nextstep
 		;;
 	*-sequent)
-		os=ptx
+		os=-ptx
 		;;
 	*-crds)
-		os=unos
+		os=-unos
 		;;
 	*-ns)
-		os=genix
+		os=-genix
 		;;
 	i370-*)
-		os=mvs
+		os=-mvs
 		;;
 	*-gould)
-		os=sysv
+		os=-sysv
 		;;
 	*-highlevel)
-		os=bsd
+		os=-bsd
 		;;
 	*-encore)
-		os=bsd
+		os=-bsd
 		;;
 	*-sgi)
-		os=irix
+		os=-irix
 		;;
 	*-siemens)
-		os=sysv4
+		os=-sysv4
 		;;
 	*-masscomp)
-		os=rtu
+		os=-rtu
 		;;
 	f30[01]-fujitsu | f700-fujitsu)
-		os=uxpv
+		os=-uxpv
 		;;
 	*-rom68k)
-		os=coff
+		os=-coff
 		;;
 	*-*bug)
-		os=coff
+		os=-coff
 		;;
 	*-apple)
-		os=macos
+		os=-macos
 		;;
 	*-atari*)
-		os=mint
-		;;
-	*-wrs)
-		os=vxworks
+		os=-mint
 		;;
 	*)
-		os=none
+		os=-none
 		;;
 esac
 fi
 
 # Here we handle the case where we know the os, and the CPU type, but not the
 # manufacturer.  We pick the logical manufacturer.
-case $vendor in
-	unknown)
+vendor=unknown
+case $basic_machine in
+	*-unknown)
 		case $os in
-			riscix*)
+			-riscix*)
 				vendor=acorn
 				;;
-			sunos*)
+			-sunos*)
 				vendor=sun
 				;;
-			cnk*|-aix*)
+			-cnk*|-aix*)
 				vendor=ibm
 				;;
-			beos*)
+			-beos*)
 				vendor=be
 				;;
-			hpux*)
+			-hpux*)
 				vendor=hp
 				;;
-			mpeix*)
+			-mpeix*)
 				vendor=hp
 				;;
-			hiux*)
+			-hiux*)
 				vendor=hitachi
 				;;
-			unos*)
+			-unos*)
 				vendor=crds
 				;;
-			dgux*)
+			-dgux*)
 				vendor=dg
 				;;
-			luna*)
+			-luna*)
 				vendor=omron
 				;;
-			genix*)
+			-genix*)
 				vendor=ns
 				;;
-			clix*)
-				vendor=intergraph
-				;;
-			mvs* | opened*)
+			-mvs* | -opened*)
 				vendor=ibm
 				;;
-			os400*)
+			-os400*)
 				vendor=ibm
 				;;
-			ptx*)
+			-ptx*)
 				vendor=sequent
 				;;
-			tpf*)
+			-tpf*)
 				vendor=ibm
 				;;
-			vxsim* | vxworks* | windiss*)
+			-vxsim* | -vxworks* | -windiss*)
 				vendor=wrs
 				;;
-			aux*)
+			-aux*)
 				vendor=apple
 				;;
-			hms*)
+			-hms*)
 				vendor=hitachi
 				;;
-			mpw* | macos*)
+			-mpw* | -macos*)
 				vendor=apple
 				;;
-			*mint | mint[0-9]* | *MiNT | MiNT[0-9]*)
+			-*mint | -mint[0-9]* | -*MiNT | -MiNT[0-9]*)
 				vendor=atari
 				;;
-			vos*)
+			-vos*)
 				vendor=stratus
 				;;
 		esac
+		basic_machine=`echo "$basic_machine" | sed "s/unknown/$vendor/"`
 		;;
 esac
 
-echo "$cpu-$vendor-$os"
+echo "$basic_machine$os"
 exit
 
 # Local variables:
diff -pruN 0.14.1+dfsg-1/libocispec/build-aux/ltmain.sh 0.15+dfsg-1/libocispec/build-aux/ltmain.sh
--- 0.14.1+dfsg-1/libocispec/build-aux/ltmain.sh	2020-07-08 06:49:59.000000000 +0000
+++ 0.15+dfsg-1/libocispec/build-aux/ltmain.sh	2020-09-23 14:48:50.000000000 +0000
@@ -2124,7 +2124,7 @@ fi
 # a configuration failure hint, and exit.
 func_fatal_configuration ()
 {
-    func_fatal_error ${1+"$@"} \
+    func__fatal_error ${1+"$@"} \
       "See the $PACKAGE documentation for more information." \
       "Fatal configuration error."
 }
diff -pruN 0.14.1+dfsg-1/libocispec/Makefile.am 0.15+dfsg-1/libocispec/Makefile.am
--- 0.14.1+dfsg-1/libocispec/Makefile.am	2020-06-18 12:41:03.000000000 +0000
+++ 0.15+dfsg-1/libocispec/Makefile.am	2020-09-03 12:13:17.000000000 +0000
@@ -94,6 +94,9 @@ tests_test_7_LDADD = $(TESTS_LDADD)
 tests_test_8_SOURCES = tests/test-8.c
 tests_test_8_LDADD = $(TESTS_LDADD)
 
+tests_test_9_SOURCES = tests/test-9.c
+tests_test_9_LDADD = $(TESTS_LDADD)
+
 src_validate_SOURCES = src/validate.c
 src_validate_LDADD = $(TESTS_LDADD)
 
@@ -104,7 +107,8 @@ TESTS = tests/test-1 \
 	tests/test-5 \
 	tests/test-6 \
 	tests/test-7 \
-	tests/test-8
+	tests/test-8 \
+	tests/test-9
 
 noinst_PROGRAMS = src/validate $(TESTS)
 
@@ -124,6 +128,7 @@ EXTRA_DIST = autogen.sh \
 	tests/data/image_config.json \
 	tests/data/config.nocwd.json \
 	tests/data/image_manifest_item.json \
+	tests/data/residual_image_layout_config.json \
 	tests/test-spec \
 	src/generate.py \
 	src/common_c.py \
diff -pruN 0.14.1+dfsg-1/libocispec/Makefile.in 0.15+dfsg-1/libocispec/Makefile.in
--- 0.14.1+dfsg-1/libocispec/Makefile.in	2020-07-08 06:50:01.000000000 +0000
+++ 0.15+dfsg-1/libocispec/Makefile.in	2020-09-23 14:48:53.000000000 +0000
@@ -93,7 +93,8 @@ host_triplet = @host@
 TESTS = tests/test-1$(EXEEXT) tests/test-2$(EXEEXT) \
 	tests/test-3$(EXEEXT) tests/test-4$(EXEEXT) \
 	tests/test-5$(EXEEXT) tests/test-6$(EXEEXT) \
-	tests/test-7$(EXEEXT) tests/test-8$(EXEEXT)
+	tests/test-7$(EXEEXT) tests/test-8$(EXEEXT) \
+	tests/test-9$(EXEEXT)
 noinst_PROGRAMS = src/validate$(EXEEXT) $(am__EXEEXT_1)
 subdir = .
 ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
@@ -114,7 +115,8 @@ CONFIG_CLEAN_VPATH_FILES =
 am__EXEEXT_1 = tests/test-1$(EXEEXT) tests/test-2$(EXEEXT) \
 	tests/test-3$(EXEEXT) tests/test-4$(EXEEXT) \
 	tests/test-5$(EXEEXT) tests/test-6$(EXEEXT) \
-	tests/test-7$(EXEEXT) tests/test-8$(EXEEXT)
+	tests/test-7$(EXEEXT) tests/test-8$(EXEEXT) \
+	tests/test-9$(EXEEXT)
 PROGRAMS = $(noinst_PROGRAMS)
 LIBRARIES = $(noinst_LIBRARIES)
 LTLIBRARIES = $(noinst_LTLIBRARIES)
@@ -183,6 +185,9 @@ tests_test_7_DEPENDENCIES = $(am__DEPEND
 am_tests_test_8_OBJECTS = tests/test-8.$(OBJEXT)
 tests_test_8_OBJECTS = $(am_tests_test_8_OBJECTS)
 tests_test_8_DEPENDENCIES = $(am__DEPENDENCIES_2)
+am_tests_test_9_OBJECTS = tests/test-9.$(OBJEXT)
+tests_test_9_OBJECTS = $(am_tests_test_9_OBJECTS)
+tests_test_9_DEPENDENCIES = $(am__DEPENDENCIES_2)
 AM_V_P = $(am__v_P_@AM_V@)
 am__v_P_ = $(am__v_P_@AM_DEFAULT_V@)
 am__v_P_0 = false
@@ -221,7 +226,7 @@ am__depfiles_remade = src/$(DEPDIR)/imag
 	tests/$(DEPDIR)/test-2.Po tests/$(DEPDIR)/test-3.Po \
 	tests/$(DEPDIR)/test-4.Po tests/$(DEPDIR)/test-5.Po \
 	tests/$(DEPDIR)/test-6.Po tests/$(DEPDIR)/test-7.Po \
-	tests/$(DEPDIR)/test-8.Po
+	tests/$(DEPDIR)/test-8.Po tests/$(DEPDIR)/test-9.Po
 am__mv = mv -f
 COMPILE = $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) \
 	$(CPPFLAGS) $(AM_CFLAGS) $(CFLAGS)
@@ -246,13 +251,13 @@ SOURCES = $(libocispec_a_SOURCES) $(libo
 	$(tests_test_2_SOURCES) $(tests_test_3_SOURCES) \
 	$(tests_test_4_SOURCES) $(tests_test_5_SOURCES) \
 	$(tests_test_6_SOURCES) $(tests_test_7_SOURCES) \
-	$(tests_test_8_SOURCES)
+	$(tests_test_8_SOURCES) $(tests_test_9_SOURCES)
 DIST_SOURCES = $(libocispec_a_SOURCES) $(libocispec_la_SOURCES) \
 	$(src_validate_SOURCES) $(tests_test_1_SOURCES) \
 	$(tests_test_2_SOURCES) $(tests_test_3_SOURCES) \
 	$(tests_test_4_SOURCES) $(tests_test_5_SOURCES) \
 	$(tests_test_6_SOURCES) $(tests_test_7_SOURCES) \
-	$(tests_test_8_SOURCES)
+	$(tests_test_8_SOURCES) $(tests_test_9_SOURCES)
 am__can_run_installinfo = \
   case $$AM_UPDATE_INFO_DIR in \
     n|no|NO) false;; \
@@ -696,6 +701,8 @@ tests_test_7_SOURCES = tests/test-7.c
 tests_test_7_LDADD = $(TESTS_LDADD)
 tests_test_8_SOURCES = tests/test-8.c
 tests_test_8_LDADD = $(TESTS_LDADD)
+tests_test_9_SOURCES = tests/test-9.c
+tests_test_9_LDADD = $(TESTS_LDADD)
 src_validate_SOURCES = src/validate.c
 src_validate_LDADD = $(TESTS_LDADD)
 EXTRA_DIST = autogen.sh \
@@ -707,6 +714,7 @@ EXTRA_DIST = autogen.sh \
 	tests/data/image_config.json \
 	tests/data/config.nocwd.json \
 	tests/data/image_manifest_item.json \
+	tests/data/residual_image_layout_config.json \
 	tests/test-spec \
 	src/generate.py \
 	src/common_c.py \
@@ -903,6 +911,12 @@ tests/test-8.$(OBJEXT): tests/$(am__dirs
 tests/test-8$(EXEEXT): $(tests_test_8_OBJECTS) $(tests_test_8_DEPENDENCIES) $(EXTRA_tests_test_8_DEPENDENCIES) tests/$(am__dirstamp)
 	@rm -f tests/test-8$(EXEEXT)
 	$(AM_V_CCLD)$(LINK) $(tests_test_8_OBJECTS) $(tests_test_8_LDADD) $(LIBS)
+tests/test-9.$(OBJEXT): tests/$(am__dirstamp) \
+	tests/$(DEPDIR)/$(am__dirstamp)
+
+tests/test-9$(EXEEXT): $(tests_test_9_OBJECTS) $(tests_test_9_DEPENDENCIES) $(EXTRA_tests_test_9_DEPENDENCIES) tests/$(am__dirstamp)
+	@rm -f tests/test-9$(EXEEXT)
+	$(AM_V_CCLD)$(LINK) $(tests_test_9_OBJECTS) $(tests_test_9_LDADD) $(LIBS)
 
 mostlyclean-compile:
 	-rm -f *.$(OBJEXT)
@@ -942,6 +956,7 @@ distclean-compile:
 @AMDEP_TRUE@@am__include@ @am__quote@tests/$(DEPDIR)/test-6.Po@am__quote@ # am--include-marker
 @AMDEP_TRUE@@am__include@ @am__quote@tests/$(DEPDIR)/test-7.Po@am__quote@ # am--include-marker
 @AMDEP_TRUE@@am__include@ @am__quote@tests/$(DEPDIR)/test-8.Po@am__quote@ # am--include-marker
+@AMDEP_TRUE@@am__include@ @am__quote@tests/$(DEPDIR)/test-9.Po@am__quote@ # am--include-marker
 
 $(am__depfiles_remade):
 	@$(MKDIR_P) $(@D)
@@ -1240,6 +1255,13 @@ tests/test-8.log: tests/test-8$(EXEEXT)
 	--log-file $$b.log --trs-file $$b.trs \
 	$(am__common_driver_flags) $(AM_LOG_DRIVER_FLAGS) $(LOG_DRIVER_FLAGS) -- $(LOG_COMPILE) \
 	"$$tst" $(AM_TESTS_FD_REDIRECT)
+tests/test-9.log: tests/test-9$(EXEEXT)
+	@p='tests/test-9$(EXEEXT)'; \
+	b='tests/test-9'; \
+	$(am__check_pre) $(LOG_DRIVER) --test-name "$$f" \
+	--log-file $$b.log --trs-file $$b.trs \
+	$(am__common_driver_flags) $(AM_LOG_DRIVER_FLAGS) $(LOG_DRIVER_FLAGS) -- $(LOG_COMPILE) \
+	"$$tst" $(AM_TESTS_FD_REDIRECT)
 .test.log:
 	@p='$<'; \
 	$(am__set_b); \
@@ -1502,6 +1524,7 @@ distclean: distclean-am
 	-rm -f tests/$(DEPDIR)/test-6.Po
 	-rm -f tests/$(DEPDIR)/test-7.Po
 	-rm -f tests/$(DEPDIR)/test-8.Po
+	-rm -f tests/$(DEPDIR)/test-9.Po
 	-rm -f Makefile
 distclean-am: clean-am distclean-compile distclean-generic \
 	distclean-hdr distclean-libtool distclean-tags
@@ -1578,6 +1601,7 @@ maintainer-clean: maintainer-clean-am
 	-rm -f tests/$(DEPDIR)/test-6.Po
 	-rm -f tests/$(DEPDIR)/test-7.Po
 	-rm -f tests/$(DEPDIR)/test-8.Po
+	-rm -f tests/$(DEPDIR)/test-9.Po
 	-rm -f Makefile
 maintainer-clean-am: distclean-am maintainer-clean-generic
 
diff -pruN 0.14.1+dfsg-1/libocispec/src/common_c.py 0.15+dfsg-1/libocispec/src/common_c.py
--- 0.14.1+dfsg-1/libocispec/src/common_c.py	2020-06-18 12:41:03.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/common_c.py	2020-09-03 12:13:17.000000000 +0000
@@ -54,6 +54,117 @@ def generate_json_common_c(out):
 
 # define MAX_NUM_STR_LEN 21
 
+static yajl_gen_status gen_yajl_val (yajl_val obj, yajl_gen g, parser_error *err);
+
+static yajl_gen_status gen_yajl_val_obj (yajl_val obj, yajl_gen g, parser_error *err)
+{
+    size_t i;
+    yajl_gen_status stat = yajl_gen_status_ok;
+
+    stat = yajl_gen_map_open (g);
+    if (yajl_gen_status_ok != stat)
+        GEN_SET_ERROR_AND_RETURN (stat, err);
+
+    for (i = 0; i < obj->u.object.len; i++)
+    {
+        stat = yajl_gen_string (g, (const unsigned char *) obj->u.object.keys[i], strlen (obj->u.object.keys[i]));
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+        stat = gen_yajl_val (obj->u.object.values[i], g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
+
+    stat = yajl_gen_map_close (g);
+    if (yajl_gen_status_ok != stat)
+        GEN_SET_ERROR_AND_RETURN (stat, err);
+    return yajl_gen_status_ok;
+}
+
+static yajl_gen_status gen_yajl_val_array (yajl_val arr, yajl_gen g, parser_error *err)
+{
+    size_t i;
+    yajl_gen_status stat = yajl_gen_status_ok;
+
+    stat = yajl_gen_array_open (g);
+    if (yajl_gen_status_ok != stat)
+        GEN_SET_ERROR_AND_RETURN (stat, err);
+
+    for (i = 0; i < arr->u.array.len; i++)
+    {
+        stat = gen_yajl_val (arr->u.array.values[i], g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
+
+    stat = yajl_gen_array_close (g);
+    if (yajl_gen_status_ok != stat)
+        GEN_SET_ERROR_AND_RETURN (stat, err);
+    return yajl_gen_status_ok;
+}
+
+static yajl_gen_status gen_yajl_val (yajl_val obj, yajl_gen g, parser_error *err)
+{
+    yajl_gen_status __stat = yajl_gen_status_ok;
+    char *__tstr;
+
+    switch(obj->type)
+    {
+        case yajl_t_string:
+            __tstr = YAJL_GET_STRING (obj);
+            if (__tstr == NULL) {
+                return __stat;
+            }
+            __stat = yajl_gen_string (g, (const unsigned char *) __tstr, strlen (__tstr));
+            if (yajl_gen_status_ok != __stat)
+                GEN_SET_ERROR_AND_RETURN (__stat, err);
+            return yajl_gen_status_ok;
+        case yajl_t_number:
+            __tstr = YAJL_GET_NUMBER (obj);
+            if (__tstr == NULL) {
+                return __stat;
+            }
+            __stat = yajl_gen_number (g, __tstr, strlen (__tstr));
+            if (yajl_gen_status_ok != __stat)
+                GEN_SET_ERROR_AND_RETURN (__stat, err);
+            return yajl_gen_status_ok;
+        case yajl_t_object:
+            return gen_yajl_val_obj (obj, g, err);
+        case yajl_t_array:
+            return gen_yajl_val_array (obj, g, err);
+        case yajl_t_true:
+            return yajl_gen_bool (g, true);
+        case yajl_t_false:
+            return yajl_gen_bool (g, false);
+        case yajl_t_null:
+        case yajl_t_any:
+            return __stat;
+    }
+    return __stat;
+}
+
+yajl_gen_status gen_yajl_object_residual (yajl_val obj, yajl_gen g, parser_error *err)
+{
+    size_t i;
+    yajl_gen_status stat = yajl_gen_status_ok;
+
+    for (i = 0; i < obj->u.object.len; i++)
+    {
+        if (obj->u.object.keys[i] == NULL)
+        {
+            continue;
+        }
+        stat = yajl_gen_string (g, (const unsigned char *) obj->u.object.keys[i], strlen (obj->u.object.keys[i]));
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+        stat = gen_yajl_val (obj->u.object.values[i], g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
+
+    return yajl_gen_status_ok;
+}
+
 yajl_gen_status
 map_uint (void *ctx, long long unsigned int num)
 {
@@ -384,8 +495,8 @@ gen_json_map_int_int (void *ctx, const j
 		  (long long int) map->keys[i]);
       if (nret < 0 || (size_t) nret >= sizeof (numstr))
 	{
-	  if (!*err && asprintf (err, "Error to print string") < 0)
-	    *(err) = strdup ("error allocating memory");
+	  if (!*err)
+            *err = strdup ("Error to print string");
 	  return yajl_gen_in_error_state;
 	}
       stat =
@@ -419,11 +530,13 @@ free_json_map_int_int (json_map_int_int
     }
 }
 
+define_cleaner_function (json_map_int_int *, free_json_map_int_int)
+
 json_map_int_int *
 make_json_map_int_int (yajl_val src, const struct parser_context *ctx,
 		       parser_error * err)
 {
-  json_map_int_int *ret = NULL;
+  __auto_cleanup(free_json_map_int_int) json_map_int_int *ret = NULL;
   size_t i;
   size_t len;
 
@@ -441,15 +554,12 @@ make_json_map_int_int (yajl_val src, con
   ret->keys = calloc (len + 1, sizeof (int));
   if (ret->keys == NULL)
     {
-      free (ret);
       return NULL;
     }
 
   ret->values = calloc (len + 1, sizeof (int));
   if (ret->values == NULL)
     {
-      free (ret->keys);
-      free (ret);
       return NULL;
     }
 
@@ -467,10 +577,11 @@ make_json_map_int_int (yajl_val src, con
           int invalid = common_safe_int (srckey, &(ret->keys[i]));
           if (invalid)
             {
-              free_json_map_int_int (ret);
-              if (*err == NULL)
-                asprintf (err, "Invalid key '%s' with type 'int': %s",
-                          srckey, strerror (-invalid));
+              if (*err == NULL && asprintf (err, "Invalid key '%s' with type 'int': %s",
+                    srckey, strerror (-invalid)) < 0)
+                {
+                  *err = strdup ("error allocating memory");
+                }
               return NULL;
             }
         }
@@ -480,32 +591,34 @@ make_json_map_int_int (yajl_val src, con
           int invalid;
           if (!YAJL_IS_NUMBER (srcval))
             {
-              free_json_map_int_int (ret);
-              if (*err == NULL)
-                asprintf (err, "Invalid value with type 'int' for key '%s'",
-                          srckey);
+              if (*err == NULL && asprintf (err,
+                    "Invalid value with type 'int' for key '%s'", srckey) < 0)
+                {
+                  *err = strdup ("error allocating memory");
+                }
               return NULL;
             }
           invalid = common_safe_int (YAJL_GET_NUMBER (srcval), &(ret->values[i]));
           if (invalid)
             {
-              free_json_map_int_int (ret);
-              if (*err == NULL)
-                asprintf (err, "Invalid value with type 'int' for key '%s': %s",
-                          srckey, strerror (-invalid));
+              if (*err == NULL && asprintf (err, "Invalid value with type 'int' for key '%s': %s",
+                    srckey, strerror (-invalid)) < 0)
+                {
+                  *err = strdup ("error allocating memory");
+                }
               return NULL;
             }
         }
     }
-  return ret;
+  return move_ptr (ret);
 }
 
 int
 append_json_map_int_int (json_map_int_int * map, int key, int val)
 {
   size_t len;
-  int *keys = NULL;
-  int *vals = NULL;
+  __auto_free int *keys = NULL;
+  __auto_free int *vals = NULL;
 
   if (map == NULL)
     return -1;
@@ -520,7 +633,6 @@ append_json_map_int_int (json_map_int_in
   vals = calloc (1, len * sizeof (int));
   if (vals == NULL)
     {
-      free (keys);
       return -1;
     }
 
@@ -531,8 +643,10 @@ append_json_map_int_int (json_map_int_in
     }
   free (map->keys);
   map->keys = keys;
+  keys = NULL;
   free (map->values);
   map->values = vals;
+  vals = NULL;
   map->keys[map->len] = key;
   map->values[map->len] = val;
 
@@ -564,7 +678,7 @@ gen_json_map_int_bool (void *ctx, const
       if (nret < 0 || (size_t) nret >= sizeof (numstr))
 	{
 	  if (!*err)
-            asprintf (err, "Error to print string");
+            *err = strdup ("Error to print string");
 	  return yajl_gen_in_error_state;
 	}
       stat =
@@ -604,11 +718,13 @@ free_json_map_int_bool (json_map_int_boo
     }
 }
 
+define_cleaner_function (json_map_int_bool *, free_json_map_int_bool)
+
 json_map_int_bool *
 make_json_map_int_bool (yajl_val src, const struct parser_context *ctx,
 			parser_error * err)
 {
-  json_map_int_bool *ret = NULL;
+  __auto_cleanup(free_json_map_int_bool) json_map_int_bool *ret = NULL;
   size_t i;
   size_t len;
 
@@ -625,14 +741,11 @@ make_json_map_int_bool (yajl_val src, co
   ret->keys = calloc (len + 1, sizeof (int));
   if (ret->keys == NULL)
     {
-      free (ret);
       return NULL;
     }
   ret->values = calloc (len + 1, sizeof (bool));
   if (ret->values == NULL)
     {
-      free (ret->keys);
-      free (ret);
       return NULL;
     }
   for (i = 0; i < len; i++)
@@ -649,10 +762,11 @@ make_json_map_int_bool (yajl_val src, co
           int invalid = common_safe_int (srckey, &(ret->keys[i]));
           if (invalid)
             {
-              free_json_map_int_bool (ret);
-              if (*err == NULL)
-                asprintf (err, "Invalid key '%s' with type 'int': %s",
-                          srckey, strerror (-invalid));
+              if (*err == NULL && asprintf (err, "Invalid key '%s' with type 'int': %s",
+                    srckey, strerror (-invalid)) < 0)
+                {
+                  *err = strdup ("error allocating memory");
+                }
               return NULL;
             }
         }
@@ -665,23 +779,24 @@ make_json_map_int_bool (yajl_val src, co
             ret->values[i] = false;
           else
             {
-              free_json_map_int_bool (ret);
-              if (*err == NULL)
-                asprintf (err, "Invalid value with type 'bool' for key '%s'",
-                          srckey);
+              if (*err == NULL && asprintf (err,
+                    "Invalid value with type 'bool' for key '%s'", srckey) < 0)
+                {
+                  *err = strdup ("error allocating memory");
+                }
               return NULL;
             }
         }
     }
-  return ret;
+  return move_ptr (ret);
 }
 
 int
 append_json_map_int_bool (json_map_int_bool * map, int key, bool val)
 {
   size_t len;
-  int *keys = NULL;
-  bool *vals = NULL;
+  __auto_free int *keys = NULL;
+  __auto_free bool *vals = NULL;
 
   if (map == NULL)
     return -1;
@@ -697,7 +812,6 @@ append_json_map_int_bool (json_map_int_b
   vals = calloc (len, sizeof (bool));
   if (vals == NULL)
     {
-      free (keys);
       return -1;
     }
 
@@ -708,8 +822,10 @@ append_json_map_int_bool (json_map_int_b
     }
   free (map->keys);
   map->keys = keys;
+  keys = NULL;
   free (map->values);
   map->values = vals;
+  vals = NULL;
   map->keys[map->len] = key;
   map->values[map->len] = val;
 
@@ -742,7 +858,7 @@ gen_json_map_int_string (void *ctx, cons
       if (nret < 0 || (size_t) nret >= sizeof (numstr))
 	{
 	  if (!*err)
-            asprintf (err, "Error to print string");
+            *err = strdup ("Error to print string");
 	  return yajl_gen_in_error_state;
 	}
       stat =
@@ -786,13 +902,15 @@ free_json_map_int_string (json_map_int_s
     }
 }
 
+define_cleaner_function (json_map_int_string *, free_json_map_int_string)
+
 json_map_int_string *
 make_json_map_int_string (yajl_val src, const struct parser_context *ctx,
 			  parser_error * err)
 {
+  __auto_cleanup(free_json_map_int_string) json_map_int_string *ret = NULL;
   size_t i;
   size_t len;
-  json_map_int_string *ret = NULL;
 
   if (src == NULL || YAJL_GET_OBJECT (src) == NULL)
     return NULL;
@@ -809,15 +927,12 @@ make_json_map_int_string (yajl_val src,
   ret->keys = calloc (len + 1, sizeof (int));
   if (ret->keys == NULL)
     {
-      free (ret);
       return NULL;
     }
 
   ret->values = calloc (len + 1, sizeof (char *));
   if (ret->values == NULL)
     {
-      free (ret->keys);
-      free (ret);
       return NULL;
     }
 
@@ -836,10 +951,11 @@ make_json_map_int_string (yajl_val src,
           invalid = common_safe_int (srckey, &(ret->keys[i]));
           if (invalid)
             {
-              free_json_map_int_string (ret);
-              if (*err == NULL)
-                asprintf (err, "Invalid key '%s' with type 'int': %s",
-                          srckey, strerror (-invalid));
+              if (*err == NULL && asprintf (err, "Invalid key '%s' with type 'int': %s",
+                    srckey, strerror (-invalid)) < 0)
+                {
+                  *err = strdup ("error allocating memory");
+                }
               return NULL;
             }
         }
@@ -848,17 +964,18 @@ make_json_map_int_string (yajl_val src,
         {
           if (!YAJL_IS_STRING (srcval))
             {
-              free_json_map_int_string (ret);
-              if (*err == NULL)
-                asprintf (err, "Invalid value with type 'string' for key '%s'",
-                          srckey);
+              if (*err == NULL && asprintf (err,
+                   "Invalid value with type 'string' for key '%s'", srckey) < 0)
+                {
+                  *err = strdup ("error allocating memory");
+                }
               return NULL;
             }
           char *str = YAJL_GET_STRING_NO_CHECK (srcval);
           ret->values[i] = strdup (str ? str : "");
         }
     }
-  return ret;
+  return move_ptr (ret);
 }
 
 int
@@ -952,11 +1069,13 @@ free_json_map_string_int (json_map_strin
     }
 }
 
+define_cleaner_function (json_map_string_int *, free_json_map_string_int)
+
 json_map_string_int *
 make_json_map_string_int (yajl_val src, const struct parser_context *ctx,
 			  parser_error * err)
 {
-  json_map_string_int *ret = NULL;
+  __auto_cleanup(free_json_map_string_int) json_map_string_int *ret = NULL;
   size_t i;
   size_t len;
 
@@ -976,15 +1095,12 @@ make_json_map_string_int (yajl_val src,
   ret->keys = calloc (len + 1, sizeof (char *));
   if (ret->keys == NULL)
     {
-      free (ret);
       *(err) = strdup ("error allocating memory");
       return NULL;
     }
   ret->values = calloc (len + 1, sizeof (int));
   if (ret->values == NULL)
     {
-      free (ret->keys);
-      free (ret);
       *(err) = strdup ("error allocating memory");
       return NULL;
     }
@@ -1000,7 +1116,6 @@ make_json_map_string_int (yajl_val src,
       ret->keys[i] = strdup (srckey ? srckey : "");
       if (ret->keys[i] == NULL)
         {
-          free_json_map_string_int (ret);
           *(err) = strdup ("error allocating memory");
           return NULL;
         }
@@ -1010,24 +1125,26 @@ make_json_map_string_int (yajl_val src,
           int invalid;
           if (!YAJL_IS_NUMBER (srcval))
             {
-              free_json_map_string_int (ret);
-              if (*err == NULL)
-                asprintf (err, "Invalid value with type 'int' for key '%s'",
-                          srckey);
+              if (*err == NULL && asprintf (err,
+                    "Invalid value with type 'int' for key '%s'", srckey) < 0)
+                {
+                  *err = strdup ("error allocating memory");
+                }
               return NULL;
             }
           invalid = common_safe_int (YAJL_GET_NUMBER (srcval), &(ret->values[i]));
           if (invalid)
             {
-              free_json_map_string_int (ret);
-              if (*err == NULL)
-                asprintf (err, "Invalid value with type 'int' for key '%s': %s",
-                          srckey, strerror (-invalid));
+              if (*err == NULL && asprintf (err, "Invalid value with type 'int' for key '%s': %s",
+                    srckey, strerror (-invalid)) < 0)
+                {
+                  *err = strdup ("error allocating memory");
+                }
               return NULL;
             }
         }
     }
-  return ret;
+  return move_ptr (ret);
 }
 
 int
@@ -1121,11 +1238,13 @@ free_json_map_string_bool (json_map_stri
     }
 }
 
+define_cleaner_function (json_map_string_bool *, free_json_map_string_bool)
+
 json_map_string_bool *
 make_json_map_string_bool (yajl_val src, const struct parser_context *ctx,
 			   parser_error * err)
 {
-  json_map_string_bool *ret = NULL;
+  __auto_cleanup(free_json_map_string_bool) json_map_string_bool *ret = NULL;
   size_t i;
   size_t len;
 
@@ -1143,15 +1262,12 @@ make_json_map_string_bool (yajl_val src,
   ret->keys = calloc (len + 1, sizeof (char *));
   if (ret->keys == NULL)
     {
-      free (ret);
       return NULL;
     }
 
   ret->values = calloc (len + 1, sizeof (bool));
   if (ret->values == NULL)
     {
-      free (ret->values);
-      free (ret);
       return NULL;
     }
   for (i = 0; i < len; i++)
@@ -1166,7 +1282,6 @@ make_json_map_string_bool (yajl_val src,
       ret->keys[i] = strdup (srckey ? srckey : "");
       if (ret->keys[i] == NULL)
         {
-          free_json_map_string_bool (ret);
           *(err) = strdup ("error allocating memory");
           return NULL;
         }
@@ -1178,15 +1293,16 @@ make_json_map_string_bool (yajl_val src,
             ret->values[i] = false;
           else
             {
-              free_json_map_string_bool (ret);
-              if (*err == NULL)
-                asprintf (err, "Invalid value with type 'bool' for key '%s'",
-                          srckey);
+              if (*err == NULL && asprintf (err,
+                   "Invalid value with type 'bool' for key '%s'", srckey) < 0)
+                {
+                  *err = strdup ("error allocating memory");
+                }
               return NULL;
             }
         }
     }
-  return ret;
+  return move_ptr (ret);
 }
 
 int
@@ -1194,9 +1310,9 @@ append_json_map_string_bool (json_map_st
 			     bool val)
 {
   size_t len;
-  char **keys = NULL;
-  bool *vals = NULL;
-  char *new_value;
+  __auto_free char **keys = NULL;
+  __auto_free bool *vals = NULL;
+  __auto_free char *new_value;
 
   if (map == NULL)
     return -1;
@@ -1212,15 +1328,12 @@ append_json_map_string_bool (json_map_st
   vals = calloc (len, sizeof (bool));
   if (vals == NULL)
     {
-      free (keys);
       return -1;
     }
 
   new_value = strdup (key ? key : "");
   if (new_value == NULL)
     {
-      free (vals);
-      free (keys);
       return -1;
     }
 
@@ -1231,9 +1344,12 @@ append_json_map_string_bool (json_map_st
     }
   free (map->keys);
   map->keys = keys;
+  keys = NULL;
   free (map->values);
   map->values = vals;
+  vals = NULL;
   map->keys[map->len] = new_value;
+  new_value = NULL;
   map->values[map->len] = val;
 
   map->len++;
@@ -1302,11 +1418,13 @@ free_json_map_string_string (json_map_st
     }
 }
 
+define_cleaner_function (json_map_string_string *, free_json_map_string_string)
+
 json_map_string_string *
 make_json_map_string_string (yajl_val src, const struct parser_context *ctx,
 			     parser_error * err)
 {
-  json_map_string_string *ret = NULL;
+  __auto_cleanup(free_json_map_string_string) json_map_string_string *ret = NULL;
   size_t i;
   size_t len;
 
@@ -1328,7 +1446,6 @@ make_json_map_string_string (yajl_val sr
   ret->keys = calloc (len + 1, sizeof (char *));
   if (ret->keys == NULL)
     {
-      free (ret);
       *(err) = strdup ("error allocating memory");
       return NULL;
     }
@@ -1336,8 +1453,6 @@ make_json_map_string_string (yajl_val sr
   ret->values = calloc (len + 1, sizeof (char *));
   if (ret->values == NULL)
     {
-      free (ret->keys);
-      free (ret);
       *(err) = strdup ("error allocating memory");
       return NULL;
     }
@@ -1353,7 +1468,6 @@ make_json_map_string_string (yajl_val sr
       ret->keys[i] = strdup (srckey ? srckey : "");
       if (ret->keys[i] == NULL)
         {
-          free_json_map_string_string (ret);
           return NULL;
         }
       if (srcval != NULL)
@@ -1361,10 +1475,11 @@ make_json_map_string_string (yajl_val sr
           char *str;
           if (!YAJL_IS_STRING (srcval))
             {
-              free_json_map_string_string (ret);
-              if (*err == NULL)
-                asprintf (err, "Invalid value with type 'string' for key '%s'",
-                          srckey);
+              if (*err == NULL && asprintf (err,
+                   "Invalid value with type 'string' for key '%s'", srckey) < 0)
+                {
+                  *err = strdup ("error allocating memory");
+                }
               return NULL;
             }
 
@@ -1373,12 +1488,11 @@ make_json_map_string_string (yajl_val sr
           ret->values[i] = strdup (str ? str : "");
           if (ret->values[i] == NULL)
             {
-              free_json_map_string_string (ret);
               return NULL;
             }
         }
     }
-  return ret;
+  return move_ptr (ret);
 }
 
 int
@@ -1386,10 +1500,10 @@ append_json_map_string_string (json_map_
 			       const char *val)
 {
   size_t len, i;
-  char **keys = NULL;
-  char **values = NULL;
-  char *new_key = NULL;
-  char *new_value = NULL;
+  __auto_free char **keys = NULL;
+  __auto_free char **values = NULL;
+  __auto_free char *new_key = NULL;
+  __auto_free char *new_value = NULL;
 
   if (map == NULL)
     return -1;
@@ -1412,41 +1526,51 @@ append_json_map_string_string (json_map_
 
   new_key = strdup (key ? key : "");
   if (new_key == NULL)
-    goto cleanup;
+    return -1;
 
   new_value = strdup (val ? val : "");
   if (new_value == NULL)
-    goto cleanup;
+    return -1;
 
   len = map->len + 1;
   keys = realloc (map->keys, len * sizeof (char *));
   if (keys == NULL)
-    goto cleanup;
+    return -1;
   map->keys = keys;
+  keys = NULL;
   map->keys[map->len] = NULL;
 
   values = realloc (map->values, len * sizeof (char *));
   if (values == NULL)
-    goto cleanup;
+    return -1;
 
   map->keys[map->len] = new_key;
+  new_key = NULL;
   map->values = values;
+  values = NULL;
   map->values[map->len] = new_value;
+  new_value = NULL;
 
   map->len++;
   return 0;
+}
 
- cleanup:
-  free (new_value);
-  free (new_key);
-  return -1;
+static void
+cleanup_yajl_gen(yajl_gen g)
+{
+  if (!g)
+    return;
+  yajl_gen_clear (g);
+  yajl_gen_free (g);
 }
 
+define_cleaner_function (yajl_gen, cleanup_yajl_gen)
+
 char *
 json_marshal_string (const char *str, size_t length,
 		     const struct parser_context *ctx, parser_error * err)
 {
-  yajl_gen g = NULL;
+  __auto_cleanup(cleanup_yajl_gen) yajl_gen g = NULL;
   struct parser_context tmp_ctx = { 0 };
   const unsigned char *gen_buf = NULL;
   char *json_buf = NULL;
@@ -1463,35 +1587,32 @@ json_marshal_string (const char *str, si
   if (!json_gen_init (&g, ctx))
     {
       *err = strdup ("Json_gen init failed");
-      goto out;
+      return json_buf;
     }
   stat = yajl_gen_string ((yajl_gen) g, (const unsigned char *) str, length);
   if (yajl_gen_status_ok != stat)
     {
-      asprintf (err, "error generating json, errcode: %d", (int) stat);
-      goto free_out;
+      if (asprintf (err, "error generating json, errcode: %d", (int) stat) < 0)
+          *err = strdup ("error allocating memory");
+      return json_buf;
     }
   yajl_gen_get_buf (g, &gen_buf, &gen_len);
   if (gen_buf == NULL)
     {
       *err = strdup ("Error to get generated json");
-      goto free_out;
+      return json_buf;
     }
 
   json_buf = calloc (1, gen_len + 1);
   if (json_buf == NULL)
     {
       *err = strdup ("error allocating memory");
-      goto free_out;
+      return json_buf;
     }
 
   (void) memcpy (json_buf, gen_buf, gen_len);
   json_buf[gen_len] = '\\0';
 
-free_out:
-  yajl_gen_clear (g);
-  yajl_gen_free (g);
-out:
   return json_buf;
 }
         """)
diff -pruN 0.14.1+dfsg-1/libocispec/src/common_h.py 0.15+dfsg-1/libocispec/src/common_h.py
--- 0.14.1+dfsg-1/libocispec/src/common_h.py	2020-06-18 12:41:03.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/common_h.py	2020-09-03 12:13:17.000000000 +0000
@@ -65,8 +65,32 @@ extern "C" {
 # define OPT_GEN_KEY_VALUE 0x02
 // options to generate simplify(no indent) json string
 # define OPT_GEN_SIMPLIFY 0x04
+// options to keep all keys and values, even do not known
+# define OPT_PARSE_FULLKEY 0x08
 // options not to validate utf8 data
-# define OPT_GEN_NO_VALIDATE_UTF8 0x08
+# define OPT_GEN_NO_VALIDATE_UTF8 0x10
+
+#define define_cleaner_function(type, cleaner)           \\
+        static inline void cleaner##_function(type *ptr) \\
+        {                                                \\
+                if (*ptr)                                \\
+                        cleaner(*ptr);                   \\
+        }
+
+#define __auto_cleanup(cleaner) __attribute__((__cleanup__(cleaner##_function)))
+
+static inline void ptr_free_function(void *p) {
+    free(*(void**)p);
+}
+
+#define __auto_free __auto_cleanup(ptr_free)
+
+#define move_ptr(ptr)                                 \\
+        ({                                            \\
+                typeof(ptr) moved_ptr = (ptr);        \\
+                (ptr) = NULL;                         \\
+                moved_ptr;                            \\
+        })
 
 # define GEN_SET_ERROR_AND_RETURN(stat, err) { \\
     if (*(err) == NULL) {\\
@@ -85,6 +109,8 @@ struct parser_context
   FILE *errfile;
 };
 
+yajl_gen_status gen_yajl_object_residual (yajl_val obj, yajl_gen g, parser_error *err);
+
 yajl_gen_status map_uint (void *ctx, long long unsigned int num);
 
 yajl_gen_status map_int (void *ctx, long long int num);
diff -pruN 0.14.1+dfsg-1/libocispec/src/generate.py 0.15+dfsg-1/libocispec/src/generate.py
--- 0.14.1+dfsg-1/libocispec/src/generate.py	2020-06-18 12:41:03.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/generate.py	2020-09-03 12:13:17.000000000 +0000
@@ -736,6 +736,7 @@ def handle_single_file(args, srcpath, ge
                         schema_info = schema_from_file(os.path.join(dirpath, target_file), \
                                                        srcpath.name)
                         reflection(schema_info, gen_ref)
+                        print("\033[1;34mReflection:\033[0m\t%-60s \033[1;32mSuccess\033[0m" % (target_file))
         else:
             # only parse files in current direcotory
             for target_file in os.listdir(schemapath.name):
@@ -743,10 +744,12 @@ def handle_single_file(args, srcpath, ge
                 if fullpath.endswith(JSON_SUFFIX) and os.path.isfile(fullpath):
                     schema_info = schema_from_file(fullpath, srcpath.name)
                     reflection(schema_info, gen_ref)
+                    print("\033[1;34mReflection:\033[0m\t%-60s \033[1;32mSuccess\033[0m" % (fullpath))
     else:
         if schemapath.name.endswith(JSON_SUFFIX):
             schema_info = schema_from_file(schemapath.name, srcpath.name)
             reflection(schema_info, gen_ref)
+            print("\033[1;34mReflection:\033[0m\t%-60s \033[1;32mSuccess\033[0m" % (schemapath.name))
         else:
             print('File %s is not ends with .json' % schemapath.name)
 
diff -pruN 0.14.1+dfsg-1/libocispec/src/headers.py 0.15+dfsg-1/libocispec/src/headers.py
--- 0.14.1+dfsg-1/libocispec/src/headers.py	2020-06-18 12:41:03.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/headers.py	2020-09-03 12:13:17.000000000 +0000
@@ -155,6 +155,8 @@ def append_type_c_header(obj, header, pr
                 append_header_child_others(i, header, prefix)
             if helpers.judge_data_type(i.typ) or i.typ == 'boolean':
                 header.write("    unsigned int %s_present : 1;\n" % (i.fixname))
+        if obj.children is not None:
+            header.write("    yajl_val _residual;\n")
     typename = helpers.get_prefixed_name(obj.name, prefix)
     header.write("}\n%s;\n\n" % typename)
     header.write("void free_%s (%s *ptr);\n\n" % (typename, typename))
diff -pruN 0.14.1+dfsg-1/libocispec/src/image_manifest_items_image_manifest_items_schema.c 0.15+dfsg-1/libocispec/src/image_manifest_items_image_manifest_items_schema.c
--- 0.14.1+dfsg-1/libocispec/src/image_manifest_items_image_manifest_items_schema.c	2020-07-08 06:50:09.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/image_manifest_items_image_manifest_items_schema.c	2020-09-23 11:23:27.000000000 +0000
@@ -8,14 +8,15 @@
 
 #define YAJL_GET_ARRAY_NO_CHECK(v) (&(v)->u.array)
 #define YAJL_GET_OBJECT_NO_CHECK(v) (&(v)->u.object)
+define_cleaner_function (image_manifest_items_image_manifest_items_schema_element *, free_image_manifest_items_image_manifest_items_schema_element)
 image_manifest_items_image_manifest_items_schema_element *
 make_image_manifest_items_image_manifest_items_schema_element (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    image_manifest_items_image_manifest_items_schema_element *ret = NULL;
+    __auto_cleanup(free_image_manifest_items_image_manifest_items_schema_element) image_manifest_items_image_manifest_items_schema_element *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -28,7 +29,6 @@ make_image_manifest_items_image_manifest
             ret->config = strdup (str ? str : "");
             if (ret->config == NULL)
               {
-                free_image_manifest_items_image_manifest_items_schema_element (ret);
                 return NULL;
               }
           }
@@ -46,7 +46,6 @@ make_image_manifest_items_image_manifest
             ret->layers = calloc (len + 1, sizeof (*ret->layers));
             if (ret->layers == NULL)
               {
-                free_image_manifest_items_image_manifest_items_schema_element (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -58,7 +57,6 @@ make_image_manifest_items_image_manifest
                     ret->layers[i] = strdup (str ? str : "");
                     if (ret->layers[i] == NULL)
                       {
-                        free_image_manifest_items_image_manifest_items_schema_element (ret);
                         return NULL;
                       }
                   }
@@ -78,7 +76,6 @@ make_image_manifest_items_image_manifest
             ret->repo_tags = calloc (len + 1, sizeof (*ret->repo_tags));
             if (ret->repo_tags == NULL)
               {
-                free_image_manifest_items_image_manifest_items_schema_element (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -90,7 +87,6 @@ make_image_manifest_items_image_manifest
                     ret->repo_tags[i] = strdup (str ? str : "");
                     if (ret->repo_tags[i] == NULL)
                       {
-                        free_image_manifest_items_image_manifest_items_schema_element (ret);
                         return NULL;
                       }
                   }
@@ -107,7 +103,6 @@ make_image_manifest_items_image_manifest
             ret->parent = strdup (str ? str : "");
             if (ret->parent == NULL)
               {
-                free_image_manifest_items_image_manifest_items_schema_element (ret);
                 return NULL;
               }
           }
@@ -117,17 +112,15 @@ make_image_manifest_items_image_manifest
       {
         if (asprintf (err, "Required field '%s' not present",  "Config") < 0)
             *err = strdup ("error allocating memory");
-        free_image_manifest_items_image_manifest_items_schema_element (ret);
         return NULL;
       }
     if (ret->layers == NULL)
       {
         if (asprintf (err, "Required field '%s' not present",  "Layers") < 0)
             *err = strdup ("error allocating memory");
-        free_image_manifest_items_image_manifest_items_schema_element (ret);
         return NULL;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -336,7 +329,7 @@ image_manifest_items_image_manifest_item
 {
     image_manifest_items_image_manifest_items_schema_element **ptr = NULL;
     size_t filesize;
-    char *content = NULL;
+    __auto_free char *content = NULL;
 
     if (filename == NULL || err == NULL)
       return NULL;
@@ -350,15 +343,15 @@ image_manifest_items_image_manifest_item
         return NULL;
       }
     ptr = image_manifest_items_image_manifest_items_schema_parse_data (content, ctx, err, len);
-    free (content);
     return ptr;
 }
 
-image_manifest_items_image_manifest_items_schema_element **image_manifest_items_image_manifest_items_schema_parse_file_stream (FILE *stream, const struct parser_context *ctx, parser_error *err, size_t *len)
+image_manifest_items_image_manifest_items_schema_element **
+image_manifest_items_image_manifest_items_schema_parse_file_stream (FILE *stream, const struct parser_context *ctx, parser_error *err, size_t *len)
 {
     image_manifest_items_image_manifest_items_schema_element **ptr = NULL;
     size_t filesize;
-    char *content = NULL ;
+    __auto_free char *content = NULL ;
 
     if (stream == NULL || err == NULL)
       return NULL;
@@ -371,14 +364,16 @@ image_manifest_items_image_manifest_item
         return NULL;
       }
     ptr = image_manifest_items_image_manifest_items_schema_parse_data (content, ctx, err, len);
-    free (content);
     return ptr;
 }
 
-image_manifest_items_image_manifest_items_schema_element **image_manifest_items_image_manifest_items_schema_parse_data (const char *jsondata, const struct parser_context *ctx, parser_error *err, size_t *len)
+define_cleaner_function (yajl_val, yajl_tree_free)
+
+image_manifest_items_image_manifest_items_schema_element **
+image_manifest_items_image_manifest_items_schema_parse_data (const char *jsondata, const struct parser_context *ctx, parser_error *err, size_t *len)
 {
     image_manifest_items_image_manifest_items_schema_element **ptr = NULL;
-    yajl_val tree;
+    __auto_cleanup(yajl_tree_free) yajl_val tree;
     char errbuf[1024];
     struct parser_context tmp_ctx = { 0 };
 
@@ -397,12 +392,24 @@ image_manifest_items_image_manifest_item
         return NULL;
       }
     ptr = make_image_manifest_items_image_manifest_items_schema (tree, ctx, err, len);
-    yajl_tree_free (tree);
     return ptr;
 }
-char *image_manifest_items_image_manifest_items_schema_generate_json(const image_manifest_items_image_manifest_items_schema_element **ptr, size_t len, const struct parser_context *ctx, parser_error *err)
+
+static void
+cleanup_yajl_gen (yajl_gen g)
 {
-    yajl_gen g = NULL;
+    if (!g)
+      return;
+    yajl_gen_clear (g);
+    yajl_gen_free (g);
+}
+
+define_cleaner_function (yajl_gen, cleanup_yajl_gen)
+
+char *
+image_manifest_items_image_manifest_items_schema_generate_json (const image_manifest_items_image_manifest_items_schema_element **ptr, size_t len, const struct parser_context *ctx, parser_error *err)
+{
+    __auto_cleanup(cleanup_yajl_gen) yajl_gen g = NULL;
     struct parser_context tmp_ctx = { 0 };
     const unsigned char *gen_buf = NULL;
     char *json_buf = NULL;
@@ -418,35 +425,31 @@ char *image_manifest_items_image_manifes
     if (!json_gen_init(&g, ctx))
       {
         *err = strdup ("Json_gen init failed");
-        goto out;
+        return json_buf;
       }
 
     if (yajl_gen_status_ok != gen_image_manifest_items_image_manifest_items_schema (g, ptr, len, ctx, err))
       {
         if (*err == NULL)
             *err = strdup ("Failed to generate json");
-        goto free_out;
+        return json_buf;
       }
 
     yajl_gen_get_buf (g, &gen_buf, &gen_len);
     if (gen_buf == NULL)
       {
         *err = strdup ("Error to get generated json");
-        goto free_out;
+        return json_buf;
       }
 
     json_buf = calloc (1, gen_len + 1);
     if (json_buf == NULL)
       {
         *err = strdup ("Cannot allocate memory");
-        goto free_out;
+        return json_buf;
       }
-    (void) memcpy(json_buf, gen_buf, gen_len);
+    (void) memcpy (json_buf, gen_buf, gen_len);
     json_buf[gen_len] = '\0';
 
-free_out:
-    yajl_gen_clear (g);
-    yajl_gen_free (g);
-out:
     return json_buf;
 }
diff -pruN 0.14.1+dfsg-1/libocispec/src/image_spec_schema_config_schema.c 0.15+dfsg-1/libocispec/src/image_spec_schema_config_schema.c
--- 0.14.1+dfsg-1/libocispec/src/image_spec_schema_config_schema.c	2020-07-08 06:50:09.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/image_spec_schema_config_schema.c	2020-09-23 11:23:27.000000000 +0000
@@ -8,14 +8,15 @@
 
 #define YAJL_GET_ARRAY_NO_CHECK(v) (&(v)->u.array)
 #define YAJL_GET_OBJECT_NO_CHECK(v) (&(v)->u.object)
+define_cleaner_function (image_spec_schema_config_schema_config *, free_image_spec_schema_config_schema_config)
 image_spec_schema_config_schema_config *
 make_image_spec_schema_config_schema_config (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    image_spec_schema_config_schema_config *ret = NULL;
+    __auto_cleanup(free_image_spec_schema_config_schema_config) image_spec_schema_config_schema_config *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -28,7 +29,6 @@ make_image_spec_schema_config_schema_con
             ret->user = strdup (str ? str : "");
             if (ret->user == NULL)
               {
-                free_image_spec_schema_config_schema_config (ret);
                 return NULL;
               }
           }
@@ -37,7 +37,6 @@ make_image_spec_schema_config_schema_con
     ret->exposed_ports = make_image_spec_schema_defs_map_string_object (get_val (tree, "ExposedPorts", yajl_t_object), ctx, err);
     if (ret->exposed_ports == NULL && *err != 0)
       {
-        free_image_spec_schema_config_schema_config (ret);
         return NULL;
       }
     do
@@ -52,7 +51,6 @@ make_image_spec_schema_config_schema_con
             ret->env = calloc (len + 1, sizeof (*ret->env));
             if (ret->env == NULL)
               {
-                free_image_spec_schema_config_schema_config (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -64,7 +62,6 @@ make_image_spec_schema_config_schema_con
                     ret->env[i] = strdup (str ? str : "");
                     if (ret->env[i] == NULL)
                       {
-                        free_image_spec_schema_config_schema_config (ret);
                         return NULL;
                       }
                   }
@@ -84,7 +81,6 @@ make_image_spec_schema_config_schema_con
             ret->entrypoint = calloc (len + 1, sizeof (*ret->entrypoint));
             if (ret->entrypoint == NULL)
               {
-                free_image_spec_schema_config_schema_config (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -96,7 +92,6 @@ make_image_spec_schema_config_schema_con
                     ret->entrypoint[i] = strdup (str ? str : "");
                     if (ret->entrypoint[i] == NULL)
                       {
-                        free_image_spec_schema_config_schema_config (ret);
                         return NULL;
                       }
                   }
@@ -116,7 +111,6 @@ make_image_spec_schema_config_schema_con
             ret->cmd = calloc (len + 1, sizeof (*ret->cmd));
             if (ret->cmd == NULL)
               {
-                free_image_spec_schema_config_schema_config (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -128,7 +122,6 @@ make_image_spec_schema_config_schema_con
                     ret->cmd[i] = strdup (str ? str : "");
                     if (ret->cmd[i] == NULL)
                       {
-                        free_image_spec_schema_config_schema_config (ret);
                         return NULL;
                       }
                   }
@@ -139,7 +132,6 @@ make_image_spec_schema_config_schema_con
     ret->volumes = make_image_spec_schema_defs_map_string_object (get_val (tree, "Volumes", yajl_t_object), ctx, err);
     if (ret->volumes == NULL && *err != 0)
       {
-        free_image_spec_schema_config_schema_config (ret);
         return NULL;
       }
     do
@@ -151,7 +143,6 @@ make_image_spec_schema_config_schema_con
             ret->working_dir = strdup (str ? str : "");
             if (ret->working_dir == NULL)
               {
-                free_image_spec_schema_config_schema_config (ret);
                 return NULL;
               }
           }
@@ -170,7 +161,6 @@ make_image_spec_schema_config_schema_con
                   new_error = strdup ("error allocating memory");
                 free (*err);
                 *err = new_error;
-                free_image_spec_schema_config_schema_config (ret);
                 return NULL;
             }
         }
@@ -185,16 +175,41 @@ make_image_spec_schema_config_schema_con
             ret->stop_signal = strdup (str ? str : "");
             if (ret->stop_signal == NULL)
               {
-                free_image_spec_schema_config_schema_config (ret);
                 return NULL;
               }
           }
       }
     while (0);
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "User")
@@ -205,14 +220,28 @@ make_image_spec_schema_config_schema_con
                 && strcmp (tree->u.object.keys[i], "Volumes")
                 && strcmp (tree->u.object.keys[i], "WorkingDir")
                 && strcmp (tree->u.object.keys[i], "Labels")
-                && strcmp (tree->u.object.keys[i], "StopSignal") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "StopSignal"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -274,6 +303,8 @@ free_image_spec_schema_config_schema_con
     ptr->labels = NULL;
     free (ptr->stop_signal);
     ptr->stop_signal = NULL;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -424,20 +455,27 @@ gen_image_spec_schema_config_schema_conf
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (image_spec_schema_config_schema_rootfs *, free_image_spec_schema_config_schema_rootfs)
 image_spec_schema_config_schema_rootfs *
 make_image_spec_schema_config_schema_rootfs (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    image_spec_schema_config_schema_rootfs *ret = NULL;
+    __auto_cleanup(free_image_spec_schema_config_schema_rootfs) image_spec_schema_config_schema_rootfs *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -453,7 +491,6 @@ make_image_spec_schema_config_schema_roo
             ret->diff_ids = calloc (len + 1, sizeof (*ret->diff_ids));
             if (ret->diff_ids == NULL)
               {
-                free_image_spec_schema_config_schema_rootfs (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -465,7 +502,6 @@ make_image_spec_schema_config_schema_roo
                     ret->diff_ids[i] = strdup (str ? str : "");
                     if (ret->diff_ids[i] == NULL)
                       {
-                        free_image_spec_schema_config_schema_rootfs (ret);
                         return NULL;
                       }
                   }
@@ -482,7 +518,6 @@ make_image_spec_schema_config_schema_roo
             ret->type = strdup (str ? str : "");
             if (ret->type == NULL)
               {
-                free_image_spec_schema_config_schema_rootfs (ret);
                 return NULL;
               }
           }
@@ -492,31 +527,69 @@ make_image_spec_schema_config_schema_roo
       {
         if (asprintf (err, "Required field '%s' not present",  "diff_ids") < 0)
             *err = strdup ("error allocating memory");
-        free_image_spec_schema_config_schema_rootfs (ret);
         return NULL;
       }
     if (ret->type == NULL)
       {
         if (asprintf (err, "Required field '%s' not present",  "type") < 0)
             *err = strdup ("error allocating memory");
-        free_image_spec_schema_config_schema_rootfs (ret);
         return NULL;
       }
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "diff_ids")
-                && strcmp (tree->u.object.keys[i], "type") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "type"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -540,6 +613,8 @@ free_image_spec_schema_config_schema_roo
     }
     free (ptr->type);
     ptr->type = NULL;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -589,20 +664,27 @@ gen_image_spec_schema_config_schema_root
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (image_spec_schema_config_schema_history_element *, free_image_spec_schema_config_schema_history_element)
 image_spec_schema_config_schema_history_element *
 make_image_spec_schema_config_schema_history_element (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    image_spec_schema_config_schema_history_element *ret = NULL;
+    __auto_cleanup(free_image_spec_schema_config_schema_history_element) image_spec_schema_config_schema_history_element *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -615,7 +697,6 @@ make_image_spec_schema_config_schema_his
             ret->created = strdup (str ? str : "");
             if (ret->created == NULL)
               {
-                free_image_spec_schema_config_schema_history_element (ret);
                 return NULL;
               }
           }
@@ -630,7 +711,6 @@ make_image_spec_schema_config_schema_his
             ret->author = strdup (str ? str : "");
             if (ret->author == NULL)
               {
-                free_image_spec_schema_config_schema_history_element (ret);
                 return NULL;
               }
           }
@@ -645,7 +725,6 @@ make_image_spec_schema_config_schema_his
             ret->created_by = strdup (str ? str : "");
             if (ret->created_by == NULL)
               {
-                free_image_spec_schema_config_schema_history_element (ret);
                 return NULL;
               }
           }
@@ -660,7 +739,6 @@ make_image_spec_schema_config_schema_his
             ret->comment = strdup (str ? str : "");
             if (ret->comment == NULL)
               {
-                free_image_spec_schema_config_schema_history_element (ret);
                 return NULL;
               }
           }
@@ -685,7 +763,7 @@ make_image_spec_schema_config_schema_his
           }
       }
     while (0);
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -780,14 +858,15 @@ gen_image_spec_schema_config_schema_hist
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (image_spec_schema_config_schema *, free_image_spec_schema_config_schema)
 image_spec_schema_config_schema *
 make_image_spec_schema_config_schema (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    image_spec_schema_config_schema *ret = NULL;
+    __auto_cleanup(free_image_spec_schema_config_schema) image_spec_schema_config_schema *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -800,7 +879,6 @@ make_image_spec_schema_config_schema (ya
             ret->created = strdup (str ? str : "");
             if (ret->created == NULL)
               {
-                free_image_spec_schema_config_schema (ret);
                 return NULL;
               }
           }
@@ -815,7 +893,6 @@ make_image_spec_schema_config_schema (ya
             ret->author = strdup (str ? str : "");
             if (ret->author == NULL)
               {
-                free_image_spec_schema_config_schema (ret);
                 return NULL;
               }
           }
@@ -830,7 +907,6 @@ make_image_spec_schema_config_schema (ya
             ret->architecture = strdup (str ? str : "");
             if (ret->architecture == NULL)
               {
-                free_image_spec_schema_config_schema (ret);
                 return NULL;
               }
           }
@@ -845,7 +921,6 @@ make_image_spec_schema_config_schema (ya
             ret->os = strdup (str ? str : "");
             if (ret->os == NULL)
               {
-                free_image_spec_schema_config_schema (ret);
                 return NULL;
               }
           }
@@ -854,13 +929,11 @@ make_image_spec_schema_config_schema (ya
     ret->config = make_image_spec_schema_config_schema_config (get_val (tree, "config", yajl_t_object), ctx, err);
     if (ret->config == NULL && *err != 0)
       {
-        free_image_spec_schema_config_schema (ret);
         return NULL;
       }
     ret->rootfs = make_image_spec_schema_config_schema_rootfs (get_val (tree, "rootfs", yajl_t_object), ctx, err);
     if (ret->rootfs == NULL && *err != 0)
       {
-        free_image_spec_schema_config_schema (ret);
         return NULL;
       }
     do
@@ -875,7 +948,6 @@ make_image_spec_schema_config_schema (ya
             ret->history = calloc (len + 1, sizeof (*ret->history));
             if (ret->history == NULL)
               {
-                free_image_spec_schema_config_schema (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -884,7 +956,6 @@ make_image_spec_schema_config_schema (ya
                 ret->history[i] = make_image_spec_schema_config_schema_history_element (val, ctx, err);
                 if (ret->history[i] == NULL)
                   {
-                    free_image_spec_schema_config_schema (ret);
                     return NULL;
                 }
             }
@@ -895,27 +966,50 @@ make_image_spec_schema_config_schema (ya
       {
         if (asprintf (err, "Required field '%s' not present",  "architecture") < 0)
             *err = strdup ("error allocating memory");
-        free_image_spec_schema_config_schema (ret);
         return NULL;
       }
     if (ret->os == NULL)
       {
         if (asprintf (err, "Required field '%s' not present",  "os") < 0)
             *err = strdup ("error allocating memory");
-        free_image_spec_schema_config_schema (ret);
         return NULL;
       }
     if (ret->rootfs == NULL)
       {
         if (asprintf (err, "Required field '%s' not present",  "rootfs") < 0)
             *err = strdup ("error allocating memory");
-        free_image_spec_schema_config_schema (ret);
         return NULL;
       }
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "created")
@@ -924,14 +1018,28 @@ make_image_spec_schema_config_schema (ya
                 && strcmp (tree->u.object.keys[i], "os")
                 && strcmp (tree->u.object.keys[i], "config")
                 && strcmp (tree->u.object.keys[i], "rootfs")
-                && strcmp (tree->u.object.keys[i], "history") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "history"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -969,6 +1077,8 @@ free_image_spec_schema_config_schema (im
         free (ptr->history);
         ptr->history = NULL;
       }
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -1072,6 +1182,12 @@ gen_image_spec_schema_config_schema (yaj
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
@@ -1084,7 +1200,7 @@ image_spec_schema_config_schema_parse_fi
 {
     image_spec_schema_config_schema *ptr = NULL;
     size_t filesize;
-    char *content = NULL;
+    __auto_free char *content = NULL;
 
     if (filename == NULL || err == NULL)
       return NULL;
@@ -1098,15 +1214,15 @@ image_spec_schema_config_schema_parse_fi
         return NULL;
       }
     ptr = image_spec_schema_config_schema_parse_data (content, ctx, err);
-    free (content);
     return ptr;
 }
 
-image_spec_schema_config_schema *image_spec_schema_config_schema_parse_file_stream (FILE *stream, const struct parser_context *ctx, parser_error *err)
+image_spec_schema_config_schema *
+image_spec_schema_config_schema_parse_file_stream (FILE *stream, const struct parser_context *ctx, parser_error *err)
 {
     image_spec_schema_config_schema *ptr = NULL;
     size_t filesize;
-    char *content = NULL ;
+    __auto_free char *content = NULL ;
 
     if (stream == NULL || err == NULL)
       return NULL;
@@ -1119,14 +1235,16 @@ image_spec_schema_config_schema *image_s
         return NULL;
       }
     ptr = image_spec_schema_config_schema_parse_data (content, ctx, err);
-    free (content);
     return ptr;
 }
 
-image_spec_schema_config_schema *image_spec_schema_config_schema_parse_data (const char *jsondata, const struct parser_context *ctx, parser_error *err)
+define_cleaner_function (yajl_val, yajl_tree_free)
+
+image_spec_schema_config_schema *
+image_spec_schema_config_schema_parse_data (const char *jsondata, const struct parser_context *ctx, parser_error *err)
 {
     image_spec_schema_config_schema *ptr = NULL;
-    yajl_val tree;
+    __auto_cleanup(yajl_tree_free) yajl_val tree;
     char errbuf[1024];
     struct parser_context tmp_ctx = { 0 };
 
@@ -1145,12 +1263,24 @@ image_spec_schema_config_schema *image_s
         return NULL;
       }
     ptr = make_image_spec_schema_config_schema (tree, ctx, err);
-    yajl_tree_free (tree);
     return ptr;
 }
-char *image_spec_schema_config_schema_generate_json(const image_spec_schema_config_schema *ptr, const struct parser_context *ctx, parser_error *err)
+
+static void
+cleanup_yajl_gen (yajl_gen g)
 {
-    yajl_gen g = NULL;
+    if (!g)
+      return;
+    yajl_gen_clear (g);
+    yajl_gen_free (g);
+}
+
+define_cleaner_function (yajl_gen, cleanup_yajl_gen)
+
+char *
+image_spec_schema_config_schema_generate_json (const image_spec_schema_config_schema *ptr, const struct parser_context *ctx, parser_error *err)
+{
+    __auto_cleanup(cleanup_yajl_gen) yajl_gen g = NULL;
     struct parser_context tmp_ctx = { 0 };
     const unsigned char *gen_buf = NULL;
     char *json_buf = NULL;
@@ -1166,35 +1296,31 @@ char *image_spec_schema_config_schema_ge
     if (!json_gen_init(&g, ctx))
       {
         *err = strdup ("Json_gen init failed");
-        goto out;
+        return json_buf;
       }
 
     if (yajl_gen_status_ok != gen_image_spec_schema_config_schema (g, ptr, ctx, err))
       {
         if (*err == NULL)
             *err = strdup ("Failed to generate json");
-        goto free_out;
+        return json_buf;
       }
 
     yajl_gen_get_buf (g, &gen_buf, &gen_len);
     if (gen_buf == NULL)
       {
         *err = strdup ("Error to get generated json");
-        goto free_out;
+        return json_buf;
       }
 
     json_buf = calloc (1, gen_len + 1);
     if (json_buf == NULL)
       {
         *err = strdup ("Cannot allocate memory");
-        goto free_out;
+        return json_buf;
       }
-    (void) memcpy(json_buf, gen_buf, gen_len);
+    (void) memcpy (json_buf, gen_buf, gen_len);
     json_buf[gen_len] = '\0';
 
-free_out:
-    yajl_gen_clear (g);
-    yajl_gen_free (g);
-out:
     return json_buf;
 }
diff -pruN 0.14.1+dfsg-1/libocispec/src/image_spec_schema_config_schema.h 0.15+dfsg-1/libocispec/src/image_spec_schema_config_schema.h
--- 0.14.1+dfsg-1/libocispec/src/image_spec_schema_config_schema.h	2020-07-08 06:50:09.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/image_spec_schema_config_schema.h	2020-09-23 11:23:27.000000000 +0000
@@ -33,6 +33,7 @@ typedef struct {
 
     char *stop_signal;
 
+    yajl_val _residual;
 }
 image_spec_schema_config_schema_config;
 
@@ -48,6 +49,7 @@ typedef struct {
 
     char *type;
 
+    yajl_val _residual;
 }
 image_spec_schema_config_schema_rootfs;
 
@@ -87,6 +89,7 @@ typedef struct {
     image_spec_schema_config_schema_history_element **history;
     size_t history_len;
 
+    yajl_val _residual;
 }
 image_spec_schema_config_schema;
 
diff -pruN 0.14.1+dfsg-1/libocispec/src/image_spec_schema_content_descriptor.c 0.15+dfsg-1/libocispec/src/image_spec_schema_content_descriptor.c
--- 0.14.1+dfsg-1/libocispec/src/image_spec_schema_content_descriptor.c	2020-07-08 06:50:09.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/image_spec_schema_content_descriptor.c	2020-09-23 11:23:27.000000000 +0000
@@ -8,14 +8,15 @@
 
 #define YAJL_GET_ARRAY_NO_CHECK(v) (&(v)->u.array)
 #define YAJL_GET_OBJECT_NO_CHECK(v) (&(v)->u.object)
+define_cleaner_function (image_spec_schema_content_descriptor *, free_image_spec_schema_content_descriptor)
 image_spec_schema_content_descriptor *
 make_image_spec_schema_content_descriptor (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    image_spec_schema_content_descriptor *ret = NULL;
+    __auto_cleanup(free_image_spec_schema_content_descriptor) image_spec_schema_content_descriptor *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -28,7 +29,6 @@ make_image_spec_schema_content_descripto
             ret->media_type = strdup (str ? str : "");
             if (ret->media_type == NULL)
               {
-                free_image_spec_schema_content_descriptor (ret);
                 return NULL;
               }
           }
@@ -44,7 +44,6 @@ make_image_spec_schema_content_descripto
               {
                 if (asprintf (err, "Invalid value '%s' with type 'int64' for key 'size': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_image_spec_schema_content_descriptor (ret);
                 return NULL;
             }
             ret->size_present = 1;
@@ -60,7 +59,6 @@ make_image_spec_schema_content_descripto
             ret->digest = strdup (str ? str : "");
             if (ret->digest == NULL)
               {
-                free_image_spec_schema_content_descriptor (ret);
                 return NULL;
               }
           }
@@ -78,7 +76,6 @@ make_image_spec_schema_content_descripto
             ret->urls = calloc (len + 1, sizeof (*ret->urls));
             if (ret->urls == NULL)
               {
-                free_image_spec_schema_content_descriptor (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -90,7 +87,6 @@ make_image_spec_schema_content_descripto
                     ret->urls[i] = strdup (str ? str : "");
                     if (ret->urls[i] == NULL)
                       {
-                        free_image_spec_schema_content_descriptor (ret);
                         return NULL;
                       }
                   }
@@ -111,7 +107,6 @@ make_image_spec_schema_content_descripto
                   new_error = strdup ("error allocating memory");
                 free (*err);
                 *err = new_error;
-                free_image_spec_schema_content_descriptor (ret);
                 return NULL;
             }
         }
@@ -121,34 +116,72 @@ make_image_spec_schema_content_descripto
       {
         if (asprintf (err, "Required field '%s' not present",  "mediaType") < 0)
             *err = strdup ("error allocating memory");
-        free_image_spec_schema_content_descriptor (ret);
         return NULL;
       }
     if (ret->digest == NULL)
       {
         if (asprintf (err, "Required field '%s' not present",  "digest") < 0)
             *err = strdup ("error allocating memory");
-        free_image_spec_schema_content_descriptor (ret);
         return NULL;
       }
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "mediaType")
                 && strcmp (tree->u.object.keys[i], "size")
                 && strcmp (tree->u.object.keys[i], "digest")
                 && strcmp (tree->u.object.keys[i], "urls")
-                && strcmp (tree->u.object.keys[i], "annotations") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "annotations"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -176,6 +209,8 @@ free_image_spec_schema_content_descripto
     }
     free_json_map_string_string (ptr->annotations);
     ptr->annotations = NULL;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -258,6 +293,12 @@ gen_image_spec_schema_content_descriptor
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
@@ -270,7 +311,7 @@ image_spec_schema_content_descriptor_par
 {
     image_spec_schema_content_descriptor *ptr = NULL;
     size_t filesize;
-    char *content = NULL;
+    __auto_free char *content = NULL;
 
     if (filename == NULL || err == NULL)
       return NULL;
@@ -284,15 +325,15 @@ image_spec_schema_content_descriptor_par
         return NULL;
       }
     ptr = image_spec_schema_content_descriptor_parse_data (content, ctx, err);
-    free (content);
     return ptr;
 }
 
-image_spec_schema_content_descriptor *image_spec_schema_content_descriptor_parse_file_stream (FILE *stream, const struct parser_context *ctx, parser_error *err)
+image_spec_schema_content_descriptor *
+image_spec_schema_content_descriptor_parse_file_stream (FILE *stream, const struct parser_context *ctx, parser_error *err)
 {
     image_spec_schema_content_descriptor *ptr = NULL;
     size_t filesize;
-    char *content = NULL ;
+    __auto_free char *content = NULL ;
 
     if (stream == NULL || err == NULL)
       return NULL;
@@ -305,14 +346,16 @@ image_spec_schema_content_descriptor *im
         return NULL;
       }
     ptr = image_spec_schema_content_descriptor_parse_data (content, ctx, err);
-    free (content);
     return ptr;
 }
 
-image_spec_schema_content_descriptor *image_spec_schema_content_descriptor_parse_data (const char *jsondata, const struct parser_context *ctx, parser_error *err)
+define_cleaner_function (yajl_val, yajl_tree_free)
+
+image_spec_schema_content_descriptor *
+image_spec_schema_content_descriptor_parse_data (const char *jsondata, const struct parser_context *ctx, parser_error *err)
 {
     image_spec_schema_content_descriptor *ptr = NULL;
-    yajl_val tree;
+    __auto_cleanup(yajl_tree_free) yajl_val tree;
     char errbuf[1024];
     struct parser_context tmp_ctx = { 0 };
 
@@ -331,12 +374,24 @@ image_spec_schema_content_descriptor *im
         return NULL;
       }
     ptr = make_image_spec_schema_content_descriptor (tree, ctx, err);
-    yajl_tree_free (tree);
     return ptr;
 }
-char *image_spec_schema_content_descriptor_generate_json(const image_spec_schema_content_descriptor *ptr, const struct parser_context *ctx, parser_error *err)
+
+static void
+cleanup_yajl_gen (yajl_gen g)
+{
+    if (!g)
+      return;
+    yajl_gen_clear (g);
+    yajl_gen_free (g);
+}
+
+define_cleaner_function (yajl_gen, cleanup_yajl_gen)
+
+char *
+image_spec_schema_content_descriptor_generate_json (const image_spec_schema_content_descriptor *ptr, const struct parser_context *ctx, parser_error *err)
 {
-    yajl_gen g = NULL;
+    __auto_cleanup(cleanup_yajl_gen) yajl_gen g = NULL;
     struct parser_context tmp_ctx = { 0 };
     const unsigned char *gen_buf = NULL;
     char *json_buf = NULL;
@@ -352,35 +407,31 @@ char *image_spec_schema_content_descript
     if (!json_gen_init(&g, ctx))
       {
         *err = strdup ("Json_gen init failed");
-        goto out;
+        return json_buf;
       }
 
     if (yajl_gen_status_ok != gen_image_spec_schema_content_descriptor (g, ptr, ctx, err))
       {
         if (*err == NULL)
             *err = strdup ("Failed to generate json");
-        goto free_out;
+        return json_buf;
       }
 
     yajl_gen_get_buf (g, &gen_buf, &gen_len);
     if (gen_buf == NULL)
       {
         *err = strdup ("Error to get generated json");
-        goto free_out;
+        return json_buf;
       }
 
     json_buf = calloc (1, gen_len + 1);
     if (json_buf == NULL)
       {
         *err = strdup ("Cannot allocate memory");
-        goto free_out;
+        return json_buf;
       }
-    (void) memcpy(json_buf, gen_buf, gen_len);
+    (void) memcpy (json_buf, gen_buf, gen_len);
     json_buf[gen_len] = '\0';
 
-free_out:
-    yajl_gen_clear (g);
-    yajl_gen_free (g);
-out:
     return json_buf;
 }
diff -pruN 0.14.1+dfsg-1/libocispec/src/image_spec_schema_content_descriptor.h 0.15+dfsg-1/libocispec/src/image_spec_schema_content_descriptor.h
--- 0.14.1+dfsg-1/libocispec/src/image_spec_schema_content_descriptor.h	2020-07-08 06:50:09.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/image_spec_schema_content_descriptor.h	2020-09-23 11:23:27.000000000 +0000
@@ -25,6 +25,7 @@ typedef struct {
 
     json_map_string_string *annotations;
 
+    yajl_val _residual;
 }
 image_spec_schema_content_descriptor;
 
diff -pruN 0.14.1+dfsg-1/libocispec/src/image_spec_schema_defs.c 0.15+dfsg-1/libocispec/src/image_spec_schema_defs.c
--- 0.14.1+dfsg-1/libocispec/src/image_spec_schema_defs.c	2020-07-08 06:50:09.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/image_spec_schema_defs.c	2020-09-23 11:23:27.000000000 +0000
@@ -8,18 +8,19 @@
 
 #define YAJL_GET_ARRAY_NO_CHECK(v) (&(v)->u.array)
 #define YAJL_GET_OBJECT_NO_CHECK(v) (&(v)->u.object)
+define_cleaner_function (image_spec_schema_defs_map_string_object_element *, free_image_spec_schema_defs_map_string_object_element)
 image_spec_schema_defs_map_string_object_element *
 make_image_spec_schema_defs_map_string_object_element (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    image_spec_schema_defs_map_string_object_element *ret = NULL;
+    __auto_cleanup(free_image_spec_schema_defs_map_string_object_element) image_spec_schema_defs_map_string_object_element *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -49,14 +50,15 @@ gen_image_spec_schema_defs_map_string_ob
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (image_spec_schema_defs_map_string_object *, free_image_spec_schema_defs_map_string_object)
 image_spec_schema_defs_map_string_object *
 make_image_spec_schema_defs_map_string_object (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    image_spec_schema_defs_map_string_object *ret = NULL;
+    __auto_cleanup(free_image_spec_schema_defs_map_string_object) image_spec_schema_defs_map_string_object *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -73,7 +75,6 @@ make_image_spec_schema_defs_map_string_o
         ret->values = calloc (len + 1, sizeof (*ret->values));
         if (ret->values == NULL)
           {
-            free (ret->keys);
             return NULL;
           }
         for (i = 0; i < len; i++)
@@ -83,19 +84,17 @@ make_image_spec_schema_defs_map_string_o
             ret->keys[i] = strdup (tmpkey ? tmpkey : "");
             if (ret->keys[i] == NULL)
               {
-                free_image_spec_schema_defs_map_string_object (ret);
                 return NULL;
               }
             val = values[i];
             ret->values[i] = make_image_spec_schema_defs_map_string_object_element (val, ctx, err);
             if (ret->values[i] == NULL)
               {
-                free_image_spec_schema_defs_map_string_object (ret);
                 return NULL;
               }
         }
     }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
diff -pruN 0.14.1+dfsg-1/libocispec/src/image_spec_schema_image_index_schema.c 0.15+dfsg-1/libocispec/src/image_spec_schema_image_index_schema.c
--- 0.14.1+dfsg-1/libocispec/src/image_spec_schema_image_index_schema.c	2020-07-08 06:50:09.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/image_spec_schema_image_index_schema.c	2020-09-23 11:23:27.000000000 +0000
@@ -8,14 +8,15 @@
 
 #define YAJL_GET_ARRAY_NO_CHECK(v) (&(v)->u.array)
 #define YAJL_GET_OBJECT_NO_CHECK(v) (&(v)->u.object)
+define_cleaner_function (image_spec_schema_image_index_schema_manifests_platform *, free_image_spec_schema_image_index_schema_manifests_platform)
 image_spec_schema_image_index_schema_manifests_platform *
 make_image_spec_schema_image_index_schema_manifests_platform (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    image_spec_schema_image_index_schema_manifests_platform *ret = NULL;
+    __auto_cleanup(free_image_spec_schema_image_index_schema_manifests_platform) image_spec_schema_image_index_schema_manifests_platform *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -28,7 +29,6 @@ make_image_spec_schema_image_index_schem
             ret->architecture = strdup (str ? str : "");
             if (ret->architecture == NULL)
               {
-                free_image_spec_schema_image_index_schema_manifests_platform (ret);
                 return NULL;
               }
           }
@@ -43,7 +43,6 @@ make_image_spec_schema_image_index_schem
             ret->os = strdup (str ? str : "");
             if (ret->os == NULL)
               {
-                free_image_spec_schema_image_index_schema_manifests_platform (ret);
                 return NULL;
               }
           }
@@ -58,7 +57,6 @@ make_image_spec_schema_image_index_schem
             ret->os_version = strdup (str ? str : "");
             if (ret->os_version == NULL)
               {
-                free_image_spec_schema_image_index_schema_manifests_platform (ret);
                 return NULL;
               }
           }
@@ -76,7 +74,6 @@ make_image_spec_schema_image_index_schem
             ret->os_features = calloc (len + 1, sizeof (*ret->os_features));
             if (ret->os_features == NULL)
               {
-                free_image_spec_schema_image_index_schema_manifests_platform (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -88,7 +85,6 @@ make_image_spec_schema_image_index_schem
                     ret->os_features[i] = strdup (str ? str : "");
                     if (ret->os_features[i] == NULL)
                       {
-                        free_image_spec_schema_image_index_schema_manifests_platform (ret);
                         return NULL;
                       }
                   }
@@ -105,7 +101,6 @@ make_image_spec_schema_image_index_schem
             ret->variant = strdup (str ? str : "");
             if (ret->variant == NULL)
               {
-                free_image_spec_schema_image_index_schema_manifests_platform (ret);
                 return NULL;
               }
           }
@@ -115,34 +110,72 @@ make_image_spec_schema_image_index_schem
       {
         if (asprintf (err, "Required field '%s' not present",  "architecture") < 0)
             *err = strdup ("error allocating memory");
-        free_image_spec_schema_image_index_schema_manifests_platform (ret);
         return NULL;
       }
     if (ret->os == NULL)
       {
         if (asprintf (err, "Required field '%s' not present",  "os") < 0)
             *err = strdup ("error allocating memory");
-        free_image_spec_schema_image_index_schema_manifests_platform (ret);
         return NULL;
       }
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "architecture")
                 && strcmp (tree->u.object.keys[i], "os")
                 && strcmp (tree->u.object.keys[i], "os.version")
                 && strcmp (tree->u.object.keys[i], "os.features")
-                && strcmp (tree->u.object.keys[i], "variant") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "variant"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -172,6 +205,8 @@ free_image_spec_schema_image_index_schem
     }
     free (ptr->variant);
     ptr->variant = NULL;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -257,20 +292,27 @@ gen_image_spec_schema_image_index_schema
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (image_spec_schema_image_index_schema_manifests_element *, free_image_spec_schema_image_index_schema_manifests_element)
 image_spec_schema_image_index_schema_manifests_element *
 make_image_spec_schema_image_index_schema_manifests_element (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    image_spec_schema_image_index_schema_manifests_element *ret = NULL;
+    __auto_cleanup(free_image_spec_schema_image_index_schema_manifests_element) image_spec_schema_image_index_schema_manifests_element *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -283,7 +325,6 @@ make_image_spec_schema_image_index_schem
             ret->media_type = strdup (str ? str : "");
             if (ret->media_type == NULL)
               {
-                free_image_spec_schema_image_index_schema_manifests_element (ret);
                 return NULL;
               }
           }
@@ -299,7 +340,6 @@ make_image_spec_schema_image_index_schem
               {
                 if (asprintf (err, "Invalid value '%s' with type 'int64' for key 'size': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_image_spec_schema_image_index_schema_manifests_element (ret);
                 return NULL;
             }
             ret->size_present = 1;
@@ -315,7 +355,6 @@ make_image_spec_schema_image_index_schem
             ret->digest = strdup (str ? str : "");
             if (ret->digest == NULL)
               {
-                free_image_spec_schema_image_index_schema_manifests_element (ret);
                 return NULL;
               }
           }
@@ -333,7 +372,6 @@ make_image_spec_schema_image_index_schem
             ret->urls = calloc (len + 1, sizeof (*ret->urls));
             if (ret->urls == NULL)
               {
-                free_image_spec_schema_image_index_schema_manifests_element (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -345,7 +383,6 @@ make_image_spec_schema_image_index_schem
                     ret->urls[i] = strdup (str ? str : "");
                     if (ret->urls[i] == NULL)
                       {
-                        free_image_spec_schema_image_index_schema_manifests_element (ret);
                         return NULL;
                       }
                   }
@@ -356,7 +393,6 @@ make_image_spec_schema_image_index_schem
     ret->platform = make_image_spec_schema_image_index_schema_manifests_platform (get_val (tree, "platform", yajl_t_object), ctx, err);
     if (ret->platform == NULL && *err != 0)
       {
-        free_image_spec_schema_image_index_schema_manifests_element (ret);
         return NULL;
       }
     do
@@ -372,7 +408,6 @@ make_image_spec_schema_image_index_schem
                   new_error = strdup ("error allocating memory");
                 free (*err);
                 *err = new_error;
-                free_image_spec_schema_image_index_schema_manifests_element (ret);
                 return NULL;
             }
         }
@@ -382,17 +417,15 @@ make_image_spec_schema_image_index_schem
       {
         if (asprintf (err, "Required field '%s' not present",  "mediaType") < 0)
             *err = strdup ("error allocating memory");
-        free_image_spec_schema_image_index_schema_manifests_element (ret);
         return NULL;
       }
     if (ret->digest == NULL)
       {
         if (asprintf (err, "Required field '%s' not present",  "digest") < 0)
             *err = strdup ("error allocating memory");
-        free_image_spec_schema_image_index_schema_manifests_element (ret);
         return NULL;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -522,14 +555,15 @@ gen_image_spec_schema_image_index_schema
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (image_spec_schema_image_index_schema *, free_image_spec_schema_image_index_schema)
 image_spec_schema_image_index_schema *
 make_image_spec_schema_image_index_schema (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    image_spec_schema_image_index_schema *ret = NULL;
+    __auto_cleanup(free_image_spec_schema_image_index_schema) image_spec_schema_image_index_schema *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -543,7 +577,6 @@ make_image_spec_schema_image_index_schem
               {
                 if (asprintf (err, "Invalid value '%s' with type 'integer' for key 'schemaVersion': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_image_spec_schema_image_index_schema (ret);
                 return NULL;
             }
             ret->schema_version_present = 1;
@@ -562,7 +595,6 @@ make_image_spec_schema_image_index_schem
             ret->manifests = calloc (len + 1, sizeof (*ret->manifests));
             if (ret->manifests == NULL)
               {
-                free_image_spec_schema_image_index_schema (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -571,7 +603,6 @@ make_image_spec_schema_image_index_schem
                 ret->manifests[i] = make_image_spec_schema_image_index_schema_manifests_element (val, ctx, err);
                 if (ret->manifests[i] == NULL)
                   {
-                    free_image_spec_schema_image_index_schema (ret);
                     return NULL;
                 }
             }
@@ -591,7 +622,6 @@ make_image_spec_schema_image_index_schem
                   new_error = strdup ("error allocating memory");
                 free (*err);
                 *err = new_error;
-                free_image_spec_schema_image_index_schema (ret);
                 return NULL;
             }
         }
@@ -601,25 +631,64 @@ make_image_spec_schema_image_index_schem
       {
         if (asprintf (err, "Required field '%s' not present",  "manifests") < 0)
             *err = strdup ("error allocating memory");
-        free_image_spec_schema_image_index_schema (ret);
         return NULL;
       }
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "schemaVersion")
                 && strcmp (tree->u.object.keys[i], "manifests")
-                && strcmp (tree->u.object.keys[i], "annotations") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "annotations"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -641,6 +710,8 @@ free_image_spec_schema_image_index_schem
       }
     free_json_map_string_string (ptr->annotations);
     ptr->annotations = NULL;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -699,6 +770,12 @@ gen_image_spec_schema_image_index_schema
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
@@ -711,7 +788,7 @@ image_spec_schema_image_index_schema_par
 {
     image_spec_schema_image_index_schema *ptr = NULL;
     size_t filesize;
-    char *content = NULL;
+    __auto_free char *content = NULL;
 
     if (filename == NULL || err == NULL)
       return NULL;
@@ -725,15 +802,15 @@ image_spec_schema_image_index_schema_par
         return NULL;
       }
     ptr = image_spec_schema_image_index_schema_parse_data (content, ctx, err);
-    free (content);
     return ptr;
 }
 
-image_spec_schema_image_index_schema *image_spec_schema_image_index_schema_parse_file_stream (FILE *stream, const struct parser_context *ctx, parser_error *err)
+image_spec_schema_image_index_schema *
+image_spec_schema_image_index_schema_parse_file_stream (FILE *stream, const struct parser_context *ctx, parser_error *err)
 {
     image_spec_schema_image_index_schema *ptr = NULL;
     size_t filesize;
-    char *content = NULL ;
+    __auto_free char *content = NULL ;
 
     if (stream == NULL || err == NULL)
       return NULL;
@@ -746,14 +823,16 @@ image_spec_schema_image_index_schema *im
         return NULL;
       }
     ptr = image_spec_schema_image_index_schema_parse_data (content, ctx, err);
-    free (content);
     return ptr;
 }
 
-image_spec_schema_image_index_schema *image_spec_schema_image_index_schema_parse_data (const char *jsondata, const struct parser_context *ctx, parser_error *err)
+define_cleaner_function (yajl_val, yajl_tree_free)
+
+image_spec_schema_image_index_schema *
+image_spec_schema_image_index_schema_parse_data (const char *jsondata, const struct parser_context *ctx, parser_error *err)
 {
     image_spec_schema_image_index_schema *ptr = NULL;
-    yajl_val tree;
+    __auto_cleanup(yajl_tree_free) yajl_val tree;
     char errbuf[1024];
     struct parser_context tmp_ctx = { 0 };
 
@@ -772,12 +851,24 @@ image_spec_schema_image_index_schema *im
         return NULL;
       }
     ptr = make_image_spec_schema_image_index_schema (tree, ctx, err);
-    yajl_tree_free (tree);
     return ptr;
 }
-char *image_spec_schema_image_index_schema_generate_json(const image_spec_schema_image_index_schema *ptr, const struct parser_context *ctx, parser_error *err)
+
+static void
+cleanup_yajl_gen (yajl_gen g)
 {
-    yajl_gen g = NULL;
+    if (!g)
+      return;
+    yajl_gen_clear (g);
+    yajl_gen_free (g);
+}
+
+define_cleaner_function (yajl_gen, cleanup_yajl_gen)
+
+char *
+image_spec_schema_image_index_schema_generate_json (const image_spec_schema_image_index_schema *ptr, const struct parser_context *ctx, parser_error *err)
+{
+    __auto_cleanup(cleanup_yajl_gen) yajl_gen g = NULL;
     struct parser_context tmp_ctx = { 0 };
     const unsigned char *gen_buf = NULL;
     char *json_buf = NULL;
@@ -793,35 +884,31 @@ char *image_spec_schema_image_index_sche
     if (!json_gen_init(&g, ctx))
       {
         *err = strdup ("Json_gen init failed");
-        goto out;
+        return json_buf;
       }
 
     if (yajl_gen_status_ok != gen_image_spec_schema_image_index_schema (g, ptr, ctx, err))
       {
         if (*err == NULL)
             *err = strdup ("Failed to generate json");
-        goto free_out;
+        return json_buf;
       }
 
     yajl_gen_get_buf (g, &gen_buf, &gen_len);
     if (gen_buf == NULL)
       {
         *err = strdup ("Error to get generated json");
-        goto free_out;
+        return json_buf;
       }
 
     json_buf = calloc (1, gen_len + 1);
     if (json_buf == NULL)
       {
         *err = strdup ("Cannot allocate memory");
-        goto free_out;
+        return json_buf;
       }
-    (void) memcpy(json_buf, gen_buf, gen_len);
+    (void) memcpy (json_buf, gen_buf, gen_len);
     json_buf[gen_len] = '\0';
 
-free_out:
-    yajl_gen_clear (g);
-    yajl_gen_free (g);
-out:
     return json_buf;
 }
diff -pruN 0.14.1+dfsg-1/libocispec/src/image_spec_schema_image_index_schema.h 0.15+dfsg-1/libocispec/src/image_spec_schema_image_index_schema.h
--- 0.14.1+dfsg-1/libocispec/src/image_spec_schema_image_index_schema.h	2020-07-08 06:50:09.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/image_spec_schema_image_index_schema.h	2020-09-23 11:23:27.000000000 +0000
@@ -24,6 +24,7 @@ typedef struct {
 
     char *variant;
 
+    yajl_val _residual;
 }
 image_spec_schema_image_index_schema_manifests_platform;
 
@@ -59,6 +60,7 @@ typedef struct {
 
     json_map_string_string *annotations;
 
+    yajl_val _residual;
 }
 image_spec_schema_image_index_schema;
 
diff -pruN 0.14.1+dfsg-1/libocispec/src/image_spec_schema_image_layout_schema.c 0.15+dfsg-1/libocispec/src/image_spec_schema_image_layout_schema.c
--- 0.14.1+dfsg-1/libocispec/src/image_spec_schema_image_layout_schema.c	2020-07-08 06:50:09.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/image_spec_schema_image_layout_schema.c	2020-09-23 11:23:27.000000000 +0000
@@ -8,14 +8,15 @@
 
 #define YAJL_GET_ARRAY_NO_CHECK(v) (&(v)->u.array)
 #define YAJL_GET_OBJECT_NO_CHECK(v) (&(v)->u.object)
+define_cleaner_function (image_spec_schema_image_layout_schema *, free_image_spec_schema_image_layout_schema)
 image_spec_schema_image_layout_schema *
 make_image_spec_schema_image_layout_schema (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    image_spec_schema_image_layout_schema *ret = NULL;
+    __auto_cleanup(free_image_spec_schema_image_layout_schema) image_spec_schema_image_layout_schema *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -28,7 +29,6 @@ make_image_spec_schema_image_layout_sche
             ret->image_layout_version = strdup (str ? str : "");
             if (ret->image_layout_version == NULL)
               {
-                free_image_spec_schema_image_layout_schema (ret);
                 return NULL;
               }
           }
@@ -38,23 +38,62 @@ make_image_spec_schema_image_layout_sche
       {
         if (asprintf (err, "Required field '%s' not present",  "imageLayoutVersion") < 0)
             *err = strdup ("error allocating memory");
-        free_image_spec_schema_image_layout_schema (ret);
         return NULL;
       }
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
-            if (strcmp (tree->u.object.keys[i], "imageLayoutVersion") && ctx->errfile != NULL)
+            if (strcmp (tree->u.object.keys[i], "imageLayoutVersion"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -64,6 +103,8 @@ free_image_spec_schema_image_layout_sche
         return;
     free (ptr->image_layout_version);
     ptr->image_layout_version = NULL;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -88,6 +129,12 @@ gen_image_spec_schema_image_layout_schem
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
@@ -100,7 +147,7 @@ image_spec_schema_image_layout_schema_pa
 {
     image_spec_schema_image_layout_schema *ptr = NULL;
     size_t filesize;
-    char *content = NULL;
+    __auto_free char *content = NULL;
 
     if (filename == NULL || err == NULL)
       return NULL;
@@ -114,15 +161,15 @@ image_spec_schema_image_layout_schema_pa
         return NULL;
       }
     ptr = image_spec_schema_image_layout_schema_parse_data (content, ctx, err);
-    free (content);
     return ptr;
 }
 
-image_spec_schema_image_layout_schema *image_spec_schema_image_layout_schema_parse_file_stream (FILE *stream, const struct parser_context *ctx, parser_error *err)
+image_spec_schema_image_layout_schema *
+image_spec_schema_image_layout_schema_parse_file_stream (FILE *stream, const struct parser_context *ctx, parser_error *err)
 {
     image_spec_schema_image_layout_schema *ptr = NULL;
     size_t filesize;
-    char *content = NULL ;
+    __auto_free char *content = NULL ;
 
     if (stream == NULL || err == NULL)
       return NULL;
@@ -135,14 +182,16 @@ image_spec_schema_image_layout_schema *i
         return NULL;
       }
     ptr = image_spec_schema_image_layout_schema_parse_data (content, ctx, err);
-    free (content);
     return ptr;
 }
 
-image_spec_schema_image_layout_schema *image_spec_schema_image_layout_schema_parse_data (const char *jsondata, const struct parser_context *ctx, parser_error *err)
+define_cleaner_function (yajl_val, yajl_tree_free)
+
+image_spec_schema_image_layout_schema *
+image_spec_schema_image_layout_schema_parse_data (const char *jsondata, const struct parser_context *ctx, parser_error *err)
 {
     image_spec_schema_image_layout_schema *ptr = NULL;
-    yajl_val tree;
+    __auto_cleanup(yajl_tree_free) yajl_val tree;
     char errbuf[1024];
     struct parser_context tmp_ctx = { 0 };
 
@@ -161,12 +210,24 @@ image_spec_schema_image_layout_schema *i
         return NULL;
       }
     ptr = make_image_spec_schema_image_layout_schema (tree, ctx, err);
-    yajl_tree_free (tree);
     return ptr;
 }
-char *image_spec_schema_image_layout_schema_generate_json(const image_spec_schema_image_layout_schema *ptr, const struct parser_context *ctx, parser_error *err)
+
+static void
+cleanup_yajl_gen (yajl_gen g)
+{
+    if (!g)
+      return;
+    yajl_gen_clear (g);
+    yajl_gen_free (g);
+}
+
+define_cleaner_function (yajl_gen, cleanup_yajl_gen)
+
+char *
+image_spec_schema_image_layout_schema_generate_json (const image_spec_schema_image_layout_schema *ptr, const struct parser_context *ctx, parser_error *err)
 {
-    yajl_gen g = NULL;
+    __auto_cleanup(cleanup_yajl_gen) yajl_gen g = NULL;
     struct parser_context tmp_ctx = { 0 };
     const unsigned char *gen_buf = NULL;
     char *json_buf = NULL;
@@ -182,35 +243,31 @@ char *image_spec_schema_image_layout_sch
     if (!json_gen_init(&g, ctx))
       {
         *err = strdup ("Json_gen init failed");
-        goto out;
+        return json_buf;
       }
 
     if (yajl_gen_status_ok != gen_image_spec_schema_image_layout_schema (g, ptr, ctx, err))
       {
         if (*err == NULL)
             *err = strdup ("Failed to generate json");
-        goto free_out;
+        return json_buf;
       }
 
     yajl_gen_get_buf (g, &gen_buf, &gen_len);
     if (gen_buf == NULL)
       {
         *err = strdup ("Error to get generated json");
-        goto free_out;
+        return json_buf;
       }
 
     json_buf = calloc (1, gen_len + 1);
     if (json_buf == NULL)
       {
         *err = strdup ("Cannot allocate memory");
-        goto free_out;
+        return json_buf;
       }
-    (void) memcpy(json_buf, gen_buf, gen_len);
+    (void) memcpy (json_buf, gen_buf, gen_len);
     json_buf[gen_len] = '\0';
 
-free_out:
-    yajl_gen_clear (g);
-    yajl_gen_free (g);
-out:
     return json_buf;
 }
diff -pruN 0.14.1+dfsg-1/libocispec/src/image_spec_schema_image_layout_schema.h 0.15+dfsg-1/libocispec/src/image_spec_schema_image_layout_schema.h
--- 0.14.1+dfsg-1/libocispec/src/image_spec_schema_image_layout_schema.h	2020-07-08 06:50:09.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/image_spec_schema_image_layout_schema.h	2020-09-23 11:23:27.000000000 +0000
@@ -13,6 +13,7 @@ extern "C" {
 typedef struct {
     char *image_layout_version;
 
+    yajl_val _residual;
 }
 image_spec_schema_image_layout_schema;
 
diff -pruN 0.14.1+dfsg-1/libocispec/src/image_spec_schema_image_manifest_schema.c 0.15+dfsg-1/libocispec/src/image_spec_schema_image_manifest_schema.c
--- 0.14.1+dfsg-1/libocispec/src/image_spec_schema_image_manifest_schema.c	2020-07-08 06:50:09.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/image_spec_schema_image_manifest_schema.c	2020-09-23 11:23:27.000000000 +0000
@@ -8,14 +8,15 @@
 
 #define YAJL_GET_ARRAY_NO_CHECK(v) (&(v)->u.array)
 #define YAJL_GET_OBJECT_NO_CHECK(v) (&(v)->u.object)
+define_cleaner_function (image_spec_schema_image_manifest_schema *, free_image_spec_schema_image_manifest_schema)
 image_spec_schema_image_manifest_schema *
 make_image_spec_schema_image_manifest_schema (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    image_spec_schema_image_manifest_schema *ret = NULL;
+    __auto_cleanup(free_image_spec_schema_image_manifest_schema) image_spec_schema_image_manifest_schema *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -29,7 +30,6 @@ make_image_spec_schema_image_manifest_sc
               {
                 if (asprintf (err, "Invalid value '%s' with type 'integer' for key 'schemaVersion': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_image_spec_schema_image_manifest_schema (ret);
                 return NULL;
             }
             ret->schema_version_present = 1;
@@ -39,7 +39,6 @@ make_image_spec_schema_image_manifest_sc
     ret->config = make_image_spec_schema_content_descriptor (get_val (tree, "config", yajl_t_object), ctx, err);
     if (ret->config == NULL && *err != 0)
       {
-        free_image_spec_schema_image_manifest_schema (ret);
         return NULL;
       }
     do
@@ -54,7 +53,6 @@ make_image_spec_schema_image_manifest_sc
             ret->layers = calloc (len + 1, sizeof (*ret->layers));
             if (ret->layers == NULL)
               {
-                free_image_spec_schema_image_manifest_schema (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -63,7 +61,6 @@ make_image_spec_schema_image_manifest_sc
                 ret->layers[i] = make_image_spec_schema_content_descriptor (val, ctx, err);
                 if (ret->layers[i] == NULL)
                   {
-                    free_image_spec_schema_image_manifest_schema (ret);
                     return NULL;
                 }
             }
@@ -83,7 +80,6 @@ make_image_spec_schema_image_manifest_sc
                   new_error = strdup ("error allocating memory");
                 free (*err);
                 *err = new_error;
-                free_image_spec_schema_image_manifest_schema (ret);
                 return NULL;
             }
         }
@@ -93,33 +89,71 @@ make_image_spec_schema_image_manifest_sc
       {
         if (asprintf (err, "Required field '%s' not present",  "config") < 0)
             *err = strdup ("error allocating memory");
-        free_image_spec_schema_image_manifest_schema (ret);
         return NULL;
       }
     if (ret->layers == NULL)
       {
         if (asprintf (err, "Required field '%s' not present",  "layers") < 0)
             *err = strdup ("error allocating memory");
-        free_image_spec_schema_image_manifest_schema (ret);
         return NULL;
       }
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "schemaVersion")
                 && strcmp (tree->u.object.keys[i], "config")
                 && strcmp (tree->u.object.keys[i], "layers")
-                && strcmp (tree->u.object.keys[i], "annotations") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "annotations"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -146,6 +180,8 @@ free_image_spec_schema_image_manifest_sc
       }
     free_json_map_string_string (ptr->annotations);
     ptr->annotations = NULL;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -213,6 +249,12 @@ gen_image_spec_schema_image_manifest_sch
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
@@ -225,7 +267,7 @@ image_spec_schema_image_manifest_schema_
 {
     image_spec_schema_image_manifest_schema *ptr = NULL;
     size_t filesize;
-    char *content = NULL;
+    __auto_free char *content = NULL;
 
     if (filename == NULL || err == NULL)
       return NULL;
@@ -239,15 +281,15 @@ image_spec_schema_image_manifest_schema_
         return NULL;
       }
     ptr = image_spec_schema_image_manifest_schema_parse_data (content, ctx, err);
-    free (content);
     return ptr;
 }
 
-image_spec_schema_image_manifest_schema *image_spec_schema_image_manifest_schema_parse_file_stream (FILE *stream, const struct parser_context *ctx, parser_error *err)
+image_spec_schema_image_manifest_schema *
+image_spec_schema_image_manifest_schema_parse_file_stream (FILE *stream, const struct parser_context *ctx, parser_error *err)
 {
     image_spec_schema_image_manifest_schema *ptr = NULL;
     size_t filesize;
-    char *content = NULL ;
+    __auto_free char *content = NULL ;
 
     if (stream == NULL || err == NULL)
       return NULL;
@@ -260,14 +302,16 @@ image_spec_schema_image_manifest_schema
         return NULL;
       }
     ptr = image_spec_schema_image_manifest_schema_parse_data (content, ctx, err);
-    free (content);
     return ptr;
 }
 
-image_spec_schema_image_manifest_schema *image_spec_schema_image_manifest_schema_parse_data (const char *jsondata, const struct parser_context *ctx, parser_error *err)
+define_cleaner_function (yajl_val, yajl_tree_free)
+
+image_spec_schema_image_manifest_schema *
+image_spec_schema_image_manifest_schema_parse_data (const char *jsondata, const struct parser_context *ctx, parser_error *err)
 {
     image_spec_schema_image_manifest_schema *ptr = NULL;
-    yajl_val tree;
+    __auto_cleanup(yajl_tree_free) yajl_val tree;
     char errbuf[1024];
     struct parser_context tmp_ctx = { 0 };
 
@@ -286,12 +330,24 @@ image_spec_schema_image_manifest_schema
         return NULL;
       }
     ptr = make_image_spec_schema_image_manifest_schema (tree, ctx, err);
-    yajl_tree_free (tree);
     return ptr;
 }
-char *image_spec_schema_image_manifest_schema_generate_json(const image_spec_schema_image_manifest_schema *ptr, const struct parser_context *ctx, parser_error *err)
+
+static void
+cleanup_yajl_gen (yajl_gen g)
 {
-    yajl_gen g = NULL;
+    if (!g)
+      return;
+    yajl_gen_clear (g);
+    yajl_gen_free (g);
+}
+
+define_cleaner_function (yajl_gen, cleanup_yajl_gen)
+
+char *
+image_spec_schema_image_manifest_schema_generate_json (const image_spec_schema_image_manifest_schema *ptr, const struct parser_context *ctx, parser_error *err)
+{
+    __auto_cleanup(cleanup_yajl_gen) yajl_gen g = NULL;
     struct parser_context tmp_ctx = { 0 };
     const unsigned char *gen_buf = NULL;
     char *json_buf = NULL;
@@ -307,35 +363,31 @@ char *image_spec_schema_image_manifest_s
     if (!json_gen_init(&g, ctx))
       {
         *err = strdup ("Json_gen init failed");
-        goto out;
+        return json_buf;
       }
 
     if (yajl_gen_status_ok != gen_image_spec_schema_image_manifest_schema (g, ptr, ctx, err))
       {
         if (*err == NULL)
             *err = strdup ("Failed to generate json");
-        goto free_out;
+        return json_buf;
       }
 
     yajl_gen_get_buf (g, &gen_buf, &gen_len);
     if (gen_buf == NULL)
       {
         *err = strdup ("Error to get generated json");
-        goto free_out;
+        return json_buf;
       }
 
     json_buf = calloc (1, gen_len + 1);
     if (json_buf == NULL)
       {
         *err = strdup ("Cannot allocate memory");
-        goto free_out;
+        return json_buf;
       }
-    (void) memcpy(json_buf, gen_buf, gen_len);
+    (void) memcpy (json_buf, gen_buf, gen_len);
     json_buf[gen_len] = '\0';
 
-free_out:
-    yajl_gen_clear (g);
-    yajl_gen_free (g);
-out:
     return json_buf;
 }
diff -pruN 0.14.1+dfsg-1/libocispec/src/image_spec_schema_image_manifest_schema.h 0.15+dfsg-1/libocispec/src/image_spec_schema_image_manifest_schema.h
--- 0.14.1+dfsg-1/libocispec/src/image_spec_schema_image_manifest_schema.h	2020-07-08 06:50:09.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/image_spec_schema_image_manifest_schema.h	2020-09-23 11:23:27.000000000 +0000
@@ -24,6 +24,7 @@ typedef struct {
 
     json_map_string_string *annotations;
 
+    yajl_val _residual;
 }
 image_spec_schema_image_manifest_schema;
 
diff -pruN 0.14.1+dfsg-1/libocispec/src/json_common.c 0.15+dfsg-1/libocispec/src/json_common.c
--- 0.14.1+dfsg-1/libocispec/src/json_common.c	2020-07-08 06:50:09.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/json_common.c	2020-09-23 11:23:27.000000000 +0000
@@ -11,6 +11,117 @@
 
 # define MAX_NUM_STR_LEN 21
 
+static yajl_gen_status gen_yajl_val (yajl_val obj, yajl_gen g, parser_error *err);
+
+static yajl_gen_status gen_yajl_val_obj (yajl_val obj, yajl_gen g, parser_error *err)
+{
+    size_t i;
+    yajl_gen_status stat = yajl_gen_status_ok;
+
+    stat = yajl_gen_map_open (g);
+    if (yajl_gen_status_ok != stat)
+        GEN_SET_ERROR_AND_RETURN (stat, err);
+
+    for (i = 0; i < obj->u.object.len; i++)
+    {
+        stat = yajl_gen_string (g, (const unsigned char *) obj->u.object.keys[i], strlen (obj->u.object.keys[i]));
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+        stat = gen_yajl_val (obj->u.object.values[i], g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
+
+    stat = yajl_gen_map_close (g);
+    if (yajl_gen_status_ok != stat)
+        GEN_SET_ERROR_AND_RETURN (stat, err);
+    return yajl_gen_status_ok;
+}
+
+static yajl_gen_status gen_yajl_val_array (yajl_val arr, yajl_gen g, parser_error *err)
+{
+    size_t i;
+    yajl_gen_status stat = yajl_gen_status_ok;
+
+    stat = yajl_gen_array_open (g);
+    if (yajl_gen_status_ok != stat)
+        GEN_SET_ERROR_AND_RETURN (stat, err);
+
+    for (i = 0; i < arr->u.array.len; i++)
+    {
+        stat = gen_yajl_val (arr->u.array.values[i], g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
+
+    stat = yajl_gen_array_close (g);
+    if (yajl_gen_status_ok != stat)
+        GEN_SET_ERROR_AND_RETURN (stat, err);
+    return yajl_gen_status_ok;
+}
+
+static yajl_gen_status gen_yajl_val (yajl_val obj, yajl_gen g, parser_error *err)
+{
+    yajl_gen_status __stat = yajl_gen_status_ok;
+    char *__tstr;
+
+    switch(obj->type)
+    {
+        case yajl_t_string:
+            __tstr = YAJL_GET_STRING (obj);
+            if (__tstr == NULL) {
+                return __stat;
+            }
+            __stat = yajl_gen_string (g, (const unsigned char *) __tstr, strlen (__tstr));
+            if (yajl_gen_status_ok != __stat)
+                GEN_SET_ERROR_AND_RETURN (__stat, err);
+            return yajl_gen_status_ok;
+        case yajl_t_number:
+            __tstr = YAJL_GET_NUMBER (obj);
+            if (__tstr == NULL) {
+                return __stat;
+            }
+            __stat = yajl_gen_number (g, __tstr, strlen (__tstr));
+            if (yajl_gen_status_ok != __stat)
+                GEN_SET_ERROR_AND_RETURN (__stat, err);
+            return yajl_gen_status_ok;
+        case yajl_t_object:
+            return gen_yajl_val_obj (obj, g, err);
+        case yajl_t_array:
+            return gen_yajl_val_array (obj, g, err);
+        case yajl_t_true:
+            return yajl_gen_bool (g, true);
+        case yajl_t_false:
+            return yajl_gen_bool (g, false);
+        case yajl_t_null:
+        case yajl_t_any:
+            return __stat;
+    }
+    return __stat;
+}
+
+yajl_gen_status gen_yajl_object_residual (yajl_val obj, yajl_gen g, parser_error *err)
+{
+    size_t i;
+    yajl_gen_status stat = yajl_gen_status_ok;
+
+    for (i = 0; i < obj->u.object.len; i++)
+    {
+        if (obj->u.object.keys[i] == NULL)
+        {
+            continue;
+        }
+        stat = yajl_gen_string (g, (const unsigned char *) obj->u.object.keys[i], strlen (obj->u.object.keys[i]));
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+        stat = gen_yajl_val (obj->u.object.values[i], g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
+
+    return yajl_gen_status_ok;
+}
+
 yajl_gen_status
 map_uint (void *ctx, long long unsigned int num)
 {
@@ -341,8 +452,8 @@ gen_json_map_int_int (void *ctx, const j
 		  (long long int) map->keys[i]);
       if (nret < 0 || (size_t) nret >= sizeof (numstr))
 	{
-	  if (!*err && asprintf (err, "Error to print string") < 0)
-	    *(err) = strdup ("error allocating memory");
+	  if (!*err)
+            *err = strdup ("Error to print string");
 	  return yajl_gen_in_error_state;
 	}
       stat =
@@ -376,11 +487,13 @@ free_json_map_int_int (json_map_int_int
     }
 }
 
+define_cleaner_function (json_map_int_int *, free_json_map_int_int)
+
 json_map_int_int *
 make_json_map_int_int (yajl_val src, const struct parser_context *ctx,
 		       parser_error * err)
 {
-  json_map_int_int *ret = NULL;
+  __auto_cleanup(free_json_map_int_int) json_map_int_int *ret = NULL;
   size_t i;
   size_t len;
 
@@ -398,15 +511,12 @@ make_json_map_int_int (yajl_val src, con
   ret->keys = calloc (len + 1, sizeof (int));
   if (ret->keys == NULL)
     {
-      free (ret);
       return NULL;
     }
 
   ret->values = calloc (len + 1, sizeof (int));
   if (ret->values == NULL)
     {
-      free (ret->keys);
-      free (ret);
       return NULL;
     }
 
@@ -424,10 +534,11 @@ make_json_map_int_int (yajl_val src, con
           int invalid = common_safe_int (srckey, &(ret->keys[i]));
           if (invalid)
             {
-              free_json_map_int_int (ret);
-              if (*err == NULL)
-                asprintf (err, "Invalid key '%s' with type 'int': %s",
-                          srckey, strerror (-invalid));
+              if (*err == NULL && asprintf (err, "Invalid key '%s' with type 'int': %s",
+                    srckey, strerror (-invalid)) < 0)
+                {
+                  *err = strdup ("error allocating memory");
+                }
               return NULL;
             }
         }
@@ -437,32 +548,34 @@ make_json_map_int_int (yajl_val src, con
           int invalid;
           if (!YAJL_IS_NUMBER (srcval))
             {
-              free_json_map_int_int (ret);
-              if (*err == NULL)
-                asprintf (err, "Invalid value with type 'int' for key '%s'",
-                          srckey);
+              if (*err == NULL && asprintf (err,
+                    "Invalid value with type 'int' for key '%s'", srckey) < 0)
+                {
+                  *err = strdup ("error allocating memory");
+                }
               return NULL;
             }
           invalid = common_safe_int (YAJL_GET_NUMBER (srcval), &(ret->values[i]));
           if (invalid)
             {
-              free_json_map_int_int (ret);
-              if (*err == NULL)
-                asprintf (err, "Invalid value with type 'int' for key '%s': %s",
-                          srckey, strerror (-invalid));
+              if (*err == NULL && asprintf (err, "Invalid value with type 'int' for key '%s': %s",
+                    srckey, strerror (-invalid)) < 0)
+                {
+                  *err = strdup ("error allocating memory");
+                }
               return NULL;
             }
         }
     }
-  return ret;
+  return move_ptr (ret);
 }
 
 int
 append_json_map_int_int (json_map_int_int * map, int key, int val)
 {
   size_t len;
-  int *keys = NULL;
-  int *vals = NULL;
+  __auto_free int *keys = NULL;
+  __auto_free int *vals = NULL;
 
   if (map == NULL)
     return -1;
@@ -477,7 +590,6 @@ append_json_map_int_int (json_map_int_in
   vals = calloc (1, len * sizeof (int));
   if (vals == NULL)
     {
-      free (keys);
       return -1;
     }
 
@@ -488,8 +600,10 @@ append_json_map_int_int (json_map_int_in
     }
   free (map->keys);
   map->keys = keys;
+  keys = NULL;
   free (map->values);
   map->values = vals;
+  vals = NULL;
   map->keys[map->len] = key;
   map->values[map->len] = val;
 
@@ -521,7 +635,7 @@ gen_json_map_int_bool (void *ctx, const
       if (nret < 0 || (size_t) nret >= sizeof (numstr))
 	{
 	  if (!*err)
-            asprintf (err, "Error to print string");
+            *err = strdup ("Error to print string");
 	  return yajl_gen_in_error_state;
 	}
       stat =
@@ -561,11 +675,13 @@ free_json_map_int_bool (json_map_int_boo
     }
 }
 
+define_cleaner_function (json_map_int_bool *, free_json_map_int_bool)
+
 json_map_int_bool *
 make_json_map_int_bool (yajl_val src, const struct parser_context *ctx,
 			parser_error * err)
 {
-  json_map_int_bool *ret = NULL;
+  __auto_cleanup(free_json_map_int_bool) json_map_int_bool *ret = NULL;
   size_t i;
   size_t len;
 
@@ -582,14 +698,11 @@ make_json_map_int_bool (yajl_val src, co
   ret->keys = calloc (len + 1, sizeof (int));
   if (ret->keys == NULL)
     {
-      free (ret);
       return NULL;
     }
   ret->values = calloc (len + 1, sizeof (bool));
   if (ret->values == NULL)
     {
-      free (ret->keys);
-      free (ret);
       return NULL;
     }
   for (i = 0; i < len; i++)
@@ -606,10 +719,11 @@ make_json_map_int_bool (yajl_val src, co
           int invalid = common_safe_int (srckey, &(ret->keys[i]));
           if (invalid)
             {
-              free_json_map_int_bool (ret);
-              if (*err == NULL)
-                asprintf (err, "Invalid key '%s' with type 'int': %s",
-                          srckey, strerror (-invalid));
+              if (*err == NULL && asprintf (err, "Invalid key '%s' with type 'int': %s",
+                    srckey, strerror (-invalid)) < 0)
+                {
+                  *err = strdup ("error allocating memory");
+                }
               return NULL;
             }
         }
@@ -622,23 +736,24 @@ make_json_map_int_bool (yajl_val src, co
             ret->values[i] = false;
           else
             {
-              free_json_map_int_bool (ret);
-              if (*err == NULL)
-                asprintf (err, "Invalid value with type 'bool' for key '%s'",
-                          srckey);
+              if (*err == NULL && asprintf (err,
+                    "Invalid value with type 'bool' for key '%s'", srckey) < 0)
+                {
+                  *err = strdup ("error allocating memory");
+                }
               return NULL;
             }
         }
     }
-  return ret;
+  return move_ptr (ret);
 }
 
 int
 append_json_map_int_bool (json_map_int_bool * map, int key, bool val)
 {
   size_t len;
-  int *keys = NULL;
-  bool *vals = NULL;
+  __auto_free int *keys = NULL;
+  __auto_free bool *vals = NULL;
 
   if (map == NULL)
     return -1;
@@ -654,7 +769,6 @@ append_json_map_int_bool (json_map_int_b
   vals = calloc (len, sizeof (bool));
   if (vals == NULL)
     {
-      free (keys);
       return -1;
     }
 
@@ -665,8 +779,10 @@ append_json_map_int_bool (json_map_int_b
     }
   free (map->keys);
   map->keys = keys;
+  keys = NULL;
   free (map->values);
   map->values = vals;
+  vals = NULL;
   map->keys[map->len] = key;
   map->values[map->len] = val;
 
@@ -699,7 +815,7 @@ gen_json_map_int_string (void *ctx, cons
       if (nret < 0 || (size_t) nret >= sizeof (numstr))
 	{
 	  if (!*err)
-            asprintf (err, "Error to print string");
+            *err = strdup ("Error to print string");
 	  return yajl_gen_in_error_state;
 	}
       stat =
@@ -743,13 +859,15 @@ free_json_map_int_string (json_map_int_s
     }
 }
 
+define_cleaner_function (json_map_int_string *, free_json_map_int_string)
+
 json_map_int_string *
 make_json_map_int_string (yajl_val src, const struct parser_context *ctx,
 			  parser_error * err)
 {
+  __auto_cleanup(free_json_map_int_string) json_map_int_string *ret = NULL;
   size_t i;
   size_t len;
-  json_map_int_string *ret = NULL;
 
   if (src == NULL || YAJL_GET_OBJECT (src) == NULL)
     return NULL;
@@ -766,15 +884,12 @@ make_json_map_int_string (yajl_val src,
   ret->keys = calloc (len + 1, sizeof (int));
   if (ret->keys == NULL)
     {
-      free (ret);
       return NULL;
     }
 
   ret->values = calloc (len + 1, sizeof (char *));
   if (ret->values == NULL)
     {
-      free (ret->keys);
-      free (ret);
       return NULL;
     }
 
@@ -793,10 +908,11 @@ make_json_map_int_string (yajl_val src,
           invalid = common_safe_int (srckey, &(ret->keys[i]));
           if (invalid)
             {
-              free_json_map_int_string (ret);
-              if (*err == NULL)
-                asprintf (err, "Invalid key '%s' with type 'int': %s",
-                          srckey, strerror (-invalid));
+              if (*err == NULL && asprintf (err, "Invalid key '%s' with type 'int': %s",
+                    srckey, strerror (-invalid)) < 0)
+                {
+                  *err = strdup ("error allocating memory");
+                }
               return NULL;
             }
         }
@@ -805,17 +921,18 @@ make_json_map_int_string (yajl_val src,
         {
           if (!YAJL_IS_STRING (srcval))
             {
-              free_json_map_int_string (ret);
-              if (*err == NULL)
-                asprintf (err, "Invalid value with type 'string' for key '%s'",
-                          srckey);
+              if (*err == NULL && asprintf (err,
+                   "Invalid value with type 'string' for key '%s'", srckey) < 0)
+                {
+                  *err = strdup ("error allocating memory");
+                }
               return NULL;
             }
           char *str = YAJL_GET_STRING_NO_CHECK (srcval);
           ret->values[i] = strdup (str ? str : "");
         }
     }
-  return ret;
+  return move_ptr (ret);
 }
 
 int
@@ -909,11 +1026,13 @@ free_json_map_string_int (json_map_strin
     }
 }
 
+define_cleaner_function (json_map_string_int *, free_json_map_string_int)
+
 json_map_string_int *
 make_json_map_string_int (yajl_val src, const struct parser_context *ctx,
 			  parser_error * err)
 {
-  json_map_string_int *ret = NULL;
+  __auto_cleanup(free_json_map_string_int) json_map_string_int *ret = NULL;
   size_t i;
   size_t len;
 
@@ -933,15 +1052,12 @@ make_json_map_string_int (yajl_val src,
   ret->keys = calloc (len + 1, sizeof (char *));
   if (ret->keys == NULL)
     {
-      free (ret);
       *(err) = strdup ("error allocating memory");
       return NULL;
     }
   ret->values = calloc (len + 1, sizeof (int));
   if (ret->values == NULL)
     {
-      free (ret->keys);
-      free (ret);
       *(err) = strdup ("error allocating memory");
       return NULL;
     }
@@ -957,7 +1073,6 @@ make_json_map_string_int (yajl_val src,
       ret->keys[i] = strdup (srckey ? srckey : "");
       if (ret->keys[i] == NULL)
         {
-          free_json_map_string_int (ret);
           *(err) = strdup ("error allocating memory");
           return NULL;
         }
@@ -967,24 +1082,26 @@ make_json_map_string_int (yajl_val src,
           int invalid;
           if (!YAJL_IS_NUMBER (srcval))
             {
-              free_json_map_string_int (ret);
-              if (*err == NULL)
-                asprintf (err, "Invalid value with type 'int' for key '%s'",
-                          srckey);
+              if (*err == NULL && asprintf (err,
+                    "Invalid value with type 'int' for key '%s'", srckey) < 0)
+                {
+                  *err = strdup ("error allocating memory");
+                }
               return NULL;
             }
           invalid = common_safe_int (YAJL_GET_NUMBER (srcval), &(ret->values[i]));
           if (invalid)
             {
-              free_json_map_string_int (ret);
-              if (*err == NULL)
-                asprintf (err, "Invalid value with type 'int' for key '%s': %s",
-                          srckey, strerror (-invalid));
+              if (*err == NULL && asprintf (err, "Invalid value with type 'int' for key '%s': %s",
+                    srckey, strerror (-invalid)) < 0)
+                {
+                  *err = strdup ("error allocating memory");
+                }
               return NULL;
             }
         }
     }
-  return ret;
+  return move_ptr (ret);
 }
 
 int
@@ -1078,11 +1195,13 @@ free_json_map_string_bool (json_map_stri
     }
 }
 
+define_cleaner_function (json_map_string_bool *, free_json_map_string_bool)
+
 json_map_string_bool *
 make_json_map_string_bool (yajl_val src, const struct parser_context *ctx,
 			   parser_error * err)
 {
-  json_map_string_bool *ret = NULL;
+  __auto_cleanup(free_json_map_string_bool) json_map_string_bool *ret = NULL;
   size_t i;
   size_t len;
 
@@ -1100,15 +1219,12 @@ make_json_map_string_bool (yajl_val src,
   ret->keys = calloc (len + 1, sizeof (char *));
   if (ret->keys == NULL)
     {
-      free (ret);
       return NULL;
     }
 
   ret->values = calloc (len + 1, sizeof (bool));
   if (ret->values == NULL)
     {
-      free (ret->values);
-      free (ret);
       return NULL;
     }
   for (i = 0; i < len; i++)
@@ -1123,7 +1239,6 @@ make_json_map_string_bool (yajl_val src,
       ret->keys[i] = strdup (srckey ? srckey : "");
       if (ret->keys[i] == NULL)
         {
-          free_json_map_string_bool (ret);
           *(err) = strdup ("error allocating memory");
           return NULL;
         }
@@ -1135,15 +1250,16 @@ make_json_map_string_bool (yajl_val src,
             ret->values[i] = false;
           else
             {
-              free_json_map_string_bool (ret);
-              if (*err == NULL)
-                asprintf (err, "Invalid value with type 'bool' for key '%s'",
-                          srckey);
+              if (*err == NULL && asprintf (err,
+                   "Invalid value with type 'bool' for key '%s'", srckey) < 0)
+                {
+                  *err = strdup ("error allocating memory");
+                }
               return NULL;
             }
         }
     }
-  return ret;
+  return move_ptr (ret);
 }
 
 int
@@ -1151,9 +1267,9 @@ append_json_map_string_bool (json_map_st
 			     bool val)
 {
   size_t len;
-  char **keys = NULL;
-  bool *vals = NULL;
-  char *new_value;
+  __auto_free char **keys = NULL;
+  __auto_free bool *vals = NULL;
+  __auto_free char *new_value;
 
   if (map == NULL)
     return -1;
@@ -1169,15 +1285,12 @@ append_json_map_string_bool (json_map_st
   vals = calloc (len, sizeof (bool));
   if (vals == NULL)
     {
-      free (keys);
       return -1;
     }
 
   new_value = strdup (key ? key : "");
   if (new_value == NULL)
     {
-      free (vals);
-      free (keys);
       return -1;
     }
 
@@ -1188,9 +1301,12 @@ append_json_map_string_bool (json_map_st
     }
   free (map->keys);
   map->keys = keys;
+  keys = NULL;
   free (map->values);
   map->values = vals;
+  vals = NULL;
   map->keys[map->len] = new_value;
+  new_value = NULL;
   map->values[map->len] = val;
 
   map->len++;
@@ -1259,11 +1375,13 @@ free_json_map_string_string (json_map_st
     }
 }
 
+define_cleaner_function (json_map_string_string *, free_json_map_string_string)
+
 json_map_string_string *
 make_json_map_string_string (yajl_val src, const struct parser_context *ctx,
 			     parser_error * err)
 {
-  json_map_string_string *ret = NULL;
+  __auto_cleanup(free_json_map_string_string) json_map_string_string *ret = NULL;
   size_t i;
   size_t len;
 
@@ -1285,7 +1403,6 @@ make_json_map_string_string (yajl_val sr
   ret->keys = calloc (len + 1, sizeof (char *));
   if (ret->keys == NULL)
     {
-      free (ret);
       *(err) = strdup ("error allocating memory");
       return NULL;
     }
@@ -1293,8 +1410,6 @@ make_json_map_string_string (yajl_val sr
   ret->values = calloc (len + 1, sizeof (char *));
   if (ret->values == NULL)
     {
-      free (ret->keys);
-      free (ret);
       *(err) = strdup ("error allocating memory");
       return NULL;
     }
@@ -1310,7 +1425,6 @@ make_json_map_string_string (yajl_val sr
       ret->keys[i] = strdup (srckey ? srckey : "");
       if (ret->keys[i] == NULL)
         {
-          free_json_map_string_string (ret);
           return NULL;
         }
       if (srcval != NULL)
@@ -1318,10 +1432,11 @@ make_json_map_string_string (yajl_val sr
           char *str;
           if (!YAJL_IS_STRING (srcval))
             {
-              free_json_map_string_string (ret);
-              if (*err == NULL)
-                asprintf (err, "Invalid value with type 'string' for key '%s'",
-                          srckey);
+              if (*err == NULL && asprintf (err,
+                   "Invalid value with type 'string' for key '%s'", srckey) < 0)
+                {
+                  *err = strdup ("error allocating memory");
+                }
               return NULL;
             }
 
@@ -1330,12 +1445,11 @@ make_json_map_string_string (yajl_val sr
           ret->values[i] = strdup (str ? str : "");
           if (ret->values[i] == NULL)
             {
-              free_json_map_string_string (ret);
               return NULL;
             }
         }
     }
-  return ret;
+  return move_ptr (ret);
 }
 
 int
@@ -1343,10 +1457,10 @@ append_json_map_string_string (json_map_
 			       const char *val)
 {
   size_t len, i;
-  char **keys = NULL;
-  char **values = NULL;
-  char *new_key = NULL;
-  char *new_value = NULL;
+  __auto_free char **keys = NULL;
+  __auto_free char **values = NULL;
+  __auto_free char *new_key = NULL;
+  __auto_free char *new_value = NULL;
 
   if (map == NULL)
     return -1;
@@ -1369,41 +1483,51 @@ append_json_map_string_string (json_map_
 
   new_key = strdup (key ? key : "");
   if (new_key == NULL)
-    goto cleanup;
+    return -1;
 
   new_value = strdup (val ? val : "");
   if (new_value == NULL)
-    goto cleanup;
+    return -1;
 
   len = map->len + 1;
   keys = realloc (map->keys, len * sizeof (char *));
   if (keys == NULL)
-    goto cleanup;
+    return -1;
   map->keys = keys;
+  keys = NULL;
   map->keys[map->len] = NULL;
 
   values = realloc (map->values, len * sizeof (char *));
   if (values == NULL)
-    goto cleanup;
+    return -1;
 
   map->keys[map->len] = new_key;
+  new_key = NULL;
   map->values = values;
+  values = NULL;
   map->values[map->len] = new_value;
+  new_value = NULL;
 
   map->len++;
   return 0;
+}
 
- cleanup:
-  free (new_value);
-  free (new_key);
-  return -1;
+static void
+cleanup_yajl_gen(yajl_gen g)
+{
+  if (!g)
+    return;
+  yajl_gen_clear (g);
+  yajl_gen_free (g);
 }
 
+define_cleaner_function (yajl_gen, cleanup_yajl_gen)
+
 char *
 json_marshal_string (const char *str, size_t length,
 		     const struct parser_context *ctx, parser_error * err)
 {
-  yajl_gen g = NULL;
+  __auto_cleanup(cleanup_yajl_gen) yajl_gen g = NULL;
   struct parser_context tmp_ctx = { 0 };
   const unsigned char *gen_buf = NULL;
   char *json_buf = NULL;
@@ -1420,35 +1544,32 @@ json_marshal_string (const char *str, si
   if (!json_gen_init (&g, ctx))
     {
       *err = strdup ("Json_gen init failed");
-      goto out;
+      return json_buf;
     }
   stat = yajl_gen_string ((yajl_gen) g, (const unsigned char *) str, length);
   if (yajl_gen_status_ok != stat)
     {
-      asprintf (err, "error generating json, errcode: %d", (int) stat);
-      goto free_out;
+      if (asprintf (err, "error generating json, errcode: %d", (int) stat) < 0)
+          *err = strdup ("error allocating memory");
+      return json_buf;
     }
   yajl_gen_get_buf (g, &gen_buf, &gen_len);
   if (gen_buf == NULL)
     {
       *err = strdup ("Error to get generated json");
-      goto free_out;
+      return json_buf;
     }
 
   json_buf = calloc (1, gen_len + 1);
   if (json_buf == NULL)
     {
       *err = strdup ("error allocating memory");
-      goto free_out;
+      return json_buf;
     }
 
   (void) memcpy (json_buf, gen_buf, gen_len);
   json_buf[gen_len] = '\0';
 
-free_out:
-  yajl_gen_clear (g);
-  yajl_gen_free (g);
-out:
   return json_buf;
 }
         
\ No newline at end of file
diff -pruN 0.14.1+dfsg-1/libocispec/src/json_common.h 0.15+dfsg-1/libocispec/src/json_common.h
--- 0.14.1+dfsg-1/libocispec/src/json_common.h	2020-07-08 06:50:09.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/json_common.h	2020-09-23 11:23:27.000000000 +0000
@@ -22,8 +22,32 @@ extern "C" {
 # define OPT_GEN_KEY_VALUE 0x02
 // options to generate simplify(no indent) json string
 # define OPT_GEN_SIMPLIFY 0x04
+// options to keep all keys and values, even do not known
+# define OPT_PARSE_FULLKEY 0x08
 // options not to validate utf8 data
-# define OPT_GEN_NO_VALIDATE_UTF8 0x08
+# define OPT_GEN_NO_VALIDATE_UTF8 0x10
+
+#define define_cleaner_function(type, cleaner)           \
+        static inline void cleaner##_function(type *ptr) \
+        {                                                \
+                if (*ptr)                                \
+                        cleaner(*ptr);                   \
+        }
+
+#define __auto_cleanup(cleaner) __attribute__((__cleanup__(cleaner##_function)))
+
+static inline void ptr_free_function(void *p) {
+    free(*(void**)p);
+}
+
+#define __auto_free __auto_cleanup(ptr_free)
+
+#define move_ptr(ptr)                                 \
+        ({                                            \
+                typeof(ptr) moved_ptr = (ptr);        \
+                (ptr) = NULL;                         \
+                moved_ptr;                            \
+        })
 
 # define GEN_SET_ERROR_AND_RETURN(stat, err) { \
     if (*(err) == NULL) {\
@@ -42,6 +66,8 @@ struct parser_context
   FILE *errfile;
 };
 
+yajl_gen_status gen_yajl_object_residual (yajl_val obj, yajl_gen g, parser_error *err);
+
 yajl_gen_status map_uint (void *ctx, long long unsigned int num);
 
 yajl_gen_status map_int (void *ctx, long long int num);
diff -pruN 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_config_linux.c 0.15+dfsg-1/libocispec/src/runtime_spec_schema_config_linux.c
--- 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_config_linux.c	2020-07-08 06:50:09.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/runtime_spec_schema_config_linux.c	2020-09-23 11:23:27.000000000 +0000
@@ -8,14 +8,15 @@
 
 #define YAJL_GET_ARRAY_NO_CHECK(v) (&(v)->u.array)
 #define YAJL_GET_OBJECT_NO_CHECK(v) (&(v)->u.object)
+define_cleaner_function (runtime_spec_schema_config_linux_resources_pids *, free_runtime_spec_schema_config_linux_resources_pids)
 runtime_spec_schema_config_linux_resources_pids *
 make_runtime_spec_schema_config_linux_resources_pids (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_linux_resources_pids *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_linux_resources_pids) runtime_spec_schema_config_linux_resources_pids *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -29,7 +30,6 @@ make_runtime_spec_schema_config_linux_re
               {
                 if (asprintf (err, "Invalid value '%s' with type 'int64' for key 'limit': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_config_linux_resources_pids (ret);
                 return NULL;
             }
             ret->limit_present = 1;
@@ -37,19 +37,59 @@ make_runtime_spec_schema_config_linux_re
       }
     while (0);
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
-            if (strcmp (tree->u.object.keys[i], "limit") && ctx->errfile != NULL)
+            if (strcmp (tree->u.object.keys[i], "limit"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -57,6 +97,8 @@ free_runtime_spec_schema_config_linux_re
 {
     if (ptr == NULL)
         return;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -81,20 +123,27 @@ gen_runtime_spec_schema_config_linux_res
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_config_linux_resources_block_io *, free_runtime_spec_schema_config_linux_resources_block_io)
 runtime_spec_schema_config_linux_resources_block_io *
 make_runtime_spec_schema_config_linux_resources_block_io (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_linux_resources_block_io *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_linux_resources_block_io) runtime_spec_schema_config_linux_resources_block_io *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -108,7 +157,6 @@ make_runtime_spec_schema_config_linux_re
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint16' for key 'weight': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_config_linux_resources_block_io (ret);
                 return NULL;
             }
             ret->weight_present = 1;
@@ -125,7 +173,6 @@ make_runtime_spec_schema_config_linux_re
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint16' for key 'leafWeight': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_config_linux_resources_block_io (ret);
                 return NULL;
             }
             ret->leaf_weight_present = 1;
@@ -144,7 +191,6 @@ make_runtime_spec_schema_config_linux_re
             ret->throttle_read_bps_device = calloc (len + 1, sizeof (*ret->throttle_read_bps_device));
             if (ret->throttle_read_bps_device == NULL)
               {
-                free_runtime_spec_schema_config_linux_resources_block_io (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -153,7 +199,6 @@ make_runtime_spec_schema_config_linux_re
                 ret->throttle_read_bps_device[i] = make_runtime_spec_schema_defs_linux_block_io_device_throttle (val, ctx, err);
                 if (ret->throttle_read_bps_device[i] == NULL)
                   {
-                    free_runtime_spec_schema_config_linux_resources_block_io (ret);
                     return NULL;
                 }
             }
@@ -172,7 +217,6 @@ make_runtime_spec_schema_config_linux_re
             ret->throttle_write_bps_device = calloc (len + 1, sizeof (*ret->throttle_write_bps_device));
             if (ret->throttle_write_bps_device == NULL)
               {
-                free_runtime_spec_schema_config_linux_resources_block_io (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -181,7 +225,6 @@ make_runtime_spec_schema_config_linux_re
                 ret->throttle_write_bps_device[i] = make_runtime_spec_schema_defs_linux_block_io_device_throttle (val, ctx, err);
                 if (ret->throttle_write_bps_device[i] == NULL)
                   {
-                    free_runtime_spec_schema_config_linux_resources_block_io (ret);
                     return NULL;
                 }
             }
@@ -200,7 +243,6 @@ make_runtime_spec_schema_config_linux_re
             ret->throttle_read_iops_device = calloc (len + 1, sizeof (*ret->throttle_read_iops_device));
             if (ret->throttle_read_iops_device == NULL)
               {
-                free_runtime_spec_schema_config_linux_resources_block_io (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -209,7 +251,6 @@ make_runtime_spec_schema_config_linux_re
                 ret->throttle_read_iops_device[i] = make_runtime_spec_schema_defs_linux_block_io_device_throttle (val, ctx, err);
                 if (ret->throttle_read_iops_device[i] == NULL)
                   {
-                    free_runtime_spec_schema_config_linux_resources_block_io (ret);
                     return NULL;
                 }
             }
@@ -228,7 +269,6 @@ make_runtime_spec_schema_config_linux_re
             ret->throttle_write_iops_device = calloc (len + 1, sizeof (*ret->throttle_write_iops_device));
             if (ret->throttle_write_iops_device == NULL)
               {
-                free_runtime_spec_schema_config_linux_resources_block_io (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -237,7 +277,6 @@ make_runtime_spec_schema_config_linux_re
                 ret->throttle_write_iops_device[i] = make_runtime_spec_schema_defs_linux_block_io_device_throttle (val, ctx, err);
                 if (ret->throttle_write_iops_device[i] == NULL)
                   {
-                    free_runtime_spec_schema_config_linux_resources_block_io (ret);
                     return NULL;
                 }
             }
@@ -256,7 +295,6 @@ make_runtime_spec_schema_config_linux_re
             ret->weight_device = calloc (len + 1, sizeof (*ret->weight_device));
             if (ret->weight_device == NULL)
               {
-                free_runtime_spec_schema_config_linux_resources_block_io (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -265,7 +303,6 @@ make_runtime_spec_schema_config_linux_re
                 ret->weight_device[i] = make_runtime_spec_schema_defs_linux_block_io_device_weight (val, ctx, err);
                 if (ret->weight_device[i] == NULL)
                   {
-                    free_runtime_spec_schema_config_linux_resources_block_io (ret);
                     return NULL;
                 }
             }
@@ -273,9 +310,35 @@ make_runtime_spec_schema_config_linux_re
       }
     while (0);
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "weight")
@@ -284,14 +347,28 @@ make_runtime_spec_schema_config_linux_re
                 && strcmp (tree->u.object.keys[i], "throttleWriteBpsDevice")
                 && strcmp (tree->u.object.keys[i], "throttleReadIOPSDevice")
                 && strcmp (tree->u.object.keys[i], "throttleWriteIOPSDevice")
-                && strcmp (tree->u.object.keys[i], "weightDevice") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "weightDevice"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -359,6 +436,8 @@ free_runtime_spec_schema_config_linux_re
         free (ptr->weight_device);
         ptr->weight_device = NULL;
       }
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -520,20 +599,27 @@ gen_runtime_spec_schema_config_linux_res
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_config_linux_resources_cpu *, free_runtime_spec_schema_config_linux_resources_cpu)
 runtime_spec_schema_config_linux_resources_cpu *
 make_runtime_spec_schema_config_linux_resources_cpu (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_linux_resources_cpu *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_linux_resources_cpu) runtime_spec_schema_config_linux_resources_cpu *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -546,7 +632,6 @@ make_runtime_spec_schema_config_linux_re
             ret->cpus = strdup (str ? str : "");
             if (ret->cpus == NULL)
               {
-                free_runtime_spec_schema_config_linux_resources_cpu (ret);
                 return NULL;
               }
           }
@@ -561,7 +646,6 @@ make_runtime_spec_schema_config_linux_re
             ret->mems = strdup (str ? str : "");
             if (ret->mems == NULL)
               {
-                free_runtime_spec_schema_config_linux_resources_cpu (ret);
                 return NULL;
               }
           }
@@ -577,7 +661,6 @@ make_runtime_spec_schema_config_linux_re
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint64' for key 'period': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_config_linux_resources_cpu (ret);
                 return NULL;
             }
             ret->period_present = 1;
@@ -594,7 +677,6 @@ make_runtime_spec_schema_config_linux_re
               {
                 if (asprintf (err, "Invalid value '%s' with type 'int64' for key 'quota': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_config_linux_resources_cpu (ret);
                 return NULL;
             }
             ret->quota_present = 1;
@@ -611,7 +693,6 @@ make_runtime_spec_schema_config_linux_re
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint64' for key 'realtimePeriod': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_config_linux_resources_cpu (ret);
                 return NULL;
             }
             ret->realtime_period_present = 1;
@@ -628,7 +709,6 @@ make_runtime_spec_schema_config_linux_re
               {
                 if (asprintf (err, "Invalid value '%s' with type 'int64' for key 'realtimeRuntime': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_config_linux_resources_cpu (ret);
                 return NULL;
             }
             ret->realtime_runtime_present = 1;
@@ -645,7 +725,6 @@ make_runtime_spec_schema_config_linux_re
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint64' for key 'shares': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_config_linux_resources_cpu (ret);
                 return NULL;
             }
             ret->shares_present = 1;
@@ -653,9 +732,35 @@ make_runtime_spec_schema_config_linux_re
       }
     while (0);
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "cpus")
@@ -664,14 +769,28 @@ make_runtime_spec_schema_config_linux_re
                 && strcmp (tree->u.object.keys[i], "quota")
                 && strcmp (tree->u.object.keys[i], "realtimePeriod")
                 && strcmp (tree->u.object.keys[i], "realtimeRuntime")
-                && strcmp (tree->u.object.keys[i], "shares") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "shares"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -683,6 +802,8 @@ free_runtime_spec_schema_config_linux_re
     ptr->cpus = NULL;
     free (ptr->mems);
     ptr->mems = NULL;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -779,20 +900,27 @@ gen_runtime_spec_schema_config_linux_res
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_config_linux_resources_hugepage_limits_element *, free_runtime_spec_schema_config_linux_resources_hugepage_limits_element)
 runtime_spec_schema_config_linux_resources_hugepage_limits_element *
 make_runtime_spec_schema_config_linux_resources_hugepage_limits_element (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_linux_resources_hugepage_limits_element *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_linux_resources_hugepage_limits_element) runtime_spec_schema_config_linux_resources_hugepage_limits_element *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -805,7 +933,6 @@ make_runtime_spec_schema_config_linux_re
             ret->page_size = strdup (str ? str : "");
             if (ret->page_size == NULL)
               {
-                free_runtime_spec_schema_config_linux_resources_hugepage_limits_element (ret);
                 return NULL;
               }
           }
@@ -821,7 +948,6 @@ make_runtime_spec_schema_config_linux_re
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint64' for key 'limit': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_config_linux_resources_hugepage_limits_element (ret);
                 return NULL;
             }
             ret->limit_present = 1;
@@ -832,10 +958,9 @@ make_runtime_spec_schema_config_linux_re
       {
         if (asprintf (err, "Required field '%s' not present",  "pageSize") < 0)
             *err = strdup ("error allocating memory");
-        free_runtime_spec_schema_config_linux_resources_hugepage_limits_element (ret);
         return NULL;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -887,14 +1012,15 @@ gen_runtime_spec_schema_config_linux_res
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_config_linux_resources_memory *, free_runtime_spec_schema_config_linux_resources_memory)
 runtime_spec_schema_config_linux_resources_memory *
 make_runtime_spec_schema_config_linux_resources_memory (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_linux_resources_memory *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_linux_resources_memory) runtime_spec_schema_config_linux_resources_memory *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -908,7 +1034,6 @@ make_runtime_spec_schema_config_linux_re
               {
                 if (asprintf (err, "Invalid value '%s' with type 'int64' for key 'kernel': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_config_linux_resources_memory (ret);
                 return NULL;
             }
             ret->kernel_present = 1;
@@ -925,7 +1050,6 @@ make_runtime_spec_schema_config_linux_re
               {
                 if (asprintf (err, "Invalid value '%s' with type 'int64' for key 'kernelTCP': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_config_linux_resources_memory (ret);
                 return NULL;
             }
             ret->kernel_tcp_present = 1;
@@ -942,7 +1066,6 @@ make_runtime_spec_schema_config_linux_re
               {
                 if (asprintf (err, "Invalid value '%s' with type 'int64' for key 'limit': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_config_linux_resources_memory (ret);
                 return NULL;
             }
             ret->limit_present = 1;
@@ -959,7 +1082,6 @@ make_runtime_spec_schema_config_linux_re
               {
                 if (asprintf (err, "Invalid value '%s' with type 'int64' for key 'reservation': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_config_linux_resources_memory (ret);
                 return NULL;
             }
             ret->reservation_present = 1;
@@ -976,7 +1098,6 @@ make_runtime_spec_schema_config_linux_re
               {
                 if (asprintf (err, "Invalid value '%s' with type 'int64' for key 'swap': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_config_linux_resources_memory (ret);
                 return NULL;
             }
             ret->swap_present = 1;
@@ -993,7 +1114,6 @@ make_runtime_spec_schema_config_linux_re
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint64' for key 'swappiness': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_config_linux_resources_memory (ret);
                 return NULL;
             }
             ret->swappiness_present = 1;
@@ -1039,9 +1159,35 @@ make_runtime_spec_schema_config_linux_re
       }
     while (0);
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "kernel")
@@ -1051,14 +1197,28 @@ make_runtime_spec_schema_config_linux_re
                 && strcmp (tree->u.object.keys[i], "swap")
                 && strcmp (tree->u.object.keys[i], "swappiness")
                 && strcmp (tree->u.object.keys[i], "disableOOMKiller")
-                && strcmp (tree->u.object.keys[i], "useHierarchy") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "useHierarchy"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -1066,6 +1226,8 @@ free_runtime_spec_schema_config_linux_re
 {
     if (ptr == NULL)
         return;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -1176,20 +1338,27 @@ gen_runtime_spec_schema_config_linux_res
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_config_linux_resources_network *, free_runtime_spec_schema_config_linux_resources_network)
 runtime_spec_schema_config_linux_resources_network *
 make_runtime_spec_schema_config_linux_resources_network (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_linux_resources_network *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_linux_resources_network) runtime_spec_schema_config_linux_resources_network *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -1203,7 +1372,6 @@ make_runtime_spec_schema_config_linux_re
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint32' for key 'classID': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_config_linux_resources_network (ret);
                 return NULL;
             }
             ret->class_id_present = 1;
@@ -1222,7 +1390,6 @@ make_runtime_spec_schema_config_linux_re
             ret->priorities = calloc (len + 1, sizeof (*ret->priorities));
             if (ret->priorities == NULL)
               {
-                free_runtime_spec_schema_config_linux_resources_network (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -1231,7 +1398,6 @@ make_runtime_spec_schema_config_linux_re
                 ret->priorities[i] = make_runtime_spec_schema_defs_linux_network_interface_priority (val, ctx, err);
                 if (ret->priorities[i] == NULL)
                   {
-                    free_runtime_spec_schema_config_linux_resources_network (ret);
                     return NULL;
                 }
             }
@@ -1239,20 +1405,60 @@ make_runtime_spec_schema_config_linux_re
       }
     while (0);
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "classID")
-                && strcmp (tree->u.object.keys[i], "priorities") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "priorities"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -1272,6 +1478,8 @@ free_runtime_spec_schema_config_linux_re
         free (ptr->priorities);
         ptr->priorities = NULL;
       }
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -1321,24 +1529,31 @@ gen_runtime_spec_schema_config_linux_res
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_config_linux_resources_rdma *, free_runtime_spec_schema_config_linux_resources_rdma)
 runtime_spec_schema_config_linux_resources_rdma *
 make_runtime_spec_schema_config_linux_resources_rdma (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_linux_resources_rdma *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_linux_resources_rdma) runtime_spec_schema_config_linux_resources_rdma *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -1368,19 +1583,38 @@ gen_runtime_spec_schema_config_linux_res
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_config_linux_resources *, free_runtime_spec_schema_config_linux_resources)
 runtime_spec_schema_config_linux_resources *
 make_runtime_spec_schema_config_linux_resources (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_linux_resources *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_linux_resources) runtime_spec_schema_config_linux_resources *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
     do
       {
+        yajl_val tmp = get_val (tree, "unified", yajl_t_object);
+        if (tmp != NULL)
+          {
+            ret->unified = make_json_map_string_string (tmp, ctx, err);
+            if (ret->unified == NULL)
+              {
+                char *new_error = NULL;
+                if (asprintf (&new_error, "Value error for key 'unified': %s", *err ? *err : "null") < 0)
+                  new_error = strdup ("error allocating memory");
+                free (*err);
+                *err = new_error;
+                return NULL;
+            }
+        }
+      }
+    while (0);
+    do
+      {
         yajl_val tmp = get_val (tree, "devices", yajl_t_array);
         if (tmp != NULL && YAJL_GET_ARRAY (tmp) != NULL && YAJL_GET_ARRAY_NO_CHECK (tmp)->len > 0)
           {
@@ -1391,7 +1625,6 @@ make_runtime_spec_schema_config_linux_re
             ret->devices = calloc (len + 1, sizeof (*ret->devices));
             if (ret->devices == NULL)
               {
-                free_runtime_spec_schema_config_linux_resources (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -1400,7 +1633,6 @@ make_runtime_spec_schema_config_linux_re
                 ret->devices[i] = make_runtime_spec_schema_defs_linux_device_cgroup (val, ctx, err);
                 if (ret->devices[i] == NULL)
                   {
-                    free_runtime_spec_schema_config_linux_resources (ret);
                     return NULL;
                 }
             }
@@ -1410,19 +1642,16 @@ make_runtime_spec_schema_config_linux_re
     ret->pids = make_runtime_spec_schema_config_linux_resources_pids (get_val (tree, "pids", yajl_t_object), ctx, err);
     if (ret->pids == NULL && *err != 0)
       {
-        free_runtime_spec_schema_config_linux_resources (ret);
         return NULL;
       }
     ret->block_io = make_runtime_spec_schema_config_linux_resources_block_io (get_val (tree, "blockIO", yajl_t_object), ctx, err);
     if (ret->block_io == NULL && *err != 0)
       {
-        free_runtime_spec_schema_config_linux_resources (ret);
         return NULL;
       }
     ret->cpu = make_runtime_spec_schema_config_linux_resources_cpu (get_val (tree, "cpu", yajl_t_object), ctx, err);
     if (ret->cpu == NULL && *err != 0)
       {
-        free_runtime_spec_schema_config_linux_resources (ret);
         return NULL;
       }
     do
@@ -1437,7 +1666,6 @@ make_runtime_spec_schema_config_linux_re
             ret->hugepage_limits = calloc (len + 1, sizeof (*ret->hugepage_limits));
             if (ret->hugepage_limits == NULL)
               {
-                free_runtime_spec_schema_config_linux_resources (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -1446,7 +1674,6 @@ make_runtime_spec_schema_config_linux_re
                 ret->hugepage_limits[i] = make_runtime_spec_schema_config_linux_resources_hugepage_limits_element (val, ctx, err);
                 if (ret->hugepage_limits[i] == NULL)
                   {
-                    free_runtime_spec_schema_config_linux_resources (ret);
                     return NULL;
                 }
             }
@@ -1456,42 +1683,80 @@ make_runtime_spec_schema_config_linux_re
     ret->memory = make_runtime_spec_schema_config_linux_resources_memory (get_val (tree, "memory", yajl_t_object), ctx, err);
     if (ret->memory == NULL && *err != 0)
       {
-        free_runtime_spec_schema_config_linux_resources (ret);
         return NULL;
       }
     ret->network = make_runtime_spec_schema_config_linux_resources_network (get_val (tree, "network", yajl_t_object), ctx, err);
     if (ret->network == NULL && *err != 0)
       {
-        free_runtime_spec_schema_config_linux_resources (ret);
         return NULL;
       }
     ret->rdma = make_runtime_spec_schema_config_linux_resources_rdma (get_val (tree, "rdma", yajl_t_object), ctx, err);
     if (ret->rdma == NULL && *err != 0)
       {
-        free_runtime_spec_schema_config_linux_resources (ret);
         return NULL;
       }
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
-            if (strcmp (tree->u.object.keys[i], "devices")
+            if (strcmp (tree->u.object.keys[i], "unified")
+                && strcmp (tree->u.object.keys[i], "devices")
                 && strcmp (tree->u.object.keys[i], "pids")
                 && strcmp (tree->u.object.keys[i], "blockIO")
                 && strcmp (tree->u.object.keys[i], "cpu")
                 && strcmp (tree->u.object.keys[i], "hugepageLimits")
                 && strcmp (tree->u.object.keys[i], "memory")
                 && strcmp (tree->u.object.keys[i], "network")
-                && strcmp (tree->u.object.keys[i], "rdma") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "rdma"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -1499,6 +1764,8 @@ free_runtime_spec_schema_config_linux_re
 {
     if (ptr == NULL)
         return;
+    free_json_map_string_string (ptr->unified);
+    ptr->unified = NULL;
     if (ptr->devices != NULL)
       {
         size_t i;
@@ -1553,6 +1820,8 @@ free_runtime_spec_schema_config_linux_re
         free_runtime_spec_schema_config_linux_resources_rdma (ptr->rdma);
         ptr->rdma = NULL;
       }
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -1565,6 +1834,15 @@ gen_runtime_spec_schema_config_linux_res
     stat = yajl_gen_map_open ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
+    if ((ctx->options & OPT_GEN_KEY_VALUE) || (ptr != NULL && ptr->unified != NULL))
+      {
+        stat = yajl_gen_string ((yajl_gen) g, (const unsigned char *)("unified"), 7 /* strlen ("unified") */);
+        if (stat != yajl_gen_status_ok)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+        stat = gen_json_map_string_string (g, ptr ? ptr->unified : NULL, ctx, err);
+        if (stat != yajl_gen_status_ok)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+      }
     if ((ctx->options & OPT_GEN_KEY_VALUE) || (ptr != NULL && ptr->devices != NULL))
       {
         size_t len = 0, i;
@@ -1669,20 +1947,27 @@ gen_runtime_spec_schema_config_linux_res
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_config_linux_seccomp *, free_runtime_spec_schema_config_linux_seccomp)
 runtime_spec_schema_config_linux_seccomp *
 make_runtime_spec_schema_config_linux_seccomp (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_linux_seccomp *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_linux_seccomp) runtime_spec_schema_config_linux_seccomp *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -1695,7 +1980,6 @@ make_runtime_spec_schema_config_linux_se
             ret->default_action = strdup (str ? str : "");
             if (ret->default_action == NULL)
               {
-                free_runtime_spec_schema_config_linux_seccomp (ret);
                 return NULL;
               }
           }
@@ -1713,7 +1997,6 @@ make_runtime_spec_schema_config_linux_se
             ret->flags = calloc (len + 1, sizeof (*ret->flags));
             if (ret->flags == NULL)
               {
-                free_runtime_spec_schema_config_linux_seccomp (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -1725,7 +2008,6 @@ make_runtime_spec_schema_config_linux_se
                     ret->flags[i] = strdup (str ? str : "");
                     if (ret->flags[i] == NULL)
                       {
-                        free_runtime_spec_schema_config_linux_seccomp (ret);
                         return NULL;
                       }
                   }
@@ -1745,7 +2027,6 @@ make_runtime_spec_schema_config_linux_se
             ret->architectures = calloc (len + 1, sizeof (*ret->architectures));
             if (ret->architectures == NULL)
               {
-                free_runtime_spec_schema_config_linux_seccomp (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -1757,7 +2038,6 @@ make_runtime_spec_schema_config_linux_se
                     ret->architectures[i] = strdup (str ? str : "");
                     if (ret->architectures[i] == NULL)
                       {
-                        free_runtime_spec_schema_config_linux_seccomp (ret);
                         return NULL;
                       }
                   }
@@ -1777,7 +2057,6 @@ make_runtime_spec_schema_config_linux_se
             ret->syscalls = calloc (len + 1, sizeof (*ret->syscalls));
             if (ret->syscalls == NULL)
               {
-                free_runtime_spec_schema_config_linux_seccomp (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -1786,7 +2065,6 @@ make_runtime_spec_schema_config_linux_se
                 ret->syscalls[i] = make_runtime_spec_schema_defs_linux_syscall (val, ctx, err);
                 if (ret->syscalls[i] == NULL)
                   {
-                    free_runtime_spec_schema_config_linux_seccomp (ret);
                     return NULL;
                 }
             }
@@ -1797,26 +2075,65 @@ make_runtime_spec_schema_config_linux_se
       {
         if (asprintf (err, "Required field '%s' not present",  "defaultAction") < 0)
             *err = strdup ("error allocating memory");
-        free_runtime_spec_schema_config_linux_seccomp (ret);
         return NULL;
       }
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "defaultAction")
                 && strcmp (tree->u.object.keys[i], "flags")
                 && strcmp (tree->u.object.keys[i], "architectures")
-                && strcmp (tree->u.object.keys[i], "syscalls") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "syscalls"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -1866,6 +2183,8 @@ free_runtime_spec_schema_config_linux_se
         free (ptr->syscalls);
         ptr->syscalls = NULL;
       }
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -1965,20 +2284,27 @@ gen_runtime_spec_schema_config_linux_sec
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_config_linux_intel_rdt *, free_runtime_spec_schema_config_linux_intel_rdt)
 runtime_spec_schema_config_linux_intel_rdt *
 make_runtime_spec_schema_config_linux_intel_rdt (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_linux_intel_rdt *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_linux_intel_rdt) runtime_spec_schema_config_linux_intel_rdt *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -1991,7 +2317,6 @@ make_runtime_spec_schema_config_linux_in
             ret->clos_id = strdup (str ? str : "");
             if (ret->clos_id == NULL)
               {
-                free_runtime_spec_schema_config_linux_intel_rdt (ret);
                 return NULL;
               }
           }
@@ -2006,7 +2331,6 @@ make_runtime_spec_schema_config_linux_in
             ret->l3cache_schema = strdup (str ? str : "");
             if (ret->l3cache_schema == NULL)
               {
-                free_runtime_spec_schema_config_linux_intel_rdt (ret);
                 return NULL;
               }
           }
@@ -2021,28 +2345,67 @@ make_runtime_spec_schema_config_linux_in
             ret->mem_bw_schema = strdup (str ? str : "");
             if (ret->mem_bw_schema == NULL)
               {
-                free_runtime_spec_schema_config_linux_intel_rdt (ret);
                 return NULL;
               }
           }
       }
     while (0);
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "closID")
                 && strcmp (tree->u.object.keys[i], "l3CacheSchema")
-                && strcmp (tree->u.object.keys[i], "memBwSchema") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "memBwSchema"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -2056,6 +2419,8 @@ free_runtime_spec_schema_config_linux_in
     ptr->l3cache_schema = NULL;
     free (ptr->mem_bw_schema);
     ptr->mem_bw_schema = NULL;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -2104,20 +2469,27 @@ gen_runtime_spec_schema_config_linux_int
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_config_linux *, free_runtime_spec_schema_config_linux)
 runtime_spec_schema_config_linux *
 make_runtime_spec_schema_config_linux (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_linux *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_linux) runtime_spec_schema_config_linux *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -2133,7 +2505,6 @@ make_runtime_spec_schema_config_linux (y
             ret->devices = calloc (len + 1, sizeof (*ret->devices));
             if (ret->devices == NULL)
               {
-                free_runtime_spec_schema_config_linux (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -2142,7 +2513,6 @@ make_runtime_spec_schema_config_linux (y
                 ret->devices[i] = make_runtime_spec_schema_defs_linux_device (val, ctx, err);
                 if (ret->devices[i] == NULL)
                   {
-                    free_runtime_spec_schema_config_linux (ret);
                     return NULL;
                 }
             }
@@ -2161,7 +2531,6 @@ make_runtime_spec_schema_config_linux (y
             ret->uid_mappings = calloc (len + 1, sizeof (*ret->uid_mappings));
             if (ret->uid_mappings == NULL)
               {
-                free_runtime_spec_schema_config_linux (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -2170,7 +2539,6 @@ make_runtime_spec_schema_config_linux (y
                 ret->uid_mappings[i] = make_runtime_spec_schema_defs_id_mapping (val, ctx, err);
                 if (ret->uid_mappings[i] == NULL)
                   {
-                    free_runtime_spec_schema_config_linux (ret);
                     return NULL;
                 }
             }
@@ -2189,7 +2557,6 @@ make_runtime_spec_schema_config_linux (y
             ret->gid_mappings = calloc (len + 1, sizeof (*ret->gid_mappings));
             if (ret->gid_mappings == NULL)
               {
-                free_runtime_spec_schema_config_linux (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -2198,7 +2565,6 @@ make_runtime_spec_schema_config_linux (y
                 ret->gid_mappings[i] = make_runtime_spec_schema_defs_id_mapping (val, ctx, err);
                 if (ret->gid_mappings[i] == NULL)
                   {
-                    free_runtime_spec_schema_config_linux (ret);
                     return NULL;
                 }
             }
@@ -2217,7 +2583,6 @@ make_runtime_spec_schema_config_linux (y
             ret->namespaces = calloc (len + 1, sizeof (*ret->namespaces));
             if (ret->namespaces == NULL)
               {
-                free_runtime_spec_schema_config_linux (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -2226,7 +2591,6 @@ make_runtime_spec_schema_config_linux (y
                 ret->namespaces[i] = make_runtime_spec_schema_defs_linux_namespace_reference (val, ctx, err);
                 if (ret->namespaces[i] == NULL)
                   {
-                    free_runtime_spec_schema_config_linux (ret);
                     return NULL;
                 }
             }
@@ -2236,7 +2600,6 @@ make_runtime_spec_schema_config_linux (y
     ret->resources = make_runtime_spec_schema_config_linux_resources (get_val (tree, "resources", yajl_t_object), ctx, err);
     if (ret->resources == NULL && *err != 0)
       {
-        free_runtime_spec_schema_config_linux (ret);
         return NULL;
       }
     do
@@ -2248,7 +2611,6 @@ make_runtime_spec_schema_config_linux (y
             ret->cgroups_path = strdup (str ? str : "");
             if (ret->cgroups_path == NULL)
               {
-                free_runtime_spec_schema_config_linux (ret);
                 return NULL;
               }
           }
@@ -2263,7 +2625,6 @@ make_runtime_spec_schema_config_linux (y
             ret->rootfs_propagation = strdup (str ? str : "");
             if (ret->rootfs_propagation == NULL)
               {
-                free_runtime_spec_schema_config_linux (ret);
                 return NULL;
               }
           }
@@ -2272,7 +2633,6 @@ make_runtime_spec_schema_config_linux (y
     ret->seccomp = make_runtime_spec_schema_config_linux_seccomp (get_val (tree, "seccomp", yajl_t_object), ctx, err);
     if (ret->seccomp == NULL && *err != 0)
       {
-        free_runtime_spec_schema_config_linux (ret);
         return NULL;
       }
     do
@@ -2288,7 +2648,6 @@ make_runtime_spec_schema_config_linux (y
                   new_error = strdup ("error allocating memory");
                 free (*err);
                 *err = new_error;
-                free_runtime_spec_schema_config_linux (ret);
                 return NULL;
             }
         }
@@ -2306,7 +2665,6 @@ make_runtime_spec_schema_config_linux (y
             ret->masked_paths = calloc (len + 1, sizeof (*ret->masked_paths));
             if (ret->masked_paths == NULL)
               {
-                free_runtime_spec_schema_config_linux (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -2318,7 +2676,6 @@ make_runtime_spec_schema_config_linux (y
                     ret->masked_paths[i] = strdup (str ? str : "");
                     if (ret->masked_paths[i] == NULL)
                       {
-                        free_runtime_spec_schema_config_linux (ret);
                         return NULL;
                       }
                   }
@@ -2338,7 +2695,6 @@ make_runtime_spec_schema_config_linux (y
             ret->readonly_paths = calloc (len + 1, sizeof (*ret->readonly_paths));
             if (ret->readonly_paths == NULL)
               {
-                free_runtime_spec_schema_config_linux (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -2350,7 +2706,6 @@ make_runtime_spec_schema_config_linux (y
                     ret->readonly_paths[i] = strdup (str ? str : "");
                     if (ret->readonly_paths[i] == NULL)
                       {
-                        free_runtime_spec_schema_config_linux (ret);
                         return NULL;
                       }
                   }
@@ -2367,7 +2722,6 @@ make_runtime_spec_schema_config_linux (y
             ret->mount_label = strdup (str ? str : "");
             if (ret->mount_label == NULL)
               {
-                free_runtime_spec_schema_config_linux (ret);
                 return NULL;
               }
           }
@@ -2376,19 +2730,43 @@ make_runtime_spec_schema_config_linux (y
     ret->intel_rdt = make_runtime_spec_schema_config_linux_intel_rdt (get_val (tree, "intelRdt", yajl_t_object), ctx, err);
     if (ret->intel_rdt == NULL && *err != 0)
       {
-        free_runtime_spec_schema_config_linux (ret);
         return NULL;
       }
     ret->personality = make_runtime_spec_schema_defs_linux_personality (get_val (tree, "personality", yajl_t_object), ctx, err);
     if (ret->personality == NULL && *err != 0)
       {
-        free_runtime_spec_schema_config_linux (ret);
         return NULL;
       }
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "devices")
@@ -2404,14 +2782,28 @@ make_runtime_spec_schema_config_linux (y
                 && strcmp (tree->u.object.keys[i], "readonlyPaths")
                 && strcmp (tree->u.object.keys[i], "mountLabel")
                 && strcmp (tree->u.object.keys[i], "intelRdt")
-                && strcmp (tree->u.object.keys[i], "personality") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "personality"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -2523,6 +2915,8 @@ free_runtime_spec_schema_config_linux (r
         free_runtime_spec_schema_defs_linux_personality (ptr->personality);
         ptr->personality = NULL;
       }
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -2766,6 +3160,12 @@ gen_runtime_spec_schema_config_linux (ya
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
diff -pruN 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_config_linux.h 0.15+dfsg-1/libocispec/src/runtime_spec_schema_config_linux.h
--- 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_config_linux.h	2020-07-08 06:50:09.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/runtime_spec_schema_config_linux.h	2020-09-23 11:23:27.000000000 +0000
@@ -16,6 +16,7 @@ typedef struct {
     int64_t limit;
 
     unsigned int limit_present : 1;
+    yajl_val _residual;
 }
 runtime_spec_schema_config_linux_resources_pids;
 
@@ -47,6 +48,7 @@ typedef struct {
     runtime_spec_schema_defs_linux_block_io_device_weight **weight_device;
     size_t weight_device_len;
 
+    yajl_val _residual;
 }
 runtime_spec_schema_config_linux_resources_block_io;
 
@@ -76,6 +78,7 @@ typedef struct {
     uint64_t shares;
 
     unsigned int shares_present : 1;
+    yajl_val _residual;
 }
 runtime_spec_schema_config_linux_resources_cpu;
 
@@ -121,6 +124,7 @@ typedef struct {
     bool use_hierarchy;
 
     unsigned int use_hierarchy_present : 1;
+    yajl_val _residual;
 }
 runtime_spec_schema_config_linux_resources_memory;
 
@@ -137,6 +141,7 @@ typedef struct {
     runtime_spec_schema_defs_linux_network_interface_priority **priorities;
     size_t priorities_len;
 
+    yajl_val _residual;
 }
 runtime_spec_schema_config_linux_resources_network;
 
@@ -158,6 +163,8 @@ runtime_spec_schema_config_linux_resourc
 yajl_gen_status gen_runtime_spec_schema_config_linux_resources_rdma (yajl_gen g, const runtime_spec_schema_config_linux_resources_rdma *ptr, const struct parser_context *ctx, parser_error *err);
 
 typedef struct {
+    json_map_string_string *unified;
+
     runtime_spec_schema_defs_linux_device_cgroup **devices;
     size_t devices_len;
 
@@ -176,6 +183,7 @@ typedef struct {
 
     runtime_spec_schema_config_linux_resources_rdma *rdma;
 
+    yajl_val _residual;
 }
 runtime_spec_schema_config_linux_resources;
 
@@ -197,6 +205,7 @@ typedef struct {
     runtime_spec_schema_defs_linux_syscall **syscalls;
     size_t syscalls_len;
 
+    yajl_val _residual;
 }
 runtime_spec_schema_config_linux_seccomp;
 
@@ -213,6 +222,7 @@ typedef struct {
 
     char *mem_bw_schema;
 
+    yajl_val _residual;
 }
 runtime_spec_schema_config_linux_intel_rdt;
 
@@ -257,6 +267,7 @@ typedef struct {
 
     runtime_spec_schema_defs_linux_personality *personality;
 
+    yajl_val _residual;
 }
 runtime_spec_schema_config_linux;
 
diff -pruN 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_config_schema.c 0.15+dfsg-1/libocispec/src/runtime_spec_schema_config_schema.c
--- 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_config_schema.c	2020-07-08 06:50:09.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/runtime_spec_schema_config_schema.c	2020-09-23 11:23:26.000000000 +0000
@@ -8,14 +8,15 @@
 
 #define YAJL_GET_ARRAY_NO_CHECK(v) (&(v)->u.array)
 #define YAJL_GET_OBJECT_NO_CHECK(v) (&(v)->u.object)
+define_cleaner_function (runtime_spec_schema_config_schema_hooks *, free_runtime_spec_schema_config_schema_hooks)
 runtime_spec_schema_config_schema_hooks *
 make_runtime_spec_schema_config_schema_hooks (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_schema_hooks *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_schema_hooks) runtime_spec_schema_config_schema_hooks *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -31,7 +32,6 @@ make_runtime_spec_schema_config_schema_h
             ret->prestart = calloc (len + 1, sizeof (*ret->prestart));
             if (ret->prestart == NULL)
               {
-                free_runtime_spec_schema_config_schema_hooks (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -40,7 +40,6 @@ make_runtime_spec_schema_config_schema_h
                 ret->prestart[i] = make_runtime_spec_schema_defs_hook (val, ctx, err);
                 if (ret->prestart[i] == NULL)
                   {
-                    free_runtime_spec_schema_config_schema_hooks (ret);
                     return NULL;
                 }
             }
@@ -59,7 +58,6 @@ make_runtime_spec_schema_config_schema_h
             ret->create_runtime = calloc (len + 1, sizeof (*ret->create_runtime));
             if (ret->create_runtime == NULL)
               {
-                free_runtime_spec_schema_config_schema_hooks (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -68,7 +66,6 @@ make_runtime_spec_schema_config_schema_h
                 ret->create_runtime[i] = make_runtime_spec_schema_defs_hook (val, ctx, err);
                 if (ret->create_runtime[i] == NULL)
                   {
-                    free_runtime_spec_schema_config_schema_hooks (ret);
                     return NULL;
                 }
             }
@@ -87,7 +84,6 @@ make_runtime_spec_schema_config_schema_h
             ret->create_container = calloc (len + 1, sizeof (*ret->create_container));
             if (ret->create_container == NULL)
               {
-                free_runtime_spec_schema_config_schema_hooks (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -96,7 +92,6 @@ make_runtime_spec_schema_config_schema_h
                 ret->create_container[i] = make_runtime_spec_schema_defs_hook (val, ctx, err);
                 if (ret->create_container[i] == NULL)
                   {
-                    free_runtime_spec_schema_config_schema_hooks (ret);
                     return NULL;
                 }
             }
@@ -115,7 +110,6 @@ make_runtime_spec_schema_config_schema_h
             ret->start_container = calloc (len + 1, sizeof (*ret->start_container));
             if (ret->start_container == NULL)
               {
-                free_runtime_spec_schema_config_schema_hooks (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -124,7 +118,6 @@ make_runtime_spec_schema_config_schema_h
                 ret->start_container[i] = make_runtime_spec_schema_defs_hook (val, ctx, err);
                 if (ret->start_container[i] == NULL)
                   {
-                    free_runtime_spec_schema_config_schema_hooks (ret);
                     return NULL;
                 }
             }
@@ -143,7 +136,6 @@ make_runtime_spec_schema_config_schema_h
             ret->poststart = calloc (len + 1, sizeof (*ret->poststart));
             if (ret->poststart == NULL)
               {
-                free_runtime_spec_schema_config_schema_hooks (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -152,7 +144,6 @@ make_runtime_spec_schema_config_schema_h
                 ret->poststart[i] = make_runtime_spec_schema_defs_hook (val, ctx, err);
                 if (ret->poststart[i] == NULL)
                   {
-                    free_runtime_spec_schema_config_schema_hooks (ret);
                     return NULL;
                 }
             }
@@ -171,7 +162,6 @@ make_runtime_spec_schema_config_schema_h
             ret->poststop = calloc (len + 1, sizeof (*ret->poststop));
             if (ret->poststop == NULL)
               {
-                free_runtime_spec_schema_config_schema_hooks (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -180,7 +170,6 @@ make_runtime_spec_schema_config_schema_h
                 ret->poststop[i] = make_runtime_spec_schema_defs_hook (val, ctx, err);
                 if (ret->poststop[i] == NULL)
                   {
-                    free_runtime_spec_schema_config_schema_hooks (ret);
                     return NULL;
                 }
             }
@@ -188,9 +177,35 @@ make_runtime_spec_schema_config_schema_h
       }
     while (0);
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "prestart")
@@ -198,14 +213,28 @@ make_runtime_spec_schema_config_schema_h
                 && strcmp (tree->u.object.keys[i], "createContainer")
                 && strcmp (tree->u.object.keys[i], "startContainer")
                 && strcmp (tree->u.object.keys[i], "poststart")
-                && strcmp (tree->u.object.keys[i], "poststop") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "poststop"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -285,6 +314,8 @@ free_runtime_spec_schema_config_schema_h
         free (ptr->poststop);
         ptr->poststop = NULL;
       }
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -447,20 +478,27 @@ gen_runtime_spec_schema_config_schema_ho
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_config_schema_root *, free_runtime_spec_schema_config_schema_root)
 runtime_spec_schema_config_schema_root *
 make_runtime_spec_schema_config_schema_root (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_schema_root *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_schema_root) runtime_spec_schema_config_schema_root *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -473,7 +511,6 @@ make_runtime_spec_schema_config_schema_r
             ret->path = strdup (str ? str : "");
             if (ret->path == NULL)
               {
-                free_runtime_spec_schema_config_schema_root (ret);
                 return NULL;
               }
           }
@@ -502,24 +539,63 @@ make_runtime_spec_schema_config_schema_r
       {
         if (asprintf (err, "Required field '%s' not present",  "path") < 0)
             *err = strdup ("error allocating memory");
-        free_runtime_spec_schema_config_schema_root (ret);
         return NULL;
       }
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "path")
-                && strcmp (tree->u.object.keys[i], "readonly") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "readonly"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -529,6 +605,8 @@ free_runtime_spec_schema_config_schema_r
         return;
     free (ptr->path);
     ptr->path = NULL;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -566,20 +644,27 @@ gen_runtime_spec_schema_config_schema_ro
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_config_schema_process_console_size *, free_runtime_spec_schema_config_schema_process_console_size)
 runtime_spec_schema_config_schema_process_console_size *
 make_runtime_spec_schema_config_schema_process_console_size (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_schema_process_console_size *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_schema_process_console_size) runtime_spec_schema_config_schema_process_console_size *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -593,7 +678,6 @@ make_runtime_spec_schema_config_schema_p
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint64' for key 'height': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_config_schema_process_console_size (ret);
                 return NULL;
             }
             ret->height_present = 1;
@@ -610,7 +694,6 @@ make_runtime_spec_schema_config_schema_p
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint64' for key 'width': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_config_schema_process_console_size (ret);
                 return NULL;
             }
             ret->width_present = 1;
@@ -618,20 +701,60 @@ make_runtime_spec_schema_config_schema_p
       }
     while (0);
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "height")
-                && strcmp (tree->u.object.keys[i], "width") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "width"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -639,6 +762,8 @@ free_runtime_spec_schema_config_schema_p
 {
     if (ptr == NULL)
         return;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -675,20 +800,27 @@ gen_runtime_spec_schema_config_schema_pr
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_config_schema_process_user *, free_runtime_spec_schema_config_schema_process_user)
 runtime_spec_schema_config_schema_process_user *
 make_runtime_spec_schema_config_schema_process_user (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_schema_process_user *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_schema_process_user) runtime_spec_schema_config_schema_process_user *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -702,7 +834,6 @@ make_runtime_spec_schema_config_schema_p
               {
                 if (asprintf (err, "Invalid value '%s' with type 'UID' for key 'uid': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_config_schema_process_user (ret);
                 return NULL;
             }
             ret->uid_present = 1;
@@ -719,7 +850,6 @@ make_runtime_spec_schema_config_schema_p
               {
                 if (asprintf (err, "Invalid value '%s' with type 'GID' for key 'gid': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_config_schema_process_user (ret);
                 return NULL;
             }
             ret->gid_present = 1;
@@ -736,7 +866,6 @@ make_runtime_spec_schema_config_schema_p
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint32' for key 'umask': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_config_schema_process_user (ret);
                 return NULL;
             }
             ret->umask_present = 1;
@@ -755,7 +884,6 @@ make_runtime_spec_schema_config_schema_p
             ret->additional_gids = calloc (len + 1, sizeof (*ret->additional_gids));
             if (ret->additional_gids == NULL)
               {
-                free_runtime_spec_schema_config_schema_process_user (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -768,7 +896,6 @@ make_runtime_spec_schema_config_schema_p
                       {
                         if (asprintf (err, "Invalid value '%s' with type 'GID' for key 'additionalGids': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                             *err = strdup ("error allocating memory");
-                        free_runtime_spec_schema_config_schema_process_user (ret);
                         return NULL;
                     }
                 }
@@ -785,30 +912,69 @@ make_runtime_spec_schema_config_schema_p
             ret->username = strdup (str ? str : "");
             if (ret->username == NULL)
               {
-                free_runtime_spec_schema_config_schema_process_user (ret);
                 return NULL;
               }
           }
       }
     while (0);
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "uid")
                 && strcmp (tree->u.object.keys[i], "gid")
                 && strcmp (tree->u.object.keys[i], "umask")
                 && strcmp (tree->u.object.keys[i], "additionalGids")
-                && strcmp (tree->u.object.keys[i], "username") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "username"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -820,6 +986,8 @@ free_runtime_spec_schema_config_schema_p
     ptr->additional_gids = NULL;
     free (ptr->username);
     ptr->username = NULL;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -905,20 +1073,27 @@ gen_runtime_spec_schema_config_schema_pr
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_config_schema_process_capabilities *, free_runtime_spec_schema_config_schema_process_capabilities)
 runtime_spec_schema_config_schema_process_capabilities *
 make_runtime_spec_schema_config_schema_process_capabilities (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_schema_process_capabilities *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_schema_process_capabilities) runtime_spec_schema_config_schema_process_capabilities *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -934,7 +1109,6 @@ make_runtime_spec_schema_config_schema_p
             ret->bounding = calloc (len + 1, sizeof (*ret->bounding));
             if (ret->bounding == NULL)
               {
-                free_runtime_spec_schema_config_schema_process_capabilities (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -946,7 +1120,6 @@ make_runtime_spec_schema_config_schema_p
                     ret->bounding[i] = strdup (str ? str : "");
                     if (ret->bounding[i] == NULL)
                       {
-                        free_runtime_spec_schema_config_schema_process_capabilities (ret);
                         return NULL;
                       }
                   }
@@ -966,7 +1139,6 @@ make_runtime_spec_schema_config_schema_p
             ret->permitted = calloc (len + 1, sizeof (*ret->permitted));
             if (ret->permitted == NULL)
               {
-                free_runtime_spec_schema_config_schema_process_capabilities (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -978,7 +1150,6 @@ make_runtime_spec_schema_config_schema_p
                     ret->permitted[i] = strdup (str ? str : "");
                     if (ret->permitted[i] == NULL)
                       {
-                        free_runtime_spec_schema_config_schema_process_capabilities (ret);
                         return NULL;
                       }
                   }
@@ -998,7 +1169,6 @@ make_runtime_spec_schema_config_schema_p
             ret->effective = calloc (len + 1, sizeof (*ret->effective));
             if (ret->effective == NULL)
               {
-                free_runtime_spec_schema_config_schema_process_capabilities (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -1010,7 +1180,6 @@ make_runtime_spec_schema_config_schema_p
                     ret->effective[i] = strdup (str ? str : "");
                     if (ret->effective[i] == NULL)
                       {
-                        free_runtime_spec_schema_config_schema_process_capabilities (ret);
                         return NULL;
                       }
                   }
@@ -1030,7 +1199,6 @@ make_runtime_spec_schema_config_schema_p
             ret->inheritable = calloc (len + 1, sizeof (*ret->inheritable));
             if (ret->inheritable == NULL)
               {
-                free_runtime_spec_schema_config_schema_process_capabilities (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -1042,7 +1210,6 @@ make_runtime_spec_schema_config_schema_p
                     ret->inheritable[i] = strdup (str ? str : "");
                     if (ret->inheritable[i] == NULL)
                       {
-                        free_runtime_spec_schema_config_schema_process_capabilities (ret);
                         return NULL;
                       }
                   }
@@ -1062,7 +1229,6 @@ make_runtime_spec_schema_config_schema_p
             ret->ambient = calloc (len + 1, sizeof (*ret->ambient));
             if (ret->ambient == NULL)
               {
-                free_runtime_spec_schema_config_schema_process_capabilities (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -1074,7 +1240,6 @@ make_runtime_spec_schema_config_schema_p
                     ret->ambient[i] = strdup (str ? str : "");
                     if (ret->ambient[i] == NULL)
                       {
-                        free_runtime_spec_schema_config_schema_process_capabilities (ret);
                         return NULL;
                       }
                   }
@@ -1083,23 +1248,63 @@ make_runtime_spec_schema_config_schema_p
       }
     while (0);
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "bounding")
                 && strcmp (tree->u.object.keys[i], "permitted")
                 && strcmp (tree->u.object.keys[i], "effective")
                 && strcmp (tree->u.object.keys[i], "inheritable")
-                && strcmp (tree->u.object.keys[i], "ambient") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "ambient"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -1177,6 +1382,8 @@ free_runtime_spec_schema_config_schema_p
         free (ptr->ambient);
         ptr->ambient = NULL;
     }
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -1314,20 +1521,27 @@ gen_runtime_spec_schema_config_schema_pr
         if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
             yajl_gen_config (g, yajl_gen_beautify, 1);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_config_schema_process_rlimits_element *, free_runtime_spec_schema_config_schema_process_rlimits_element)
 runtime_spec_schema_config_schema_process_rlimits_element *
 make_runtime_spec_schema_config_schema_process_rlimits_element (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_schema_process_rlimits_element *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_schema_process_rlimits_element) runtime_spec_schema_config_schema_process_rlimits_element *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -1341,7 +1555,6 @@ make_runtime_spec_schema_config_schema_p
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint64' for key 'hard': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_config_schema_process_rlimits_element (ret);
                 return NULL;
             }
             ret->hard_present = 1;
@@ -1358,7 +1571,6 @@ make_runtime_spec_schema_config_schema_p
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint64' for key 'soft': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_config_schema_process_rlimits_element (ret);
                 return NULL;
             }
             ret->soft_present = 1;
@@ -1374,7 +1586,6 @@ make_runtime_spec_schema_config_schema_p
             ret->type = strdup (str ? str : "");
             if (ret->type == NULL)
               {
-                free_runtime_spec_schema_config_schema_process_rlimits_element (ret);
                 return NULL;
               }
           }
@@ -1384,10 +1595,9 @@ make_runtime_spec_schema_config_schema_p
       {
         if (asprintf (err, "Required field '%s' not present",  "type") < 0)
             *err = strdup ("error allocating memory");
-        free_runtime_spec_schema_config_schema_process_rlimits_element (ret);
         return NULL;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -1451,14 +1661,15 @@ gen_runtime_spec_schema_config_schema_pr
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_config_schema_process *, free_runtime_spec_schema_config_schema_process)
 runtime_spec_schema_config_schema_process *
 make_runtime_spec_schema_config_schema_process (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_schema_process *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_schema_process) runtime_spec_schema_config_schema_process *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -1474,7 +1685,6 @@ make_runtime_spec_schema_config_schema_p
             ret->args = calloc (len + 1, sizeof (*ret->args));
             if (ret->args == NULL)
               {
-                free_runtime_spec_schema_config_schema_process (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -1486,7 +1696,6 @@ make_runtime_spec_schema_config_schema_p
                     ret->args[i] = strdup (str ? str : "");
                     if (ret->args[i] == NULL)
                       {
-                        free_runtime_spec_schema_config_schema_process (ret);
                         return NULL;
                       }
                   }
@@ -1503,7 +1712,6 @@ make_runtime_spec_schema_config_schema_p
             ret->command_line = strdup (str ? str : "");
             if (ret->command_line == NULL)
               {
-                free_runtime_spec_schema_config_schema_process (ret);
                 return NULL;
               }
           }
@@ -1512,7 +1720,6 @@ make_runtime_spec_schema_config_schema_p
     ret->console_size = make_runtime_spec_schema_config_schema_process_console_size (get_val (tree, "consoleSize", yajl_t_object), ctx, err);
     if (ret->console_size == NULL && *err != 0)
       {
-        free_runtime_spec_schema_config_schema_process (ret);
         return NULL;
       }
     do
@@ -1524,7 +1731,6 @@ make_runtime_spec_schema_config_schema_p
             ret->cwd = strdup (str ? str : "");
             if (ret->cwd == NULL)
               {
-                free_runtime_spec_schema_config_schema_process (ret);
                 return NULL;
               }
           }
@@ -1542,7 +1748,6 @@ make_runtime_spec_schema_config_schema_p
             ret->env = calloc (len + 1, sizeof (*ret->env));
             if (ret->env == NULL)
               {
-                free_runtime_spec_schema_config_schema_process (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -1554,7 +1759,6 @@ make_runtime_spec_schema_config_schema_p
                     ret->env[i] = strdup (str ? str : "");
                     if (ret->env[i] == NULL)
                       {
-                        free_runtime_spec_schema_config_schema_process (ret);
                         return NULL;
                       }
                   }
@@ -1584,13 +1788,11 @@ make_runtime_spec_schema_config_schema_p
     ret->user = make_runtime_spec_schema_config_schema_process_user (get_val (tree, "user", yajl_t_object), ctx, err);
     if (ret->user == NULL && *err != 0)
       {
-        free_runtime_spec_schema_config_schema_process (ret);
         return NULL;
       }
     ret->capabilities = make_runtime_spec_schema_config_schema_process_capabilities (get_val (tree, "capabilities", yajl_t_object), ctx, err);
     if (ret->capabilities == NULL && *err != 0)
       {
-        free_runtime_spec_schema_config_schema_process (ret);
         return NULL;
       }
     do
@@ -1602,7 +1804,6 @@ make_runtime_spec_schema_config_schema_p
             ret->apparmor_profile = strdup (str ? str : "");
             if (ret->apparmor_profile == NULL)
               {
-                free_runtime_spec_schema_config_schema_process (ret);
                 return NULL;
               }
           }
@@ -1618,7 +1819,6 @@ make_runtime_spec_schema_config_schema_p
               {
                 if (asprintf (err, "Invalid value '%s' with type 'integer' for key 'oomScoreAdj': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_config_schema_process (ret);
                 return NULL;
             }
             ret->oom_score_adj_present = 1;
@@ -1634,7 +1834,6 @@ make_runtime_spec_schema_config_schema_p
             ret->selinux_label = strdup (str ? str : "");
             if (ret->selinux_label == NULL)
               {
-                free_runtime_spec_schema_config_schema_process (ret);
                 return NULL;
               }
           }
@@ -1671,7 +1870,6 @@ make_runtime_spec_schema_config_schema_p
             ret->rlimits = calloc (len + 1, sizeof (*ret->rlimits));
             if (ret->rlimits == NULL)
               {
-                free_runtime_spec_schema_config_schema_process (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -1680,7 +1878,6 @@ make_runtime_spec_schema_config_schema_p
                 ret->rlimits[i] = make_runtime_spec_schema_config_schema_process_rlimits_element (val, ctx, err);
                 if (ret->rlimits[i] == NULL)
                   {
-                    free_runtime_spec_schema_config_schema_process (ret);
                     return NULL;
                 }
             }
@@ -1691,13 +1888,38 @@ make_runtime_spec_schema_config_schema_p
       {
         if (asprintf (err, "Required field '%s' not present",  "cwd") < 0)
             *err = strdup ("error allocating memory");
-        free_runtime_spec_schema_config_schema_process (ret);
         return NULL;
       }
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "args")
@@ -1712,14 +1934,28 @@ make_runtime_spec_schema_config_schema_p
                 && strcmp (tree->u.object.keys[i], "oomScoreAdj")
                 && strcmp (tree->u.object.keys[i], "selinuxLabel")
                 && strcmp (tree->u.object.keys[i], "noNewPrivileges")
-                && strcmp (tree->u.object.keys[i], "rlimits") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "rlimits"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -1790,6 +2026,8 @@ free_runtime_spec_schema_config_schema_p
         free (ptr->rlimits);
         ptr->rlimits = NULL;
       }
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -1990,20 +2228,27 @@ gen_runtime_spec_schema_config_schema_pr
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_config_schema *, free_runtime_spec_schema_config_schema)
 runtime_spec_schema_config_schema *
 make_runtime_spec_schema_config_schema (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_schema *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_schema) runtime_spec_schema_config_schema *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -2016,7 +2261,6 @@ make_runtime_spec_schema_config_schema (
             ret->oci_version = strdup (str ? str : "");
             if (ret->oci_version == NULL)
               {
-                free_runtime_spec_schema_config_schema (ret);
                 return NULL;
               }
           }
@@ -2025,7 +2269,6 @@ make_runtime_spec_schema_config_schema (
     ret->hooks = make_runtime_spec_schema_config_schema_hooks (get_val (tree, "hooks", yajl_t_object), ctx, err);
     if (ret->hooks == NULL && *err != 0)
       {
-        free_runtime_spec_schema_config_schema (ret);
         return NULL;
       }
     do
@@ -2041,7 +2284,6 @@ make_runtime_spec_schema_config_schema (
                   new_error = strdup ("error allocating memory");
                 free (*err);
                 *err = new_error;
-                free_runtime_spec_schema_config_schema (ret);
                 return NULL;
             }
         }
@@ -2056,7 +2298,6 @@ make_runtime_spec_schema_config_schema (
             ret->hostname = strdup (str ? str : "");
             if (ret->hostname == NULL)
               {
-                free_runtime_spec_schema_config_schema (ret);
                 return NULL;
               }
           }
@@ -2074,7 +2315,6 @@ make_runtime_spec_schema_config_schema (
             ret->mounts = calloc (len + 1, sizeof (*ret->mounts));
             if (ret->mounts == NULL)
               {
-                free_runtime_spec_schema_config_schema (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -2083,7 +2323,6 @@ make_runtime_spec_schema_config_schema (
                 ret->mounts[i] = make_runtime_spec_schema_defs_mount (val, ctx, err);
                 if (ret->mounts[i] == NULL)
                   {
-                    free_runtime_spec_schema_config_schema (ret);
                     return NULL;
                 }
             }
@@ -2093,50 +2332,69 @@ make_runtime_spec_schema_config_schema (
     ret->root = make_runtime_spec_schema_config_schema_root (get_val (tree, "root", yajl_t_object), ctx, err);
     if (ret->root == NULL && *err != 0)
       {
-        free_runtime_spec_schema_config_schema (ret);
         return NULL;
       }
     ret->process = make_runtime_spec_schema_config_schema_process (get_val (tree, "process", yajl_t_object), ctx, err);
     if (ret->process == NULL && *err != 0)
       {
-        free_runtime_spec_schema_config_schema (ret);
         return NULL;
       }
     ret->linux = make_runtime_spec_schema_config_linux (get_val (tree, "linux", yajl_t_object), ctx, err);
     if (ret->linux == NULL && *err != 0)
       {
-        free_runtime_spec_schema_config_schema (ret);
         return NULL;
       }
     ret->solaris = make_runtime_spec_schema_config_solaris (get_val (tree, "solaris", yajl_t_object), ctx, err);
     if (ret->solaris == NULL && *err != 0)
       {
-        free_runtime_spec_schema_config_schema (ret);
         return NULL;
       }
     ret->windows = make_runtime_spec_schema_config_windows (get_val (tree, "windows", yajl_t_object), ctx, err);
     if (ret->windows == NULL && *err != 0)
       {
-        free_runtime_spec_schema_config_schema (ret);
         return NULL;
       }
     ret->vm = make_runtime_spec_schema_config_vm (get_val (tree, "vm", yajl_t_object), ctx, err);
     if (ret->vm == NULL && *err != 0)
       {
-        free_runtime_spec_schema_config_schema (ret);
         return NULL;
       }
     if (ret->oci_version == NULL)
       {
         if (asprintf (err, "Required field '%s' not present",  "ociVersion") < 0)
             *err = strdup ("error allocating memory");
-        free_runtime_spec_schema_config_schema (ret);
         return NULL;
       }
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "ociVersion")
@@ -2149,14 +2407,28 @@ make_runtime_spec_schema_config_schema (
                 && strcmp (tree->u.object.keys[i], "linux")
                 && strcmp (tree->u.object.keys[i], "solaris")
                 && strcmp (tree->u.object.keys[i], "windows")
-                && strcmp (tree->u.object.keys[i], "vm") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "vm"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -2217,6 +2489,8 @@ free_runtime_spec_schema_config_schema (
         free_runtime_spec_schema_config_vm (ptr->vm);
         ptr->vm = NULL;
       }
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -2350,6 +2624,12 @@ gen_runtime_spec_schema_config_schema (y
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
@@ -2362,7 +2642,7 @@ runtime_spec_schema_config_schema_parse_
 {
     runtime_spec_schema_config_schema *ptr = NULL;
     size_t filesize;
-    char *content = NULL;
+    __auto_free char *content = NULL;
 
     if (filename == NULL || err == NULL)
       return NULL;
@@ -2376,15 +2656,15 @@ runtime_spec_schema_config_schema_parse_
         return NULL;
       }
     ptr = runtime_spec_schema_config_schema_parse_data (content, ctx, err);
-    free (content);
     return ptr;
 }
 
-runtime_spec_schema_config_schema *runtime_spec_schema_config_schema_parse_file_stream (FILE *stream, const struct parser_context *ctx, parser_error *err)
+runtime_spec_schema_config_schema *
+runtime_spec_schema_config_schema_parse_file_stream (FILE *stream, const struct parser_context *ctx, parser_error *err)
 {
     runtime_spec_schema_config_schema *ptr = NULL;
     size_t filesize;
-    char *content = NULL ;
+    __auto_free char *content = NULL ;
 
     if (stream == NULL || err == NULL)
       return NULL;
@@ -2397,14 +2677,16 @@ runtime_spec_schema_config_schema *runti
         return NULL;
       }
     ptr = runtime_spec_schema_config_schema_parse_data (content, ctx, err);
-    free (content);
     return ptr;
 }
 
-runtime_spec_schema_config_schema *runtime_spec_schema_config_schema_parse_data (const char *jsondata, const struct parser_context *ctx, parser_error *err)
+define_cleaner_function (yajl_val, yajl_tree_free)
+
+runtime_spec_schema_config_schema *
+runtime_spec_schema_config_schema_parse_data (const char *jsondata, const struct parser_context *ctx, parser_error *err)
 {
     runtime_spec_schema_config_schema *ptr = NULL;
-    yajl_val tree;
+    __auto_cleanup(yajl_tree_free) yajl_val tree;
     char errbuf[1024];
     struct parser_context tmp_ctx = { 0 };
 
@@ -2423,12 +2705,24 @@ runtime_spec_schema_config_schema *runti
         return NULL;
       }
     ptr = make_runtime_spec_schema_config_schema (tree, ctx, err);
-    yajl_tree_free (tree);
     return ptr;
 }
-char *runtime_spec_schema_config_schema_generate_json(const runtime_spec_schema_config_schema *ptr, const struct parser_context *ctx, parser_error *err)
+
+static void
+cleanup_yajl_gen (yajl_gen g)
 {
-    yajl_gen g = NULL;
+    if (!g)
+      return;
+    yajl_gen_clear (g);
+    yajl_gen_free (g);
+}
+
+define_cleaner_function (yajl_gen, cleanup_yajl_gen)
+
+char *
+runtime_spec_schema_config_schema_generate_json (const runtime_spec_schema_config_schema *ptr, const struct parser_context *ctx, parser_error *err)
+{
+    __auto_cleanup(cleanup_yajl_gen) yajl_gen g = NULL;
     struct parser_context tmp_ctx = { 0 };
     const unsigned char *gen_buf = NULL;
     char *json_buf = NULL;
@@ -2444,35 +2738,31 @@ char *runtime_spec_schema_config_schema_
     if (!json_gen_init(&g, ctx))
       {
         *err = strdup ("Json_gen init failed");
-        goto out;
+        return json_buf;
       }
 
     if (yajl_gen_status_ok != gen_runtime_spec_schema_config_schema (g, ptr, ctx, err))
       {
         if (*err == NULL)
             *err = strdup ("Failed to generate json");
-        goto free_out;
+        return json_buf;
       }
 
     yajl_gen_get_buf (g, &gen_buf, &gen_len);
     if (gen_buf == NULL)
       {
         *err = strdup ("Error to get generated json");
-        goto free_out;
+        return json_buf;
       }
 
     json_buf = calloc (1, gen_len + 1);
     if (json_buf == NULL)
       {
         *err = strdup ("Cannot allocate memory");
-        goto free_out;
+        return json_buf;
       }
-    (void) memcpy(json_buf, gen_buf, gen_len);
+    (void) memcpy (json_buf, gen_buf, gen_len);
     json_buf[gen_len] = '\0';
 
-free_out:
-    yajl_gen_clear (g);
-    yajl_gen_free (g);
-out:
     return json_buf;
 }
diff -pruN 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_config_schema.h 0.15+dfsg-1/libocispec/src/runtime_spec_schema_config_schema.h
--- 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_config_schema.h	2020-07-08 06:50:09.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/runtime_spec_schema_config_schema.h	2020-09-23 11:23:26.000000000 +0000
@@ -37,6 +37,7 @@ typedef struct {
     runtime_spec_schema_defs_hook **poststop;
     size_t poststop_len;
 
+    yajl_val _residual;
 }
 runtime_spec_schema_config_schema_hooks;
 
@@ -52,6 +53,7 @@ typedef struct {
     bool readonly;
 
     unsigned int readonly_present : 1;
+    yajl_val _residual;
 }
 runtime_spec_schema_config_schema_root;
 
@@ -68,6 +70,7 @@ typedef struct {
     uint64_t width;
 
     unsigned int width_present : 1;
+    yajl_val _residual;
 }
 runtime_spec_schema_config_schema_process_console_size;
 
@@ -92,6 +95,7 @@ typedef struct {
 
     char *username;
 
+    yajl_val _residual;
 }
 runtime_spec_schema_config_schema_process_user;
 
@@ -117,6 +121,7 @@ typedef struct {
     char **ambient;
     size_t ambient_len;
 
+    yajl_val _residual;
 }
 runtime_spec_schema_config_schema_process_capabilities;
 
@@ -172,6 +177,7 @@ typedef struct {
     runtime_spec_schema_config_schema_process_rlimits_element **rlimits;
     size_t rlimits_len;
 
+    yajl_val _residual;
 }
 runtime_spec_schema_config_schema_process;
 
@@ -205,6 +211,7 @@ typedef struct {
 
     runtime_spec_schema_config_vm *vm;
 
+    yajl_val _residual;
 }
 runtime_spec_schema_config_schema;
 
diff -pruN 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_config_solaris.c 0.15+dfsg-1/libocispec/src/runtime_spec_schema_config_solaris.c
--- 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_config_solaris.c	2020-07-08 06:50:09.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/runtime_spec_schema_config_solaris.c	2020-09-23 11:23:27.000000000 +0000
@@ -8,14 +8,15 @@
 
 #define YAJL_GET_ARRAY_NO_CHECK(v) (&(v)->u.array)
 #define YAJL_GET_OBJECT_NO_CHECK(v) (&(v)->u.object)
+define_cleaner_function (runtime_spec_schema_config_solaris_capped_cpu *, free_runtime_spec_schema_config_solaris_capped_cpu)
 runtime_spec_schema_config_solaris_capped_cpu *
 make_runtime_spec_schema_config_solaris_capped_cpu (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_solaris_capped_cpu *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_solaris_capped_cpu) runtime_spec_schema_config_solaris_capped_cpu *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -28,26 +29,65 @@ make_runtime_spec_schema_config_solaris_
             ret->ncpus = strdup (str ? str : "");
             if (ret->ncpus == NULL)
               {
-                free_runtime_spec_schema_config_solaris_capped_cpu (ret);
                 return NULL;
               }
           }
       }
     while (0);
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
-            if (strcmp (tree->u.object.keys[i], "ncpus") && ctx->errfile != NULL)
+            if (strcmp (tree->u.object.keys[i], "ncpus"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -57,6 +97,8 @@ free_runtime_spec_schema_config_solaris_
         return;
     free (ptr->ncpus);
     ptr->ncpus = NULL;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -81,20 +123,27 @@ gen_runtime_spec_schema_config_solaris_c
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_config_solaris_capped_memory *, free_runtime_spec_schema_config_solaris_capped_memory)
 runtime_spec_schema_config_solaris_capped_memory *
 make_runtime_spec_schema_config_solaris_capped_memory (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_solaris_capped_memory *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_solaris_capped_memory) runtime_spec_schema_config_solaris_capped_memory *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -107,7 +156,6 @@ make_runtime_spec_schema_config_solaris_
             ret->physical = strdup (str ? str : "");
             if (ret->physical == NULL)
               {
-                free_runtime_spec_schema_config_solaris_capped_memory (ret);
                 return NULL;
               }
           }
@@ -122,27 +170,66 @@ make_runtime_spec_schema_config_solaris_
             ret->swap = strdup (str ? str : "");
             if (ret->swap == NULL)
               {
-                free_runtime_spec_schema_config_solaris_capped_memory (ret);
                 return NULL;
               }
           }
       }
     while (0);
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "physical")
-                && strcmp (tree->u.object.keys[i], "swap") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "swap"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -154,6 +241,8 @@ free_runtime_spec_schema_config_solaris_
     ptr->physical = NULL;
     free (ptr->swap);
     ptr->swap = NULL;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -190,20 +279,27 @@ gen_runtime_spec_schema_config_solaris_c
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_config_solaris_anet_element *, free_runtime_spec_schema_config_solaris_anet_element)
 runtime_spec_schema_config_solaris_anet_element *
 make_runtime_spec_schema_config_solaris_anet_element (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_solaris_anet_element *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_solaris_anet_element) runtime_spec_schema_config_solaris_anet_element *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -216,7 +312,6 @@ make_runtime_spec_schema_config_solaris_
             ret->linkname = strdup (str ? str : "");
             if (ret->linkname == NULL)
               {
-                free_runtime_spec_schema_config_solaris_anet_element (ret);
                 return NULL;
               }
           }
@@ -231,7 +326,6 @@ make_runtime_spec_schema_config_solaris_
             ret->lower_link = strdup (str ? str : "");
             if (ret->lower_link == NULL)
               {
-                free_runtime_spec_schema_config_solaris_anet_element (ret);
                 return NULL;
               }
           }
@@ -246,7 +340,6 @@ make_runtime_spec_schema_config_solaris_
             ret->allowed_address = strdup (str ? str : "");
             if (ret->allowed_address == NULL)
               {
-                free_runtime_spec_schema_config_solaris_anet_element (ret);
                 return NULL;
               }
           }
@@ -261,7 +354,6 @@ make_runtime_spec_schema_config_solaris_
             ret->configure_allowed_address = strdup (str ? str : "");
             if (ret->configure_allowed_address == NULL)
               {
-                free_runtime_spec_schema_config_solaris_anet_element (ret);
                 return NULL;
               }
           }
@@ -276,7 +368,6 @@ make_runtime_spec_schema_config_solaris_
             ret->defrouter = strdup (str ? str : "");
             if (ret->defrouter == NULL)
               {
-                free_runtime_spec_schema_config_solaris_anet_element (ret);
                 return NULL;
               }
           }
@@ -291,7 +382,6 @@ make_runtime_spec_schema_config_solaris_
             ret->mac_address = strdup (str ? str : "");
             if (ret->mac_address == NULL)
               {
-                free_runtime_spec_schema_config_solaris_anet_element (ret);
                 return NULL;
               }
           }
@@ -306,13 +396,12 @@ make_runtime_spec_schema_config_solaris_
             ret->link_protection = strdup (str ? str : "");
             if (ret->link_protection == NULL)
               {
-                free_runtime_spec_schema_config_solaris_anet_element (ret);
                 return NULL;
               }
           }
       }
     while (0);
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -436,14 +525,15 @@ gen_runtime_spec_schema_config_solaris_a
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_config_solaris *, free_runtime_spec_schema_config_solaris)
 runtime_spec_schema_config_solaris *
 make_runtime_spec_schema_config_solaris (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_solaris *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_solaris) runtime_spec_schema_config_solaris *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -456,7 +546,6 @@ make_runtime_spec_schema_config_solaris
             ret->milestone = strdup (str ? str : "");
             if (ret->milestone == NULL)
               {
-                free_runtime_spec_schema_config_solaris (ret);
                 return NULL;
               }
           }
@@ -471,7 +560,6 @@ make_runtime_spec_schema_config_solaris
             ret->limitpriv = strdup (str ? str : "");
             if (ret->limitpriv == NULL)
               {
-                free_runtime_spec_schema_config_solaris (ret);
                 return NULL;
               }
           }
@@ -486,7 +574,6 @@ make_runtime_spec_schema_config_solaris
             ret->max_shm_memory = strdup (str ? str : "");
             if (ret->max_shm_memory == NULL)
               {
-                free_runtime_spec_schema_config_solaris (ret);
                 return NULL;
               }
           }
@@ -495,13 +582,11 @@ make_runtime_spec_schema_config_solaris
     ret->capped_cpu = make_runtime_spec_schema_config_solaris_capped_cpu (get_val (tree, "cappedCPU", yajl_t_object), ctx, err);
     if (ret->capped_cpu == NULL && *err != 0)
       {
-        free_runtime_spec_schema_config_solaris (ret);
         return NULL;
       }
     ret->capped_memory = make_runtime_spec_schema_config_solaris_capped_memory (get_val (tree, "cappedMemory", yajl_t_object), ctx, err);
     if (ret->capped_memory == NULL && *err != 0)
       {
-        free_runtime_spec_schema_config_solaris (ret);
         return NULL;
       }
     do
@@ -516,7 +601,6 @@ make_runtime_spec_schema_config_solaris
             ret->anet = calloc (len + 1, sizeof (*ret->anet));
             if (ret->anet == NULL)
               {
-                free_runtime_spec_schema_config_solaris (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -525,7 +609,6 @@ make_runtime_spec_schema_config_solaris
                 ret->anet[i] = make_runtime_spec_schema_config_solaris_anet_element (val, ctx, err);
                 if (ret->anet[i] == NULL)
                   {
-                    free_runtime_spec_schema_config_solaris (ret);
                     return NULL;
                 }
             }
@@ -533,9 +616,35 @@ make_runtime_spec_schema_config_solaris
       }
     while (0);
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "milestone")
@@ -543,14 +652,28 @@ make_runtime_spec_schema_config_solaris
                 && strcmp (tree->u.object.keys[i], "maxShmMemory")
                 && strcmp (tree->u.object.keys[i], "cappedCPU")
                 && strcmp (tree->u.object.keys[i], "cappedMemory")
-                && strcmp (tree->u.object.keys[i], "anet") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "anet"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -586,6 +709,8 @@ free_runtime_spec_schema_config_solaris
         free (ptr->anet);
         ptr->anet = NULL;
       }
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -677,6 +802,12 @@ gen_runtime_spec_schema_config_solaris (
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
diff -pruN 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_config_solaris.h 0.15+dfsg-1/libocispec/src/runtime_spec_schema_config_solaris.h
--- 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_config_solaris.h	2020-07-08 06:50:09.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/runtime_spec_schema_config_solaris.h	2020-09-23 11:23:27.000000000 +0000
@@ -13,6 +13,7 @@ extern "C" {
 typedef struct {
     char *ncpus;
 
+    yajl_val _residual;
 }
 runtime_spec_schema_config_solaris_capped_cpu;
 
@@ -27,6 +28,7 @@ typedef struct {
 
     char *swap;
 
+    yajl_val _residual;
 }
 runtime_spec_schema_config_solaris_capped_memory;
 
@@ -65,6 +67,7 @@ typedef struct {
     runtime_spec_schema_config_solaris_anet_element **anet;
     size_t anet_len;
 
+    yajl_val _residual;
 }
 runtime_spec_schema_config_solaris;
 
diff -pruN 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_config_vm.c 0.15+dfsg-1/libocispec/src/runtime_spec_schema_config_vm.c
--- 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_config_vm.c	2020-07-08 06:50:09.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/runtime_spec_schema_config_vm.c	2020-09-23 11:23:27.000000000 +0000
@@ -8,14 +8,15 @@
 
 #define YAJL_GET_ARRAY_NO_CHECK(v) (&(v)->u.array)
 #define YAJL_GET_OBJECT_NO_CHECK(v) (&(v)->u.object)
+define_cleaner_function (runtime_spec_schema_config_vm_hypervisor *, free_runtime_spec_schema_config_vm_hypervisor)
 runtime_spec_schema_config_vm_hypervisor *
 make_runtime_spec_schema_config_vm_hypervisor (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_vm_hypervisor *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_vm_hypervisor) runtime_spec_schema_config_vm_hypervisor *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -28,7 +29,6 @@ make_runtime_spec_schema_config_vm_hyper
             ret->path = strdup (str ? str : "");
             if (ret->path == NULL)
               {
-                free_runtime_spec_schema_config_vm_hypervisor (ret);
                 return NULL;
               }
           }
@@ -46,7 +46,6 @@ make_runtime_spec_schema_config_vm_hyper
             ret->parameters = calloc (len + 1, sizeof (*ret->parameters));
             if (ret->parameters == NULL)
               {
-                free_runtime_spec_schema_config_vm_hypervisor (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -58,7 +57,6 @@ make_runtime_spec_schema_config_vm_hyper
                     ret->parameters[i] = strdup (str ? str : "");
                     if (ret->parameters[i] == NULL)
                       {
-                        free_runtime_spec_schema_config_vm_hypervisor (ret);
                         return NULL;
                       }
                   }
@@ -70,24 +68,63 @@ make_runtime_spec_schema_config_vm_hyper
       {
         if (asprintf (err, "Required field '%s' not present",  "path") < 0)
             *err = strdup ("error allocating memory");
-        free_runtime_spec_schema_config_vm_hypervisor (ret);
         return NULL;
       }
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "path")
-                && strcmp (tree->u.object.keys[i], "parameters") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "parameters"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -111,6 +148,8 @@ free_runtime_spec_schema_config_vm_hyper
         free (ptr->parameters);
         ptr->parameters = NULL;
     }
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -160,20 +199,27 @@ gen_runtime_spec_schema_config_vm_hyperv
         if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
             yajl_gen_config (g, yajl_gen_beautify, 1);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_config_vm_kernel *, free_runtime_spec_schema_config_vm_kernel)
 runtime_spec_schema_config_vm_kernel *
 make_runtime_spec_schema_config_vm_kernel (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_vm_kernel *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_vm_kernel) runtime_spec_schema_config_vm_kernel *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -186,7 +232,6 @@ make_runtime_spec_schema_config_vm_kerne
             ret->path = strdup (str ? str : "");
             if (ret->path == NULL)
               {
-                free_runtime_spec_schema_config_vm_kernel (ret);
                 return NULL;
               }
           }
@@ -204,7 +249,6 @@ make_runtime_spec_schema_config_vm_kerne
             ret->parameters = calloc (len + 1, sizeof (*ret->parameters));
             if (ret->parameters == NULL)
               {
-                free_runtime_spec_schema_config_vm_kernel (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -216,7 +260,6 @@ make_runtime_spec_schema_config_vm_kerne
                     ret->parameters[i] = strdup (str ? str : "");
                     if (ret->parameters[i] == NULL)
                       {
-                        free_runtime_spec_schema_config_vm_kernel (ret);
                         return NULL;
                       }
                   }
@@ -233,7 +276,6 @@ make_runtime_spec_schema_config_vm_kerne
             ret->initrd = strdup (str ? str : "");
             if (ret->initrd == NULL)
               {
-                free_runtime_spec_schema_config_vm_kernel (ret);
                 return NULL;
               }
           }
@@ -243,25 +285,64 @@ make_runtime_spec_schema_config_vm_kerne
       {
         if (asprintf (err, "Required field '%s' not present",  "path") < 0)
             *err = strdup ("error allocating memory");
-        free_runtime_spec_schema_config_vm_kernel (ret);
         return NULL;
       }
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "path")
                 && strcmp (tree->u.object.keys[i], "parameters")
-                && strcmp (tree->u.object.keys[i], "initrd") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "initrd"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -287,6 +368,8 @@ free_runtime_spec_schema_config_vm_kerne
     }
     free (ptr->initrd);
     ptr->initrd = NULL;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -348,20 +431,27 @@ gen_runtime_spec_schema_config_vm_kernel
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_config_vm_image *, free_runtime_spec_schema_config_vm_image)
 runtime_spec_schema_config_vm_image *
 make_runtime_spec_schema_config_vm_image (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_vm_image *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_vm_image) runtime_spec_schema_config_vm_image *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -374,7 +464,6 @@ make_runtime_spec_schema_config_vm_image
             ret->path = strdup (str ? str : "");
             if (ret->path == NULL)
               {
-                free_runtime_spec_schema_config_vm_image (ret);
                 return NULL;
               }
           }
@@ -389,7 +478,6 @@ make_runtime_spec_schema_config_vm_image
             ret->format = strdup (str ? str : "");
             if (ret->format == NULL)
               {
-                free_runtime_spec_schema_config_vm_image (ret);
                 return NULL;
               }
           }
@@ -399,31 +487,69 @@ make_runtime_spec_schema_config_vm_image
       {
         if (asprintf (err, "Required field '%s' not present",  "path") < 0)
             *err = strdup ("error allocating memory");
-        free_runtime_spec_schema_config_vm_image (ret);
         return NULL;
       }
     if (ret->format == NULL)
       {
         if (asprintf (err, "Required field '%s' not present",  "format") < 0)
             *err = strdup ("error allocating memory");
-        free_runtime_spec_schema_config_vm_image (ret);
         return NULL;
       }
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "path")
-                && strcmp (tree->u.object.keys[i], "format") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "format"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -435,6 +561,8 @@ free_runtime_spec_schema_config_vm_image
     ptr->path = NULL;
     free (ptr->format);
     ptr->format = NULL;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -471,64 +599,107 @@ gen_runtime_spec_schema_config_vm_image
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_config_vm *, free_runtime_spec_schema_config_vm)
 runtime_spec_schema_config_vm *
 make_runtime_spec_schema_config_vm (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_vm *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_vm) runtime_spec_schema_config_vm *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
     ret->hypervisor = make_runtime_spec_schema_config_vm_hypervisor (get_val (tree, "hypervisor", yajl_t_object), ctx, err);
     if (ret->hypervisor == NULL && *err != 0)
       {
-        free_runtime_spec_schema_config_vm (ret);
         return NULL;
       }
     ret->kernel = make_runtime_spec_schema_config_vm_kernel (get_val (tree, "kernel", yajl_t_object), ctx, err);
     if (ret->kernel == NULL && *err != 0)
       {
-        free_runtime_spec_schema_config_vm (ret);
         return NULL;
       }
     ret->image = make_runtime_spec_schema_config_vm_image (get_val (tree, "image", yajl_t_object), ctx, err);
     if (ret->image == NULL && *err != 0)
       {
-        free_runtime_spec_schema_config_vm (ret);
         return NULL;
       }
     if (ret->kernel == NULL)
       {
         if (asprintf (err, "Required field '%s' not present",  "kernel") < 0)
             *err = strdup ("error allocating memory");
-        free_runtime_spec_schema_config_vm (ret);
         return NULL;
       }
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "hypervisor")
                 && strcmp (tree->u.object.keys[i], "kernel")
-                && strcmp (tree->u.object.keys[i], "image") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "image"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -551,6 +722,8 @@ free_runtime_spec_schema_config_vm (runt
         free_runtime_spec_schema_config_vm_image (ptr->image);
         ptr->image = NULL;
       }
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -590,6 +763,12 @@ gen_runtime_spec_schema_config_vm (yajl_
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
diff -pruN 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_config_vm.h 0.15+dfsg-1/libocispec/src/runtime_spec_schema_config_vm.h
--- 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_config_vm.h	2020-07-08 06:50:09.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/runtime_spec_schema_config_vm.h	2020-09-23 11:23:27.000000000 +0000
@@ -18,6 +18,7 @@ typedef struct {
     char **parameters;
     size_t parameters_len;
 
+    yajl_val _residual;
 }
 runtime_spec_schema_config_vm_hypervisor;
 
@@ -35,6 +36,7 @@ typedef struct {
 
     char *initrd;
 
+    yajl_val _residual;
 }
 runtime_spec_schema_config_vm_kernel;
 
@@ -49,6 +51,7 @@ typedef struct {
 
     char *format;
 
+    yajl_val _residual;
 }
 runtime_spec_schema_config_vm_image;
 
@@ -65,6 +68,7 @@ typedef struct {
 
     runtime_spec_schema_config_vm_image *image;
 
+    yajl_val _residual;
 }
 runtime_spec_schema_config_vm;
 
diff -pruN 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_config_windows.c 0.15+dfsg-1/libocispec/src/runtime_spec_schema_config_windows.c
--- 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_config_windows.c	2020-07-08 06:50:09.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/runtime_spec_schema_config_windows.c	2020-09-23 11:23:27.000000000 +0000
@@ -8,14 +8,15 @@
 
 #define YAJL_GET_ARRAY_NO_CHECK(v) (&(v)->u.array)
 #define YAJL_GET_OBJECT_NO_CHECK(v) (&(v)->u.object)
+define_cleaner_function (runtime_spec_schema_config_windows_resources_memory *, free_runtime_spec_schema_config_windows_resources_memory)
 runtime_spec_schema_config_windows_resources_memory *
 make_runtime_spec_schema_config_windows_resources_memory (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_windows_resources_memory *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_windows_resources_memory) runtime_spec_schema_config_windows_resources_memory *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -29,7 +30,6 @@ make_runtime_spec_schema_config_windows_
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint64' for key 'limit': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_config_windows_resources_memory (ret);
                 return NULL;
             }
             ret->limit_present = 1;
@@ -37,19 +37,59 @@ make_runtime_spec_schema_config_windows_
       }
     while (0);
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
-            if (strcmp (tree->u.object.keys[i], "limit") && ctx->errfile != NULL)
+            if (strcmp (tree->u.object.keys[i], "limit"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -57,6 +97,8 @@ free_runtime_spec_schema_config_windows_
 {
     if (ptr == NULL)
         return;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -81,20 +123,27 @@ gen_runtime_spec_schema_config_windows_r
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_config_windows_resources_cpu *, free_runtime_spec_schema_config_windows_resources_cpu)
 runtime_spec_schema_config_windows_resources_cpu *
 make_runtime_spec_schema_config_windows_resources_cpu (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_windows_resources_cpu *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_windows_resources_cpu) runtime_spec_schema_config_windows_resources_cpu *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -108,7 +157,6 @@ make_runtime_spec_schema_config_windows_
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint64' for key 'count': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_config_windows_resources_cpu (ret);
                 return NULL;
             }
             ret->count_present = 1;
@@ -125,7 +173,6 @@ make_runtime_spec_schema_config_windows_
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint16' for key 'shares': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_config_windows_resources_cpu (ret);
                 return NULL;
             }
             ret->shares_present = 1;
@@ -142,7 +189,6 @@ make_runtime_spec_schema_config_windows_
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint16' for key 'maximum': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_config_windows_resources_cpu (ret);
                 return NULL;
             }
             ret->maximum_present = 1;
@@ -150,21 +196,61 @@ make_runtime_spec_schema_config_windows_
       }
     while (0);
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "count")
                 && strcmp (tree->u.object.keys[i], "shares")
-                && strcmp (tree->u.object.keys[i], "maximum") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "maximum"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -172,6 +258,8 @@ free_runtime_spec_schema_config_windows_
 {
     if (ptr == NULL)
         return;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -220,20 +308,27 @@ gen_runtime_spec_schema_config_windows_r
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_config_windows_resources_storage *, free_runtime_spec_schema_config_windows_resources_storage)
 runtime_spec_schema_config_windows_resources_storage *
 make_runtime_spec_schema_config_windows_resources_storage (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_windows_resources_storage *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_windows_resources_storage) runtime_spec_schema_config_windows_resources_storage *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -247,7 +342,6 @@ make_runtime_spec_schema_config_windows_
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint64' for key 'iops': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_config_windows_resources_storage (ret);
                 return NULL;
             }
             ret->iops_present = 1;
@@ -264,7 +358,6 @@ make_runtime_spec_schema_config_windows_
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint64' for key 'bps': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_config_windows_resources_storage (ret);
                 return NULL;
             }
             ret->bps_present = 1;
@@ -281,7 +374,6 @@ make_runtime_spec_schema_config_windows_
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint64' for key 'sandboxSize': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_config_windows_resources_storage (ret);
                 return NULL;
             }
             ret->sandbox_size_present = 1;
@@ -289,21 +381,61 @@ make_runtime_spec_schema_config_windows_
       }
     while (0);
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "iops")
                 && strcmp (tree->u.object.keys[i], "bps")
-                && strcmp (tree->u.object.keys[i], "sandboxSize") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "sandboxSize"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -311,6 +443,8 @@ free_runtime_spec_schema_config_windows_
 {
     if (ptr == NULL)
         return;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -359,57 +493,101 @@ gen_runtime_spec_schema_config_windows_r
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_config_windows_resources *, free_runtime_spec_schema_config_windows_resources)
 runtime_spec_schema_config_windows_resources *
 make_runtime_spec_schema_config_windows_resources (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_windows_resources *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_windows_resources) runtime_spec_schema_config_windows_resources *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
     ret->memory = make_runtime_spec_schema_config_windows_resources_memory (get_val (tree, "memory", yajl_t_object), ctx, err);
     if (ret->memory == NULL && *err != 0)
       {
-        free_runtime_spec_schema_config_windows_resources (ret);
         return NULL;
       }
     ret->cpu = make_runtime_spec_schema_config_windows_resources_cpu (get_val (tree, "cpu", yajl_t_object), ctx, err);
     if (ret->cpu == NULL && *err != 0)
       {
-        free_runtime_spec_schema_config_windows_resources (ret);
         return NULL;
       }
     ret->storage = make_runtime_spec_schema_config_windows_resources_storage (get_val (tree, "storage", yajl_t_object), ctx, err);
     if (ret->storage == NULL && *err != 0)
       {
-        free_runtime_spec_schema_config_windows_resources (ret);
         return NULL;
       }
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "memory")
                 && strcmp (tree->u.object.keys[i], "cpu")
-                && strcmp (tree->u.object.keys[i], "storage") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "storage"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -432,6 +610,8 @@ free_runtime_spec_schema_config_windows_
         free_runtime_spec_schema_config_windows_resources_storage (ptr->storage);
         ptr->storage = NULL;
       }
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -471,20 +651,27 @@ gen_runtime_spec_schema_config_windows_r
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_config_windows_network *, free_runtime_spec_schema_config_windows_network)
 runtime_spec_schema_config_windows_network *
 make_runtime_spec_schema_config_windows_network (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_windows_network *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_windows_network) runtime_spec_schema_config_windows_network *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -500,7 +687,6 @@ make_runtime_spec_schema_config_windows_
             ret->endpoint_list = calloc (len + 1, sizeof (*ret->endpoint_list));
             if (ret->endpoint_list == NULL)
               {
-                free_runtime_spec_schema_config_windows_network (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -512,7 +698,6 @@ make_runtime_spec_schema_config_windows_
                     ret->endpoint_list[i] = strdup (str ? str : "");
                     if (ret->endpoint_list[i] == NULL)
                       {
-                        free_runtime_spec_schema_config_windows_network (ret);
                         return NULL;
                       }
                   }
@@ -551,7 +736,6 @@ make_runtime_spec_schema_config_windows_
             ret->dns_search_list = calloc (len + 1, sizeof (*ret->dns_search_list));
             if (ret->dns_search_list == NULL)
               {
-                free_runtime_spec_schema_config_windows_network (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -563,7 +747,6 @@ make_runtime_spec_schema_config_windows_
                     ret->dns_search_list[i] = strdup (str ? str : "");
                     if (ret->dns_search_list[i] == NULL)
                       {
-                        free_runtime_spec_schema_config_windows_network (ret);
                         return NULL;
                       }
                   }
@@ -580,7 +763,6 @@ make_runtime_spec_schema_config_windows_
             ret->network_shared_container_name = strdup (str ? str : "");
             if (ret->network_shared_container_name == NULL)
               {
-                free_runtime_spec_schema_config_windows_network (ret);
                 return NULL;
               }
           }
@@ -595,30 +777,69 @@ make_runtime_spec_schema_config_windows_
             ret->network_namespace = strdup (str ? str : "");
             if (ret->network_namespace == NULL)
               {
-                free_runtime_spec_schema_config_windows_network (ret);
                 return NULL;
               }
           }
       }
     while (0);
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "endpointList")
                 && strcmp (tree->u.object.keys[i], "allowUnqualifiedDNSQuery")
                 && strcmp (tree->u.object.keys[i], "DNSSearchList")
                 && strcmp (tree->u.object.keys[i], "networkSharedContainerName")
-                && strcmp (tree->u.object.keys[i], "networkNamespace") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "networkNamespace"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -658,6 +879,8 @@ free_runtime_spec_schema_config_windows_
     ptr->network_shared_container_name = NULL;
     free (ptr->network_namespace);
     ptr->network_namespace = NULL;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -757,24 +980,31 @@ gen_runtime_spec_schema_config_windows_n
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_config_windows_credential_spec *, free_runtime_spec_schema_config_windows_credential_spec)
 runtime_spec_schema_config_windows_credential_spec *
 make_runtime_spec_schema_config_windows_credential_spec (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_windows_credential_spec *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_windows_credential_spec) runtime_spec_schema_config_windows_credential_spec *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -804,14 +1034,15 @@ gen_runtime_spec_schema_config_windows_c
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_config_windows_hyperv *, free_runtime_spec_schema_config_windows_hyperv)
 runtime_spec_schema_config_windows_hyperv *
 make_runtime_spec_schema_config_windows_hyperv (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_windows_hyperv *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_windows_hyperv) runtime_spec_schema_config_windows_hyperv *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -824,26 +1055,65 @@ make_runtime_spec_schema_config_windows_
             ret->utility_vm_path = strdup (str ? str : "");
             if (ret->utility_vm_path == NULL)
               {
-                free_runtime_spec_schema_config_windows_hyperv (ret);
                 return NULL;
               }
           }
       }
     while (0);
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
-            if (strcmp (tree->u.object.keys[i], "utilityVMPath") && ctx->errfile != NULL)
+            if (strcmp (tree->u.object.keys[i], "utilityVMPath"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -853,6 +1123,8 @@ free_runtime_spec_schema_config_windows_
         return;
     free (ptr->utility_vm_path);
     ptr->utility_vm_path = NULL;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -877,20 +1149,27 @@ gen_runtime_spec_schema_config_windows_h
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_config_windows *, free_runtime_spec_schema_config_windows)
 runtime_spec_schema_config_windows *
 make_runtime_spec_schema_config_windows (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_config_windows *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_config_windows) runtime_spec_schema_config_windows *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -906,7 +1185,6 @@ make_runtime_spec_schema_config_windows
             ret->layer_folders = calloc (len + 1, sizeof (*ret->layer_folders));
             if (ret->layer_folders == NULL)
               {
-                free_runtime_spec_schema_config_windows (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -918,7 +1196,6 @@ make_runtime_spec_schema_config_windows
                     ret->layer_folders[i] = strdup (str ? str : "");
                     if (ret->layer_folders[i] == NULL)
                       {
-                        free_runtime_spec_schema_config_windows (ret);
                         return NULL;
                       }
                   }
@@ -938,7 +1215,6 @@ make_runtime_spec_schema_config_windows
             ret->devices = calloc (len + 1, sizeof (*ret->devices));
             if (ret->devices == NULL)
               {
-                free_runtime_spec_schema_config_windows (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -947,7 +1223,6 @@ make_runtime_spec_schema_config_windows
                 ret->devices[i] = make_runtime_spec_schema_defs_windows_device (val, ctx, err);
                 if (ret->devices[i] == NULL)
                   {
-                    free_runtime_spec_schema_config_windows (ret);
                     return NULL;
                 }
             }
@@ -957,19 +1232,16 @@ make_runtime_spec_schema_config_windows
     ret->resources = make_runtime_spec_schema_config_windows_resources (get_val (tree, "resources", yajl_t_object), ctx, err);
     if (ret->resources == NULL && *err != 0)
       {
-        free_runtime_spec_schema_config_windows (ret);
         return NULL;
       }
     ret->network = make_runtime_spec_schema_config_windows_network (get_val (tree, "network", yajl_t_object), ctx, err);
     if (ret->network == NULL && *err != 0)
       {
-        free_runtime_spec_schema_config_windows (ret);
         return NULL;
       }
     ret->credential_spec = make_runtime_spec_schema_config_windows_credential_spec (get_val (tree, "credentialSpec", yajl_t_object), ctx, err);
     if (ret->credential_spec == NULL && *err != 0)
       {
-        free_runtime_spec_schema_config_windows (ret);
         return NULL;
       }
     do
@@ -1013,20 +1285,44 @@ make_runtime_spec_schema_config_windows
     ret->hyperv = make_runtime_spec_schema_config_windows_hyperv (get_val (tree, "hyperv", yajl_t_object), ctx, err);
     if (ret->hyperv == NULL && *err != 0)
       {
-        free_runtime_spec_schema_config_windows (ret);
         return NULL;
       }
     if (ret->layer_folders == NULL)
       {
         if (asprintf (err, "Required field '%s' not present",  "layerFolders") < 0)
             *err = strdup ("error allocating memory");
-        free_runtime_spec_schema_config_windows (ret);
         return NULL;
       }
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "layerFolders")
@@ -1036,14 +1332,28 @@ make_runtime_spec_schema_config_windows
                 && strcmp (tree->u.object.keys[i], "credentialSpec")
                 && strcmp (tree->u.object.keys[i], "servicing")
                 && strcmp (tree->u.object.keys[i], "ignoreFlushesDuringBoot")
-                && strcmp (tree->u.object.keys[i], "hyperv") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "hyperv"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -1097,6 +1407,8 @@ free_runtime_spec_schema_config_windows
         free_runtime_spec_schema_config_windows_hyperv (ptr->hyperv);
         ptr->hyperv = NULL;
       }
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -1221,6 +1533,12 @@ gen_runtime_spec_schema_config_windows (
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
diff -pruN 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_config_windows.h 0.15+dfsg-1/libocispec/src/runtime_spec_schema_config_windows.h
--- 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_config_windows.h	2020-07-08 06:50:09.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/runtime_spec_schema_config_windows.h	2020-09-23 11:23:27.000000000 +0000
@@ -16,6 +16,7 @@ typedef struct {
     uint64_t limit;
 
     unsigned int limit_present : 1;
+    yajl_val _residual;
 }
 runtime_spec_schema_config_windows_resources_memory;
 
@@ -35,6 +36,7 @@ typedef struct {
     uint16_t maximum;
 
     unsigned int maximum_present : 1;
+    yajl_val _residual;
 }
 runtime_spec_schema_config_windows_resources_cpu;
 
@@ -54,6 +56,7 @@ typedef struct {
     uint64_t sandbox_size;
 
     unsigned int sandbox_size_present : 1;
+    yajl_val _residual;
 }
 runtime_spec_schema_config_windows_resources_storage;
 
@@ -70,6 +73,7 @@ typedef struct {
 
     runtime_spec_schema_config_windows_resources_storage *storage;
 
+    yajl_val _residual;
 }
 runtime_spec_schema_config_windows_resources;
 
@@ -93,6 +97,7 @@ typedef struct {
 
     char *network_namespace;
 
+    yajl_val _residual;
 }
 runtime_spec_schema_config_windows_network;
 
@@ -116,6 +121,7 @@ yajl_gen_status gen_runtime_spec_schema_
 typedef struct {
     char *utility_vm_path;
 
+    yajl_val _residual;
 }
 runtime_spec_schema_config_windows_hyperv;
 
@@ -146,6 +152,7 @@ typedef struct {
     unsigned int ignore_flushes_during_boot_present : 1;
     runtime_spec_schema_config_windows_hyperv *hyperv;
 
+    yajl_val _residual;
 }
 runtime_spec_schema_config_windows;
 
diff -pruN 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_defs.c 0.15+dfsg-1/libocispec/src/runtime_spec_schema_defs.c
--- 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_defs.c	2020-07-08 06:50:09.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/runtime_spec_schema_defs.c	2020-09-23 11:23:27.000000000 +0000
@@ -8,14 +8,15 @@
 
 #define YAJL_GET_ARRAY_NO_CHECK(v) (&(v)->u.array)
 #define YAJL_GET_OBJECT_NO_CHECK(v) (&(v)->u.object)
+define_cleaner_function (runtime_spec_schema_defs_hook *, free_runtime_spec_schema_defs_hook)
 runtime_spec_schema_defs_hook *
 make_runtime_spec_schema_defs_hook (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_defs_hook *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_defs_hook) runtime_spec_schema_defs_hook *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -28,7 +29,6 @@ make_runtime_spec_schema_defs_hook (yajl
             ret->path = strdup (str ? str : "");
             if (ret->path == NULL)
               {
-                free_runtime_spec_schema_defs_hook (ret);
                 return NULL;
               }
           }
@@ -46,7 +46,6 @@ make_runtime_spec_schema_defs_hook (yajl
             ret->args = calloc (len + 1, sizeof (*ret->args));
             if (ret->args == NULL)
               {
-                free_runtime_spec_schema_defs_hook (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -58,7 +57,6 @@ make_runtime_spec_schema_defs_hook (yajl
                     ret->args[i] = strdup (str ? str : "");
                     if (ret->args[i] == NULL)
                       {
-                        free_runtime_spec_schema_defs_hook (ret);
                         return NULL;
                       }
                   }
@@ -78,7 +76,6 @@ make_runtime_spec_schema_defs_hook (yajl
             ret->env = calloc (len + 1, sizeof (*ret->env));
             if (ret->env == NULL)
               {
-                free_runtime_spec_schema_defs_hook (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -90,7 +87,6 @@ make_runtime_spec_schema_defs_hook (yajl
                     ret->env[i] = strdup (str ? str : "");
                     if (ret->env[i] == NULL)
                       {
-                        free_runtime_spec_schema_defs_hook (ret);
                         return NULL;
                       }
                   }
@@ -108,7 +104,6 @@ make_runtime_spec_schema_defs_hook (yajl
               {
                 if (asprintf (err, "Invalid value '%s' with type 'integer' for key 'timeout': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_defs_hook (ret);
                 return NULL;
             }
             ret->timeout_present = 1;
@@ -119,26 +114,65 @@ make_runtime_spec_schema_defs_hook (yajl
       {
         if (asprintf (err, "Required field '%s' not present",  "path") < 0)
             *err = strdup ("error allocating memory");
-        free_runtime_spec_schema_defs_hook (ret);
         return NULL;
       }
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "path")
                 && strcmp (tree->u.object.keys[i], "args")
                 && strcmp (tree->u.object.keys[i], "env")
-                && strcmp (tree->u.object.keys[i], "timeout") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "timeout"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -176,6 +210,8 @@ free_runtime_spec_schema_defs_hook (runt
         free (ptr->env);
         ptr->env = NULL;
     }
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -262,20 +298,27 @@ gen_runtime_spec_schema_defs_hook (yajl_
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_defs_id_mapping *, free_runtime_spec_schema_defs_id_mapping)
 runtime_spec_schema_defs_id_mapping *
 make_runtime_spec_schema_defs_id_mapping (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_defs_id_mapping *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_defs_id_mapping) runtime_spec_schema_defs_id_mapping *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -289,7 +332,6 @@ make_runtime_spec_schema_defs_id_mapping
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint32' for key 'containerID': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_defs_id_mapping (ret);
                 return NULL;
             }
             ret->container_id_present = 1;
@@ -306,7 +348,6 @@ make_runtime_spec_schema_defs_id_mapping
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint32' for key 'hostID': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_defs_id_mapping (ret);
                 return NULL;
             }
             ret->host_id_present = 1;
@@ -323,7 +364,6 @@ make_runtime_spec_schema_defs_id_mapping
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint32' for key 'size': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_defs_id_mapping (ret);
                 return NULL;
             }
             ret->size_present = 1;
@@ -331,21 +371,61 @@ make_runtime_spec_schema_defs_id_mapping
       }
     while (0);
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "containerID")
                 && strcmp (tree->u.object.keys[i], "hostID")
-                && strcmp (tree->u.object.keys[i], "size") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "size"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -353,6 +433,8 @@ free_runtime_spec_schema_defs_id_mapping
 {
     if (ptr == NULL)
         return;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -401,20 +483,27 @@ gen_runtime_spec_schema_defs_id_mapping
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_defs_mount *, free_runtime_spec_schema_defs_mount)
 runtime_spec_schema_defs_mount *
 make_runtime_spec_schema_defs_mount (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_defs_mount *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_defs_mount) runtime_spec_schema_defs_mount *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -427,7 +516,6 @@ make_runtime_spec_schema_defs_mount (yaj
             ret->source = strdup (str ? str : "");
             if (ret->source == NULL)
               {
-                free_runtime_spec_schema_defs_mount (ret);
                 return NULL;
               }
           }
@@ -442,7 +530,6 @@ make_runtime_spec_schema_defs_mount (yaj
             ret->destination = strdup (str ? str : "");
             if (ret->destination == NULL)
               {
-                free_runtime_spec_schema_defs_mount (ret);
                 return NULL;
               }
           }
@@ -460,7 +547,6 @@ make_runtime_spec_schema_defs_mount (yaj
             ret->options = calloc (len + 1, sizeof (*ret->options));
             if (ret->options == NULL)
               {
-                free_runtime_spec_schema_defs_mount (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -472,7 +558,6 @@ make_runtime_spec_schema_defs_mount (yaj
                     ret->options[i] = strdup (str ? str : "");
                     if (ret->options[i] == NULL)
                       {
-                        free_runtime_spec_schema_defs_mount (ret);
                         return NULL;
                       }
                   }
@@ -489,7 +574,6 @@ make_runtime_spec_schema_defs_mount (yaj
             ret->type = strdup (str ? str : "");
             if (ret->type == NULL)
               {
-                free_runtime_spec_schema_defs_mount (ret);
                 return NULL;
               }
           }
@@ -499,26 +583,65 @@ make_runtime_spec_schema_defs_mount (yaj
       {
         if (asprintf (err, "Required field '%s' not present",  "destination") < 0)
             *err = strdup ("error allocating memory");
-        free_runtime_spec_schema_defs_mount (ret);
         return NULL;
       }
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "source")
                 && strcmp (tree->u.object.keys[i], "destination")
                 && strcmp (tree->u.object.keys[i], "options")
-                && strcmp (tree->u.object.keys[i], "type") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "type"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -546,6 +669,8 @@ free_runtime_spec_schema_defs_mount (run
     }
     free (ptr->type);
     ptr->type = NULL;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -619,6 +744,12 @@ gen_runtime_spec_schema_defs_mount (yajl
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
diff -pruN 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_defs.h 0.15+dfsg-1/libocispec/src/runtime_spec_schema_defs.h
--- 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_defs.h	2020-07-08 06:50:09.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/runtime_spec_schema_defs.h	2020-09-23 11:23:27.000000000 +0000
@@ -22,6 +22,7 @@ typedef struct {
     int timeout;
 
     unsigned int timeout_present : 1;
+    yajl_val _residual;
 }
 runtime_spec_schema_defs_hook;
 
@@ -41,6 +42,7 @@ typedef struct {
     uint32_t size;
 
     unsigned int size_present : 1;
+    yajl_val _residual;
 }
 runtime_spec_schema_defs_id_mapping;
 
@@ -60,6 +62,7 @@ typedef struct {
 
     char *type;
 
+    yajl_val _residual;
 }
 runtime_spec_schema_defs_mount;
 
diff -pruN 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_defs_linux.c 0.15+dfsg-1/libocispec/src/runtime_spec_schema_defs_linux.c
--- 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_defs_linux.c	2020-07-08 06:50:09.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/runtime_spec_schema_defs_linux.c	2020-09-23 11:23:27.000000000 +0000
@@ -8,14 +8,15 @@
 
 #define YAJL_GET_ARRAY_NO_CHECK(v) (&(v)->u.array)
 #define YAJL_GET_OBJECT_NO_CHECK(v) (&(v)->u.object)
+define_cleaner_function (runtime_spec_schema_defs_linux_personality *, free_runtime_spec_schema_defs_linux_personality)
 runtime_spec_schema_defs_linux_personality *
 make_runtime_spec_schema_defs_linux_personality (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_defs_linux_personality *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_defs_linux_personality) runtime_spec_schema_defs_linux_personality *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -28,7 +29,6 @@ make_runtime_spec_schema_defs_linux_pers
             ret->domain = strdup (str ? str : "");
             if (ret->domain == NULL)
               {
-                free_runtime_spec_schema_defs_linux_personality (ret);
                 return NULL;
               }
           }
@@ -46,7 +46,6 @@ make_runtime_spec_schema_defs_linux_pers
             ret->flags = calloc (len + 1, sizeof (*ret->flags));
             if (ret->flags == NULL)
               {
-                free_runtime_spec_schema_defs_linux_personality (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -58,7 +57,6 @@ make_runtime_spec_schema_defs_linux_pers
                     ret->flags[i] = strdup (str ? str : "");
                     if (ret->flags[i] == NULL)
                       {
-                        free_runtime_spec_schema_defs_linux_personality (ret);
                         return NULL;
                       }
                   }
@@ -67,20 +65,60 @@ make_runtime_spec_schema_defs_linux_pers
       }
     while (0);
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "domain")
-                && strcmp (tree->u.object.keys[i], "flags") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "flags"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -104,6 +142,8 @@ free_runtime_spec_schema_defs_linux_pers
         free (ptr->flags);
         ptr->flags = NULL;
     }
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -153,20 +193,27 @@ gen_runtime_spec_schema_defs_linux_perso
         if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
             yajl_gen_config (g, yajl_gen_beautify, 1);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_defs_linux_syscall_arg *, free_runtime_spec_schema_defs_linux_syscall_arg)
 runtime_spec_schema_defs_linux_syscall_arg *
 make_runtime_spec_schema_defs_linux_syscall_arg (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_defs_linux_syscall_arg *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_defs_linux_syscall_arg) runtime_spec_schema_defs_linux_syscall_arg *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -180,7 +227,6 @@ make_runtime_spec_schema_defs_linux_sysc
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint32' for key 'index': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_defs_linux_syscall_arg (ret);
                 return NULL;
             }
             ret->index_present = 1;
@@ -197,7 +243,6 @@ make_runtime_spec_schema_defs_linux_sysc
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint64' for key 'value': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_defs_linux_syscall_arg (ret);
                 return NULL;
             }
             ret->value_present = 1;
@@ -214,7 +259,6 @@ make_runtime_spec_schema_defs_linux_sysc
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint64' for key 'valueTwo': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_defs_linux_syscall_arg (ret);
                 return NULL;
             }
             ret->value_two_present = 1;
@@ -230,7 +274,6 @@ make_runtime_spec_schema_defs_linux_sysc
             ret->op = strdup (str ? str : "");
             if (ret->op == NULL)
               {
-                free_runtime_spec_schema_defs_linux_syscall_arg (ret);
                 return NULL;
               }
           }
@@ -240,26 +283,65 @@ make_runtime_spec_schema_defs_linux_sysc
       {
         if (asprintf (err, "Required field '%s' not present",  "op") < 0)
             *err = strdup ("error allocating memory");
-        free_runtime_spec_schema_defs_linux_syscall_arg (ret);
         return NULL;
       }
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "index")
                 && strcmp (tree->u.object.keys[i], "value")
                 && strcmp (tree->u.object.keys[i], "valueTwo")
-                && strcmp (tree->u.object.keys[i], "op") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "op"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -269,6 +351,8 @@ free_runtime_spec_schema_defs_linux_sysc
         return;
     free (ptr->op);
     ptr->op = NULL;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -329,20 +413,27 @@ gen_runtime_spec_schema_defs_linux_sysca
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_defs_linux_syscall *, free_runtime_spec_schema_defs_linux_syscall)
 runtime_spec_schema_defs_linux_syscall *
 make_runtime_spec_schema_defs_linux_syscall (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_defs_linux_syscall *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_defs_linux_syscall) runtime_spec_schema_defs_linux_syscall *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -358,7 +449,6 @@ make_runtime_spec_schema_defs_linux_sysc
             ret->names = calloc (len + 1, sizeof (*ret->names));
             if (ret->names == NULL)
               {
-                free_runtime_spec_schema_defs_linux_syscall (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -370,7 +460,6 @@ make_runtime_spec_schema_defs_linux_sysc
                     ret->names[i] = strdup (str ? str : "");
                     if (ret->names[i] == NULL)
                       {
-                        free_runtime_spec_schema_defs_linux_syscall (ret);
                         return NULL;
                       }
                   }
@@ -387,7 +476,6 @@ make_runtime_spec_schema_defs_linux_sysc
             ret->action = strdup (str ? str : "");
             if (ret->action == NULL)
               {
-                free_runtime_spec_schema_defs_linux_syscall (ret);
                 return NULL;
               }
           }
@@ -403,7 +491,6 @@ make_runtime_spec_schema_defs_linux_sysc
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint32' for key 'errnoRet': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_defs_linux_syscall (ret);
                 return NULL;
             }
             ret->errno_ret_present = 1;
@@ -422,7 +509,6 @@ make_runtime_spec_schema_defs_linux_sysc
             ret->args = calloc (len + 1, sizeof (*ret->args));
             if (ret->args == NULL)
               {
-                free_runtime_spec_schema_defs_linux_syscall (ret);
                 return NULL;
               }
             for (i = 0; i < len; i++)
@@ -431,7 +517,6 @@ make_runtime_spec_schema_defs_linux_sysc
                 ret->args[i] = make_runtime_spec_schema_defs_linux_syscall_arg (val, ctx, err);
                 if (ret->args[i] == NULL)
                   {
-                    free_runtime_spec_schema_defs_linux_syscall (ret);
                     return NULL;
                 }
             }
@@ -442,33 +527,71 @@ make_runtime_spec_schema_defs_linux_sysc
       {
         if (asprintf (err, "Required field '%s' not present",  "names") < 0)
             *err = strdup ("error allocating memory");
-        free_runtime_spec_schema_defs_linux_syscall (ret);
         return NULL;
       }
     if (ret->action == NULL)
       {
         if (asprintf (err, "Required field '%s' not present",  "action") < 0)
             *err = strdup ("error allocating memory");
-        free_runtime_spec_schema_defs_linux_syscall (ret);
         return NULL;
       }
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "names")
                 && strcmp (tree->u.object.keys[i], "action")
                 && strcmp (tree->u.object.keys[i], "errnoRet")
-                && strcmp (tree->u.object.keys[i], "args") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "args"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -504,6 +627,8 @@ free_runtime_spec_schema_defs_linux_sysc
         free (ptr->args);
         ptr->args = NULL;
       }
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -590,20 +715,27 @@ gen_runtime_spec_schema_defs_linux_sysca
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_defs_linux_device *, free_runtime_spec_schema_defs_linux_device)
 runtime_spec_schema_defs_linux_device *
 make_runtime_spec_schema_defs_linux_device (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_defs_linux_device *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_defs_linux_device) runtime_spec_schema_defs_linux_device *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -616,7 +748,6 @@ make_runtime_spec_schema_defs_linux_devi
             ret->type = strdup (str ? str : "");
             if (ret->type == NULL)
               {
-                free_runtime_spec_schema_defs_linux_device (ret);
                 return NULL;
               }
           }
@@ -631,7 +762,6 @@ make_runtime_spec_schema_defs_linux_devi
             ret->path = strdup (str ? str : "");
             if (ret->path == NULL)
               {
-                free_runtime_spec_schema_defs_linux_device (ret);
                 return NULL;
               }
           }
@@ -647,7 +777,6 @@ make_runtime_spec_schema_defs_linux_devi
               {
                 if (asprintf (err, "Invalid value '%s' with type 'integer' for key 'fileMode': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_defs_linux_device (ret);
                 return NULL;
             }
             ret->file_mode_present = 1;
@@ -664,7 +793,6 @@ make_runtime_spec_schema_defs_linux_devi
               {
                 if (asprintf (err, "Invalid value '%s' with type 'int64' for key 'major': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_defs_linux_device (ret);
                 return NULL;
             }
             ret->major_present = 1;
@@ -681,7 +809,6 @@ make_runtime_spec_schema_defs_linux_devi
               {
                 if (asprintf (err, "Invalid value '%s' with type 'int64' for key 'minor': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_defs_linux_device (ret);
                 return NULL;
             }
             ret->minor_present = 1;
@@ -698,7 +825,6 @@ make_runtime_spec_schema_defs_linux_devi
               {
                 if (asprintf (err, "Invalid value '%s' with type 'UID' for key 'uid': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_defs_linux_device (ret);
                 return NULL;
             }
             ret->uid_present = 1;
@@ -715,7 +841,6 @@ make_runtime_spec_schema_defs_linux_devi
               {
                 if (asprintf (err, "Invalid value '%s' with type 'GID' for key 'gid': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_defs_linux_device (ret);
                 return NULL;
             }
             ret->gid_present = 1;
@@ -726,20 +851,44 @@ make_runtime_spec_schema_defs_linux_devi
       {
         if (asprintf (err, "Required field '%s' not present",  "type") < 0)
             *err = strdup ("error allocating memory");
-        free_runtime_spec_schema_defs_linux_device (ret);
         return NULL;
       }
     if (ret->path == NULL)
       {
         if (asprintf (err, "Required field '%s' not present",  "path") < 0)
             *err = strdup ("error allocating memory");
-        free_runtime_spec_schema_defs_linux_device (ret);
         return NULL;
       }
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "type")
@@ -748,14 +897,28 @@ make_runtime_spec_schema_defs_linux_devi
                 && strcmp (tree->u.object.keys[i], "major")
                 && strcmp (tree->u.object.keys[i], "minor")
                 && strcmp (tree->u.object.keys[i], "uid")
-                && strcmp (tree->u.object.keys[i], "gid") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "gid"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -767,6 +930,8 @@ free_runtime_spec_schema_defs_linux_devi
     ptr->type = NULL;
     free (ptr->path);
     ptr->path = NULL;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -863,20 +1028,27 @@ gen_runtime_spec_schema_defs_linux_devic
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_defs_linux_block_io_device *, free_runtime_spec_schema_defs_linux_block_io_device)
 runtime_spec_schema_defs_linux_block_io_device *
 make_runtime_spec_schema_defs_linux_block_io_device (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_defs_linux_block_io_device *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_defs_linux_block_io_device) runtime_spec_schema_defs_linux_block_io_device *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -890,7 +1062,6 @@ make_runtime_spec_schema_defs_linux_bloc
               {
                 if (asprintf (err, "Invalid value '%s' with type 'int64' for key 'major': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_defs_linux_block_io_device (ret);
                 return NULL;
             }
             ret->major_present = 1;
@@ -907,7 +1078,6 @@ make_runtime_spec_schema_defs_linux_bloc
               {
                 if (asprintf (err, "Invalid value '%s' with type 'int64' for key 'minor': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_defs_linux_block_io_device (ret);
                 return NULL;
             }
             ret->minor_present = 1;
@@ -915,20 +1085,60 @@ make_runtime_spec_schema_defs_linux_bloc
       }
     while (0);
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "major")
-                && strcmp (tree->u.object.keys[i], "minor") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "minor"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -936,6 +1146,8 @@ free_runtime_spec_schema_defs_linux_bloc
 {
     if (ptr == NULL)
         return;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -972,20 +1184,27 @@ gen_runtime_spec_schema_defs_linux_block
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_defs_linux_block_io_device_weight *, free_runtime_spec_schema_defs_linux_block_io_device_weight)
 runtime_spec_schema_defs_linux_block_io_device_weight *
 make_runtime_spec_schema_defs_linux_block_io_device_weight (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_defs_linux_block_io_device_weight *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_defs_linux_block_io_device_weight) runtime_spec_schema_defs_linux_block_io_device_weight *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -999,7 +1218,6 @@ make_runtime_spec_schema_defs_linux_bloc
               {
                 if (asprintf (err, "Invalid value '%s' with type 'int64' for key 'major': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_defs_linux_block_io_device_weight (ret);
                 return NULL;
             }
             ret->major_present = 1;
@@ -1016,7 +1234,6 @@ make_runtime_spec_schema_defs_linux_bloc
               {
                 if (asprintf (err, "Invalid value '%s' with type 'int64' for key 'minor': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_defs_linux_block_io_device_weight (ret);
                 return NULL;
             }
             ret->minor_present = 1;
@@ -1033,7 +1250,6 @@ make_runtime_spec_schema_defs_linux_bloc
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint16' for key 'weight': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_defs_linux_block_io_device_weight (ret);
                 return NULL;
             }
             ret->weight_present = 1;
@@ -1050,7 +1266,6 @@ make_runtime_spec_schema_defs_linux_bloc
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint16' for key 'leafWeight': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_defs_linux_block_io_device_weight (ret);
                 return NULL;
             }
             ret->leaf_weight_present = 1;
@@ -1058,22 +1273,62 @@ make_runtime_spec_schema_defs_linux_bloc
       }
     while (0);
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "major")
                 && strcmp (tree->u.object.keys[i], "minor")
                 && strcmp (tree->u.object.keys[i], "weight")
-                && strcmp (tree->u.object.keys[i], "leafWeight") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "leafWeight"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -1081,6 +1336,8 @@ free_runtime_spec_schema_defs_linux_bloc
 {
     if (ptr == NULL)
         return;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -1141,20 +1398,27 @@ gen_runtime_spec_schema_defs_linux_block
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_defs_linux_block_io_device_throttle *, free_runtime_spec_schema_defs_linux_block_io_device_throttle)
 runtime_spec_schema_defs_linux_block_io_device_throttle *
 make_runtime_spec_schema_defs_linux_block_io_device_throttle (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_defs_linux_block_io_device_throttle *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_defs_linux_block_io_device_throttle) runtime_spec_schema_defs_linux_block_io_device_throttle *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -1168,7 +1432,6 @@ make_runtime_spec_schema_defs_linux_bloc
               {
                 if (asprintf (err, "Invalid value '%s' with type 'int64' for key 'major': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_defs_linux_block_io_device_throttle (ret);
                 return NULL;
             }
             ret->major_present = 1;
@@ -1185,7 +1448,6 @@ make_runtime_spec_schema_defs_linux_bloc
               {
                 if (asprintf (err, "Invalid value '%s' with type 'int64' for key 'minor': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_defs_linux_block_io_device_throttle (ret);
                 return NULL;
             }
             ret->minor_present = 1;
@@ -1202,7 +1464,6 @@ make_runtime_spec_schema_defs_linux_bloc
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint64' for key 'rate': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_defs_linux_block_io_device_throttle (ret);
                 return NULL;
             }
             ret->rate_present = 1;
@@ -1210,21 +1471,61 @@ make_runtime_spec_schema_defs_linux_bloc
       }
     while (0);
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "major")
                 && strcmp (tree->u.object.keys[i], "minor")
-                && strcmp (tree->u.object.keys[i], "rate") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "rate"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -1232,6 +1533,8 @@ free_runtime_spec_schema_defs_linux_bloc
 {
     if (ptr == NULL)
         return;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -1280,20 +1583,27 @@ gen_runtime_spec_schema_defs_linux_block
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_defs_linux_device_cgroup *, free_runtime_spec_schema_defs_linux_device_cgroup)
 runtime_spec_schema_defs_linux_device_cgroup *
 make_runtime_spec_schema_defs_linux_device_cgroup (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_defs_linux_device_cgroup *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_defs_linux_device_cgroup) runtime_spec_schema_defs_linux_device_cgroup *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -1325,7 +1635,6 @@ make_runtime_spec_schema_defs_linux_devi
             ret->type = strdup (str ? str : "");
             if (ret->type == NULL)
               {
-                free_runtime_spec_schema_defs_linux_device_cgroup (ret);
                 return NULL;
               }
           }
@@ -1341,7 +1650,6 @@ make_runtime_spec_schema_defs_linux_devi
               {
                 if (asprintf (err, "Invalid value '%s' with type 'int64' for key 'major': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_defs_linux_device_cgroup (ret);
                 return NULL;
             }
             ret->major_present = 1;
@@ -1358,7 +1666,6 @@ make_runtime_spec_schema_defs_linux_devi
               {
                 if (asprintf (err, "Invalid value '%s' with type 'int64' for key 'minor': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_defs_linux_device_cgroup (ret);
                 return NULL;
             }
             ret->minor_present = 1;
@@ -1374,30 +1681,69 @@ make_runtime_spec_schema_defs_linux_devi
             ret->access = strdup (str ? str : "");
             if (ret->access == NULL)
               {
-                free_runtime_spec_schema_defs_linux_device_cgroup (ret);
                 return NULL;
               }
           }
       }
     while (0);
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "allow")
                 && strcmp (tree->u.object.keys[i], "type")
                 && strcmp (tree->u.object.keys[i], "major")
                 && strcmp (tree->u.object.keys[i], "minor")
-                && strcmp (tree->u.object.keys[i], "access") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "access"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -1409,6 +1755,8 @@ free_runtime_spec_schema_defs_linux_devi
     ptr->type = NULL;
     free (ptr->access);
     ptr->access = NULL;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -1482,20 +1830,27 @@ gen_runtime_spec_schema_defs_linux_devic
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_defs_linux_network_interface_priority *, free_runtime_spec_schema_defs_linux_network_interface_priority)
 runtime_spec_schema_defs_linux_network_interface_priority *
 make_runtime_spec_schema_defs_linux_network_interface_priority (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_defs_linux_network_interface_priority *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_defs_linux_network_interface_priority) runtime_spec_schema_defs_linux_network_interface_priority *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -1508,7 +1863,6 @@ make_runtime_spec_schema_defs_linux_netw
             ret->name = strdup (str ? str : "");
             if (ret->name == NULL)
               {
-                free_runtime_spec_schema_defs_linux_network_interface_priority (ret);
                 return NULL;
               }
           }
@@ -1524,7 +1878,6 @@ make_runtime_spec_schema_defs_linux_netw
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint32' for key 'priority': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_defs_linux_network_interface_priority (ret);
                 return NULL;
             }
             ret->priority_present = 1;
@@ -1535,24 +1888,63 @@ make_runtime_spec_schema_defs_linux_netw
       {
         if (asprintf (err, "Required field '%s' not present",  "name") < 0)
             *err = strdup ("error allocating memory");
-        free_runtime_spec_schema_defs_linux_network_interface_priority (ret);
         return NULL;
       }
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "name")
-                && strcmp (tree->u.object.keys[i], "priority") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "priority"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -1562,6 +1954,8 @@ free_runtime_spec_schema_defs_linux_netw
         return;
     free (ptr->name);
     ptr->name = NULL;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -1598,20 +1992,27 @@ gen_runtime_spec_schema_defs_linux_netwo
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_defs_linux_rdma *, free_runtime_spec_schema_defs_linux_rdma)
 runtime_spec_schema_defs_linux_rdma *
 make_runtime_spec_schema_defs_linux_rdma (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_defs_linux_rdma *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_defs_linux_rdma) runtime_spec_schema_defs_linux_rdma *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -1625,7 +2026,6 @@ make_runtime_spec_schema_defs_linux_rdma
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint32' for key 'hcaHandles': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_defs_linux_rdma (ret);
                 return NULL;
             }
             ret->hca_handles_present = 1;
@@ -1642,7 +2042,6 @@ make_runtime_spec_schema_defs_linux_rdma
               {
                 if (asprintf (err, "Invalid value '%s' with type 'uint32' for key 'hcaObjects': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_defs_linux_rdma (ret);
                 return NULL;
             }
             ret->hca_objects_present = 1;
@@ -1650,20 +2049,60 @@ make_runtime_spec_schema_defs_linux_rdma
       }
     while (0);
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "hcaHandles")
-                && strcmp (tree->u.object.keys[i], "hcaObjects") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "hcaObjects"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -1671,6 +2110,8 @@ free_runtime_spec_schema_defs_linux_rdma
 {
     if (ptr == NULL)
         return;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -1707,20 +2148,27 @@ gen_runtime_spec_schema_defs_linux_rdma
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
     return yajl_gen_status_ok;
 }
 
+define_cleaner_function (runtime_spec_schema_defs_linux_namespace_reference *, free_runtime_spec_schema_defs_linux_namespace_reference)
 runtime_spec_schema_defs_linux_namespace_reference *
 make_runtime_spec_schema_defs_linux_namespace_reference (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_defs_linux_namespace_reference *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_defs_linux_namespace_reference) runtime_spec_schema_defs_linux_namespace_reference *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -1733,7 +2181,6 @@ make_runtime_spec_schema_defs_linux_name
             ret->type = strdup (str ? str : "");
             if (ret->type == NULL)
               {
-                free_runtime_spec_schema_defs_linux_namespace_reference (ret);
                 return NULL;
               }
           }
@@ -1748,7 +2195,6 @@ make_runtime_spec_schema_defs_linux_name
             ret->path = strdup (str ? str : "");
             if (ret->path == NULL)
               {
-                free_runtime_spec_schema_defs_linux_namespace_reference (ret);
                 return NULL;
               }
           }
@@ -1758,24 +2204,63 @@ make_runtime_spec_schema_defs_linux_name
       {
         if (asprintf (err, "Required field '%s' not present",  "type") < 0)
             *err = strdup ("error allocating memory");
-        free_runtime_spec_schema_defs_linux_namespace_reference (ret);
         return NULL;
       }
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "type")
-                && strcmp (tree->u.object.keys[i], "path") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "path"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -1787,6 +2272,8 @@ free_runtime_spec_schema_defs_linux_name
     ptr->type = NULL;
     free (ptr->path);
     ptr->path = NULL;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -1823,6 +2310,12 @@ gen_runtime_spec_schema_defs_linux_names
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
diff -pruN 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_defs_linux.h 0.15+dfsg-1/libocispec/src/runtime_spec_schema_defs_linux.h
--- 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_defs_linux.h	2020-07-08 06:50:09.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/runtime_spec_schema_defs_linux.h	2020-09-23 11:23:27.000000000 +0000
@@ -17,6 +17,7 @@ typedef struct {
     char **flags;
     size_t flags_len;
 
+    yajl_val _residual;
 }
 runtime_spec_schema_defs_linux_personality;
 
@@ -38,6 +39,7 @@ typedef struct {
     unsigned int value_two_present : 1;
     char *op;
 
+    yajl_val _residual;
 }
 runtime_spec_schema_defs_linux_syscall_arg;
 
@@ -59,6 +61,7 @@ typedef struct {
     runtime_spec_schema_defs_linux_syscall_arg **args;
     size_t args_len;
 
+    yajl_val _residual;
 }
 runtime_spec_schema_defs_linux_syscall;
 
@@ -88,6 +91,7 @@ typedef struct {
     gid_t gid;
 
     unsigned int gid_present : 1;
+    yajl_val _residual;
 }
 runtime_spec_schema_defs_linux_device;
 
@@ -104,6 +108,7 @@ typedef struct {
     int64_t minor;
 
     unsigned int minor_present : 1;
+    yajl_val _residual;
 }
 runtime_spec_schema_defs_linux_block_io_device;
 
@@ -126,6 +131,7 @@ typedef struct {
     uint16_t leaf_weight;
 
     unsigned int leaf_weight_present : 1;
+    yajl_val _residual;
 }
 runtime_spec_schema_defs_linux_block_io_device_weight;
 
@@ -145,6 +151,7 @@ typedef struct {
     uint64_t rate;
 
     unsigned int rate_present : 1;
+    yajl_val _residual;
 }
 runtime_spec_schema_defs_linux_block_io_device_throttle;
 
@@ -168,6 +175,7 @@ typedef struct {
     unsigned int minor_present : 1;
     char *access;
 
+    yajl_val _residual;
 }
 runtime_spec_schema_defs_linux_device_cgroup;
 
@@ -183,6 +191,7 @@ typedef struct {
     uint32_t priority;
 
     unsigned int priority_present : 1;
+    yajl_val _residual;
 }
 runtime_spec_schema_defs_linux_network_interface_priority;
 
@@ -199,6 +208,7 @@ typedef struct {
     uint32_t hca_objects;
 
     unsigned int hca_objects_present : 1;
+    yajl_val _residual;
 }
 runtime_spec_schema_defs_linux_rdma;
 
@@ -213,6 +223,7 @@ typedef struct {
 
     char *path;
 
+    yajl_val _residual;
 }
 runtime_spec_schema_defs_linux_namespace_reference;
 
diff -pruN 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_defs_windows.c 0.15+dfsg-1/libocispec/src/runtime_spec_schema_defs_windows.c
--- 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_defs_windows.c	2020-07-08 06:50:09.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/runtime_spec_schema_defs_windows.c	2020-09-23 11:23:27.000000000 +0000
@@ -8,14 +8,15 @@
 
 #define YAJL_GET_ARRAY_NO_CHECK(v) (&(v)->u.array)
 #define YAJL_GET_OBJECT_NO_CHECK(v) (&(v)->u.object)
+define_cleaner_function (runtime_spec_schema_defs_windows_device *, free_runtime_spec_schema_defs_windows_device)
 runtime_spec_schema_defs_windows_device *
 make_runtime_spec_schema_defs_windows_device (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_defs_windows_device *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_defs_windows_device) runtime_spec_schema_defs_windows_device *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -28,7 +29,6 @@ make_runtime_spec_schema_defs_windows_de
             ret->id = strdup (str ? str : "");
             if (ret->id == NULL)
               {
-                free_runtime_spec_schema_defs_windows_device (ret);
                 return NULL;
               }
           }
@@ -43,7 +43,6 @@ make_runtime_spec_schema_defs_windows_de
             ret->id_type = strdup (str ? str : "");
             if (ret->id_type == NULL)
               {
-                free_runtime_spec_schema_defs_windows_device (ret);
                 return NULL;
               }
           }
@@ -53,31 +52,69 @@ make_runtime_spec_schema_defs_windows_de
       {
         if (asprintf (err, "Required field '%s' not present",  "id") < 0)
             *err = strdup ("error allocating memory");
-        free_runtime_spec_schema_defs_windows_device (ret);
         return NULL;
       }
     if (ret->id_type == NULL)
       {
         if (asprintf (err, "Required field '%s' not present",  "idType") < 0)
             *err = strdup ("error allocating memory");
-        free_runtime_spec_schema_defs_windows_device (ret);
         return NULL;
       }
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "id")
-                && strcmp (tree->u.object.keys[i], "idType") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "idType"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -89,6 +126,8 @@ free_runtime_spec_schema_defs_windows_de
     ptr->id = NULL;
     free (ptr->id_type);
     ptr->id_type = NULL;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -125,6 +164,12 @@ gen_runtime_spec_schema_defs_windows_dev
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
diff -pruN 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_defs_windows.h 0.15+dfsg-1/libocispec/src/runtime_spec_schema_defs_windows.h
--- 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_defs_windows.h	2020-07-08 06:50:09.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/runtime_spec_schema_defs_windows.h	2020-09-23 11:23:27.000000000 +0000
@@ -15,6 +15,7 @@ typedef struct {
 
     char *id_type;
 
+    yajl_val _residual;
 }
 runtime_spec_schema_defs_windows_device;
 
diff -pruN 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_state_schema.c 0.15+dfsg-1/libocispec/src/runtime_spec_schema_state_schema.c
--- 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_state_schema.c	2020-07-08 06:50:09.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/runtime_spec_schema_state_schema.c	2020-09-23 11:23:27.000000000 +0000
@@ -8,14 +8,15 @@
 
 #define YAJL_GET_ARRAY_NO_CHECK(v) (&(v)->u.array)
 #define YAJL_GET_OBJECT_NO_CHECK(v) (&(v)->u.object)
+define_cleaner_function (runtime_spec_schema_state_schema *, free_runtime_spec_schema_state_schema)
 runtime_spec_schema_state_schema *
 make_runtime_spec_schema_state_schema (yajl_val tree, const struct parser_context *ctx, parser_error *err)
 {
-    runtime_spec_schema_state_schema *ret = NULL;
+    __auto_cleanup(free_runtime_spec_schema_state_schema) runtime_spec_schema_state_schema *ret = NULL;
     *err = NULL;
     (void) ctx;  /* Silence compiler warning.  */
     if (tree == NULL)
-      return ret;
+      return NULL;
     ret = calloc (1, sizeof (*ret));
     if (ret == NULL)
       return NULL;
@@ -28,7 +29,6 @@ make_runtime_spec_schema_state_schema (y
             ret->oci_version = strdup (str ? str : "");
             if (ret->oci_version == NULL)
               {
-                free_runtime_spec_schema_state_schema (ret);
                 return NULL;
               }
           }
@@ -43,7 +43,6 @@ make_runtime_spec_schema_state_schema (y
             ret->id = strdup (str ? str : "");
             if (ret->id == NULL)
               {
-                free_runtime_spec_schema_state_schema (ret);
                 return NULL;
               }
           }
@@ -58,7 +57,6 @@ make_runtime_spec_schema_state_schema (y
             ret->status = strdup (str ? str : "");
             if (ret->status == NULL)
               {
-                free_runtime_spec_schema_state_schema (ret);
                 return NULL;
               }
           }
@@ -74,7 +72,6 @@ make_runtime_spec_schema_state_schema (y
               {
                 if (asprintf (err, "Invalid value '%s' with type 'integer' for key 'pid': %s", YAJL_GET_NUMBER (val), strerror (-invalid)) < 0)
                     *err = strdup ("error allocating memory");
-                free_runtime_spec_schema_state_schema (ret);
                 return NULL;
             }
             ret->pid_present = 1;
@@ -90,7 +87,6 @@ make_runtime_spec_schema_state_schema (y
             ret->bundle = strdup (str ? str : "");
             if (ret->bundle == NULL)
               {
-                free_runtime_spec_schema_state_schema (ret);
                 return NULL;
               }
           }
@@ -109,7 +105,6 @@ make_runtime_spec_schema_state_schema (y
                   new_error = strdup ("error allocating memory");
                 free (*err);
                 *err = new_error;
-                free_runtime_spec_schema_state_schema (ret);
                 return NULL;
             }
         }
@@ -119,34 +114,56 @@ make_runtime_spec_schema_state_schema (y
       {
         if (asprintf (err, "Required field '%s' not present",  "ociVersion") < 0)
             *err = strdup ("error allocating memory");
-        free_runtime_spec_schema_state_schema (ret);
         return NULL;
       }
     if (ret->id == NULL)
       {
         if (asprintf (err, "Required field '%s' not present",  "id") < 0)
             *err = strdup ("error allocating memory");
-        free_runtime_spec_schema_state_schema (ret);
         return NULL;
       }
     if (ret->status == NULL)
       {
         if (asprintf (err, "Required field '%s' not present",  "status") < 0)
             *err = strdup ("error allocating memory");
-        free_runtime_spec_schema_state_schema (ret);
         return NULL;
       }
     if (ret->bundle == NULL)
       {
         if (asprintf (err, "Required field '%s' not present",  "bundle") < 0)
             *err = strdup ("error allocating memory");
-        free_runtime_spec_schema_state_schema (ret);
         return NULL;
       }
 
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
             if (strcmp (tree->u.object.keys[i], "ociVersion")
@@ -154,14 +171,28 @@ make_runtime_spec_schema_state_schema (y
                 && strcmp (tree->u.object.keys[i], "status")
                 && strcmp (tree->u.object.keys[i], "pid")
                 && strcmp (tree->u.object.keys[i], "bundle")
-                && strcmp (tree->u.object.keys[i], "annotations") && ctx->errfile != NULL)
+                && strcmp (tree->u.object.keys[i], "annotations"))
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %s\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-    return ret;
+    return move_ptr (ret);
 }
 
 void
@@ -179,6 +210,8 @@ free_runtime_spec_schema_state_schema (r
     ptr->bundle = NULL;
     free_json_map_string_string (ptr->annotations);
     ptr->annotations = NULL;
+    yajl_tree_free (ptr->_residual);
+    ptr->_residual = NULL;
     free (ptr);
 }
 
@@ -260,6 +293,12 @@ gen_runtime_spec_schema_state_schema (ya
         if (stat != yajl_gen_status_ok)
             GEN_SET_ERROR_AND_RETURN (stat, err);
       }
+    if (ptr != NULL && ptr->_residual != NULL)
+    {
+        stat = gen_yajl_object_residual (ptr->_residual, g, err);
+        if (yajl_gen_status_ok != stat)
+            GEN_SET_ERROR_AND_RETURN (stat, err);
+    }
     stat = yajl_gen_map_close ((yajl_gen) g);
     if (stat != yajl_gen_status_ok)
         GEN_SET_ERROR_AND_RETURN (stat, err);
@@ -272,7 +311,7 @@ runtime_spec_schema_state_schema_parse_f
 {
     runtime_spec_schema_state_schema *ptr = NULL;
     size_t filesize;
-    char *content = NULL;
+    __auto_free char *content = NULL;
 
     if (filename == NULL || err == NULL)
       return NULL;
@@ -286,15 +325,15 @@ runtime_spec_schema_state_schema_parse_f
         return NULL;
       }
     ptr = runtime_spec_schema_state_schema_parse_data (content, ctx, err);
-    free (content);
     return ptr;
 }
 
-runtime_spec_schema_state_schema *runtime_spec_schema_state_schema_parse_file_stream (FILE *stream, const struct parser_context *ctx, parser_error *err)
+runtime_spec_schema_state_schema *
+runtime_spec_schema_state_schema_parse_file_stream (FILE *stream, const struct parser_context *ctx, parser_error *err)
 {
     runtime_spec_schema_state_schema *ptr = NULL;
     size_t filesize;
-    char *content = NULL ;
+    __auto_free char *content = NULL ;
 
     if (stream == NULL || err == NULL)
       return NULL;
@@ -307,14 +346,16 @@ runtime_spec_schema_state_schema *runtim
         return NULL;
       }
     ptr = runtime_spec_schema_state_schema_parse_data (content, ctx, err);
-    free (content);
     return ptr;
 }
 
-runtime_spec_schema_state_schema *runtime_spec_schema_state_schema_parse_data (const char *jsondata, const struct parser_context *ctx, parser_error *err)
+define_cleaner_function (yajl_val, yajl_tree_free)
+
+runtime_spec_schema_state_schema *
+runtime_spec_schema_state_schema_parse_data (const char *jsondata, const struct parser_context *ctx, parser_error *err)
 {
     runtime_spec_schema_state_schema *ptr = NULL;
-    yajl_val tree;
+    __auto_cleanup(yajl_tree_free) yajl_val tree;
     char errbuf[1024];
     struct parser_context tmp_ctx = { 0 };
 
@@ -333,12 +374,24 @@ runtime_spec_schema_state_schema *runtim
         return NULL;
       }
     ptr = make_runtime_spec_schema_state_schema (tree, ctx, err);
-    yajl_tree_free (tree);
     return ptr;
 }
-char *runtime_spec_schema_state_schema_generate_json(const runtime_spec_schema_state_schema *ptr, const struct parser_context *ctx, parser_error *err)
+
+static void
+cleanup_yajl_gen (yajl_gen g)
+{
+    if (!g)
+      return;
+    yajl_gen_clear (g);
+    yajl_gen_free (g);
+}
+
+define_cleaner_function (yajl_gen, cleanup_yajl_gen)
+
+char *
+runtime_spec_schema_state_schema_generate_json (const runtime_spec_schema_state_schema *ptr, const struct parser_context *ctx, parser_error *err)
 {
-    yajl_gen g = NULL;
+    __auto_cleanup(cleanup_yajl_gen) yajl_gen g = NULL;
     struct parser_context tmp_ctx = { 0 };
     const unsigned char *gen_buf = NULL;
     char *json_buf = NULL;
@@ -354,35 +407,31 @@ char *runtime_spec_schema_state_schema_g
     if (!json_gen_init(&g, ctx))
       {
         *err = strdup ("Json_gen init failed");
-        goto out;
+        return json_buf;
       }
 
     if (yajl_gen_status_ok != gen_runtime_spec_schema_state_schema (g, ptr, ctx, err))
       {
         if (*err == NULL)
             *err = strdup ("Failed to generate json");
-        goto free_out;
+        return json_buf;
       }
 
     yajl_gen_get_buf (g, &gen_buf, &gen_len);
     if (gen_buf == NULL)
       {
         *err = strdup ("Error to get generated json");
-        goto free_out;
+        return json_buf;
       }
 
     json_buf = calloc (1, gen_len + 1);
     if (json_buf == NULL)
       {
         *err = strdup ("Cannot allocate memory");
-        goto free_out;
+        return json_buf;
       }
-    (void) memcpy(json_buf, gen_buf, gen_len);
+    (void) memcpy (json_buf, gen_buf, gen_len);
     json_buf[gen_len] = '\0';
 
-free_out:
-    yajl_gen_clear (g);
-    yajl_gen_free (g);
-out:
     return json_buf;
 }
diff -pruN 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_state_schema.h 0.15+dfsg-1/libocispec/src/runtime_spec_schema_state_schema.h
--- 0.14.1+dfsg-1/libocispec/src/runtime_spec_schema_state_schema.h	2020-07-08 06:50:09.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/runtime_spec_schema_state_schema.h	2020-09-23 11:23:27.000000000 +0000
@@ -25,6 +25,7 @@ typedef struct {
 
     json_map_string_string *annotations;
 
+    yajl_val _residual;
 }
 runtime_spec_schema_state_schema;
 
diff -pruN 0.14.1+dfsg-1/libocispec/src/sources.py 0.15+dfsg-1/libocispec/src/sources.py
--- 0.14.1+dfsg-1/libocispec/src/sources.py	2020-06-18 12:41:03.000000000 +0000
+++ 0.15+dfsg-1/libocispec/src/sources.py	2020-09-03 12:13:17.000000000 +0000
@@ -70,7 +70,6 @@ def parse_map_string_obj(obj, c_file, pr
                  (child.fixname, child.fixname))
     c_file.write('        if (ret->%s == NULL)\n' % child.fixname)
     c_file.write('          {\n')
-    c_file.write('            free (ret->keys);\n')
     c_file.write('            return NULL;\n')
     c_file.write('          }\n')
     c_file.write('        for (i = 0; i < len; i++)\n')
@@ -80,7 +79,6 @@ def parse_map_string_obj(obj, c_file, pr
     c_file.write('            ret->keys[i] = strdup (tmpkey ? tmpkey : "");\n')
     c_file.write('            if (ret->keys[i] == NULL)\n')
     c_file.write('              {\n')
-    c_file.write("                free_%s (ret);\n" % obj_typename)
     c_file.write("                return NULL;\n")
     c_file.write('              }\n')
     c_file.write('            val = values[i];\n')
@@ -88,7 +86,6 @@ def parse_map_string_obj(obj, c_file, pr
                  % (child.fixname, childname))
     c_file.write('            if (ret->%s[i] == NULL)\n' % (child.fixname))
     c_file.write('              {\n')
-    c_file.write("                free_%s (ret);\n" % obj_typename)
     c_file.write("                return NULL;\n")
     c_file.write('              }\n')
     c_file.write('        }\n')
@@ -146,7 +143,6 @@ def parse_obj_type(obj, c_file, prefix,
             % (obj.fixname, typename, obj.origname))
         c_file.write("    if (ret->%s == NULL && *err != 0)\n" % obj.fixname)
         c_file.write("      {\n")
-        c_file.write("        free_%s (ret);\n" % obj_typename)
         c_file.write("        return NULL;\n")
         c_file.write("      }\n")
     elif obj.typ == 'array' and (obj.subtypobj or obj.subtyp == 'object'):
@@ -169,7 +165,6 @@ def parse_obj_type(obj, c_file, prefix,
                      (obj.fixname, obj.fixname))
         c_file.write('            if (ret->%s == NULL)\n' % obj.fixname)
         c_file.write('              {\n')
-        c_file.write("                free_%s (ret);\n" % obj_typename)
         c_file.write('                return NULL;\n')
         c_file.write('              }\n')
         c_file.write('            for (i = 0; i < len; i++)\n')
@@ -179,7 +174,6 @@ def parse_obj_type(obj, c_file, prefix,
                      % (obj.fixname, typename))
         c_file.write('                if (ret->%s[i] == NULL)\n' % (obj.fixname))
         c_file.write('                  {\n')
-        c_file.write("                    free_%s (ret);\n" % obj_typename)
         c_file.write("                    return NULL;\n")
         c_file.write('                }\n')
         c_file.write('            }\n')
@@ -219,7 +213,6 @@ def parse_obj_type(obj, c_file, prefix,
                      % (obj.fixname, obj.fixname))
         c_file.write('            if (ret->%s == NULL)\n' % obj.fixname)
         c_file.write('              {\n')
-        c_file.write('                free_%s (ret);\n' % obj_typename)
         c_file.write('                return NULL;\n')
         c_file.write('              }\n')
         c_file.write('            for (i = 0; i < len; i++)\n')
@@ -248,7 +241,6 @@ def parse_obj_type(obj, c_file, prefix,
                      '"error allocating memory");\n')
         c_file.write('                free (*err);\n')
         c_file.write('                *err = new_error;\n')
-        c_file.write('                free_%s (ret);\n' % obj_typename)
         c_file.write('                return NULL;\n')
         c_file.write('            }\n')
         c_file.write('        }\n')
@@ -275,7 +267,6 @@ def parse_obj_arr_obj(obj, c_file, prefi
         c_file.write('        if (asprintf (err, "Required field \'%%s\' not present", ' \
                      ' "%s") < 0)\n' % i.origname)
         c_file.write('            *err = strdup ("error allocating memory");\n')
-        c_file.write("        free_%s (ret);\n" % obj_typename)
         c_file.write("        return NULL;\n")
         c_file.write('      }\n')
 
@@ -284,19 +275,59 @@ def parse_obj_arr_obj(obj, c_file, prefi
         condition = "\n                && ".join( \
             ['strcmp (tree->u.object.keys[i], "%s")' % i.origname for i in obj.children])
         c_file.write("""
-    if (tree->type == yajl_t_object && (ctx->options & OPT_PARSE_STRICT))
+    if (tree->type == yajl_t_object)
       {
         size_t i;
+        size_t j = 0;
+        size_t cnt = tree->u.object.len;
+        yajl_val resi = NULL;
+
+        if (ctx->options & OPT_PARSE_FULLKEY)
+          {
+            resi = calloc (1, sizeof(*tree));
+            if (resi == NULL)
+              {
+                return NULL;
+              }
+            resi->type = yajl_t_object;
+            resi->u.object.keys = calloc (cnt, sizeof (const char *));
+            if (resi->u.object.keys == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
+            if (resi->u.object.values == NULL)
+              {
+                yajl_tree_free (resi);
+                return NULL;
+              }
+          }
+
         for (i = 0; i < tree->u.object.len; i++)
           {
-            if (%s && ctx->errfile != NULL)
+            if (%s)
               {
-                (void) fprintf (ctx->errfile, "WARNING: unknown key found: %%s\\n",
-                        tree->u.object.keys[i]);
+                if (ctx->options & OPT_PARSE_FULLKEY)
+                  {
+                    resi->u.object.keys[j] = tree->u.object.keys[i];
+                    tree->u.object.keys[i] = NULL;
+                    resi->u.object.values[j] = tree->u.object.values[i];
+                    tree->u.object.values[i] = NULL;
+                    resi->u.object.len++;
+                  }
+                j++;
               }
           }
+        if (ctx->options & OPT_PARSE_STRICT)
+          {
+            if (j > 0 && ctx->errfile != NULL)
+                (void) fprintf (ctx->errfile, "WARNING: unknown key found\\n");
+          }
+        if (ctx->options & OPT_PARSE_FULLKEY)
+            ret->_residual = resi;
       }
-""" % condition)
+""" % (condition))
 
 
 def parse_json_to_c(obj, c_file, prefix):
@@ -316,14 +347,15 @@ def parse_json_to_c(obj, c_file, prefix)
         objs = obj.subtypobj
         if objs is None or obj.subtypname:
             return
+    c_file.write("define_cleaner_function (%s *, free_%s)\n" % (typename, typename))
     c_file.write("%s *\nmake_%s (yajl_val tree, const struct parser_context *ctx, "\
         "parser_error *err)\n" % (typename, typename))
     c_file.write("{\n")
-    c_file.write("    %s *ret = NULL;\n" % (typename))
+    c_file.write("    __auto_cleanup(free_%s) %s *ret = NULL;\n" % (typename, typename))
     c_file.write("    *err = NULL;\n")
     c_file.write("    (void) ctx;  /* Silence compiler warning.  */\n")
     c_file.write("    if (tree == NULL)\n")
-    c_file.write("      return ret;\n")
+    c_file.write("      return NULL;\n")
     c_file.write("    ret = calloc (1, sizeof (*ret));\n")
     c_file.write("    if (ret == NULL)\n")
     c_file.write("      return NULL;\n")
@@ -332,7 +364,7 @@ def parse_json_to_c(obj, c_file, prefix)
 
     if obj.typ == 'object' or (obj.typ == 'array' and obj.subtypobj):
         parse_obj_arr_obj(obj, c_file, prefix, obj_typename)
-    c_file.write('    return ret;\n')
+    c_file.write('    return move_ptr (ret);\n')
     c_file.write("}\n\n")
 
 
@@ -606,6 +638,14 @@ def get_c_json(obj, c_file, prefix):
         c_file.write("        GEN_SET_ERROR_AND_RETURN (stat, err);\n")
         for i in nodes or []:
             get_obj_arr_obj(i, c_file, prefix)
+        if obj.typ == 'object':
+            if obj.children is not None:
+                c_file.write("    if (ptr != NULL && ptr->_residual != NULL)\n")
+                c_file.write("    {\n")
+                c_file.write("        stat = gen_yajl_object_residual (ptr->_residual, g, err);\n")
+                c_file.write("        if (yajl_gen_status_ok != stat)\n")
+                c_file.write("            GEN_SET_ERROR_AND_RETURN (stat, err);\n")
+                c_file.write("    }\n")
         c_file.write("    stat = yajl_gen_map_close ((yajl_gen) g);\n")
         c_file.write("    if (stat != yajl_gen_status_ok)\n")
         c_file.write("        GEN_SET_ERROR_AND_RETURN (stat, err);\n")
@@ -638,7 +678,6 @@ def read_val_generator(c_file, level, sr
                      % ('    ' * (level + 1)))
         c_file.write('%s    free (*err);\n' % ('    ' * (level + 1)))
         c_file.write('%s    *err = new_error;\n' % ('    ' * (level + 1)))
-        c_file.write('%s    free_%s (ret);\n' % ('    ' * (level + 1), obj_typename))
         c_file.write('%s    return NULL;\n' % ('    ' * (level + 1)))
         c_file.write('%s  }\n' % ('    ' * (level + 1)))
         c_file.write('%s}\n' % ('    ' * (level)))
@@ -650,7 +689,6 @@ def read_val_generator(c_file, level, sr
         c_file.write('%s%s = strdup (str ? str : "");\n' % ('    ' * (level + 1), dest))
         c_file.write('%sif (%s == NULL)\n' % ('    ' * (level + 1), dest))
         c_file.write('%s  {\n' % ('    ' * (level+1)))
-        c_file.write('%s    free_%s (ret);\n' % ('    ' * (level + 1), obj_typename))
         c_file.write('%s    return NULL;\n' % ('    ' * (level+1)))
         c_file.write('%s  }\n' % ('    ' * (level+1)))
         c_file.write('%s  }\n' % ('    ' * level))
@@ -675,7 +713,6 @@ def read_val_generator(c_file, level, sr
                      % ('    ' * (level + 1), typ, keyname))
         c_file.write('%s        *err = strdup ("error allocating memory");\n' \
                      % ('    ' * (level + 1)))
-        c_file.write('%s    free_%s (ret);\n' % ('    ' * (level + 1), obj_typename))
         c_file.write('%s    return NULL;\n' % ('    ' * (level + 1)))
         c_file.write('%s}\n' % ('    ' * (level + 1)))
         if '[' not in dest:
@@ -701,7 +738,6 @@ def read_val_generator(c_file, level, sr
                      % ('    ' * (level + 1), typ, keyname))
         c_file.write('%s        *err = strdup ("error allocating memory");\n' \
                      % ('    ' * (level + 1)))
-        c_file.write('%s    free_%s (ret);\n' % ('    ' * (level + 1), obj_typename))
         c_file.write('%s    return NULL;\n' % ('    ' * (level + 1)))
         c_file.write('%s}\n' % ('    ' * (level + 1)))
         c_file.write('%s}\n' % ('    ' * (level)))
@@ -883,6 +919,10 @@ def make_c_free (obj, c_file, prefix):
                 c_file.write("        free_%s (ptr->%s);\n" % (typename, i.fixname))
                 c_file.write("        ptr->%s = NULL;\n" % (i.fixname))
                 c_file.write("      }\n")
+    if obj.typ == 'object':
+        if obj.children is not None:
+            c_file.write("    yajl_tree_free (ptr->_residual);\n")
+            c_file.write("    ptr->_residual = NULL;\n")
     c_file.write("    free (ptr);\n")
     c_file.write("}\n\n")
 
@@ -1041,7 +1081,7 @@ yajl_gen_status gen_%s (yajl_gen g, cons
                            prefix, ' ' if typ == 'object' else '_element *'))
     c_file.write("""
     size_t filesize;
-    char *content = NULL;
+    __auto_free char *content = NULL;
 
     if (filename == NULL || err == NULL)
       return NULL;
@@ -1055,19 +1095,19 @@ yajl_gen_status gen_%s (yajl_gen g, cons
         return NULL;
       }
     ptr = %s_parse_data (content, ctx, err%s);
-    free (content);
     return ptr;
 }
 """ % (prefix, '' if typ == 'object' else ', len'))
     c_file.write("""
-%s%s*%s_parse_file_stream (FILE *stream, const struct parser_context *ctx, parser_error *err%s)
+%s%s*
+%s_parse_file_stream (FILE *stream, const struct parser_context *ctx, parser_error *err%s)
 {
     %s%s*ptr = NULL;""" % (prefix, ' ' if typ == 'object' else '_element *', \
                            prefix, '' if typ == 'object' else ', size_t *len', \
                            prefix, ' ' if typ == 'object' else '_element *'))
     c_file.write("""
     size_t filesize;
-    char *content = NULL ;
+    __auto_free char *content = NULL ;
 
     if (stream == NULL || err == NULL)
       return NULL;
@@ -1080,18 +1120,20 @@ yajl_gen_status gen_%s (yajl_gen g, cons
         return NULL;
       }
     ptr = %s_parse_data (content, ctx, err%s);
-    free (content);
     return ptr;
 }
 """ % (prefix, '' if typ == 'object' else ', len'))
     c_file.write("""
-%s%s*%s_parse_data (const char *jsondata, const struct parser_context *ctx, parser_error *err%s)
+define_cleaner_function (yajl_val, yajl_tree_free)
+
+%s%s*
+%s_parse_data (const char *jsondata, const struct parser_context *ctx, parser_error *err%s)
 {
     %s%s*ptr = NULL;""" % (prefix, ' ' if typ == 'object' else '_element *', \
                            prefix, '' if typ == 'object' else ', size_t *len', \
                            prefix, ' ' if typ == 'object' else '_element *'))
     c_file.write("""
-    yajl_val tree;
+    __auto_cleanup(yajl_tree_free) yajl_val tree;
     char errbuf[1024];
     struct parser_context tmp_ctx = { 0 };
 
@@ -1110,17 +1152,27 @@ yajl_gen_status gen_%s (yajl_gen g, cons
         return NULL;
       }
     ptr = make_%s (tree, ctx, err%s);
-    yajl_tree_free (tree);
     return ptr;
 }
 """ % (prefix, '' if typ == 'object' else ', len'))
-    c_file.write("char *%s_generate_json(const %s%s*ptr%s, const struct parser_context *ctx," \
+    c_file.write("""\nstatic void\ncleanup_yajl_gen (yajl_gen g)
+{
+    if (!g)
+      return;
+    yajl_gen_clear (g);
+    yajl_gen_free (g);
+}
+
+define_cleaner_function (yajl_gen, cleanup_yajl_gen)
+
+""")
+    c_file.write("char *\n%s_generate_json (const %s%s*ptr%s, const struct parser_context *ctx," \
                  " parser_error *err)" % (prefix, prefix, \
                                             ' ' if typ == 'object' else '_element *', \
                                             '' if typ == 'object' else ', size_t len'))
     c_file.write("""
 {
-    yajl_gen g = NULL;
+    __auto_cleanup(cleanup_yajl_gen) yajl_gen g = NULL;
     struct parser_context tmp_ctx = { 0 };
     const unsigned char *gen_buf = NULL;
     char *json_buf = NULL;
@@ -1136,36 +1188,32 @@ yajl_gen_status gen_%s (yajl_gen g, cons
     if (!json_gen_init(&g, ctx))
       {
         *err = strdup ("Json_gen init failed");
-        goto out;
+        return json_buf;
       }
 
     if (yajl_gen_status_ok != gen_%s (g, ptr%s, ctx, err))
       {
         if (*err == NULL)
             *err = strdup ("Failed to generate json");
-        goto free_out;
+        return json_buf;
       }
 
     yajl_gen_get_buf (g, &gen_buf, &gen_len);
     if (gen_buf == NULL)
       {
         *err = strdup ("Error to get generated json");
-        goto free_out;
+        return json_buf;
       }
 
     json_buf = calloc (1, gen_len + 1);
     if (json_buf == NULL)
       {
         *err = strdup ("Cannot allocate memory");
-        goto free_out;
+        return json_buf;
       }
-    (void) memcpy(json_buf, gen_buf, gen_len);
+    (void) memcpy (json_buf, gen_buf, gen_len);
     json_buf[gen_len] = '\\0';
 
-free_out:
-    yajl_gen_clear (g);
-    yajl_gen_free (g);
-out:
     return json_buf;
 }
 """ % (prefix, '' if typ == 'object' else ', len'))
diff -pruN 0.14.1+dfsg-1/libocispec/tests/data/residual_image_layout_config.json 0.15+dfsg-1/libocispec/tests/data/residual_image_layout_config.json
--- 0.14.1+dfsg-1/libocispec/tests/data/residual_image_layout_config.json	1970-01-01 00:00:00.000000000 +0000
+++ 0.15+dfsg-1/libocispec/tests/data/residual_image_layout_config.json	2020-09-03 12:13:17.000000000 +0000
@@ -0,0 +1,16 @@
+{
+    "imageLayoutVersion": "1.0.0",
+    "residual_int": 1,
+    "residual_float": 1.1,
+    "residual_string": "residual",
+    "residual_true": true,
+    "residual_false": false,
+    "residual_array": [
+        1, 2, 3, 4, 5, 6
+    ],
+    "residual_obj": {
+        "key1": "value1",
+        "key2": "value2",
+        "key3": "value3"
+    }
+}
diff -pruN 0.14.1+dfsg-1/libocispec/tests/test-9.c 0.15+dfsg-1/libocispec/tests/test-9.c
--- 0.14.1+dfsg-1/libocispec/tests/test-9.c	1970-01-01 00:00:00.000000000 +0000
+++ 0.15+dfsg-1/libocispec/tests/test-9.c	2020-09-22 18:18:06.000000000 +0000
@@ -0,0 +1,86 @@
+/* Copyright (C) 2020 duguhaotian <knowledgehao@163.com>
+
+libocispec is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 3 of the License, or
+(at your option) any later version.
+
+libocispec is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with libocispec.  If not, see <http://www.gnu.org/licenses/>.
+
+*/
+
+#include "config.h"
+#include <unistd.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include "image_spec_schema_image_layout_schema.h"
+
+int
+main ()
+{
+  parser_error err;
+  struct parser_context ctx;
+  ctx.options = OPT_PARSE_FULLKEY;
+
+  image_spec_schema_image_layout_schema *image_layout = image_spec_schema_image_layout_schema_parse_file ("tests/data/residual_image_layout_config.json", &ctx, &err);
+  image_spec_schema_image_layout_schema *image_layout_gen = NULL;
+  char *json_buf = NULL;
+
+  if (image_layout == NULL) {
+    printf ("error %s\n", err);
+    exit (1);
+  }
+  json_buf = image_spec_schema_image_layout_schema_generate_json(image_layout, &ctx, &err);
+  if (json_buf == NULL) {
+    printf("gen error %s\n", err);
+    free(err);
+    exit (1);
+  }
+  image_layout_gen = image_spec_schema_image_layout_schema_parse_data(json_buf, 0, &err);
+  if (image_layout_gen == NULL) {
+    printf("parse error %s\n", err);
+    free(err);
+    exit(1);
+  }
+
+  if (strcmp (image_layout->image_layout_version, "1.0.0") && strcmp (image_layout->image_layout_version, image_layout_gen->image_layout_version))
+    exit (5);
+
+  printf("%s\n", json_buf);
+
+  // origin json str should same with generate new json str,
+  if (strstr(json_buf, "residual_int") == NULL)
+    exit (51);
+  if (strstr(json_buf, "residual_float") == NULL)
+    exit (52);
+  if (strstr(json_buf, "residual_string") == NULL)
+    exit (53);
+  if (strstr(json_buf, "residual_true") == NULL)
+    exit (54);
+  if (strstr(json_buf, "residual_false") == NULL)
+    exit (55);
+  if (strstr(json_buf, "residual_array") == NULL)
+    exit (56);
+  if (strstr(json_buf, "residual_obj") == NULL)
+    exit (57);
+  if (strstr(json_buf, "key1") == NULL ||
+          strstr(json_buf, "key2") == NULL ||
+          strstr(json_buf, "key3") == NULL)
+    exit (58);
+  if (strstr(json_buf, "value1") == NULL ||
+          strstr(json_buf, "value2") == NULL ||
+          strstr(json_buf, "value3") == NULL)
+    exit (59);
+
+  free(json_buf);
+  free_image_spec_schema_image_layout_schema (image_layout);
+  free_image_spec_schema_image_layout_schema (image_layout_gen);
+  exit (0);
+}
diff -pruN 0.14.1+dfsg-1/Makefile.am 0.15+dfsg-1/Makefile.am
--- 0.14.1+dfsg-1/Makefile.am	2020-07-08 06:49:25.000000000 +0000
+++ 0.15+dfsg-1/Makefile.am	2020-09-22 20:26:46.000000000 +0000
@@ -14,10 +14,7 @@ srpm: dist-gzip rpm/crun.spec
 	$(MAKE) -C $(WD) dist-gzip
 	rpmbuild -bs --define "_sourcedir $(WD)" --define "_specdir $(WD)" --define "_builddir $(WD)" --define "_srcrpmdir $(WD)" --define "_rpmdir $(WD)" --define "_buildrootdir $(WD)/.build" rpm/crun.spec
 
-oci-runtime-validation:
-	RUNTIME=$(CURDIR)/crun tests/oci-runtime-validation
-
-CLEANFILES = crun.spec crun.1
+CLEANFILES = crun.spec
 
 lib_LTLIBRARIES = libcrun.la
 
@@ -35,7 +32,9 @@ libcrun_SOURCES = src/libcrun/utils.c \
 			src/libcrun/status.c \
 			src/libcrun/terminal.c \
 			src/libcrun/chroot_realpath.c \
-			src/libcrun/signals.c
+			src/libcrun/signals.c \
+			src/libcrun/seccomp_notify.c
+
 
 libcrun_la_SOURCES = $(libcrun_SOURCES)
 libcrun_la_CFLAGS = -I $(abs_top_builddir)/libocispec/src -I $(abs_top_srcdir)/libocispec/src -fvisibility=hidden
@@ -65,11 +64,11 @@ crun_LDFLAGS = $(CRUN_LDFLAGS)
 EXTRA_DIST = COPYING COPYING.libcrun README.md NEWS SECURITY.md rpm/crun.spec.in autogen.sh \
 	src/crun.h src/list.h src/run.h src/delete.h src/kill.h src/pause.h src/unpause.h \
 	src/create.h src/start.h src/state.h src/exec.h src/spec.h src/update.h src/ps.h \
-	src/checkpoint.h src/restore.h \
+	src/checkpoint.h src/restore.h src/libcrun/seccomp_notify.h src/libcrun/seccomp_notify_plugin.h \
 	src/libcrun/container.h src/libcrun/seccomp.h src/libcrun/ebpf.h src/libcrun/cgroup.h \
 	src/libcrun/linux.h src/libcrun/utils.h src/libcrun/error.h src/libcrun/criu.h \
 	src/libcrun/status.h src/libcrun/terminal.h \
-	src/libcrun/intprops.h crun.1.md
+	src/libcrun/intprops.h crun.1.md crun.1 libcrun.lds
 
 UNIT_TESTS = tests/tests_libcrun_utils tests/tests_libcrun_errors
 
@@ -138,13 +137,14 @@ dist-hook:
 EXTRA_DIST += $(TESTS) tests/Makefile.tests tests/run_all_tests.sh tests/tests_utils.py build-aux/git-version-gen .version git-version.h src/libcrun/signals.perf
 BUILT_SOURCES = .version git-version.h
 
-if HAVE_MD2MAN
 man1_MANS = crun.1
+
 crun.1: $(abs_srcdir)/crun.1.md
+if HAVE_MD2MAN
 	$(MD2MAN) -in $(abs_srcdir)/crun.1.md -out crun.1
+endif HAVE_MD2MAN
 
 generate-man: crun.1
-endif HAVE_MD2MAN
 
 sync:
 	(cd libocispec; git pull https://github.com/containers/libocispec)
@@ -161,4 +161,8 @@ generate-rust-bindings: libcrun.rs
 generate-signals.c: src/libcrun/signals.perf
 	${GPERF} --lookup-function-name libcrun_signal_in_word_set -m 100 --null-strings --pic -tCEG -S1 $< > src/libcrun/signals.c
 
-.PHONY: coverity sync generate-rust-bindings generate-signals.c
+clang-format:
+# do not format files that were copied into the source directory.
+	git ls-files src | egrep "\\.[hc]" | grep -v "chroot_realpath.c\|cloned_binary.c\|signals.c" | xargs clang-format -style=file -i
+
+.PHONY: coverity sync generate-rust-bindings generate-signals.c clang-format
diff -pruN 0.14.1+dfsg-1/Makefile.in 0.15+dfsg-1/Makefile.in
--- 0.14.1+dfsg-1/Makefile.in	2020-07-08 06:50:03.000000000 +0000
+++ 0.15+dfsg-1/Makefile.in	2020-09-23 14:48:58.000000000 +0000
@@ -169,7 +169,8 @@ am__objects_1 = src/libcrun/libcrun_test
 	src/libcrun/libcrun_testing_a-status.$(OBJEXT) \
 	src/libcrun/libcrun_testing_a-terminal.$(OBJEXT) \
 	src/libcrun/libcrun_testing_a-chroot_realpath.$(OBJEXT) \
-	src/libcrun/libcrun_testing_a-signals.$(OBJEXT)
+	src/libcrun/libcrun_testing_a-signals.$(OBJEXT) \
+	src/libcrun/libcrun_testing_a-seccomp_notify.$(OBJEXT)
 am_libcrun_testing_a_OBJECTS = $(am__objects_1)
 libcrun_testing_a_OBJECTS = $(am_libcrun_testing_a_OBJECTS)
 libcrun_la_DEPENDENCIES = libocispec/libocispec.la
@@ -183,7 +184,8 @@ am__objects_2 = src/libcrun/libcrun_la-u
 	src/libcrun/libcrun_la-status.lo \
 	src/libcrun/libcrun_la-terminal.lo \
 	src/libcrun/libcrun_la-chroot_realpath.lo \
-	src/libcrun/libcrun_la-signals.lo
+	src/libcrun/libcrun_la-signals.lo \
+	src/libcrun/libcrun_la-seccomp_notify.lo
 am_libcrun_la_OBJECTS = $(am__objects_2)
 libcrun_la_OBJECTS = $(am_libcrun_la_OBJECTS)
 AM_V_lt = $(am__v_lt_@AM_V@)
@@ -278,6 +280,7 @@ am__depfiles_remade = python/$(DEPDIR)/c
 	src/libcrun/$(DEPDIR)/libcrun_la-error.Plo \
 	src/libcrun/$(DEPDIR)/libcrun_la-linux.Plo \
 	src/libcrun/$(DEPDIR)/libcrun_la-seccomp.Plo \
+	src/libcrun/$(DEPDIR)/libcrun_la-seccomp_notify.Plo \
 	src/libcrun/$(DEPDIR)/libcrun_la-signals.Plo \
 	src/libcrun/$(DEPDIR)/libcrun_la-status.Plo \
 	src/libcrun/$(DEPDIR)/libcrun_la-terminal.Plo \
@@ -291,6 +294,7 @@ am__depfiles_remade = python/$(DEPDIR)/c
 	src/libcrun/$(DEPDIR)/libcrun_testing_a-error.Po \
 	src/libcrun/$(DEPDIR)/libcrun_testing_a-linux.Po \
 	src/libcrun/$(DEPDIR)/libcrun_testing_a-seccomp.Po \
+	src/libcrun/$(DEPDIR)/libcrun_testing_a-seccomp_notify.Po \
 	src/libcrun/$(DEPDIR)/libcrun_testing_a-signals.Po \
 	src/libcrun/$(DEPDIR)/libcrun_testing_a-status.Po \
 	src/libcrun/$(DEPDIR)/libcrun_testing_a-terminal.Po \
@@ -741,7 +745,7 @@ DIST_SUBDIRS = libocispec
 SUBDIRS = libocispec
 ACLOCAL_AMFLAGS = -I m4
 WD := $(shell pwd)
-CLEANFILES = crun.spec crun.1
+CLEANFILES = crun.spec
 lib_LTLIBRARIES = libcrun.la
 check_LIBRARIES = libcrun_testing.a
 libcrun_SOURCES = src/libcrun/utils.c \
@@ -756,7 +760,8 @@ libcrun_SOURCES = src/libcrun/utils.c \
 			src/libcrun/status.c \
 			src/libcrun/terminal.c \
 			src/libcrun/chroot_realpath.c \
-			src/libcrun/signals.c
+			src/libcrun/signals.c \
+			src/libcrun/seccomp_notify.c
 
 libcrun_la_SOURCES = $(libcrun_SOURCES)
 libcrun_la_CFLAGS = -I $(abs_top_builddir)/libocispec/src -I $(abs_top_srcdir)/libocispec/src -fvisibility=hidden
@@ -784,14 +789,15 @@ EXTRA_DIST = COPYING COPYING.libcrun REA
 	src/delete.h src/kill.h src/pause.h src/unpause.h src/create.h \
 	src/start.h src/state.h src/exec.h src/spec.h src/update.h \
 	src/ps.h src/checkpoint.h src/restore.h \
-	src/libcrun/container.h src/libcrun/seccomp.h \
-	src/libcrun/ebpf.h src/libcrun/cgroup.h src/libcrun/linux.h \
-	src/libcrun/utils.h src/libcrun/error.h src/libcrun/criu.h \
-	src/libcrun/status.h src/libcrun/terminal.h \
-	src/libcrun/intprops.h crun.1.md $(TESTS) tests/Makefile.tests \
-	tests/run_all_tests.sh tests/tests_utils.py \
-	build-aux/git-version-gen .version git-version.h \
-	src/libcrun/signals.perf
+	src/libcrun/seccomp_notify.h \
+	src/libcrun/seccomp_notify_plugin.h src/libcrun/container.h \
+	src/libcrun/seccomp.h src/libcrun/ebpf.h src/libcrun/cgroup.h \
+	src/libcrun/linux.h src/libcrun/utils.h src/libcrun/error.h \
+	src/libcrun/criu.h src/libcrun/status.h src/libcrun/terminal.h \
+	src/libcrun/intprops.h crun.1.md crun.1 libcrun.lds $(TESTS) \
+	tests/Makefile.tests tests/run_all_tests.sh \
+	tests/tests_utils.py build-aux/git-version-gen .version \
+	git-version.h src/libcrun/signals.perf
 UNIT_TESTS = tests/tests_libcrun_utils tests/tests_libcrun_errors
 TESTS_LDADD = libcrun_testing.a $(FOUND_LIBS)
 tests_init_LDADD = 
@@ -810,7 +816,7 @@ PY_LOG_COMPILER = $(PYTHON)
 PY_LOG_DRIVER = env AM_TAP_AWK='$(AWK)' $(SHELL) $(top_srcdir)/build-aux/tap-driver.sh
 LOG_DRIVER = env AM_TAP_AWK='$(AWK)' $(SHELL) $(top_srcdir)/build-aux/tap-driver.sh
 BUILT_SOURCES = .version git-version.h
-@HAVE_MD2MAN_TRUE@man1_MANS = crun.1
+man1_MANS = crun.1
 all: $(BUILT_SOURCES) config.h
 	$(MAKE) $(AM_MAKEFLAGS) all-recursive
 
@@ -1042,6 +1048,9 @@ src/libcrun/libcrun_testing_a-chroot_rea
 src/libcrun/libcrun_testing_a-signals.$(OBJEXT):  \
 	src/libcrun/$(am__dirstamp) \
 	src/libcrun/$(DEPDIR)/$(am__dirstamp)
+src/libcrun/libcrun_testing_a-seccomp_notify.$(OBJEXT):  \
+	src/libcrun/$(am__dirstamp) \
+	src/libcrun/$(DEPDIR)/$(am__dirstamp)
 
 libcrun_testing.a: $(libcrun_testing_a_OBJECTS) $(libcrun_testing_a_DEPENDENCIES) $(EXTRA_libcrun_testing_a_DEPENDENCIES) 
 	$(AM_V_at)-rm -f libcrun_testing.a
@@ -1074,6 +1083,8 @@ src/libcrun/libcrun_la-chroot_realpath.l
 	src/libcrun/$(DEPDIR)/$(am__dirstamp)
 src/libcrun/libcrun_la-signals.lo: src/libcrun/$(am__dirstamp) \
 	src/libcrun/$(DEPDIR)/$(am__dirstamp)
+src/libcrun/libcrun_la-seccomp_notify.lo: src/libcrun/$(am__dirstamp) \
+	src/libcrun/$(DEPDIR)/$(am__dirstamp)
 
 libcrun.la: $(libcrun_la_OBJECTS) $(libcrun_la_DEPENDENCIES) $(EXTRA_libcrun_la_DEPENDENCIES) 
 	$(AM_V_CCLD)$(libcrun_la_LINK) -rpath $(libdir) $(libcrun_la_OBJECTS) $(libcrun_la_LIBADD) $(LIBS)
@@ -1193,6 +1204,7 @@ distclean-compile:
 @AMDEP_TRUE@@am__include@ @am__quote@src/libcrun/$(DEPDIR)/libcrun_la-error.Plo@am__quote@ # am--include-marker
 @AMDEP_TRUE@@am__include@ @am__quote@src/libcrun/$(DEPDIR)/libcrun_la-linux.Plo@am__quote@ # am--include-marker
 @AMDEP_TRUE@@am__include@ @am__quote@src/libcrun/$(DEPDIR)/libcrun_la-seccomp.Plo@am__quote@ # am--include-marker
+@AMDEP_TRUE@@am__include@ @am__quote@src/libcrun/$(DEPDIR)/libcrun_la-seccomp_notify.Plo@am__quote@ # am--include-marker
 @AMDEP_TRUE@@am__include@ @am__quote@src/libcrun/$(DEPDIR)/libcrun_la-signals.Plo@am__quote@ # am--include-marker
 @AMDEP_TRUE@@am__include@ @am__quote@src/libcrun/$(DEPDIR)/libcrun_la-status.Plo@am__quote@ # am--include-marker
 @AMDEP_TRUE@@am__include@ @am__quote@src/libcrun/$(DEPDIR)/libcrun_la-terminal.Plo@am__quote@ # am--include-marker
@@ -1206,6 +1218,7 @@ distclean-compile:
 @AMDEP_TRUE@@am__include@ @am__quote@src/libcrun/$(DEPDIR)/libcrun_testing_a-error.Po@am__quote@ # am--include-marker
 @AMDEP_TRUE@@am__include@ @am__quote@src/libcrun/$(DEPDIR)/libcrun_testing_a-linux.Po@am__quote@ # am--include-marker
 @AMDEP_TRUE@@am__include@ @am__quote@src/libcrun/$(DEPDIR)/libcrun_testing_a-seccomp.Po@am__quote@ # am--include-marker
+@AMDEP_TRUE@@am__include@ @am__quote@src/libcrun/$(DEPDIR)/libcrun_testing_a-seccomp_notify.Po@am__quote@ # am--include-marker
 @AMDEP_TRUE@@am__include@ @am__quote@src/libcrun/$(DEPDIR)/libcrun_testing_a-signals.Po@am__quote@ # am--include-marker
 @AMDEP_TRUE@@am__include@ @am__quote@src/libcrun/$(DEPDIR)/libcrun_testing_a-status.Po@am__quote@ # am--include-marker
 @AMDEP_TRUE@@am__include@ @am__quote@src/libcrun/$(DEPDIR)/libcrun_testing_a-terminal.Po@am__quote@ # am--include-marker
@@ -1426,6 +1439,20 @@ src/libcrun/libcrun_testing_a-signals.ob
 @AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
 @am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libcrun_testing_a_CFLAGS) $(CFLAGS) -c -o src/libcrun/libcrun_testing_a-signals.obj `if test -f 'src/libcrun/signals.c'; then $(CYGPATH_W) 'src/libcrun/signals.c'; else $(CYGPATH_W) '$(srcdir)/src/libcrun/signals.c'; fi`
 
+src/libcrun/libcrun_testing_a-seccomp_notify.o: src/libcrun/seccomp_notify.c
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libcrun_testing_a_CFLAGS) $(CFLAGS) -MT src/libcrun/libcrun_testing_a-seccomp_notify.o -MD -MP -MF src/libcrun/$(DEPDIR)/libcrun_testing_a-seccomp_notify.Tpo -c -o src/libcrun/libcrun_testing_a-seccomp_notify.o `test -f 'src/libcrun/seccomp_notify.c' || echo '$(srcdir)/'`src/libcrun/seccomp_notify.c
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) src/libcrun/$(DEPDIR)/libcrun_testing_a-seccomp_notify.Tpo src/libcrun/$(DEPDIR)/libcrun_testing_a-seccomp_notify.Po
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='src/libcrun/seccomp_notify.c' object='src/libcrun/libcrun_testing_a-seccomp_notify.o' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libcrun_testing_a_CFLAGS) $(CFLAGS) -c -o src/libcrun/libcrun_testing_a-seccomp_notify.o `test -f 'src/libcrun/seccomp_notify.c' || echo '$(srcdir)/'`src/libcrun/seccomp_notify.c
+
+src/libcrun/libcrun_testing_a-seccomp_notify.obj: src/libcrun/seccomp_notify.c
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libcrun_testing_a_CFLAGS) $(CFLAGS) -MT src/libcrun/libcrun_testing_a-seccomp_notify.obj -MD -MP -MF src/libcrun/$(DEPDIR)/libcrun_testing_a-seccomp_notify.Tpo -c -o src/libcrun/libcrun_testing_a-seccomp_notify.obj `if test -f 'src/libcrun/seccomp_notify.c'; then $(CYGPATH_W) 'src/libcrun/seccomp_notify.c'; else $(CYGPATH_W) '$(srcdir)/src/libcrun/seccomp_notify.c'; fi`
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) src/libcrun/$(DEPDIR)/libcrun_testing_a-seccomp_notify.Tpo src/libcrun/$(DEPDIR)/libcrun_testing_a-seccomp_notify.Po
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='src/libcrun/seccomp_notify.c' object='src/libcrun/libcrun_testing_a-seccomp_notify.obj' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libcrun_testing_a_CFLAGS) $(CFLAGS) -c -o src/libcrun/libcrun_testing_a-seccomp_notify.obj `if test -f 'src/libcrun/seccomp_notify.c'; then $(CYGPATH_W) 'src/libcrun/seccomp_notify.c'; else $(CYGPATH_W) '$(srcdir)/src/libcrun/seccomp_notify.c'; fi`
+
 src/libcrun/libcrun_la-utils.lo: src/libcrun/utils.c
 @am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libcrun_la_CFLAGS) $(CFLAGS) -MT src/libcrun/libcrun_la-utils.lo -MD -MP -MF src/libcrun/$(DEPDIR)/libcrun_la-utils.Tpo -c -o src/libcrun/libcrun_la-utils.lo `test -f 'src/libcrun/utils.c' || echo '$(srcdir)/'`src/libcrun/utils.c
 @am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) src/libcrun/$(DEPDIR)/libcrun_la-utils.Tpo src/libcrun/$(DEPDIR)/libcrun_la-utils.Plo
@@ -1517,6 +1544,13 @@ src/libcrun/libcrun_la-signals.lo: src/l
 @AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
 @am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libcrun_la_CFLAGS) $(CFLAGS) -c -o src/libcrun/libcrun_la-signals.lo `test -f 'src/libcrun/signals.c' || echo '$(srcdir)/'`src/libcrun/signals.c
 
+src/libcrun/libcrun_la-seccomp_notify.lo: src/libcrun/seccomp_notify.c
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libcrun_la_CFLAGS) $(CFLAGS) -MT src/libcrun/libcrun_la-seccomp_notify.lo -MD -MP -MF src/libcrun/$(DEPDIR)/libcrun_la-seccomp_notify.Tpo -c -o src/libcrun/libcrun_la-seccomp_notify.lo `test -f 'src/libcrun/seccomp_notify.c' || echo '$(srcdir)/'`src/libcrun/seccomp_notify.c
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) src/libcrun/$(DEPDIR)/libcrun_la-seccomp_notify.Tpo src/libcrun/$(DEPDIR)/libcrun_la-seccomp_notify.Plo
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='src/libcrun/seccomp_notify.c' object='src/libcrun/libcrun_la-seccomp_notify.lo' libtool=yes @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libcrun_la_CFLAGS) $(CFLAGS) -c -o src/libcrun/libcrun_la-seccomp_notify.lo `test -f 'src/libcrun/seccomp_notify.c' || echo '$(srcdir)/'`src/libcrun/seccomp_notify.c
+
 python/crun_la-crun_python.lo: python/crun_python.c
 @am__fastdepCC_TRUE@	$(AM_V_CC)$(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(python_crun_la_CFLAGS) $(CFLAGS) -MT python/crun_la-crun_python.lo -MD -MP -MF python/$(DEPDIR)/crun_la-crun_python.Tpo -c -o python/crun_la-crun_python.lo `test -f 'python/crun_python.c' || echo '$(srcdir)/'`python/crun_python.c
 @am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) python/$(DEPDIR)/crun_la-crun_python.Tpo python/$(DEPDIR)/crun_la-crun_python.Plo
@@ -2389,6 +2423,7 @@ distclean: distclean-recursive
 	-rm -f src/libcrun/$(DEPDIR)/libcrun_la-error.Plo
 	-rm -f src/libcrun/$(DEPDIR)/libcrun_la-linux.Plo
 	-rm -f src/libcrun/$(DEPDIR)/libcrun_la-seccomp.Plo
+	-rm -f src/libcrun/$(DEPDIR)/libcrun_la-seccomp_notify.Plo
 	-rm -f src/libcrun/$(DEPDIR)/libcrun_la-signals.Plo
 	-rm -f src/libcrun/$(DEPDIR)/libcrun_la-status.Plo
 	-rm -f src/libcrun/$(DEPDIR)/libcrun_la-terminal.Plo
@@ -2402,6 +2437,7 @@ distclean: distclean-recursive
 	-rm -f src/libcrun/$(DEPDIR)/libcrun_testing_a-error.Po
 	-rm -f src/libcrun/$(DEPDIR)/libcrun_testing_a-linux.Po
 	-rm -f src/libcrun/$(DEPDIR)/libcrun_testing_a-seccomp.Po
+	-rm -f src/libcrun/$(DEPDIR)/libcrun_testing_a-seccomp_notify.Po
 	-rm -f src/libcrun/$(DEPDIR)/libcrun_testing_a-signals.Po
 	-rm -f src/libcrun/$(DEPDIR)/libcrun_testing_a-status.Po
 	-rm -f src/libcrun/$(DEPDIR)/libcrun_testing_a-terminal.Po
@@ -2483,6 +2519,7 @@ maintainer-clean: maintainer-clean-recur
 	-rm -f src/libcrun/$(DEPDIR)/libcrun_la-error.Plo
 	-rm -f src/libcrun/$(DEPDIR)/libcrun_la-linux.Plo
 	-rm -f src/libcrun/$(DEPDIR)/libcrun_la-seccomp.Plo
+	-rm -f src/libcrun/$(DEPDIR)/libcrun_la-seccomp_notify.Plo
 	-rm -f src/libcrun/$(DEPDIR)/libcrun_la-signals.Plo
 	-rm -f src/libcrun/$(DEPDIR)/libcrun_la-status.Plo
 	-rm -f src/libcrun/$(DEPDIR)/libcrun_la-terminal.Plo
@@ -2496,6 +2533,7 @@ maintainer-clean: maintainer-clean-recur
 	-rm -f src/libcrun/$(DEPDIR)/libcrun_testing_a-error.Po
 	-rm -f src/libcrun/$(DEPDIR)/libcrun_testing_a-linux.Po
 	-rm -f src/libcrun/$(DEPDIR)/libcrun_testing_a-seccomp.Po
+	-rm -f src/libcrun/$(DEPDIR)/libcrun_testing_a-seccomp_notify.Po
 	-rm -f src/libcrun/$(DEPDIR)/libcrun_testing_a-signals.Po
 	-rm -f src/libcrun/$(DEPDIR)/libcrun_testing_a-status.Po
 	-rm -f src/libcrun/$(DEPDIR)/libcrun_testing_a-terminal.Po
@@ -2564,9 +2602,6 @@ srpm: dist-gzip rpm/crun.spec
 	$(MAKE) -C $(WD) dist-gzip
 	rpmbuild -bs --define "_sourcedir $(WD)" --define "_specdir $(WD)" --define "_builddir $(WD)" --define "_srcrpmdir $(WD)" --define "_rpmdir $(WD)" --define "_buildrootdir $(WD)/.build" rpm/crun.spec
 
-oci-runtime-validation:
-	RUNTIME=$(CURDIR)/crun tests/oci-runtime-validation
-
 .version:
 	$(AM_V_GEN)echo $(VERSION) > $@-t && mv $@-t $@
 
@@ -2582,10 +2617,11 @@ nixpkgs:
 dist-hook:
 	$(AM_V_GEN)echo $(VERSION) > $(distdir)/.tarball-version
 	$(AM__GEN)cp git-version.h $(distdir)/git-version.h
-@HAVE_MD2MAN_TRUE@crun.1: $(abs_srcdir)/crun.1.md
+
+crun.1: $(abs_srcdir)/crun.1.md
 @HAVE_MD2MAN_TRUE@	$(MD2MAN) -in $(abs_srcdir)/crun.1.md -out crun.1
 
-@HAVE_MD2MAN_TRUE@generate-man: crun.1
+generate-man: crun.1
 
 sync:
 	(cd libocispec; git pull https://github.com/containers/libocispec)
@@ -2602,7 +2638,11 @@ generate-rust-bindings: libcrun.rs
 generate-signals.c: src/libcrun/signals.perf
 	${GPERF} --lookup-function-name libcrun_signal_in_word_set -m 100 --null-strings --pic -tCEG -S1 $< > src/libcrun/signals.c
 
-.PHONY: coverity sync generate-rust-bindings generate-signals.c
+clang-format:
+# do not format files that were copied into the source directory.
+	git ls-files src | egrep "\\.[hc]" | grep -v "chroot_realpath.c\|cloned_binary.c\|signals.c" | xargs clang-format -style=file -i
+
+.PHONY: coverity sync generate-rust-bindings generate-signals.c clang-format
 
 # Tell versions [3.59,3.63) of GNU make to not export all variables.
 # Otherwise a system limit (for SysV at least) may be exceeded.
diff -pruN 0.14.1+dfsg-1/NEWS 0.15+dfsg-1/NEWS
--- 0.14.1+dfsg-1/NEWS	2020-07-08 06:49:25.000000000 +0000
+++ 0.15+dfsg-1/NEWS	2020-09-23 14:47:06.000000000 +0000
@@ -1,3 +1,21 @@
+* crun-0.15
+
+- add support for OCI unified cgroup v2.
+- add json format option to `crun list`.
+- get last kernel capability dynamically instead of using a build
+  time constant.
+- enable all available cgroup controllers.
+- support the seccomp SCMP_ACT_LOG action.
+- support the seccomp SCMP_ACT_KILL_THREAD action.
+- properly set a SELinux label for the mqueue mount.
+- `crun kill` uses pidfd when supported.
+- experimental support for seccomp notifications.
+- fix bundle option for `crun create` and `crun run`.
+- allow to declare path to config file.
+- check /sys/kernel/security/apparmor when using AppArmor.
+- doesn't accept type=bind alone anymore, but require either "bind"
+  or "rbind" to be present in the mount flags.
+
 * crun-0.14.1
 
 - fix a regression in crun-0.14 where openat2(2) would fail when bind
@@ -52,7 +70,7 @@
   through an annotation.
 - cgroup: write the correct blkio settings.
 - exec: do not inherit env variables from main pid.
-- ebpf: fix endianess issue on s390x.
+- ebpf: fix endianness issue on s390x.
 - linux: fix recursive mount on cgroup v1.
 
 * crun-0.12.2.1
diff -pruN 0.14.1+dfsg-1/python/crun_python.c 0.15+dfsg-1/python/crun_python.c
--- 0.14.1+dfsg-1/python/crun_python.c	2020-07-03 19:38:11.000000000 +0000
+++ 0.15+dfsg-1/python/crun_python.c	2020-09-03 11:43:25.000000000 +0000
@@ -50,10 +50,11 @@ set_error (libcrun_error_t *err)
   else
     {
       cleanup_free char *msg = NULL;
-      asprintf (&msg, "%s: %s", (*err)->msg, strerror ((*err)->status));
-      if (msg == NULL)
-	return NULL;
-      PyErr_SetString (PyExc_RuntimeError, msg);
+      int ret;
+
+      ret = asprintf (&msg, "%s: %s", (*err)->msg, strerror ((*err)->status));
+      if (LIKELY (ret >= 0))
+        PyErr_SetString (PyExc_RuntimeError, msg);
     }
 
   libcrun_error_release (err);
@@ -401,11 +402,10 @@ container_update (PyObject *self, PyObje
   if (process == NULL)
     {
       cleanup_free char *msg = NULL;
-      asprintf (&msg, "cannot parse process: %s", parser_err);
-      if (msg == NULL)
-	return NULL;
+      ret = asprintf (&msg, "cannot parse process: %s", parser_err);
+      if (LIKELY (ret >= 0))
+        PyErr_SetString (PyExc_RuntimeError, msg);
       free (parser_err);
-      PyErr_SetString (PyExc_RuntimeError, msg);
       return NULL;
     }
 
diff -pruN 0.14.1+dfsg-1/README.md 0.15+dfsg-1/README.md
--- 0.14.1+dfsg-1/README.md	2020-07-03 19:38:11.000000000 +0000
+++ 0.15+dfsg-1/README.md	2020-09-03 20:51:17.000000000 +0000
@@ -124,6 +124,10 @@ To install into default PREFIX (`/usr/lo
 sudo make install
 ```
 
+### Shared Libraries
+
+The previous build instructions do not enable shared libraries, therefore you will be unable to use libcrun. If you wish to build the shared libraries you can change the previous `./configure.sh` statement to `./configure --enable-shared`.
+
 ## Static build
 
 It is possible to build a statically linked binary of crun by using the
diff -pruN 0.14.1+dfsg-1/src/checkpoint.c 0.15+dfsg-1/src/checkpoint.c
--- 0.14.1+dfsg-1/src/checkpoint.c	2020-07-03 19:38:11.000000000 +0000
+++ 0.15+dfsg-1/src/checkpoint.c	2020-09-03 11:43:25.000000000 +0000
@@ -46,19 +46,16 @@ static char doc[] = "OCI runtime";
 
 static libcrun_checkpoint_restore_t cr_options;
 
-static struct argp_option options[] = {
-  {"image-path", OPTION_IMAGE_PATH, "DIR", 0,
-   "path for saving criu image files", 0},
-  {"work-path", OPTION_WORK_PATH, "DIR", 0,
-   "path for saving work files and logs", 0},
-  {"leave-running", OPTION_LEAVE_RUNNING, 0, 0,
-   "leave the process running after checkpointing", 0},
-  {"tcp-established", OPTION_TCP_ESTABLISHED, 0, 0,
-   "allow open tcp connections", 0},
-  {"ext-unix-sk", OPTION_EXT_UNIX_SK, 0, 0, "allow external unix sockets", 0},
-  {"shell-job", OPTION_SHELL_JOB, 0, 0, "allow shell jobs", 0},
-  {0,}
-};
+static struct argp_option options[]
+    = { { "image-path", OPTION_IMAGE_PATH, "DIR", 0, "path for saving criu image files", 0 },
+        { "work-path", OPTION_WORK_PATH, "DIR", 0, "path for saving work files and logs", 0 },
+        { "leave-running", OPTION_LEAVE_RUNNING, 0, 0, "leave the process running after checkpointing", 0 },
+        { "tcp-established", OPTION_TCP_ESTABLISHED, 0, 0, "allow open tcp connections", 0 },
+        { "ext-unix-sk", OPTION_EXT_UNIX_SK, 0, 0, "allow external unix sockets", 0 },
+        { "shell-job", OPTION_SHELL_JOB, 0, 0, "allow shell jobs", 0 },
+        {
+            0,
+        } };
 
 static char args_doc[] = "checkpoint CONTAINER";
 
@@ -101,24 +98,23 @@ parse_opt (int key, char *arg arg_unused
   return 0;
 }
 
-static struct argp run_argp =
-  { options, parse_opt, args_doc, doc, NULL, NULL, NULL };
+static struct argp run_argp = { options, parse_opt, args_doc, doc, NULL, NULL, NULL };
 
 int
-crun_command_checkpoint (struct crun_global_arguments *global_args, int argc,
-                         char **argv, libcrun_error_t *err)
+crun_command_checkpoint (struct crun_global_arguments *global_args, int argc, char **argv, libcrun_error_t *err)
 {
   cleanup_free char *cr_path = NULL;
   int first_arg;
   int ret;
 
-  libcrun_context_t crun_context = { 0, };
+  libcrun_context_t crun_context = {
+    0,
+  };
 
   argp_parse (&run_argp, argc, argv, ARGP_IN_ORDER, &first_arg, &cr_options);
   crun_assert_n_args (argc - first_arg, 1, 2);
 
-  ret =
-    init_libcrun_context (&crun_context, argv[first_arg], global_args, err);
+  ret = init_libcrun_context (&crun_context, argv[first_arg], global_args, err);
   if (UNLIKELY (ret < 0))
     return ret;
 
@@ -130,14 +126,11 @@ crun_command_checkpoint (struct crun_glo
       if (UNLIKELY (path == NULL))
         libcrun_fail_with_error (0, "realloc failed");
 
-      asprintf (&cr_path, "%s/checkpoint", path);
-      if (cr_path == NULL)
-        libcrun_fail_with_error (0, "asprintf failed");
-
-
+      ret = asprintf (&cr_path, "%s/checkpoint", path);
+      if (UNLIKELY (ret < 0))
+        OOM ();
       cr_options.image_path = cr_path;
     }
 
-  return libcrun_container_checkpoint (&crun_context, argv[first_arg],
-                                       &cr_options, err);
+  return libcrun_container_checkpoint (&crun_context, argv[first_arg], &cr_options, err);
 }
diff -pruN 0.14.1+dfsg-1/src/checkpoint.h 0.15+dfsg-1/src/checkpoint.h
--- 0.14.1+dfsg-1/src/checkpoint.h	2020-07-02 13:46:33.000000000 +0000
+++ 0.15+dfsg-1/src/checkpoint.h	2020-09-03 11:43:25.000000000 +0000
@@ -20,7 +20,6 @@
 
 #include "crun.h"
 
-int crun_command_checkpoint (struct crun_global_arguments *global_args,
-                             int argc, char **argv, libcrun_error_t * error);
+int crun_command_checkpoint (struct crun_global_arguments *global_args, int argc, char **argv, libcrun_error_t *error);
 
 #endif
diff -pruN 0.14.1+dfsg-1/src/create.c 0.15+dfsg-1/src/create.c
--- 0.14.1+dfsg-1/src/create.c	2020-07-02 13:46:33.000000000 +0000
+++ 0.15+dfsg-1/src/create.c	2020-09-03 11:43:25.000000000 +0000
@@ -29,31 +29,32 @@
 #include "libcrun/utils.h"
 
 enum
-  {
-    OPTION_CONSOLE_SOCKET = 1000,
-    OPTION_PID_FILE,
-    OPTION_NO_SUBREAPER,
-    OPTION_NO_NEW_KEYRING,
-    OPTION_PRESERVE_FDS,
-    OPTION_NO_PIVOT
-  };
+{
+  OPTION_CONSOLE_SOCKET = 1000,
+  OPTION_PID_FILE,
+  OPTION_NO_SUBREAPER,
+  OPTION_NO_NEW_KEYRING,
+  OPTION_PRESERVE_FDS,
+  OPTION_NO_PIVOT
+};
 
 static const char *bundle = NULL;
 
 static libcrun_context_t crun_context;
 
-static struct argp_option options[] =
-  {
-   {"bundle", 'b', 0, 0, "container bundle (default \".\")", 0},
-   {"config", 'f', "FILE", 0, "override the config file name", 0},
-   {"console-socket", OPTION_CONSOLE_SOCKET, "SOCK", 0, "path to a socket that will receive the master end of the tty", 0},
-   {"preserve-fds", OPTION_PRESERVE_FDS, 0, 0, "pass additional FDs to the container", 0},
-   {"no-pivot", OPTION_NO_PIVOT, 0, 0, "do not use pivot_root", 0},
-   {"pid-file", OPTION_PID_FILE, "FILE", 0, "where to write the PID of the container", 0},
-   {"no-subreaper", OPTION_NO_SUBREAPER, 0, 0, "do not create a subreaper process", 0},
-   {"no-new-keyring", OPTION_NO_NEW_KEYRING, 0, 0, "keep the same session key", 0},
-   { 0, }
-  };
+static struct argp_option options[]
+    = { { "bundle", 'b', "DIR", 0, "container bundle (default \".\")", 0 },
+        { "config", 'f', "FILE", 0, "override the config file name", 0 },
+        { "console-socket", OPTION_CONSOLE_SOCKET, "SOCK", 0,
+          "path to a socket that will receive the ptmx end of the tty", 0 },
+        { "preserve-fds", OPTION_PRESERVE_FDS, 0, 0, "pass additional FDs to the container", 0 },
+        { "no-pivot", OPTION_NO_PIVOT, 0, 0, "do not use pivot_root", 0 },
+        { "pid-file", OPTION_PID_FILE, "FILE", 0, "where to write the PID of the container", 0 },
+        { "no-subreaper", OPTION_NO_SUBREAPER, 0, 0, "do not create a subreaper process", 0 },
+        { "no-new-keyring", OPTION_NO_NEW_KEYRING, 0, 0, "keep the same session key", 0 },
+        {
+            0,
+        } };
 
 static char doc[] = "OCI runtime";
 
@@ -71,7 +72,7 @@ parse_opt (int key, char *arg, struct ar
       break;
 
     case 'f':
-      config_file = argp_mandatory_argument (arg, state);
+      config_file = crun_context.config_file = argp_mandatory_argument (arg, state);
       break;
 
     case OPTION_CONSOLE_SOCKET:
@@ -116,12 +117,26 @@ crun_command_create (struct crun_global_
   int first_arg, ret;
   libcrun_container_t *container;
   cleanup_free char *bundle_cleanup = NULL;
+  cleanup_free char *config_file_cleanup = NULL;
 
   crun_context.preserve_fds = 0;
   argp_parse (&run_argp, argc, argv, ARGP_IN_ORDER, &first_arg, &crun_context);
 
   crun_assert_n_args (argc - first_arg, 1, 1);
 
+  /* Make sure the config is an absolute path before changing the directory.  */
+  if ((strcmp ("config.json", config_file) != 0))
+    {
+      if (config_file[0] != '/')
+        {
+          config_file_cleanup = realpath (config_file, NULL);
+          if (config_file_cleanup == NULL)
+            libcrun_fail_with_error (errno, "realpath `%s` failed", config_file);
+          config_file = config_file_cleanup;
+          crun_context.config_file = config_file;
+        }
+    }
+
   /* Make sure the bundle is an absolute path.  */
   if (bundle)
     {
diff -pruN 0.14.1+dfsg-1/src/create.h 0.15+dfsg-1/src/create.h
--- 0.14.1+dfsg-1/src/create.h	2020-07-02 13:46:33.000000000 +0000
+++ 0.15+dfsg-1/src/create.h	2020-09-03 11:43:25.000000000 +0000
@@ -16,9 +16,9 @@
  * along with crun.  If not, see <http://www.gnu.org/licenses/>.
  */
 #ifndef CREATE_H
-# define CREATE_H
+#define CREATE_H
 
-# include "crun.h"
+#include "crun.h"
 
 int crun_command_create (struct crun_global_arguments *global_args, int argc, char **argv, libcrun_error_t *error);
 
diff -pruN 0.14.1+dfsg-1/src/crun.c 0.15+dfsg-1/src/crun.c
--- 0.14.1+dfsg-1/src/crun.c	2020-07-03 19:38:11.000000000 +0000
+++ 0.15+dfsg-1/src/crun.c	2020-09-23 14:47:06.000000000 +0000
@@ -77,67 +77,67 @@ init_libcrun_context (libcrun_context_t
   if (con->bundle == NULL)
     con->bundle = ".";
 
+  if (con->config_file == NULL)
+    con->config_file = "./config.json";
+
   return 0;
 }
 
 enum
-  {
-    COMMAND_CREATE = 1000,
-    COMMAND_DELETE,
-    COMMAND_EXEC,
-    COMMAND_LIST,
-    COMMAND_KILL,
-    COMMAND_RUN,
-    COMMAND_SPEC,
-    COMMAND_START,
-    COMMAND_STATE,
-    COMMAND_UPDATE,
-    COMMAND_PAUSE,
-    COMMAND_UNPAUSE,
-    COMMAND_PS,
-    COMMAND_CHECKPOINT,
-    COMMAND_RESTORE,
-  };
-
-struct commands_s commands[] =
-  {
-    { COMMAND_CREATE, "create", crun_command_create},
-    { COMMAND_DELETE, "delete", crun_command_delete},
-    { COMMAND_EXEC, "exec", crun_command_exec},
-    { COMMAND_LIST, "list", crun_command_list},
-    { COMMAND_KILL, "kill", crun_command_kill},
-    { COMMAND_PS, "ps", crun_command_ps},
-    { COMMAND_RUN, "run", crun_command_run},
-    { COMMAND_SPEC, "spec", crun_command_spec},
-    { COMMAND_START, "start", crun_command_start},
-    { COMMAND_STATE, "state", crun_command_state},
-    { COMMAND_UPDATE, "update", crun_command_update},
-    { COMMAND_PAUSE, "pause", crun_command_pause},
-    { COMMAND_UNPAUSE, "resume", crun_command_unpause},
-    /* Not calling it yet 'checkpoint' as this might confuse tools
-     * testing for checkpoint support like Podman does.
-     * Once it is ready for Podman, this can be renamed to 'checkpoint' */
-    { COMMAND_CHECKPOINT, "_checkpoint", crun_command_checkpoint},
-    { COMMAND_RESTORE, "_restore", crun_command_restore},
-    { 0, }
-  };
-
-static char doc[] =                                                   \
-  "\nCOMMANDS:\n"                                                     \
-  "\tcreate  - create a container\n"                                  \
-  "\tdelete  - remove definition for a container\n"                   \
-  "\texec    - exec a command in a running container\n"               \
-  "\tlist    - list known containers\n"                               \
-  "\tkill    - send a signal to the container init process\n"         \
-  "\tps      - show the processes in the container\n"                 \
-  "\trun     - run a container\n"                                     \
-  "\tspec    - generate a configuration file\n"                       \
-  "\tstart   - start a container\n"                                   \
-  "\tstate   - output the state of a container\n"                     \
-  "\tpause   - pause all the processes in the container\n"            \
-  "\tresume  - unpause the processes in the container\n"              \
-  "\tupdate  - update container resource constraints\n"               \
-  ;
+{
+  COMMAND_CREATE = 1000,
+  COMMAND_DELETE,
+  COMMAND_EXEC,
+  COMMAND_LIST,
+  COMMAND_KILL,
+  COMMAND_RUN,
+  COMMAND_SPEC,
+  COMMAND_START,
+  COMMAND_STATE,
+  COMMAND_UPDATE,
+  COMMAND_PAUSE,
+  COMMAND_UNPAUSE,
+  COMMAND_PS,
+  COMMAND_CHECKPOINT,
+  COMMAND_RESTORE,
+};
+
+struct commands_s commands[] = { { COMMAND_CREATE, "create", crun_command_create },
+                                 { COMMAND_DELETE, "delete", crun_command_delete },
+                                 { COMMAND_EXEC, "exec", crun_command_exec },
+                                 { COMMAND_LIST, "list", crun_command_list },
+                                 { COMMAND_KILL, "kill", crun_command_kill },
+                                 { COMMAND_PS, "ps", crun_command_ps },
+                                 { COMMAND_RUN, "run", crun_command_run },
+                                 { COMMAND_SPEC, "spec", crun_command_spec },
+                                 { COMMAND_START, "start", crun_command_start },
+                                 { COMMAND_STATE, "state", crun_command_state },
+                                 { COMMAND_UPDATE, "update", crun_command_update },
+                                 { COMMAND_PAUSE, "pause", crun_command_pause },
+                                 { COMMAND_UNPAUSE, "resume", crun_command_unpause },
+                                 /* Not calling it yet 'checkpoint' as this might confuse tools
+                                  * testing for checkpoint support like Podman does.
+                                  * Once it is ready for Podman, this can be renamed to 'checkpoint' */
+                                 { COMMAND_CHECKPOINT, "_checkpoint", crun_command_checkpoint },
+                                 { COMMAND_RESTORE, "_restore", crun_command_restore },
+                                 {
+                                     0,
+                                 } };
+
+static char doc[] = "\nCOMMANDS:\n"
+                    "\tcreate  - create a container\n"
+                    "\tdelete  - remove definition for a container\n"
+                    "\texec    - exec a command in a running container\n"
+                    "\tlist    - list known containers\n"
+                    "\tkill    - send a signal to the container init process\n"
+                    "\tps      - show the processes in the container\n"
+                    "\trun     - run a container\n"
+                    "\tspec    - generate a configuration file\n"
+                    "\tstart   - start a container\n"
+                    "\tstate   - output the state of a container\n"
+                    "\tpause   - pause all the processes in the container\n"
+                    "\tresume  - unpause the processes in the container\n"
+                    "\tupdate  - update container resource constraints\n";
 static char args_doc[] = "COMMAND [OPTION...]";
 
 static struct commands_s *
@@ -151,31 +151,29 @@ get_command (const char *arg)
 }
 
 enum
-  {
-    OPTION_DEBUG = 1000,
-    OPTION_SYSTEMD_CGROUP,
-    OPTION_CGROUP_MANAGER,
-    OPTION_LOG,
-    OPTION_LOG_FORMAT,
-    OPTION_ROOT,
-    OPTION_ROOTLESS
-  };
-
+{
+  OPTION_DEBUG = 1000,
+  OPTION_SYSTEMD_CGROUP,
+  OPTION_CGROUP_MANAGER,
+  OPTION_LOG,
+  OPTION_LOG_FORMAT,
+  OPTION_ROOT,
+  OPTION_ROOTLESS
+};
 
 const char *argp_program_version = PACKAGE_STRING;
 const char *argp_program_bug_address = "https://github.com/containers/crun/issues";
 
-static struct argp_option options[] =
-  {
-   {"debug", OPTION_DEBUG, 0, 0, "produce verbose output", 0},
-   {"cgroup-manager", OPTION_CGROUP_MANAGER, "MANAGER", 0, "cgroup manager", 0},
-   {"systemd-cgroup", OPTION_SYSTEMD_CGROUP, 0, 0, "use systemd cgroups", 0},
-   {"log", OPTION_LOG, "FILE", 0, NULL, 0},
-   {"log-format", OPTION_LOG_FORMAT, "FORMAT", 0, NULL, 0},
-   {"root", OPTION_ROOT, "DIR",  0, NULL, 0},
-   {"rootless", OPTION_ROOT, "VALUE",  0, NULL, 0},
-   { 0, }
-  };
+static struct argp_option options[] = { { "debug", OPTION_DEBUG, 0, 0, "produce verbose output", 0 },
+                                        { "cgroup-manager", OPTION_CGROUP_MANAGER, "MANAGER", 0, "cgroup manager", 0 },
+                                        { "systemd-cgroup", OPTION_SYSTEMD_CGROUP, 0, 0, "use systemd cgroups", 0 },
+                                        { "log", OPTION_LOG, "FILE", 0, NULL, 0 },
+                                        { "log-format", OPTION_LOG_FORMAT, "FORMAT", 0, NULL, 0 },
+                                        { "root", OPTION_ROOT, "DIR", 0, NULL, 0 },
+                                        { "rootless", OPTION_ROOT, "VALUE", 0, NULL, 0 },
+                                        {
+                                            0,
+                                        } };
 
 static void
 print_version (FILE *stream, struct argp_state *state arg_unused)
@@ -303,6 +301,9 @@ main (int argc, char **argv)
   if (command == NULL)
     libcrun_fail_with_error (0, "unknown command %s", argv[first_argument]);
 
+  if (arguments.debug)
+    libcrun_set_verbosity (LIBCRUN_VERBOSITY_WARNING);
+
   ret = command->handler (&arguments, argc - first_argument, argv + first_argument, &err);
   if (ret && err)
     libcrun_fail_with_error (err->status, "%s", err->msg);
diff -pruN 0.14.1+dfsg-1/src/crun.h 0.15+dfsg-1/src/crun.h
--- 0.14.1+dfsg-1/src/crun.h	2020-07-03 19:38:11.000000000 +0000
+++ 0.15+dfsg-1/src/crun.h	2020-09-03 11:43:25.000000000 +0000
@@ -16,9 +16,9 @@
  * along with crun.  If not, see <http://www.gnu.org/licenses/>.
  */
 #ifndef CRUN_H
-# define CRUN_H
+#define CRUN_H
 
-# include "libcrun/container.h"
+#include "libcrun/container.h"
 
 struct crun_global_arguments
 {
@@ -33,6 +33,7 @@ struct crun_global_arguments
 };
 
 char *argp_mandatory_argument (char *arg, struct argp_state *state);
-int init_libcrun_context (libcrun_context_t *con, const char *id, struct crun_global_arguments *glob, libcrun_error_t *err);
+int init_libcrun_context (libcrun_context_t *con, const char *id, struct crun_global_arguments *glob,
+                          libcrun_error_t *err);
 void crun_assert_n_args (int n, int min, int max);
 #endif
diff -pruN 0.14.1+dfsg-1/src/delete.c 0.15+dfsg-1/src/delete.c
--- 0.14.1+dfsg-1/src/delete.c	2020-07-03 19:38:11.000000000 +0000
+++ 0.15+dfsg-1/src/delete.c	2020-09-03 11:43:25.000000000 +0000
@@ -33,13 +33,13 @@
 static char doc[] = "OCI runtime";
 
 enum
-  {
-    OPTION_CONSOLE_SOCKET = 1000,
-    OPTION_PID_FILE,
-    OPTION_NO_SUBREAPER,
-    OPTION_NO_NEW_KEYRING,
-    OPTION_PRESERVE_FDS
-  };
+{
+  OPTION_CONSOLE_SOCKET = 1000,
+  OPTION_PID_FILE,
+  OPTION_NO_SUBREAPER,
+  OPTION_NO_NEW_KEYRING,
+  OPTION_PRESERVE_FDS
+};
 
 struct delete_options_s
 {
@@ -49,12 +49,12 @@ struct delete_options_s
 
 static struct delete_options_s delete_options;
 
-static struct argp_option options[] =
-  {
-   {"force", 'f', 0, 0, "delete the container even if it is still running", 0},
-   {"regex", 'r', 0, 0, "the specified CONTAINER is a regular expression (delete multiple containers)", 0},
-   { 0, }
-  };
+static struct argp_option options[]
+    = { { "force", 'f', 0, 0, "delete the container even if it is still running", 0 },
+        { "regex", 'r', 0, 0, "the specified CONTAINER is a regular expression (delete multiple containers)", 0 },
+        {
+            0,
+        } };
 
 static char args_doc[] = "delete CONTAINER";
 
@@ -88,7 +88,9 @@ crun_command_delete (struct crun_global_
 {
   int first_arg, ret;
 
-  libcrun_context_t crun_context = {0, };
+  libcrun_context_t crun_context = {
+    0,
+  };
 
   argp_parse (&run_argp, argc, argv, ARGP_IN_ORDER, &first_arg, &delete_options);
   crun_assert_n_args (argc - first_arg, 1, 1);
diff -pruN 0.14.1+dfsg-1/src/delete.h 0.15+dfsg-1/src/delete.h
--- 0.14.1+dfsg-1/src/delete.h	2020-07-02 13:46:33.000000000 +0000
+++ 0.15+dfsg-1/src/delete.h	2020-09-03 11:43:25.000000000 +0000
@@ -16,9 +16,9 @@
  * along with crun.  If not, see <http://www.gnu.org/licenses/>.
  */
 #ifndef DELETE_H
-# define DELETE_H
+#define DELETE_H
 
-# include "crun.h"
+#include "crun.h"
 
 int crun_command_delete (struct crun_global_arguments *global_args, int argc, char **argv, libcrun_error_t *error);
 
diff -pruN 0.14.1+dfsg-1/src/exec.c 0.15+dfsg-1/src/exec.c
--- 0.14.1+dfsg-1/src/exec.c	2020-07-03 19:38:11.000000000 +0000
+++ 0.15+dfsg-1/src/exec.c	2020-09-03 11:43:25.000000000 +0000
@@ -48,29 +48,30 @@ struct exec_options_s
 };
 
 enum
-  {
-    OPTION_CONSOLE_SOCKET = 1000,
-    OPTION_PID_FILE,
-    OPTION_CWD,
-    OPTION_PRESERVE_FDS
-  };
+{
+  OPTION_CONSOLE_SOCKET = 1000,
+  OPTION_PID_FILE,
+  OPTION_CWD,
+  OPTION_PRESERVE_FDS
+};
 
 static struct exec_options_s exec_options;
 
-static struct argp_option options[] =
-  {
-   {"console-socket", OPTION_CONSOLE_SOCKET, "SOCKET", 0, "path to a socket that will receive the master end of the tty", 0},
-   {"tty", 't', "TTY", OPTION_ARG_OPTIONAL, "allocate a pseudo-TTY", 0},
-   {"process", 'p', "FILE", 0, "path to the process.json", 0},
-   {"cwd", OPTION_CWD, "CWD", 0, "current working directory", 0},
-   {"detach", 'd', 0, 0, "detach the command in the background", 0},
-   {"user", 'u', "USERSPEC", 0, "specify the user in the form UID[:GID]", 0},
-   {"env", 'e', "ENV", 0, "add an environment variable", 0},
-   {"cap", 'c', "CAP", 0, "add a capability", 0},
-   {"pid-file", OPTION_PID_FILE, "FILE", 0, "where to write the PID of the container", 0},
-   {"preserve-fds", OPTION_PRESERVE_FDS, 0, 0, "pass additional FDs to the container", 0},
-   {0,}
-  };
+static struct argp_option options[]
+    = { { "console-socket", OPTION_CONSOLE_SOCKET, "SOCKET", 0,
+          "path to a socket that will receive the ptmx end of the tty", 0 },
+        { "tty", 't', "TTY", OPTION_ARG_OPTIONAL, "allocate a pseudo-TTY", 0 },
+        { "process", 'p', "FILE", 0, "path to the process.json", 0 },
+        { "cwd", OPTION_CWD, "CWD", 0, "current working directory", 0 },
+        { "detach", 'd', 0, 0, "detach the command in the background", 0 },
+        { "user", 'u', "USERSPEC", 0, "specify the user in the form UID[:GID]", 0 },
+        { "env", 'e', "ENV", 0, "add an environment variable", 0 },
+        { "cap", 'c', "CAP", 0, "add a capability", 0 },
+        { "pid-file", OPTION_PID_FILE, "FILE", 0, "where to write the PID of the container", 0 },
+        { "preserve-fds", OPTION_PRESERVE_FDS, 0, 0, "pass additional FDs to the container", 0 },
+        {
+            0,
+        } };
 
 static char args_doc[] = "exec CONTAINER cmd";
 
@@ -96,7 +97,8 @@ append_cap (const char *arg)
   exec_options.cap_size++;
 }
 
-static char **dup_array (char **arr, size_t len)
+static char **
+dup_array (char **arr, size_t len)
 {
   size_t i;
   char **ret;
@@ -133,7 +135,7 @@ parse_opt (int key, char *arg, struct ar
       break;
 
     case 'p':
-        exec_options.process = arg;
+      exec_options.process = arg;
       break;
 
     case 't':
@@ -201,7 +203,9 @@ int
 crun_command_exec (struct crun_global_arguments *global_args, int argc, char **argv, libcrun_error_t *err)
 {
   int first_arg, ret = 0;
-  libcrun_context_t crun_context = {0, };
+  libcrun_context_t crun_context = {
+    0,
+  };
 
   crun_context.preserve_fds = 0;
 
@@ -240,7 +244,8 @@ crun_command_exec (struct crun_global_ar
       process->user = make_oci_process_user (exec_options.user);
       if (exec_options.cap_size > 0)
         {
-          runtime_spec_schema_config_schema_process_capabilities *capabilities = xmalloc (sizeof (runtime_spec_schema_config_schema_process_capabilities));
+          runtime_spec_schema_config_schema_process_capabilities *capabilities
+              = xmalloc (sizeof (runtime_spec_schema_config_schema_process_capabilities));
 
           capabilities->effective = exec_options.cap;
           capabilities->effective_len = exec_options.cap_size;
diff -pruN 0.14.1+dfsg-1/src/exec.h 0.15+dfsg-1/src/exec.h
--- 0.14.1+dfsg-1/src/exec.h	2020-07-02 13:46:33.000000000 +0000
+++ 0.15+dfsg-1/src/exec.h	2020-09-03 11:43:25.000000000 +0000
@@ -16,9 +16,9 @@
  * along with crun.  If not, see <http://www.gnu.org/licenses/>.
  */
 #ifndef EXEC_H
-# define EXEC_H
+#define EXEC_H
 
-# include "crun.h"
+#include "crun.h"
 
 int crun_command_exec (struct crun_global_arguments *global_args, int argc, char **argv, libcrun_error_t *error);
 
diff -pruN 0.14.1+dfsg-1/src/kill.c 0.15+dfsg-1/src/kill.c
--- 0.14.1+dfsg-1/src/kill.c	2020-07-03 19:38:11.000000000 +0000
+++ 0.15+dfsg-1/src/kill.c	2020-09-03 11:43:25.000000000 +0000
@@ -34,13 +34,13 @@
 static char doc[] = "OCI runtime";
 
 enum
-  {
-    OPTION_CONSOLE_SOCKET = 1000,
-    OPTION_PID_FILE,
-    OPTION_NO_SUBREAPER,
-    OPTION_NO_NEW_KEYRING,
-    OPTION_PRESERVE_FDS
-  };
+{
+  OPTION_CONSOLE_SOCKET = 1000,
+  OPTION_PID_FILE,
+  OPTION_NO_SUBREAPER,
+  OPTION_NO_NEW_KEYRING,
+  OPTION_PRESERVE_FDS
+};
 
 struct kill_options_s
 {
@@ -50,12 +50,12 @@ struct kill_options_s
 
 static struct kill_options_s kill_options;
 
-static struct argp_option options[] =
-  {
-   {"all", 'a', 0, 0, "kill all the processes", 0 },
-   {"regex", 'r', 0, 0, "the specified CONTAINER is a regular expression (kill multiple containers)", 0 },
-   { 0, }
-  };
+static struct argp_option options[]
+    = { { "all", 'a', 0, 0, "kill all the processes", 0 },
+        { "regex", 'r', 0, 0, "the specified CONTAINER is a regular expression (kill multiple containers)", 0 },
+        {
+            0,
+        } };
 
 static char args_doc[] = "kill CONTAINER [SIGNAL]";
 
@@ -89,7 +89,9 @@ crun_command_kill (struct crun_global_ar
 {
   int first_arg, signal, ret;
 
-  libcrun_context_t crun_context = {0, };
+  libcrun_context_t crun_context = {
+    0,
+  };
 
   argp_parse (&run_argp, argc, argv, ARGP_IN_ORDER, &first_arg, &kill_options);
   crun_assert_n_args (argc - first_arg, 1, 2);
@@ -127,7 +129,6 @@ crun_command_kill (struct crun_global_ar
               libcrun_error_write_warning_and_release (stderr, &err);
           }
 
-
       libcrun_free_containers_list (list);
       regfree (&re);
       return 0;
diff -pruN 0.14.1+dfsg-1/src/kill.h 0.15+dfsg-1/src/kill.h
--- 0.14.1+dfsg-1/src/kill.h	2020-07-02 13:46:33.000000000 +0000
+++ 0.15+dfsg-1/src/kill.h	2020-09-03 11:43:25.000000000 +0000
@@ -16,9 +16,9 @@
  * along with crun.  If not, see <http://www.gnu.org/licenses/>.
  */
 #ifndef KILL_H
-# define KILL_H
+#define KILL_H
 
-# include "crun.h"
+#include "crun.h"
 
 int crun_command_kill (struct crun_global_arguments *global_args, int argc, char **argv, libcrun_error_t *error);
 
diff -pruN 0.14.1+dfsg-1/src/libcrun/cgroup.c 0.15+dfsg-1/src/libcrun/cgroup.c
--- 0.14.1+dfsg-1/src/libcrun/cgroup.c	2020-07-03 19:38:11.000000000 +0000
+++ 0.15+dfsg-1/src/libcrun/cgroup.c	2020-09-22 18:17:19.000000000 +0000
@@ -30,7 +30,7 @@
 #include <time.h>
 
 #ifdef HAVE_SYSTEMD
-# include <systemd/sd-bus.h>
+#  include <systemd/sd-bus.h>
 #endif
 
 #include <sys/stat.h>
@@ -38,10 +38,9 @@
 #include <fcntl.h>
 #include <libgen.h>
 
-static const cgroups_subsystem_t cgroups_subsystems[] = {"cpuset", "cpu", "devices", "pids", "memory",
-                                                         "net_cls,net_prio", "freezer", "blkio",
-                                                         "hugetlb", "cpu,cpuacct", "perf_event",
-                                                         "unified", NULL};
+static const cgroups_subsystem_t cgroups_subsystems[]
+    = { "cpuset",  "cpu",         "devices",    "pids",    "memory", "net_cls,net_prio", "freezer", "blkio",
+        "hugetlb", "cpu,cpuacct", "perf_event", "unified", NULL };
 
 const cgroups_subsystem_t *
 libcrun_get_cgroups_subsystems (libcrun_error_t *err arg_unused)
@@ -55,22 +54,20 @@ struct symlink_s
   const char *target;
 };
 
-static struct symlink_s cgroup_symlinks[] = {
-  { "cpu", "cpu,cpuacct" },
-  { "cpuacct", "cpu,cpuacct" },
-  { "net_cls", "net_cls,net_prio" },
-  { "net_prio", "net_cls,net_prio" },
-  { NULL, NULL }
-};
+static struct symlink_s cgroup_symlinks[] = { { "cpu", "cpu,cpuacct" },
+                                              { "cpuacct", "cpu,cpuacct" },
+                                              { "net_cls", "net_cls,net_prio" },
+                                              { "net_prio", "net_cls,net_prio" },
+                                              { NULL, NULL } };
 
 #define SYSTEMD_PROPERTY_PREFIX "org.systemd.property."
 
 #ifndef CGROUP2_SUPER_MAGIC
-# define CGROUP2_SUPER_MAGIC 0x63677270
+#  define CGROUP2_SUPER_MAGIC 0x63677270
 #endif
 
 #ifndef TMPFS_MAGIC
-# define TMPFS_MAGIC 0x01021994
+#  define TMPFS_MAGIC 0x01021994
 #endif
 
 static int
@@ -142,54 +139,140 @@ is_rwm (const char *str, libcrun_error_t
   return r && w && m ? 1 : 0;
 }
 
+enum
+{
+  CGROUP_MEMORY = 1 << 0,
+  CGROUP_CPU = 1 << 1,
+  CGROUP_HUGETLB = 1 << 2,
+  CGROUP_CPUSET = 1 << 3,
+  CGROUP_PIDS = 1 << 4,
+  CGROUP_IO = 1 << 5,
+};
+
+static int
+read_available_controllers (const char *path, libcrun_error_t *err)
+{
+  cleanup_close int fd;
+  char *saveptr = NULL;
+  const char *token;
+  char *controllers;
+  int available = 0;
+  char buf[256];
+  ssize_t ret;
+
+  xasprintf (&controllers, "%s/cgroup.controllers", path);
+
+  fd = TEMP_FAILURE_RETRY (open (controllers, O_RDONLY | O_CLOEXEC));
+  if (UNLIKELY (fd < 0))
+    return crun_make_error (err, errno, "error opening file `%s`", path);
+
+  ret = TEMP_FAILURE_RETRY (read (fd, buf, sizeof (buf) - 1));
+  if (UNLIKELY (ret < 0))
+    return crun_make_error (err, errno, "error reading from file `%s`", path);
+  buf[ret] = '\0';
+
+  for (token = strtok_r (buf, " \n", &saveptr); token; token = strtok_r (NULL, " \n", &saveptr))
+    {
+      if (strcmp (token, "memory") == 0)
+        available |= CGROUP_MEMORY;
+      else if (strcmp (token, "cpu") == 0)
+        available |= CGROUP_CPU;
+      else if (strcmp (token, "cpuset") == 0)
+        available |= CGROUP_CPUSET;
+      else if (strcmp (token, "hugetlb") == 0)
+        available |= CGROUP_HUGETLB;
+      else if (strcmp (token, "pids") == 0)
+        available |= CGROUP_PIDS;
+      else if (strcmp (token, "io") == 0)
+        available |= CGROUP_IO;
+    }
+  return available;
+}
+
 static int
-enable_controllers (runtime_spec_schema_config_linux_resources *resources, const char *path, libcrun_error_t *err)
+write_controller_file (const char *path, int controllers_to_enable, libcrun_error_t *err)
 {
+  cleanup_free char *subtree_control = NULL;
   cleanup_free char *controllers = NULL;
-  cleanup_free char *tmp_path = NULL;
   size_t controllers_len = 0;
-  bool has_hugetlb = false;
-  bool has_memory = false;
-  bool has_cpuset = false;
-  bool has_pids = false;
-  bool has_cpu = false;
-  bool has_io = false;
-  char *it;
   int ret;
 
-  if (resources)
+  controllers_len = xasprintf (
+      &controllers, "%s %s %s %s %s %s", (controllers_to_enable & CGROUP_CPU) ? "+cpu" : "",
+      (controllers_to_enable & CGROUP_IO) ? "+io" : "", (controllers_to_enable & CGROUP_MEMORY) ? "+memory" : "",
+      (controllers_to_enable & CGROUP_PIDS) ? "+pids" : "", (controllers_to_enable & CGROUP_CPUSET) ? "+cpuset" : "",
+      (controllers_to_enable & CGROUP_HUGETLB) ? "+hugetlb" : "");
+
+  xasprintf (&subtree_control, "%s/cgroup.subtree_control", path);
+  ret = write_file (subtree_control, controllers, controllers_len, err);
+  if (UNLIKELY (ret < 0))
     {
-      has_cpu = resources->cpu && (resources->cpu->shares
-                                   || resources->cpu->period
-                                   || resources->cpu->quota
-                                   || resources->cpu->realtime_period
-                                   || resources->cpu->realtime_runtime);
-      has_cpuset = resources->cpu && (resources->cpu->cpus || resources->cpu->mems);
-      has_io = resources->block_io;
-      has_memory = resources->memory;
-      has_pids = resources->pids;
-      has_hugetlb = resources->hugepage_limits_len;
-    }
-
-  controllers_len = xasprintf (&controllers, "%s %s %s %s %s %s",
-                               has_cpu ? "+cpu" : "",
-                               has_io ? "+io" : "",
-                               has_memory ? "+memory" : "",
-                               has_pids ? "+pids" : "",
-                               has_cpuset ? "+cpuset" : "",
-                               has_hugetlb ? "+hugetlb" : "");
+      char *saveptr = NULL;
+      const char *token;
+      int e;
+
+      e = crun_error_get_errno (err);
+      if (e != EPERM && e != EACCES && e != EBUSY && e != ENOENT)
+        return ret;
+
+      /* ENOENT can mean both that the file doesn't exist or the controller is not present.  */
+      if (e == ENOENT)
+        {
+          libcrun_error_t tmp_err = NULL;
+          int exists;
+
+          exists = crun_path_exists (subtree_control, &tmp_err);
+          if (UNLIKELY (exists < 0))
+            {
+              crun_error_release (&tmp_err);
+              return ret;
+            }
+          /* If the file doesn't exist, then return the original ENOENT.  */
+          if (exists == 0)
+            return ret;
+        }
+
+      crun_error_release (err);
+
+      /* Fallback to write each one individually.  */
+      for (token = strtok_r (controllers, " ", &saveptr); token; token = strtok_r (NULL, " ", &saveptr))
+        {
+          ret = write_file (subtree_control, token, strlen (token), err);
+          if (ret < 0)
+            crun_error_release (err);
+        }
+
+      /* Refresh what controllers are available.  */
+      return read_available_controllers (path, err);
+    }
+
+  /* All controllers were enabled successfully.  */
+  return controllers_to_enable;
+}
+
+static int
+enable_controllers (const char *path, libcrun_error_t *err)
+{
+  cleanup_free char *tmp_path = NULL;
+  char *it;
+  int ret, controllers_to_enable;
 
   xasprintf (&tmp_path, "%s/", path);
 
-  /* Activate the needed controllers in the root cgroup, but ignore errors here.  */
-  ret = write_file ("/sys/fs/cgroup/cgroup.subtree_control", controllers, controllers_len, err);
+  ret = read_available_controllers ("/sys/fs/cgroup", err);
   if (UNLIKELY (ret < 0))
-    crun_error_release (err);
+    return ret;
+
+  controllers_to_enable = ret;
+
+  /* Enable all possible controllers in the root cgroup.  */
+  ret = write_controller_file ("/sys/fs/cgroup", controllers_to_enable, err);
+  if (UNLIKELY (ret < 0))
+    return ret;
 
   for (it = strchr (tmp_path + 1, '/'); it;)
     {
       cleanup_free char *cgroup_path = NULL;
-      cleanup_free char *subtree_control = NULL;
       char *next_slash = strchr (it + 1, '/');
 
       *it = '\0';
@@ -201,20 +284,11 @@ enable_controllers (runtime_spec_schema_
 
       if (next_slash)
         {
-          xasprintf (&subtree_control, "%s/cgroup.subtree_control", cgroup_path);
-          ret = write_file (subtree_control, controllers, controllers_len, err);
+          ret = write_controller_file (cgroup_path, controllers_to_enable, err);
           if (UNLIKELY (ret < 0))
-            {
-              int e = crun_error_get_errno (err);
-              if (e == EPERM || e == EACCES || e == EBUSY)
-                {
-                  crun_error_release (err);
-                  goto next;
-                }
-              return ret;
-            }
+            return ret;
         }
-    next:
+
       *it = '/';
       it = next_slash;
     }
@@ -267,7 +341,8 @@ initialize_cpuset_subsystem_rec (char *p
       size_t parent_path_len;
       int ret;
 
-      for (parent_path_len = path_len -1; parent_path_len > 1 && path[parent_path_len] != '/'; parent_path_len--);
+      for (parent_path_len = path_len - 1; parent_path_len > 1 && path[parent_path_len] != '/'; parent_path_len--)
+        ;
       if (parent_path_len == 1)
         return 0;
 
@@ -312,7 +387,8 @@ initialize_cpuset_subsystem (const char
 static int
 initialize_memory_subsystem (const char *path, libcrun_error_t *err)
 {
-  const char *const files[] = {"memory.limit_in_bytes", "memory.kmem.limit_in_bytes", "memory.memsw.limit_in_bytes", NULL};
+  const char *const files[]
+      = { "memory.limit_in_bytes", "memory.kmem.limit_in_bytes", "memory.memsw.limit_in_bytes", NULL };
   cleanup_close int dirfd = -1;
   int i;
 
@@ -349,7 +425,8 @@ move_process_to_cgroup (pid_t pid, const
 }
 
 static int
-enter_cgroup_subsystem (pid_t pid, const char *subsystem, const char *path, bool create_if_missing, libcrun_error_t *err)
+enter_cgroup_subsystem (pid_t pid, const char *subsystem, const char *path, bool create_if_missing,
+                        libcrun_error_t *err)
 {
   cleanup_free char *cgroup_path = NULL;
   int ret;
@@ -363,9 +440,9 @@ enter_cgroup_subsystem (pid_t pid, const
           if (errno != EROFS)
             return crun_make_error (err, errno, "creating cgroup directory `%s`", cgroup_path);
 
-         crun_error_release (err);
-         return 0;
-       }
+          crun_error_release (err);
+          return 0;
+        }
 
       if (strcmp (subsystem, "cpuset") == 0)
         {
@@ -410,7 +487,7 @@ get_file_owner (const char *path, uid_t
 #ifdef HAVE_STATX
   struct statx stx;
 
-  ret = statx (AT_FDCWD, path, AT_STATX_DONT_SYNC, STATX_UID|STATX_GID, &stx);
+  ret = statx (AT_FDCWD, path, AT_STATX_DONT_SYNC, STATX_UID | STATX_GID, &stx);
   if (UNLIKELY (ret < 0))
     {
       if (errno == ENOSYS || errno == EINVAL)
@@ -422,7 +499,7 @@ get_file_owner (const char *path, uid_t
   *gid = stx.stx_gid;
   return ret;
 
- fallback:
+fallback:
 #endif
   ret = stat (path, &st);
   if (UNLIKELY (ret < 0))
@@ -639,7 +716,8 @@ enter_cgroup_v2 (pid_t pid, pid_t init_p
 }
 
 static int
-enter_cgroup (int cgroup_mode, pid_t pid, pid_t init_pid, const char *path, bool create_if_missing, libcrun_error_t *err)
+enter_cgroup (int cgroup_mode, pid_t pid, pid_t init_pid, const char *path, bool create_if_missing,
+              libcrun_error_t *err)
 {
   if (cgroup_mode == CGROUP_MODE_UNIFIED)
     return enter_cgroup_v2 (pid, init_pid, path, create_if_missing, err);
@@ -682,8 +760,8 @@ libcrun_move_process_to_cgroup (pid_t pi
 
 #ifdef HAVE_SYSTEMD
 
-static
-void get_systemd_scope_and_slice (const char *id, const char *cgroup_path, char **scope, char **slice)
+static void
+get_systemd_scope_and_slice (const char *id, const char *cgroup_path, char **scope, char **slice)
 {
   char *n;
 
@@ -712,10 +790,9 @@ void get_systemd_scope_and_slice (const
     }
 }
 
-static
-int systemd_finalize (struct libcrun_cgroup_args *args, const char *suffix, libcrun_error_t *err)
+static int
+systemd_finalize (struct libcrun_cgroup_args *args, const char *suffix, libcrun_error_t *err)
 {
-  runtime_spec_schema_config_linux_resources *resources = args->resources;
   cleanup_free char *content = NULL;
   int cgroup_mode = args->cgroup_mode;
   char **path = args->path;
@@ -790,7 +867,7 @@ int systemd_finalize (struct libcrun_cgr
             return ret;
         }
 
-      ret = enable_controllers (resources, *path, err);
+      ret = enable_controllers (*path, err);
       if (UNLIKELY (ret < 0))
         return ret;
     }
@@ -805,9 +882,14 @@ int systemd_finalize (struct libcrun_cgr
       subpath = strchr (subsystem, ':') + 1;
       *(subpath - 1) = '\0';
 
+      /* on cgroup v2, ignore any subsystem except unified,
+         since other subsystems are not supported anyway.  */
+      if (cgroup_mode == CGROUP_MODE_UNIFIED && subsystem[0] != '\0')
+        continue;
+
       if (strcmp (subpath, *path))
         {
-          ret = enter_cgroup_subsystem (pid, subsystem, *path, 1, err);
+          ret = enter_cgroup_subsystem (pid, subsystem, *path, true, err);
           if (UNLIKELY (ret < 0))
             {
               /* If it is a named hierarchy, skip the error.  */
@@ -855,21 +937,12 @@ systemd_job_removed (sd_bus_message *m,
 }
 
 static int
-systemd_check_job_status_setup (sd_bus *bus,
-                                struct systemd_job_removed_s *data,
-                                libcrun_error_t *err)
+systemd_check_job_status_setup (sd_bus *bus, struct systemd_job_removed_s *data, libcrun_error_t *err)
 {
   int ret;
 
-  ret = sd_bus_match_signal_async (bus,
-                                   NULL,
-                                   "org.freedesktop.systemd1",
-                                   "/org/freedesktop/systemd1",
-                                   "org.freedesktop.systemd1.Manager",
-                                   "JobRemoved",
-                                   systemd_job_removed,
-                                   NULL,
-                                   data);
+  ret = sd_bus_match_signal_async (bus, NULL, "org.freedesktop.systemd1", "/org/freedesktop/systemd1",
+                                   "org.freedesktop.systemd1.Manager", "JobRemoved", systemd_job_removed, NULL, data);
   if (UNLIKELY (ret < 0))
     return crun_make_error (err, -ret, "sd-bus match signal");
 
@@ -877,17 +950,14 @@ systemd_check_job_status_setup (sd_bus *
 }
 
 static int
-systemd_check_job_status (sd_bus *bus,
-                          struct systemd_job_removed_s *data,
-                          const char *path,
-                          const char *op,
+systemd_check_job_status (sd_bus *bus, struct systemd_job_removed_s *data, const char *path, const char *op,
                           libcrun_error_t *err)
 {
   int sd_err;
 
   data->path = path;
   data->op = op;
-  while (!data->terminated)
+  while (! data->terminated)
     {
       sd_err = sd_bus_process (bus, NULL);
       if (UNLIKELY (sd_err < 0))
@@ -912,10 +982,7 @@ systemd_check_job_status (sd_bus *bus,
 
 /* Parse a gvariant string.  Support only a subset of types, just enough for systemd .  */
 static int
-append_systemd_annotation (sd_bus_message *m,
-                           const char *name,
-                           size_t name_len,
-                           const char *value,
+append_systemd_annotation (sd_bus_message *m, const char *name, size_t name_len, const char *value,
                            libcrun_error_t *err)
 {
   cleanup_free char *tmp_name = NULL;
@@ -929,10 +996,7 @@ append_systemd_annotation (sd_bus_messag
   it = value;
 
   /* If the name has the form NameSec, convert it to NameUSec.  */
-  if (name_len > 4
-      && name[name_len - 4] != 'U'
-      && name[name_len - 3] == 'S'
-      && name[name_len - 2] == 'e'
+  if (name_len > 4 && name[name_len - 4] != 'U' && name[name_len - 3] == 'S' && name[name_len - 2] == 'e'
       && name[name_len - 1] == 'c')
     {
       factor = 1000000;
@@ -944,7 +1008,6 @@ append_systemd_annotation (sd_bus_messag
       name = tmp_name;
     }
 
-
   if ((strcmp (it, "true") == 0) || (strcmp (it, "false") == 0))
     {
       bool b = *it == 't';
@@ -983,7 +1046,7 @@ append_systemd_annotation (sd_bus_messag
       if (UNLIKELY (errno != 0 || *endptr))
         return crun_make_error (err, errno, "invalid value for `%s`", name);
 
-      sd_err = sd_bus_message_append (m, "(sv)", name, "t", (uint64_t)(v * factor));
+      sd_err = sd_bus_message_append (m, "(sv)", name, "t", (uint64_t) (v * factor));
       if (UNLIKELY (sd_err < 0))
         return crun_make_error (err, -sd_err, "sd-bus message append `%s`", name);
 
@@ -999,7 +1062,7 @@ append_systemd_annotation (sd_bus_messag
       if (UNLIKELY (errno != 0 || *endptr))
         return crun_make_error (err, errno, "invalid value for `%s`", name);
 
-      sd_err = sd_bus_message_append (m, "(sv)", name, "x", (int64_t)(v * factor));
+      sd_err = sd_bus_message_append (m, "(sv)", name, "x", (int64_t) (v * factor));
       if (UNLIKELY (sd_err < 0))
         return crun_make_error (err, -sd_err, "sd-bus message append `%s`", name);
 
@@ -1015,7 +1078,7 @@ append_systemd_annotation (sd_bus_messag
       if (UNLIKELY (errno != 0 || *endptr))
         return crun_make_error (err, errno, "invalid value for `%s`", name);
 
-      sd_err = sd_bus_message_append (m, "(sv)", name, "u", (uint32_t)(v * factor));
+      sd_err = sd_bus_message_append (m, "(sv)", name, "u", (uint32_t) (v * factor));
       if (UNLIKELY (sd_err < 0))
         return crun_make_error (err, -sd_err, "sd-bus message append `%s`", name);
 
@@ -1036,7 +1099,7 @@ append_systemd_annotation (sd_bus_messag
       if (UNLIKELY (errno != 0 || *endptr))
         return crun_make_error (err, errno, "invalid value for `%s`", name);
 
-      sd_err = sd_bus_message_append (m, "(sv)", name, "i", (int32_t)(v * factor));
+      sd_err = sd_bus_message_append (m, "(sv)", name, "i", (int32_t) (v * factor));
       if (UNLIKELY (sd_err < 0))
         return crun_make_error (err, -sd_err, "sd-bus message append `%s`", name);
 
@@ -1062,12 +1125,8 @@ open_sd_bus_connection (sd_bus **bus, li
 }
 
 static int
-enter_systemd_cgroup_scope (runtime_spec_schema_config_linux_resources *resources,
-                            json_map_string_string *annotations,
-                            const char *scope,
-                            const char *slice,
-                            pid_t pid,
-                            libcrun_error_t *err)
+enter_systemd_cgroup_scope (runtime_spec_schema_config_linux_resources *resources, json_map_string_string *annotations,
+                            const char *scope, const char *slice, pid_t pid, libcrun_error_t *err)
 {
   sd_bus *bus = NULL;
   sd_bus_message *m = NULL;
@@ -1082,7 +1141,7 @@ enter_systemd_cgroup_scope (runtime_spec
   i = 0;
   boolean_opts[i++] = "Delegate";
   if (resources)
-   {
+    {
       if (resources->cpu)
         boolean_opts[i++] = "CPUAccounting";
       if (resources->memory)
@@ -1100,12 +1159,10 @@ enter_systemd_cgroup_scope (runtime_spec
 
   ret = systemd_check_job_status_setup (bus, &job_data, err);
   if (UNLIKELY (ret < 0))
-      goto exit;
+    goto exit;
 
-  sd_err = sd_bus_message_new_method_call (bus, &m, "org.freedesktop.systemd1",
-                                           "/org/freedesktop/systemd1",
-                                           "org.freedesktop.systemd1.Manager",
-                                           "StartTransientUnit");
+  sd_err = sd_bus_message_new_method_call (bus, &m, "org.freedesktop.systemd1", "/org/freedesktop/systemd1",
+                                           "org.freedesktop.systemd1.Manager", "StartTransientUnit");
   if (UNLIKELY (sd_err < 0))
     {
       ret = crun_make_error (err, -sd_err, "set up dbus message");
@@ -1151,13 +1208,11 @@ enter_systemd_cgroup_scope (runtime_spec
           len = strlen (annotations->keys[i]);
           if (len < prefix_len + 3)
             {
-              ret = crun_make_error (err, EINVAL, "invalid systemd property name `%s`",
-                                     annotations->keys[i]);
+              ret = crun_make_error (err, EINVAL, "invalid systemd property name `%s`", annotations->keys[i]);
               goto exit;
             }
 
-          ret = append_systemd_annotation (m, annotations->keys[i] + prefix_len,
-                                           len - prefix_len,
+          ret = append_systemd_annotation (m, annotations->keys[i] + prefix_len, len - prefix_len,
                                            annotations->values[i], err);
           if (UNLIKELY (ret < 0))
             goto exit;
@@ -1229,8 +1284,8 @@ exit:
   return ret;
 }
 
-static
-int destroy_systemd_cgroup_scope (const char *scope, libcrun_error_t *err)
+static int
+destroy_systemd_cgroup_scope (const char *scope, libcrun_error_t *err)
 {
   sd_bus *bus = NULL;
   sd_bus_message *m = NULL;
@@ -1248,12 +1303,9 @@ int destroy_systemd_cgroup_scope (const
   if (UNLIKELY (ret < 0))
     goto exit;
 
-  ret = sd_bus_message_new_method_call (bus, &m,
-                                        "org.freedesktop.systemd1",
-                                        "/org/freedesktop/systemd1",
-                                        "org.freedesktop.systemd1.Manager",
-                                        "StopUnit");
-  if (UNLIKELY (ret  < 0))
+  ret = sd_bus_message_new_method_call (bus, &m, "org.freedesktop.systemd1", "/org/freedesktop/systemd1",
+                                        "org.freedesktop.systemd1.Manager", "StopUnit");
+  if (UNLIKELY (ret < 0))
     {
       ret = crun_make_error (err, -ret, "set up dbus message");
       goto exit;
@@ -1305,7 +1357,6 @@ libcrun_cgroup_enter_no_manager (struct
 static int
 libcrun_cgroup_enter_cgroupfs (struct libcrun_cgroup_args *args, libcrun_error_t *err)
 {
-  runtime_spec_schema_config_linux_resources *resources = args->resources;
   int cgroup_mode = args->cgroup_mode;
   char **path = args->path;
   const char *cgroup_path = args->cgroup_path;
@@ -1313,7 +1364,7 @@ libcrun_cgroup_enter_cgroupfs (struct li
   const char *id = args->id;
 
   if (cgroup_path == NULL)
-      xasprintf (path, "/%s", id);
+    xasprintf (path, "/%s", id);
   else
     {
       if (cgroup_path[0] == '/')
@@ -1326,7 +1377,7 @@ libcrun_cgroup_enter_cgroupfs (struct li
     {
       int ret;
 
-      ret = enable_controllers (resources, *path, err);
+      ret = enable_controllers (*path, err);
       if (UNLIKELY (ret < 0))
         return ret;
     }
@@ -1462,7 +1513,8 @@ libcrun_cgroup_is_container_paused (cons
 }
 
 static int
-libcrun_cgroup_pause_unpause_with_mode (const char *cgroup_path, int cgroup_mode, const bool pause, libcrun_error_t *err)
+libcrun_cgroup_pause_unpause_with_mode (const char *cgroup_path, int cgroup_mode, const bool pause,
+                                        libcrun_error_t *err)
 {
   cleanup_free char *path = NULL;
   const char *state = "";
@@ -1497,8 +1549,8 @@ libcrun_cgroup_pause_unpause (const char
   return libcrun_cgroup_pause_unpause_with_mode (cgroup_path, cgroup_mode, pause, err);
 }
 
-static
-int read_pids_cgroup (int dfd, bool recurse, pid_t **pids, size_t *n_pids, size_t *allocated, libcrun_error_t *err)
+static int
+read_pids_cgroup (int dfd, bool recurse, pid_t **pids, size_t *n_pids, size_t *allocated, libcrun_error_t *err)
 {
   cleanup_close int clean_dfd = dfd;
   cleanup_close int tasksfd = -1;
@@ -1509,7 +1561,7 @@ int read_pids_cgroup (int dfd, bool recu
   char *it;
   int ret;
 
-  tasksfd = openat (dfd, "cgroup.procs", O_RDONLY|O_CLOEXEC);
+  tasksfd = openat (dfd, "cgroup.procs", O_RDONLY | O_CLOEXEC);
   if (tasksfd < 0)
     return crun_make_error (err, errno, "open cgroup.procs");
 
@@ -1542,7 +1594,7 @@ int read_pids_cgroup (int dfd, bool recu
 
       dir = fdopendir (dfd);
       if (UNLIKELY (dir == NULL))
-          return crun_make_error (err, errno, "open cgroup sub-directory");
+        return crun_make_error (err, errno, "open cgroup sub-directory");
       /* Now dir owns the dfd descriptor.  */
       clean_dfd = -1;
 
@@ -1550,15 +1602,14 @@ int read_pids_cgroup (int dfd, bool recu
         {
           int nfd;
 
-          if (strcmp (de->d_name, ".") == 0 ||
-              strcmp (de->d_name, "..") == 0)
+          if (strcmp (de->d_name, ".") == 0 || strcmp (de->d_name, "..") == 0)
             continue;
 
           if (de->d_type != DT_DIR)
             continue;
 
-          nfd = openat (dirfd (dir), de->d_name, O_DIRECTORY|O_CLOEXEC);
-          if (UNLIKELY (dir == NULL))
+          nfd = openat (dirfd (dir), de->d_name, O_DIRECTORY | O_CLOEXEC);
+          if (UNLIKELY (nfd < 0))
             return crun_make_error (err, errno, "open cgroup directory %s", de->d_name);
           ret = read_pids_cgroup (nfd, recurse, pids, n_pids, allocated, err);
           if (UNLIKELY (ret < 0))
@@ -1705,7 +1756,8 @@ libcrun_cgroup_killall (const char *path
   return libcrun_cgroup_killall_signal (path, SIGKILL, err);
 }
 
-int libcrun_cgroup_destroy (const char *id, const char *path, const char *scope, int manager, libcrun_error_t *err)
+int
+libcrun_cgroup_destroy (const char *id, const char *path, const char *scope, int manager, libcrun_error_t *err)
 {
   int ret;
   size_t i;
@@ -1781,11 +1833,10 @@ int libcrun_cgroup_destroy (const char *
 
       if (repeat)
         {
-          struct timespec req =
-            {
-             .tv_sec = 0,
-             .tv_nsec = 100000,
-            };
+          struct timespec req = {
+            .tv_sec = 0,
+            .tv_nsec = 100000,
+          };
 
           nanosleep (&req, NULL);
 
@@ -1803,7 +1854,8 @@ int libcrun_cgroup_destroy (const char *
 typedef runtime_spec_schema_defs_linux_block_io_device_throttle throttling_s;
 
 static int
-write_blkio_v1_resources_throttling (int dirfd, const char *name, throttling_s **throttling, size_t throttling_len, libcrun_error_t *err)
+write_blkio_v1_resources_throttling (int dirfd, const char *name, throttling_s **throttling, size_t throttling_len,
+                                     libcrun_error_t *err)
 {
   char fmt_buf[128];
   size_t i;
@@ -1820,9 +1872,7 @@ write_blkio_v1_resources_throttling (int
     {
       int ret;
       size_t len;
-      len = sprintf (fmt_buf, "%" PRIu64 ":%" PRIu64 " %" PRIu64 "\n",
-                     throttling[i]->major,
-                     throttling[i]->minor,
+      len = sprintf (fmt_buf, "%" PRIu64 ":%" PRIu64 " %" PRIu64 "\n", throttling[i]->major, throttling[i]->minor,
                      throttling[i]->rate);
 
       ret = TEMP_FAILURE_RETRY (write (fd, fmt_buf, len));
@@ -1833,7 +1883,8 @@ write_blkio_v1_resources_throttling (int
 }
 
 static int
-write_blkio_v2_resources_throttling (int fd, const char *name, throttling_s **throttling, size_t throttling_len, libcrun_error_t *err)
+write_blkio_v2_resources_throttling (int fd, const char *name, throttling_s **throttling, size_t throttling_len,
+                                     libcrun_error_t *err)
 {
   char fmt_buf[128];
   size_t i;
@@ -1845,10 +1896,7 @@ write_blkio_v2_resources_throttling (int
     {
       int ret;
       size_t len;
-      len = sprintf (fmt_buf, "%" PRIu64 ":%" PRIu64 " %s=%lu\n",
-                     throttling[i]->major,
-                     throttling[i]->minor,
-                     name,
+      len = sprintf (fmt_buf, "%" PRIu64 ":%" PRIu64 " %s=%lu\n", throttling[i]->major, throttling[i]->minor, name,
                      throttling[i]->rate);
 
       ret = TEMP_FAILURE_RETRY (write (fd, fmt_buf, len));
@@ -1859,13 +1907,14 @@ write_blkio_v2_resources_throttling (int
 }
 
 static int
-write_blkio_resources (int dirfd, bool cgroup2, runtime_spec_schema_config_linux_resources_block_io *blkio, libcrun_error_t *err)
+write_blkio_resources (int dirfd, bool cgroup2, runtime_spec_schema_config_linux_resources_block_io *blkio,
+                       libcrun_error_t *err)
 {
   char fmt_buf[128];
   size_t len;
   int ret;
-      /* convert linearly from 10-1000 to 1-10000.  */
-#define CONVERT_WEIGHT_TO_CGROUPS_V2(x) (1 + ((x) - 10) * 9999 / 990)
+  /* convert linearly from 10-1000 to 1-10000.  */
+#define CONVERT_WEIGHT_TO_CGROUPS_V2(x) (1 + ((x) -10) * 9999 / 990)
 
   if (blkio->weight)
     {
@@ -1902,10 +1951,8 @@ write_blkio_resources (int dirfd, bool c
             {
               uint32_t w = CONVERT_WEIGHT_TO_CGROUPS_V2 (blkio->weight_device[i]->weight);
 
-              len = sprintf (fmt_buf, "%" PRIu64 ":%" PRIu64 " %i\n",
-                             blkio->weight_device[i]->major,
-                             blkio->weight_device[i]->minor,
-                             w);
+              len = sprintf (fmt_buf, "%" PRIu64 ":%" PRIu64 " %i\n", blkio->weight_device[i]->major,
+                             blkio->weight_device[i]->minor, w);
               ret = TEMP_FAILURE_RETRY (write (wfd, fmt_buf, len));
               if (UNLIKELY (ret < 0))
                 return crun_make_error (err, errno, "write io.weight");
@@ -1929,17 +1976,13 @@ write_blkio_resources (int dirfd, bool c
 
           for (i = 0; i < blkio->weight_device_len; i++)
             {
-              len = sprintf (fmt_buf, "%lu:%lu %i\n",
-                             blkio->weight_device[i]->major,
-                             blkio->weight_device[i]->minor,
+              len = sprintf (fmt_buf, "%lu:%lu %i\n", blkio->weight_device[i]->major, blkio->weight_device[i]->minor,
                              blkio->weight_device[i]->weight);
               ret = TEMP_FAILURE_RETRY (write (w_device_fd, fmt_buf, len));
               if (UNLIKELY (ret < 0))
                 return crun_make_error (err, errno, "write blkio.weight_device");
 
-              len = sprintf (fmt_buf, "%lu:%lu %i\n",
-                             blkio->weight_device[i]->major,
-                             blkio->weight_device[i]->minor,
+              len = sprintf (fmt_buf, "%lu:%lu %i\n", blkio->weight_device[i]->major, blkio->weight_device[i]->minor,
                              blkio->weight_device[i]->leaf_weight);
               ret = TEMP_FAILURE_RETRY (write (w_leafdevice_fd, fmt_buf, len));
               if (UNLIKELY (ret < 0))
@@ -1955,31 +1998,23 @@ write_blkio_resources (int dirfd, bool c
       if (UNLIKELY (wfd < 0))
         return crun_make_error (err, errno, "open io.max");
 
-      ret = write_blkio_v2_resources_throttling (wfd, "rbps",
-                                                 (throttling_s **) blkio->throttle_read_bps_device,
-                                                 blkio->throttle_read_bps_device_len,
-                                                 err);
+      ret = write_blkio_v2_resources_throttling (wfd, "rbps", (throttling_s **) blkio->throttle_read_bps_device,
+                                                 blkio->throttle_read_bps_device_len, err);
       if (UNLIKELY (ret < 0))
         return ret;
 
-      ret = write_blkio_v2_resources_throttling (wfd, "wbps",
-                                                 (throttling_s **) blkio->throttle_write_bps_device,
-                                                 blkio->throttle_write_bps_device_len,
-                                                 err);
+      ret = write_blkio_v2_resources_throttling (wfd, "wbps", (throttling_s **) blkio->throttle_write_bps_device,
+                                                 blkio->throttle_write_bps_device_len, err);
       if (UNLIKELY (ret < 0))
         return ret;
 
-      ret = write_blkio_v2_resources_throttling (wfd, "riops",
-                                                 (throttling_s **) blkio->throttle_read_iops_device,
-                                                 blkio->throttle_read_iops_device_len,
-                                                 err);
+      ret = write_blkio_v2_resources_throttling (wfd, "riops", (throttling_s **) blkio->throttle_read_iops_device,
+                                                 blkio->throttle_read_iops_device_len, err);
       if (UNLIKELY (ret < 0))
         return ret;
 
-      ret = write_blkio_v2_resources_throttling (wfd, "wiops",
-                                                 (throttling_s **) blkio->throttle_write_iops_device,
-                                                 blkio->throttle_write_iops_device_len,
-                                                 err);
+      ret = write_blkio_v2_resources_throttling (wfd, "wiops", (throttling_s **) blkio->throttle_write_iops_device,
+                                                 blkio->throttle_write_iops_device_len, err);
       if (UNLIKELY (ret < 0))
         return ret;
     }
@@ -1987,29 +2022,25 @@ write_blkio_resources (int dirfd, bool c
     {
       ret = write_blkio_v1_resources_throttling (dirfd, "blkio.throttle.read_bps_device",
                                                  (throttling_s **) blkio->throttle_read_bps_device,
-                                                 blkio->throttle_read_bps_device_len,
-                                                 err);
+                                                 blkio->throttle_read_bps_device_len, err);
       if (UNLIKELY (ret < 0))
         return ret;
 
       ret = write_blkio_v1_resources_throttling (dirfd, "blkio.throttle.write_bps_device",
                                                  (throttling_s **) blkio->throttle_write_bps_device,
-                                                 blkio->throttle_write_bps_device_len,
-                                                 err);
+                                                 blkio->throttle_write_bps_device_len, err);
       if (UNLIKELY (ret < 0))
         return ret;
 
       ret = write_blkio_v1_resources_throttling (dirfd, "blkio.throttle.read_iops_device",
                                                  (throttling_s **) blkio->throttle_read_iops_device,
-                                                 blkio->throttle_read_iops_device_len,
-                                                 err);
+                                                 blkio->throttle_read_iops_device_len, err);
       if (UNLIKELY (ret < 0))
         return ret;
 
       ret = write_blkio_v1_resources_throttling (dirfd, "blkio.throttle.write_iops_device",
                                                  (throttling_s **) blkio->throttle_write_iops_device,
-                                                 blkio->throttle_write_iops_device_len,
-                                                 err);
+                                                 blkio->throttle_write_iops_device_len, err);
       if (UNLIKELY (ret < 0))
         return ret;
     }
@@ -2017,7 +2048,8 @@ write_blkio_resources (int dirfd, bool c
 }
 
 static int
-write_network_resources (int dirfd_netclass, int dirfd_netprio, runtime_spec_schema_config_linux_resources_network *net, libcrun_error_t *err)
+write_network_resources (int dirfd_netclass, int dirfd_netprio, runtime_spec_schema_config_linux_resources_network *net,
+                         libcrun_error_t *err)
 {
   char fmt_buf[128];
   size_t len;
@@ -2044,14 +2076,15 @@ write_network_resources (int dirfd_netcl
           if (UNLIKELY (ret < 0))
             return crun_make_error (err, errno, "write net_prio.ifpriomap");
         }
-
     }
 
   return 0;
 }
 
 static int
-write_hugetlb_resources (int dirfd, bool cgroup2, runtime_spec_schema_config_linux_resources_hugepage_limits_element **htlb, size_t htlb_len, libcrun_error_t *err)
+write_hugetlb_resources (int dirfd, bool cgroup2,
+                         runtime_spec_schema_config_linux_resources_hugepage_limits_element **htlb, size_t htlb_len,
+                         libcrun_error_t *err)
 {
   char fmt_buf[128];
   size_t i;
@@ -2074,28 +2107,15 @@ write_hugetlb_resources (int dirfd, bool
   return 0;
 }
 
-
 static int
-write_devices_resources_v1 (int dirfd, runtime_spec_schema_defs_linux_device_cgroup **devs, size_t devs_len, libcrun_error_t *err)
+write_devices_resources_v1 (int dirfd, runtime_spec_schema_defs_linux_device_cgroup **devs, size_t devs_len,
+                            libcrun_error_t *err)
 {
   size_t i, len;
   int ret;
-  char *default_devices[] =
-    {
-      "c *:* m",
-      "b *:* m",
-      "c 1:3 rwm",
-      "c 1:8 rwm",
-      "c 1:7 rwm",
-      "c 5:0 rwm",
-      "c 1:5 rwm",
-      "c 1:9 rwm",
-      "c 5:1 rwm",
-      "c 136:* rwm",
-      "c 5:2 rwm",
-      "c 10:200 rwm",
-      NULL
-  };
+  char *default_devices[]
+      = { "c *:* m",   "b *:* m",   "c 1:3 rwm",   "c 1:8 rwm", "c 1:7 rwm",    "c 5:0 rwm", "c 1:5 rwm",
+          "c 1:9 rwm", "c 5:1 rwm", "c 136:* rwm", "c 5:2 rwm", "c 10:200 rwm", NULL };
 
   for (i = 0; i < devs_len; i++)
     {
@@ -2114,17 +2134,21 @@ write_devices_resources_v1 (int dirfd, r
           char fmt_buf_major[16];
           char fmt_buf_minor[16];
 
-#define FMT_DEV(x, b) do {                      \
-            if (x ## _present)                  \
-              sprintf (b, "%lu", x);            \
-            else                                \
-              strcpy (b, "*");                  \
-          } while(0)                            \
+#define FMT_DEV(x, b)          \
+  do                           \
+    {                          \
+      if (x##_present)         \
+        sprintf (b, "%lu", x); \
+      else                     \
+        strcpy (b, "*");       \
+    }                          \
+  while (0)
 
           FMT_DEV (devs[i]->major, fmt_buf_major);
           FMT_DEV (devs[i]->minor, fmt_buf_minor);
 
-          len = snprintf (fmt_buf, FMT_BUF_LEN - 1, "%s %s:%s %s", devs[i]->type, fmt_buf_major, fmt_buf_minor, devs[i]->access);
+          len = snprintf (fmt_buf, FMT_BUF_LEN - 1, "%s %s:%s %s", devs[i]->type, fmt_buf_major, fmt_buf_minor,
+                          devs[i]->access);
           /* Make sure it is still a NUL terminated string.  */
           fmt_buf[len] = '\0';
         }
@@ -2144,30 +2168,22 @@ write_devices_resources_v1 (int dirfd, r
 }
 
 static int
-write_devices_resources_v2_internal (int dirfd, runtime_spec_schema_defs_linux_device_cgroup **devs, size_t devs_len, libcrun_error_t *err)
+write_devices_resources_v2_internal (int dirfd, runtime_spec_schema_defs_linux_device_cgroup **devs, size_t devs_len,
+                                     libcrun_error_t *err)
 {
   int i, ret;
   cleanup_free struct bpf_program *program = NULL;
-  struct default_dev_s {
+  struct default_dev_s
+  {
     char type;
     int major;
     int minor;
     const char *access;
   };
-  struct default_dev_s default_devices[] =
-    {
-     {'c', -1, -1, "m"},
-     {'b', -1, -1, "m"},
-     {'c', 1, 3, "rwm"},
-     {'c', 1, 8, "rwm"},
-     {'c', 1, 7, "rwm"},
-     {'c', 5, 0, "rwm"},
-     {'c', 1, 5, "rwm"},
-     {'c', 1, 9, "rwm"},
-     {'c', 5, 1, "rwm"},
-     {'c', 136, -1, "rwm"},
-     {'c', 5, 2, "rwm"},
-     {'c', 10, 200, "rwm"},
+  struct default_dev_s default_devices[] = {
+    { 'c', -1, -1, "m" }, { 'b', -1, -1, "m" },    { 'c', 1, 3, "rwm" }, { 'c', 1, 8, "rwm" },
+    { 'c', 1, 7, "rwm" }, { 'c', 5, 0, "rwm" },    { 'c', 1, 5, "rwm" }, { 'c', 1, 9, "rwm" },
+    { 'c', 5, 1, "rwm" }, { 'c', 136, -1, "rwm" }, { 'c', 5, 2, "rwm" }, { 'c', 10, 200, "rwm" },
   };
 
   program = bpf_program_new (2048);
@@ -2176,7 +2192,7 @@ write_devices_resources_v2_internal (int
   if (UNLIKELY (program == NULL))
     return -1;
 
-  for (i = (sizeof (default_devices) / sizeof (default_devices[0])) - 1; i >= 0 ; i--)
+  for (i = (sizeof (default_devices) / sizeof (default_devices[0])) - 1; i >= 0; i--)
     {
       program = bpf_program_append_dev (program, default_devices[i].access, default_devices[i].type,
                                         default_devices[i].major, default_devices[i].minor, true, err);
@@ -2212,7 +2228,8 @@ write_devices_resources_v2_internal (int
 }
 
 static int
-write_devices_resources_v2 (int dirfd, runtime_spec_schema_defs_linux_device_cgroup **devs, size_t devs_len, libcrun_error_t *err)
+write_devices_resources_v2 (int dirfd, runtime_spec_schema_defs_linux_device_cgroup **devs, size_t devs_len,
+                            libcrun_error_t *err)
 {
   int ret;
   size_t i;
@@ -2225,7 +2242,7 @@ write_devices_resources_v2 (int dirfd, r
   /* If writing the resources ebpf failed, check if it is fine to ignore the error.  */
   for (i = 0; i < devs_len; i++)
     {
-      if (devs[i]->allow_present && !devs[i]->allow)
+      if (devs[i]->allow_present && ! devs[i]->allow)
         {
           can_skip = false;
           break;
@@ -2257,9 +2274,9 @@ write_devices_resources_v2 (int dirfd, r
   return ret;
 }
 
-
 static int
-write_devices_resources (int dirfd, bool cgroup2, runtime_spec_schema_defs_linux_device_cgroup **devs, size_t devs_len, libcrun_error_t *err)
+write_devices_resources (int dirfd, bool cgroup2, runtime_spec_schema_defs_linux_device_cgroup **devs, size_t devs_len,
+                         libcrun_error_t *err)
 {
   if (cgroup2)
     return write_devices_resources_v2 (dirfd, devs, devs_len, err);
@@ -2271,10 +2288,10 @@ write_devices_resources (int dirfd, bool
 static int
 cg_itoa (char *buf, int64_t value, bool cgroup2)
 {
-  if (!(cgroup2 && value == -1))
+  if (! (cgroup2 && value == -1))
     return sprintf (buf, "%lu", value);
 
-  memcpy(buf, "max", 4);
+  memcpy (buf, "max", 4);
   return 3;
 }
 
@@ -2293,7 +2310,8 @@ write_memory (int dirfd, bool cgroup2, r
 }
 
 static int
-write_memory_swap (int dirfd, bool cgroup2, runtime_spec_schema_config_linux_resources_memory *memory, libcrun_error_t *err)
+write_memory_swap (int dirfd, bool cgroup2, runtime_spec_schema_config_linux_resources_memory *memory,
+                   libcrun_error_t *err)
 {
   int64_t swap;
   char swap_buf[32];
@@ -2305,7 +2323,7 @@ write_memory_swap (int dirfd, bool cgrou
   swap = memory->swap;
   if (cgroup2 && memory->swap != -1)
     {
-      if (!memory->limit_present)
+      if (! memory->limit_present)
         return crun_make_error (err, 0, "cannot set swap limit without the memory limit");
       if (memory->swap < memory->limit)
         return crun_make_error (err, 0, "cannot set memory+swap limit less than the memory limit");
@@ -2315,11 +2333,13 @@ write_memory_swap (int dirfd, bool cgrou
 
   swap_buf_len = cg_itoa (swap_buf, swap, cgroup2);
 
-  return write_file_at (dirfd, cgroup2 ? "memory.swap.max" : "memory.memsw.limit_in_bytes", swap_buf, swap_buf_len, err);
+  return write_file_at (dirfd, cgroup2 ? "memory.swap.max" : "memory.memsw.limit_in_bytes", swap_buf, swap_buf_len,
+                        err);
 }
 
 static int
-write_memory_resources (int dirfd, bool cgroup2, runtime_spec_schema_config_linux_resources_memory *memory, libcrun_error_t *err)
+write_memory_resources (int dirfd, bool cgroup2, runtime_spec_schema_config_linux_resources_memory *memory,
+                        libcrun_error_t *err)
 {
   size_t len;
   int ret;
@@ -2350,7 +2370,7 @@ write_memory_resources (int dirfd, bool
   if (UNLIKELY (ret < 0))
     return ret;
 
-  if (memory->limit_present && !memory_limits_written)
+  if (memory->limit_present && ! memory_limits_written)
     {
       ret = write_memory (dirfd, cgroup2, memory, err);
       if (UNLIKELY (ret < 0))
@@ -2409,7 +2429,8 @@ write_memory_resources (int dirfd, bool
 }
 
 static int
-write_pids_resources (int dirfd, bool cgroup2, runtime_spec_schema_config_linux_resources_pids *pids, libcrun_error_t *err)
+write_pids_resources (int dirfd, bool cgroup2, runtime_spec_schema_config_linux_resources_pids *pids,
+                      libcrun_error_t *err)
 {
   if (pids->limit)
     {
@@ -2427,7 +2448,8 @@ write_pids_resources (int dirfd, bool cg
 }
 
 static int
-write_cpu_resources (int dirfd_cpu, bool cgroup2, runtime_spec_schema_config_linux_resources_cpu *cpu, libcrun_error_t *err)
+write_cpu_resources (int dirfd_cpu, bool cgroup2, runtime_spec_schema_config_linux_resources_cpu *cpu,
+                     libcrun_error_t *err)
 {
   size_t len;
   int ret;
@@ -2435,8 +2457,8 @@ write_cpu_resources (int dirfd_cpu, bool
   int64_t period = -1;
   int64_t quota = -1;
 
-      /* convert linearly from 2-262144 to 1-10000.  */
-#define CONVERT_SHARES_TO_CGROUPS_V2(x) (1 + (((x) - 2) * 9999) / 262142)
+  /* convert linearly from 2-262144 to 1-10000.  */
+#define CONVERT_SHARES_TO_CGROUPS_V2(x) (1 + (((x) -2) * 9999) / 262142)
 
   if (cpu->shares)
     {
@@ -2510,7 +2532,8 @@ write_cpu_resources (int dirfd_cpu, bool
 }
 
 static int
-write_cpuset_resources (int dirfd_cpuset, int cgroup2 arg_unused, runtime_spec_schema_config_linux_resources_cpu *cpu, libcrun_error_t *err)
+write_cpuset_resources (int dirfd_cpuset, int cgroup2 arg_unused, runtime_spec_schema_config_linux_resources_cpu *cpu,
+                        libcrun_error_t *err)
 {
   int ret;
 
@@ -2584,9 +2607,7 @@ update_cgroup_v1_resources (runtime_spec
       if (UNLIKELY (dirfd_htlb < 0))
         return crun_make_error (err, errno, "open %s", path_to_htlb);
 
-      ret = write_hugetlb_resources (dirfd_htlb, false,
-                                     resources->hugepage_limits,
-                                     resources->hugepage_limits_len,
+      ret = write_hugetlb_resources (dirfd_htlb, false, resources->hugepage_limits, resources->hugepage_limits_len,
                                      err);
       if (UNLIKELY (ret < 0))
         return ret;
@@ -2602,10 +2623,7 @@ update_cgroup_v1_resources (runtime_spec
       if (UNLIKELY (dirfd_devs < 0))
         return crun_make_error (err, errno, "open %s", path_to_devs);
 
-      ret = write_devices_resources (dirfd_devs, false,
-                                     resources->devices,
-                                     resources->devices_len,
-                                     err);
+      ret = write_devices_resources (dirfd_devs, false, resources->devices, resources->devices_len, err);
       if (UNLIKELY (ret < 0))
         return ret;
     }
@@ -2620,9 +2638,7 @@ update_cgroup_v1_resources (runtime_spec
       if (UNLIKELY (dirfd_mem < 0))
         return crun_make_error (err, errno, "open %s", path_to_mem);
 
-      ret = write_memory_resources (dirfd_mem, false,
-                                    resources->memory,
-                                    err);
+      ret = write_memory_resources (dirfd_mem, false, resources->memory, err);
       if (UNLIKELY (ret < 0))
         return ret;
     }
@@ -2637,9 +2653,7 @@ update_cgroup_v1_resources (runtime_spec
       if (UNLIKELY (dirfd_pid < 0))
         return crun_make_error (err, errno, "open %s", path_to_pid);
 
-      ret = write_pids_resources (dirfd_pid, false,
-                                  resources->pids,
-                                  err);
+      ret = write_pids_resources (dirfd_pid, false, resources->pids, err);
       if (UNLIKELY (ret < 0))
         return ret;
     }
@@ -2655,9 +2669,7 @@ update_cgroup_v1_resources (runtime_spec
       dirfd_cpu = open (path_to_cpu, O_DIRECTORY | O_RDONLY);
       if (UNLIKELY (dirfd_cpu < 0))
         return crun_make_error (err, errno, "open %s", path_to_cpu);
-      ret = write_cpu_resources (dirfd_cpu, false,
-                                 resources->cpu,
-                                 err);
+      ret = write_cpu_resources (dirfd_cpu, false, resources->cpu, err);
       if (UNLIKELY (ret < 0))
         return ret;
 
@@ -2668,13 +2680,87 @@ update_cgroup_v1_resources (runtime_spec
       dirfd_cpuset = open (path_to_cpuset, O_DIRECTORY | O_RDONLY);
       if (UNLIKELY (dirfd_cpuset < 0))
         return crun_make_error (err, errno, "open %s", path_to_cpuset);
-      ret = write_cpuset_resources (dirfd_cpuset, false,
-                                    resources->cpu,
-                                    err);
+      ret = write_cpuset_resources (dirfd_cpuset, false, resources->cpu, err);
       if (UNLIKELY (ret < 0))
         return ret;
     }
 
+  if (resources->unified && resources->unified->len > 0)
+    return crun_make_error (err, 0, "invalid configuration: cannot use unified on cgroup v1");
+
+  return 0;
+}
+
+static int
+write_unified_resources (int cgroup_dirfd, runtime_spec_schema_config_linux_resources *resources, libcrun_error_t *err)
+{
+  size_t i;
+  int ret;
+
+  for (i = 0; i < resources->unified->len; i++)
+    {
+      size_t len;
+
+      if (strchr (resources->unified->keys[i], '/'))
+        return crun_make_error (err, 0, "key `%s` must be a file name without any slash", resources->unified->keys[i]);
+
+      len = strlen (resources->unified->values[i]);
+      ret = write_file_at (cgroup_dirfd, resources->unified->keys[i], resources->unified->values[i], len, err);
+      if (UNLIKELY (ret < 0))
+        {
+          errno = crun_error_get_errno (err);
+
+          /* If the file is not found, try to give a more meaningful error message.  */
+          if (errno == ENOENT || errno == EPERM || errno == EACCES)
+            {
+              cleanup_free char *controllers = NULL;
+              libcrun_error_t tmp_err = NULL;
+              cleanup_free char *key = NULL;
+              char *saveptr = NULL;
+              bool found = false;
+              const char *token;
+              char *it;
+
+              /* Check if the specified controller is enabled.  */
+              key = xstrdup (resources->unified->keys[i]);
+
+              it = strchr (key, '.');
+              if (it == NULL)
+                {
+                  crun_error_release (err);
+                  return crun_make_error (err, 0, "the specified key has not the form CONTROLLER.VALUE `%s`",
+                                          resources->unified->keys[i]);
+                }
+              *it = '\0';
+
+              /* cgroup. files are not part of a controller.  Return the original error.  */
+              if (strcmp (key, "cgroup") == 0)
+                return ret;
+
+              /* If the cgroup.controllers file cannot be read, return the original error.  */
+              if (read_all_file_at (cgroup_dirfd, "cgroup.controllers", &controllers, NULL, &tmp_err) < 0)
+                {
+                  crun_error_release (&tmp_err);
+                  return ret;
+                }
+              for (token = strtok_r (controllers, " \n", &saveptr); token; token = strtok_r (NULL, " \n", &saveptr))
+                {
+                  if (strcmp (token, key) == 0)
+                    {
+                      found = true;
+                      break;
+                    }
+                }
+              if (! found)
+                {
+                  crun_error_release (err);
+                  return crun_make_error (err, 0, "the requested controller `%s` is not available", key);
+                }
+            }
+          return ret;
+        }
+    }
+
   return 0;
 }
 
@@ -2696,41 +2782,30 @@ update_cgroup_v2_resources (runtime_spec
 
   if (resources->devices_len)
     {
-      ret = write_devices_resources (cgroup_dirfd, true,
-                                     resources->devices,
-                                     resources->devices_len,
-                                     err);
+      ret = write_devices_resources (cgroup_dirfd, true, resources->devices, resources->devices_len, err);
       if (UNLIKELY (ret < 0))
         return ret;
     }
 
   if (resources->memory)
     {
-      ret = write_memory_resources (cgroup_dirfd, true,
-                                    resources->memory,
-                                    err);
+      ret = write_memory_resources (cgroup_dirfd, true, resources->memory, err);
       if (UNLIKELY (ret < 0))
         return ret;
     }
   if (resources->pids)
     {
-      ret = write_pids_resources (cgroup_dirfd, true,
-                                  resources->pids,
-                                  err);
+      ret = write_pids_resources (cgroup_dirfd, true, resources->pids, err);
       if (UNLIKELY (ret < 0))
         return ret;
     }
   if (resources->cpu)
     {
-      ret = write_cpu_resources (cgroup_dirfd, true,
-                                 resources->cpu,
-                                 err);
+      ret = write_cpu_resources (cgroup_dirfd, true, resources->cpu, err);
       if (UNLIKELY (ret < 0))
         return ret;
 
-      ret = write_cpuset_resources (cgroup_dirfd, true,
-                                    resources->cpu,
-                                    err);
+      ret = write_cpuset_resources (cgroup_dirfd, true, resources->cpu, err);
       if (UNLIKELY (ret < 0))
         return ret;
     }
@@ -2743,30 +2818,33 @@ update_cgroup_v2_resources (runtime_spec
 
   if (resources->hugepage_limits_len)
     {
-      ret = write_hugetlb_resources (cgroup_dirfd, true,
-                                     resources->hugepage_limits,
-                                     resources->hugepage_limits_len,
+      ret = write_hugetlb_resources (cgroup_dirfd, true, resources->hugepage_limits, resources->hugepage_limits_len,
                                      err);
       if (UNLIKELY (ret < 0))
         return ret;
     }
 
+  /* Write unified resources if any.  They have higher precedence and override any previous setting.  */
+  if (resources->unified)
+    {
+      ret = write_unified_resources (cgroup_dirfd, resources, err);
+      if (UNLIKELY (ret < 0))
+        return ret;
+    }
+
   return 0;
 }
 
 int
-libcrun_update_cgroup_resources (int cgroup_mode, runtime_spec_schema_config_linux_resources *resources, char *path, libcrun_error_t *err)
+libcrun_update_cgroup_resources (int cgroup_mode, runtime_spec_schema_config_linux_resources *resources, char *path,
+                                 libcrun_error_t *err)
 {
   if (path == NULL)
     {
       size_t i;
 
-      if (resources->block_io
-          || resources->network
-          || resources->hugepage_limits_len
-          || resources->memory
-          || resources->pids
-          || resources->cpu)
+      if (resources->block_io || resources->network || resources->hugepage_limits_len || resources->memory
+          || resources->pids || resources->cpu)
         return crun_make_error (err, 0, "cannot set limits without cgroups");
 
       for (i = 0; i < resources->devices_len; i++)
diff -pruN 0.14.1+dfsg-1/src/libcrun/cgroup.h 0.15+dfsg-1/src/libcrun/cgroup.h
--- 0.14.1+dfsg-1/src/libcrun/cgroup.h	2020-07-03 19:38:11.000000000 +0000
+++ 0.15+dfsg-1/src/libcrun/cgroup.h	2020-09-03 11:43:25.000000000 +0000
@@ -16,24 +16,24 @@
  * along with crun.  If not, see <http://www.gnu.org/licenses/>.
  */
 #ifndef CGROUP_H
-# define CGROUP_H
+#define CGROUP_H
 
-# include "container.h"
-# include <unistd.h>
+#include "container.h"
+#include <unistd.h>
 
 enum
-  {
-   CGROUP_MODE_UNIFIED = 1,
-   CGROUP_MODE_LEGACY,
-   CGROUP_MODE_HYBRID
-  };
+{
+  CGROUP_MODE_UNIFIED = 1,
+  CGROUP_MODE_LEGACY,
+  CGROUP_MODE_HYBRID
+};
 
 enum
-  {
-   CGROUP_MANAGER_CGROUPFS = 1,
-   CGROUP_MANAGER_SYSTEMD,
-   CGROUP_MANAGER_DISABLED
-  };
+{
+  CGROUP_MANAGER_CGROUPFS = 1,
+  CGROUP_MANAGER_SYSTEMD,
+  CGROUP_MANAGER_DISABLED
+};
 
 struct libcrun_cgroup_args
 {
@@ -54,18 +54,21 @@ struct libcrun_cgroup_args
 LIBCRUN_PUBLIC int libcrun_get_cgroup_mode (libcrun_error_t *err);
 LIBCRUN_PUBLIC int libcrun_cgroup_killall_signal (const char *path, int signal, libcrun_error_t *err);
 LIBCRUN_PUBLIC int libcrun_cgroup_killall (const char *path, libcrun_error_t *err);
-LIBCRUN_PUBLIC int libcrun_cgroup_destroy (const char *id, const char *path, const char *scope, int manager, libcrun_error_t *err);
+LIBCRUN_PUBLIC int libcrun_cgroup_destroy (const char *id, const char *path, const char *scope, int manager,
+                                           libcrun_error_t *err);
 LIBCRUN_PUBLIC int libcrun_move_process_to_cgroup (pid_t pid, pid_t init_pid, char *path, libcrun_error_t *err);
-LIBCRUN_PUBLIC int libcrun_update_cgroup_resources (int cgroup_mode, runtime_spec_schema_config_linux_resources *resources,
-                                     char *path, libcrun_error_t *err);
-LIBCRUN_PUBLIC int libcrun_cgroup_is_container_paused (const char *cgroup_path, int cgroup_mode, bool *paused, libcrun_error_t *err);
+LIBCRUN_PUBLIC int libcrun_update_cgroup_resources (int cgroup_mode,
+                                                    runtime_spec_schema_config_linux_resources *resources, char *path,
+                                                    libcrun_error_t *err);
+LIBCRUN_PUBLIC int libcrun_cgroup_is_container_paused (const char *cgroup_path, int cgroup_mode, bool *paused,
+                                                       libcrun_error_t *err);
 LIBCRUN_PUBLIC int libcrun_cgroup_pause_unpause (const char *path, const bool pause, libcrun_error_t *err);
 LIBCRUN_PUBLIC int libcrun_cgroup_read_pids (const char *path, bool recurse, pid_t **pids, libcrun_error_t *err);
 
 int libcrun_cgroup_enter (struct libcrun_cgroup_args *args, libcrun_error_t *err);
 int libcrun_cgroups_create_symlinks (int dirfd, libcrun_error_t *err);
 
-typedef const char * cgroups_subsystem_t;
+typedef const char *cgroups_subsystem_t;
 
 const cgroups_subsystem_t *libcrun_get_cgroups_subsystems ();
 
diff -pruN 0.14.1+dfsg-1/src/libcrun/chroot_realpath.c 0.15+dfsg-1/src/libcrun/chroot_realpath.c
--- 0.14.1+dfsg-1/src/libcrun/chroot_realpath.c	2020-07-02 13:46:33.000000000 +0000
+++ 0.15+dfsg-1/src/libcrun/chroot_realpath.c	2020-09-22 18:17:19.000000000 +0000
@@ -1,5 +1,5 @@
 /*
- * chroot_realpath.c -- reslove pathname as if inside chroot
+ * chroot_realpath.c -- resolve pathname as if inside chroot
  * Based on realpath.c Copyright (C) 1993 Rick Sladkey <jrs@world.std.com>
  *
  * This program is free software; you can redistribute it and/or
diff -pruN 0.14.1+dfsg-1/src/libcrun/container.c 0.15+dfsg-1/src/libcrun/container.c
--- 0.14.1+dfsg-1/src/libcrun/container.c	2020-07-03 20:15:41.000000000 +0000
+++ 0.15+dfsg-1/src/libcrun/container.c	2020-09-22 18:17:19.000000000 +0000
@@ -23,6 +23,7 @@
 #include "container.h"
 #include "utils.h"
 #include "seccomp.h"
+#include "seccomp_notify.h"
 #include <stdbool.h>
 #include <argp.h>
 #include <unistd.h>
@@ -42,8 +43,12 @@
 #include <sys/socket.h>
 #include <grp.h>
 
+#ifdef HAVE_DLOPEN
+#  include <dlfcn.h>
+#endif
+
 #ifdef HAVE_SYSTEMD
-# include <systemd/sd-daemon.h>
+#  include <systemd/sd-daemon.h>
 #endif
 
 #include <yajl/yajl_tree.h>
@@ -52,11 +57,11 @@
 #define YAJL_STR(x) ((const unsigned char *) (x))
 
 enum
-  {
-    SYNC_SOCKET_SYNC_MESSAGE,
-    SYNC_SOCKET_ERROR_MESSAGE,
-    SYNC_SOCKET_WARNING_MESSAGE,
-  };
+{
+  SYNC_SOCKET_SYNC_MESSAGE,
+  SYNC_SOCKET_ERROR_MESSAGE,
+  SYNC_SOCKET_WARNING_MESSAGE,
+};
 
 struct container_entrypoint_s
 {
@@ -69,6 +74,7 @@ struct container_entrypoint_s
   int sync_socket;
 
   int seccomp_fd;
+  int seccomp_receiver_fd;
   int console_socket_fd;
 
   int hooks_out_fd;
@@ -240,15 +246,18 @@ static char spec_file[] = "\
 			}\n\
 		],\n\
 		\"maskedPaths\": [\n\
+			\"/proc/acpi\",\n\
+			\"/proc/asound\",\n\
 			\"/proc/kcore\",\n\
+			\"/proc/keys\",\n\
 			\"/proc/latency_stats\",\n\
 			\"/proc/timer_list\",\n\
 			\"/proc/timer_stats\",\n\
 			\"/proc/sched_debug\",\n\
-			\"/sys/firmware\"\n\
+			\"/sys/firmware\",\n\
+			\"/proc/scsi\"\n\
 		],\n\
 		\"readonlyPaths\": [\n\
-			\"/proc/asound\",\n\
 			\"/proc/bus\",\n\
 			\"/proc/fs\",\n\
 			\"/proc/irq\",\n\
@@ -342,7 +351,7 @@ sync_socket_wait_sync (libcrun_context_t
           return crun_make_error (err, 0, "sync socket closed");
         }
 
-      if (!flush && msg.type == SYNC_SOCKET_SYNC_MESSAGE)
+      if (! flush && msg.type == SYNC_SOCKET_SYNC_MESSAGE)
         return 0;
 
       if (msg.type == SYNC_SOCKET_WARNING_MESSAGE)
@@ -360,7 +369,9 @@ static int
 sync_socket_send_sync (int fd, bool flush_errors, libcrun_error_t *err)
 {
   int ret;
-  struct sync_socket_message_s msg = {0, };
+  struct sync_socket_message_s msg = {
+    0,
+  };
   msg.type = SYNC_SOCKET_SYNC_MESSAGE;
 
   if (fd < 0)
@@ -371,13 +382,12 @@ sync_socket_send_sync (int fd, bool flus
     {
       if (flush_errors)
         {
+          int saved_errno = errno;
           ret = TEMP_FAILURE_RETRY (read (fd, &msg, sizeof (msg)));
-          if (UNLIKELY (ret < 0))
-            goto original_error;
-          if (msg.type == SYNC_SOCKET_ERROR_MESSAGE)
+          if (ret >= 0 && msg.type == SYNC_SOCKET_ERROR_MESSAGE)
             return crun_make_error (err, msg.error_value, "%s", msg.message);
+          errno = saved_errno;
         }
-    original_error:
       return crun_make_error (err, errno, "write to sync socket");
     }
 
@@ -424,8 +434,8 @@ libcrun_container_load_from_file (const
   return make_container (container_def);
 }
 
-static
-int block_signals (libcrun_error_t *err)
+static int
+block_signals (libcrun_error_t *err)
 {
   int ret;
   sigset_t mask;
@@ -436,8 +446,8 @@ int block_signals (libcrun_error_t *err)
   return 0;
 }
 
-static
-int unblock_signals (libcrun_error_t *err)
+static int
+unblock_signals (libcrun_error_t *err)
 {
   int i;
   int ret;
@@ -480,21 +490,16 @@ initialize_security (runtime_spec_schema
   if (UNLIKELY (ret < 0))
     return ret;
 
+  ret = libcrun_init_caps (err);
+  if (UNLIKELY (ret < 0))
+    return ret;
+
   return 0;
 }
 
 static int
-do_hooks (runtime_spec_schema_config_schema *def,
-          pid_t pid,
-          const char *id,
-          bool keep_going,
-          const char *cwd,
-          const char *status,
-          hook **hooks,
-          size_t hooks_len,
-          int out_fd,
-          int err_fd,
-          libcrun_error_t *err)
+do_hooks (runtime_spec_schema_config_schema *def, pid_t pid, const char *id, bool keep_going, const char *cwd,
+          const char *status, hook **hooks, size_t hooks_len, int out_fd, int err_fd, libcrun_error_t *err)
 {
   size_t i, stdin_len;
   int ret;
@@ -533,11 +538,17 @@ do_hooks (runtime_spec_schema_config_sch
       yajl_gen_get_buf (gen, &annotations, &len);
     }
 
-  stdin_len = xasprintf (&stdin, "{\"ociVersion\":\"1.0\", \"id\":\"%s\", \"pid\":%i, \"root\":\"%s\", \"bundle\":\"%s\", \"status\":\"%s\", \"annotations\":%s}", id, pid, rootfs, cwd, status, annotations);
+  stdin_len = xasprintf (&stdin,
+                         "{\"ociVersion\":\"1.0\", \"id\":\"%s\", \"pid\":%i, \"root\":\"%s\", \"bundle\":\"%s\", "
+                         "\"status\":\"%s\", \"annotations\":%s}",
+                         id, pid, rootfs, cwd, status, annotations);
+
+  ret = 0;
 
   for (i = 0; i < hooks_len; i++)
     {
-      ret = run_process_with_stdin_timeout_envp (hooks[i]->path, hooks[i]->args, cwd, hooks[i]->timeout, hooks[i]->env, stdin, stdin_len, out_fd, err_fd, err);
+      ret = run_process_with_stdin_timeout_envp (hooks[i]->path, hooks[i]->args, cwd, hooks[i]->timeout, hooks[i]->env,
+                                                 stdin, stdin_len, out_fd, err_fd, err);
       if (UNLIKELY (ret != 0))
         {
           if (keep_going)
@@ -545,14 +556,11 @@ do_hooks (runtime_spec_schema_config_sch
           else
             {
               libcrun_error (0, "error executing hook `%s` (exit code: %d)", hooks[i]->path, ret);
-              goto exit;
+              break;
             }
         }
     }
 
-  ret = 0;
-
- exit:
   if (gen)
     yajl_gen_free (gen);
 
@@ -562,9 +570,7 @@ do_hooks (runtime_spec_schema_config_sch
 /* Initialize the environment where the container process runs.
    It is used by the container init process.  */
 static int
-container_init_setup (void *args, char *notify_socket,
-                      int sync_socket, const char **exec_path,
-                      libcrun_error_t *err)
+container_init_setup (void *args, char *notify_socket, int sync_socket, const char **exec_path, libcrun_error_t *err)
 {
   struct container_entrypoint_s *entrypoint_args = args;
   libcrun_container_t *container = entrypoint_args->container;
@@ -627,11 +633,8 @@ container_init_setup (void *args, char *
 
   if (def->hooks && def->hooks->create_container_len)
     {
-      ret = do_hooks (def, 0, container->context->id, false, NULL, "created",
-                      (hook **) def->hooks->create_container,
-                      def->hooks->create_container_len,
-                      entrypoint_args->hooks_out_fd,
-                      entrypoint_args->hooks_err_fd,
+      ret = do_hooks (def, 0, container->context->id, false, NULL, "created", (hook **) def->hooks->create_container,
+                      def->hooks->create_container_len, entrypoint_args->hooks_out_fd, entrypoint_args->hooks_err_fd,
                       err);
       if (UNLIKELY (ret != 0))
         return ret;
@@ -677,7 +680,7 @@ container_init_setup (void *args, char *
       ret = set_home_env (container->container_uid);
       if (UNLIKELY (ret < 0 && errno != ENOTSUP))
         {
-          setenv("HOME", "/", 1);
+          setenv ("HOME", "/", 1);
           libcrun_warning ("cannot detect HOME environment variable, setting default");
         }
     }
@@ -692,7 +695,7 @@ container_init_setup (void *args, char *
       if (UNLIKELY (*exec_path == NULL))
         {
           if (errno == ENOENT)
-            return crun_make_error (err, errno, "executable file not found in $PATH");
+            return crun_make_error (err, errno, "executable file `%s` not found in $PATH", def->process->args[0]);
 
           return crun_make_error (err, errno, "open executable");
         }
@@ -743,7 +746,7 @@ container_init_setup (void *args, char *
   if (def->process->user)
     umask (def->process->user->umask_present ? def->process->user->umask : 0022);
 
-  if (def->process && !def->process->no_new_privileges)
+  if (def->process && ! def->process->no_new_privileges)
     {
       char **seccomp_flags = NULL;
       size_t seccomp_flags_len = 0;
@@ -754,11 +757,13 @@ container_init_setup (void *args, char *
           seccomp_flags_len = def->linux->seccomp->flags_len;
         }
 
-      ret = libcrun_apply_seccomp (entrypoint_args->seccomp_fd, seccomp_flags, seccomp_flags_len, err);
+      ret = libcrun_apply_seccomp (entrypoint_args->seccomp_fd, entrypoint_args->seccomp_receiver_fd, seccomp_flags,
+                                   seccomp_flags_len, err);
       if (UNLIKELY (ret < 0))
         return ret;
 
       close_and_reset (&entrypoint_args->seccomp_fd);
+      close_and_reset (&entrypoint_args->seccomp_receiver_fd);
     }
 
   capabilities = def->process ? def->process->capabilities : NULL;
@@ -776,8 +781,8 @@ container_init_setup (void *args, char *
   return 0;
 }
 
-static
-int open_hooks_output (libcrun_container_t *container, int *out_fd, int *err_fd, libcrun_error_t *err)
+static int
+open_hooks_output (libcrun_container_t *container, int *out_fd, int *err_fd, libcrun_error_t *err)
 {
   const char *annotation;
 
@@ -804,8 +809,7 @@ int open_hooks_output (libcrun_container
 
 /* Entrypoint to the container.  */
 static int
-container_init (void *args, char *notify_socket, int sync_socket,
-                libcrun_error_t *err)
+container_init (void *args, char *notify_socket, int sync_socket, libcrun_error_t *err)
 {
   struct container_entrypoint_s *entrypoint_args = args;
   int ret;
@@ -879,10 +883,12 @@ container_init (void *args, char *notify
           seccomp_flags_len = def->linux->seccomp->flags_len;
         }
 
-      ret = libcrun_apply_seccomp (entrypoint_args->seccomp_fd, seccomp_flags, seccomp_flags_len, err);
+      ret = libcrun_apply_seccomp (entrypoint_args->seccomp_fd, entrypoint_args->seccomp_receiver_fd, seccomp_flags,
+                                   seccomp_flags_len, err);
       if (UNLIKELY (ret < 0))
         return ret;
       close_and_reset (&entrypoint_args->seccomp_fd);
+      close_and_reset (&entrypoint_args->seccomp_receiver_fd);
     }
 
   if (UNLIKELY (def->process == NULL))
@@ -895,11 +901,8 @@ container_init (void *args, char *notify
     {
       libcrun_container_t *container = entrypoint_args->container;
 
-      ret = do_hooks (def, 0, container->context->id, false, NULL, "starting",
-                      (hook **) def->hooks->start_container,
-                      def->hooks->start_container_len,
-                      entrypoint_args->hooks_out_fd,
-                      entrypoint_args->hooks_err_fd,
+      ret = do_hooks (def, 0, container->context->id, false, NULL, "starting", (hook **) def->hooks->start_container,
+                      def->hooks->start_container_len, entrypoint_args->hooks_out_fd, entrypoint_args->hooks_err_fd,
                       err);
       if (UNLIKELY (ret != 0))
         return ret;
@@ -919,7 +922,8 @@ container_init (void *args, char *notify
 }
 
 static int
-read_container_config_from_state (libcrun_container_t **container, const char *state_root, const char *id, libcrun_error_t *err)
+read_container_config_from_state (libcrun_container_t **container, const char *state_root, const char *id,
+                                  libcrun_error_t *err)
 {
   cleanup_free char *dir = NULL;
   cleanup_free char *config_file = NULL;
@@ -939,11 +943,8 @@ read_container_config_from_state (libcru
 }
 
 static int
-run_poststop_hooks (libcrun_context_t *context,
-                    libcrun_container_t *container,
-                    runtime_spec_schema_config_schema *def,
-                    libcrun_container_status_t *status,
-                    const char *state_root, const char *id, libcrun_error_t *err)
+run_poststop_hooks (libcrun_context_t *context, libcrun_container_t *container, runtime_spec_schema_config_schema *def,
+                    libcrun_container_status_t *status, const char *state_root, const char *id, libcrun_error_t *err)
 {
   cleanup_free libcrun_container_t *container_cleanup = NULL;
   int ret;
@@ -978,8 +979,7 @@ run_poststop_hooks (libcrun_context_t *c
       if (UNLIKELY (ret < 0))
         return ret;
 
-      ret = do_hooks (def, 0, id, true, status->bundle,
-                      "stopped", (hook **) def->hooks->poststop,
+      ret = do_hooks (def, 0, id, true, status->bundle, "stopped", (hook **) def->hooks->poststop,
                       def->hooks->poststop_len, hooks_out_fd, hooks_err_fd, err);
       if (UNLIKELY (ret < 0))
         crun_error_write_warning_and_release (context->output_handler_arg, &err);
@@ -999,15 +999,15 @@ has_new_pid_namespace (runtime_spec_sche
 
   for (i = 0; i < def->linux->namespaces_len; i++)
     {
-      if (strcmp (def->linux->namespaces[i]->type, "pid") == 0
-          && def->linux->namespaces[i]->path == NULL)
+      if (strcmp (def->linux->namespaces[i]->type, "pid") == 0 && def->linux->namespaces[i]->path == NULL)
         return true;
     }
   return false;
 }
 
 static int
-container_delete_internal (libcrun_context_t *context, runtime_spec_schema_config_schema *def, const char *id, bool force, bool only_cleanup, libcrun_error_t *err)
+container_delete_internal (libcrun_context_t *context, runtime_spec_schema_config_schema *def, const char *id,
+                           bool force, bool killall, libcrun_error_t *err)
 {
   int ret;
   cleanup_container_status libcrun_container_status_t status = {};
@@ -1026,7 +1026,7 @@ container_delete_internal (libcrun_conte
           crun_error_release (&tmp_err);
           return 0;
         }
-      goto delete;
+      return libcrun_container_delete_status (state_root, id, err);
     }
 
   if (! force)
@@ -1038,7 +1038,7 @@ container_delete_internal (libcrun_conte
         return crun_make_error (err, 0, "the container `%s` is not in 'stopped' state", id);
     }
 
-  if (!only_cleanup && !status.detached)
+  if (killall)
     {
       if (force)
         {
@@ -1056,11 +1056,13 @@ container_delete_internal (libcrun_conte
           */
           if (has_new_pid_namespace (def))
             {
-              ret = kill (status.pid, SIGKILL);
-              if (UNLIKELY (ret < 0) && errno != ESRCH)
+              ret = libcrun_kill_linux (&status, SIGKILL, err);
+              if (UNLIKELY (ret < 0))
                 {
-                  crun_make_error (err, errno, "kill cannot find process");
-                  return ret;
+                  if (crun_error_get_errno (err) != ESRCH)
+                    return ret;
+
+                  crun_error_release (err);
                 }
             }
           else if (status.cgroup_path)
@@ -1086,16 +1088,14 @@ container_delete_internal (libcrun_conte
   if (UNLIKELY (ret < 0))
     crun_error_write_warning_and_release (context->output_handler_arg, &err);
 
- delete:
-  ret = libcrun_container_delete_status (state_root, id, err);
-
-  return ret;
+  return libcrun_container_delete_status (state_root, id, err);
 }
 
 int
-libcrun_container_delete (libcrun_context_t *context, runtime_spec_schema_config_schema *def, const char *id, bool force, libcrun_error_t *err)
+libcrun_container_delete (libcrun_context_t *context, runtime_spec_schema_config_schema *def, const char *id,
+                          bool force, libcrun_error_t *err)
 {
-  return container_delete_internal (context, def, id, force, false, err);
+  return container_delete_internal (context, def, id, force, true, err);
 }
 
 int
@@ -1109,10 +1109,7 @@ libcrun_container_kill (libcrun_context_
   if (UNLIKELY (ret < 0))
     return ret;
 
-  ret = kill (status.pid, signal);
-  if (UNLIKELY (ret < 0))
-    return crun_make_error (err, errno, "kill container");
-  return 0;
+  return libcrun_kill_linux (&status, signal, err);
 }
 
 int
@@ -1133,20 +1130,20 @@ libcrun_container_kill_all (libcrun_cont
 }
 
 static int
-write_container_status (libcrun_container_t *container, libcrun_context_t *context, pid_t pid,
-                        char *cgroup_path, char *scope, char *created, libcrun_error_t *err)
+write_container_status (libcrun_container_t *container, libcrun_context_t *context, pid_t pid, char *cgroup_path,
+                        char *scope, char *created, libcrun_error_t *err)
 {
   cleanup_free char *cwd = get_current_dir_name ();
   char *external_descriptors = libcrun_get_external_descriptors (container);
-  libcrun_container_status_t status = {.pid = pid,
-                                       .cgroup_path = cgroup_path,
-                                       .scope = scope,
-                                       .rootfs = container->container_def->root->path,
-                                       .bundle = cwd,
-                                       .created = created,
-                                       .systemd_cgroup = context->systemd_cgroup,
-                                       .detached = context->detach,
-                                       .external_descriptors = external_descriptors};
+  libcrun_container_status_t status = { .pid = pid,
+                                        .cgroup_path = cgroup_path,
+                                        .scope = scope,
+                                        .rootfs = container->container_def->root->path,
+                                        .bundle = cwd,
+                                        .created = created,
+                                        .systemd_cgroup = context->systemd_cgroup,
+                                        .detached = context->detach,
+                                        .external_descriptors = external_descriptors };
   if (cwd == NULL)
     OOM ();
   return libcrun_write_container_status (context->state_root, context->id, &status, err);
@@ -1214,7 +1211,8 @@ handle_notify_socket (int notify_socketf
 }
 
 static int
-wait_for_process (pid_t pid, libcrun_context_t *context, int terminal_fd, int notify_socket, int container_ready_fd, libcrun_error_t *err)
+wait_for_process (pid_t pid, libcrun_context_t *context, int terminal_fd, int notify_socket, int container_ready_fd,
+                  int seccomp_notify_fd, const char *seccomp_notify_plugins, libcrun_error_t *err)
 {
   cleanup_close int epollfd = -1;
   cleanup_close int signalfd = -1;
@@ -1224,6 +1222,7 @@ wait_for_process (pid_t pid, libcrun_con
   int levelfds[10];
   int levelfds_len = 0;
   int fds_len = 0;
+  cleanup_seccomp_notify_context struct seccomp_notify_context_s *seccomp_notify_ctx = NULL;
 
   container_exit_code = 0;
 
@@ -1263,6 +1262,31 @@ wait_for_process (pid_t pid, libcrun_con
   if (last_process)
     return container_exit_code;
 
+  if (seccomp_notify_fd >= 0)
+    {
+      cleanup_free char *state_root = NULL;
+      cleanup_free char *oci_config_path = NULL;
+
+      struct libcrun_load_seccomp_notify_conf_s conf;
+      memset (&conf, 0, sizeof conf);
+
+      state_root = libcrun_get_state_directory (context->state_root, context->id);
+      if (UNLIKELY (state_root == NULL))
+        return crun_make_error (err, 0, "cannot get state directory");
+      xasprintf (&oci_config_path, "%s/config.json", state_root);
+
+      conf.runtime_root_path = state_root;
+      conf.name = context->id;
+      conf.bundle_path = context->bundle;
+      conf.oci_config_path = oci_config_path;
+
+      ret = libcrun_load_seccomp_notify_plugins (&seccomp_notify_ctx, seccomp_notify_plugins, &conf, err);
+      if (UNLIKELY (ret < 0))
+        return ret;
+
+      fds[fds_len++] = seccomp_notify_fd;
+    }
+
   fds[fds_len++] = signalfd;
   if (notify_socket >= 0)
     fds[fds_len++] = notify_socket;
@@ -1297,6 +1321,12 @@ wait_for_process (pid_t pid, libcrun_con
               if (UNLIKELY (ret < 0))
                 return crun_error_wrap (err, "copy to terminal fd");
             }
+          else if (events[i].data.fd == seccomp_notify_fd)
+            {
+              ret = libcrun_seccomp_notify_plugins (seccomp_notify_ctx, seccomp_notify_fd, err);
+              if (UNLIKELY (ret < 0))
+                return ret;
+            }
           else if (events[i].data.fd == terminal_fd)
             {
               ret = set_blocking_fd (terminal_fd, 0, err);
@@ -1407,7 +1437,7 @@ open_seccomp_output (const char *id, int
 
   dir = libcrun_get_state_directory (state_root, id);
   if (UNLIKELY (dir == NULL))
-        return crun_make_error (err, 0, "cannot get state directory");
+    return crun_make_error (err, 0, "cannot get state directory");
 
   xasprintf (&dest_path, "%s/seccomp.bpf", dir);
 
@@ -1436,7 +1466,8 @@ open_seccomp_output (const char *id, int
 
 /* Find the uid:gid that is mapped to root inside the container user namespace.  */
 static void
-get_root_in_the_userns_for_cgroups (runtime_spec_schema_config_schema *def, uid_t host_uid, gid_t host_gid, uid_t *uid, gid_t *gid)
+get_root_in_the_userns_for_cgroups (runtime_spec_schema_config_schema *def, uid_t host_uid, gid_t host_gid, uid_t *uid,
+                                    gid_t *gid)
 {
   *uid = -1;
   *gid = -1;
@@ -1473,8 +1504,8 @@ get_root_in_the_userns_for_cgroups (runt
     *uid = *gid = -1;
 }
 
-static
-const char *find_systemd_subgroup (libcrun_container_t *container, int cgroup_mode)
+static const char *
+find_systemd_subgroup (libcrun_container_t *container, int cgroup_mode)
 {
   const char *annotation;
 
@@ -1493,7 +1524,48 @@ const char *find_systemd_subgroup (libcr
 }
 
 static int
-libcrun_container_run_internal (libcrun_container_t *container, libcrun_context_t *context, int container_ready_fd, libcrun_error_t *err)
+get_seccomp_receiver_fd (libcrun_container_t *container, int *fd, int *self_receiver_fd, const char **plugins,
+                         libcrun_error_t *err)
+{
+  const char *tmp;
+
+  *fd = -1;
+  *self_receiver_fd = -1;
+
+  tmp = find_annotation (container, "run.oci.seccomp.plugins");
+  if (tmp)
+    {
+      int fds[2];
+      int ret;
+
+      ret = create_socket_pair (fds, err);
+      if (UNLIKELY (ret < 0))
+        return crun_error_wrap (err, "create socket pair");
+
+      *fd = fds[0];
+      *self_receiver_fd = fds[1];
+      *plugins = tmp;
+    }
+
+  tmp = find_annotation (container, "run.oci.seccomp.receiver");
+  if (tmp == NULL)
+    tmp = getenv ("RUN_OCI_SECCOMP_RECEIVER");
+  if (tmp)
+    {
+      if (tmp[0] != '/')
+        return crun_make_error (err, 0, "the seccomp receiver `%s` is not an absolute path", tmp);
+
+      *fd = open_unix_domain_client_socket (tmp, 0, err);
+      if (UNLIKELY (*fd < 0))
+        return crun_error_wrap (err, "open seccomp receiver");
+    }
+
+  return 0;
+}
+
+static int
+libcrun_container_run_internal (libcrun_container_t *container, libcrun_context_t *context, int container_ready_fd,
+                                libcrun_error_t *err)
 {
   runtime_spec_schema_config_schema *def = container->container_def;
   int ret;
@@ -1511,25 +1583,26 @@ libcrun_container_run_internal (libcrun_
   cleanup_close int console_socket_fd = -1;
   cleanup_close int hooks_out_fd = -1;
   cleanup_close int hooks_err_fd = -1;
+  cleanup_close int own_seccomp_receiver_fd = -1;
+  cleanup_close int seccomp_notify_fd = -1;
+  const char *seccomp_notify_plugins = NULL;
   int cgroup_mode, cgroup_manager;
   char created[35];
   uid_t root_uid = -1;
   gid_t root_gid = -1;
-  struct container_entrypoint_s container_args =
-    {
-      .container = container,
-      .context = context,
-      .terminal_socketpair = {-1, -1},
-      .console_socket_fd = -1,
-      .hooks_out_fd = -1,
-      .hooks_err_fd = -1,
-    };
+  struct container_entrypoint_s container_args = {
+    .container = container,
+    .context = context,
+    .terminal_socketpair = { -1, -1 },
+    .console_socket_fd = -1,
+    .hooks_out_fd = -1,
+    .hooks_err_fd = -1,
+    .seccomp_receiver_fd = -1,
+  };
 
-  if (def->hooks && (def->hooks->prestart_len
-                     || def->hooks->poststart_len
-                     || def->hooks->create_runtime_len
-                     || def->hooks->create_container_len
-                     || def->hooks->start_container_len))
+  if (def->hooks
+      && (def->hooks->prestart_len || def->hooks->poststart_len || def->hooks->create_runtime_len
+          || def->hooks->create_container_len || def->hooks->start_container_len))
     {
       ret = open_hooks_output (container, &hooks_out_fd, &hooks_err_fd, err);
       if (UNLIKELY (ret < 0))
@@ -1540,21 +1613,21 @@ libcrun_container_run_internal (libcrun_
 
   container->context = context;
 
-  if (!detach || context->notify_socket)
+  if (! detach || context->notify_socket)
     {
       ret = prctl (PR_SET_CHILD_SUBREAPER, 1, 0, 0, 0);
       if (UNLIKELY (ret < 0))
         return crun_make_error (err, errno, "set child subreaper");
     }
 
-  if (!context->no_new_keyring)
+  if (! context->no_new_keyring)
     {
       ret = libcrun_create_keyring (container->context->id, err);
       if (UNLIKELY (ret < 0))
         return ret;
     }
 
-  if (def->process && def->process->terminal && !detach && context->console_socket == NULL)
+  if (def->process && def->process->terminal && ! detach && context->console_socket == NULL)
     {
       container_args.has_terminal_socket_pair = 1;
       ret = create_socket_pair (container_args.terminal_socketpair, err);
@@ -1577,6 +1650,14 @@ libcrun_container_run_internal (libcrun_
     }
   container_args.seccomp_fd = seccomp_fd;
 
+  if (seccomp_fd >= 0)
+    {
+      ret = get_seccomp_receiver_fd (container, &container_args.seccomp_receiver_fd, &own_seccomp_receiver_fd,
+                                     &seccomp_notify_plugins, err);
+      if (UNLIKELY (ret < 0))
+        return ret;
+    }
+
   if (context->console_socket)
     {
       console_socket_fd = open_unix_domain_client_socket (context->console_socket, 0, err);
@@ -1589,8 +1670,7 @@ libcrun_container_run_internal (libcrun_
   if (cgroup_mode < 0)
     return cgroup_mode;
 
-  pid = libcrun_run_linux_container (container, container_init, &container_args,
-                                     &sync_socket, err);
+  pid = libcrun_run_linux_container (container, container_init, &container_args, &sync_socket, err);
   if (UNLIKELY (pid < 0))
     return pid;
 
@@ -1611,25 +1691,25 @@ libcrun_container_run_internal (libcrun_
   else if (context->force_no_cgroup)
     cgroup_manager = CGROUP_MANAGER_DISABLED;
 
-  /* If we are root (either on the host or in a namespace), then chown the cgroup to root in the container user namespace.  */
+  /* If we are root (either on the host or in a namespace), then chown the cgroup to root in the container user
+   * namespace.  */
   get_root_in_the_userns_for_cgroups (def, container->host_uid, container->host_gid, &root_uid, &root_gid);
 
   {
-    struct libcrun_cgroup_args cg =
-      {
-       .resources = def->linux ? def->linux->resources : NULL,
-       .annotations = def->annotations,
-       .cgroup_mode = cgroup_mode,
-       .path = &cgroup_path,
-       .scope = &scope,
-       .cgroup_path = def->linux ? def->linux->cgroups_path : "",
-       .manager = cgroup_manager,
-       .pid = pid,
-       .root_uid = root_uid,
-       .root_gid = root_gid,
-       .id = context->id,
-       .systemd_subgroup = find_systemd_subgroup (container, cgroup_mode),
-      };
+    struct libcrun_cgroup_args cg = {
+      .resources = def->linux ? def->linux->resources : NULL,
+      .annotations = def->annotations,
+      .cgroup_mode = cgroup_mode,
+      .path = &cgroup_path,
+      .scope = &scope,
+      .cgroup_path = def->linux ? def->linux->cgroups_path : "",
+      .manager = cgroup_manager,
+      .pid = pid,
+      .root_uid = root_uid,
+      .root_gid = root_gid,
+      .id = context->id,
+      .systemd_subgroup = find_systemd_subgroup (container, cgroup_mode),
+    };
 
     ret = libcrun_cgroup_enter (&cg, err);
     if (UNLIKELY (ret < 0))
@@ -1637,9 +1717,7 @@ libcrun_container_run_internal (libcrun_
 
     if (def->linux && def->linux->resources)
       {
-        ret = libcrun_update_cgroup_resources (cgroup_mode,
-                                               def->linux->resources,
-                                               cgroup_path, err);
+        ret = libcrun_update_cgroup_resources (cgroup_mode, def->linux->resources, cgroup_path, err);
         if (UNLIKELY (ret < 0))
           return cleanup_watch (context, pid, sync_socket, terminal_fd, err);
       }
@@ -1659,16 +1737,14 @@ libcrun_container_run_internal (libcrun_
      prestart hooks.  */
   if (def->hooks && def->hooks->prestart_len)
     {
-      ret = do_hooks (def, pid, context->id, false, NULL, "created",
-                      (hook **) def->hooks->prestart,
+      ret = do_hooks (def, pid, context->id, false, NULL, "created", (hook **) def->hooks->prestart,
                       def->hooks->prestart_len, hooks_out_fd, hooks_err_fd, err);
       if (UNLIKELY (ret != 0))
         return cleanup_watch (context, pid, sync_socket, terminal_fd, err);
     }
   if (def->hooks && def->hooks->create_runtime_len)
     {
-      ret = do_hooks (def, pid, context->id, false, NULL, "created",
-                      (hook **) def->hooks->create_runtime,
+      ret = do_hooks (def, pid, context->id, false, NULL, "created", (hook **) def->hooks->create_runtime,
                       def->hooks->create_runtime_len, hooks_out_fd, hooks_err_fd, err);
       if (UNLIKELY (ret != 0))
         return cleanup_watch (context, pid, sync_socket, terminal_fd, err);
@@ -1694,7 +1770,7 @@ libcrun_container_run_internal (libcrun_
   if (UNLIKELY (ret < 0))
     return cleanup_watch (context, pid, sync_socket, terminal_fd, err);
 
-  if (def->process && def->process->terminal && !detach && context->console_socket == NULL)
+  if (def->process && def->process->terminal && ! detach && context->console_socket == NULL)
     {
       terminal_fd = receive_fd_from_socket (socket_pair_0, err);
       if (UNLIKELY (terminal_fd < 0))
@@ -1702,7 +1778,7 @@ libcrun_container_run_internal (libcrun_
 
       close_and_reset (&socket_pair_0);
 
-      ret = libcrun_setup_terminal_master (terminal_fd, &orig_terminal, err);
+      ret = libcrun_setup_terminal_ptmx (terminal_fd, &orig_terminal, err);
       if (UNLIKELY (ret < 0))
         return cleanup_watch (context, pid, sync_socket, terminal_fd, err);
     }
@@ -1725,25 +1801,38 @@ libcrun_container_run_internal (libcrun_
      hooks will be executed as part of the start command.  */
   if (context->fifo_exec_wait_fd < 0 && def->hooks && def->hooks->poststart_len)
     {
-      ret = do_hooks (def, pid, context->id, true, NULL, "running",
-                      (hook **) def->hooks->poststart,
+      ret = do_hooks (def, pid, context->id, true, NULL, "running", (hook **) def->hooks->poststart,
                       def->hooks->poststart_len, hooks_out_fd, hooks_err_fd, err);
       if (UNLIKELY (ret < 0))
         return cleanup_watch (context, pid, sync_socket, terminal_fd, err);
     }
 
-  ret = wait_for_process (pid, context, terminal_fd, notify_socket, container_ready_fd, err);
-  if (!context->detach)
+  /* Let's receive the seccomp notify fd and handle it as part of wait_for_process().  */
+  if (own_seccomp_receiver_fd >= 0)
     {
-      cleanup_watch (context, 0, sync_socket, terminal_fd, err);
-      crun_error_release (err);
+      seccomp_notify_fd = receive_fd_from_socket (own_seccomp_receiver_fd, err);
+      if (UNLIKELY (seccomp_notify_fd < 0))
+        return cleanup_watch (context, pid, sync_socket, terminal_fd, err);
+
+      ret = close_and_reset (&own_seccomp_receiver_fd);
+      if (UNLIKELY (ret < 0))
+        return cleanup_watch (context, pid, sync_socket, terminal_fd, err);
+    }
+
+  ret = wait_for_process (pid, context, terminal_fd, notify_socket, container_ready_fd, seccomp_notify_fd,
+                          seccomp_notify_plugins, err);
+  if (! context->detach)
+    {
+      libcrun_error_t tmp_err = NULL;
+      cleanup_watch (context, 0, sync_socket, terminal_fd, &tmp_err);
+      crun_error_release (&tmp_err);
     }
 
   return ret;
 }
 
-static
-int check_config_file (runtime_spec_schema_config_schema *def, libcrun_error_t *err)
+static int
+check_config_file (runtime_spec_schema_config_schema *def, libcrun_error_t *err)
 {
   if (UNLIKELY (def->root == NULL))
     return crun_make_error (err, 0, "invalid config file, no 'root' block specified");
@@ -1754,11 +1843,10 @@ int check_config_file (runtime_spec_sche
   return 0;
 }
 
-static
-int libcrun_copy_config_file (const char *id, const char *state_root, const char *bundle, libcrun_error_t *err)
+static int
+libcrun_copy_config_file (const char *id, const char *state_root, const char *config_file, libcrun_error_t *err)
 {
   int ret;
-  cleanup_free char *src_path = NULL;
   cleanup_free char *dest_path = NULL;
   cleanup_free char *dir = NULL;
   cleanup_free char *buffer = NULL;
@@ -1766,12 +1854,11 @@ int libcrun_copy_config_file (const char
 
   dir = libcrun_get_state_directory (state_root, id);
   if (UNLIKELY (dir == NULL))
-        return crun_make_error (err, 0, "cannot get state directory");
+    return crun_make_error (err, 0, "cannot get state directory");
 
-  xasprintf (&src_path, "%s/config.json", bundle);
   xasprintf (&dest_path, "%s/config.json", dir);
 
-  ret = read_all_file (src_path, &buffer, &len, err);
+  ret = read_all_file (config_file, &buffer, &len, err);
   if (UNLIKELY (ret < 0))
     return ret;
 
@@ -1786,12 +1873,13 @@ static void
 force_delete_container_status (libcrun_context_t *context, runtime_spec_schema_config_schema *def)
 {
   libcrun_error_t tmp_err = NULL;
-  container_delete_internal (context, def, context->id, 1, true, &tmp_err);
+  container_delete_internal (context, def, context->id, true, false, &tmp_err);
   crun_error_release (&tmp_err);
 }
 
 int
-libcrun_container_run (libcrun_context_t *context, libcrun_container_t *container, unsigned int options, libcrun_error_t *err)
+libcrun_container_run (libcrun_context_t *context, libcrun_container_t *container, unsigned int options,
+                       libcrun_error_t *err)
 {
   runtime_spec_schema_config_schema *def = container->container_def;
   int ret;
@@ -1816,9 +1904,9 @@ libcrun_container_run (libcrun_context_t
   if (UNLIKELY (ret < 0))
     return ret;
 
-  if (!detach && (options & LIBCRUN_RUN_OPTIONS_PREFORK) == 0)
+  if (! detach && (options & LIBCRUN_RUN_OPTIONS_PREFORK) == 0)
     {
-      ret = libcrun_copy_config_file (context->id, context->state_root, context->bundle, err);
+      ret = libcrun_copy_config_file (context->id, context->state_root, context->config_file, err);
       if (UNLIKELY (ret < 0))
         return ret;
 
@@ -1859,7 +1947,7 @@ libcrun_container_run (libcrun_context_t
             return ret;
           buf[ret] = '\0';
 
-          return crun_make_error (err, errno_, buf);
+          return crun_make_error (err, errno_, "%s", buf);
         }
 
       return status;
@@ -1872,7 +1960,7 @@ libcrun_container_run (libcrun_context_t
   if (UNLIKELY (ret < 0))
     libcrun_fail_with_error (errno, "detach process");
 
-  ret = libcrun_copy_config_file (context->id, context->state_root, context->bundle, err);
+  ret = libcrun_copy_config_file (context->id, context->state_root, context->config_file, err);
   if (UNLIKELY (ret < 0))
     return ret;
 
@@ -1888,7 +1976,8 @@ libcrun_container_run (libcrun_context_t
 }
 
 int
-libcrun_container_create (libcrun_context_t *context, libcrun_container_t *container, unsigned int options, libcrun_error_t *err)
+libcrun_container_create (libcrun_context_t *context, libcrun_container_t *container, unsigned int options,
+                          libcrun_error_t *err)
 {
   runtime_spec_schema_config_schema *def = container->container_def;
   int ret;
@@ -1923,7 +2012,7 @@ libcrun_container_create (libcrun_contex
 
   if ((options & LIBCRUN_RUN_OPTIONS_PREFORK) == 0)
     {
-      ret = libcrun_copy_config_file (context->id, context->state_root, context->bundle, err);
+      ret = libcrun_copy_config_file (context->id, context->state_root, context->config_file, err);
       if (UNLIKELY (ret < 0))
         return ret;
       ret = libcrun_container_run_internal (container, context, -1, err);
@@ -2003,7 +2092,7 @@ libcrun_container_start (libcrun_context
   if (UNLIKELY (ret < 0))
     return ret;
 
-  if (!ret)
+  if (! ret)
     return crun_make_error (err, 0, "container `%s` is not running", id);
 
   ret = read_container_config_from_state (&container, state_root, id, err);
@@ -2032,8 +2121,8 @@ libcrun_container_start (libcrun_context
           while (1)
             {
               struct timeval timeout = {
-                                        .tv_sec = 0,
-                                        .tv_usec = 10000,
+                .tv_sec = 0,
+                .tv_usec = 10000,
               };
               FD_ZERO (&read_set);
               FD_SET (fd, &read_set);
@@ -2054,7 +2143,7 @@ libcrun_container_start (libcrun_context
                   ret = libcrun_is_container_running (&status, err);
                   if (UNLIKELY (ret < 0))
                     return ret;
-                  if (!ret)
+                  if (! ret)
                     return 0;
                 }
             }
@@ -2072,19 +2161,18 @@ libcrun_container_start (libcrun_context
       if (UNLIKELY (ret < 0))
         return ret;
 
-      ret = do_hooks (def, status.pid, context->id, true, status.bundle, "running",
-                      (hook **) def->hooks->poststart,
+      ret = do_hooks (def, status.pid, context->id, true, status.bundle, "running", (hook **) def->hooks->poststart,
                       def->hooks->poststart_len, hooks_out_fd, hooks_err_fd, err);
       if (UNLIKELY (ret < 0))
         crun_error_release (err);
     }
 
-
   return 0;
 }
 
 int
-libcrun_get_container_state_string (const char *id, libcrun_container_status_t *status, const char *state_root, const char **container_status, int *running, libcrun_error_t *err)
+libcrun_get_container_state_string (const char *id, libcrun_container_status_t *status, const char *state_root,
+                                    const char **container_status, int *running, libcrun_error_t *err)
 {
   int ret, has_fifo = 0;
   bool paused = false;
@@ -2102,7 +2190,7 @@ libcrun_get_container_state_string (cons
       has_fifo = ret;
     }
 
-  if (*running && !has_fifo)
+  if (*running && ! has_fifo)
     {
       int cgroup_mode;
 
@@ -2112,7 +2200,17 @@ libcrun_get_container_state_string (cons
 
       ret = libcrun_cgroup_is_container_paused (status->cgroup_path, cgroup_mode, &paused, err);
       if (UNLIKELY (ret < 0))
-        return ret;
+        {
+          /* The cgroup might have been cleaned up by systemd by the time we try to read it, so ignore ENOENT.  */
+          if (status->systemd_cgroup && crun_error_get_errno (err) == ENOENT)
+            {
+              crun_error_release (err);
+              *container_status = "stopped";
+              return 0;
+            }
+
+          return ret;
+        }
     }
 
   if (! *running)
@@ -2188,12 +2286,18 @@ libcrun_container_state (libcrun_context
 
     dir = libcrun_get_state_directory (state_root, id);
     if (UNLIKELY (dir == NULL))
-      return crun_make_error (err, 0, "cannot get state directory");
+      {
+        ret = crun_make_error (err, 0, "cannot get state directory");
+        goto exit;
+      }
 
     xasprintf (&config_file, "%s/config.json", dir);
     container = libcrun_container_load_from_file (config_file, err);
     if (UNLIKELY (container == NULL))
-      return crun_make_error (err, 0, "error loading config.json");
+      {
+        ret = crun_make_error (err, 0, "error loading config.json");
+        goto exit;
+      }
 
     if (container->container_def->annotations && container->container_def->annotations->len)
       {
@@ -2208,7 +2312,7 @@ libcrun_container_state (libcrun_context
           }
         yajl_gen_map_close (gen);
       }
-   free_runtime_spec_schema_config_schema (container->container_def);
+    free_runtime_spec_schema_config_schema (container->container_def);
   }
 
   yajl_gen_map_close (gen);
@@ -2217,7 +2321,7 @@ libcrun_container_state (libcrun_context
 
   fprintf (out, "%s\n", buf);
 
- exit:
+exit:
   if (gen)
     yajl_gen_free (gen);
   libcrun_free_container_status (&status);
@@ -2225,7 +2329,8 @@ libcrun_container_state (libcrun_context
 }
 
 int
-libcrun_container_exec (libcrun_context_t *context, const char *id, runtime_spec_schema_config_schema_process *process, libcrun_error_t *err)
+libcrun_container_exec (libcrun_context_t *context, const char *id, runtime_spec_schema_config_schema_process *process,
+                        libcrun_error_t *err)
 {
   int ret;
   pid_t pid;
@@ -2241,6 +2346,10 @@ libcrun_container_exec (libcrun_context_
   int container_ret_status[2];
   cleanup_close int pipefd0 = -1;
   cleanup_close int pipefd1 = -1;
+  cleanup_close int seccomp_receiver_fd = -1;
+  cleanup_close int own_seccomp_receiver_fd = -1;
+  cleanup_close int seccomp_notify_fd = -1;
+  const char *seccomp_notify_plugins = NULL;
   char b;
 
   ret = libcrun_read_container_status (&status, state_root, id, err);
@@ -2271,6 +2380,14 @@ libcrun_container_exec (libcrun_context_
   if (UNLIKELY (ret < 0))
     return ret;
 
+  if (seccomp_fd >= 0)
+    {
+      ret = get_seccomp_receiver_fd (container, &seccomp_receiver_fd, &own_seccomp_receiver_fd, &seccomp_notify_plugins,
+                                     err);
+      if (UNLIKELY (ret < 0))
+        return ret;
+    }
+
   /* This must be done before we enter a user namespace.  */
   ret = libcrun_set_rlimits (process->rlimits, process->rlimits_len, err);
   if (UNLIKELY (ret < 0))
@@ -2287,17 +2404,18 @@ libcrun_container_exec (libcrun_context_
   if (container->container_def->process)
     {
       if (process->selinux_label == NULL && container->container_def->process->selinux_label)
-	process->selinux_label = xstrdup (container->container_def->process->selinux_label);
+        process->selinux_label = xstrdup (container->container_def->process->selinux_label);
 
       if (process->apparmor_profile == NULL && container->container_def->process->apparmor_profile)
-	process->apparmor_profile = xstrdup (container->container_def->process->apparmor_profile);
+        process->apparmor_profile = xstrdup (container->container_def->process->apparmor_profile);
     }
 
   ret = initialize_security (process, err);
   if (UNLIKELY (ret < 0))
     return ret;
 
-  pid = libcrun_join_process (container, status.pid, &status, context->detach, process->terminal ? &terminal_fd : NULL, err);
+  pid = libcrun_join_process (container, status.pid, &status, context->detach, process->terminal ? &terminal_fd : NULL,
+                              err);
   if (UNLIKELY (pid < 0))
     return pid;
 
@@ -2331,7 +2449,7 @@ libcrun_container_exec (libcrun_context_
         {
           for (i = 0; i < process->env_len; i++)
             if (putenv (process->env[i]) < 0)
-              libcrun_fail_with_error ( errno, "putenv `%s`", process->env[i]);
+              libcrun_fail_with_error (errno, "putenv `%s`", process->env[i]);
         }
       else if (container->container_def->process->env_len)
         {
@@ -2341,7 +2459,7 @@ libcrun_container_exec (libcrun_context_
             {
               e = container->container_def->process->env[i];
               if (putenv (e) < 0)
-                libcrun_fail_with_error ( errno, "putenv `%s`", e);
+                libcrun_fail_with_error (errno, "putenv `%s`", e);
             }
         }
 
@@ -2350,7 +2468,7 @@ libcrun_container_exec (libcrun_context_
           ret = set_home_env (container->container_uid);
           if (UNLIKELY (ret < 0 && errno != ENOTSUP))
             {
-              setenv("HOME", "/", 1);
+              setenv ("HOME", "/", 1);
               libcrun_warning ("cannot detect HOME environment variable, setting default");
             }
         }
@@ -2371,7 +2489,7 @@ libcrun_container_exec (libcrun_context_
       if (UNLIKELY (exec_path == NULL))
         {
           if (errno == ENOENT)
-            crun_make_error (err, errno, "executable file not found in $PATH");
+            crun_make_error (err, errno, "executable file `%s` not found in $PATH", process->args[0]);
           else
             crun_make_error (err, errno, "open executable");
 
@@ -2385,12 +2503,13 @@ libcrun_container_exec (libcrun_context_
             return ret;
         }
 
-      if (!process->no_new_privileges)
+      if (! process->no_new_privileges)
         {
-          ret = libcrun_apply_seccomp (seccomp_fd, seccomp_flags, seccomp_flags_len, err);
+          ret = libcrun_apply_seccomp (seccomp_fd, seccomp_receiver_fd, seccomp_flags, seccomp_flags_len, err);
           if (UNLIKELY (ret < 0))
             return ret;
           close_and_reset (&seccomp_fd);
+          close_and_reset (&seccomp_receiver_fd);
         }
 
       ret = libcrun_container_setgroups (container, err);
@@ -2415,10 +2534,11 @@ libcrun_container_exec (libcrun_context_
 
       if (process->no_new_privileges)
         {
-          ret = libcrun_apply_seccomp (seccomp_fd, seccomp_flags, seccomp_flags_len, err);
+          ret = libcrun_apply_seccomp (seccomp_fd, seccomp_receiver_fd, seccomp_flags, seccomp_flags_len, err);
           if (UNLIKELY (ret < 0))
             return ret;
           close_and_reset (&seccomp_fd);
+          close_and_reset (&seccomp_receiver_fd);
         }
 
       if (process->user)
@@ -2466,7 +2586,7 @@ libcrun_container_exec (libcrun_context_
         }
       else
         {
-          ret = libcrun_setup_terminal_master (terminal_fd, &orig_terminal, err);
+          ret = libcrun_setup_terminal_ptmx (terminal_fd, &orig_terminal, err);
           if (UNLIKELY (ret < 0))
             {
               flush_fd_to_err (context, terminal_fd);
@@ -2481,7 +2601,20 @@ libcrun_container_exec (libcrun_context_
   if (b != '0')
     ret = -1;
   else
-    ret = wait_for_process (pid, context, terminal_fd, -1, -1, err);
+    {
+      /* Let's receive the seccomp notify fd and handle it as part of wait_for_process().  */
+      if (own_seccomp_receiver_fd >= 0)
+        {
+          seccomp_notify_fd = receive_fd_from_socket (own_seccomp_receiver_fd, err);
+          if (UNLIKELY (seccomp_notify_fd < 0))
+            return seccomp_notify_fd;
+
+          ret = close_and_reset (&own_seccomp_receiver_fd);
+          if (UNLIKELY (ret < 0))
+            return ret;
+        }
+      ret = wait_for_process (pid, context, terminal_fd, -1, -1, seccomp_notify_fd, seccomp_notify_plugins, err);
+    }
 
   flush_fd_to_err (context, terminal_fd);
   return ret;
@@ -2493,7 +2626,7 @@ libcrun_container_exec_process_file (lib
   int ret;
   size_t len;
   cleanup_free char *content = NULL;
-  struct parser_context ctx = {0, stderr};
+  struct parser_context ctx = { 0, stderr };
   yajl_val tree = NULL;
   parser_error parser_err = NULL;
   runtime_spec_schema_config_schema_process *process = NULL;
@@ -2507,15 +2640,11 @@ libcrun_container_exec_process_file (lib
     return ret;
 
   process = make_runtime_spec_schema_config_schema_process (tree, &ctx, &parser_err);
-  if (UNLIKELY (process == NULL))
-    {
-      ret = crun_make_error (err, errno, "cannot parse process file");
-      goto exit;
-    }
-
-  ret = libcrun_container_exec (context, id, process, err);
+  if (LIKELY (process != NULL))
+    ret = libcrun_container_exec (context, id, process, err);
+  else
+    ret = crun_make_error (err, errno, "cannot parse process file");
 
- exit:
   free (parser_err);
 
   if (tree)
@@ -2528,7 +2657,8 @@ libcrun_container_exec_process_file (lib
 }
 
 int
-libcrun_container_update (libcrun_context_t *context, const char *id, const char *content, size_t len, libcrun_error_t *err)
+libcrun_container_update (libcrun_context_t *context, const char *id, const char *content, size_t len,
+                          libcrun_error_t *err)
 {
   int ret;
   libcrun_container_status_t status = {};
@@ -2541,7 +2671,6 @@ libcrun_container_update (libcrun_contex
   return libcrun_linux_container_update (&status, content, len, err);
 }
 
-
 int
 libcrun_container_update_from_file (libcrun_context_t *context, const char *id, const char *file, libcrun_error_t *err)
 {
@@ -2603,8 +2732,7 @@ libcrun_container_unpause (libcrun_conte
 }
 
 int
-libcrun_container_checkpoint (libcrun_context_t *context, const char *id,
-                              libcrun_checkpoint_restore_t *cr_options,
+libcrun_container_checkpoint (libcrun_context_t *context, const char *id, libcrun_checkpoint_restore_t *cr_options,
                               libcrun_error_t *err)
 {
   int ret;
@@ -2620,26 +2748,23 @@ libcrun_container_checkpoint (libcrun_co
   if (UNLIKELY (ret < 0))
     return ret;
   if (ret == 0)
-    return crun_make_error (err, errno, "the container `%s` is not running",
-                            id);
+    return crun_make_error (err, errno, "the container `%s` is not running", id);
 
   ret = read_container_config_from_state (&container, state_root, id, err);
   if (UNLIKELY (ret < 0))
     return ret;
-  ret = libcrun_container_checkpoint_linux (&status, container, cr_options,
-                                            err);
+  ret = libcrun_container_checkpoint_linux (&status, container, cr_options, err);
   if (UNLIKELY (ret < 0))
     return ret;
 
-  if (!cr_options->leave_running)
+  if (! cr_options->leave_running)
     return container_delete_internal (context, NULL, id, true, true, err);
 
   return 0;
 }
 
 int
-libcrun_container_restore (libcrun_context_t *context, const char *id,
-                           libcrun_checkpoint_restore_t *cr_options,
+libcrun_container_restore (libcrun_context_t *context, const char *id, libcrun_checkpoint_restore_t *cr_options,
                            libcrun_error_t *err)
 {
   cleanup_free libcrun_container_t *container = NULL;
@@ -2671,12 +2796,12 @@ libcrun_container_restore (libcrun_conte
   if (UNLIKELY (ret < 0))
     return ret;
 
-  ret = libcrun_copy_config_file (context->id, context->state_root, context->bundle, err);
+  ret = libcrun_copy_config_file (context->id, context->state_root, context->config_file, err);
   if (UNLIKELY (ret < 0))
     return ret;
 
   /* The CRIU restore code uses bundle and rootfs of status. */
-  status.bundle = (char *)context->bundle;
+  status.bundle = (char *) context->bundle;
   status.rootfs = def->root->path;
 
   ret = libcrun_container_restore_linux (&status, container, cr_options, err);
@@ -2699,26 +2824,23 @@ libcrun_container_restore (libcrun_conte
 
   /* If we are root (either on the host or in a namespace),
    * then chown the cgroup to root in the container user namespace. */
-  get_root_in_the_userns_for_cgroups (def, container->host_uid,
-                                      container->host_gid, &root_uid,
-                                      &root_gid);
+  get_root_in_the_userns_for_cgroups (def, container->host_uid, container->host_gid, &root_uid, &root_gid);
 
   {
-    struct libcrun_cgroup_args cg =
-      {
-       .resources = def->linux ? def->linux->resources : NULL,
-       .annotations = def->annotations,
-       .cgroup_mode = cgroup_mode,
-       .scope = &scope,
-       .path = &cgroup_path,
-       .cgroup_path = def->linux ? def->linux->cgroups_path : "",
-       .manager = cgroup_manager,
-       .pid = status.pid,
-       .root_uid = root_uid,
-       .root_gid = root_gid,
-       .id = context->id,
-       .systemd_subgroup = find_systemd_subgroup (container, cgroup_mode),
-      };
+    struct libcrun_cgroup_args cg = {
+      .resources = def->linux ? def->linux->resources : NULL,
+      .annotations = def->annotations,
+      .cgroup_mode = cgroup_mode,
+      .scope = &scope,
+      .path = &cgroup_path,
+      .cgroup_path = def->linux ? def->linux->cgroups_path : "",
+      .manager = cgroup_manager,
+      .pid = status.pid,
+      .root_uid = root_uid,
+      .root_gid = root_gid,
+      .id = context->id,
+      .systemd_subgroup = find_systemd_subgroup (container, cgroup_mode),
+    };
 
     ret = libcrun_cgroup_enter (&cg, err);
     if (UNLIKELY (ret < 0))
@@ -2726,9 +2848,7 @@ libcrun_container_restore (libcrun_conte
 
     if (def->linux && def->linux->resources)
       {
-        ret = libcrun_update_cgroup_resources (cgroup_mode,
-                                               def->linux->resources,
-                                               cgroup_path, err);
+        ret = libcrun_update_cgroup_resources (cgroup_mode, def->linux->resources, cgroup_path, err);
         if (UNLIKELY (ret < 0))
           return ret;
       }
@@ -2736,9 +2856,7 @@ libcrun_container_restore (libcrun_conte
 
   get_current_timestamp (created);
   context->detach = cr_options->detach;
-  ret = write_container_status (container, context, status.pid,
-                                cgroup_path, scope,
-                                created, err);
+  ret = write_container_status (container, context, status.pid, cgroup_path, scope, created, err);
   if (UNLIKELY (ret < 0))
     return ret;
 
@@ -2751,14 +2869,12 @@ libcrun_container_restore (libcrun_conte
         return ret;
     }
 
-  if (!cr_options->detach)
+  if (! cr_options->detach)
     {
       int wait_status;
       ret = waitpid (status.pid, &wait_status, 0);
       if (UNLIKELY (ret < 0))
-        return crun_make_error (err, errno,
-                                "waitpid failed for container '%s' with %d",
-                                id, ret);
+        return crun_make_error (err, errno, "waitpid failed for container '%s' with %d", id, ret);
 
       if (WEXITSTATUS (wait_status))
         return WEXITSTATUS (wait_status);
diff -pruN 0.14.1+dfsg-1/src/libcrun/container.h 0.15+dfsg-1/src/libcrun/container.h
--- 0.14.1+dfsg-1/src/libcrun/container.h	2020-07-03 19:38:11.000000000 +0000
+++ 0.15+dfsg-1/src/libcrun/container.h	2020-09-03 11:43:25.000000000 +0000
@@ -17,17 +17,18 @@
  */
 
 #ifndef CONTAINER_H
-# define CONTAINER_H
+#define CONTAINER_H
 
-# include <config.h>
-# include <runtime_spec_schema_config_schema.h>
-# include "error.h"
+#include <config.h>
+#include <runtime_spec_schema_config_schema.h>
+#include "error.h"
 
 struct libcrun_context_s
 {
   const char *state_root;
   const char *id;
   const char *bundle;
+  const char *config_file;
   const char *console_socket;
   const char *pid_file;
   const char *notify_socket;
@@ -47,9 +48,9 @@ struct libcrun_context_s
 };
 
 enum
-  {
-    LIBCRUN_RUN_OPTIONS_PREFORK = 1 << 0,
-  };
+{
+  LIBCRUN_RUN_OPTIONS_PREFORK = 1 << 0,
+};
 
 struct libcrun_container_s
 {
@@ -88,29 +89,41 @@ LIBCRUN_PUBLIC libcrun_container_t *libc
 
 LIBCRUN_PUBLIC libcrun_container_t *libcrun_container_load_from_memory (const char *json, libcrun_error_t *err);
 
-LIBCRUN_PUBLIC int libcrun_container_run (libcrun_context_t *context, libcrun_container_t *container, unsigned int options, libcrun_error_t *error);
+LIBCRUN_PUBLIC int libcrun_container_run (libcrun_context_t *context, libcrun_container_t *container,
+                                          unsigned int options, libcrun_error_t *error);
 
-LIBCRUN_PUBLIC int libcrun_container_delete (libcrun_context_t *context, runtime_spec_schema_config_schema *def, const char *id, bool force, libcrun_error_t *err);
+LIBCRUN_PUBLIC int libcrun_container_delete (libcrun_context_t *context, runtime_spec_schema_config_schema *def,
+                                             const char *id, bool force, libcrun_error_t *err);
 
-LIBCRUN_PUBLIC int libcrun_container_kill (libcrun_context_t *context, const char *id, int signal, libcrun_error_t *err);
+LIBCRUN_PUBLIC int libcrun_container_kill (libcrun_context_t *context, const char *id, int signal,
+                                           libcrun_error_t *err);
 
-LIBCRUN_PUBLIC int libcrun_container_kill_all (libcrun_context_t *context, const char *id, int signal, libcrun_error_t *err);
+LIBCRUN_PUBLIC int libcrun_container_kill_all (libcrun_context_t *context, const char *id, int signal,
+                                               libcrun_error_t *err);
 
-LIBCRUN_PUBLIC int libcrun_container_create (libcrun_context_t *context, libcrun_container_t *container, unsigned int options, libcrun_error_t *err);
+LIBCRUN_PUBLIC int libcrun_container_create (libcrun_context_t *context, libcrun_container_t *container,
+                                             unsigned int options, libcrun_error_t *err);
 
 LIBCRUN_PUBLIC int libcrun_container_start (libcrun_context_t *context, const char *id, libcrun_error_t *err);
 
-LIBCRUN_PUBLIC int libcrun_container_state (libcrun_context_t *context, const char *id, FILE *out, libcrun_error_t *err);
+LIBCRUN_PUBLIC int libcrun_container_state (libcrun_context_t *context, const char *id, FILE *out,
+                                            libcrun_error_t *err);
 
-LIBCRUN_PUBLIC int libcrun_get_container_state_string (const char *id, libcrun_container_status_t *status, const char *state_root, const char **container_status, int *running, libcrun_error_t *err);
+LIBCRUN_PUBLIC int libcrun_get_container_state_string (const char *id, libcrun_container_status_t *status,
+                                                       const char *state_root, const char **container_status,
+                                                       int *running, libcrun_error_t *err);
 
-LIBCRUN_PUBLIC int libcrun_container_exec (libcrun_context_t *context, const char *id, runtime_spec_schema_config_schema_process *process, libcrun_error_t *err);
+LIBCRUN_PUBLIC int libcrun_container_exec (libcrun_context_t *context, const char *id,
+                                           runtime_spec_schema_config_schema_process *process, libcrun_error_t *err);
 
-LIBCRUN_PUBLIC int libcrun_container_exec_process_file (libcrun_context_t *context, const char *id, const char *path, libcrun_error_t *err);
+LIBCRUN_PUBLIC int libcrun_container_exec_process_file (libcrun_context_t *context, const char *id, const char *path,
+                                                        libcrun_error_t *err);
 
-LIBCRUN_PUBLIC int libcrun_container_update (libcrun_context_t *context, const char *id, const char *content, size_t len, libcrun_error_t *err);
+LIBCRUN_PUBLIC int libcrun_container_update (libcrun_context_t *context, const char *id, const char *content,
+                                             size_t len, libcrun_error_t *err);
 
-LIBCRUN_PUBLIC int libcrun_container_update_from_file (libcrun_context_t *context, const char *id, const char *file, libcrun_error_t *err);
+LIBCRUN_PUBLIC int libcrun_container_update_from_file (libcrun_context_t *context, const char *id, const char *file,
+                                                       libcrun_error_t *err);
 
 LIBCRUN_PUBLIC int libcrun_container_spec (bool root, FILE *out, libcrun_error_t *err);
 
@@ -118,8 +131,10 @@ LIBCRUN_PUBLIC int libcrun_container_pau
 
 LIBCRUN_PUBLIC int libcrun_container_unpause (libcrun_context_t *context, const char *id, libcrun_error_t *err);
 
-LIBCRUN_PUBLIC int libcrun_container_checkpoint (libcrun_context_t *context, const char *id, libcrun_checkpoint_restore_t * cr_options, libcrun_error_t *err);
+LIBCRUN_PUBLIC int libcrun_container_checkpoint (libcrun_context_t *context, const char *id,
+                                                 libcrun_checkpoint_restore_t *cr_options, libcrun_error_t *err);
 
-LIBCRUN_PUBLIC int libcrun_container_restore (libcrun_context_t *context, const char *id, libcrun_checkpoint_restore_t * cr_options, libcrun_error_t *err);
+LIBCRUN_PUBLIC int libcrun_container_restore (libcrun_context_t *context, const char *id,
+                                              libcrun_checkpoint_restore_t *cr_options, libcrun_error_t *err);
 
 #endif
diff -pruN 0.14.1+dfsg-1/src/libcrun/criu.c 0.15+dfsg-1/src/libcrun/criu.c
--- 0.14.1+dfsg-1/src/libcrun/criu.c	2020-07-02 13:46:33.000000000 +0000
+++ 0.15+dfsg-1/src/libcrun/criu.c	2020-09-03 11:43:25.000000000 +0000
@@ -21,28 +21,26 @@
 
 #ifdef HAVE_CRIU
 
-#include <unistd.h>
-#include <sys/types.h>
-#include <criu/criu.h>
-#include <sched.h>
-#include <sys/stat.h>
-#include <sys/mount.h>
-#include <fcntl.h>
-
-#include "container.h"
-#include "linux.h"
-#include "status.h"
-#include "utils.h"
-
-#define CRIU_CHECKPOINT_LOG_FILE "dump.log"
-#define CRIU_RESTORE_LOG_FILE "restore.log"
-#define DESCRIPTORS_FILENAME "descriptors.json"
+#  include <unistd.h>
+#  include <sys/types.h>
+#  include <criu/criu.h>
+#  include <sched.h>
+#  include <sys/stat.h>
+#  include <sys/mount.h>
+#  include <fcntl.h>
+
+#  include "container.h"
+#  include "linux.h"
+#  include "status.h"
+#  include "utils.h"
+
+#  define CRIU_CHECKPOINT_LOG_FILE "dump.log"
+#  define CRIU_RESTORE_LOG_FILE "restore.log"
+#  define DESCRIPTORS_FILENAME "descriptors.json"
 
 int
-libcrun_container_checkpoint_linux_criu (libcrun_container_status_t *status,
-                                         libcrun_container_t *container,
-                                         libcrun_checkpoint_restore_t *
-                                         cr_options, libcrun_error_t *err)
+libcrun_container_checkpoint_linux_criu (libcrun_container_status_t *status, libcrun_container_t *container,
+                                         libcrun_checkpoint_restore_t *cr_options, libcrun_error_t *err)
 {
   runtime_spec_schema_config_schema *def = container->container_def;
   cleanup_free char *descriptors_path = NULL;
@@ -83,29 +81,24 @@ libcrun_container_checkpoint_linux_criu
 
   ret = mkdir (cr_options->image_path, 0700);
   if (UNLIKELY ((ret == -1) && (errno != EEXIST)))
-    return crun_make_error (err, errno,
-                            "error creating checkpoint directory %s\n",
-                            cr_options->image_path);
+    return crun_make_error (err, errno, "error creating checkpoint directory %s\n", cr_options->image_path);
 
   image_fd = open (cr_options->image_path, O_DIRECTORY);
   if (UNLIKELY (image_fd == -1))
-    return crun_make_error (err, errno, "error opening checkpoint directory %s\n",
-                            cr_options->image_path);
+    return crun_make_error (err, errno, "error opening checkpoint directory %s\n", cr_options->image_path);
 
   criu_set_images_dir_fd (image_fd);
 
   /* descriptors.json is needed during restore to correctly
    * reconnect stdin, stdout, stderr. */
-  xasprintf (&descriptors_path, "%s/%s", cr_options->image_path,
-             DESCRIPTORS_FILENAME);
+  xasprintf (&descriptors_path, "%s/%s", cr_options->image_path, DESCRIPTORS_FILENAME);
   descriptors_fd = open (descriptors_path, O_CREAT | O_WRONLY | O_CLOEXEC, S_IRUSR | S_IWUSR);
   if (UNLIKELY (descriptors_fd == -1))
-    return crun_make_error (err, errno, "error opening descriptors file %s\n",
-                            descriptors_path);
+    return crun_make_error (err, errno, "error opening descriptors file %s\n", descriptors_path);
   if (status->external_descriptors)
     {
-      ret = TEMP_FAILURE_RETRY (write (descriptors_fd, status->external_descriptors,
-                                       strlen (status->external_descriptors)));
+      ret = TEMP_FAILURE_RETRY (
+          write (descriptors_fd, status->external_descriptors, strlen (status->external_descriptors)));
       if (UNLIKELY (ret < 0))
         return crun_make_error (err, errno, "write '%s'", DESCRIPTORS_FILENAME);
     }
@@ -117,9 +110,7 @@ libcrun_container_checkpoint_linux_criu
     {
       work_fd = open (cr_options->work_path, O_DIRECTORY);
       if (UNLIKELY (work_fd == -1))
-        return crun_make_error (err, errno,
-                                "error opening CRIU work directory %s\n",
-                                cr_options->work_path);
+        return crun_make_error (err, errno, "error opening CRIU work directory %s\n", cr_options->work_path);
 
       criu_set_work_dir_fd (work_fd);
     }
@@ -146,11 +137,9 @@ libcrun_container_checkpoint_linux_criu
 
       for (j = 0; j < def->mounts[i]->options_len; j++)
         {
-          if (strcmp (def->mounts[i]->options[j], "bind") == 0
-              || strcmp (def->mounts[i]->options[j], "rbind") == 0)
+          if (strcmp (def->mounts[i]->options[j], "bind") == 0 || strcmp (def->mounts[i]->options[j], "rbind") == 0)
             {
-              criu_add_ext_mount (def->mounts[i]->destination,
-                                  def->mounts[i]->destination);
+              criu_add_ext_mount (def->mounts[i]->destination, def->mounts[i]->destination);
               break;
             }
         }
@@ -182,16 +171,14 @@ libcrun_container_checkpoint_linux_criu
     {
       int value = libcrun_find_namespace (def->linux->namespaces[i]->type);
       if (UNLIKELY (value < 0))
-        return crun_make_error (err, 0, "invalid namespace type: `%s`",
-                                def->linux->namespaces[i]->type);
+        return crun_make_error (err, 0, "invalid namespace type: `%s`", def->linux->namespaces[i]->type);
 
       if (value == CLONE_NEWNET && def->linux->namespaces[i]->path != NULL)
         {
           struct stat statbuf;
           ret = stat (def->linux->namespaces[i]->path, &statbuf);
           if (UNLIKELY (ret < 0))
-            return crun_make_error (err, errno, "unable to stat(): `%s`",
-                                    def->linux->namespaces[i]->path);
+            return crun_make_error (err, errno, "unable to stat(): `%s`", def->linux->namespaces[i]->path);
 
           xasprintf (&external, "net[%ld]:extRootNetNS", statbuf.st_ino);
           criu_add_external (external);
@@ -212,16 +199,14 @@ libcrun_container_checkpoint_linux_criu
   if (UNLIKELY (ret != 0))
     return crun_make_error (err, 0,
                             "CRIU checkpointing failed %d\n"
-                            "Please check CRIU logfile %s/%s\n", ret,
-                            cr_options->work_path, CRIU_CHECKPOINT_LOG_FILE);
+                            "Please check CRIU logfile %s/%s\n",
+                            ret, cr_options->work_path, CRIU_CHECKPOINT_LOG_FILE);
 
   return 0;
 }
 
 static int
-prepare_restore_mounts (runtime_spec_schema_config_schema *def,
-                        char *root,
-                        libcrun_error_t *err)
+prepare_restore_mounts (runtime_spec_schema_config_schema *def, char *root, libcrun_error_t *err)
 {
   int i;
 
@@ -236,8 +221,7 @@ prepare_restore_mounts (runtime_spec_sch
       size_t j;
 
       /* cgroup restore should be handled by CRIU itself */
-      if (strcmp (type, "cgroup") == 0
-          || strcmp (type, "cgroup2") == 0)
+      if (strcmp (type, "cgroup") == 0 || strcmp (type, "cgroup2") == 0)
         continue;
 
       /* Check if the mountpoint is on a tmpfs. CRIU restores
@@ -247,8 +231,7 @@ prepare_restore_mounts (runtime_spec_sch
           cleanup_free char *dest_loop = NULL;
 
           xasprintf (&dest_loop, "%s/", def->mounts[j]->destination);
-          if (strncmp (dest, dest_loop, strlen (dest_loop)) == 0 &&
-              strcmp (def->mounts[j]->type, "tmpfs") == 0)
+          if (strncmp (dest, dest_loop, strlen (dest_loop)) == 0 && strcmp (def->mounts[j]->type, "tmpfs") == 0)
             {
               /* This is a mountpoint which is on a tmpfs.*/
               on_tmpfs = true;
@@ -274,16 +257,13 @@ prepare_restore_mounts (runtime_spec_sch
 
       root_fd = open (root, O_RDONLY | O_CLOEXEC);
       if (UNLIKELY (root_fd == -1))
-        return crun_make_error (err, errno,
-                                "error opening container root directory %s",
-                                root);
+        return crun_make_error (err, errno, "error opening container root directory %s", root);
 
       if (is_dir)
         {
           int ret;
 
-          ret = crun_safe_ensure_directory_at (root_fd, root, strlen (root),
-                                               dest, 0755, err);
+          ret = crun_safe_ensure_directory_at (root_fd, root, strlen (root), dest, 0755, err);
           if (UNLIKELY (ret < 0))
             return ret;
         }
@@ -291,8 +271,7 @@ prepare_restore_mounts (runtime_spec_sch
         {
           int ret;
 
-          ret = crun_safe_ensure_file_at (root_fd, root, strlen (root), dest,
-                                          0755, err);
+          ret = crun_safe_ensure_file_at (root_fd, root, strlen (root), dest, 0755, err);
           if (UNLIKELY (ret < 0))
             return ret;
         }
@@ -302,10 +281,8 @@ prepare_restore_mounts (runtime_spec_sch
 }
 
 int
-libcrun_container_restore_linux_criu (libcrun_container_status_t *status,
-                                      libcrun_container_t *container,
-                                      libcrun_checkpoint_restore_t *
-                                      cr_options, libcrun_error_t *err)
+libcrun_container_restore_linux_criu (libcrun_container_status_t *status, libcrun_container_t *container,
+                                      libcrun_checkpoint_restore_t *cr_options, libcrun_error_t *err)
 {
   runtime_spec_schema_config_schema *def = container->container_def;
   cleanup_close int inherit_fd = -1;
@@ -328,8 +305,7 @@ libcrun_container_restore_linux_criu (li
 
   image_fd = open (cr_options->image_path, O_DIRECTORY);
   if (UNLIKELY (image_fd == -1))
-    return crun_make_error (err, errno, "error opening checkpoint directory %s\n",
-                            cr_options->image_path);
+    return crun_make_error (err, errno, "error opening checkpoint directory %s\n", cr_options->image_path);
 
   criu_set_images_dir_fd (image_fd);
 
@@ -340,8 +316,7 @@ libcrun_container_restore_linux_criu (li
     char err_buffer[256];
     yajl_val tree;
 
-    xasprintf (&descriptors_path, "%s/%s", cr_options->image_path,
-               DESCRIPTORS_FILENAME);
+    xasprintf (&descriptors_path, "%s/%s", cr_options->image_path, DESCRIPTORS_FILENAME);
     ret = read_all_file (descriptors_path, &buffer, NULL, err);
     if (UNLIKELY (ret < 0))
       return ret;
@@ -354,11 +329,9 @@ libcrun_container_restore_linux_criu (li
      * a pipe 'pipe:' we tell CRIU to reconnect that pipe
      * to the corresponding FD to have (especially) stdout
      * and stderr being correctly redirected. */
-    tree = yajl_tree_parse (buffer, err_buffer, sizeof(err_buffer));
+    tree = yajl_tree_parse (buffer, err_buffer, sizeof (err_buffer));
     if (UNLIKELY (tree == NULL))
-      return crun_make_error (err, 0,
-                              "cannot parse descriptors file %s",
-                              DESCRIPTORS_FILENAME);
+      return crun_make_error (err, 0, "cannot parse descriptors file %s", DESCRIPTORS_FILENAME);
 
     if (tree && YAJL_IS_ARRAY (tree))
       {
@@ -380,7 +353,6 @@ libcrun_container_restore_linux_criu (li
     yajl_tree_free (tree);
   }
 
-
   /* work_dir is the place CRIU will put its logfiles. If not explicitly set,
    * CRIU will put the logfiles into the images_dir from above. No need for
    * crun to set it if the user has not selected a specific directory. */
@@ -388,9 +360,7 @@ libcrun_container_restore_linux_criu (li
     {
       work_fd = open (cr_options->work_path, O_DIRECTORY);
       if (UNLIKELY (work_fd == -1))
-        return crun_make_error (err, errno,
-                                "error opening CRIU work directory %s\n",
-                                cr_options->work_path);
+        return crun_make_error (err, errno, "error opening CRIU work directory %s\n", cr_options->work_path);
 
       criu_set_work_dir_fd (work_fd);
     }
@@ -407,11 +377,9 @@ libcrun_container_restore_linux_criu (li
 
       for (j = 0; j < def->mounts[i]->options_len; j++)
         {
-          if (strcmp (def->mounts[i]->options[j], "bind") == 0
-              || strcmp (def->mounts[i]->options[j], "rbind") == 0)
+          if (strcmp (def->mounts[i]->options[j], "bind") == 0 || strcmp (def->mounts[i]->options[j], "rbind") == 0)
             {
-              criu_add_ext_mount (def->mounts[i]->destination,
-                                  def->mounts[i]->source);
+              criu_add_ext_mount (def->mounts[i]->destination, def->mounts[i]->source);
               break;
             }
         }
@@ -430,14 +398,12 @@ libcrun_container_restore_linux_criu (li
 
   ret = mkdir (root, 0755);
   if (UNLIKELY (ret == -1))
-    return crun_make_error (err, errno,
-                            "error creating restore directory %s\n", root);
+    return crun_make_error (err, errno, "error creating restore directory %s\n", root);
   /* do realpath on root */
   ret = mount (status->rootfs, root, NULL, MS_BIND | MS_REC, NULL);
   if (UNLIKELY (ret == -1))
     {
-      ret = crun_make_error (err, errno,
-                             "error mounting restore directory %s\n", root);
+      ret = crun_make_error (err, errno, "error mounting restore directory %s\n", root);
       goto out;
     }
 
@@ -468,15 +434,13 @@ libcrun_container_restore_linux_criu (li
     {
       int value = libcrun_find_namespace (def->linux->namespaces[i]->type);
       if (UNLIKELY (value < 0))
-        return crun_make_error (err, 0, "invalid namespace type: `%s`",
-                                def->linux->namespaces[i]->type);
+        return crun_make_error (err, 0, "invalid namespace type: `%s`", def->linux->namespaces[i]->type);
 
       if (value == CLONE_NEWNET && def->linux->namespaces[i]->path != NULL)
         {
           inherit_fd = open (def->linux->namespaces[i]->path, O_RDONLY);
           if (UNLIKELY (ret < 0))
-            return crun_make_error (err, errno, "unable to open(): `%s`",
-                                    def->linux->namespaces[i]->path);
+            return crun_make_error (err, errno, "unable to open(): `%s`", def->linux->namespaces[i]->path);
 
           criu_add_inherit_fd (inherit_fd, "extRootNetNS");
           break;
@@ -500,8 +464,8 @@ libcrun_container_restore_linux_criu (li
     {
       ret = crun_make_error (err, 0,
                              "CRIU restoring failed %d\n"
-                             "Please check CRIU logfile %s/%s\n", ret,
-                             cr_options->work_path, CRIU_RESTORE_LOG_FILE);
+                             "Please check CRIU logfile %s/%s\n",
+                             ret, cr_options->work_path, CRIU_RESTORE_LOG_FILE);
       goto out_umount;
     }
 
@@ -512,15 +476,13 @@ libcrun_container_restore_linux_criu (li
 out_umount:
   ret_out = umount (root);
   if (UNLIKELY (ret_out == -1))
-    return crun_make_error (err, errno,
-                            "error unmounting restore directory %s\n", root);
+    return crun_make_error (err, errno, "error unmounting restore directory %s\n", root);
 out:
   ret_out = rmdir (root);
   if (UNLIKELY (ret == -1))
     return ret;
   if (UNLIKELY (ret_out == -1))
-    return crun_make_error (err, errno,
-                            "error removing restore directory %s\n", root);
+    return crun_make_error (err, errno, "error removing restore directory %s\n", root);
   return ret;
 }
 #endif
diff -pruN 0.14.1+dfsg-1/src/libcrun/criu.h 0.15+dfsg-1/src/libcrun/criu.h
--- 0.14.1+dfsg-1/src/libcrun/criu.h	2020-07-02 13:46:33.000000000 +0000
+++ 0.15+dfsg-1/src/libcrun/criu.h	2020-09-03 11:43:25.000000000 +0000
@@ -26,36 +26,28 @@
 
 #ifdef HAVE_CRIU
 
-int libcrun_container_checkpoint_linux_criu (libcrun_container_status_t *status,
-                                             libcrun_container_t *container,
-                                             libcrun_checkpoint_restore_t *cr_options,
-                                             libcrun_error_t *err);
-
-int libcrun_container_restore_linux_criu (libcrun_container_status_t *status,
-                                          libcrun_container_t *container,
-                                          libcrun_checkpoint_restore_t *cr_options,
-                                          libcrun_error_t *err);
+int libcrun_container_checkpoint_linux_criu (libcrun_container_status_t *status, libcrun_container_t *container,
+                                             libcrun_checkpoint_restore_t *cr_options, libcrun_error_t *err);
+
+int libcrun_container_restore_linux_criu (libcrun_container_status_t *status, libcrun_container_t *container,
+                                          libcrun_checkpoint_restore_t *cr_options, libcrun_error_t *err);
 
 #else
 
 static inline int
 libcrun_container_checkpoint_linux_criu (arg_unused libcrun_container_status_t *status,
                                          arg_unused libcrun_container_t *container,
-                                         arg_unused libcrun_checkpoint_restore_t *cr_options,
-                                         libcrun_error_t *err)
+                                         arg_unused libcrun_checkpoint_restore_t *cr_options, libcrun_error_t *err)
 {
-  return crun_make_error (err, 0,
-                          "Compiled without CRIU support. Checkpointing not available.");
+  return crun_make_error (err, 0, "Compiled without CRIU support. Checkpointing not available.");
 }
 
 static inline int
 libcrun_container_restore_linux_criu (arg_unused libcrun_container_status_t *status,
                                       arg_unused libcrun_container_t *container,
-                                      arg_unused libcrun_checkpoint_restore_t *cr_options,
-                                      libcrun_error_t *err)
+                                      arg_unused libcrun_checkpoint_restore_t *cr_options, libcrun_error_t *err)
 {
-  return crun_make_error (err, 0,
-                          "Compiled without CRIU support. Restore not available.");
+  return crun_make_error (err, 0, "Compiled without CRIU support. Restore not available.");
 }
 
 #endif
diff -pruN 0.14.1+dfsg-1/src/libcrun/ebpf.c 0.15+dfsg-1/src/libcrun/ebpf.c
--- 0.14.1+dfsg-1/src/libcrun/ebpf.c	2020-07-03 19:38:11.000000000 +0000
+++ 0.15+dfsg-1/src/libcrun/ebpf.c	2020-09-03 11:43:25.000000000 +0000
@@ -26,21 +26,22 @@
 #include <sys/resource.h>
 
 #ifdef HAVE_EBPF
-# include <linux/bpf.h>
+#  include <linux/bpf.h>
 
-# ifndef HAVE_BPF
+#  ifndef HAVE_BPF
 static int
 syscall_bpf (int cmd, union bpf_attr *attr, unsigned int size)
 {
   return (int) syscall (__NR_bpf, cmd, attr, size);
 }
-#  define bpf syscall_bpf
-# endif
+#    define bpf syscall_bpf
+#  endif
 
 #endif
 
-enum {
-      HAS_WILDCARD = 1
+enum
+{
+  HAS_WILDCARD = 1
 };
 
 struct bpf_program
@@ -53,69 +54,30 @@ struct bpf_program
 
 #ifdef HAVE_EBPF
 
-# define BPF_ALU32_IMM(OP, DST, IMM)            \
-  ((struct bpf_insn) {                          \
-    .code  = BPF_ALU | BPF_OP(OP) | BPF_K,      \
-      .dst_reg = DST,                           \
-      .src_reg = 0,                             \
-      .off   = 0,                               \
-      .imm   = IMM })
-
-# define BPF_LDX_MEM(SIZE, DST, SRC, OFF)               \
-  ((struct bpf_insn) {                                  \
-    .code  = BPF_LDX | BPF_SIZE(SIZE) | BPF_MEM,        \
-      .dst_reg = DST,                                   \
-      .src_reg = SRC,                                   \
-      .off   = OFF,                                     \
-      .imm   = 0 })
-
-# define BPF_MOV64_REG(DST, SRC)                \
-  ((struct bpf_insn) {                          \
-    .code  = BPF_ALU64 | BPF_MOV | BPF_X,       \
-      .dst_reg = DST,                           \
-      .src_reg = SRC,                           \
-      .off   = 0,                               \
-      .imm   = 0 })
-
-# define BPF_JMP_A(OFF)                         \
-  ((struct bpf_insn) {                          \
-    .code  = BPF_JMP | BPF_JA,                  \
-      .dst_reg = 0,                             \
-      .src_reg = 0,                             \
-      .off   = OFF,                             \
-      .imm   = 0 })
-
-# define BPF_JMP_IMM(OP, DST, IMM, OFF)         \
-  ((struct bpf_insn) {                          \
-    .code  = BPF_JMP | BPF_OP(OP) | BPF_K,      \
-      .dst_reg = DST,                           \
-      .src_reg = 0,                             \
-      .off   = OFF,                             \
-      .imm   = IMM })
-
-# define BPF_MOV64_IMM(DST, IMM)                \
-  ((struct bpf_insn) {                          \
-    .code  = BPF_ALU64 | BPF_MOV | BPF_K,       \
-      .dst_reg = DST,                           \
-      .src_reg = 0,                             \
-      .off   = 0,                               \
-      .imm   = IMM })
-
-# define BPF_MOV32_REG(DST, SRC)                \
-  ((struct bpf_insn) {                          \
-    .code  = BPF_ALU | BPF_MOV | BPF_X,         \
-      .dst_reg = DST,                           \
-      .src_reg = SRC,                           \
-      .off   = 0,                               \
-      .imm   = 0 })
-
-# define BPF_EXIT_INSN()                        \
-  ((struct bpf_insn) {                          \
-    .code  = BPF_JMP | BPF_EXIT,                \
-      .dst_reg = 0,                             \
-      .src_reg = 0,                             \
-      .off   = 0,                               \
-      .imm   = 0 })
+#  define BPF_ALU32_IMM(OP, DST, IMM) \
+    ((struct bpf_insn){ .code = BPF_ALU | BPF_OP (OP) | BPF_K, .dst_reg = DST, .src_reg = 0, .off = 0, .imm = IMM })
+
+#  define BPF_LDX_MEM(SIZE, DST, SRC, OFF) \
+    ((struct bpf_insn){                    \
+        .code = BPF_LDX | BPF_SIZE (SIZE) | BPF_MEM, .dst_reg = DST, .src_reg = SRC, .off = OFF, .imm = 0 })
+
+#  define BPF_MOV64_REG(DST, SRC) \
+    ((struct bpf_insn){ .code = BPF_ALU64 | BPF_MOV | BPF_X, .dst_reg = DST, .src_reg = SRC, .off = 0, .imm = 0 })
+
+#  define BPF_JMP_A(OFF) \
+    ((struct bpf_insn){ .code = BPF_JMP | BPF_JA, .dst_reg = 0, .src_reg = 0, .off = OFF, .imm = 0 })
+
+#  define BPF_JMP_IMM(OP, DST, IMM, OFF) \
+    ((struct bpf_insn){ .code = BPF_JMP | BPF_OP (OP) | BPF_K, .dst_reg = DST, .src_reg = 0, .off = OFF, .imm = IMM })
+
+#  define BPF_MOV64_IMM(DST, IMM) \
+    ((struct bpf_insn){ .code = BPF_ALU64 | BPF_MOV | BPF_K, .dst_reg = DST, .src_reg = 0, .off = 0, .imm = IMM })
+
+#  define BPF_MOV32_REG(DST, SRC) \
+    ((struct bpf_insn){ .code = BPF_ALU | BPF_MOV | BPF_X, .dst_reg = DST, .src_reg = SRC, .off = 0, .imm = 0 })
+
+#  define BPF_EXIT_INSN() \
+    ((struct bpf_insn){ .code = BPF_JMP | BPF_EXIT, .dst_reg = 0, .src_reg = 0, .off = 0, .imm = 0 })
 #endif
 
 #ifdef HAVE_EBPF
@@ -157,19 +119,19 @@ bpf_program_init_dev (struct bpf_program
 #ifdef HAVE_EBPF
   /* taken from systemd.  */
   struct bpf_insn pre_insn[] = {
-                                /* type -> R2.  */
-                                BPF_LDX_MEM (BPF_W, BPF_REG_2, BPF_REG_1, 0),
-                                BPF_ALU32_IMM(BPF_AND, BPF_REG_2, 0xFFFF),
-
-                                /* access -> R3.  */
-                                BPF_LDX_MEM (BPF_W, BPF_REG_3, BPF_REG_1, 0),
-                                BPF_ALU32_IMM (BPF_RSH, BPF_REG_3, 16),
+    /* type -> R2.  */
+    BPF_LDX_MEM (BPF_W, BPF_REG_2, BPF_REG_1, 0),
+    BPF_ALU32_IMM (BPF_AND, BPF_REG_2, 0xFFFF),
+
+    /* access -> R3.  */
+    BPF_LDX_MEM (BPF_W, BPF_REG_3, BPF_REG_1, 0),
+    BPF_ALU32_IMM (BPF_RSH, BPF_REG_3, 16),
 
-                                /* major -> R4.  */
-                                BPF_LDX_MEM (BPF_W, BPF_REG_4, BPF_REG_1, 4),
+    /* major -> R4.  */
+    BPF_LDX_MEM (BPF_W, BPF_REG_4, BPF_REG_1, 4),
 
-                                /* minor -> R5.  */
-                                BPF_LDX_MEM (BPF_W, BPF_REG_5, BPF_REG_1, 8),
+    /* minor -> R5.  */
+    BPF_LDX_MEM (BPF_W, BPF_REG_5, BPF_REG_1, 8),
   };
   program = bpf_program_append (program, pre_insn, sizeof (pre_insn));
 #endif
@@ -177,7 +139,8 @@ bpf_program_init_dev (struct bpf_program
 }
 
 struct bpf_program *
-bpf_program_append_dev (struct bpf_program *program, const char *access, char type, int major, int minor, bool accept, libcrun_error_t *err arg_unused)
+bpf_program_append_dev (struct bpf_program *program, const char *access, char type, int major, int minor, bool accept,
+                        libcrun_error_t *err arg_unused)
 {
 #ifdef HAVE_EBPF
   int i;
@@ -189,8 +152,8 @@ bpf_program_append_dev (struct bpf_progr
   bool has_access = false;
   int number_instructions = 0;
   struct bpf_insn accept_block[] = {
-                                    BPF_MOV64_IMM (BPF_REG_0, accept ? 1 : 0),
-                                    BPF_EXIT_INSN (),
+    BPF_MOV64_IMM (BPF_REG_0, accept ? 1 : 0),
+    BPF_EXIT_INSN (),
   };
 
   if (program->private & HAS_WILDCARD)
@@ -235,35 +198,29 @@ bpf_program_append_dev (struct bpf_progr
 
   if (has_type)
     {
-      struct bpf_insn i[] = {
-                             BPF_JMP_IMM (BPF_JNE, BPF_REG_2, bpf_type, number_instructions)
-      };
+      struct bpf_insn i[] = { BPF_JMP_IMM (BPF_JNE, BPF_REG_2, bpf_type, number_instructions) };
       number_instructions--;
       program = bpf_program_append (program, i, sizeof (i));
     }
   if (has_access)
     {
       struct bpf_insn i[] = {
-                             BPF_MOV32_REG (BPF_REG_1, BPF_REG_3),
-                             BPF_ALU32_IMM (BPF_AND, BPF_REG_1, bpf_access),
-                             BPF_JMP_IMM (BPF_JEQ, BPF_REG_1, 0, number_instructions - 2),
+        BPF_MOV32_REG (BPF_REG_1, BPF_REG_3),
+        BPF_ALU32_IMM (BPF_AND, BPF_REG_1, bpf_access),
+        BPF_JMP_IMM (BPF_JEQ, BPF_REG_1, 0, number_instructions - 2),
       };
       number_instructions -= 3;
       program = bpf_program_append (program, i, sizeof (i));
     }
   if (has_major)
     {
-      struct bpf_insn i[] = {
-                             BPF_JMP_IMM (BPF_JNE, BPF_REG_4, major, number_instructions)
-      };
+      struct bpf_insn i[] = { BPF_JMP_IMM (BPF_JNE, BPF_REG_4, major, number_instructions) };
       number_instructions--;
       program = bpf_program_append (program, i, sizeof (i));
     }
   if (has_minor)
     {
-      struct bpf_insn i[] = {
-                             BPF_JMP_IMM (BPF_JNE, BPF_REG_5, minor, number_instructions)
-      };
+      struct bpf_insn i[] = { BPF_JMP_IMM (BPF_JNE, BPF_REG_5, minor, number_instructions) };
       number_instructions--;
       program = bpf_program_append (program, i, sizeof (i));
     }
@@ -281,8 +238,8 @@ bpf_program_complete_dev (struct bpf_pro
 {
 #ifdef HAVE_EBPF
   struct bpf_insn i[] = {
-                         BPF_MOV64_IMM (BPF_REG_0, 0),
-                         BPF_EXIT_INSN (),
+    BPF_MOV64_IMM (BPF_REG_0, 0),
+    BPF_EXIT_INSN (),
   };
 
   if (program->private & HAS_WILDCARD)
@@ -316,7 +273,8 @@ read_all_progs (int dirfd, uint32_t **pr
 
       ret = bpf (BPF_PROG_QUERY, &attr, sizeof (attr));
     }
-  while (ret < 0 && errno == ENOSPC);
+  while (ret < 0 && errno == ENOSPC)
+    ;
 
   if (UNLIKELY (ret < 0))
     return crun_make_error (err, errno, "bpf query");
@@ -386,10 +344,10 @@ ebpf_attach_program (int fd, int dirfd,
 {
 #ifndef HAVE_EBPF
   return crun_make_error (err, 0, "eBPF not supported");
-# else
-# ifdef BPF_F_REPLACE
+#else
+#  ifdef BPF_F_REPLACE
   bool skip_replace = false;
-# endif
+#  endif
   const int MAX_ATTEMPTS = 20;
   int attempt;
 
@@ -405,9 +363,9 @@ ebpf_attach_program (int fd, int dirfd,
       if (UNLIKELY (ret < 0))
         return ret;
 
-# ifdef BPF_F_REPLACE
+#  ifdef BPF_F_REPLACE
       /* There is just one program installed, let's attempt an atomic replace if supported.  */
-      if (!skip_replace && n_progs == 1)
+      if (! skip_replace && n_progs == 1)
         {
           memset (&attr, 0, sizeof (attr));
           attr.prog_id = progs[0];
@@ -422,20 +380,20 @@ ebpf_attach_program (int fd, int dirfd,
               return crun_make_error (err, errno, "cannot open existing eBPF program");
             }
         }
-# endif
+#  endif
 
       memset (&attr, 0, sizeof (attr));
       attr.attach_type = BPF_CGROUP_DEVICE;
       attr.target_fd = dirfd;
       attr.attach_bpf_fd = fd;
       attr.attach_flags = BPF_F_ALLOW_MULTI;
-# ifdef BPF_F_REPLACE
+#  ifdef BPF_F_REPLACE
       if (replacefd >= 0)
         {
           attr.attach_flags = BPF_F_ALLOW_MULTI | BPF_F_REPLACE;
           attr.replace_bpf_fd = replacefd;
         }
-# endif
+#  endif
 
       ret = bpf (BPF_PROG_ATTACH, &attr, sizeof (attr));
       if (UNLIKELY (ret < 0))
@@ -445,13 +403,13 @@ ebpf_attach_program (int fd, int dirfd,
               /* Another update might have already updated the cgroup, try again.  */
               continue;
             }
-# ifdef BPF_F_REPLACE
+#  ifdef BPF_F_REPLACE
           if (errno == EINVAL && replacefd >= 0)
             {
               skip_replace = true;
               continue;
             }
-# endif
+#  endif
           return crun_make_error (err, errno, "bpf attach");
         }
 
diff -pruN 0.14.1+dfsg-1/src/libcrun/ebpf.h 0.15+dfsg-1/src/libcrun/ebpf.h
--- 0.14.1+dfsg-1/src/libcrun/ebpf.h	2020-07-02 13:46:33.000000000 +0000
+++ 0.15+dfsg-1/src/libcrun/ebpf.h	2020-09-03 11:43:25.000000000 +0000
@@ -16,16 +16,16 @@
  * along with crun.  If not, see <http://www.gnu.org/licenses/>.
  */
 #ifndef EBPF_H
-# define EBPF_H
+#define EBPF_H
 
-# include <config.h>
-# include <stdio.h>
-# include <stdlib.h>
-# include "error.h"
-# include <errno.h>
-# include <argp.h>
-# include <runtime_spec_schema_config_schema.h>
-# include "container.h"
+#include <config.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include "error.h"
+#include <errno.h>
+#include <argp.h>
+#include <runtime_spec_schema_config_schema.h>
+#include "container.h"
 
 struct bpf_program;
 
@@ -33,10 +33,10 @@ struct bpf_program *bpf_program_new (siz
 struct bpf_program *bpf_program_append (struct bpf_program *p, void *data, size_t size);
 
 struct bpf_program *bpf_program_init_dev (struct bpf_program *program, libcrun_error_t *err);
-struct bpf_program *bpf_program_append_dev (struct bpf_program *program, const char *access, char type, int major, int minor, bool accept, libcrun_error_t *err);
+struct bpf_program *bpf_program_append_dev (struct bpf_program *program, const char *access, char type, int major,
+                                            int minor, bool accept, libcrun_error_t *err);
 struct bpf_program *bpf_program_complete_dev (struct bpf_program *program, libcrun_error_t *err);
 
-
 int libcrun_ebpf_load (struct bpf_program *program, int dirfd, const char *pin, libcrun_error_t *err);
 
 #endif
diff -pruN 0.14.1+dfsg-1/src/libcrun/error.c 0.15+dfsg-1/src/libcrun/error.c
--- 0.14.1+dfsg-1/src/libcrun/error.c	2020-07-03 19:38:11.000000000 +0000
+++ 0.15+dfsg-1/src/libcrun/error.c	2020-09-23 14:47:06.000000000 +0000
@@ -30,39 +30,37 @@
 #include <yajl/yajl_gen.h>
 
 #ifdef HAVE_SYSTEMD
-# include <systemd/sd-journal.h>
+#  include <systemd/sd-journal.h>
 #endif
 
-
 #define YAJL_STR(x) ((const unsigned char *) (x))
 
 enum
-  {
-   LOG_FORMAT_TEXT = 0,
-   LOG_FORMAT_JSON,
-  };
+{
+  LOG_FORMAT_TEXT = 0,
+  LOG_FORMAT_JSON,
+};
 
 static int log_format;
 static bool log_also_to_stderr;
 
-#define MAKE_ERROR(FUNC_NAME)                                           \
-  int                                                                   \
- FUNC_NAME (libcrun_error_t *err, int status, const char *msg, ...)     \
-  {                                                                     \
-  va_list args_list;                                                    \
-  libcrun_error_t ptr;                                                  \
-  va_start (args_list, msg);                                            \
-  *err = xmalloc (sizeof (struct libcrun_error_s));                     \
-  ptr = *err;                                                           \
-  ptr->status = status;                                                 \
-  if (vasprintf (&(ptr->msg), msg, args_list) < 0)                      \
-    OOM ();                                                             \
-  va_end (args_list);                                                   \
-  return -status - 1;                                                   \
-}
+#define MAKE_ERROR(FUNC_NAME)                                            \
+  int FUNC_NAME (libcrun_error_t *err, int status, const char *msg, ...) \
+  {                                                                      \
+    va_list args_list;                                                   \
+    libcrun_error_t ptr;                                                 \
+    va_start (args_list, msg);                                           \
+    *err = xmalloc (sizeof (struct libcrun_error_s));                    \
+    ptr = *err;                                                          \
+    ptr->status = status;                                                \
+    if (vasprintf (&(ptr->msg), msg, args_list) < 0)                     \
+      OOM ();                                                            \
+    va_end (args_list);                                                  \
+    return -status - 1;                                                  \
+  }
 
-MAKE_ERROR(crun_make_error);
-MAKE_ERROR(libcrun_make_error);
+MAKE_ERROR (crun_make_error);
+MAKE_ERROR (libcrun_make_error);
 
 int
 crun_error_wrap (libcrun_error_t *err, const char *fmt, ...)
@@ -76,17 +74,18 @@ crun_error_wrap (libcrun_error_t *err, c
   if (err == NULL || *err == NULL)
     return 0;
 
-  ret = -(*err)->status -1;
+  ret = -(*err)->status - 1;
 
   va_start (args_list, fmt);
 
   if (vasprintf (&msg, fmt, args_list) < 0)
-    return ret;
-
-  asprintf (&tmp, "%s: %s", msg, (*err)->msg);
-  if (tmp == NULL)
-    return ret;
+    {
+      va_end (args_list);
+      return ret;
+    }
+  va_end (args_list);
 
+  xasprintf (&tmp, "%s: %s", msg, (*err)->msg);
   swap = tmp;
   tmp = (*err)->msg;
   (*err)->msg = swap;
@@ -174,11 +173,11 @@ init_syslog (const char *id)
 }
 
 enum
-  {
-   LOG_TYPE_FILE = 1,
-   LOG_TYPE_SYSLOG = 2,
-   LOG_TYPE_JOURNALD = 3
-  };
+{
+  LOG_TYPE_FILE = 1,
+  LOG_TYPE_SYSLOG = 2,
+  LOG_TYPE_JOURNALD = 3
+};
 
 static int
 get_log_type (const char *log, const char **data)
@@ -202,8 +201,8 @@ get_log_type (const char *log, const cha
 }
 
 int
-libcrun_init_logging (crun_output_handler *new_output_handler, void **new_output_handler_arg,
-                      const char *id, const char *log, libcrun_error_t *err)
+libcrun_init_logging (crun_output_handler *new_output_handler, void **new_output_handler_arg, const char *id,
+                      const char *log, libcrun_error_t *err)
 {
   if (log == NULL)
     {
@@ -245,7 +244,9 @@ libcrun_init_logging (crun_output_handle
 void
 log_write_to_stream (int errno_, const char *msg, bool warning, void *arg)
 {
-  timestamp_t timestamp = {0, };
+  timestamp_t timestamp = {
+    0,
+  };
   FILE *stream = arg;
   int tty = isatty (fileno (stream));
   const char *color_begin = "";
@@ -291,13 +292,14 @@ log_write_to_journald (int errno_, const
   if (errno_ == 0)
     sd_journal_send ("PRIORITY=%d", warning ? LOG_WARNING : LOG_ERR, "MESSAGE=%s", msg, "ID=%s", arg, NULL);
   else
-    sd_journal_send ("PRIORITY=%d", warning ? LOG_WARNING : LOG_ERR, "MESSAGE=%s: %s", msg, strerror (errno_), "ID=%s", arg, NULL);
+    sd_journal_send ("PRIORITY=%d", warning ? LOG_WARNING : LOG_ERR, "MESSAGE=%s: %s", msg, strerror (errno_), "ID=%s",
+                     arg, NULL);
 #endif
 }
 
 static crun_output_handler output_handler = log_write_to_stderr;
 static void *output_handler_arg = NULL;
-static int output_verbosity = LIBCRUN_VERBOSITY_WARNING;
+static int output_verbosity = LIBCRUN_VERBOSITY_ERROR;
 
 void
 libcrun_set_verbosity (int verbosity)
@@ -327,7 +329,9 @@ make_json_error (const char *msg, int er
   yajl_gen gen = NULL;
   char *ret = NULL;
   size_t buf_len;
-  timestamp_t timestamp = {0, };
+  timestamp_t timestamp = {
+    0,
+  };
 
   gen = yajl_gen_alloc (NULL);
   if (gen == NULL)
@@ -417,8 +421,7 @@ libcrun_error (int errno_, const char *m
   va_end (args_list);
 }
 
-void __attribute__ ((noreturn))
-libcrun_fail_with_error (int errno_, const char *msg, ...)
+void __attribute__ ((noreturn)) libcrun_fail_with_error (int errno_, const char *msg, ...)
 {
   va_list args_list;
   va_start (args_list, msg);
diff -pruN 0.14.1+dfsg-1/src/libcrun/error.h 0.15+dfsg-1/src/libcrun/error.h
--- 0.14.1+dfsg-1/src/libcrun/error.h	2020-07-03 19:38:11.000000000 +0000
+++ 0.15+dfsg-1/src/libcrun/error.h	2020-09-03 11:43:25.000000000 +0000
@@ -16,28 +16,31 @@
  * along with crun.  If not, see <http://www.gnu.org/licenses/>.
  */
 #ifndef ERROR_H
-# define ERROR_H
-# include <config.h>
-# ifdef HAVE_ERROR_H
+#define ERROR_H
+#include <config.h>
+#ifdef HAVE_ERROR_H
 #  include <error.h>
-# else
-#  define error(status, errno, fmt, ...) do {                           \
-    if (errno == 0)                                                     \
-      fprintf (stderr, "crun: " fmt "\n", ##__VA_ARGS__);               \
-    else                                                                \
-      {                                                                 \
-        fprintf (stderr, "crun: " fmt, ##__VA_ARGS__);                  \
-        fprintf (stderr, ": %s\n", strerror (errno));                   \
-      }                                                                 \
-    if (status)                                                         \
-      exit (status);                                                    \
-  } while(0)
-# endif
-# include <stdlib.h>
-# include <stdio.h>
-# include <stdbool.h>
-# include <syslog.h>
-# include <unistd.h>
+#else
+#  define error(status, errno, fmt, ...)                      \
+    do                                                        \
+      {                                                       \
+        if (errno == 0)                                       \
+          fprintf (stderr, "crun: " fmt "\n", ##__VA_ARGS__); \
+        else                                                  \
+          {                                                   \
+            fprintf (stderr, "crun: " fmt, ##__VA_ARGS__);    \
+            fprintf (stderr, ": %s\n", strerror (errno));     \
+          }                                                   \
+        if (status)                                           \
+          exit (status);                                      \
+      }                                                       \
+    while (0)
+#endif
+#include <stdlib.h>
+#include <stdio.h>
+#include <stdbool.h>
+#include <syslog.h>
+#include <unistd.h>
 
 struct libcrun_error_s
 {
@@ -46,12 +49,12 @@ struct libcrun_error_s
 };
 typedef struct libcrun_error_s *libcrun_error_t;
 
-#define OOM()                                   \
-  do                                            \
-    {                                           \
-      fprintf (stderr, "out of memory");        \
-      _exit (EXIT_FAILURE);                     \
-    }                                           \
+#define OOM()                            \
+  do                                     \
+    {                                    \
+      fprintf (stderr, "out of memory"); \
+      _exit (EXIT_FAILURE);              \
+    }                                    \
   while (0)
 
 typedef void (*crun_output_handler) (int errno_, const char *msg, bool warning, void *arg);
@@ -88,16 +91,16 @@ LIBCRUN_PUBLIC void libcrun_fail_with_er
 
 LIBCRUN_PUBLIC int libcrun_set_log_format (const char *format, libcrun_error_t *err);
 
-LIBCRUN_PUBLIC int libcrun_init_logging (crun_output_handler *output_handler, void **output_handler_arg,
-                                         const char *id, const char *log, libcrun_error_t *err);
+LIBCRUN_PUBLIC int libcrun_init_logging (crun_output_handler *output_handler, void **output_handler_arg, const char *id,
+                                         const char *log, libcrun_error_t *err);
 
 LIBCRUN_PUBLIC int libcrun_error_release (libcrun_error_t *err);
 
 enum
-  {
-    LIBCRUN_VERBOSITY_ERROR,
-    LIBCRUN_VERBOSITY_WARNING,
-  };
+{
+  LIBCRUN_VERBOSITY_ERROR,
+  LIBCRUN_VERBOSITY_WARNING,
+};
 
 LIBCRUN_PUBLIC void libcrun_set_verbosity (int verbosity);
 LIBCRUN_PUBLIC int libcrun_get_verbosity ();
diff -pruN 0.14.1+dfsg-1/src/libcrun/intprops.h 0.15+dfsg-1/src/libcrun/intprops.h
--- 0.14.1+dfsg-1/src/libcrun/intprops.h	2020-07-02 13:46:33.000000000 +0000
+++ 0.15+dfsg-1/src/libcrun/intprops.h	2020-09-03 11:43:25.000000000 +0000
@@ -43,7 +43,6 @@
    signed or floating type.  */
 #define EXPR_SIGNED(e) (_GL_INT_NEGATE_CONVERT (e, 1) < 0)
 
-
 /* Minimum and maximum values for integer types and expressions.  */
 
 /* The width in bits of the integer type or expression T.
@@ -51,29 +50,19 @@
 #define TYPE_WIDTH(t) (sizeof (t) * CHAR_BIT)
 
 /* The maximum and minimum values for the integer type T.  */
-#define TYPE_MINIMUM(t) ((t) ~ TYPE_MAXIMUM (t))
-#define TYPE_MAXIMUM(t)                                                 \
-  ((t) (! TYPE_SIGNED (t)                                               \
-        ? (t) -1                                                        \
-        : ((((t) 1 << (TYPE_WIDTH (t) - 2)) - 1) * 2 + 1)))
+#define TYPE_MINIMUM(t) ((t) ~TYPE_MAXIMUM (t))
+#define TYPE_MAXIMUM(t) ((t) (! TYPE_SIGNED (t) ? (t) -1 : ((((t) 1 << (TYPE_WIDTH (t) - 2)) - 1) * 2 + 1)))
 
 /* The maximum and minimum values for the type of the expression E,
    after integer promotion.  E should not have side effects.  */
-#define _GL_INT_MINIMUM(e)                                              \
-  (EXPR_SIGNED (e)                                                      \
-   ? ~ _GL_SIGNED_INT_MAXIMUM (e)                                       \
-   : _GL_INT_CONVERT (e, 0))
-#define _GL_INT_MAXIMUM(e)                                              \
-  (EXPR_SIGNED (e)                                                      \
-   ? _GL_SIGNED_INT_MAXIMUM (e)                                         \
-   : _GL_INT_NEGATE_CONVERT (e, 1))
-#define _GL_SIGNED_INT_MAXIMUM(e)                                       \
-  (((_GL_INT_CONVERT (e, 1) << (TYPE_WIDTH ((e) + 0) - 2)) - 1) * 2 + 1)
+#define _GL_INT_MINIMUM(e) (EXPR_SIGNED (e) ? ~_GL_SIGNED_INT_MAXIMUM (e) : _GL_INT_CONVERT (e, 0))
+#define _GL_INT_MAXIMUM(e) (EXPR_SIGNED (e) ? _GL_SIGNED_INT_MAXIMUM (e) : _GL_INT_NEGATE_CONVERT (e, 1))
+#define _GL_SIGNED_INT_MAXIMUM(e) (((_GL_INT_CONVERT (e, 1) << (TYPE_WIDTH ((e) + 0) - 2)) - 1) * 2 + 1)
 
 /* Work around OpenVMS incompatibility with C99.  */
-#if !defined LLONG_MAX && defined __INT64_MAX
-# define LLONG_MAX __INT64_MAX
-# define LLONG_MIN __INT64_MIN
+#if ! defined LLONG_MAX && defined __INT64_MAX
+#  define LLONG_MAX __INT64_MAX
+#  define LLONG_MIN __INT64_MIN
 #endif
 
 /* This include file assumes that signed types are two's complement without
@@ -83,27 +72,25 @@
 
 /* Does the __typeof__ keyword work?  This could be done by
    'configure', but for now it's easier to do it by hand.  */
-#if (2 <= __GNUC__ \
-     || (1210 <= __IBMC__ && defined __IBM__TYPEOF__) \
-     || (0x5110 <= __SUNPRO_C && !__STDC__))
-# define _GL_HAVE___TYPEOF__ 1
+#if (2 <= __GNUC__ || (1210 <= __IBMC__ && defined __IBM__TYPEOF__) || (0x5110 <= __SUNPRO_C && ! __STDC__))
+#  define _GL_HAVE___TYPEOF__ 1
 #else
-# define _GL_HAVE___TYPEOF__ 0
+#  define _GL_HAVE___TYPEOF__ 0
 #endif
 
 /* Return 1 if the integer type or expression T might be signed.  Return 0
    if it is definitely unsigned.  This macro does not evaluate its argument,
    and expands to an integer constant expression.  */
 #if _GL_HAVE___TYPEOF__
-# define _GL_SIGNED_TYPE_OR_EXPR(t) TYPE_SIGNED (__typeof__ (t))
+#  define _GL_SIGNED_TYPE_OR_EXPR(t) TYPE_SIGNED (__typeof__ (t))
 #else
-# define _GL_SIGNED_TYPE_OR_EXPR(t) 1
+#  define _GL_SIGNED_TYPE_OR_EXPR(t) 1
 #endif
 
 /* Bound on length of the string representing an unsigned integer
    value representable in B bits.  log10 (2.0) < 146/485.  The
    smallest value of B where this bound is not tight is 2621.  */
-#define INT_BITS_STRLEN_BOUND(b) (((b) * 146 + 484) / 485)
+#define INT_BITS_STRLEN_BOUND(b) (((b) *146 + 484) / 485)
 
 /* Bound on length of the string representing an integer type or expression T.
    Subtract 1 for the sign bit if T is signed, and then add 1 more for
@@ -112,15 +99,13 @@
    Because _GL_SIGNED_TYPE_OR_EXPR sometimes returns 0 when its argument is
    signed, this macro may overestimate the true bound by one byte when
    applied to unsigned types of size 2, 4, 16, ... bytes.  */
-#define INT_STRLEN_BOUND(t)                                     \
-  (INT_BITS_STRLEN_BOUND (TYPE_WIDTH (t) - _GL_SIGNED_TYPE_OR_EXPR (t)) \
-   + _GL_SIGNED_TYPE_OR_EXPR (t))
+#define INT_STRLEN_BOUND(t) \
+  (INT_BITS_STRLEN_BOUND (TYPE_WIDTH (t) - _GL_SIGNED_TYPE_OR_EXPR (t)) + _GL_SIGNED_TYPE_OR_EXPR (t))
 
 /* Bound on buffer size needed to represent an integer type or expression T,
    including the terminating null.  */
 #define INT_BUFSIZE_BOUND(t) (INT_STRLEN_BOUND (t) + 1)
 
-
 /* Range overflow checks.
 
    The INT_<op>_RANGE_OVERFLOW macros return 1 if the corresponding C
@@ -157,54 +142,34 @@
 
 /* Return 1 if A + B would overflow in [MIN,MAX] arithmetic.
    See above for restrictions.  */
-#define INT_ADD_RANGE_OVERFLOW(a, b, min, max)          \
-  ((b) < 0                                              \
-   ? (a) < (min) - (b)                                  \
-   : (max) - (b) < (a))
+#define INT_ADD_RANGE_OVERFLOW(a, b, min, max) ((b) < 0 ? (a) < (min) - (b) : (max) - (b) < (a))
 
 /* Return 1 if A - B would overflow in [MIN,MAX] arithmetic.
    See above for restrictions.  */
-#define INT_SUBTRACT_RANGE_OVERFLOW(a, b, min, max)     \
-  ((b) < 0                                              \
-   ? (max) + (b) < (a)                                  \
-   : (a) < (min) + (b))
+#define INT_SUBTRACT_RANGE_OVERFLOW(a, b, min, max) ((b) < 0 ? (max) + (b) < (a) : (a) < (min) + (b))
 
 /* Return 1 if - A would overflow in [MIN,MAX] arithmetic.
    See above for restrictions.  */
-#define INT_NEGATE_RANGE_OVERFLOW(a, min, max)          \
-  ((min) < 0                                            \
-   ? (a) < - (max)                                      \
-   : 0 < (a))
+#define INT_NEGATE_RANGE_OVERFLOW(a, min, max) ((min) < 0 ? (a) < -(max) : 0 < (a))
 
 /* Return 1 if A * B would overflow in [MIN,MAX] arithmetic.
    See above for restrictions.  Avoid && and || as they tickle
    bugs in Sun C 5.11 2010/08/13 and other compilers; see
    <http://lists.gnu.org/archive/html/bug-gnulib/2011-05/msg00401.html>.  */
-#define INT_MULTIPLY_RANGE_OVERFLOW(a, b, min, max)     \
-  ((b) < 0                                              \
-   ? ((a) < 0                                           \
-      ? (a) < (max) / (b)                               \
-      : (b) == -1                                       \
-      ? 0                                               \
-      : (min) / (b) < (a))                              \
-   : (b) == 0                                           \
-   ? 0                                                  \
-   : ((a) < 0                                           \
-      ? (a) < (min) / (b)                               \
-      : (max) / (b) < (a)))
+#define INT_MULTIPLY_RANGE_OVERFLOW(a, b, min, max)                            \
+  ((b) < 0 ? ((a) < 0 ? (a) < (max) / (b) : (b) == -1 ? 0 : (min) / (b) < (a)) \
+           : (b) == 0 ? 0 : ((a) < 0 ? (a) < (min) / (b) : (max) / (b) < (a)))
 
 /* Return 1 if A / B would overflow in [MIN,MAX] arithmetic.
    See above for restrictions.  Do not check for division by zero.  */
-#define INT_DIVIDE_RANGE_OVERFLOW(a, b, min, max)       \
-  ((min) < 0 && (b) == -1 && (a) < - (max))
+#define INT_DIVIDE_RANGE_OVERFLOW(a, b, min, max) ((min) < 0 && (b) == -1 && (a) < -(max))
 
 /* Return 1 if A % B would overflow in [MIN,MAX] arithmetic.
    See above for restrictions.  Do not check for division by zero.
    Mathematically, % should never overflow, but on x86-like hosts
    INT_MIN % -1 traps, and the C standard permits this, so treat this
    as an overflow too.  */
-#define INT_REMAINDER_RANGE_OVERFLOW(a, b, min, max)    \
-  INT_DIVIDE_RANGE_OVERFLOW (a, b, min, max)
+#define INT_REMAINDER_RANGE_OVERFLOW(a, b, min, max) INT_DIVIDE_RANGE_OVERFLOW (a, b, min, max)
 
 /* Return 1 if A << B would overflow in [MIN,MAX] arithmetic.
    See above for restrictions.  Here, MIN and MAX are for A only, and B need
@@ -213,16 +178,13 @@
    A is negative then A << B has undefined behavior and A >> B has
    implementation-defined behavior, but do not check these other
    restrictions.  */
-#define INT_LEFT_SHIFT_RANGE_OVERFLOW(a, b, min, max)   \
-  ((a) < 0                                              \
-   ? (a) < (min) >> (b)                                 \
-   : (max) >> (b) < (a))
+#define INT_LEFT_SHIFT_RANGE_OVERFLOW(a, b, min, max) ((a) < 0 ? (a) < (min) >> (b) : (max) >> (b) < (a))
 
 /* True if __builtin_add_overflow (A, B, P) works when P is non-null.  */
-#if 5 <= __GNUC__ && !defined __ICC
-# define _GL_HAS_BUILTIN_OVERFLOW 1
+#if 5 <= __GNUC__ && ! defined __ICC
+#  define _GL_HAS_BUILTIN_OVERFLOW 1
 #else
-# define _GL_HAS_BUILTIN_OVERFLOW 0
+#  define _GL_HAS_BUILTIN_OVERFLOW 0
 #endif
 
 /* True if __builtin_add_overflow_p (A, B, C) works.  */
@@ -233,46 +195,33 @@
    (e.g., A and B) have the same type as MIN and MAX.  Instead, they assume
    that the result (e.g., A + B) has that type.  */
 #if _GL_HAS_BUILTIN_OVERFLOW_P
-# define _GL_ADD_OVERFLOW(a, b, min, max)                               \
-   __builtin_add_overflow_p (a, b, (__typeof__ ((a) + (b))) 0)
-# define _GL_SUBTRACT_OVERFLOW(a, b, min, max)                          \
-   __builtin_sub_overflow_p (a, b, (__typeof__ ((a) - (b))) 0)
-# define _GL_MULTIPLY_OVERFLOW(a, b, min, max)                          \
-   __builtin_mul_overflow_p (a, b, (__typeof__ ((a) * (b))) 0)
+#  define _GL_ADD_OVERFLOW(a, b, min, max) __builtin_add_overflow_p (a, b, (__typeof__ ((a) + (b))) 0)
+#  define _GL_SUBTRACT_OVERFLOW(a, b, min, max) __builtin_sub_overflow_p (a, b, (__typeof__ ((a) - (b))) 0)
+#  define _GL_MULTIPLY_OVERFLOW(a, b, min, max) __builtin_mul_overflow_p (a, b, (__typeof__ ((a) * (b))) 0)
 #else
-# define _GL_ADD_OVERFLOW(a, b, min, max)                                \
-   ((min) < 0 ? INT_ADD_RANGE_OVERFLOW (a, b, min, max)                  \
-    : (a) < 0 ? (b) <= (a) + (b)                                         \
-    : (b) < 0 ? (a) <= (a) + (b)                                         \
-    : (a) + (b) < (b))
-# define _GL_SUBTRACT_OVERFLOW(a, b, min, max)                           \
-   ((min) < 0 ? INT_SUBTRACT_RANGE_OVERFLOW (a, b, min, max)             \
-    : (a) < 0 ? 1                                                        \
-    : (b) < 0 ? (a) - (b) <= (a)                                         \
-    : (a) < (b))
-# define _GL_MULTIPLY_OVERFLOW(a, b, min, max)                           \
-   (((min) == 0 && (((a) < 0 && 0 < (b)) || ((b) < 0 && 0 < (a))))       \
-    || INT_MULTIPLY_RANGE_OVERFLOW (a, b, min, max))
+#  define _GL_ADD_OVERFLOW(a, b, min, max)               \
+    ((min) < 0 ? INT_ADD_RANGE_OVERFLOW (a, b, min, max) \
+               : (a) < 0 ? (b) <= (a) + (b) : (b) < 0 ? (a) <= (a) + (b) : (a) + (b) < (b))
+#  define _GL_SUBTRACT_OVERFLOW(a, b, min, max) \
+    ((min) < 0 ? INT_SUBTRACT_RANGE_OVERFLOW (a, b, min, max) : (a) < 0 ? 1 : (b) < 0 ? (a) - (b) <= (a) : (a) < (b))
+#  define _GL_MULTIPLY_OVERFLOW(a, b, min, max) \
+    (((min) == 0 && (((a) < 0 && 0 < (b)) || ((b) < 0 && 0 < (a)))) || INT_MULTIPLY_RANGE_OVERFLOW (a, b, min, max))
 #endif
-#define _GL_DIVIDE_OVERFLOW(a, b, min, max)                             \
-  ((min) < 0 ? (b) == _GL_INT_NEGATE_CONVERT (min, 1) && (a) < - (max)  \
-   : (a) < 0 ? (b) <= (a) + (b) - 1                                     \
-   : (b) < 0 && (a) + (b) <= (a))
-#define _GL_REMAINDER_OVERFLOW(a, b, min, max)                          \
-  ((min) < 0 ? (b) == _GL_INT_NEGATE_CONVERT (min, 1) && (a) < - (max)  \
-   : (a) < 0 ? (a) % (b) != ((max) - (b) + 1) % (b)                     \
-   : (b) < 0 && ! _GL_UNSIGNED_NEG_MULTIPLE (a, b, max))
+#define _GL_DIVIDE_OVERFLOW(a, b, min, max)                           \
+  ((min) < 0 ? (b) == _GL_INT_NEGATE_CONVERT (min, 1) && (a) < -(max) \
+             : (a) < 0 ? (b) <= (a) + (b) -1 : (b) < 0 && (a) + (b) <= (a))
+#define _GL_REMAINDER_OVERFLOW(a, b, min, max)                        \
+  ((min) < 0 ? (b) == _GL_INT_NEGATE_CONVERT (min, 1) && (a) < -(max) \
+             : (a) < 0 ? (a) % (b) != ((max) - (b) + 1) % (b) : (b) < 0 && ! _GL_UNSIGNED_NEG_MULTIPLE (a, b, max))
 
 /* Return a nonzero value if A is a mathematical multiple of B, where
    A is unsigned, B is negative, and MAX is the maximum value of A's
    type.  A's type must be the same as (A % B)'s type.  Normally (A %
    -B == 0) suffices, but things get tricky if -B would overflow.  */
-#define _GL_UNSIGNED_NEG_MULTIPLE(a, b, max)                            \
-  (((b) < -_GL_SIGNED_INT_MAXIMUM (b)                                   \
-    ? (_GL_SIGNED_INT_MAXIMUM (b) == (max)                              \
-       ? (a)                                                            \
-       : (a) % (_GL_INT_CONVERT (a, _GL_SIGNED_INT_MAXIMUM (b)) + 1))   \
-    : (a) % - (b))                                                      \
+#define _GL_UNSIGNED_NEG_MULTIPLE(a, b, max)                                                                        \
+  (((b) < -_GL_SIGNED_INT_MAXIMUM (b)                                                                               \
+        ? (_GL_SIGNED_INT_MAXIMUM (b) == (max) ? (a) : (a) % (_GL_INT_CONVERT (a, _GL_SIGNED_INT_MAXIMUM (b)) + 1)) \
+        : (a) % -(b))                                                                                               \
    == 0)
 
 /* Check for integer overflow, and report low order bits of answer.
@@ -314,43 +263,30 @@
    Return 1 if the integer expressions A * B, A - B, -A, A * B, A / B,
    A % B, and A << B would overflow, respectively.  */
 
-#define INT_ADD_OVERFLOW(a, b) \
-  _GL_BINARY_OP_OVERFLOW (a, b, _GL_ADD_OVERFLOW)
-#define INT_SUBTRACT_OVERFLOW(a, b) \
-  _GL_BINARY_OP_OVERFLOW (a, b, _GL_SUBTRACT_OVERFLOW)
+#define INT_ADD_OVERFLOW(a, b) _GL_BINARY_OP_OVERFLOW (a, b, _GL_ADD_OVERFLOW)
+#define INT_SUBTRACT_OVERFLOW(a, b) _GL_BINARY_OP_OVERFLOW (a, b, _GL_SUBTRACT_OVERFLOW)
 #if _GL_HAS_BUILTIN_OVERFLOW_P
-# define INT_NEGATE_OVERFLOW(a) INT_SUBTRACT_OVERFLOW (0, a)
+#  define INT_NEGATE_OVERFLOW(a) INT_SUBTRACT_OVERFLOW (0, a)
 #else
-# define INT_NEGATE_OVERFLOW(a) \
-   INT_NEGATE_RANGE_OVERFLOW (a, _GL_INT_MINIMUM (a), _GL_INT_MAXIMUM (a))
+#  define INT_NEGATE_OVERFLOW(a) INT_NEGATE_RANGE_OVERFLOW (a, _GL_INT_MINIMUM (a), _GL_INT_MAXIMUM (a))
 #endif
-#define INT_MULTIPLY_OVERFLOW(a, b) \
-  _GL_BINARY_OP_OVERFLOW (a, b, _GL_MULTIPLY_OVERFLOW)
-#define INT_DIVIDE_OVERFLOW(a, b) \
-  _GL_BINARY_OP_OVERFLOW (a, b, _GL_DIVIDE_OVERFLOW)
-#define INT_REMAINDER_OVERFLOW(a, b) \
-  _GL_BINARY_OP_OVERFLOW (a, b, _GL_REMAINDER_OVERFLOW)
-#define INT_LEFT_SHIFT_OVERFLOW(a, b) \
-  INT_LEFT_SHIFT_RANGE_OVERFLOW (a, b, \
-                                 _GL_INT_MINIMUM (a), _GL_INT_MAXIMUM (a))
+#define INT_MULTIPLY_OVERFLOW(a, b) _GL_BINARY_OP_OVERFLOW (a, b, _GL_MULTIPLY_OVERFLOW)
+#define INT_DIVIDE_OVERFLOW(a, b) _GL_BINARY_OP_OVERFLOW (a, b, _GL_DIVIDE_OVERFLOW)
+#define INT_REMAINDER_OVERFLOW(a, b) _GL_BINARY_OP_OVERFLOW (a, b, _GL_REMAINDER_OVERFLOW)
+#define INT_LEFT_SHIFT_OVERFLOW(a, b) INT_LEFT_SHIFT_RANGE_OVERFLOW (a, b, _GL_INT_MINIMUM (a), _GL_INT_MAXIMUM (a))
 
 /* Return 1 if the expression A <op> B would overflow,
    where OP_RESULT_OVERFLOW (A, B, MIN, MAX) does the actual test,
    assuming MIN and MAX are the minimum and maximum for the result type.
    Arguments should be free of side effects.  */
-#define _GL_BINARY_OP_OVERFLOW(a, b, op_result_overflow)        \
-  op_result_overflow (a, b,                                     \
-                      _GL_INT_MINIMUM (0 * (b) + (a)),          \
-                      _GL_INT_MAXIMUM (0 * (b) + (a)))
+#define _GL_BINARY_OP_OVERFLOW(a, b, op_result_overflow) \
+  op_result_overflow (a, b, _GL_INT_MINIMUM (0 * (b) + (a)), _GL_INT_MAXIMUM (0 * (b) + (a)))
 
 /* Store the low-order bits of A + B, A - B, A * B, respectively, into *R.
    Return 1 if the result overflows.  See above for restrictions.  */
-#define INT_ADD_WRAPV(a, b, r) \
-  _GL_INT_OP_WRAPV (a, b, r, +, __builtin_add_overflow, INT_ADD_OVERFLOW)
-#define INT_SUBTRACT_WRAPV(a, b, r) \
-  _GL_INT_OP_WRAPV (a, b, r, -, __builtin_sub_overflow, INT_SUBTRACT_OVERFLOW)
-#define INT_MULTIPLY_WRAPV(a, b, r) \
-  _GL_INT_OP_WRAPV (a, b, r, *, __builtin_mul_overflow, INT_MULTIPLY_OVERFLOW)
+#define INT_ADD_WRAPV(a, b, r) _GL_INT_OP_WRAPV (a, b, r, +, __builtin_add_overflow, INT_ADD_OVERFLOW)
+#define INT_SUBTRACT_WRAPV(a, b, r) _GL_INT_OP_WRAPV (a, b, r, -, __builtin_sub_overflow, INT_SUBTRACT_OVERFLOW)
+#define INT_MULTIPLY_WRAPV(a, b, r) _GL_INT_OP_WRAPV (a, b, r, *, __builtin_mul_overflow, INT_MULTIPLY_OVERFLOW)
 
 /* Nonzero if this compiler has GCC bug 68193 or Clang bug 25390.  See:
    https://gcc.gnu.org/bugzilla/show_bug.cgi?id=68193
@@ -359,9 +295,9 @@
    warnings for _Generic.  This matters only for older compilers that
    lack __builtin_add_overflow.  */
 #if __GNUC__
-# define _GL__GENERIC_BOGUS 1
+#  define _GL__GENERIC_BOGUS 1
 #else
-# define _GL__GENERIC_BOGUS 0
+#  define _GL__GENERIC_BOGUS 0
 #endif
 
 /* Store the low-order bits of A <op> B into *R, where OP specifies
@@ -369,66 +305,47 @@
    overflow predicate.  Return 1 if the result overflows.  See above
    for restrictions.  */
 #if _GL_HAS_BUILTIN_OVERFLOW
-# define _GL_INT_OP_WRAPV(a, b, r, op, builtin, overflow) builtin (a, b, r)
-#elif 201112 <= __STDC_VERSION__ && !_GL__GENERIC_BOGUS
-# define _GL_INT_OP_WRAPV(a, b, r, op, builtin, overflow) \
-   (_Generic \
-    (*(r), \
-     signed char: \
-       _GL_INT_OP_CALC (a, b, r, op, overflow, unsigned int, \
-                        signed char, SCHAR_MIN, SCHAR_MAX), \
-     short int: \
-       _GL_INT_OP_CALC (a, b, r, op, overflow, unsigned int, \
-                        short int, SHRT_MIN, SHRT_MAX), \
-     int: \
-       _GL_INT_OP_CALC (a, b, r, op, overflow, unsigned int, \
-                        int, INT_MIN, INT_MAX), \
-     long int: \
-       _GL_INT_OP_CALC (a, b, r, op, overflow, unsigned long int, \
-                        long int, LONG_MIN, LONG_MAX), \
-     long long int: \
-       _GL_INT_OP_CALC (a, b, r, op, overflow, unsigned long long int, \
-                        long long int, LLONG_MIN, LLONG_MAX)))
+#  define _GL_INT_OP_WRAPV(a, b, r, op, builtin, overflow) builtin (a, b, r)
+#elif 201112 <= __STDC_VERSION__ && ! _GL__GENERIC_BOGUS
+#  define _GL_INT_OP_WRAPV(a, b, r, op, builtin, overflow)                                                          \
+    (_Generic(*(r), signed char                                                                                     \
+              : _GL_INT_OP_CALC (a, b, r, op, overflow, unsigned int, signed char, SCHAR_MIN, SCHAR_MAX), short int \
+              : _GL_INT_OP_CALC (a, b, r, op, overflow, unsigned int, short int, SHRT_MIN, SHRT_MAX), int           \
+              : _GL_INT_OP_CALC (a, b, r, op, overflow, unsigned int, int, INT_MIN, INT_MAX), long int              \
+              : _GL_INT_OP_CALC (a, b, r, op, overflow, unsigned long int, long int, LONG_MIN, LONG_MAX),           \
+                long long int                                                                                       \
+              : _GL_INT_OP_CALC (a, b, r, op, overflow, unsigned long long int, long long int, LLONG_MIN, LLONG_MAX)))
 #else
-# define _GL_INT_OP_WRAPV(a, b, r, op, builtin, overflow) \
-   (sizeof *(r) == sizeof (signed char) \
-    ? _GL_INT_OP_CALC (a, b, r, op, overflow, unsigned int, \
-                       signed char, SCHAR_MIN, SCHAR_MAX) \
-    : sizeof *(r) == sizeof (short int) \
-    ? _GL_INT_OP_CALC (a, b, r, op, overflow, unsigned int, \
-                       short int, SHRT_MIN, SHRT_MAX) \
-    : sizeof *(r) == sizeof (int) \
-    ? _GL_INT_OP_CALC (a, b, r, op, overflow, unsigned int, \
-                       int, INT_MIN, INT_MAX) \
-    : _GL_INT_OP_WRAPV_LONGISH(a, b, r, op, overflow))
-# ifdef LLONG_MAX
-#  define _GL_INT_OP_WRAPV_LONGISH(a, b, r, op, overflow) \
-    (sizeof *(r) == sizeof (long int) \
-     ? _GL_INT_OP_CALC (a, b, r, op, overflow, unsigned long int, \
-                        long int, LONG_MIN, LONG_MAX) \
-     : _GL_INT_OP_CALC (a, b, r, op, overflow, unsigned long long int, \
-                        long long int, LLONG_MIN, LLONG_MAX))
-# else
-#  define _GL_INT_OP_WRAPV_LONGISH(a, b, r, op, overflow) \
-    _GL_INT_OP_CALC (a, b, r, op, overflow, unsigned long int, \
-                     long int, LONG_MIN, LONG_MAX)
-# endif
+#  define _GL_INT_OP_WRAPV(a, b, r, op, builtin, overflow)                                            \
+    (sizeof *(r) == sizeof (signed char)                                                              \
+         ? _GL_INT_OP_CALC (a, b, r, op, overflow, unsigned int, signed char, SCHAR_MIN, SCHAR_MAX)   \
+         : sizeof *(r) == sizeof (short int)                                                          \
+               ? _GL_INT_OP_CALC (a, b, r, op, overflow, unsigned int, short int, SHRT_MIN, SHRT_MAX) \
+               : sizeof *(r) == sizeof (int)                                                          \
+                     ? _GL_INT_OP_CALC (a, b, r, op, overflow, unsigned int, int, INT_MIN, INT_MAX)   \
+                     : _GL_INT_OP_WRAPV_LONGISH (a, b, r, op, overflow))
+#  ifdef LLONG_MAX
+#    define _GL_INT_OP_WRAPV_LONGISH(a, b, r, op, overflow)                                           \
+      (sizeof *(r) == sizeof (long int)                                                               \
+           ? _GL_INT_OP_CALC (a, b, r, op, overflow, unsigned long int, long int, LONG_MIN, LONG_MAX) \
+           : _GL_INT_OP_CALC (a, b, r, op, overflow, unsigned long long int, long long int, LLONG_MIN, LLONG_MAX))
+#  else
+#    define _GL_INT_OP_WRAPV_LONGISH(a, b, r, op, overflow) \
+      _GL_INT_OP_CALC (a, b, r, op, overflow, unsigned long int, long int, LONG_MIN, LONG_MAX)
+#  endif
 #endif
 
 /* Store the low-order bits of A <op> B into *R, where the operation
    is given by OP.  Use the unsigned type UT for calculation to avoid
    overflow problems.  *R's type is T, with extrema TMIN and TMAX.
    T must be a signed integer type.  Return 1 if the result overflows.  */
-#define _GL_INT_OP_CALC(a, b, r, op, overflow, ut, t, tmin, tmax) \
-  (sizeof ((a) op (b)) < sizeof (t) \
-   ? _GL_INT_OP_CALC1 ((t) (a), (t) (b), r, op, overflow, ut, t, tmin, tmax) \
-   : _GL_INT_OP_CALC1 (a, b, r, op, overflow, ut, t, tmin, tmax))
-#define _GL_INT_OP_CALC1(a, b, r, op, overflow, ut, t, tmin, tmax) \
-  ((overflow (a, b) \
-    || (EXPR_SIGNED ((a) op (b)) && ((a) op (b)) < (tmin)) \
-    || (tmax) < ((a) op (b))) \
-   ? (*(r) = _GL_INT_OP_WRAPV_VIA_UNSIGNED (a, b, op, ut, t), 1) \
-   : (*(r) = _GL_INT_OP_WRAPV_VIA_UNSIGNED (a, b, op, ut, t), 0))
+#define _GL_INT_OP_CALC(a, b, r, op, overflow, ut, t, tmin, tmax)                                             \
+  (sizeof ((a) op (b)) < sizeof (t) ? _GL_INT_OP_CALC1 ((t) (a), (t) (b), r, op, overflow, ut, t, tmin, tmax) \
+                                    : _GL_INT_OP_CALC1 (a, b, r, op, overflow, ut, t, tmin, tmax))
+#define _GL_INT_OP_CALC1(a, b, r, op, overflow, ut, t, tmin, tmax)                                   \
+  ((overflow (a, b) || (EXPR_SIGNED ((a) op (b)) && ((a) op (b)) < (tmin)) || (tmax) < ((a) op (b))) \
+       ? (*(r) = _GL_INT_OP_WRAPV_VIA_UNSIGNED (a, b, op, ut, t), 1)                                 \
+       : (*(r) = _GL_INT_OP_WRAPV_VIA_UNSIGNED (a, b, op, ut, t), 0))
 
 /* Return the low-order bits of A <op> B, where the operation is given
    by OP.  Use the unsigned type UT for calculation to avoid undefined
@@ -447,7 +364,6 @@
    As the compiler bug is real, don't try to work around the
    theoretical problem.  */
 
-#define _GL_INT_OP_WRAPV_VIA_UNSIGNED(a, b, op, ut, t) \
-  ((t) ((ut) (a) op (ut) (b)))
+#define _GL_INT_OP_WRAPV_VIA_UNSIGNED(a, b, op, ut, t) ((t) ((ut) (a) op (ut) (b)))
 
 #endif /* _GL_INTPROPS_H */
diff -pruN 0.14.1+dfsg-1/src/libcrun/linux.c 0.15+dfsg-1/src/libcrun/linux.c
--- 0.14.1+dfsg-1/src/libcrun/linux.c	2020-07-03 19:38:11.000000000 +0000
+++ 0.15+dfsg-1/src/libcrun/linux.c	2020-09-23 14:47:06.000000000 +0000
@@ -27,7 +27,7 @@
 #include <unistd.h>
 #include <sys/mount.h>
 #ifdef HAVE_FSCONFIG_CMD_CREATE
-# include <linux/mount.h>
+#  include <linux/mount.h>
 #endif
 #include <sys/syscall.h>
 #include <sys/prctl.h>
@@ -59,7 +59,7 @@
 #define YAJL_STR(x) ((const unsigned char *) (x))
 
 #ifndef RLIMIT_RTTIME
-# define RLIMIT_RTTIME 15
+#  define RLIMIT_RTTIME 15
 #endif
 
 struct remount_s
@@ -120,22 +120,19 @@ get_private_data (struct libcrun_contain
   return container->private_data;
 }
 
-static struct linux_namespace_s namespaces[] =
-  {
-   {"mount", "mnt", CLONE_NEWNS},
-   {"network", "net", CLONE_NEWNET},
-   {"ipc", "ipc", CLONE_NEWIPC},
-   {"pid", "pid", CLONE_NEWPID},
-   {"uts", "uts", CLONE_NEWUTS},
-   {"user", "user", CLONE_NEWUSER},
+static struct linux_namespace_s namespaces[] = { { "mount", "mnt", CLONE_NEWNS },
+                                                 { "network", "net", CLONE_NEWNET },
+                                                 { "ipc", "ipc", CLONE_NEWIPC },
+                                                 { "pid", "pid", CLONE_NEWPID },
+                                                 { "uts", "uts", CLONE_NEWUTS },
+                                                 { "user", "user", CLONE_NEWUSER },
 #ifdef CLONE_NEWCGROUP
-   {"cgroup", "cgroup", CLONE_NEWCGROUP},
+                                                 { "cgroup", "cgroup", CLONE_NEWCGROUP },
 #endif
 #ifdef CLONE_NEWTIME
-   {"time", "time", CLONE_NEWTIME},
+                                                 { "time", "time", CLONE_NEWTIME },
 #endif
-   {NULL, NULL, 0}
-  };
+                                                 { NULL, NULL, 0 } };
 
 static int
 get_and_reset (int *old)
@@ -164,6 +161,7 @@ syscall_clone (unsigned long flags, void
   return (int) syscall (__NR_clone, flags, child_stack);
 #endif
 }
+
 static int
 syscall_fsopen (const char *fs_name, unsigned int flags)
 {
@@ -198,8 +196,7 @@ syscall_fsconfig (int fsfd, unsigned int
 }
 
 static int
-syscall_move_mount (int from_dfd, const char *from_pathname, int to_dfd,
-                    const char *to_pathname, unsigned int flags)
+syscall_move_mount (int from_dfd, const char *from_pathname, int to_dfd, const char *to_pathname, unsigned int flags)
 
 {
 #if defined __NR_move_mount
@@ -217,6 +214,34 @@ syscall_keyctl_join (const char *name)
   return (int) syscall (__NR_keyctl, KEYCTL_JOIN_SESSION_KEYRING, name, 0);
 }
 
+static int
+syscall_pidfd_open (pid_t pid, unsigned int flags)
+{
+#if defined __NR_pidfd_open
+  return (int) syscall (__NR_pidfd_open, pid, flags);
+#else
+  (void) pid;
+  (void) flags;
+  errno = ENOTSUP;
+  return -1;
+#endif
+}
+
+static int
+syscall_pidfd_send_signal (int pidfd, int sig, siginfo_t *info, unsigned int flags)
+{
+#if defined __NR_pidfd_send_signal
+  return (int) syscall (__NR_pidfd_send_signal, pidfd, sig, info, flags);
+#else
+  (void) pidfd;
+  (void) sig;
+  (void) info;
+  (void) flags;
+  errno = ENOTSUP;
+  return -1;
+#endif
+}
+
 int
 libcrun_create_keyring (const char *name, libcrun_error_t *err)
 {
@@ -242,56 +267,55 @@ get_uid_gid_from_def (runtime_spec_schem
 }
 
 struct propagation_flags_s
-  {
-    const char *name;
-    int clear;
-    int flags;
-    int extra_flags;
-  };
+{
+  const char *name;
+  int clear;
+  int flags;
+  int extra_flags;
+};
 
-enum {
-      OPTION_TMPCOPYUP = 1
+enum
+{
+  OPTION_TMPCOPYUP = 1
 };
 
-static struct propagation_flags_s propagation_flags[] =
-  {
-   {"defaults", 0, 0, 0},
-   {"rbind", 0, MS_REC | MS_BIND, 0},
-   {"ro", 0, MS_RDONLY, 0},
-   {"rw", 1, MS_RDONLY, 0},
-   {"suid", 1, MS_NOSUID, 0},
-   {"nosuid", 0, MS_NOSUID, 0},
-   {"dev", 1, MS_NODEV, 0},
-   {"nodev", 0, MS_NODEV, 0},
-   {"exec", 1, MS_NOEXEC, 0},
-   {"noexec", 0, MS_NOEXEC, 0},
-   {"sync", 0, MS_SYNCHRONOUS, 0},
-   {"async", 1, MS_SYNCHRONOUS, 0},
-   {"dirsync", 0, MS_DIRSYNC, 0},
-   {"remount", 0, MS_REMOUNT, 0},
-   {"mand", 0, MS_MANDLOCK, 0},
-   {"nomand", 1, MS_MANDLOCK, 0},
-   {"atime", 1, MS_NOATIME, 0},
-   {"noatime", 0, MS_NOATIME, 0},
-   {"diratime", 1, MS_NODIRATIME, 0},
-   {"nodiratime", 0, MS_NODIRATIME, 0},
-   {"relatime", 0, MS_RELATIME, 0},
-   {"norelatime", 1, MS_RELATIME, 0},
-   {"strictatime", 0, MS_STRICTATIME, 0},
-   {"nostrictatime", 1, MS_STRICTATIME, 0},
-   {"shared", 0, MS_SHARED, 0},
-   {"rshared", 0, MS_REC | MS_SHARED, 0},
-   {"slave", 0, MS_SLAVE, 0},
-   {"rslave", 0, MS_REC | MS_SLAVE, 0},
-   {"private", 0, MS_PRIVATE, 0},
-   {"rprivate", 0, MS_REC | MS_PRIVATE, 0},
-   {"unbindable", 0, MS_UNBINDABLE, 0},
-   {"runbindable", 0, MS_REC | MS_UNBINDABLE, 0},
+static struct propagation_flags_s propagation_flags[] = { { "defaults", 0, 0, 0 },
+                                                          { "bind", 0, MS_BIND, 0 },
+                                                          { "rbind", 0, MS_REC | MS_BIND, 0 },
+                                                          { "ro", 0, MS_RDONLY, 0 },
+                                                          { "rw", 1, MS_RDONLY, 0 },
+                                                          { "suid", 1, MS_NOSUID, 0 },
+                                                          { "nosuid", 0, MS_NOSUID, 0 },
+                                                          { "dev", 1, MS_NODEV, 0 },
+                                                          { "nodev", 0, MS_NODEV, 0 },
+                                                          { "exec", 1, MS_NOEXEC, 0 },
+                                                          { "noexec", 0, MS_NOEXEC, 0 },
+                                                          { "sync", 0, MS_SYNCHRONOUS, 0 },
+                                                          { "async", 1, MS_SYNCHRONOUS, 0 },
+                                                          { "dirsync", 0, MS_DIRSYNC, 0 },
+                                                          { "remount", 0, MS_REMOUNT, 0 },
+                                                          { "mand", 0, MS_MANDLOCK, 0 },
+                                                          { "nomand", 1, MS_MANDLOCK, 0 },
+                                                          { "atime", 1, MS_NOATIME, 0 },
+                                                          { "noatime", 0, MS_NOATIME, 0 },
+                                                          { "diratime", 1, MS_NODIRATIME, 0 },
+                                                          { "nodiratime", 0, MS_NODIRATIME, 0 },
+                                                          { "relatime", 0, MS_RELATIME, 0 },
+                                                          { "norelatime", 1, MS_RELATIME, 0 },
+                                                          { "strictatime", 0, MS_STRICTATIME, 0 },
+                                                          { "nostrictatime", 1, MS_STRICTATIME, 0 },
+                                                          { "shared", 0, MS_SHARED, 0 },
+                                                          { "rshared", 0, MS_REC | MS_SHARED, 0 },
+                                                          { "slave", 0, MS_SLAVE, 0 },
+                                                          { "rslave", 0, MS_REC | MS_SLAVE, 0 },
+                                                          { "private", 0, MS_PRIVATE, 0 },
+                                                          { "rprivate", 0, MS_REC | MS_PRIVATE, 0 },
+                                                          { "unbindable", 0, MS_UNBINDABLE, 0 },
+                                                          { "runbindable", 0, MS_REC | MS_UNBINDABLE, 0 },
 
-   {"tmpcopyup", 0, 0, OPTION_TMPCOPYUP},
+                                                          { "tmpcopyup", 0, 0, OPTION_TMPCOPYUP },
 
-   {NULL, 0, 0, 0}
-  };
+                                                          { NULL, 0, 0, 0 } };
 
 static unsigned long
 get_mount_flags (const char *name, int current_flags, int *found, unsigned long *extra_flags)
@@ -335,7 +359,7 @@ get_mount_flags_or_option (const char *n
 }
 
 int
-pivot_root (const char * new_root, const char * put_old)
+pivot_root (const char *new_root, const char *put_old)
 {
   return syscall (__NR_pivot_root, new_root, put_old);
 }
@@ -423,7 +447,7 @@ finalize_mounts (libcrun_container_t *co
       r = next;
     }
 
- cleanup:
+cleanup:
   while (r)
     {
       struct remount_s *next = r->next;
@@ -443,7 +467,7 @@ open_mount_target (libcrun_container_t *
   int rootfsfd = get_private_data (container)->rootfsfd;
 
   if (rootfsfd < 0)
-   return crun_make_error (err, 0, "invalid rootfs state");
+    return crun_make_error (err, 0, "invalid rootfs state");
 
   return safe_openat (rootfsfd, rootfs, rootfs_len, target_rel, O_PATH | O_CLOEXEC, 0, err);
 }
@@ -486,18 +510,20 @@ fs_move_mount_to (int fd, int dirfd, con
 #endif
 }
 
+enum
+{
+  /* Do not apply any label to the mount.  */
+  LABEL_NONE = 0,
+  /* Apply the label as a mount option.  */
+  LABEL_MOUNT,
+  /* Apply the label using setxattr.  */
+  LABEL_XATTR,
+};
+
 static int
-do_mount (libcrun_container_t *container,
-          const char *source,
-          int targetfd,
-          const char *target,
-          const char *fstype,
-          unsigned long mountflags,
-          const void *data,
-          bool skip_labelling,
-          libcrun_error_t *err)
+do_mount (libcrun_container_t *container, const char *source, int targetfd, const char *target, const char *fstype,
+          unsigned long mountflags, const void *data, int label_how, libcrun_error_t *err)
 {
-  const char *label = container->container_def->linux->mount_label;
   cleanup_free char *data_with_label = NULL;
   const char *temporary_mount = NULL;
   bool use_temporary_mount = false;
@@ -505,18 +531,23 @@ do_mount (libcrun_container_t *container
   bool single_instance = false;
   bool needs_remount = false;
   cleanup_close int fd = -1;
+  const char *label = NULL;
   char target_buffer[64];
   int ret = 0;
 
 #define ALL_PROPAGATIONS_NO_REC (MS_SHARED | MS_PRIVATE | MS_SLAVE | MS_UNBINDABLE)
 #define ALL_PROPAGATIONS (MS_REC | ALL_PROPAGATIONS_NO_REC)
 
+  if (container->container_def->linux && container->container_def->linux->mount_label)
+    label = container->container_def->linux->mount_label;
+  else
+    label_how = LABEL_NONE;
+
   if (targetfd >= 0)
     {
-      use_temporary_mount =                                             \
-        (get_private_data (container)->unshare_flags & CLONE_NEWNS)     \
-        && get_private_data (container)->tmpmountdir                    \
-        && (mountflags & (ALL_PROPAGATIONS | MS_BIND | MS_RDONLY));
+      use_temporary_mount = (get_private_data (container)->unshare_flags & CLONE_NEWNS)
+                            && get_private_data (container)->tmpmountdir
+                            && (mountflags & (ALL_PROPAGATIONS | MS_BIND | MS_RDONLY));
       sprintf (target_buffer, "/proc/self/fd/%d", targetfd);
       real_target = target_buffer;
     }
@@ -538,10 +569,10 @@ do_mount (libcrun_container_t *container
         temporary_mount = get_private_data (container)->tmpmountfile;
     }
 
-  if (!skip_labelling)
+  if (label_how == LABEL_MOUNT)
     {
       ret = add_selinux_mount_label (&data_with_label, data, label, err);
-      if  (ret < 0)
+      if (ret < 0)
         return ret;
       data = data_with_label;
     }
@@ -592,6 +623,16 @@ do_mount (libcrun_container_t *container
               return fd;
             }
 
+#ifdef HAVE_FGETXATTR
+          if (label_how == LABEL_XATTR)
+            {
+              char proc_file[32];
+              sprintf (proc_file, "/proc/self/fd/%d", fd);
+
+              /* We need to go through the proc_file since fd itself is opened as O_PATH.  */
+              (void) setxattr (proc_file, "security.selinux", label, strlen (label), 0);
+            }
+#endif
           /* We have a fd pointing to the new mountpoint (done in a safe location).  We can move
              the mount to the destination under the rootfs.  */
           if (use_temporary_mount)
@@ -633,10 +674,7 @@ do_mount (libcrun_container_t *container
 
   if (needs_remount)
     {
-      unsigned long remount_flags = \
-        MS_REMOUNT                        \
-        | (single_instance ? 0 : MS_BIND) \
-        | (mountflags & ~ALL_PROPAGATIONS);
+      unsigned long remount_flags = MS_REMOUNT | (single_instance ? 0 : MS_BIND) | (mountflags & ~ALL_PROPAGATIONS);
 
       if ((remount_flags & MS_RDONLY) == 0)
         {
@@ -655,8 +693,7 @@ do_mount (libcrun_container_t *container
             }
 
           /* The remount owns the fd.  */
-          r = make_remount (get_and_reset (&fd), target, remount_flags, data,
-                            get_private_data (container)->remounts);
+          r = make_remount (get_and_reset (&fd), target, remount_flags, data, get_private_data (container)->remounts);
           get_private_data (container)->remounts = r;
         }
     }
@@ -665,10 +702,7 @@ do_mount (libcrun_container_t *container
 }
 
 static int
-do_mount_cgroup_v2 (libcrun_container_t *container,
-                    int targetfd,
-                    const char *target,
-                    unsigned long mountflags,
+do_mount_cgroup_v2 (libcrun_container_t *container, int targetfd, const char *target, unsigned long mountflags,
                     libcrun_error_t *err)
 {
   int ret;
@@ -678,14 +712,15 @@ do_mount_cgroup_v2 (libcrun_container_t
   if (cgroup_mode < 0)
     return cgroup_mode;
 
-  ret = do_mount (container, "cgroup2", targetfd, target, "cgroup2", mountflags, NULL, 1, err);
+  ret = do_mount (container, "cgroup2", targetfd, target, "cgroup2", mountflags, NULL, LABEL_NONE, err);
   if (UNLIKELY (ret < 0))
     {
       if (crun_error_get_errno (err) == EPERM || crun_error_get_errno (err) == EBUSY)
         {
           crun_error_release (err);
 
-          ret = do_mount (container, "/sys/fs/cgroup", targetfd, target, NULL, MS_BIND | mountflags, NULL, 1, err);
+          ret = do_mount (container, "/sys/fs/cgroup", targetfd, target, NULL, MS_BIND | mountflags, NULL, LABEL_NONE,
+                          err);
         }
       return ret;
     }
@@ -708,12 +743,8 @@ has_mount_for (libcrun_container_t *cont
 }
 
 static int
-do_mount_cgroup_systemd_v1 (libcrun_container_t *container,
-                            const char *source,
-                            int targetfd,
-                            const char *target,
-                            unsigned long mountflags,
-                            libcrun_error_t *err)
+do_mount_cgroup_systemd_v1 (libcrun_container_t *container, const char *source, int targetfd, const char *target,
+                            unsigned long mountflags, libcrun_error_t *err)
 {
   int ret;
   cleanup_close int fd = -1;
@@ -723,7 +754,7 @@ do_mount_cgroup_systemd_v1 (libcrun_cont
 
   mountflags = mountflags & ~MS_BIND;
 
-  ret = do_mount (container, source, targetfd, target, "tmpfs", mountflags, "size=1024k", 1, err);
+  ret = do_mount (container, source, targetfd, target, "tmpfs", mountflags, "size=1024k", LABEL_NONE, err);
   if (UNLIKELY (ret < 0))
     return ret;
 
@@ -738,21 +769,18 @@ do_mount_cgroup_systemd_v1 (libcrun_cont
     return crun_make_error (err, errno, "mkdir `%s`", subsystem);
 
   fd = openat (targetfd, subsystem, O_CLOEXEC | O_DIRECTORY | O_NOFOLLOW);
-  if (UNLIKELY (ret < 0))
+  if (UNLIKELY (fd < 0))
     return crun_make_error (err, errno, "open `%s`", subsystem_path);
 
   xasprintf (&subsystem_path, "%s/%s", target, subsystem);
 
-  return do_mount (container, "cgroup", fd, subsystem_path, "cgroup", mountflags, "none,name=systemd,xattr", true, err);
+  return do_mount (container, "cgroup", fd, subsystem_path, "cgroup", mountflags, "none,name=systemd,xattr", LABEL_NONE,
+                   err);
 }
 
 static int
-do_mount_cgroup_v1 (libcrun_container_t *container,
-                    const char *source,
-                    int targetfd,
-                    const char *target,
-                    unsigned long mountflags,
-                    libcrun_error_t *err)
+do_mount_cgroup_v1 (libcrun_container_t *container, const char *source, int targetfd, const char *target,
+                    unsigned long mountflags, libcrun_error_t *err)
 {
   int ret;
   const cgroups_subsystem_t *subsystems = NULL;
@@ -770,7 +798,7 @@ do_mount_cgroup_v1 (libcrun_container_t
   if (UNLIKELY (subsystems == NULL))
     return -1;
 
-  ret = do_mount (container, source, targetfd, target, "tmpfs", mountflags & ~MS_RDONLY, "size=1024k", true, err);
+  ret = do_mount (container, source, targetfd, target, "tmpfs", mountflags & ~MS_RDONLY, "size=1024k", LABEL_NONE, err);
   if (UNLIKELY (ret < 0))
     return ret;
 
@@ -826,12 +854,13 @@ do_mount_cgroup_v1 (libcrun_container_t
         return crun_make_error (err, errno, "mkdir `%s`", subsystem_path);
 
       subsystemfd = openat (targetfd, subsystem, O_CLOEXEC | O_DIRECTORY | O_NOFOLLOW);
-      if (UNLIKELY (ret < 0))
+      if (UNLIKELY (subsystemfd < 0))
         return crun_make_error (err, errno, "open `%s`", subsystem_path);
 
       if (has_cgroupns)
         {
-          ret = do_mount (container, source_path, subsystemfd, subsystem_path, "cgroup", mountflags, subsystem_fqn, 1, err);
+          ret = do_mount (container, source_path, subsystemfd, subsystem_path, "cgroup", mountflags, subsystem_fqn,
+                          LABEL_NONE, err);
           if (UNLIKELY (ret < 0))
             {
               if (crun_error_get_errno (err) == ENOENT || crun_error_get_errno (err) == ENODEV)
@@ -845,7 +874,8 @@ do_mount_cgroup_v1 (libcrun_container_t
         }
       else
         {
-          ret = do_mount (container, source_path, subsystemfd, subsystem_path, NULL, MS_BIND | mountflags, NULL, 1, err);
+          ret = do_mount (container, source_path, subsystemfd, subsystem_path, NULL, MS_BIND | mountflags, NULL,
+                          LABEL_NONE, err);
           if (UNLIKELY (ret < 0))
             {
               if (crun_error_get_errno (err) != ENOENT)
@@ -854,7 +884,8 @@ do_mount_cgroup_v1 (libcrun_container_t
               crun_error_release (err);
 
               /* We might already be in a container.  Mount the source subsystem.  */
-              ret = do_mount (container, source_subsystem, subsystemfd, subsystem_path, NULL, MS_BIND | mountflags, NULL, 1, err);
+              ret = do_mount (container, source_subsystem, subsystemfd, subsystem_path, NULL, MS_BIND | mountflags,
+                              NULL, LABEL_NONE, err);
               if (UNLIKELY (ret < 0))
                 return ret;
             }
@@ -869,12 +900,8 @@ do_mount_cgroup_v1 (libcrun_container_t
 }
 
 static int
-do_mount_cgroup (libcrun_container_t *container,
-                 const char *source,
-                 int targetfd,
-                 const char *target,
-                 unsigned long mountflags,
-                 libcrun_error_t *err)
+do_mount_cgroup (libcrun_container_t *container, const char *source, int targetfd, const char *target,
+                 unsigned long mountflags, libcrun_error_t *err)
 {
   int cgroup_mode;
 
@@ -905,16 +932,13 @@ struct device_s
   gid_t gid;
 };
 
-struct device_s needed_devs[] =
-  {
-   {"/dev/null", "c", 1, 3, 0666, 0, 0},
-   {"/dev/zero", "c", 1, 5, 0666, 0, 0},
-   {"/dev/full", "c", 1, 7, 0666, 0, 0},
-   {"/dev/tty", "c", 5, 0, 0666, 0, 0},
-   {"/dev/random", "c", 1, 8, 0666, 0, 0},
-   {"/dev/urandom", "c", 1, 9, 0666, 0, 0},
-   {}
-  };
+struct device_s needed_devs[] = { { "/dev/null", "c", 1, 3, 0666, 0, 0 },
+                                  { "/dev/zero", "c", 1, 5, 0666, 0, 0 },
+                                  { "/dev/full", "c", 1, 7, 0666, 0, 0 },
+                                  { "/dev/tty", "c", 5, 0, 0666, 0, 0 },
+                                  { "/dev/random", "c", 1, 8, 0666, 0, 0 },
+                                  { "/dev/urandom", "c", 1, 9, 0666, 0, 0 },
+                                  {} };
 
 /* Check if the specified path is a direct child of /dev.  If it is
  return a pointer to the basename.  */
@@ -933,7 +957,8 @@ relative_path_under_dev (const char *pat
 }
 
 static int
-create_dev (libcrun_container_t *container, int devfd, struct device_s *device, bool binds, bool ensure_parent_dir, libcrun_error_t *err)
+create_dev (libcrun_container_t *container, int devfd, struct device_s *device, bool binds, bool ensure_parent_dir,
+            libcrun_error_t *err)
 {
   int ret;
   dev_t dev;
@@ -948,7 +973,7 @@ create_dev (libcrun_container_t *contain
 
   if (binds)
     {
-      cleanup_close int fd = - 1;
+      cleanup_close int fd = -1;
       const char *rel_path = device->path;
 
       while (*rel_path == '/')
@@ -973,7 +998,7 @@ create_dev (libcrun_container_t *contain
 
       sprintf (fd_buffer, "/proc/self/fd/%d", fd);
 
-      ret = do_mount (container, fullname, fd, fd_buffer, NULL, MS_BIND | MS_PRIVATE, NULL, 0, err);
+      ret = do_mount (container, fullname, fd, fd_buffer, NULL, MS_BIND | MS_PRIVATE, NULL, LABEL_MOUNT, err);
       if (UNLIKELY (ret < 0))
         return ret;
     }
@@ -1059,7 +1084,6 @@ create_dev (libcrun_container_t *contain
           if (UNLIKELY (ret < 0))
             return crun_make_error (err, errno, "chown `%s`", device->path);
         }
-
     }
   return 0;
 }
@@ -1071,16 +1095,13 @@ struct symlink_s
   bool force;
 };
 
-static struct symlink_s symlinks[] =
-  {
-    {"/proc/self/fd", "fd", false},
-    {"/proc/self/fd/0", "stdin", false},
-    {"/proc/self/fd/1", "stdout", false},
-    {"/proc/self/fd/2", "stderr", false},
-    {"/proc/kcore", "core", false},
-    {"pts/ptmx", "ptmx", true},
-    {NULL, NULL, false}
-  };
+static struct symlink_s symlinks[] = { { "/proc/self/fd", "fd", false },
+                                       { "/proc/self/fd/0", "stdin", false },
+                                       { "/proc/self/fd/1", "stdout", false },
+                                       { "/proc/self/fd/2", "stderr", false },
+                                       { "/proc/kcore", "core", false },
+                                       { "pts/ptmx", "ptmx", true },
+                                       { NULL, NULL, false } };
 
 static int
 create_missing_devs (libcrun_container_t *container, bool binds, libcrun_error_t *err)
@@ -1099,13 +1120,10 @@ create_missing_devs (libcrun_container_t
 
   for (i = 0; i < def->linux->devices_len; i++)
     {
-      struct device_s device = {def->linux->devices[i]->path,
-                                def->linux->devices[i]->type,
-                                def->linux->devices[i]->major,
-                                def->linux->devices[i]->minor,
-                                def->linux->devices[i]->file_mode,
-                                def->linux->devices[i]->uid,
-                                def->linux->devices[i]->gid,
+      struct device_s device = {
+        def->linux->devices[i]->path,  def->linux->devices[i]->type,      def->linux->devices[i]->major,
+        def->linux->devices[i]->minor, def->linux->devices[i]->file_mode, def->linux->devices[i]->uid,
+        def->linux->devices[i]->gid,
       };
 
       if (! def->linux->devices[i]->file_mode_present)
@@ -1125,19 +1143,19 @@ create_missing_devs (libcrun_container_t
 
   for (i = 0; symlinks[i].target; i++)
     {
-retry_symlink:
+    retry_symlink:
       ret = symlinkat (symlinks[i].path, devfd, symlinks[i].target);
       if (UNLIKELY (ret < 0))
         {
           int saved_errno = errno;
 
-          if (errno == EEXIST && !symlinks[i].force)
+          if (errno == EEXIST && ! symlinks[i].force)
             continue;
 
           /* If the symlink should be forced, make sure to unlink any existing file at the same path.  */
           if (errno == EEXIST)
             {
-retry_unlink:
+            retry_unlink:
               ret = unlinkat (devfd, symlinks[i].target, 0);
               if (ret < 0 && errno == EISDIR)
                 ret = unlinkat (devfd, symlinks[i].target, AT_REMOVEDIR);
@@ -1150,7 +1168,7 @@ retry_unlink:
                       sprintf (procpath, "/proc/self/fd/%d", tfd);
 
                       if (umount2 (procpath, MNT_DETACH) == 0)
-                          goto retry_unlink;
+                        goto retry_unlink;
                     }
                 }
               if (ret == 0)
@@ -1164,10 +1182,7 @@ retry_unlink:
 }
 
 static int
-do_masked_or_readonly_path (libcrun_container_t *container,
-                            int rootfsfd,
-                            const char *rel_path,
-                            bool readonly,
+do_masked_or_readonly_path (libcrun_container_t *container, int rootfsfd, const char *rel_path, bool readonly,
                             libcrun_error_t *err)
 {
   cleanup_close int pathfd = -1;
@@ -1192,7 +1207,8 @@ do_masked_or_readonly_path (libcrun_cont
       char source_buffer[64];
       sprintf (source_buffer, "/proc/self/fd/%d", pathfd);
 
-      ret = do_mount (container, source_buffer, pathfd, rel_path, NULL, MS_BIND | MS_PRIVATE | MS_RDONLY | MS_REC, NULL, true, err);
+      ret = do_mount (container, source_buffer, pathfd, rel_path, NULL, MS_BIND | MS_PRIVATE | MS_RDONLY | MS_REC, NULL,
+                      LABEL_NONE, err);
       if (UNLIKELY (ret < 0))
         return ret;
     }
@@ -1205,7 +1221,8 @@ do_masked_or_readonly_path (libcrun_cont
       if ((mode & S_IFMT) == S_IFDIR)
         ret = do_mount (container, "tmpfs", pathfd, rel_path, "tmpfs", MS_RDONLY, "size=0k", false, err);
       else
-        ret = do_mount (container, "/dev/null", pathfd, rel_path, NULL, MS_BIND | MS_UNBINDABLE | MS_REC, NULL, false, err);
+        ret = do_mount (container, "/dev/null", pathfd, rel_path, NULL, MS_BIND | MS_UNBINDABLE | MS_REC, NULL,
+                        LABEL_MOUNT, err);
       if (UNLIKELY (ret < 0))
         return ret;
     }
@@ -1258,7 +1275,7 @@ do_pivot (libcrun_container_t *container
   if (UNLIKELY (ret < 0))
     return crun_make_error (err, errno, "fchdir `%s`", rootfs);
 
-  ret = do_mount (container, NULL, -1, ".", NULL, MS_REC | MS_PRIVATE, NULL, 0, err);
+  ret = do_mount (container, NULL, -1, ".", NULL, MS_REC | MS_PRIVATE, NULL, LABEL_MOUNT, err);
   if (UNLIKELY (ret < 0))
     return ret;
 
@@ -1287,9 +1304,8 @@ static int
 get_default_flags (libcrun_container_t *container, const char *destination, char **data)
 {
   if (strcmp (destination, "/proc") == 0)
-      return 0;
-  if (strcmp (destination, "/dev/cgroup") == 0
-      || strcmp (destination, "/sys/fs/cgroup") == 0)
+    return 0;
+  if (strcmp (destination, "/dev/cgroup") == 0 || strcmp (destination, "/sys/fs/cgroup") == 0)
     {
       *data = xstrdup ("none,name=");
       return MS_NOEXEC | MS_NOSUID | MS_STRICTATIME;
@@ -1305,7 +1321,7 @@ get_default_flags (libcrun_container_t *
       return MS_NOEXEC | MS_NOSUID | MS_NODEV;
     }
   if (strcmp (destination, "/dev/mqueue") == 0)
-      return MS_NOEXEC | MS_NOSUID | MS_NODEV;
+    return MS_NOEXEC | MS_NOSUID | MS_NODEV;
   if (strcmp (destination, "/dev/pts") == 0)
     {
       if (container->host_uid == 0)
@@ -1315,7 +1331,7 @@ get_default_flags (libcrun_container_t *
       return MS_NOEXEC | MS_NOSUID;
     }
   if (strcmp (destination, "/sys") == 0)
-      return MS_NOEXEC | MS_NOSUID | MS_NODEV;
+    return MS_NOEXEC | MS_NOSUID | MS_NODEV;
 
   return 0;
 }
@@ -1332,13 +1348,9 @@ do_mounts (libcrun_container_t *containe
   {
     int *fd;
     const char *fstype;
-  }
-  fsfd_mounts[] =
-    {
-     {.fstype = "proc", .fd = &(get_private_data (container)->procfsfd)},
-     {.fstype = "mqueue", .fd = &(get_private_data (container)->mqueuefsfd)},
-     {.fd = NULL, .fstype = NULL}
-    };
+  } fsfd_mounts[] = { { .fstype = "proc", .fd = &(get_private_data (container)->procfsfd) },
+                      { .fstype = "mqueue", .fd = &(get_private_data (container)->mqueuefsfd) },
+                      { .fd = NULL, .fstype = NULL } };
 
   for (i = 0; i < def->mounts_len; i++)
     {
@@ -1367,30 +1379,17 @@ do_mounts (libcrun_container_t *containe
 
           for (j = 0; j < def->mounts[i]->options_len; j++)
             flags |= get_mount_flags_or_option (def->mounts[i]->options[j], flags, &extra_flags, &data);
-
-          if (type == NULL)
-            {
-              size_t j;
-
-              for (j = 0; j < def->mounts[i]->options_len; j++)
-                {
-                  if (strcmp (def->mounts[i]->options[j], "bind") == 0 || strcmp (def->mounts[i]->options[j], "rbind") == 0)
-                    {
-                      type = "bind";
-                      break;
-                    }
-                }
-            }
         }
 
-      if (type == NULL)
+      if (type == NULL && (flags & MS_BIND) == 0)
         return crun_make_error (err, 0, "invalid mount type for `%s`", def->mounts[i]->destination);
 
-      if (strcmp (type, "bind") == 0)
+      if (flags & MS_BIND)
         {
           if (strcmp (def->mounts[i]->destination, "/dev") == 0)
             get_private_data (container)->mount_dev_from_host = true;
-          flags |= MS_BIND;
+          /* It is used only for error messages.  */
+          type = "bind";
         }
 
       if (def->mounts[i]->source && (flags & MS_BIND))
@@ -1421,8 +1420,7 @@ do_mounts (libcrun_container_t *containe
       if (is_dir)
         {
           /* Enforce /proc and /sys to be directories without any symlink under rootfs.  */
-          bool must_be_dir_under_root = strcmp (type, "sysfs") == 0
-            || strcmp (type, "proc") == 0;
+          bool must_be_dir_under_root = strcmp (type, "sysfs") == 0 || strcmp (type, "proc") == 0;
 
           ret = crun_safe_ensure_directory_at (rootfsfd, rootfs, rootfs_len, target, 01755, err);
           if (UNLIKELY (ret < 0))
@@ -1476,7 +1474,7 @@ do_mounts (libcrun_container_t *containe
             ret = fs_move_mount_to (mfd, rootfsfd, target);
             if (LIKELY (ret == 0))
               {
-                ret = do_mount (container, NULL, mfd, target, NULL, flags, data, true, err);
+                ret = do_mount (container, NULL, mfd, target, NULL, flags, data, LABEL_NONE, err);
                 if (UNLIKELY (ret < 0))
                   return ret;
                 mounted = true;
@@ -1506,11 +1504,14 @@ do_mounts (libcrun_container_t *containe
         }
       else
         {
-          bool skip_labelling = strcmp (type, "sysfs") == 0
-            || strcmp (type, "proc") == 0
-            || strcmp (type, "mqueue") == 0;
+          int label_how = LABEL_MOUNT;
 
-          ret = do_mount (container, source, targetfd, target, type, flags, data, skip_labelling, err);
+          if (strcmp (type, "sysfs") == 0 || strcmp (type, "proc") == 0)
+            label_how = LABEL_NONE;
+          else if (strcmp (type, "mqueue") == 0)
+            label_how = LABEL_XATTR;
+
+          ret = do_mount (container, source, targetfd, target, type, flags, data, label_how, err);
           if (UNLIKELY (ret < 0))
             return ret;
         }
@@ -1573,14 +1574,14 @@ get_notify_fd (libcrun_context_t *contex
   if (UNLIKELY (chmod (host_path, 0777) < 0))
     return crun_make_error (err, errno, "chmod `%s`", host_path);
 
-#ifdef HAVE_FGETXATTR
-  if (container && container->container_def->linux->mount_label)
+#  ifdef HAVE_FGETXATTR
+  if (container && container->container_def->linux && container->container_def->linux->mount_label)
     {
       /* Ignore the error, the worse that can happen is that the container fails to notify it is ready.  */
-      (void ) setxattr (host_path, "security.selinux", container->container_def->linux->mount_label,
-                        strlen (container->container_def->linux->mount_label), 0);
+      (void) setxattr (host_path, "security.selinux", container->container_def->linux->mount_label,
+                       strlen (container->container_def->linux->mount_label), 0);
     }
-#endif
+#  endif
 
   *notify_socket_out = get_and_reset (&notify_fd);
   return 1;
@@ -1629,7 +1630,8 @@ do_finalize_notify_socket (libcrun_conta
   cleanup_free char *container_notify_socket_path_dir_alloc = NULL;
   char *container_notify_socket_path_dir = NULL;
 
-  get_private_data (container)->host_notify_socket_path = get_private_data (container)->container_notify_socket_path = NULL;
+  get_private_data (container)->host_notify_socket_path = get_private_data (container)->container_notify_socket_path
+      = NULL;
 
   if (host_notify_socket_path == NULL || container_notify_socket_path == NULL)
     return 0;
@@ -1642,9 +1644,9 @@ do_finalize_notify_socket (libcrun_conta
     return ret;
 
   ret = do_mount (container, host_notify_socket_path, -1, container_notify_socket_path_dir, NULL,
-                  MS_BIND | MS_REC | MS_PRIVATE, NULL, false, err);
+                  MS_BIND | MS_REC | MS_PRIVATE, NULL, LABEL_MOUNT, err);
   if (UNLIKELY (ret < 0))
-   return ret;
+    return ret;
 
   return 0;
 }
@@ -1686,8 +1688,8 @@ make_parent_mount_private (const char *r
 }
 
 static int
-allocate_tmp_mounts (libcrun_container_t *container, char **parent_tmpdir_out,
-                     char **tmpdir_out, char **tmpfile_out, libcrun_error_t *err)
+allocate_tmp_mounts (libcrun_container_t *container, char **parent_tmpdir_out, char **tmpdir_out, char **tmpfile_out,
+                     libcrun_error_t *err)
 {
   cleanup_free char *state_dir = NULL;
   cleanup_free char *tmpdir = NULL;
@@ -1695,20 +1697,18 @@ allocate_tmp_mounts (libcrun_container_t
   char *where = NULL;
   int ret;
 
-  state_dir = libcrun_get_state_directory (container->context->state_root,
-                                           container->context->id);
+  state_dir = libcrun_get_state_directory (container->context->state_root, container->context->id);
 
   where = state_dir;
 
- repeat:
+repeat:
   xasprintf (&tmpdir, "%s/tmp-dir", where);
   ret = crun_ensure_directory (tmpdir, 0700, true, err);
   if (UNLIKELY (ret < 0))
     {
       /*If the current user has no access to the state directory (e.g. running in an
         user namespace), then try with a temporary directory.  */
-      if (crun_error_get_errno (err) == EPERM           \
-          || crun_error_get_errno (err) == EROFS        \
+      if (crun_error_get_errno (err) == EPERM || crun_error_get_errno (err) == EROFS
           || crun_error_get_errno (err) == EACCES)
         {
           char tmp_dir[32];
@@ -1773,7 +1773,7 @@ cleanup_rmdir (void *p)
         }
       unlinkat (AT_FDCWD, *pp, AT_REMOVEDIR);
     }
-    exit:
+exit:
   free (*pp);
   return 0;
 }
@@ -1785,7 +1785,7 @@ libcrun_set_mounts (libcrun_container_t
   int ret = 0, is_user_ns = 0;
   unsigned long rootfs_propagation = 0;
   cleanup_close int rootfsfd_cleanup = -1;
-  __attribute__((cleanup (cleanup_rmdir))) char *tmpdirparent = NULL;
+  __attribute__ ((cleanup (cleanup_rmdir))) char *tmpdirparent = NULL;
   int rootfsfd = -1;
 
   if (def->linux->rootfs_propagation)
@@ -1808,7 +1808,7 @@ libcrun_set_mounts (libcrun_container_t
       get_private_data (container)->tmpmountdir = tmpdir;
       get_private_data (container)->tmpmountfile = tmpfile;
 
-      ret = do_mount (container, NULL, -1, "/", NULL, rootfs_propagation, NULL, 0, err);
+      ret = do_mount (container, NULL, -1, "/", NULL, rootfs_propagation, NULL, LABEL_MOUNT, err);
       if (UNLIKELY (ret < 0))
         return ret;
 
@@ -1820,18 +1820,18 @@ libcrun_set_mounts (libcrun_container_t
       if (UNLIKELY (ret < 0))
         return ret;
 
-      ret = do_mount (container, rootfs, -1, rootfs, NULL, MS_BIND | MS_REC | MS_PRIVATE, NULL, 0, err);
+      ret = do_mount (container, rootfs, -1, rootfs, NULL, MS_BIND | MS_REC | MS_PRIVATE, NULL, LABEL_MOUNT, err);
       if (UNLIKELY (ret < 0))
         return ret;
 
-      do_mount (container, NULL, -1, "/tmp", NULL, MS_PRIVATE, NULL, 0, err);
+      do_mount (container, NULL, -1, "/tmp", NULL, MS_PRIVATE, NULL, LABEL_MOUNT, err);
     }
 
   if (rootfs == NULL)
     rootfsfd = AT_FDCWD;
   else
     {
-      rootfsfd = rootfsfd_cleanup = open (rootfs, O_PATH|O_CLOEXEC);
+      rootfsfd = rootfsfd_cleanup = open (rootfs, O_PATH | O_CLOEXEC);
       if (UNLIKELY (rootfsfd < 0))
         return crun_make_error (err, errno, "open `%s`", rootfs);
     }
@@ -1862,14 +1862,14 @@ libcrun_set_mounts (libcrun_container_t
     return ret;
 
   is_user_ns = (get_private_data (container)->unshare_flags & CLONE_NEWUSER);
-  if (!is_user_ns)
+  if (! is_user_ns)
     {
       is_user_ns = check_running_in_user_namespace (err);
       if (UNLIKELY (is_user_ns < 0))
         return is_user_ns;
     }
 
-  if (!get_private_data (container)->mount_dev_from_host)
+  if (! get_private_data (container)->mount_dev_from_host)
     {
       ret = create_missing_devs (container, is_user_ns ? true : false, err);
       if (UNLIKELY (ret < 0))
@@ -1962,7 +1962,8 @@ libcrun_do_pivot_root (libcrun_container
             return ret;
         }
 
-      ret = do_mount (container, NULL, -1, "/", NULL, get_private_data (container)->rootfs_propagation, NULL, 0, err);
+      ret = do_mount (container, NULL, -1, "/", NULL, get_private_data (container)->rootfs_propagation, NULL,
+                      LABEL_MOUNT, err);
       if (UNLIKELY (ret < 0))
         return ret;
     }
@@ -1982,9 +1983,9 @@ libcrun_do_pivot_root (libcrun_container
 
 /* If one of stdin, stdout, stderr are pointing to /dev/null on
  * the outside of the container, this moves it to /dev/null inside
- * of the container. This needs to run afer pivot/chroot-ing. */
+ * of the container. This needs to run after pivot/chroot-ing. */
 int
-libcrun_reopen_dev_null (libcrun_error_t * err)
+libcrun_reopen_dev_null (libcrun_error_t *err)
 {
   struct stat dev_null;
   struct stat statbuf;
@@ -1997,19 +1998,19 @@ libcrun_reopen_dev_null (libcrun_error_t
     return crun_make_error (err, errno, "failed open()ing /dev/null");
 
   if (UNLIKELY (fstat (fd, &dev_null) == -1))
-      return crun_make_error (err, errno, "failed stat()ing /dev/null");
+    return crun_make_error (err, errno, "failed stat()ing /dev/null");
 
   for (i = 0; i <= 2; i++)
     {
       if (UNLIKELY (fstat (i, &statbuf) == -1))
-	  return crun_make_error (err, errno, "failed stat()ing fd %d", i);
+        return crun_make_error (err, errno, "failed stat()ing fd %d", i);
       if (statbuf.st_rdev == dev_null.st_rdev)
-	{
-	  /* This FD is pointing to /dev/null. Point it to /dev/null inside
-	   * of the container. */
-	  if (UNLIKELY (dup2 (fd, i) == -1))
-	    return crun_make_error (err, errno, "failed dup2()ing %d", i);
-	}
+        {
+          /* This FD is pointing to /dev/null. Point it to /dev/null inside
+           * of the container. */
+          if (UNLIKELY (dup2 (fd, i) == -1))
+            return crun_make_error (err, errno, "failed dup2()ing %d", i);
+        }
     }
   return 0;
 }
@@ -2151,7 +2152,7 @@ libcrun_set_usernamespace (libcrun_conta
   if ((get_private_data (container)->unshare_flags & CLONE_NEWUSER) == 0)
     return 0;
 
-  if (!def->linux->uid_mappings_len)
+  if (! def->linux->uid_mappings_len)
     {
       uid_map_len = format_default_id_mapping (&uid_map, container->container_uid, container->host_uid, 1);
       if (uid_map == NULL)
@@ -2171,10 +2172,8 @@ libcrun_set_usernamespace (libcrun_conta
         {
           size_t len;
 
-          len = sprintf (buffer, MAPPING_FMT_SIZE,
-                         def->linux->uid_mappings[s]->container_id,
-                         def->linux->uid_mappings[s]->host_id,
-                         def->linux->uid_mappings[s]->size);
+          len = sprintf (buffer, MAPPING_FMT_SIZE, def->linux->uid_mappings[s]->container_id,
+                         def->linux->uid_mappings[s]->host_id, def->linux->uid_mappings[s]->size);
           memcpy (uid_map + written, buffer, len);
           written += len;
         }
@@ -2182,7 +2181,7 @@ libcrun_set_usernamespace (libcrun_conta
       uid_map_len = written;
     }
 
-  if (!def->linux->gid_mappings_len)
+  if (! def->linux->gid_mappings_len)
     {
       gid_map_len = format_default_id_mapping (&gid_map, container->container_gid, container->host_uid, 0);
       if (gid_map == NULL)
@@ -2202,10 +2201,8 @@ libcrun_set_usernamespace (libcrun_conta
         {
           size_t len;
 
-          len = sprintf (buffer, MAPPING_FMT_SIZE,
-                         def->linux->gid_mappings[s]->container_id,
-                         def->linux->gid_mappings[s]->host_id,
-                         def->linux->gid_mappings[s]->size);
+          len = sprintf (buffer, MAPPING_FMT_SIZE, def->linux->gid_mappings[s]->container_id,
+                         def->linux->gid_mappings[s]->host_id, def->linux->gid_mappings[s]->size);
           memcpy (gid_map + written, buffer, len);
           written += len;
         }
@@ -2221,7 +2218,7 @@ libcrun_set_usernamespace (libcrun_conta
 
       xasprintf (&gid_map_file, "/proc/%d/gid_map", pid);
       ret = write_file (gid_map_file, gid_map, gid_map_len, err);
-      if (ret < 0 && !def->linux->gid_mappings_len)
+      if (ret < 0 && ! def->linux->gid_mappings_len)
         {
           size_t single_mapping_len;
           char single_mapping[32];
@@ -2246,13 +2243,13 @@ libcrun_set_usernamespace (libcrun_conta
 
       xasprintf (&uid_map_file, "/proc/%d/uid_map", pid);
       ret = write_file (uid_map_file, uid_map, uid_map_len, err);
-      if (ret < 0 && !def->linux->uid_mappings_len)
+      if (ret < 0 && ! def->linux->uid_mappings_len)
         {
           size_t single_mapping_len;
           char single_mapping[32];
           crun_error_release (err);
 
-          if (!get_private_data (container)->deny_setgroups)
+          if (! get_private_data (container)->deny_setgroups)
             {
               ret = deny_setgroups (container, pid, err);
               if (UNLIKELY (ret < 0))
@@ -2271,8 +2268,8 @@ libcrun_set_usernamespace (libcrun_conta
 #undef MAPPING_FMT_1
 }
 
-#define CAP_TO_MASK_0(x) (1L << ((x) & 31))
-#define CAP_TO_MASK_1(x) CAP_TO_MASK_0(x - 32)
+#define CAP_TO_MASK_0(x) (1L << ((x) &31))
+#define CAP_TO_MASK_1(x) CAP_TO_MASK_0 (x - 32)
 
 struct all_caps_s
 {
@@ -2291,6 +2288,28 @@ has_cap_on (int cap, long unsigned *caps
   return (CAP_TO_MASK_1 (cap) & caps[1]);
 }
 
+static unsigned long cap_last_cap;
+
+int
+libcrun_init_caps (libcrun_error_t *err)
+{
+  cleanup_close int fd = -1;
+  int ret;
+  char buffer[16];
+  fd = open ("/proc/sys/kernel/cap_last_cap", O_RDONLY);
+  if (fd < 0)
+    return crun_make_error (err, errno, "open /proc/sys/kernel/cap_last_cap");
+  ret = TEMP_FAILURE_RETRY (read (fd, buffer, sizeof (buffer)));
+  if (UNLIKELY (ret < 0))
+    return crun_make_error (err, errno, "read from /proc/sys/kernel/cap_last_cap");
+
+  errno = 0;
+  cap_last_cap = strtoul (buffer, NULL, 10);
+  if (errno != 0)
+    return crun_make_error (err, errno, "strtoul() from /proc/sys/kernel/cap_last_cap");
+  return 0;
+}
+
 static int
 set_required_caps (struct all_caps_s *caps, uid_t uid, gid_t gid, int no_new_privs, libcrun_error_t *err)
 {
@@ -2299,11 +2318,14 @@ set_required_caps (struct all_caps_s *ca
   struct __user_cap_header_struct hdr = { _LINUX_CAPABILITY_VERSION_3, 0 };
   struct __user_cap_data_struct data[2] = { { 0 } };
 
-  for (cap = 0; cap <= CAP_LAST_CAP; cap++)
+  if (cap_last_cap == 0)
+    return crun_make_error (err, 0, "internal error: max number of capabilities not initialized");
+
+  for (cap = 0; cap <= cap_last_cap; cap++)
     if (! has_cap_on (cap, caps->bounding))
       {
         ret = prctl (PR_CAPBSET_DROP, cap, 0, 0, 0);
-        if (UNLIKELY (ret < 0 && !(errno == EINVAL)))
+        if (UNLIKELY (ret < 0 && ! (errno == EINVAL)))
           return crun_make_error (err, errno, "prctl drop bounding");
       }
 
@@ -2332,14 +2354,14 @@ set_required_caps (struct all_caps_s *ca
 
 #ifdef PR_CAP_AMBIENT
   ret = prctl (PR_CAP_AMBIENT, PR_CAP_AMBIENT_CLEAR_ALL, 0, 0, 0);
-  if (UNLIKELY (ret < 0 && !(errno == EINVAL || errno == EPERM)))
+  if (UNLIKELY (ret < 0 && ! (errno == EINVAL || errno == EPERM)))
     return crun_make_error (err, errno, "prctl reset ambient");
 
-  for (cap = 0; cap <= CAP_LAST_CAP; cap++)
+  for (cap = 0; cap <= cap_last_cap; cap++)
     if (has_cap_on (cap, caps->ambient))
       {
         ret = prctl (PR_CAP_AMBIENT, PR_CAP_AMBIENT_RAISE, cap, 0, 0);
-        if (UNLIKELY (ret < 0 && !(errno == EINVAL || errno == EPERM)))
+        if (UNLIKELY (ret < 0 && ! (errno == EINVAL || errno == EPERM)))
           return crun_make_error (err, errno, "prctl ambient raise");
       }
 #endif
@@ -2361,9 +2383,9 @@ read_caps (unsigned long caps[2], char *
       if (cap_from_name (values[i], &cap) < 0)
         return crun_make_error (err, 0, "unknown cap: `%s`", values[i]);
       if (cap < 32)
-          caps[0] |= CAP_TO_MASK_0 (cap);
+        caps[0] |= CAP_TO_MASK_0 (cap);
       else
-          caps[1] |= CAP_TO_MASK_1 (cap);
+        caps[1] |= CAP_TO_MASK_1 (cap);
     }
   return 0;
 }
@@ -2386,45 +2408,31 @@ libcrun_set_apparmor_profile (runtime_sp
 }
 
 int
-libcrun_set_caps (runtime_spec_schema_config_schema_process_capabilities *capabilities, uid_t uid, gid_t gid, int no_new_privileges, libcrun_error_t *err)
+libcrun_set_caps (runtime_spec_schema_config_schema_process_capabilities *capabilities, uid_t uid, gid_t gid,
+                  int no_new_privileges, libcrun_error_t *err)
 {
   int ret;
   struct all_caps_s caps = {};
 
   if (capabilities)
     {
-      ret = read_caps (caps.effective,
-                       capabilities->effective,
-                       capabilities->effective_len,
-                       err);
+      ret = read_caps (caps.effective, capabilities->effective, capabilities->effective_len, err);
       if (ret < 0)
         return ret;
 
-      ret = read_caps (caps.inheritable,
-                       capabilities->inheritable,
-                       capabilities->inheritable_len,
-                       err);
+      ret = read_caps (caps.inheritable, capabilities->inheritable, capabilities->inheritable_len, err);
       if (ret < 0)
         return ret;
 
-      ret = read_caps (caps.ambient,
-                       capabilities->ambient,
-                       capabilities->ambient_len,
-                       err);
+      ret = read_caps (caps.ambient, capabilities->ambient, capabilities->ambient_len, err);
       if (ret < 0)
         return ret;
 
-      ret = read_caps (caps.bounding,
-                       capabilities->bounding,
-                       capabilities->bounding_len,
-                       err);
+      ret = read_caps (caps.bounding, capabilities->bounding, capabilities->bounding_len, err);
       if (ret < 0)
         return ret;
 
-      ret = read_caps (caps.permitted,
-                       capabilities->permitted,
-                       capabilities->permitted_len,
-                       err);
+      ret = read_caps (caps.permitted, capabilities->permitted, capabilities->permitted_len, err);
       if (ret < 0)
         return ret;
     }
@@ -2438,26 +2446,23 @@ struct rlimit_s
   int value;
 };
 
-struct rlimit_s rlimits[] =
-  {
-    {"RLIMIT_AS", RLIMIT_AS},
-    {"RLIMIT_CORE", RLIMIT_CORE},
-    {"RLIMIT_CPU", RLIMIT_CPU},
-    {"RLIMIT_DATA", RLIMIT_DATA},
-    {"RLIMIT_FSIZE", RLIMIT_FSIZE},
-    {"RLIMIT_LOCKS", RLIMIT_LOCKS},
-    {"RLIMIT_MEMLOCK", RLIMIT_MEMLOCK},
-    {"RLIMIT_MSGQUEUE", RLIMIT_MSGQUEUE},
-    {"RLIMIT_NICE", RLIMIT_NICE},
-    {"RLIMIT_NOFILE", RLIMIT_NOFILE},
-    {"RLIMIT_NPROC", RLIMIT_NPROC},
-    {"RLIMIT_RSS", RLIMIT_RSS},
-    {"RLIMIT_RTPRIO", RLIMIT_RTPRIO},
-    {"RLIMIT_RTTIME", RLIMIT_RTTIME},
-    {"RLIMIT_SIGPENDING", RLIMIT_SIGPENDING},
-    {"RLIMIT_STACK", RLIMIT_STACK},
-    {NULL, 0}
-  };
+struct rlimit_s rlimits[] = { { "RLIMIT_AS", RLIMIT_AS },
+                              { "RLIMIT_CORE", RLIMIT_CORE },
+                              { "RLIMIT_CPU", RLIMIT_CPU },
+                              { "RLIMIT_DATA", RLIMIT_DATA },
+                              { "RLIMIT_FSIZE", RLIMIT_FSIZE },
+                              { "RLIMIT_LOCKS", RLIMIT_LOCKS },
+                              { "RLIMIT_MEMLOCK", RLIMIT_MEMLOCK },
+                              { "RLIMIT_MSGQUEUE", RLIMIT_MSGQUEUE },
+                              { "RLIMIT_NICE", RLIMIT_NICE },
+                              { "RLIMIT_NOFILE", RLIMIT_NOFILE },
+                              { "RLIMIT_NPROC", RLIMIT_NPROC },
+                              { "RLIMIT_RSS", RLIMIT_RSS },
+                              { "RLIMIT_RTPRIO", RLIMIT_RTPRIO },
+                              { "RLIMIT_RTTIME", RLIMIT_RTTIME },
+                              { "RLIMIT_SIGPENDING", RLIMIT_SIGPENDING },
+                              { "RLIMIT_STACK", RLIMIT_STACK },
+                              { NULL, 0 } };
 
 static int
 get_rlimit_resource (const char *name)
@@ -2470,7 +2475,8 @@ get_rlimit_resource (const char *name)
 }
 
 int
-libcrun_set_rlimits (runtime_spec_schema_config_schema_process_rlimits_element **new_rlimits, size_t len, libcrun_error_t *err)
+libcrun_set_rlimits (runtime_spec_schema_config_schema_process_rlimits_element **new_rlimits, size_t len,
+                     libcrun_error_t *err)
 {
   size_t i;
   for (i = 0; i < len; i++)
@@ -2496,7 +2502,7 @@ libcrun_set_hostname (libcrun_container_
   int ret;
   if (def->hostname == NULL || def->hostname[0] == '\0')
     return 0;
-  if (!has_uts)
+  if (! has_uts)
     return crun_make_error (err, 0, "hostname requires the UTS namespace");
   ret = sethostname (def->hostname, strlen (def->hostname));
   if (UNLIKELY (ret < 0))
@@ -2529,7 +2535,7 @@ libcrun_set_sysctl_from_schema (runtime_
   size_t i;
   cleanup_close int dirfd = -1;
 
-  if (!def->linux || !def->linux->sysctl)
+  if (! def->linux || ! def->linux->sysctl)
     return 0;
 
   dirfd = open ("/proc/sys", O_DIRECTORY | O_RDONLY);
@@ -2564,26 +2570,25 @@ libcrun_set_sysctl (libcrun_container_t
 }
 
 static int
-open_terminal (libcrun_container_t *container, char **slave, libcrun_error_t *err)
+open_terminal (libcrun_container_t *container, char **pty, libcrun_error_t *err)
 {
   int ret;
   cleanup_close int fd = -1;
 
-  fd = libcrun_new_terminal (slave, err);
+  fd = libcrun_new_terminal (pty, err);
   if (UNLIKELY (fd < 0))
     return fd;
 
-  ret = libcrun_set_stdio (*slave, err);
+  ret = libcrun_set_stdio (*pty, err);
   if (UNLIKELY (ret < 0))
     return ret;
 
-  if (container->container_def->process
-      && container->container_def->process->user
+  if (container->container_def->process && container->container_def->process->user
       && container->container_def->process->user->uid)
     {
-      ret = chown (*slave, container->container_def->process->user->uid, -1);
+      ret = chown (*pty, container->container_def->process->user->uid, -1);
       if (UNLIKELY (ret < 0))
-        return crun_make_error (err, errno, "chown `%s`", *slave);
+        return crun_make_error (err, errno, "chown `%s`", *pty);
     }
 
   ret = get_and_reset (&fd);
@@ -2597,9 +2602,7 @@ libcrun_get_external_descriptors (libcru
 }
 
 static int
-save_external_descriptors (libcrun_container_t *container,
-                           pid_t pid,
-                           libcrun_error_t *err)
+save_external_descriptors (libcrun_container_t *container, pid_t pid, libcrun_error_t *err)
 {
   const unsigned char *buf = NULL;
   yajl_gen gen = NULL;
@@ -2623,7 +2626,7 @@ save_external_descriptors (libcrun_conta
         {
           /* The fd could not exist.  */
           if (errno == ENOENT)
-              strcpy (link_path, "/dev/null");
+            strcpy (link_path, "/dev/null");
           else
             {
               yajl_gen_free (gen);
@@ -2637,7 +2640,7 @@ save_external_descriptors (libcrun_conta
   yajl_gen_array_close (gen);
   yajl_gen_get_buf (gen, &buf, &buf_len);
   if (buf)
-    get_private_data (container)->external_descriptors = xstrdup((const char *) buf);
+    get_private_data (container)->external_descriptors = xstrdup ((const char *) buf);
   yajl_gen_free (gen);
 
   return 0;
@@ -2648,21 +2651,19 @@ libcrun_set_terminal (libcrun_container_
 {
   int ret;
   cleanup_close int fd = -1;
-  cleanup_free char *slave = NULL;
+  cleanup_free char *pty = NULL;
   runtime_spec_schema_config_schema *def = container->container_def;
 
-  if (def->process == NULL || !def->process->terminal)
+  if (def->process == NULL || ! def->process->terminal)
     return 0;
 
-  fd = open_terminal (container, &slave, err);
+  fd = open_terminal (container, &pty, err);
   if (UNLIKELY (fd < 0))
     return fd;
 
   if (def->process->console_size)
     {
-      ret = libcrun_terminal_setup_size (0, def->process->console_size->height,
-                                         def->process->console_size->width,
-                                         err);
+      ret = libcrun_terminal_setup_size (0, def->process->console_size->height, def->process->console_size->width, err);
       if (UNLIKELY (ret < 0))
         return ret;
     }
@@ -2686,14 +2687,13 @@ libcrun_set_terminal (libcrun_container_
       crun_error_release (err);
     }
 
-  ret = do_mount (container, slave, -1, "/dev/console", NULL, MS_BIND, NULL, 0, err);
+  ret = do_mount (container, pty, -1, "/dev/console", NULL, MS_BIND, NULL, LABEL_MOUNT, err);
   if (UNLIKELY (ret < 0))
     return ret;
 
   return get_and_reset (&fd);
 }
 
-
 static bool
 read_error_from_sync_socket (int sync_socket_fd, int *error, char **str)
 {
@@ -2768,7 +2768,7 @@ send_error_to_sync_socket (int sync_sock
   return true;
 }
 
-static  __attribute__ ((noreturn)) void
+static __attribute__ ((noreturn)) void
 send_error_to_sync_socket_and_die (int sync_socket_fd, bool has_terminal, libcrun_error_t *err)
 {
   char *msg;
@@ -2807,12 +2807,8 @@ expect_success_from_sync_socket (int syn
 }
 
 static int
-join_namespaces (runtime_spec_schema_config_schema *def,
-                 int *namespaces_to_join,
-                 int n_namespaces_to_join,
-                 int *namespaces_to_join_index,
-                 bool ignore_join_errors,
-                 libcrun_error_t *err)
+join_namespaces (runtime_spec_schema_config_schema *def, int *namespaces_to_join, int n_namespaces_to_join,
+                 int *namespaces_to_join_index, bool ignore_join_errors, libcrun_error_t *err)
 {
   int ret;
   int i;
@@ -2863,7 +2859,7 @@ join_namespaces (runtime_spec_schema_con
 struct init_status_s
 {
   /* fd to the namespace to join.  */
-  int fd[MAX_NAMESPACES+1];
+  int fd[MAX_NAMESPACES + 1];
   /* Index into def->linux->namespaces.  */
   int index[MAX_NAMESPACES];
   /* CLONE_* value.  */
@@ -2893,7 +2889,8 @@ struct init_status_s
   int namespaces_to_unshare;
 };
 
-void cleanup_free_init_statusp (struct init_status_s *ns)
+void
+cleanup_free_init_statusp (struct init_status_s *ns)
 {
   size_t i;
 
@@ -2902,7 +2899,7 @@ void cleanup_free_init_statusp (struct i
 }
 
 static int
-configure_init_status (struct init_status_s *ns, libcrun_container_t *container,libcrun_error_t *err)
+configure_init_status (struct init_status_s *ns, libcrun_container_t *container, libcrun_error_t *err)
 {
   runtime_spec_schema_config_schema *def = container->container_def;
   size_t i;
@@ -2939,7 +2936,7 @@ configure_init_status (struct init_statu
 
           fd = open (def->linux->namespaces[i]->path, O_RDONLY | O_CLOEXEC);
           if (UNLIKELY (fd < 0))
-              return crun_make_error (err, errno, "open `%s`", def->linux->namespaces[i]->path);
+            return crun_make_error (err, errno, "open `%s`", def->linux->namespaces[i]->path);
 
           if (value == CLONE_NEWUSER)
             {
@@ -2965,9 +2962,7 @@ configure_init_status (struct init_statu
 }
 
 static int
-init_container (libcrun_container_t *container,
-                int sync_socket_container,
-                struct init_status_s *init_status,
+init_container (libcrun_container_t *container, int sync_socket_container, struct init_status_s *init_status,
                 libcrun_error_t *err)
 {
   runtime_spec_schema_config_schema *def = container->container_def;
@@ -2976,7 +2971,7 @@ init_container (libcrun_container_t *con
   pid_t pid_container = 0;
   size_t i;
   int ret;
-  char success = 0;
+  const char success = 0;
 
   ret = libcrun_set_oom (container, err);
   if (UNLIKELY (ret < 0))
@@ -3034,7 +3029,8 @@ init_container (libcrun_container_t *con
           /* If we need to join another user namespace, do it immediately before creating any other namespace. */
           ret = setns (init_status->fd[init_status->userns_index], CLONE_NEWUSER);
           if (UNLIKELY (ret < 0))
-            return crun_make_error (err, errno, "cannot setns `%s`", def->linux->namespaces[init_status->userns_index_origin]->path);
+            return crun_make_error (err, errno, "cannot setns `%s`",
+                                    def->linux->namespaces[init_status->userns_index_origin]->path);
         }
 
       ret = setresuid (0, 0, 0);
@@ -3088,8 +3084,13 @@ init_container (libcrun_container_t *con
           ret = TEMP_FAILURE_RETRY (write (sync_socket_container, &pid_container, sizeof (pid_container)));
           if (UNLIKELY (ret < 0))
             return crun_make_error (err, errno, "write to sync socket");
+
           _exit (EXIT_SUCCESS);
         }
+
+      ret = expect_success_from_sync_socket (sync_socket_container, err);
+      if (UNLIKELY (ret < 0))
+        return ret;
     }
 
   ret = libcrun_container_setgroups (container, err);
@@ -3103,18 +3104,17 @@ init_container (libcrun_container_t *con
 }
 
 pid_t
-libcrun_run_linux_container (libcrun_container_t *container,
-                             container_entrypoint_t entrypoint,
-                             void *args,
-                             int *sync_socket_out,
-                             libcrun_error_t *err)
+libcrun_run_linux_container (libcrun_container_t *container, container_entrypoint_t entrypoint, void *args,
+                             int *sync_socket_out, libcrun_error_t *err)
 {
-   __attribute__((cleanup (cleanup_free_init_statusp))) struct init_status_s init_status;
+  __attribute__ ((cleanup (cleanup_free_init_statusp))) struct init_status_s init_status;
   runtime_spec_schema_config_schema *def = container->container_def;
   cleanup_close int sync_socket_container = -1;
   char *notify_socket_env = NULL;
   cleanup_close int sync_socket_host = -1;
   bool clone_can_create_userns;
+  const char failure = 1;
+  const char success = 0;
   int sync_socket[2];
   pid_t pid;
   size_t i;
@@ -3143,9 +3143,7 @@ libcrun_run_linux_container (libcrun_con
     return ret;
 #endif
 
-  get_uid_gid_from_def (container->container_def,
-                        &container->container_uid,
-                        &container->container_gid);
+  get_uid_gid_from_def (container->container_def, &container->container_uid, &container->container_gid);
 
   /* This must be done before we enter a user namespace.  */
   if (def->process)
@@ -3203,10 +3201,11 @@ libcrun_run_linux_container (libcrun_con
   clone_can_create_userns = init_status.fd_len == 0;
 
   if ((init_status.all_namespaces & CLONE_NEWUSER) && init_status.userns_index < 0)
-      init_status.delayed_userns_create = !clone_can_create_userns || init_status.fd_len > 0;
+    init_status.delayed_userns_create = ! clone_can_create_userns || init_status.fd_len > 0;
 
   /* If we create a new user namespace, create it as part of the clone.  */
-  pid = syscall_clone ((init_status.namespaces_to_unshare & (clone_can_create_userns ? CLONE_NEWUSER : 0)) | SIGCHLD, NULL);
+  pid = syscall_clone ((init_status.namespaces_to_unshare & (clone_can_create_userns ? CLONE_NEWUSER : 0)) | SIGCHLD,
+                       NULL);
   if (UNLIKELY (pid < 0))
     return crun_make_error (err, errno, "clone");
 
@@ -3256,6 +3255,10 @@ libcrun_run_linux_container (libcrun_con
           if (UNLIKELY (ret < 0))
             return crun_make_error (err, errno, "read pid from sync socket");
 
+          ret = TEMP_FAILURE_RETRY (write (sync_socket_host, &success, 1));
+          if (UNLIKELY (ret < 0))
+            return ret;
+
           /* Cleanup the first process.  */
           waitpid (pid, NULL, 0);
 
@@ -3281,22 +3284,18 @@ libcrun_run_linux_container (libcrun_con
   ret = init_container (container, sync_socket_container, &init_status, err);
   if (UNLIKELY (ret < 0))
     {
-      char failure = 1;
-
       ret = TEMP_FAILURE_RETRY (write (sync_socket_container, &failure, 1));
       if (UNLIKELY (ret < 0))
         goto localfail;
 
       send_error_to_sync_socket_and_die (sync_socket_container, false, err);
 
-localfail:
+    localfail:
       libcrun_fail_with_error ((*err)->status, "%s", (*err)->msg);
       _exit (EXIT_FAILURE);
     }
   else
     {
-      char success = 0;
-
       ret = TEMP_FAILURE_RETRY (write (sync_socket_container, &success, 1));
       if (UNLIKELY (ret < 0))
         return ret;
@@ -3315,10 +3314,7 @@ localfail:
 }
 
 static int
-join_process_parent_helper (pid_t child_pid,
-                            int sync_socket_fd,
-                            libcrun_container_status_t *status,
-                            int *terminal_fd,
+join_process_parent_helper (pid_t child_pid, int sync_socket_fd, libcrun_container_status_t *status, int *terminal_fd,
                             libcrun_error_t *err)
 {
   int ret, pid_status;
@@ -3376,13 +3372,18 @@ join_process_parent_helper (pid_t child_
 }
 
 int
-libcrun_join_process (libcrun_container_t *container, pid_t pid_to_join, libcrun_container_status_t *status, int detach, int *terminal_fd, libcrun_error_t *err)
+libcrun_join_process (libcrun_container_t *container, pid_t pid_to_join, libcrun_container_status_t *status, int detach,
+                      int *terminal_fd, libcrun_error_t *err)
 {
   pid_t pid;
   int ret;
   int sync_socket_fd[2];
-  int fds[10] = {-1, };
-  int fds_joined[10] = {0, };
+  int fds[10] = {
+    -1,
+  };
+  int fds_joined[10] = {
+    0,
+  };
   runtime_spec_schema_config_schema *def = container->container_def;
   size_t i;
   cleanup_close int sync_fd = -1;
@@ -3468,7 +3469,7 @@ libcrun_join_process (libcrun_container_
                   break;
                 }
             }
-          if (!found)
+          if (! found)
             {
               /* It was not requested to create this ns, so just ignore it.  */
               fds_joined[i] = 1;
@@ -3515,7 +3516,7 @@ libcrun_join_process (libcrun_container_
       /* Inside the grandchild process.  The real process
          used for the container.  */
       int r = -1;
-      cleanup_free char *slave = NULL;
+      cleanup_free char *pty = NULL;
 
       ret = TEMP_FAILURE_RETRY (read (sync_fd, &r, sizeof (r)));
       if (UNLIKELY (ret < 0))
@@ -3523,7 +3524,7 @@ libcrun_join_process (libcrun_container_
 
       if (terminal_fd)
         {
-          cleanup_close int master_fd = -1;
+          cleanup_close int ptmx_fd = -1;
 
           ret = setsid ();
           if (ret < 0)
@@ -3546,11 +3547,11 @@ libcrun_join_process (libcrun_container_
               send_error_to_sync_socket_and_die (sync_fd, true, err);
             }
 
-          master_fd = open_terminal (container, &slave, err);
-          if (UNLIKELY (master_fd < 0))
+          ptmx_fd = open_terminal (container, &pty, err);
+          if (UNLIKELY (ptmx_fd < 0))
             send_error_to_sync_socket_and_die (sync_fd, true, err);
 
-          ret = send_fd_to_socket (sync_fd, master_fd, err);
+          ret = send_fd_to_socket (sync_fd, ptmx_fd, err);
           if (UNLIKELY (ret < 0))
             send_error_to_sync_socket_and_die (sync_fd, true, err);
         }
@@ -3561,7 +3562,7 @@ libcrun_join_process (libcrun_container_
 
   return pid;
 
- exit:
+exit:
   if (sync_socket_fd[0] >= 0)
     TEMP_FAILURE_RETRY (close (sync_socket_fd[0]));
   if (sync_socket_fd[1] >= 0)
@@ -3573,13 +3574,14 @@ libcrun_join_process (libcrun_container_
 }
 
 int
-libcrun_linux_container_update (libcrun_container_status_t *status, const char *content, size_t len arg_unused, libcrun_error_t *err)
+libcrun_linux_container_update (libcrun_container_status_t *status, const char *content, size_t len arg_unused,
+                                libcrun_error_t *err)
 {
   int ret;
   yajl_val tree = NULL;
   parser_error parser_err = NULL;
   runtime_spec_schema_config_linux_resources *resources = NULL;
-  struct parser_context ctx = {0, stderr};
+  struct parser_context ctx = { 0, stderr };
   int cgroup_mode;
 
   cgroup_mode = libcrun_get_cgroup_mode (err);
@@ -3599,7 +3601,7 @@ libcrun_linux_container_update (libcrun_
 
   ret = libcrun_update_cgroup_resources (cgroup_mode, resources, status->cgroup_path, err);
 
- cleanup:
+cleanup:
   if (tree)
     yajl_tree_free (tree);
   free (parser_err);
@@ -3634,9 +3636,9 @@ libcrun_set_personality (runtime_spec_sc
   int ret;
 
   if (strcmp (p->domain, "LINUX") == 0)
-      persona = PER_LINUX;
+    persona = PER_LINUX;
   else if (strcmp (p->domain, "LINUX32") == 0)
-      persona = PER_LINUX32;
+    persona = PER_LINUX32;
   else
     return crun_make_error (err, 0, "unknown persona specified `%s`", p->domain);
 
@@ -3653,10 +3655,7 @@ libcrun_configure_network (libcrun_conta
   int ret;
   size_t i;
   bool configure_network = false;
-  struct ifreq ifr_lo = {
-                         .ifr_name = "lo",
-                         .ifr_flags = IFF_UP | IFF_RUNNING
-  };
+  struct ifreq ifr_lo = { .ifr_name = "lo", .ifr_flags = IFF_UP | IFF_RUNNING };
   runtime_spec_schema_config_schema *def = container->container_def;
   cleanup_close int sockfd = -1;
 
@@ -3689,7 +3688,8 @@ libcrun_configure_network (libcrun_conta
 
 /* Protection for attacks like CVE-2019-5736.  */
 int ensure_cloned_binary ();
-__attribute__((constructor)) static void libcrun_rexec(void)
+__attribute__ ((constructor)) static void
+libcrun_rexec (void)
 {
   if (ensure_cloned_binary () < 0)
     {
@@ -3699,24 +3699,18 @@ __attribute__((constructor)) static void
 }
 
 int
-libcrun_container_checkpoint_linux (libcrun_container_status_t *status,
-                                    libcrun_container_t *container,
-                                    libcrun_checkpoint_restore_t *cr_options,
-                                    libcrun_error_t *err)
+libcrun_container_checkpoint_linux (libcrun_container_status_t *status, libcrun_container_t *container,
+                                    libcrun_checkpoint_restore_t *cr_options, libcrun_error_t *err)
 {
-  return libcrun_container_checkpoint_linux_criu (status, container,
-                                                  cr_options, err);
+  return libcrun_container_checkpoint_linux_criu (status, container, cr_options, err);
 }
 
 int
-libcrun_container_restore_linux (libcrun_container_status_t *status,
-                                 libcrun_container_t *container,
-                                 libcrun_checkpoint_restore_t *cr_options,
-                                 libcrun_error_t *err)
+libcrun_container_restore_linux (libcrun_container_status_t *status, libcrun_container_t *container,
+                                 libcrun_checkpoint_restore_t *cr_options, libcrun_error_t *err)
 {
   int ret;
-  ret = libcrun_container_restore_linux_criu (status, container,
-                                              cr_options, err);
+  ret = libcrun_container_restore_linux_criu (status, container, cr_options, err);
   if (UNLIKELY (ret < 0))
     return ret;
 
@@ -3724,3 +3718,41 @@ libcrun_container_restore_linux (libcrun
 
   return 0;
 }
+
+int
+libcrun_kill_linux (libcrun_container_status_t *status, int signal, libcrun_error_t *err)
+{
+  int ret;
+  cleanup_close int pidfd = -1;
+
+  pidfd = syscall_pidfd_open (status->pid, 0);
+  if (UNLIKELY (pidfd < 0))
+    {
+      /* If pidfd_open is not supported, fallback to kill.  */
+      if (errno == ENOTSUP)
+        {
+          ret = kill (status->pid, signal);
+          if (UNLIKELY (ret < 0))
+            return crun_make_error (err, errno, "kill container");
+          return 0;
+        }
+      return crun_make_error (err, errno, "open pidfd");
+    }
+
+  ret = libcrun_check_pid_valid (status, err);
+  if (UNLIKELY (ret < 0))
+    return ret;
+
+  /* The pid is not valid anymore, return an error.  */
+  if (ret == 0)
+    {
+      errno = ESRCH;
+      return crun_make_error (err, errno, "kill container");
+    }
+
+  ret = syscall_pidfd_send_signal (pidfd, signal, NULL, 0);
+  if (UNLIKELY (ret < 0))
+    return crun_make_error (err, errno, "send signal to pidfd");
+
+  return 0;
+}
diff -pruN 0.14.1+dfsg-1/src/libcrun/linux.h 0.15+dfsg-1/src/libcrun/linux.h
--- 0.14.1+dfsg-1/src/libcrun/linux.h	2020-07-03 19:38:11.000000000 +0000
+++ 0.15+dfsg-1/src/libcrun/linux.h	2020-09-22 18:17:19.000000000 +0000
@@ -16,33 +16,32 @@
  * along with crun.  If not, see <http://www.gnu.org/licenses/>.
  */
 #ifndef LINUX_H
-# define LINUX_H
-# include <config.h>
-# include <stdio.h>
-# include <stdlib.h>
-# include "error.h"
-# include <errno.h>
-# include <argp.h>
-# include <runtime_spec_schema_config_schema.h>
-# include "container.h"
-# include "status.h"
+#define LINUX_H
+#include <config.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include "error.h"
+#include <errno.h>
+#include <argp.h>
+#include <runtime_spec_schema_config_schema.h>
+#include "container.h"
+#include "status.h"
 
-typedef int (*container_entrypoint_t) (void *args, char *notify_socket,
-                                       int sync_socket,
-                                       libcrun_error_t *err);
+typedef int (*container_entrypoint_t) (void *args, char *notify_socket, int sync_socket, libcrun_error_t *err);
 
-pid_t libcrun_run_linux_container (libcrun_container_t *container,
-                                   container_entrypoint_t entrypoint,
-                                   void *args,
-                                   int *sync_socket_out,
-                                   libcrun_error_t *err);
-int get_notify_fd (libcrun_context_t *context, libcrun_container_t *container, int *notify_socket_out, libcrun_error_t *err);
+pid_t libcrun_run_linux_container (libcrun_container_t *container, container_entrypoint_t entrypoint, void *args,
+                                   int *sync_socket_out, libcrun_error_t *err);
+int get_notify_fd (libcrun_context_t *context, libcrun_container_t *container, int *notify_socket_out,
+                   libcrun_error_t *err);
 int libcrun_set_mounts (libcrun_container_t *container, const char *rootfs, libcrun_error_t *err);
+int libcrun_init_caps (libcrun_error_t *err);
 int libcrun_do_pivot_root (libcrun_container_t *container, bool no_pivot, const char *rootfs, libcrun_error_t *err);
 int libcrun_reopen_dev_null (libcrun_error_t *err);
 int libcrun_set_usernamespace (libcrun_container_t *container, pid_t pid, libcrun_error_t *err);
-int libcrun_set_caps (runtime_spec_schema_config_schema_process_capabilities *capabilities, uid_t uid, gid_t gid, int no_new_privileges, libcrun_error_t *err);
-int libcrun_set_rlimits (runtime_spec_schema_config_schema_process_rlimits_element **rlimits, size_t len, libcrun_error_t *err);
+int libcrun_set_caps (runtime_spec_schema_config_schema_process_capabilities *capabilities, uid_t uid, gid_t gid,
+                      int no_new_privileges, libcrun_error_t *err);
+int libcrun_set_rlimits (runtime_spec_schema_config_schema_process_rlimits_element **rlimits, size_t len,
+                         libcrun_error_t *err);
 int libcrun_set_selinux_exec_label (runtime_spec_schema_config_schema_process *proc, libcrun_error_t *err);
 int libcrun_set_apparmor_profile (runtime_spec_schema_config_schema_process *proc, libcrun_error_t *err);
 int libcrun_set_hostname (libcrun_container_t *container, libcrun_error_t *err);
@@ -50,8 +49,10 @@ int libcrun_set_oom (libcrun_container_t
 int libcrun_set_sysctl_from_schema (runtime_spec_schema_config_schema *def, libcrun_error_t *err);
 int libcrun_set_sysctl (libcrun_container_t *container, libcrun_error_t *err);
 int libcrun_set_terminal (libcrun_container_t *container, libcrun_error_t *err);
-int libcrun_join_process (libcrun_container_t *container, pid_t pid_to_join, libcrun_container_status_t *status, int detach, int *terminal_fd, libcrun_error_t *err);
-int libcrun_linux_container_update (libcrun_container_status_t *status, const char *content, size_t len, libcrun_error_t *err);
+int libcrun_join_process (libcrun_container_t *container, pid_t pid_to_join, libcrun_container_status_t *status,
+                          int detach, int *terminal_fd, libcrun_error_t *err);
+int libcrun_linux_container_update (libcrun_container_status_t *status, const char *content, size_t len,
+                                    libcrun_error_t *err);
 int libcrun_create_keyring (const char *name, libcrun_error_t *err);
 int libcrun_container_pause_linux (libcrun_container_status_t *status, libcrun_error_t *err);
 int libcrun_container_unpause_linux (libcrun_container_status_t *status, libcrun_error_t *err);
@@ -59,17 +60,14 @@ int libcrun_container_enter_cgroup_ns (l
 int libcrun_set_personality (runtime_spec_schema_defs_linux_personality *p, libcrun_error_t *err);
 int libcrun_configure_network (libcrun_container_t *container, libcrun_error_t *err);
 
-int libcrun_container_checkpoint_linux (libcrun_container_status_t *status,
-                                        libcrun_container_t *container,
-                                        libcrun_checkpoint_restore_t *cr_options,
-                                        libcrun_error_t *err);
+int libcrun_container_checkpoint_linux (libcrun_container_status_t *status, libcrun_container_t *container,
+                                        libcrun_checkpoint_restore_t *cr_options, libcrun_error_t *err);
 
-int libcrun_container_restore_linux (libcrun_container_status_t *status,
-                                     libcrun_container_t *container,
-                                     libcrun_checkpoint_restore_t *cr_options,
-                                     libcrun_error_t *err);
+int libcrun_container_restore_linux (libcrun_container_status_t *status, libcrun_container_t *container,
+                                     libcrun_checkpoint_restore_t *cr_options, libcrun_error_t *err);
 
 int libcrun_find_namespace (const char *name);
 char *libcrun_get_external_descriptors (libcrun_container_t *container);
 int libcrun_container_setgroups (libcrun_container_t *container, libcrun_error_t *err);
+int libcrun_kill_linux (libcrun_container_status_t *status, int signal, libcrun_error_t *err);
 #endif
diff -pruN 0.14.1+dfsg-1/src/libcrun/seccomp.c 0.15+dfsg-1/src/libcrun/seccomp.c
--- 0.14.1+dfsg-1/src/libcrun/seccomp.c	2020-07-03 20:15:37.000000000 +0000
+++ 0.15+dfsg-1/src/libcrun/seccomp.c	2020-09-03 11:43:25.000000000 +0000
@@ -42,27 +42,27 @@
 #include <sys/syscall.h>
 
 #ifndef __NR_seccomp
-# define __NR_seccomp 0xffff //seccomp syscall number unknown for this architecture
+#  define __NR_seccomp 0xffff // seccomp syscall number unknown for this architecture
 #endif
 
 #ifndef SECCOMP_SET_MODE_STRICT
-# define SECCOMP_SET_MODE_STRICT 0
+#  define SECCOMP_SET_MODE_STRICT 0
 #endif
 
 #ifndef SECCOMP_SET_MODE_FILTER
-# define SECCOMP_SET_MODE_FILTER 1
+#  define SECCOMP_SET_MODE_FILTER 1
 #endif
 
 #ifndef SECCOMP_FILTER_FLAG_TSYNC
-# define SECCOMP_FILTER_FLAG_TSYNC (1UL << 0)
+#  define SECCOMP_FILTER_FLAG_TSYNC (1UL << 0)
 #endif
 
 #ifndef SECCOMP_FILTER_FLAG_LOG
-# define SECCOMP_FILTER_FLAG_LOG (1UL << 1)
+#  define SECCOMP_FILTER_FLAG_LOG (1UL << 1)
 #endif
 
 #ifndef SECCOMP_FILTER_FLAG_SPEC_ALLOW
-# define SECCOMP_FILTER_FLAG_SPEC_ALLOW	(1UL << 2)
+#  define SECCOMP_FILTER_FLAG_SPEC_ALLOW (1UL << 2)
 #endif
 
 static int
@@ -110,6 +110,10 @@ get_seccomp_action (const char *name, in
     return SCMP_ACT_ERRNO (errno_ret);
   else if (strcmp (p, "KILL") == 0)
     return SCMP_ACT_KILL;
+#ifdef SCMP_ACT_LOG
+  else if (strcmp (p, "LOG") == 0)
+    return SCMP_ACT_LOG;
+#endif
   else if (strcmp (p, "TRAP") == 0)
     return SCMP_ACT_TRAP;
   else if (strcmp (p, "TRACE") == 0)
@@ -118,8 +122,16 @@ get_seccomp_action (const char *name, in
   else if (strcmp (p, "KILL_PROCESS") == 0)
     return SCMP_ACT_KILL_PROCESS;
 #endif
+#ifdef SCMP_ACT_KILL_THREAD
+  else if (strcmp (p, "KILL_THREAD") == 0)
+    return SCMP_ACT_KILL_THREAD;
+#endif
+#ifdef SCMP_ACT_NOTIFY
+  else if (strcmp (p, "NOTIFY") == 0)
+    return SCMP_ACT_NOTIFY;
+#endif
 
- fail:
+fail:
   crun_make_error (err, 0, "seccomp get action", name);
   return 0;
 }
@@ -141,10 +153,11 @@ cleanup_seccompp (void *p)
   if (*ctx)
     seccomp_release (*ctx);
 }
-#define cleanup_seccomp __attribute__((cleanup (cleanup_seccompp)))
+#define cleanup_seccomp __attribute__ ((cleanup (cleanup_seccompp)))
 
 int
-libcrun_apply_seccomp (int infd, char **seccomp_flags, size_t seccomp_flags_len, libcrun_error_t *err)
+libcrun_apply_seccomp (int infd, int listener_receiver_fd, char **seccomp_flags, size_t seccomp_flags_len,
+                       libcrun_error_t *err)
 {
   int ret;
   struct sock_fprog seccomp_filter;
@@ -158,17 +171,16 @@ libcrun_apply_seccomp (int infd, char **
   if (UNLIKELY (lseek (infd, 0, SEEK_SET) == (off_t) -1))
     return crun_make_error (err, errno, "lseek");
 
-
   /* if no seccomp flag was specified use a sane default.  */
   if (seccomp_flags == NULL)
-    flags = SECCOMP_FILTER_FLAG_LOG|SECCOMP_FILTER_FLAG_SPEC_ALLOW;
+    flags = SECCOMP_FILTER_FLAG_LOG | SECCOMP_FILTER_FLAG_SPEC_ALLOW;
   else
     {
       size_t i = 0;
       for (i = 0; i < seccomp_flags_len; i++)
         {
           if (strcmp (seccomp_flags[i], "SECCOMP_FILTER_FLAG_TSYNC") == 0)
-              flags |= SECCOMP_FILTER_FLAG_TSYNC;
+            flags |= SECCOMP_FILTER_FLAG_TSYNC;
           else if (strcmp (seccomp_flags[i], "SECCOMP_FILTER_FLAG_SPEC_ALLOW") == 0)
             flags |= SECCOMP_FILTER_FLAG_SPEC_ALLOW;
           else if (strcmp (seccomp_flags[i], "SECCOMP_FILTER_FLAG_LOG") == 0)
@@ -185,6 +197,15 @@ libcrun_apply_seccomp (int infd, char **
   seccomp_filter.len = len / 8;
   seccomp_filter.filter = (struct sock_filter *) bpf;
 
+  if (listener_receiver_fd >= 0)
+    {
+#ifdef SECCOMP_FILTER_FLAG_NEW_LISTENER
+      flags |= SECCOMP_FILTER_FLAG_NEW_LISTENER;
+#else
+      return crun_make_error (err, 0, "SECCOMP_FILTER_FLAG_NEW_LISTENER not supported");
+#endif
+    }
+
   ret = syscall_seccomp (SECCOMP_SET_MODE_FILTER, flags, &seccomp_filter);
   if (UNLIKELY (ret < 0))
     {
@@ -195,6 +216,14 @@ libcrun_apply_seccomp (int infd, char **
         return crun_make_error (err, errno, "seccomp (SECCOMP_SET_MODE_FILTER)");
     }
 
+  if (listener_receiver_fd >= 0)
+    {
+      int fd = ret;
+
+      ret = send_fd_to_socket (listener_receiver_fd, fd, err);
+      if (UNLIKELY (ret < 0))
+        return crun_error_wrap (err, "send listener fd `%d` to receiver", fd);
+    }
   return 0;
 }
 
@@ -239,7 +268,7 @@ libcrun_generate_seccomp (libcrun_contai
 #ifdef SECCOMP_ARCH_RESOLVE_NAME
       arch_token = seccomp_arch_resolve_name (lowercase_arch);
       if (arch_token == 0)
-        return crun_make_error (err, -ret, "seccomp unknown architecture %s", arch);
+        return crun_make_error (err, 0, "seccomp unknown architecture %s", arch);
 #else
       arch_token = SCMP_ARCH_NATIVE;
 #endif
@@ -319,11 +348,7 @@ libcrun_generate_seccomp (libcrun_contai
 
               if (! multiple_args)
                 {
-                  ret = seccomp_rule_add_array (ctx,
-                                                action,
-                                                syscall,
-                                                k,
-                                                arg_cmp);
+                  ret = seccomp_rule_add_array (ctx, action, syscall, k, arg_cmp);
                   if (UNLIKELY (ret < 0))
                     return crun_make_error (err, -ret, "seccomp_rule_add_array");
                 }
@@ -333,11 +358,7 @@ libcrun_generate_seccomp (libcrun_contai
 
                   for (r = 0; r < k; r++)
                     {
-                      ret = seccomp_rule_add_array (ctx,
-                                                    action,
-                                                    syscall,
-                                                    1,
-                                                    &arg_cmp[r]);
+                      ret = seccomp_rule_add_array (ctx, action, syscall, 1, &arg_cmp[r]);
                       if (UNLIKELY (ret < 0))
                         return crun_make_error (err, -ret, "seccomp_rule_add_array");
                     }
diff -pruN 0.14.1+dfsg-1/src/libcrun/seccomp.h 0.15+dfsg-1/src/libcrun/seccomp.h
--- 0.14.1+dfsg-1/src/libcrun/seccomp.h	2020-07-03 20:15:37.000000000 +0000
+++ 0.15+dfsg-1/src/libcrun/seccomp.h	2020-09-03 11:43:25.000000000 +0000
@@ -16,22 +16,22 @@
  * along with crun.  If not, see <http://www.gnu.org/licenses/>.
  */
 #ifndef SECCOMP_H
-# define SECCOMP_H
-# include <config.h>
-# include <stdio.h>
-# include <stdlib.h>
-# include "error.h"
-# include <errno.h>
-# include <argp.h>
-# include <runtime_spec_schema_config_schema.h>
-# include "container.h"
+#define SECCOMP_H
+#include <config.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include "error.h"
+#include <errno.h>
+#include <argp.h>
+#include <runtime_spec_schema_config_schema.h>
+#include "container.h"
 
 enum
-  {
-    LIBCRUN_SECCOMP_FAIL_UNKNOWN_SYSCALL = 1 << 0,
-  };
+{
+  LIBCRUN_SECCOMP_FAIL_UNKNOWN_SYSCALL = 1 << 0,
+};
 
 int libcrun_generate_seccomp (libcrun_container_t *container, int outfd, unsigned int options, libcrun_error_t *err);
-int libcrun_apply_seccomp (int infd, char **flags, size_t flags_len, libcrun_error_t *err);
+int libcrun_apply_seccomp (int infd, int listener_receiver_fd, char **flags, size_t flags_len, libcrun_error_t *err);
 
 #endif
diff -pruN 0.14.1+dfsg-1/src/libcrun/seccomp_notify.c 0.15+dfsg-1/src/libcrun/seccomp_notify.c
--- 0.14.1+dfsg-1/src/libcrun/seccomp_notify.c	1970-01-01 00:00:00.000000000 +0000
+++ 0.15+dfsg-1/src/libcrun/seccomp_notify.c	2020-09-03 11:43:25.000000000 +0000
@@ -0,0 +1,252 @@
+/*
+ * crun - OCI runtime written in C
+ *
+ * Copyright (C) 2020 Giuseppe Scrivano <giuseppe@scrivano.org>
+ * crun is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License as published by
+ * the Free Software Foundation; either version 2.1 of the License, or
+ * (at your option) any later version.
+ *
+ * crun is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public License
+ * along with crun.  If not, see <http://www.gnu.org/licenses/>.
+ */
+#include <config.h>
+#include <errno.h>
+
+#if HAVE_SECCOMP_GET_NOTIF_SIZES
+#  include <seccomp.h>
+#  include <sys/ioctl.h>
+#  include <linux/seccomp.h>
+#  include <sys/sysmacros.h>
+#endif
+
+#ifdef HAVE_DLOPEN
+#  include <dlfcn.h>
+#endif
+
+#include "utils.h"
+#include "seccomp_notify.h"
+
+#ifndef SECCOMP_USER_NOTIF_FLAG_CONTINUE
+#  define SECCOMP_USER_NOTIF_FLAG_CONTINUE (1UL << 0)
+#endif
+
+struct plugin
+{
+  void *handle;
+  void *opaque;
+#if HAVE_DLOPEN && HAVE_SECCOMP_GET_NOTIF_SIZES
+  run_oci_seccomp_notify_handle_request_cb handle_request_cb;
+#endif
+};
+
+struct seccomp_notify_context_s
+{
+  struct plugin *plugins;
+  size_t n_plugins;
+
+#if HAVE_DLOPEN && HAVE_SECCOMP_GET_NOTIF_SIZES
+  struct seccomp_notif_resp *sresp;
+  struct seccomp_notif *sreq;
+  struct seccomp_notif_sizes sizes;
+#endif
+};
+
+void
+cleanup_seccomp_notify_pluginsp (void *p)
+{
+  struct seccomp_notify_context_s **pp = p;
+  if (*pp)
+    {
+      libcrun_error_t tmp_err = NULL;
+      libcrun_free_seccomp_notify_plugins (*pp, &tmp_err);
+      crun_error_release (&tmp_err);
+      *pp = NULL;
+    }
+}
+
+#if HAVE_DLOPEN && HAVE_SECCOMP_GET_NOTIF_SIZES
+static int
+seccomp_syscall (unsigned int op, unsigned int flags, void *args)
+{
+  errno = 0;
+  return syscall (__NR_seccomp, op, flags, args);
+}
+#endif
+
+LIBCRUN_PUBLIC int
+libcrun_load_seccomp_notify_plugins (struct seccomp_notify_context_s **out, const char *plugins,
+                                     struct libcrun_load_seccomp_notify_conf_s *conf, libcrun_error_t *err)
+{
+#if HAVE_DLOPEN && HAVE_SECCOMP_GET_NOTIF_SIZES
+  cleanup_seccomp_notify_context struct seccomp_notify_context_s *ctx = xmalloc0 (sizeof *ctx);
+  cleanup_free char *b = NULL;
+  char *it, *saveptr;
+  size_t s;
+
+  if (seccomp_syscall (SECCOMP_GET_NOTIF_SIZES, 0, &ctx->sizes) < 0)
+    return crun_make_error (err, errno, "seccomp GET_NOTIF_SIZES");
+
+  ctx->sreq = xmalloc (ctx->sizes.seccomp_notif);
+  ctx->sresp = xmalloc (ctx->sizes.seccomp_notif_resp);
+
+  ctx->n_plugins = 1;
+  for (it = b; it; it = strchr (it, ':'))
+    ctx->n_plugins++;
+
+  ctx->plugins = xmalloc0 (sizeof (struct plugin) * (ctx->n_plugins + 1));
+
+  b = xstrdup (plugins);
+  for (s = 0, it = strtok_r (b, ":", &saveptr); it; s++, it = strtok_r (NULL, ":", &saveptr))
+    {
+      run_oci_seccomp_notify_plugin_version_cb version_cb;
+      run_oci_seccomp_notify_start_cb start_cb;
+      void *opq = NULL;
+
+      /* do not accept relative paths.  It is fine to accept only filenames as dlopen() semantics apply.  */
+      if (strchr (it, '/') && it[0] != '/')
+        return crun_make_error (err, 0, "invalid relative plugin path: `%s`", it);
+
+      ctx->plugins[s].handle = dlopen (it, RTLD_NOW);
+      if (ctx->plugins[s].handle == NULL)
+        return crun_make_error (err, 0, "cannot load `%s`: %s", it, dlerror ());
+
+      version_cb
+          = (run_oci_seccomp_notify_plugin_version_cb) dlsym (ctx->plugins[s].handle, "run_oci_seccomp_notify_version");
+      if (version_cb != NULL)
+        {
+          int version;
+
+          version = version_cb ();
+          if (version != 1)
+            return crun_make_error (err, ENOTSUP, "invalid version supported by the plugin `%s`", it);
+        }
+
+      ctx->plugins[s].handle_request_cb = (run_oci_seccomp_notify_handle_request_cb) dlsym (
+          ctx->plugins[s].handle, "run_oci_seccomp_notify_handle_request");
+      if (ctx->plugins[s].handle_request_cb == NULL)
+        return crun_make_error (err, ENOTSUP, "plugin `%s` doesn't export `run_oci_seccomp_notify_handle_request`", it);
+
+      start_cb = (run_oci_seccomp_notify_start_cb) dlsym (ctx->plugins[s].handle, "run_oci_seccomp_notify_start");
+      if (start_cb)
+        {
+          int ret;
+
+          ret = start_cb (&opq, conf, sizeof (*conf));
+          if (UNLIKELY (ret != 0))
+            return crun_make_error (err, -ret, "error loading `%s`", it);
+        }
+      ctx->plugins[s].opaque = opq;
+    }
+
+  /* Change ownership.  */
+  *out = ctx;
+  ctx = NULL;
+  return 0;
+#else
+  return crun_make_error (err, ENOTSUP, "seccomp notify support not available");
+#endif
+}
+
+LIBCRUN_PUBLIC int
+libcrun_seccomp_notify_plugins (struct seccomp_notify_context_s *ctx, int seccomp_fd, libcrun_error_t *err)
+{
+#if HAVE_DLOPEN && HAVE_SECCOMP_GET_NOTIF_SIZES
+  size_t i;
+  int ret;
+
+  memset (ctx->sreq, 0, ctx->sizes.seccomp_notif);
+  memset (ctx->sresp, 0, ctx->sizes.seccomp_notif_resp);
+
+  ret = ioctl (seccomp_fd, SECCOMP_IOCTL_NOTIF_RECV, ctx->sreq);
+  if (UNLIKELY (ret < 0))
+    return crun_make_error (err, errno, "ioctl");
+
+  for (i = 0; i < ctx->n_plugins; i++)
+    {
+      if (ctx->plugins[i].handle_request_cb)
+        {
+          int handled = 0;
+          int ret;
+
+          ret = ctx->plugins[i].handle_request_cb (ctx->plugins[i].opaque, &ctx->sizes, ctx->sreq, ctx->sresp,
+                                                   seccomp_fd, &handled);
+          if (UNLIKELY (ret != 0))
+            return crun_make_error (err, -ret, "error handling seccomp notify request");
+
+          switch (handled)
+            {
+            case RUN_OCI_SECCOMP_NOTIFY_HANDLE_NOT_HANDLED:
+              break;
+
+            case RUN_OCI_SECCOMP_NOTIFY_HANDLE_SEND_RESPONSE:
+              goto send_resp;
+
+              /* The plugin will take care of it.  */
+            case RUN_OCI_SECCOMP_NOTIFY_HANDLE_DELAYED_RESPONSE:
+              return 0;
+
+            case RUN_OCI_SECCOMP_NOTIFY_HANDLE_SEND_RESPONSE_AND_CONTINUE:
+              ctx->sresp->flags |= SECCOMP_USER_NOTIF_FLAG_CONTINUE;
+              goto send_resp;
+
+            default:
+              return crun_make_error (err, EINVAL, "unknown action specified by the plugin `%d`", handled);
+            }
+        }
+    }
+
+  /* No plugin could handle the request.  */
+  ctx->sresp->error = -ENOTSUP;
+  ctx->sresp->flags = 0;
+
+send_resp:
+  ctx->sresp->id = ctx->sreq->id;
+  ret = ioctl (seccomp_fd, SECCOMP_IOCTL_NOTIF_SEND, ctx->sresp);
+  if (UNLIKELY (ret < 0))
+    {
+      if (errno == ENOENT)
+        return 0;
+      return crun_make_error (err, errno, "ioctl");
+    }
+  return 0;
+#else
+  return crun_make_error (err, ENOTSUP, "seccomp notify support not available");
+#endif
+}
+
+LIBCRUN_PUBLIC int
+libcrun_free_seccomp_notify_plugins (struct seccomp_notify_context_s *ctx, libcrun_error_t *err)
+{
+#if HAVE_DLOPEN && HAVE_SECCOMP_GET_NOTIF_SIZES
+  size_t i;
+
+  if (ctx == NULL)
+    return crun_make_error (err, EINVAL, "invalid seccomp notify context");
+
+  free (ctx->sreq);
+  free (ctx->sresp);
+
+  for (i = 0; i < ctx->n_plugins; i++)
+    if (ctx->plugins && ctx->plugins[i].handle)
+      {
+        run_oci_seccomp_notify_stop_cb cb;
+
+        cb = (run_oci_seccomp_notify_stop_cb) dlsym (ctx->plugins[i].handle, "run_oci_seccomp_notify_stop");
+        if (cb)
+          cb (ctx->plugins[i].opaque);
+        dlclose (ctx->plugins[i].handle);
+      }
+
+  free (ctx);
+
+  return 0;
+#else
+  return crun_make_error (err, ENOTSUP, "seccomp notify support not available");
+#endif
+}
diff -pruN 0.14.1+dfsg-1/src/libcrun/seccomp_notify.h 0.15+dfsg-1/src/libcrun/seccomp_notify.h
--- 0.14.1+dfsg-1/src/libcrun/seccomp_notify.h	1970-01-01 00:00:00.000000000 +0000
+++ 0.15+dfsg-1/src/libcrun/seccomp_notify.h	2020-09-03 11:43:25.000000000 +0000
@@ -0,0 +1,41 @@
+/*
+ * crun - OCI runtime written in C
+ *
+ * Copyright (C) 2020 Giuseppe Scrivano <giuseppe@scrivano.org>
+ * crun is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License as published by
+ * the Free Software Foundation; either version 2.1 of the License, or
+ * (at your option) any later version.
+ *
+ * crun is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public License
+ * along with crun.  If not, see <http://www.gnu.org/licenses/>.
+ */
+#ifndef SECCOMP_NOTIFY_H
+#define SECCOMP_NOTIFY_H
+
+#include <config.h>
+#include "error.h"
+
+#if ! (HAVE_DLOPEN && HAVE_SECCOMP_GET_NOTIF_SIZES)
+#  define SECCOMP_NOTIFY_SKIP_TYPEDEF
+#endif
+#include "seccomp_notify_plugin.h"
+
+struct seccomp_notify_context_s;
+
+LIBCRUN_PUBLIC int libcrun_load_seccomp_notify_plugins (struct seccomp_notify_context_s **out, const char *plugins,
+                                                        struct libcrun_load_seccomp_notify_conf_s *conf,
+                                                        libcrun_error_t *err);
+LIBCRUN_PUBLIC int libcrun_seccomp_notify_plugins (struct seccomp_notify_context_s *ctx, int seccomp_fd,
+                                                   libcrun_error_t *err);
+LIBCRUN_PUBLIC int libcrun_free_seccomp_notify_plugins (struct seccomp_notify_context_s *ctx, libcrun_error_t *err);
+
+#define cleanup_seccomp_notify_context __attribute__ ((cleanup (cleanup_seccomp_notify_pluginsp)))
+void cleanup_seccomp_notify_pluginsp (void *p);
+
+#endif
diff -pruN 0.14.1+dfsg-1/src/libcrun/seccomp_notify_plugin.h 0.15+dfsg-1/src/libcrun/seccomp_notify_plugin.h
--- 0.14.1+dfsg-1/src/libcrun/seccomp_notify_plugin.h	1970-01-01 00:00:00.000000000 +0000
+++ 0.15+dfsg-1/src/libcrun/seccomp_notify_plugin.h	2020-09-03 11:43:25.000000000 +0000
@@ -0,0 +1,64 @@
+/*
+ * crun - OCI runtime written in C
+ *
+ * Copyright (C) 2020 Giuseppe Scrivano <giuseppe@scrivano.org>
+ * crun is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License as published by
+ * the Free Software Foundation; either version 2.1 of the License, or
+ * (at your option) any later version.
+ *
+ * crun is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public License
+ * along with crun.  If not, see <http://www.gnu.org/licenses/>.
+ */
+#ifndef SECCOMP_NOTIFY_PLUGINPLUGIN_H
+
+#  include <linux/seccomp.h>
+
+struct libcrun_load_seccomp_notify_conf_s
+{
+  const char *runtime_root_path;
+  const char *name;
+  const char *bundle_path;
+  const char *oci_config_path;
+};
+
+/* The plugin doesn't know how to handle the request.  */
+#  define RUN_OCI_SECCOMP_NOTIFY_HANDLE_NOT_HANDLED 0
+/* The plugin filled the response and it is ready to write.  */
+#  define RUN_OCI_SECCOMP_NOTIFY_HANDLE_SEND_RESPONSE 1
+/* The plugin will handle the request and write directly to the fd.  */
+#  define RUN_OCI_SECCOMP_NOTIFY_HANDLE_DELAYED_RESPONSE 2
+/* Specify SECCOMP_USER_NOTIF_FLAG_CONTINUE in the flags.  */
+#  define RUN_OCI_SECCOMP_NOTIFY_HANDLE_SEND_RESPONSE_AND_CONTINUE 3
+
+#  ifndef SECCOMP_NOTIFY_SKIP_TYPEDEF
+
+/* Configure the plugin.  Return an opaque pointer that will be used for successive calls.  */
+typedef int (*run_oci_seccomp_notify_start_cb) (void **opaque, struct libcrun_load_seccomp_notify_conf_s *conf,
+                                                size_t size_configuration);
+
+/* Try to handle a single request.  It MUST be defined.
+   HANDLED specifies how the request was handled by the plugin:
+   0: not handled, try next plugin or return ENOTSUP if it is the last plugin.
+   RUN_OCI_SECCOMP_NOTIFY_HANDLE_SEND_RESPONSE: sresp filled and ready to be notified to seccomp.
+   RUN_OCI_SECCOMP_NOTIFY_HANDLE_DELAYED_RESPONSE: the notification will be handled internally by the plugin and
+   forwarded to seccomp_fd. It is useful for asynchronous handling.
+*/
+typedef int (*run_oci_seccomp_notify_handle_request_cb) (void *opaque, struct seccomp_notif_sizes *sizes,
+                                                         struct seccomp_notif *sreq, struct seccomp_notif_resp *sresp,
+                                                         int seccomp_fd, int *handled);
+
+/* Stop the plugin.  The opaque value is the return value from run_oci_seccomp_notify_start.  */
+typedef int (*run_oci_seccomp_notify_stop_cb) (void *opaque);
+
+/* Retrieve the API version used by the plugin.  It MUST return 1. */
+typedef int (*run_oci_seccomp_notify_plugin_version_cb) ();
+
+#  endif
+
+#endif
diff -pruN 0.14.1+dfsg-1/src/libcrun/status.c 0.15+dfsg-1/src/libcrun/status.c
--- 0.14.1+dfsg-1/src/libcrun/status.c	2020-07-03 19:38:11.000000000 +0000
+++ 0.15+dfsg-1/src/libcrun/status.c	2020-09-22 18:17:19.000000000 +0000
@@ -33,27 +33,7 @@
 
 struct pid_stat
 {
-  int pid;
-  char comm[256];
   char state;
-  int ppid;
-  int pgrp;
-  int session;
-  int tty_nr;
-  int tpgid;
-  unsigned flags;
-  unsigned long minflt;
-  unsigned long cminflt;
-  unsigned long majflt;
-  unsigned long cmajflt;
-  unsigned long utime;
-  unsigned long stime;
-  long cutime;
-  long cstime;
-  long priority;
-  long nice;
-  long num_threads;
-  long itrealvalue;
   unsigned long long starttime;
 };
 
@@ -102,47 +82,69 @@ get_state_directory_status_file (const c
 static int
 read_pid_stat (pid_t pid, struct pid_stat *st, libcrun_error_t *err)
 {
-  cleanup_free char *pid_stat_file = NULL;
   cleanup_free char *buffer = NULL;
   cleanup_close int fd = -1;
-  int ret;
+  char pid_stat_file[64];
+  char *it, *s;
+  int i, ret;
 
-  xasprintf (&pid_stat_file, "/proc/%d/stat", pid);
+  sprintf (pid_stat_file, "/proc/%d/stat", pid);
 
   fd = open (pid_stat_file, O_RDONLY);
   if (fd < 0)
     {
       /* The process already exited.  */
       if (errno == ENOENT)
-	{
-	  memset (st, 0, sizeof (*st));
-	  return 0;
-	}
+        {
+          memset (st, 0, sizeof (*st));
+          return 0;
+        }
       return crun_make_error (err, errno, "open state file %s", pid_stat_file);
     }
 
   ret = read_all_fd (fd, pid_stat_file, &buffer, NULL, err);
   if (ret < 0)
     {
+      st->starttime = 0;
+      st->state = 'X';
       /* The process already exited.  */
       libcrun_error_release (err);
       return 0;
     }
 
-  ret = sscanf (buffer, "%d %255s %c %d %d %d %d %d %u %lu %lu %lu %lu %lu %lu %ld %ld %ld %ld %ld %ld %llu",
-    &(st->pid), st->comm, &(st->state), &(st->ppid), &(st->pgrp), &(st->session),
-    &(st->tty_nr), &(st->tpgid), &(st->flags), &(st->minflt), &(st->cminflt),
-    &(st->majflt), &(st->cmajflt), &(st->utime), &(st->stime), &(st->cutime),
-    &(st->cstime), &(st->priority), &(st->nice), &(st->num_threads), &(st->itrealvalue),
-    &(st->starttime));
-  if (UNLIKELY (ret != 22))
-    return crun_make_error (err, 0, "fscanf failed");
+  s = NULL;
+
+  /* Skip the first two arguments.  */
+  for (it = buffer; it; it = strchr (it + 1, ')'))
+    s = it + 1;
+
+  if (s)
+    while (*s == ' ')
+      s++;
+
+  if (s == NULL || *s == '\0')
+    return crun_make_error (err, 0, "could not read process state");
+
+  st->state = *s;
+
+  /* Seek to the starttime argument.  */
+  for (it = s + 1, i = 0; i < 19 && it != NULL; i++, it = strchr (it, ' ') + 1)
+    ;
+
+  if (it == NULL || i != 19)
+    return crun_make_error (err, 0, "could not read process start time");
+
+  errno = 0;
+  st->starttime = strtoull (it, NULL, 10);
+  if (errno != 0)
+    return crun_make_error (err, errno, "parse process start time");
 
   return 0;
 }
 
 int
-libcrun_write_container_status (const char *state_root, const char *id, libcrun_container_status_t *status, libcrun_error_t *err)
+libcrun_write_container_status (const char *state_root, const char *id, libcrun_container_status_t *status,
+                                libcrun_error_t *err)
 {
   int ret;
   cleanup_free char *file = get_state_directory_status_file (state_root, id);
@@ -155,7 +157,7 @@ libcrun_write_container_status (const ch
   yajl_gen gen = NULL;
 
   ret = read_pid_stat (status->pid, &st, err);
-  if (UNLIKELY (ret))
+  if (UNLIKELY (ret < 0))
     return ret;
 
   status->process_start_time = st.starttime;
@@ -227,7 +229,7 @@ libcrun_write_container_status (const ch
       goto exit;
     }
 
- exit:
+exit:
   if (gen)
     yajl_gen_free (gen);
 
@@ -235,7 +237,8 @@ libcrun_write_container_status (const ch
 }
 
 int
-libcrun_read_container_status (libcrun_container_status_t *status, const char *state_root, const char *id, libcrun_error_t *err)
+libcrun_read_container_status (libcrun_container_status_t *status, const char *state_root, const char *id,
+                               libcrun_error_t *err)
 {
   cleanup_free char *buffer = NULL;
   char err_buffer[256];
@@ -262,7 +265,7 @@ libcrun_read_container_status (libcrun_c
     const char *process_start_time_path[] = { "process-start-time", NULL };
     tmp = yajl_tree_get (tree, process_start_time_path, yajl_t_number);
     if (UNLIKELY (tmp == NULL))
-      status->process_start_time = 0; /* backwards compatability */
+      status->process_start_time = 0; /* backwards compatibility */
     else
       status->process_start_time = strtoull (YAJL_GET_NUMBER (tmp), NULL, 10);
   }
@@ -356,7 +359,7 @@ libcrun_status_check_directories (const
 
   dir = libcrun_get_state_directory (state_root, id);
   if (UNLIKELY (dir == NULL))
-        return crun_make_error (err, 0, "cannot get state directory");
+    return crun_make_error (err, 0, "cannot get state directory");
 
   ret = crun_path_exists (dir, err);
   if (UNLIKELY (ret < 0))
@@ -426,7 +429,7 @@ libcrun_container_delete_status (const c
 
   dir = get_run_directory (state_root);
   if (UNLIKELY (dir == NULL))
-        return crun_make_error (err, 0, "cannot get state directory");
+    return crun_make_error (err, 0, "cannot get state directory");
 
   rundir_dfd = open (dir, O_DIRECTORY | O_RDONLY | O_CLOEXEC);
   if (UNLIKELY (rundir_dfd < 0))
@@ -473,7 +476,7 @@ libcrun_get_containers_list (libcrun_con
   *ret = NULL;
   dir = opendir (path);
   if (UNLIKELY (dir == NULL))
-      return crun_make_error (err, errno, "cannot opendir `%s`", path);
+    return crun_make_error (err, errno, "cannot opendir `%s`", path);
 
   for (next = readdir (dir); next; next = readdir (dir))
     {
@@ -488,12 +491,12 @@ libcrun_get_containers_list (libcrun_con
       xasprintf (&status_file, "%s/%s/status", path, next->d_name);
       exists = crun_path_exists (status_file, err);
       if (exists < 0)
-       {
-         libcrun_free_containers_list (tmp);
-         return exists;
-       }
+        {
+          libcrun_free_containers_list (tmp);
+          return exists;
+        }
 
-      if (!exists)
+      if (! exists)
         continue;
 
       next_container = xmalloc (sizeof (libcrun_container_list_t));
@@ -518,6 +521,32 @@ libcrun_free_containers_list (libcrun_co
     }
 }
 
+/* check if the container pid is still valid.
+   Returns:
+   -1: on errors
+    0: pid not valid
+    1: pid valid and container in the running/created/paused state
+*/
+int
+libcrun_check_pid_valid (libcrun_container_status_t *status, libcrun_error_t *err)
+{
+  struct pid_stat st;
+  int ret;
+
+  /* For backwards compatibility, check start time only if available. */
+  if (! status->process_start_time)
+    return 1;
+
+  ret = read_pid_stat (status->pid, &st, err);
+  if (UNLIKELY (ret < 0))
+    return ret;
+
+  if (status->process_start_time != st.starttime || st.state == 'Z' || st.state == 'X')
+    return 0; /* stopped */
+
+  return 1; /* running, created, or paused */
+}
+
 int
 libcrun_is_container_running (libcrun_container_status_t *status, libcrun_error_t *err)
 {
@@ -528,20 +557,8 @@ libcrun_is_container_running (libcrun_co
     return crun_make_error (err, errno, "kill");
 
   if (ret == 0)
-    {
-      /* For backwards compatability, check start time only if available. */
-      if (status->process_start_time)
-        {
-          struct pid_stat st;
-          ret = read_pid_stat (status->pid, &st, err);
-          if (UNLIKELY (ret))
-            return ret;
+    return libcrun_check_pid_valid (status, err);
 
-          if (status->process_start_time != st.starttime || st.state == 'Z' || st.state == 'X')
-            return 0; /* stopped */
-        }
-      return 1; /* running, created, or paused */
-    }
   return 0; /* stopped */
 }
 
@@ -568,7 +585,9 @@ libcrun_status_write_exec_fifo (const ch
 {
   cleanup_free char *state_dir = libcrun_get_state_directory (state_root, id);
   cleanup_free char *fifo_path;
-  char buffer[1] = {0, };
+  char buffer[1] = {
+    0,
+  };
   int ret;
   cleanup_close int fd = -1;
 
diff -pruN 0.14.1+dfsg-1/src/libcrun/status.h 0.15+dfsg-1/src/libcrun/status.h
--- 0.14.1+dfsg-1/src/libcrun/status.h	2020-07-03 19:38:11.000000000 +0000
+++ 0.15+dfsg-1/src/libcrun/status.h	2020-09-03 11:43:25.000000000 +0000
@@ -17,12 +17,12 @@
  */
 
 #ifndef STATUS_H
-# define STATUS_H
+#define STATUS_H
 
-# include <config.h>
-# include <runtime_spec_schema_config_schema.h>
-# include "error.h"
-# include "container.h"
+#include <config.h>
+#include <runtime_spec_schema_config_schema.h>
+#include "error.h"
+#include "container.h"
 
 struct libcrun_container_list_s
 {
@@ -46,19 +46,23 @@ struct libcrun_container_status_s
 };
 typedef struct libcrun_container_status_s libcrun_container_status_t;
 
-# define cleanup_container_status __attribute__((cleanup (libcrun_free_container_status)))
+#define cleanup_container_status __attribute__ ((cleanup (libcrun_free_container_status)))
 
 LIBCRUN_PUBLIC void libcrun_free_container_status (libcrun_container_status_t *status);
-LIBCRUN_PUBLIC int libcrun_write_container_status (const char *state_root, const char *id, libcrun_container_status_t *status, libcrun_error_t *err);
-LIBCRUN_PUBLIC int libcrun_read_container_status (libcrun_container_status_t *status, const char *state_root, const char *id, libcrun_error_t *err);
+LIBCRUN_PUBLIC int libcrun_write_container_status (const char *state_root, const char *id,
+                                                   libcrun_container_status_t *status, libcrun_error_t *err);
+LIBCRUN_PUBLIC int libcrun_read_container_status (libcrun_container_status_t *status, const char *state_root,
+                                                  const char *id, libcrun_error_t *err);
 LIBCRUN_PUBLIC void libcrun_free_containers_list (libcrun_container_list_t *list);
 LIBCRUN_PUBLIC int libcrun_is_container_running (libcrun_container_status_t *status, libcrun_error_t *err);
 LIBCRUN_PUBLIC char *libcrun_get_state_directory (const char *state_root, const char *id);
 LIBCRUN_PUBLIC int libcrun_container_delete_status (const char *state_root, const char *id, libcrun_error_t *err);
-LIBCRUN_PUBLIC int libcrun_get_containers_list (libcrun_container_list_t **ret, const char *state_root, libcrun_error_t *err);
+LIBCRUN_PUBLIC int libcrun_get_containers_list (libcrun_container_list_t **ret, const char *state_root,
+                                                libcrun_error_t *err);
 
 int libcrun_status_check_directories (const char *state_root, const char *id, libcrun_error_t *err);
 int libcrun_status_create_exec_fifo (const char *state_root, const char *id, libcrun_error_t *err);
 int libcrun_status_write_exec_fifo (const char *state_root, const char *id, libcrun_error_t *err);
 int libcrun_status_has_read_exec_fifo (const char *state_root, const char *id, libcrun_error_t *err);
+int libcrun_check_pid_valid (libcrun_container_status_t *status, libcrun_error_t *err);
 #endif
diff -pruN 0.14.1+dfsg-1/src/libcrun/terminal.c 0.15+dfsg-1/src/libcrun/terminal.c
--- 0.14.1+dfsg-1/src/libcrun/terminal.c	2020-07-02 13:46:33.000000000 +0000
+++ 0.15+dfsg-1/src/libcrun/terminal.c	2020-09-03 11:43:25.000000000 +0000
@@ -36,9 +36,8 @@ struct terminal_status_s
   struct termios termios;
 };
 
-
 int
-libcrun_new_terminal (char **slave, libcrun_error_t *err)
+libcrun_new_terminal (char **pty, libcrun_error_t *err)
 {
   char buf[64];
   int ret;
@@ -54,7 +53,7 @@ libcrun_new_terminal (char **slave, libc
   if (UNLIKELY (ret < 0))
     return crun_make_error (err, errno, "unlockpt");
 
-  *slave = xstrdup (buf);
+  *pty = xstrdup (buf);
 
   ret = fd;
   fd = -1;
@@ -85,13 +84,13 @@ set_raw (int fd, libcrun_error_t *err)
 }
 
 int
-libcrun_set_stdio (char *slave, libcrun_error_t *err)
+libcrun_set_stdio (char *pty, libcrun_error_t *err)
 {
   int ret, i;
-  cleanup_close int fd = open (slave, O_RDWR);
+  cleanup_close int fd = open (pty, O_RDWR);
 
   if (UNLIKELY (fd < 0))
-    return crun_make_error (err, errno, "open %s", slave);
+    return crun_make_error (err, errno, "open %s", pty);
 
   for (i = 0; i < 3; i++)
     {
@@ -108,7 +107,7 @@ libcrun_set_stdio (char *slave, libcrun_
 }
 
 int
-libcrun_setup_terminal_master (int fd, void **current_status, libcrun_error_t *err)
+libcrun_setup_terminal_ptmx (int fd, void **current_status, libcrun_error_t *err)
 {
   int ret;
   struct termios termios;
@@ -146,7 +145,7 @@ cleanup_terminalp (void *p)
 int
 libcrun_terminal_setup_size (int fd, unsigned short rows, unsigned short cols, libcrun_error_t *err)
 {
-  struct winsize ws = {.ws_row = rows, .ws_col = cols};
+  struct winsize ws = { .ws_row = rows, .ws_col = cols };
   int ret;
 
   if (ws.ws_row == 0 || ws.ws_col == 0)
diff -pruN 0.14.1+dfsg-1/src/libcrun/terminal.h 0.15+dfsg-1/src/libcrun/terminal.h
--- 0.14.1+dfsg-1/src/libcrun/terminal.h	2020-07-02 13:46:33.000000000 +0000
+++ 0.15+dfsg-1/src/libcrun/terminal.h	2020-09-03 11:43:25.000000000 +0000
@@ -16,20 +16,20 @@
  * along with crun.  If not, see <http://www.gnu.org/licenses/>.
  */
 #ifndef TERMINAL_H
-# define TERMINAL_H
-# include <config.h>
+#define TERMINAL_H
+#include <config.h>
 
-# include "container.h"
-# include <termios.h>
+#include "container.h"
+#include <termios.h>
 
 void cleanup_terminalp (void *p);
-#define cleanup_terminal __attribute__((cleanup (cleanup_terminalp)))
+#define cleanup_terminal __attribute__ ((cleanup (cleanup_terminalp)))
 
-int libcrun_new_terminal (char **slave, libcrun_error_t *err);
+int libcrun_new_terminal (char **pty, libcrun_error_t *err);
 
-int libcrun_set_stdio (char *slave, libcrun_error_t *err);
+int libcrun_set_stdio (char *pty, libcrun_error_t *err);
 
-int libcrun_setup_terminal_master (int fd, void **current_status, libcrun_error_t *err);
+int libcrun_setup_terminal_ptmx (int fd, void **current_status, libcrun_error_t *err);
 
 int libcrun_terminal_setup_size (int fd, unsigned short rows, unsigned short cols, libcrun_error_t *err);
 
diff -pruN 0.14.1+dfsg-1/src/libcrun/utils.c 0.15+dfsg-1/src/libcrun/utils.c
--- 0.14.1+dfsg-1/src/libcrun/utils.c	2020-07-06 19:48:57.000000000 +0000
+++ 0.15+dfsg-1/src/libcrun/utils.c	2020-09-22 18:17:19.000000000 +0000
@@ -42,27 +42,27 @@
 #include <limits.h>
 
 #ifndef RESOLVE_IN_ROOT
-# define RESOLVE_IN_ROOT		0x10
+#  define RESOLVE_IN_ROOT 0x10
 #endif
 #ifndef __NR_openat2
-# define __NR_openat2 437
+#  define __NR_openat2 437
 #endif
 
+#define MAX_READLINKS 32
+
 static int
 syscall_openat2 (int dirfd, const char *path, uint64_t flags, uint64_t mode, uint64_t resolve)
 {
   struct openat2_open_how
-    {
-      uint64_t flags;
-      uint64_t mode;
-      uint64_t resolve;
-    }
-  how =
-    {
-     .flags = flags,
-     .mode = mode,
-     .resolve = resolve,
-    };
+  {
+    uint64_t flags;
+    uint64_t mode;
+    uint64_t resolve;
+  } how = {
+    .flags = flags,
+    .mode = mode,
+    .resolve = resolve,
+  };
 
   return (int) syscall (__NR_openat2, dirfd, path, &how, sizeof (how), 0);
 }
@@ -159,7 +159,7 @@ get_file_type_fd (int fd, mode_t *mode)
   *mode = stx.stx_mode;
   return ret;
 
- fallback:
+fallback:
 #endif
   ret = fstat (fd, &st);
   *mode = st.st_mode;
@@ -186,7 +186,7 @@ get_file_type_at (int dirfd, mode_t *mod
   *mode = stx.stx_mode;
   return ret;
 
- fallback:
+fallback:
 #endif
   ret = fstatat (dirfd, path, &st, nofollow ? AT_SYMLINK_NOFOLLOW : 0);
   *mode = st.st_mode;
@@ -320,8 +320,8 @@ close_and_replace (int *oldfd, int newfd
 char *chroot_realpath (const char *chroot, const char *path, char resolved_path[]);
 
 int
-safe_openat (int dirfd, const char *rootfs, size_t rootfs_len, const char *path, int flags,
-             int mode, libcrun_error_t *err)
+safe_openat (int dirfd, const char *rootfs, size_t rootfs_len, const char *path, int flags, int mode,
+             libcrun_error_t *err)
 {
   int ret;
   cleanup_close int fd = -1;
@@ -343,7 +343,7 @@ safe_openat (int dirfd, const char *root
       return ret;
     }
 
- fallback:
+fallback:
   path_in_chroot = chroot_realpath (rootfs, path, buffer);
   if (path_in_chroot == NULL)
     return crun_make_error (err, errno, "cannot resolve `%s` under rootfs", path);
@@ -363,22 +363,26 @@ safe_openat (int dirfd, const char *root
     return ret;
 
   ret = fd;
-  fd = - 1;
+  fd = -1;
   return ret;
 }
 
 static int
-crun_safe_ensure_at (bool dir, int dirfd, const char *dirpath, size_t dirpath_len, const char *path,
-                     int mode, libcrun_error_t *err)
+crun_safe_ensure_at (bool dir, int dirfd, const char *dirpath, size_t dirpath_len, const char *path, int mode,
+                     int max_readlinks, libcrun_error_t *err)
 {
   cleanup_close int wd_cleanup = -1;
   cleanup_free char *npath = NULL;
   bool last_component = false;
+  size_t depth = 0;
   const char *cur;
   char *it;
   int cwd;
   int ret;
 
+  if (max_readlinks <= 0)
+    return crun_make_error (err, ELOOP, "resolve path `%s`", path);
+
   while (*path == '/')
     path++;
 
@@ -403,16 +407,51 @@ crun_safe_ensure_at (bool dir, int dirfd
       if (cur[0] == '\0')
         break;
 
-      if (strcmp (cur, "..") == 0)
-        return crun_make_error (err, 0, "invalid path `%s`", path);
+      if (strcmp (cur, ".") == 0)
+        goto next;
+      else if (strcmp (cur, ".."))
+        depth++;
+      else
+        {
+          if (depth)
+            depth--;
+          else
+            {
+              close_and_reset (&wd_cleanup);
+              cwd = dirfd;
+            }
+        }
 
-      if (!last_component || dir)
+      if (! last_component || dir)
         ret = mkdirat (cwd, cur, mode);
       else
         {
           ret = openat (cwd, cur, O_CLOEXEC | O_CREAT | O_WRONLY | O_NOFOLLOW, 0700);
           if (UNLIKELY (ret < 0))
             {
+              /* If the last component is a symlink, repeat the lookup with the resolved path.  */
+              if (errno == ELOOP)
+                {
+                  size_t s, resolved_size = 0;
+                  cleanup_free char *resolved_path = NULL;
+
+                  do
+                    {
+                      resolved_size += 512;
+                      resolved_path = xrealloc (resolved_path, resolved_size);
+
+                      s = readlinkat (dirfd, npath, resolved_path, resolved_size);
+                    }
+                  while (s == resolved_size);
+
+                  if (s > 0)
+                    {
+                      resolved_path[s] = '\0';
+                      crun_error_release (err);
+                      return crun_safe_ensure_at (dir, dirfd, dirpath, dirpath_len, resolved_path, mode,
+                                                  max_readlinks - 1, err);
+                    }
+                }
               /* If the previous openat fails, attempt to open the file in O_PATH mode.  */
               ret = openat (cwd, cur, O_CLOEXEC | O_PATH, 0);
               if (ret < 0)
@@ -436,6 +475,7 @@ crun_safe_ensure_at (bool dir, int dirfd
 
       close_and_replace (&wd_cleanup, cwd);
 
+    next:
       if (it == NULL)
         break;
 
@@ -451,14 +491,14 @@ int
 crun_safe_ensure_directory_at (int dirfd, const char *dirpath, size_t dirpath_len, const char *path, int mode,
                                libcrun_error_t *err)
 {
-  return crun_safe_ensure_at (true, dirfd, dirpath, dirpath_len, path, mode, err);
+  return crun_safe_ensure_at (true, dirfd, dirpath, dirpath_len, path, mode, MAX_READLINKS, err);
 }
 
 int
 crun_safe_ensure_file_at (int dirfd, const char *dirpath, size_t dirpath_len, const char *path, int mode,
                           libcrun_error_t *err)
 {
-  return crun_safe_ensure_at (false, dirfd, dirpath, dirpath_len, path, mode, err);
+  return crun_safe_ensure_at (false, dirfd, dirpath, dirpath_len, path, mode, MAX_READLINKS, err);
 }
 
 int
@@ -515,7 +555,7 @@ get_file_size (int fd, off_t *size)
 
   return ret;
 
- fallback:
+fallback:
 #endif
   ret = fstat (fd, &st);
   *size = st.st_size;
@@ -581,7 +621,7 @@ libcrun_initialize_selinux (libcrun_erro
 }
 
 int
-libcrun_initialize_apparmor (libcrun_error_t *err arg_unused)
+libcrun_initialize_apparmor (libcrun_error_t *err)
 {
   cleanup_close int fd = -1;
   int size;
@@ -590,13 +630,16 @@ libcrun_initialize_apparmor (libcrun_err
   if (apparmor_enabled >= 0)
     return apparmor_enabled;
 
-  fd = open ("/sys/module/apparmor/parameters/enabled", O_RDONLY | O_CLOEXEC);
-  if (fd == -1)
-    return 0;
+  if (crun_dir_p_at (AT_FDCWD, "/sys/kernel/security/apparmor", true, err))
+    {
+      fd = open ("/sys/module/apparmor/parameters/enabled", O_RDONLY | O_CLOEXEC);
+      if (fd == -1)
+        return 0;
 
-  size = TEMP_FAILURE_RETRY (read (fd, &buf, 2));
+      size = TEMP_FAILURE_RETRY (read (fd, &buf, 2));
 
-  apparmor_enabled = size > 0 && buf[0] == 'Y' ? 1 : 0;
+      apparmor_enabled = size > 0 && buf[0] == 'Y' ? 1 : 0;
+    }
 
   return apparmor_enabled;
 }
@@ -631,7 +674,8 @@ add_selinux_mount_label (char **retlabel
 }
 
 static int
-write_file_and_check_fs_type (const char *file, const char *data, size_t len, unsigned int type, const char *type_name, libcrun_error_t *err)
+write_file_and_check_fs_type (const char *file, const char *data, size_t len, unsigned int type, const char *type_name,
+                              libcrun_error_t *err)
 {
   int ret;
   struct statfs sfs;
@@ -666,7 +710,8 @@ set_selinux_exec_label (const char *labe
 
   if (ret)
     {
-      ret = write_file_and_check_fs_type ("/proc/thread-self/attr/exec", label, strlen (label), PROC_SUPER_MAGIC, "procfs", err);
+      ret = write_file_and_check_fs_type ("/proc/thread-self/attr/exec", label, strlen (label), PROC_SUPER_MAGIC,
+                                          "procfs", err);
       if (UNLIKELY (ret < 0))
         return ret;
     }
@@ -695,7 +740,8 @@ set_apparmor_profile (const char *profil
 
       xasprintf (&buf, "exec %s", profile);
 
-      ret = write_file_and_check_fs_type ("/proc/thread-self/attr/exec", buf, strlen (buf), PROC_SUPER_MAGIC, "procfs", err);
+      ret = write_file_and_check_fs_type ("/proc/thread-self/attr/exec", buf, strlen (buf), PROC_SUPER_MAGIC, "procfs",
+                                          err);
       if (UNLIKELY (ret < 0))
         return ret;
     }
@@ -743,14 +789,11 @@ read_all_fd (int fd, const char *descrip
 }
 
 int
-read_all_file (const char *path, char **out, size_t *len, libcrun_error_t *err)
+read_all_file_at (int dirfd, const char *path, char **out, size_t *len, libcrun_error_t *err)
 {
   cleanup_close int fd;
 
-  if (strcmp (path, "-") == 0)
-    path = "/dev/stdin";
-
-  fd = TEMP_FAILURE_RETRY (open (path, O_RDONLY));
+  fd = TEMP_FAILURE_RETRY (openat (dirfd, path, O_RDONLY));
   if (UNLIKELY (fd < 0))
     return crun_make_error (err, errno, "error opening file `%s`", path);
 
@@ -758,6 +801,15 @@ read_all_file (const char *path, char **
 }
 
 int
+read_all_file (const char *path, char **out, size_t *len, libcrun_error_t *err)
+{
+  if (strcmp (path, "-") == 0)
+    path = "/dev/stdin";
+
+  return read_all_file_at (AT_FDCWD, path, out, len, err);
+}
+
+int
 open_unix_domain_client_socket (const char *path, int dgram, libcrun_error_t *err)
 {
   struct sockaddr_un addr = {};
@@ -797,7 +849,7 @@ open_unix_domain_socket (const char *pat
   if (UNLIKELY (ret < 0))
     return crun_make_error (err, errno, "bind socket to `%s`", path);
 
-  if (!dgram)
+  if (! dgram)
     {
       ret = listen (fd, 1);
       if (UNLIKELY (ret < 0))
@@ -955,7 +1007,7 @@ copy_from_fd_to_fd (int src, int dst, in
 
     fallback:
 #endif
-# define BUFFER_SIZE 4096
+#define BUFFER_SIZE 4096
 
       buffer = xmalloc (BUFFER_SIZE);
       nread = TEMP_FAILURE_RETRY (read (src, buffer, BUFFER_SIZE));
@@ -978,7 +1030,6 @@ copy_from_fd_to_fd (int src, int dst, in
   while (consume && nread);
 
   return 0;
-
 }
 
 int
@@ -1003,58 +1054,65 @@ run_process (char **args, libcrun_error_
 
 #ifndef HAVE_FGETPWENT_R
 static unsigned
-atou(char **s)
+atou (char **s)
 {
   unsigned x;
   for (x = 0; **s - '0' < 10; ++*s)
-    x = 10 * x + (**s-'0');
+    x = 10 * x + (**s - '0');
   return x;
 }
 
 int
-fgetpwent_r(FILE *f, struct passwd *pw, char *line, size_t size, struct passwd **res)
+fgetpwent_r (FILE *f, struct passwd *pw, char *line, size_t size, struct passwd **res)
 {
   char *s;
   int rv = 0;
   for (;;)
     {
-      line[size-1] = '\xff';
-      if ( (fgets(line, size, f) == NULL) || ferror(f) || line[size-1] != '\xff' ) {
-        rv = (line[size-1] != '\xff') ? ERANGE : ENOENT;
-        line = 0;
-        pw = 0;
-        break;
-      }
-    line[strcspn(line, "\n")] = 0;
+      line[size - 1] = '\xff';
+      if ((fgets (line, size, f) == NULL) || ferror (f) || line[size - 1] != '\xff')
+        {
+          rv = (line[size - 1] != '\xff') ? ERANGE : ENOENT;
+          line = 0;
+          pw = 0;
+          break;
+        }
+      line[strcspn (line, "\n")] = 0;
+
+      s = line;
+      pw->pw_name = s++;
+      if (! (s = strchr (s, ':')))
+        continue;
+
+      *s++ = 0;
+      pw->pw_passwd = s;
+      if (! (s = strchr (s, ':')))
+        continue;
+
+      *s++ = 0;
+      pw->pw_uid = atou (&s);
+      if (*s != ':')
+        continue;
 
-    s = line;
-    pw->pw_name = s++;
-    if (!(s = strchr(s, ':')))
-      continue;
-
-    *s++ = 0; pw->pw_passwd = s;
-    if (!(s = strchr(s, ':')))
-      continue;
-
-    *s++ = 0; pw->pw_uid = atou(&s);
-    if (*s != ':')
-      continue;
-
-    *s++ = 0; pw->pw_gid = atou(&s);
-    if (*s != ':')
-      continue;
-
-    *s++ = 0; pw->pw_gecos = s;
-    if (!(s = strchr(s, ':')))
-      continue;
-
-    *s++ = 0; pw->pw_dir = s;
-    if (!(s = strchr(s, ':')))
-      continue;
-
-    *s++ = 0; pw->pw_shell = s;
-    break;
-  }
+      *s++ = 0;
+      pw->pw_gid = atou (&s);
+      if (*s != ':')
+        continue;
+
+      *s++ = 0;
+      pw->pw_gecos = s;
+      if (! (s = strchr (s, ':')))
+        continue;
+
+      *s++ = 0;
+      pw->pw_dir = s;
+      if (! (s = strchr (s, ':')))
+        continue;
+
+      *s++ = 0;
+      pw->pw_shell = s;
+      break;
+    }
   *res = pw;
   if (rv)
     errno = rv;
@@ -1182,7 +1240,7 @@ getsubidrange (uid_t id, int is_uid, uin
     }
 }
 
-#define MIN(x,y) ((x)<(y)?(x):(y))
+#define MIN(x, y) ((x) < (y) ? (x) : (y))
 
 size_t
 format_default_id_mapping (char **ret, uid_t container_id, uid_t host_id, int is_uid)
@@ -1221,16 +1279,8 @@ format_default_id_mapping (char **ret, u
 
 /* will leave SIGCHLD blocked if TIMEOUT is used.  */
 int
-run_process_with_stdin_timeout_envp (char *path,
-                                     char **args,
-                                     const char *cwd,
-                                     int timeout,
-                                     char **envp,
-                                     char *stdin,
-                                     size_t stdin_len,
-                                     int out_fd,
-                                     int err_fd,
-                                     libcrun_error_t *err)
+run_process_with_stdin_timeout_envp (char *path, char **args, const char *cwd, int timeout, char **envp, char *stdin,
+                                     size_t stdin_len, int out_fd, int err_fd, libcrun_error_t *err)
 {
   int stdin_pipe[2];
   pid_t pid;
@@ -1289,12 +1339,12 @@ run_process_with_stdin_timeout_envp (cha
               if (ret < 0 && errno == EAGAIN)
                 goto timeout;
             }
- timeout:
+        timeout:
           kill (pid, SIGKILL);
           return crun_make_error (err, 0, "timeout expired for `%s`", path);
         }
 
- read_waitpid:
+    read_waitpid:
       r = TEMP_FAILURE_RETRY (waitpid (pid, &status, 0));
       if (r < 0)
         return crun_make_error (err, errno, "waitpid");
@@ -1305,7 +1355,7 @@ run_process_with_stdin_timeout_envp (cha
     }
   else
     {
-      char *tmp_args[] = {path, NULL};
+      char *tmp_args[] = { path, NULL };
       int dev_null_fd = -1;
 
       if (out_fd < 0 || err_fd < 0)
@@ -1418,15 +1468,15 @@ set_blocking_fd (int fd, int blocking, l
 int
 parse_json_file (yajl_val *out, const char *jsondata, struct parser_context *ctx arg_unused, libcrun_error_t *err)
 {
-    char errbuf[1024];
+  char errbuf[1024];
 
-    *err = NULL;
+  *err = NULL;
 
-    *out = yajl_tree_parse (jsondata, errbuf, sizeof (errbuf));
-    if (*out == NULL)
-      return crun_make_error (err, 0, "cannot parse the data: `%s`", errbuf);
+  *out = yajl_tree_parse (jsondata, errbuf, sizeof (errbuf));
+  if (*out == NULL)
+    return crun_make_error (err, 0, "cannot parse the data: `%s`", errbuf);
 
-    return 0;
+  return 0;
 }
 
 int
@@ -1583,7 +1633,6 @@ copy_xattr (int sfd, int dfd, const char
       return crun_make_error (err, errno, "get xattr list for `%s`", srcname);
     }
 
-
   if (xattr_len == 0)
     return 0;
 
@@ -1617,8 +1666,8 @@ copy_xattr (int sfd, int dfd, const char
 
 #endif
 
-static
-int copy_rec_stat_file_at (int dfd, const char *path, mode_t *mode, off_t *size, dev_t *rdev, uid_t *uid, gid_t *gid)
+static int
+copy_rec_stat_file_at (int dfd, const char *path, mode_t *mode, off_t *size, dev_t *rdev, uid_t *uid, gid_t *gid)
 {
   struct stat st;
   int ret;
@@ -1626,7 +1675,8 @@ int copy_rec_stat_file_at (int dfd, cons
 #ifdef HAVE_STATX
   struct statx stx;
 
-  ret = statx (dfd, path, AT_SYMLINK_NOFOLLOW | AT_STATX_DONT_SYNC, STATX_TYPE | STATX_MODE | STATX_SIZE | STATX_UID | STATX_GID, &stx);
+  ret = statx (dfd, path, AT_SYMLINK_NOFOLLOW | AT_STATX_DONT_SYNC,
+               STATX_TYPE | STATX_MODE | STATX_SIZE | STATX_UID | STATX_GID, &stx);
   if (UNLIKELY (ret < 0))
     {
       if (errno == ENOSYS || errno == EINVAL)
@@ -1643,7 +1693,7 @@ int copy_rec_stat_file_at (int dfd, cons
 
   return ret;
 
- fallback:
+fallback:
 #endif
   ret = fstatat (dfd, path, &st, AT_SYMLINK_NOFOLLOW);
 
@@ -1684,8 +1734,7 @@ copy_recursive_fd_to_fd (int srcdirfd, i
       uid_t uid;
       gid_t gid;
 
-      if (strcmp (de->d_name, ".") == 0 ||
-          strcmp (de->d_name, "..") == 0)
+      if (strcmp (de->d_name, ".") == 0 || strcmp (de->d_name, "..") == 0)
         continue;
 
       ret = copy_rec_stat_file_at (dirfd (dsrcfd), de->d_name, &mode, &st_size, &rdev, &uid, &gid);
@@ -1777,11 +1826,11 @@ copy_recursive_fd_to_fd (int srcdirfd, i
       if (UNLIKELY (ret < 0))
         return crun_make_error (err, errno, "chown `%s/%s`", destname, de->d_name);
 
-      /*
-       * ALLPERMS is not defined by POSIX
-       */
+        /*
+         * ALLPERMS is not defined by POSIX
+         */
 #ifndef ALLPERMS
-# define ALLPERMS (S_ISUID|S_ISGID|S_ISVTX|S_IRWXU|S_IRWXG|S_IRWXO)
+#  define ALLPERMS (S_ISUID | S_ISGID | S_ISVTX | S_IRWXU | S_IRWXG | S_IRWXO)
 #endif
 
       ret = fchmodat (destdirfd, de->d_name, mode & ALLPERMS, AT_SYMLINK_NOFOLLOW);
diff -pruN 0.14.1+dfsg-1/src/libcrun/utils.h 0.15+dfsg-1/src/libcrun/utils.h
--- 0.14.1+dfsg-1/src/libcrun/utils.h	2020-07-03 19:38:11.000000000 +0000
+++ 0.15+dfsg-1/src/libcrun/utils.h	2020-09-03 11:43:25.000000000 +0000
@@ -16,37 +16,39 @@
  * along with crun.  If not, see <http://www.gnu.org/licenses/>.
  */
 #ifndef UTILS_H
-# define UTILS_H
+#define UTILS_H
 
-# include <config.h>
-# include <stdio.h>
-# include <stdlib.h>
-# include <errno.h>
-# include <argp.h>
-# include "error.h"
-# include <dirent.h>
-# include <unistd.h>
-# include <runtime_spec_schema_config_schema.h>
-# include "container.h"
-
-# ifndef TEMP_FAILURE_RETRY
-#  define TEMP_FAILURE_RETRY(expression)                                \
-  (__extension__                                                        \
-   ({ long int __result;                                                \
-     do __result = (long int) (expression);                             \
-     while (__result < 0 && errno == EINTR);                            \
-     __result; }))
-# endif
-
-# define cleanup_file __attribute__((cleanup (cleanup_filep)))
-# define cleanup_free __attribute__((cleanup (cleanup_freep)))
-# define cleanup_close __attribute__((cleanup (cleanup_closep)))
-# define cleanup_close_vec __attribute__((cleanup (cleanup_close_vecp)))
-# define cleanup_dir __attribute__((cleanup (cleanup_dirp)))
-# define arg_unused __attribute__((unused))
+#include <config.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <errno.h>
+#include <argp.h>
+#include "error.h"
+#include <dirent.h>
+#include <unistd.h>
+#include <runtime_spec_schema_config_schema.h>
+#include "container.h"
+
+#ifndef TEMP_FAILURE_RETRY
+#  define TEMP_FAILURE_RETRY(expression)      \
+    (__extension__({                          \
+      long int __result;                      \
+      do                                      \
+        __result = (long int) (expression);   \
+      while (__result < 0 && errno == EINTR); \
+      __result;                               \
+    }))
+#endif
+
+#define cleanup_file __attribute__ ((cleanup (cleanup_filep)))
+#define cleanup_free __attribute__ ((cleanup (cleanup_freep)))
+#define cleanup_close __attribute__ ((cleanup (cleanup_closep)))
+#define cleanup_close_vec __attribute__ ((cleanup (cleanup_close_vecp)))
+#define cleanup_dir __attribute__ ((cleanup (cleanup_dirp)))
+#define arg_unused __attribute__ ((unused))
 
-# define LIKELY(x) __builtin_expect((x),1)
-# define UNLIKELY(x) __builtin_expect((x),0)
+#define LIKELY(x) __builtin_expect ((x), 1)
+#define UNLIKELY(x) __builtin_expect ((x), 0)
 
 static inline void *
 xmalloc (size_t size)
@@ -159,9 +161,11 @@ int crun_ensure_directory_at (int dirfd,
 
 int crun_ensure_file_at (int dirfd, const char *path, int mode, bool nofollow, libcrun_error_t *err);
 
-int crun_safe_ensure_directory_at (int dirfd, const char *dirpath, size_t dirpath_len, const char *path, int mode, libcrun_error_t *err);
+int crun_safe_ensure_directory_at (int dirfd, const char *dirpath, size_t dirpath_len, const char *path, int mode,
+                                   libcrun_error_t *err);
 
-int crun_safe_ensure_file_at (int dirfd, const char *dirpath, size_t dirpath_len, const char *path, int mode, libcrun_error_t *err);
+int crun_safe_ensure_file_at (int dirfd, const char *dirpath, size_t dirpath_len, const char *path, int mode,
+                              libcrun_error_t *err);
 
 int crun_dir_p (const char *path, bool nofollow, libcrun_error_t *err);
 
@@ -183,6 +187,8 @@ int read_all_fd (int fd, const char *des
 
 int read_all_file (const char *path, char **out, size_t *len, libcrun_error_t *err);
 
+int read_all_file_at (int dirfd, const char *path, char **out, size_t *len, libcrun_error_t *err);
+
 int open_unix_domain_client_socket (const char *path, int dgram, libcrun_error_t *err);
 
 int open_unix_domain_socket (const char *path, int dgram, libcrun_error_t *err);
@@ -203,7 +209,8 @@ int run_process (char **args, libcrun_er
 
 size_t format_default_id_mapping (char **ret, uid_t container_id, uid_t host_id, int is_uid);
 
-int run_process_with_stdin_timeout_envp (char *path, char **args, const char *cwd, int timeout, char **envp, char *stdin, size_t stdin_len, int out_fd, int err_fd, libcrun_error_t *err);
+int run_process_with_stdin_timeout_envp (char *path, char **args, const char *cwd, int timeout, char **envp,
+                                         char *stdin, size_t stdin_len, int out_fd, int err_fd, libcrun_error_t *err);
 
 int close_fds_ge_than (int n, libcrun_error_t *err);
 
@@ -233,7 +240,8 @@ int get_file_type (mode_t *mode, bool no
 
 int get_file_type_fd (int fd, mode_t *mode);
 
-int safe_openat (int dirfd, const char *rootfs, size_t rootfs_len, const char *path, int flags, int mode, libcrun_error_t *err);
+int safe_openat (int dirfd, const char *rootfs, size_t rootfs_len, const char *path, int flags, int mode,
+                 libcrun_error_t *err);
 
 ssize_t safe_write (int fd, const void *buf, ssize_t count);
 
diff -pruN 0.14.1+dfsg-1/src/list.c 0.15+dfsg-1/src/list.c
--- 0.14.1+dfsg-1/src/list.c	2020-07-03 19:38:11.000000000 +0000
+++ 0.15+dfsg-1/src/list.c	2020-09-03 11:43:25.000000000 +0000
@@ -23,36 +23,47 @@
 #include <string.h>
 #include <unistd.h>
 #include <errno.h>
+#include <yajl/yajl_tree.h>
+#include <yajl/yajl_gen.h>
 
 #include "crun.h"
 #include "libcrun/container.h"
 #include "libcrun/utils.h"
 #include "libcrun/status.h"
 
+#define YAJL_STR(x) ((const unsigned char *) (x))
+
 static char doc[] = "OCI runtime";
 
 enum
-  {
-    OPTION_CONSOLE_SOCKET = 1000,
-    OPTION_PID_FILE,
-    OPTION_NO_SUBREAPER,
-    OPTION_NO_NEW_KEYRING,
-    OPTION_PRESERVE_FDS
-  };
+{
+  OPTION_CONSOLE_SOCKET = 1000,
+  OPTION_PID_FILE,
+  OPTION_NO_SUBREAPER,
+  OPTION_NO_NEW_KEYRING,
+  OPTION_PRESERVE_FDS
+};
 
 struct list_options_s
 {
+  bool quiet;
+  int format;
 };
 
-static struct list_options_s list_options;
+enum
+{
+  LIST_TABLE = 100,
+  LIST_JSON,
+};
 
-static bool quiet;
+static struct list_options_s list_options;
 
-static struct argp_option options[] =
-  {
-   {"quiet", 'q', 0, 0, "show only IDs", 0},
-   { 0, }
-  };
+static struct argp_option options[]
+    = { { "quiet", 'q', 0, 0, "show only IDs", 0 },
+        { "format", 'f', "FORMAT", 0, "select one of: table or json (default: \"table\")", 0 },
+        {
+            0,
+        } };
 
 static char args_doc[] = "list";
 
@@ -62,7 +73,15 @@ parse_opt (int key, char *arg arg_unused
   switch (key)
     {
     case 'q':
-      quiet = true;
+      list_options.quiet = true;
+      break;
+    case 'f':
+      if (strcmp (arg, "table") == 0)
+        list_options.format = LIST_TABLE;
+      else if (strcmp (arg, "json") == 0)
+        list_options.format = LIST_JSON;
+      else
+        error (EXIT_FAILURE, 0, "invalid format `%s`", arg);
       break;
 
     default:
@@ -79,8 +98,15 @@ crun_command_list (struct crun_global_ar
 {
   int first_arg;
   int ret, max_length = 4;
-  libcrun_context_t crun_context = {0, };
+  libcrun_context_t crun_context = {
+    0,
+  };
   libcrun_container_list_t *list, *it;
+  yajl_gen gen = NULL;
+  size_t len;
+  const unsigned char *buf = NULL;
+
+  list_options.format = LIST_TABLE;
 
   argp_parse (&run_argp, argc, argv, ARGP_IN_ORDER, &first_arg, &list_options);
   crun_assert_n_args (argc - first_arg, 0, 0);
@@ -102,8 +128,18 @@ crun_command_list (struct crun_global_ar
 
   max_length++;
 
-  if (!quiet)
+  gen = yajl_gen_alloc (NULL);
+  if (gen == NULL)
+    error (EXIT_FAILURE, 0, "yajl_gen_alloc failed");
+
+  if (! list_options.quiet && list_options.format == LIST_TABLE)
     printf ("%-*s%-10s%-8s %-39s\n", max_length, "NAME", "PID", "STATUS", "BUNDLE PATH");
+  else if (list_options.format == LIST_JSON)
+    {
+      yajl_gen_config (gen, yajl_gen_beautify, 1);
+      yajl_gen_config (gen, yajl_gen_validate_utf8, 1);
+      yajl_gen_array_open (gen);
+    }
   for (it = list; it; it = it->next)
     {
       libcrun_container_status_t status;
@@ -114,7 +150,7 @@ crun_command_list (struct crun_global_ar
           libcrun_error_write_warning_and_release (stderr, &err);
           continue;
         }
-      if (quiet)
+      if (list_options.quiet && list_options.format == LIST_TABLE)
         printf ("%s\n", it->name);
       else
         {
@@ -122,7 +158,8 @@ crun_command_list (struct crun_global_ar
           int pid = status.pid;
           const char *container_status = NULL;
 
-          ret = libcrun_get_container_state_string (it->name, &status, crun_context.state_root, &container_status, &running, err);
+          ret = libcrun_get_container_state_string (it->name, &status, crun_context.state_root, &container_status,
+                                                    &running, err);
           if (UNLIKELY (ret < 0))
             {
               libcrun_error_write_warning_and_release (stderr, &err);
@@ -132,11 +169,44 @@ crun_command_list (struct crun_global_ar
           if (! running)
             pid = 0;
 
-          printf ("%-*s%-10d%-8s %-39s\n", max_length, it->name, pid, container_status, status.bundle);
+          switch (list_options.format)
+            {
+            case LIST_JSON:
+              yajl_gen_map_open (gen);
+              yajl_gen_string (gen, YAJL_STR ("id"), strlen ("id"));
+              yajl_gen_string (gen, YAJL_STR (it->name), strlen (it->name));
+              yajl_gen_string (gen, YAJL_STR ("pid"), strlen ("pid"));
+              yajl_gen_integer (gen, pid);
+              yajl_gen_string (gen, YAJL_STR ("status"), strlen ("status"));
+              yajl_gen_string (gen, YAJL_STR (container_status), strlen (container_status));
+              yajl_gen_string (gen, YAJL_STR ("bundle"), strlen ("bundle"));
+              yajl_gen_string (gen, YAJL_STR (status.bundle), strlen (status.bundle));
+              yajl_gen_map_close (gen);
+              break;
+
+            case LIST_TABLE:
+              printf ("%-*s%-10d%-8s %-39s\n", max_length, it->name, pid, container_status, status.bundle);
+              break;
+            }
         }
 
       libcrun_free_container_status (&status);
     }
+  if (list_options.format == LIST_JSON)
+    {
+      yajl_gen_array_close (gen);
+      if (yajl_gen_get_buf (gen, &buf, &len) != yajl_gen_status_ok)
+        {
+          ret = libcrun_make_error (err, 0, "cannot generate json list");
+          goto exit;
+        }
+      printf ("%s", buf);
+    }
+
+exit:
+  if (gen)
+    yajl_gen_free (gen);
+
   libcrun_free_containers_list (list);
-  return 0;
+  return ret >= 0 ? 0 : ret;
 }
diff -pruN 0.14.1+dfsg-1/src/list.h 0.15+dfsg-1/src/list.h
--- 0.14.1+dfsg-1/src/list.h	2020-07-02 13:46:33.000000000 +0000
+++ 0.15+dfsg-1/src/list.h	2020-09-03 11:43:25.000000000 +0000
@@ -16,9 +16,9 @@
  * along with crun.  If not, see <http://www.gnu.org/licenses/>.
  */
 #ifndef LIST_H
-# define LIST_H
+#define LIST_H
 
-# include "crun.h"
+#include "crun.h"
 
 int crun_command_list (struct crun_global_arguments *global_args, int argc, char **argv, libcrun_error_t *error);
 
diff -pruN 0.14.1+dfsg-1/src/pause.c 0.15+dfsg-1/src/pause.c
--- 0.14.1+dfsg-1/src/pause.c	2020-07-02 13:46:33.000000000 +0000
+++ 0.15+dfsg-1/src/pause.c	2020-09-03 11:43:25.000000000 +0000
@@ -38,10 +38,9 @@ struct pause_options_s
 
 static struct pause_options_s pause_options;
 
-static struct argp_option options[] =
-  {
-   {0, }
-  };
+static struct argp_option options[] = { {
+    0,
+} };
 
 static char args_doc[] = "pause CONTAINER";
 
@@ -67,7 +66,9 @@ crun_command_pause (struct crun_global_a
 {
   int first_arg, ret;
 
-  libcrun_context_t crun_context = {0, };
+  libcrun_context_t crun_context = {
+    0,
+  };
 
   argp_parse (&run_argp, argc, argv, ARGP_IN_ORDER, &first_arg, &pause_options);
   crun_assert_n_args (argc - first_arg, 1, 2);
diff -pruN 0.14.1+dfsg-1/src/pause.h 0.15+dfsg-1/src/pause.h
--- 0.14.1+dfsg-1/src/pause.h	2020-07-02 13:46:33.000000000 +0000
+++ 0.15+dfsg-1/src/pause.h	2020-09-03 11:43:25.000000000 +0000
@@ -16,9 +16,9 @@
  * along with crun.  If not, see <http://www.gnu.org/licenses/>.
  */
 #ifndef PAUSE_H
-# define PAUSE_H
+#define PAUSE_H
 
-# include "crun.h"
+#include "crun.h"
 
 int crun_command_pause (struct crun_global_arguments *global_args, int argc, char **argv, libcrun_error_t *error);
 
diff -pruN 0.14.1+dfsg-1/src/ps.c 0.15+dfsg-1/src/ps.c
--- 0.14.1+dfsg-1/src/ps.c	2020-07-03 19:38:11.000000000 +0000
+++ 0.15+dfsg-1/src/ps.c	2020-09-03 11:43:25.000000000 +0000
@@ -33,13 +33,13 @@
 static char doc[] = "OCI runtime";
 
 enum
-  {
-    OPTION_CONSOLE_SOCKET = 1000,
-    OPTION_PID_FILE,
-    OPTION_NO_SUBREAPER,
-    OPTION_NO_NEW_KEYRING,
-    OPTION_PRESERVE_FDS
-  };
+{
+  OPTION_CONSOLE_SOCKET = 1000,
+  OPTION_PID_FILE,
+  OPTION_NO_SUBREAPER,
+  OPTION_NO_NEW_KEYRING,
+  OPTION_PRESERVE_FDS
+};
 
 struct ps_options_s
 {
@@ -47,18 +47,17 @@ struct ps_options_s
 };
 
 enum
-  {
-   PS_TABLE = 100,
-   PS_JSON,
-  };
+{
+  PS_TABLE = 100,
+  PS_JSON,
+};
 
 static struct ps_options_s ps_options;
 
-static struct argp_option options[] =
-  {
-   {"format", 'f', "FORMAT", 0, "select the output format", 0},
-   { 0, }
-  };
+static struct argp_option options[] = { { "format", 'f', "FORMAT", 0, "select the output format", 0 },
+                                        {
+                                            0,
+                                        } };
 
 static char args_doc[] = "ps";
 
@@ -90,7 +89,9 @@ crun_command_ps (struct crun_global_argu
 {
   int first_arg;
   int ret;
-  libcrun_context_t crun_context = {0, };
+  libcrun_context_t crun_context = {
+    0,
+  };
   libcrun_container_status_t status;
   cleanup_free pid_t *pids = NULL;
   size_t i;
@@ -137,6 +138,5 @@ crun_command_ps (struct crun_global_argu
       break;
     }
 
-
   return 0;
 }
diff -pruN 0.14.1+dfsg-1/src/ps.h 0.15+dfsg-1/src/ps.h
--- 0.14.1+dfsg-1/src/ps.h	2020-07-02 13:46:33.000000000 +0000
+++ 0.15+dfsg-1/src/ps.h	2020-09-03 11:43:25.000000000 +0000
@@ -16,9 +16,9 @@
  * along with crun.  If not, see <http://www.gnu.org/licenses/>.
  */
 #ifndef PS_H
-# define PS_H
+#define PS_H
 
-# include "crun.h"
+#include "crun.h"
 
 int crun_command_ps (struct crun_global_arguments *global_args, int argc, char **argv, libcrun_error_t *error);
 
diff -pruN 0.14.1+dfsg-1/src/restore.c 0.15+dfsg-1/src/restore.c
--- 0.14.1+dfsg-1/src/restore.c	2020-07-03 19:38:11.000000000 +0000
+++ 0.15+dfsg-1/src/restore.c	2020-09-03 11:43:25.000000000 +0000
@@ -50,21 +50,18 @@ static libcrun_context_t crun_context;
 
 static libcrun_checkpoint_restore_t cr_options;
 
-static struct argp_option options[] = {
-  {"bundle", 'b', "DIR", 0, "container bundle (default \".\")", 0},
-  {"image-path", OPTION_IMAGE_PATH, "DIR", 0,
-   "path for saving criu image files", 0},
-  {"work-path", OPTION_WORK_PATH, "DIR", 0,
-   "path for saving work files and logs", 0},
-  {"tcp-established", OPTION_TCP_ESTABLISHED, 0, 0,
-   "allow open tcp connections", 0},
-  {"ext-unix-sk", OPTION_EXT_UNIX_SK, 0, 0, "allow external unix sockets", 0},
-  {"shell-job", OPTION_SHELL_JOB, 0, 0, "allow shell jobs", 0},
-  {"detach", 'd', 0, 0, "detach from the container's process", 0},
-  {"pid-file", OPTION_PID_FILE, "FILE", 0,
-   "where to write the PID of the container", 0},
-  {0,}
-};
+static struct argp_option options[]
+    = { { "bundle", 'b', "DIR", 0, "container bundle (default \".\")", 0 },
+        { "image-path", OPTION_IMAGE_PATH, "DIR", 0, "path for saving criu image files", 0 },
+        { "work-path", OPTION_WORK_PATH, "DIR", 0, "path for saving work files and logs", 0 },
+        { "tcp-established", OPTION_TCP_ESTABLISHED, 0, 0, "allow open tcp connections", 0 },
+        { "ext-unix-sk", OPTION_EXT_UNIX_SK, 0, 0, "allow external unix sockets", 0 },
+        { "shell-job", OPTION_SHELL_JOB, 0, 0, "allow shell jobs", 0 },
+        { "detach", 'd', 0, 0, "detach from the container's process", 0 },
+        { "pid-file", OPTION_PID_FILE, "FILE", 0, "where to write the PID of the container", 0 },
+        {
+            0,
+        } };
 
 static char args_doc[] = "restore CONTAINER";
 
@@ -115,12 +112,10 @@ parse_opt (int key, char *arg arg_unused
   return 0;
 }
 
-static struct argp run_argp =
-  { options, parse_opt, args_doc, doc, NULL, NULL, NULL };
+static struct argp run_argp = { options, parse_opt, args_doc, doc, NULL, NULL, NULL };
 
 int
-crun_command_restore (struct crun_global_arguments *global_args, int argc,
-                      char **argv, libcrun_error_t *err)
+crun_command_restore (struct crun_global_arguments *global_args, int argc, char **argv, libcrun_error_t *err)
 {
   cleanup_free char *bundle_cleanup = NULL;
   cleanup_free char *cr_path = NULL;
@@ -131,7 +126,12 @@ crun_command_restore (struct crun_global
   crun_assert_n_args (argc - first_arg, 1, 2);
 
   /* Make sure the bundle is an absolute path.  */
-  if (bundle)
+
+  if (bundle == NULL)
+    {
+      bundle = realpath (".", NULL);
+    }
+  else
     {
       if (bundle[0] != '/')
         {
@@ -145,8 +145,7 @@ crun_command_restore (struct crun_global
         libcrun_fail_with_error (errno, "chdir `%s` failed", bundle);
     }
 
-  ret =
-    init_libcrun_context (&crun_context, argv[first_arg], global_args, err);
+  ret = init_libcrun_context (&crun_context, argv[first_arg], global_args, err);
   if (UNLIKELY (ret < 0))
     return ret;
 
@@ -158,14 +157,12 @@ crun_command_restore (struct crun_global
       if (UNLIKELY (path == NULL))
         libcrun_fail_with_error (0, "realloc failed");
 
-      asprintf (&cr_path, "%s/checkpoint", path);
-      if (cr_path == NULL)
-        libcrun_fail_with_error (0, "asprintf failed");
-
+      ret = asprintf (&cr_path, "%s/checkpoint", path);
+      if (UNLIKELY (ret < 0))
+        OOM ();
       cr_options.image_path = cr_path;
     }
 
-  crun_context.bundle = bundle ? bundle : ".";
-  return libcrun_container_restore (&crun_context, argv[first_arg],
-                                    &cr_options, err);
+  crun_context.bundle = bundle;
+  return libcrun_container_restore (&crun_context, argv[first_arg], &cr_options, err);
 }
diff -pruN 0.14.1+dfsg-1/src/restore.h 0.15+dfsg-1/src/restore.h
--- 0.14.1+dfsg-1/src/restore.h	2020-07-02 13:46:33.000000000 +0000
+++ 0.15+dfsg-1/src/restore.h	2020-09-03 11:43:25.000000000 +0000
@@ -20,7 +20,6 @@
 
 #include "crun.h"
 
-int crun_command_restore (struct crun_global_arguments *global_args,
-                          int argc, char **argv, libcrun_error_t * error);
+int crun_command_restore (struct crun_global_arguments *global_args, int argc, char **argv, libcrun_error_t *error);
 
 #endif
diff -pruN 0.14.1+dfsg-1/src/run.c 0.15+dfsg-1/src/run.c
--- 0.14.1+dfsg-1/src/run.c	2020-07-02 13:46:33.000000000 +0000
+++ 0.15+dfsg-1/src/run.c	2020-09-03 11:43:25.000000000 +0000
@@ -31,32 +31,33 @@
 static char doc[] = "OCI runtime";
 
 enum
-  {
-    OPTION_CONSOLE_SOCKET = 1000,
-    OPTION_PID_FILE,
-    OPTION_NO_SUBREAPER,
-    OPTION_NO_NEW_KEYRING,
-    OPTION_PRESERVE_FDS,
-    OPTION_NO_PIVOT
-  };
+{
+  OPTION_CONSOLE_SOCKET = 1000,
+  OPTION_PID_FILE,
+  OPTION_NO_SUBREAPER,
+  OPTION_NO_NEW_KEYRING,
+  OPTION_PRESERVE_FDS,
+  OPTION_NO_PIVOT
+};
 
 static const char *bundle = NULL;
 
 static libcrun_context_t crun_context;
 
-static struct argp_option options[] =
-  {
-   {"bundle", 'b', 0, 0, "container bundle (default \".\")", 0},
-   {"config", 'f', "FILE", 0, "override the config file name", 0},
-   {"detach", 'd', 0, 0, "detach from the parent", 0},
-   {"console-socket", OPTION_CONSOLE_SOCKET, "SOCKET", 0, "path to a socket that will receive the master end of the tty", 0},
-   {"preserve-fds", OPTION_PRESERVE_FDS, 0, 0, "pass additional FDs to the container", 0},
-   {"pid-file", OPTION_PID_FILE, "FILE", 0, "where to write the PID of the container", 0},
-   {"no-subreaper", OPTION_NO_SUBREAPER, 0, 0, "do not create a subreaper process", 0},
-   {"no-new-keyring", OPTION_NO_NEW_KEYRING, 0, 0, "keep the same session key", 0},
-   {"no-pivot", OPTION_NO_PIVOT, 0, 0, "do not use pivot_root", 0},
-   { 0, }
-  };
+static struct argp_option options[]
+    = { { "bundle", 'b', "DIR", 0, "container bundle (default \".\")", 0 },
+        { "config", 'f', "FILE", 0, "override the config file name", 0 },
+        { "detach", 'd', 0, 0, "detach from the parent", 0 },
+        { "console-socket", OPTION_CONSOLE_SOCKET, "SOCKET", 0,
+          "path to a socket that will receive the ptmx end of the tty", 0 },
+        { "preserve-fds", OPTION_PRESERVE_FDS, 0, 0, "pass additional FDs to the container", 0 },
+        { "pid-file", OPTION_PID_FILE, "FILE", 0, "where to write the PID of the container", 0 },
+        { "no-subreaper", OPTION_NO_SUBREAPER, 0, 0, "do not create a subreaper process", 0 },
+        { "no-new-keyring", OPTION_NO_NEW_KEYRING, 0, 0, "keep the same session key", 0 },
+        { "no-pivot", OPTION_NO_PIVOT, 0, 0, "do not use pivot_root", 0 },
+        {
+            0,
+        } };
 
 static char args_doc[] = "run [OPTION]... CONTAINER";
 
@@ -72,7 +73,7 @@ parse_opt (int key, char *arg, struct ar
       break;
 
     case 'f':
-      config_file = argp_mandatory_argument (arg, state);
+      config_file = crun_context.config_file = argp_mandatory_argument (arg, state);
       break;
 
     case 'b':
@@ -121,12 +122,26 @@ crun_command_run (struct crun_global_arg
   int first_arg, ret;
   cleanup_free libcrun_container_t *container = NULL;
   cleanup_free char *bundle_cleanup = NULL;
+  cleanup_free char *config_file_cleanup = NULL;
 
   crun_context.preserve_fds = 0;
 
   argp_parse (&run_argp, argc, argv, ARGP_IN_ORDER, &first_arg, &crun_context);
   crun_assert_n_args (argc - first_arg, 1, 1);
 
+  /* Make sure the config is an absolute path before changing the directory.  */
+  if ((strcmp ("config.json", config_file) != 0))
+    {
+      if (config_file[0] != '/')
+        {
+          config_file_cleanup = realpath (config_file, NULL);
+          if (config_file_cleanup == NULL)
+            libcrun_fail_with_error (errno, "realpath `%s` failed", config_file);
+          config_file = config_file_cleanup;
+          crun_context.config_file = config_file;
+        }
+    }
+
   /* Make sure the bundle is an absolute path.  */
   if (bundle)
     {
diff -pruN 0.14.1+dfsg-1/src/run.h 0.15+dfsg-1/src/run.h
--- 0.14.1+dfsg-1/src/run.h	2020-07-02 13:46:33.000000000 +0000
+++ 0.15+dfsg-1/src/run.h	2020-09-03 11:43:25.000000000 +0000
@@ -16,9 +16,9 @@
  * along with crun.  If not, see <http://www.gnu.org/licenses/>.
  */
 #ifndef RUN_H
-# define RUN_H
+#define RUN_H
 
-# include "crun.h"
+#include "crun.h"
 
 int crun_command_run (struct crun_global_arguments *global_args, int argc, char **argv, libcrun_error_t *error);
 
diff -pruN 0.14.1+dfsg-1/src/spec.c 0.15+dfsg-1/src/spec.c
--- 0.14.1+dfsg-1/src/spec.c	2020-07-03 19:38:11.000000000 +0000
+++ 0.15+dfsg-1/src/spec.c	2020-09-03 11:43:25.000000000 +0000
@@ -36,17 +36,16 @@ struct spec_options_s
 };
 
 enum
-  {
-    OPTION_ROOTLESS = 1000
-  };
+{
+  OPTION_ROOTLESS = 1000
+};
 
 static struct spec_options_s spec_options;
 
-static struct argp_option options[] =
-  {
-   {"rootless", OPTION_ROOTLESS, 0, 0, "spec for the rootless case", 0 },
-   { 0, }
-  };
+static struct argp_option options[] = { { "rootless", OPTION_ROOTLESS, 0, 0, "spec for the rootless case", 0 },
+                                        {
+                                            0,
+                                        } };
 
 static char args_doc[] = "spec";
 
@@ -72,7 +71,9 @@ int
 crun_command_spec (struct crun_global_arguments *global_args, int argc, char **argv, libcrun_error_t *err)
 {
   int first_arg;
-  libcrun_context_t crun_context = {0, };
+  libcrun_context_t crun_context = {
+    0,
+  };
   int ret;
   cleanup_file FILE *f = NULL;
 
@@ -91,7 +92,7 @@ crun_command_spec (struct crun_global_ar
   if (f == NULL)
     return libcrun_make_error (err, 0, "cannot open config.json", err);
 
-  ret = libcrun_container_spec (!spec_options.rootless, f, err);
+  ret = libcrun_container_spec (! spec_options.rootless, f, err);
 
   return ret >= 0 ? 0 : ret;
 }
diff -pruN 0.14.1+dfsg-1/src/spec.h 0.15+dfsg-1/src/spec.h
--- 0.14.1+dfsg-1/src/spec.h	2020-07-02 13:46:33.000000000 +0000
+++ 0.15+dfsg-1/src/spec.h	2020-09-03 11:43:25.000000000 +0000
@@ -16,9 +16,9 @@
  * along with crun.  If not, see <http://www.gnu.org/licenses/>.
  */
 #ifndef SPEC_H
-# define SPEC_H
+#define SPEC_H
 
-# include "crun.h"
+#include "crun.h"
 
 int crun_command_spec (struct crun_global_arguments *global_args, int argc, char **argv, libcrun_error_t *error);
 
diff -pruN 0.14.1+dfsg-1/src/start.c 0.15+dfsg-1/src/start.c
--- 0.14.1+dfsg-1/src/start.c	2020-07-02 13:46:33.000000000 +0000
+++ 0.15+dfsg-1/src/start.c	2020-09-03 11:43:25.000000000 +0000
@@ -31,18 +31,17 @@
 static char doc[] = "OCI runtime";
 
 enum
-  {
-    OPTION_CONSOLE_SOCKET = 1000,
-    OPTION_PID_FILE,
-    OPTION_NO_SUBREAPER,
-    OPTION_NO_NEW_KEYRING,
-    OPTION_PRESERVE_FDS
-  };
-
-static struct argp_option options[] =
-  {
-   {0, }
-  };
+{
+  OPTION_CONSOLE_SOCKET = 1000,
+  OPTION_PID_FILE,
+  OPTION_NO_SUBREAPER,
+  OPTION_NO_NEW_KEYRING,
+  OPTION_PRESERVE_FDS
+};
+
+static struct argp_option options[] = { {
+    0,
+} };
 
 static char args_doc[] = "start CONTAINER";
 
@@ -68,7 +67,9 @@ crun_command_start (struct crun_global_a
 {
   int first_arg, ret;
 
-  libcrun_context_t crun_context = {0, };
+  libcrun_context_t crun_context = {
+    0,
+  };
 
   argp_parse (&run_argp, argc, argv, ARGP_IN_ORDER, &first_arg, NULL);
   crun_assert_n_args (argc - first_arg, 1, 1);
diff -pruN 0.14.1+dfsg-1/src/start.h 0.15+dfsg-1/src/start.h
--- 0.14.1+dfsg-1/src/start.h	2020-07-02 13:46:33.000000000 +0000
+++ 0.15+dfsg-1/src/start.h	2020-09-03 11:43:25.000000000 +0000
@@ -16,9 +16,9 @@
  * along with crun.  If not, see <http://www.gnu.org/licenses/>.
  */
 #ifndef START_H
-# define START_H
+#define START_H
 
-# include "crun.h"
+#include "crun.h"
 
 int crun_command_start (struct crun_global_arguments *global_args, int argc, char **argv, libcrun_error_t *error);
 
diff -pruN 0.14.1+dfsg-1/src/state.c 0.15+dfsg-1/src/state.c
--- 0.14.1+dfsg-1/src/state.c	2020-07-02 13:46:33.000000000 +0000
+++ 0.15+dfsg-1/src/state.c	2020-09-03 11:43:25.000000000 +0000
@@ -31,13 +31,13 @@
 static char doc[] = "OCI runtime";
 
 enum
-  {
-    OPTION_CONSOLE_SOCKET = 1000,
-    OPTION_PID_FILE,
-    OPTION_NO_SUBREAPER,
-    OPTION_NO_NEW_KEYRING,
-    OPTION_PRESERVE_FDS
-  };
+{
+  OPTION_CONSOLE_SOCKET = 1000,
+  OPTION_PID_FILE,
+  OPTION_NO_SUBREAPER,
+  OPTION_NO_NEW_KEYRING,
+  OPTION_PRESERVE_FDS
+};
 
 struct state_options_s
 {
@@ -45,10 +45,9 @@ struct state_options_s
 
 static struct state_options_s state_options;
 
-static struct argp_option options[] =
-  {
-   { 0, }
-  };
+static struct argp_option options[] = { {
+    0,
+} };
 
 static char args_doc[] = "state CONTAINER";
 
@@ -73,7 +72,9 @@ int
 crun_command_state (struct crun_global_arguments *global_args, int argc, char **argv, libcrun_error_t *err)
 {
   int first_arg, ret;
-  libcrun_context_t crun_context = {0, };
+  libcrun_context_t crun_context = {
+    0,
+  };
 
   argp_parse (&run_argp, argc, argv, ARGP_IN_ORDER, &first_arg, &state_options);
   crun_assert_n_args (argc - first_arg, 1, 1);
diff -pruN 0.14.1+dfsg-1/src/state.h 0.15+dfsg-1/src/state.h
--- 0.14.1+dfsg-1/src/state.h	2020-07-02 13:46:33.000000000 +0000
+++ 0.15+dfsg-1/src/state.h	2020-09-03 11:43:25.000000000 +0000
@@ -16,9 +16,9 @@
  * along with crun.  If not, see <http://www.gnu.org/licenses/>.
  */
 #ifndef STATE_H
-# define STATE_H
+#define STATE_H
 
-# include "crun.h"
+#include "crun.h"
 
 int crun_command_state (struct crun_global_arguments *global_args, int argc, char **argv, libcrun_error_t *error);
 
diff -pruN 0.14.1+dfsg-1/src/unpause.c 0.15+dfsg-1/src/unpause.c
--- 0.14.1+dfsg-1/src/unpause.c	2020-07-02 13:46:33.000000000 +0000
+++ 0.15+dfsg-1/src/unpause.c	2020-09-03 11:43:25.000000000 +0000
@@ -38,10 +38,9 @@ struct unpause_options_s
 
 static struct unpause_options_s unpause_options;
 
-static struct argp_option options[] =
-  {
-   { 0, }
-  };
+static struct argp_option options[] = { {
+    0,
+} };
 
 static char args_doc[] = "resume CONTAINER";
 
@@ -67,7 +66,9 @@ crun_command_unpause (struct crun_global
 {
   int first_arg, ret;
 
-  libcrun_context_t crun_context = {0, };
+  libcrun_context_t crun_context = {
+    0,
+  };
 
   argp_parse (&run_argp, argc, argv, ARGP_IN_ORDER, &first_arg, &unpause_options);
   crun_assert_n_args (argc - first_arg, 1, 2);
diff -pruN 0.14.1+dfsg-1/src/unpause.h 0.15+dfsg-1/src/unpause.h
--- 0.14.1+dfsg-1/src/unpause.h	2020-07-02 13:46:33.000000000 +0000
+++ 0.15+dfsg-1/src/unpause.h	2020-09-03 11:43:25.000000000 +0000
@@ -16,9 +16,9 @@
  * along with crun.  If not, see <http://www.gnu.org/licenses/>.
  */
 #ifndef UNPAUSE_H
-# define UNPAUSE_H
+#define UNPAUSE_H
 
-# include "crun.h"
+#include "crun.h"
 
 int crun_command_unpause (struct crun_global_arguments *global_args, int argc, char **argv, libcrun_error_t *error);
 
diff -pruN 0.14.1+dfsg-1/src/update.c 0.15+dfsg-1/src/update.c
--- 0.14.1+dfsg-1/src/update.c	2020-07-03 19:38:11.000000000 +0000
+++ 0.15+dfsg-1/src/update.c	2020-09-03 11:43:25.000000000 +0000
@@ -35,29 +35,29 @@ static char *resources = NULL;
 static libcrun_context_t crun_context;
 
 enum
-  {
-    FIRST_VALUE = 1000,
+{
+  FIRST_VALUE = 1000,
 
-    BLKIO_WEIGHT = FIRST_VALUE,
+  BLKIO_WEIGHT = FIRST_VALUE,
 
-    CPU_PERIOD,
-    CPU_QUOTA,
-    CPU_SHARE,
-    CPU_RT_PERIOD,
-    CPU_RT_RUNTIME,
-    CPUSET_CPUS,
-    CPUSET_MEMS,
-
-    KERNEL_MEMORY,
-    KERNEL_MEMORY_TCP,
-    MEMORY,
-    MEMORY_RESERVATION,
-    MEMORY_SWAP,
+  CPU_PERIOD,
+  CPU_QUOTA,
+  CPU_SHARE,
+  CPU_RT_PERIOD,
+  CPU_RT_RUNTIME,
+  CPUSET_CPUS,
+  CPUSET_MEMS,
+
+  KERNEL_MEMORY,
+  KERNEL_MEMORY_TCP,
+  MEMORY,
+  MEMORY_RESERVATION,
+  MEMORY_SWAP,
 
-    PIDS_LIMIT,
+  PIDS_LIMIT,
 
-    LAST_VALUE,
-  };
+  LAST_VALUE,
+};
 
 struct description_s
 {
@@ -67,28 +67,26 @@ struct description_s
   int numeric;
 };
 
-static const char *sections[] = {"blockIO", "cpu", "memory", "pids"};
+static const char *sections[] = { "blockIO", "cpu", "memory", "pids" };
 
-static struct description_s descriptors[] = {
-  {BLKIO_WEIGHT, 0, "weight", 1},
+static struct description_s descriptors[] = { { BLKIO_WEIGHT, 0, "weight", 1 },
 
-  {CPU_PERIOD, 1, "period", 1},
-  {CPU_QUOTA, 1, "quota", 1},
-  {CPU_SHARE, 1, "share", 1},
-  {CPU_RT_PERIOD, 1, "realtimePeriod", 1},
-  {CPU_RT_RUNTIME, 1, "realtimeRuntime", 1},
-  {CPUSET_CPUS, 1, "cpus", 0},
-  {CPUSET_MEMS, 1, "mems", 0},
-
-  {KERNEL_MEMORY, 2, "kernel", 1},
-  {KERNEL_MEMORY_TCP, 2, "kernelTCP", 1},
-  {MEMORY, 2, "limit", 1},
-  {MEMORY_RESERVATION, 2, "reservation", 1},
-  {MEMORY_SWAP, 2, "swap", 1},
+                                              { CPU_PERIOD, 1, "period", 1 },
+                                              { CPU_QUOTA, 1, "quota", 1 },
+                                              { CPU_SHARE, 1, "share", 1 },
+                                              { CPU_RT_PERIOD, 1, "realtimePeriod", 1 },
+                                              { CPU_RT_RUNTIME, 1, "realtimeRuntime", 1 },
+                                              { CPUSET_CPUS, 1, "cpus", 0 },
+                                              { CPUSET_MEMS, 1, "mems", 0 },
+
+                                              { KERNEL_MEMORY, 2, "kernel", 1 },
+                                              { KERNEL_MEMORY_TCP, 2, "kernelTCP", 1 },
+                                              { MEMORY, 2, "limit", 1 },
+                                              { MEMORY_RESERVATION, 2, "reservation", 1 },
+                                              { MEMORY_SWAP, 2, "swap", 1 },
 
-  {PIDS_LIMIT, 3, "limit", 1},
-  {0}
-};
+                                              { PIDS_LIMIT, 3, "limit", 1 },
+                                              { 0 } };
 
 static const char *values[LAST_VALUE - FIRST_VALUE];
 
@@ -98,25 +96,25 @@ set_value (int id, const char *value)
   values[id - FIRST_VALUE] = value;
 }
 
-static struct argp_option options[] =
-  {
-   {"resources", 'r', "FILE", 0, "path to the file containing the resources to update", 0},
-   {"blkio-weight", BLKIO_WEIGHT, "VALUE", 0, "Specifies per cgroup weight", 0},
-   {"cpu-period", CPU_PERIOD, "VALUE", 0, "CPU CFS period to be used for hardcapping", 0},
-   {"cpu-quota", CPU_QUOTA, "VALUE", 0, "CPU CFS hardcap limit", 0},
-   {"cpu-share", CPU_SHARE, "VALUE", 0, "CPU shares", 0},
-   {"cpu-rt-period", CPU_RT_PERIOD, "VALUE", 0, "CPU realtime period to be used for hardcapping", 0},
-   {"cpu-rt-runtime", CPU_RT_RUNTIME, "VALUE", 0, "CPU realtime hardcap limit", 0},
-   {"cpuset-cpus", CPUSET_CPUS, "VALUE", 0, "CPU(s) to use", 0},
-   {"cpuset-mems", CPUSET_MEMS, "VALUE", 0, "Memory node(s) to use", 0},
-   {"kernel-memory", KERNEL_MEMORY, "VALUE", 0, "Kernel memory limit", 0},
-   {"kernel-memory-tcp", KERNEL_MEMORY_TCP, "VALUE", 0, "Kernel memory limit for tcp buffer", 0},
-   {"memory", MEMORY, "VALUE", 0, "Memory limit", 0},
-   {"memory-reservation", MEMORY_RESERVATION, "VALUE", 0, "Memory reservation or soft_limit", 0},
-   {"memory-swap", MEMORY_SWAP, "VALUE", 0, "Total memory usage", 0},
-   {"pids-limit", PIDS_LIMIT, "VALUE", 0, "Maximum number of pids allowed in the container", 0},
-   {0,}
-  };
+static struct argp_option options[]
+    = { { "resources", 'r', "FILE", 0, "path to the file containing the resources to update", 0 },
+        { "blkio-weight", BLKIO_WEIGHT, "VALUE", 0, "Specifies per cgroup weight", 0 },
+        { "cpu-period", CPU_PERIOD, "VALUE", 0, "CPU CFS period to be used for hardcapping", 0 },
+        { "cpu-quota", CPU_QUOTA, "VALUE", 0, "CPU CFS hardcap limit", 0 },
+        { "cpu-share", CPU_SHARE, "VALUE", 0, "CPU shares", 0 },
+        { "cpu-rt-period", CPU_RT_PERIOD, "VALUE", 0, "CPU realtime period to be used for hardcapping", 0 },
+        { "cpu-rt-runtime", CPU_RT_RUNTIME, "VALUE", 0, "CPU realtime hardcap limit", 0 },
+        { "cpuset-cpus", CPUSET_CPUS, "VALUE", 0, "CPU(s) to use", 0 },
+        { "cpuset-mems", CPUSET_MEMS, "VALUE", 0, "Memory node(s) to use", 0 },
+        { "kernel-memory", KERNEL_MEMORY, "VALUE", 0, "Kernel memory limit", 0 },
+        { "kernel-memory-tcp", KERNEL_MEMORY_TCP, "VALUE", 0, "Kernel memory limit for tcp buffer", 0 },
+        { "memory", MEMORY, "VALUE", 0, "Memory limit", 0 },
+        { "memory-reservation", MEMORY_RESERVATION, "VALUE", 0, "Memory reservation or soft_limit", 0 },
+        { "memory-swap", MEMORY_SWAP, "VALUE", 0, "Total memory usage", 0 },
+        { "pids-limit", PIDS_LIMIT, "VALUE", 0, "Maximum number of pids allowed in the container", 0 },
+        {
+            0,
+        } };
 
 #define YAJL_STR(x) ((const unsigned char *) (x))
 
@@ -125,7 +123,7 @@ build_file (size_t *len)
 {
   size_t i;
   yajl_gen gen = NULL;
-  size_t n_sections = sizeof(sections) / sizeof(sections[0]);
+  size_t n_sections = sizeof (sections) / sizeof (sections[0]);
   int has_sections[n_sections];
   const unsigned char *buf;
 
@@ -136,8 +134,8 @@ build_file (size_t *len)
     error (EXIT_FAILURE, errno, "yajl_gen_alloc failed");
 
   for (i = 0; i < LAST_VALUE - FIRST_VALUE; i++)
-      if (values[i])
-        has_sections[descriptors[i].section] = 1;
+    if (values[i])
+      has_sections[descriptors[i].section] = 1;
 
   for (i = 0; i < n_sections; i++)
     {
@@ -153,7 +151,7 @@ build_file (size_t *len)
     {
       size_t j;
 
-      if (!has_sections[i])
+      if (! has_sections[i])
         continue;
 
       yajl_gen_string (gen, YAJL_STR (sections[i]), strlen (sections[i]));
@@ -162,11 +160,11 @@ build_file (size_t *len)
       for (j = 0; j < LAST_VALUE - FIRST_VALUE; j++)
         {
           struct description_s *d = &descriptors[j];
-          if(values[j] == NULL || d->section != i)
+          if (values[j] == NULL || d->section != i)
             continue;
 
           yajl_gen_string (gen, YAJL_STR (d->key), strlen (d->key));
-          if (!d->numeric)
+          if (! d->numeric)
             yajl_gen_string (gen, YAJL_STR (values[j]), strlen (values[j]));
           else
             {
diff -pruN 0.14.1+dfsg-1/src/update.h 0.15+dfsg-1/src/update.h
--- 0.14.1+dfsg-1/src/update.h	2020-07-02 13:46:33.000000000 +0000
+++ 0.15+dfsg-1/src/update.h	2020-09-03 11:43:25.000000000 +0000
@@ -16,9 +16,9 @@
  * along with crun.  If not, see <http://www.gnu.org/licenses/>.
  */
 #ifndef UPDATE_H
-# define UPDATE_H
+#define UPDATE_H
 
-# include "crun.h"
+#include "crun.h"
 
 int crun_command_update (struct crun_global_arguments *global_args, int argc, char **argv, libcrun_error_t *err);
 
diff -pruN 0.14.1+dfsg-1/.tarball-version 0.15+dfsg-1/.tarball-version
--- 0.14.1+dfsg-1/.tarball-version	2020-07-08 06:50:16.000000000 +0000
+++ 0.15+dfsg-1/.tarball-version	2020-09-23 14:49:11.000000000 +0000
@@ -1 +1 @@
-0.14.1
+0.15
diff -pruN 0.14.1+dfsg-1/tests/init.c 0.15+dfsg-1/tests/init.c
--- 0.14.1+dfsg-1/tests/init.c	2020-07-07 07:24:31.000000000 +0000
+++ 0.15+dfsg-1/tests/init.c	2020-09-22 18:17:19.000000000 +0000
@@ -136,7 +136,7 @@ int main (int argc, char **argv)
   if (strcmp (argv[1], "echo") == 0)
     {
       if (argc < 3)
-        error (EXIT_FAILURE, 0, "'cat' requires an argument");
+        error (EXIT_FAILURE, 0, "'echo' requires an argument");
       fputs (argv[2], stdout);
       exit (0);
     }
@@ -209,10 +209,14 @@ int main (int argc, char **argv)
     }
   if (strcmp (argv[1], "pause") == 0)
     {
+      unsigned int remaining = 120;
+
       close (1);
       close (2);
-      /* Make sure the process doesn't hang forever.  */
-      sleep (120);
+
+      while (remaining)
+        remaining = sleep (remaining);
+
       exit (0);
     }
   if (strcmp (argv[1], "forkbomb") == 0)
diff -pruN 0.14.1+dfsg-1/tests/test_checkpoint_restore.py 0.15+dfsg-1/tests/test_checkpoint_restore.py
--- 0.14.1+dfsg-1/tests/test_checkpoint_restore.py	2020-07-08 06:49:25.000000000 +0000
+++ 0.15+dfsg-1/tests/test_checkpoint_restore.py	2020-09-22 18:17:19.000000000 +0000
@@ -91,7 +91,7 @@ def test_cr1():
     return 0
 
 all_tests = {
-    "checkpoint restore" : test_cr1,
+    "checkpoint-restore" : test_cr1,
 }
 
 if __name__ == "__main__":
diff -pruN 0.14.1+dfsg-1/tests/test_mounts.py 0.15+dfsg-1/tests/test_mounts.py
--- 0.14.1+dfsg-1/tests/test_mounts.py	2020-07-08 06:49:25.000000000 +0000
+++ 0.15+dfsg-1/tests/test_mounts.py	2020-09-22 18:17:19.000000000 +0000
@@ -56,6 +56,17 @@ def test_mount_symlink():
         return 0
     return -1
 
+def test_mount_symlink_not_existing():
+    conf = base_config()
+    conf['process']['args'] = ['/init', 'cat', '/proc/self/mountinfo']
+    add_all_namespaces(conf)
+    mount_opt = {"destination": "/etc/not-existing", "type": "bind", "source": "/etc/localtime", "options": ["bind", "ro"]}
+    conf['mounts'].append(mount_opt)
+    out, _ = run_and_get_output(conf, hide_stderr=True)
+    if "foo/bar" in out:
+        return 0
+    return -1
+
 def test_mount_ro():
     a = helper_mount("ro")[0]
     if "ro" in a:
@@ -128,6 +139,7 @@ all_tests = {
     "test-mount-sync" : test_mount_sync,
     "test-mount-dirsync" : test_mount_dirsync,
     "test-mount-symlink" : test_mount_symlink,
+    "test-mount-symlink-not-existing" : test_mount_symlink_not_existing,
 }
 
 if __name__ == "__main__":
diff -pruN 0.14.1+dfsg-1/tests/test_resources.py 0.15+dfsg-1/tests/test_resources.py
--- 0.14.1+dfsg-1/tests/test_resources.py	2020-07-08 06:49:25.000000000 +0000
+++ 0.15+dfsg-1/tests/test_resources.py	2020-09-03 11:43:25.000000000 +0000
@@ -23,6 +23,10 @@ import shutil
 import sys
 from tests_utils import *
 
+
+def is_cgroup_v2_unified():
+    return subprocess.check_output("stat -c%T -f /sys/fs/cgroup".split()).decode("utf-8").strip() == "cgroup2fs"
+
 def test_resources_pid_limit():
     if os.getuid() != 0:
         return 77
@@ -42,8 +46,88 @@ def test_resources_pid_limit():
         return -1
     return 0
 
+def test_resources_unified_invalid_controller():
+    if not is_cgroup_v2_unified() or os.geteuid() != 0:
+        return 77
+
+    conf = base_config()
+    add_all_namespaces(conf, cgroupns=True)
+    conf['process']['args'] = ['/init', 'pause']
+
+    conf['linux']['resources'] = {}
+    conf['linux']['resources']['unified'] = {
+            "foo.bar": "doesntmatter"
+    }
+    cid = None
+    try:
+        out, cid = run_and_get_output(conf, command='run', detach=True)
+        # must raise an exception, fail if it doesn't.
+        return -1
+    except Exception as e:
+        if 'the requested controller `foo` is not available' in e.stdout.decode("utf-8").strip():
+            return 0
+        return -1
+    finally:
+        if cid is not None:
+            run_crun_command(["delete", "-f", cid])
+    return 0
+
+def test_resources_unified_invalid_key():
+    if not is_cgroup_v2_unified() or os.geteuid() != 0:
+        return 77
+
+    conf = base_config()
+    add_all_namespaces(conf, cgroupns=True)
+    conf['process']['args'] = ['/init', 'pause']
+
+    conf['linux']['resources'] = {}
+    conf['linux']['resources']['unified'] = {
+            "NOT-A-VALID-KEY": "doesntmatter"
+    }
+    cid = None
+    try:
+        out, cid = run_and_get_output(conf, command='run', detach=True)
+        # must raise an exception, fail if it doesn't.
+        return -1
+    except Exception as e:
+        if 'the specified key has not the form CONTROLLER.VALUE `NOT-A-VALID-KEY`' in e.stdout.decode("utf-8").strip():
+            return 0
+        return -1
+    finally:
+        if cid is not None:
+            run_crun_command(["delete", "-f", cid])
+    return 0
+
+def test_resources_unified():
+    if not is_cgroup_v2_unified() or os.geteuid() != 0:
+        return 77
+
+    conf = base_config()
+    add_all_namespaces(conf, cgroupns=True)
+    conf['process']['args'] = ['/init', 'pause']
+
+    conf['linux']['resources'] = {}
+    conf['linux']['resources']['unified'] = {
+            "memory.high": "1073741824"
+    }
+    cid = None
+    try:
+        _, cid = run_and_get_output(conf, command='run', detach=True)
+        out = run_crun_command(["exec", cid, "/init", "cat", "/sys/fs/cgroup/memory.high"])
+        if "1073741824" not in out:
+            return -1
+    finally:
+        if cid is not None:
+            run_crun_command(["delete", "-f", cid])
+    return 0
+
+
+
 all_tests = {
     "resources-pid-limit" : test_resources_pid_limit,
+    "resources-unified" : test_resources_unified,
+    "resources-unified-invalid-controller" : test_resources_unified_invalid_controller,
+    "resources-unified-invalid-key" : test_resources_unified_invalid_key,
 }
 
 if __name__ == "__main__":
diff -pruN 0.14.1+dfsg-1/tests/test_start.py 0.15+dfsg-1/tests/test_start.py
--- 0.14.1+dfsg-1/tests/test_start.py	2020-07-08 06:49:25.000000000 +0000
+++ 0.15+dfsg-1/tests/test_start.py	2020-09-03 11:43:25.000000000 +0000
@@ -85,6 +85,30 @@ def test_start():
             run_crun_command(["delete", "-f", cid])
     return 0
 
+def test_start_override_config():
+    conf = base_config()
+    conf['process']['args'] = ['/init', 'echo', 'hello']
+    add_all_namespaces(conf)
+    cid = None
+    try:
+        proc, cid = run_and_get_output(conf, command='create', use_popen=True, relative_config_path="config/config.json")
+        for i in range(50):
+            try:
+                s = run_crun_command(["state", cid])
+                break
+            except Exception as e:
+                time.sleep(0.1)
+
+        run_crun_command(["start", cid])
+        out, _ = proc.communicate()
+        if "hello" not in str(out):
+            return -1
+    finally:
+        if cid is not None:
+            run_crun_command(["delete", "-f", cid])
+    return 0
+
+
 def test_run_twice():
     conf = base_config()
     conf['process']['args'] = ['/init', 'echo', 'hi']
@@ -143,6 +167,7 @@ def test_sd_notify_env():
 
 all_tests = {
     "start" : test_start,
+    "start-override-config" : test_start_override_config,
     "run-twice" : test_run_twice,
     "sd-notify" : test_sd_notify,
     "sd-notify-file" : test_sd_notify_file,
diff -pruN 0.14.1+dfsg-1/tests/tests_utils.py 0.15+dfsg-1/tests/tests_utils.py
--- 0.14.1+dfsg-1/tests/tests_utils.py	2020-07-08 06:49:25.000000000 +0000
+++ 0.15+dfsg-1/tests/tests_utils.py	2020-09-22 18:17:19.000000000 +0000
@@ -144,11 +144,14 @@ def parse_proc_status(content):
         r[k] = v.strip()
     return r
 
-def add_all_namespaces(conf):
+def add_all_namespaces(conf, cgroupns=False):
     has = {}
     for i in conf['linux']['namespaces']:
         has[i['type']] = i['type']
-    for i in ['pid', 'user', 'ipc', 'uts', 'network']:
+    namespaces = ['pid', 'user', 'ipc', 'uts', 'network']
+    if cgroupns:
+        namespaces = namespaces + ["cgroup"]
+    for i in namespaces:
         if i not in has:
             conf['linux']['namespaces'].append({"type" : i})
 
@@ -187,7 +190,7 @@ def get_crun_path():
 
 def run_and_get_output(config, detach=False, preserve_fds=None, pid_file=None,
                        command='run', env=None, use_popen=False, hide_stderr=False,
-                       all_dev_null=False, id_container=None):
+                       all_dev_null=False, id_container=None, relative_config_path="config.json"):
     temp_dir = tempfile.mkdtemp(dir=get_tests_root())
     rootfs = os.path.join(temp_dir, "rootfs")
     os.makedirs(rootfs)
@@ -199,7 +202,12 @@ def run_and_get_output(config, detach=Fa
     if id_container is None:
         id_container = 'test-%s' % os.path.basename(temp_dir)
 
-    with open(os.path.join(temp_dir, "config.json"), "w") as config_file:
+    config_path = os.path.join(temp_dir, relative_config_path)
+    config_dir = os.path.dirname(config_path)
+    if not os.path.exists(config_dir):
+        os.makedirs(config_dir)
+
+    with open(config_path, "w") as config_file:
         conf = json.dumps(config)
         config_file.write(conf)
 
@@ -212,12 +220,14 @@ def run_and_get_output(config, detach=Fa
 
     open(os.path.join(rootfs, "usr/share/zoneinfo/Europe/Rome"), "w").close()
     os.symlink("../usr/share/zoneinfo/Europe/Rome", os.path.join(rootfs, "etc/localtime"))
+    os.symlink("../foo/bar/not/here", os.path.join(rootfs, "etc/not-existing"))
 
     detach_arg = ['--detach'] if detach else []
     preserve_fds_arg = ['--preserve-fds', str(preserve_fds)] if preserve_fds else []
     pid_file_arg = ['--pid-file', pid_file] if pid_file else []
+    relative_config_path = ['--config', relative_config_path] if relative_config_path else []
 
-    args = [crun, command] + preserve_fds_arg + detach_arg + pid_file_arg + [id_container]
+    args = [crun, command] + relative_config_path + preserve_fds_arg + detach_arg + pid_file_arg + [id_container]
 
     stderr = subprocess.STDOUT
     if hide_stderr:
diff -pruN 0.14.1+dfsg-1/.version 0.15+dfsg-1/.version
--- 0.14.1+dfsg-1/.version	2020-07-07 16:25:35.000000000 +0000
+++ 0.15+dfsg-1/.version	2020-09-23 14:49:06.000000000 +0000
@@ -1 +1 @@
-0.14.1
+0.15
